// SphereToon.geom

// SetParameter GL_GEOMETRY_INPUT_TYPE_EXT=GL_TRIANGLES
// SetParameter GL_GEOMETRY_OUTPUT_TYPE_EXT=GL_TRIANGLES
// SetParameter GL_GEOMETRY_VERTICES_OUT_EXT=6

#version 130
#extension GL_EXT_geometry_shader4 : enable
#extension GL_EXT_gpu_shader4 : enable

// geometry shader of carttond shading

uniform float     boldness;

//in
in vec3 positionIn[3];
in vec3 normalIn[3];
in vec4 GLSubPosition[3];
in vec4 colorIn[3];
in vec4 colorDiffuseIn[3];
in vec4 colorSpecularIn[3];
flat in int blendIn[3];
flat in int textureImageIndexIn[3];

//out
out float t;
out vec3 position;
out vec3 normal;
out vec4 color;
out vec4 colorDiffuse;
out vec4 colorSpecular;
flat out int blend;
flat out int textureImageIndex;

void main(void)
{
    int length = gl_TexCoordIn.length();
    
    for(int i = 0; i < length; i++){
	gl_TexCoord = gl_TexCoordIn[i];
	gl_Position = gl_PositionIn[i];
	t = 1;
	position = positionIn[i];
	normal = normalIn[i];
	color = colorIn[i];
	colorDiffuse = colorDiffuseIn[i];
	colorSpecular = colorSpecularIn[i];
	blend = blendIn[i];
	textureImageIndex = textureImageIndexIn[i];
	EmitVertex();
    }
    EndPrimitive();

    if (boldness != 0){
	for(int i =  length-1; i >= 0; i--){
	    gl_Position = GLSubPosition[i];
	    t = 0;
	    EmitVertex();
	}
	EndPrimitive();
    }
}
