//#extension GL_EXT_gpu_shader4 : enable

uniform sampler2D textureImage;
uniform sampler2D textureImage1;

uniform int quality;
uniform vec4 gamma;
uniform float projMatrix10;
uniform float projMatrix14;
uniform float focalDistance;
uniform float widthBase;

void main (void)
{
    vec2 texCoord = gl_TexCoord[0].st;

    vec4 texColorOrg = texture2D(textureImage, texCoord);
    
    
    //texCoord[0] = (texCoord[0] - 0.5) + 0.5;
    //texCoord[1] = (texCoord[1] - 0.5) + 0.5;
    		
    vec4 texColor1 = texture2D(textureImage1, texCoord);

    texColorOrg[0] += 0.0001;
    texColorOrg[1] += 0.0001;
    texColorOrg[2] += 0.0001;
    texColor1[0] += 0.0001;
    texColor1[1] += 0.0001;
    texColor1[2] += 0.0001;
    float alpha = 0.5;

    float z_eye = projMatrix14 / (texColor1[0] * -2.0 + 1.0 - projMatrix10);
    z_eye = -z_eye;
    /*
    if (texColor1[0] > 0.99) z_eye = 1;
    else if (texColor1[0] > 0.98) z_eye = 0.8;
    else if (texColor1[0] > 0.95) z_eye = 0.6;
    else if (texColor1[0] > 0.9) z_eye = 0.4;
    else if (texColor1[0] > 0.85) z_eye = 0.2;
    else z_eye = 0;
    */
    /*
    if (texCoord[0] < 0 || texCoord[0] > 1 ||
	texCoord[1] < 0 || texCoord[1] > 1) alpha = 0;
    */


    //float widthBase = 0.02;
    //float focusDistance = 20;
    float width = (1.0 - focalDistance/z_eye) * widthBase / 2;
    
    gl_FragColor = vec4(0, 0, 0 ,0);

    float sum = 0;
    float fqual = float(quality);
    float area = fqual / 1.5;
    float area2 = area * area;
    float gamma0 = gamma[0];
    for (int j = 0; j < quality*2+1; j++){
	float dy = float(j-quality) / float(quality) * width;

	float y = float(j-quality) / float(quality) * 1.5;
	float fy = 1.0 / sqrt(2*3.14159) * exp(-y*y / 2.0);
	//float fy2 = float(quality) / 1.5;
	
	for (int i = 0; i < quality*2+1; i++){
	    //if (i == quality && j == quality) continue;
	    float dx = float(i-quality) / float(quality) * width;
	    vec4 texColor = texture2D(textureImage, gl_TexCoord[0].st+vec2(dx, dy));
	    if (texColor[3] > 1){
		texColor[0] *= texColor[3];
		texColor[1] *= texColor[3];
		texColor[2] *= texColor[3];
		texColor[3] = 1;
	    }
	    if (gamma0 != 0.0) texColor = pow(texColor, gamma);

	    float x = float(i-quality) / float(quality) * 1.5;
	    float fx = 1.0 / sqrt(2*3.14159) * exp(-x*x / 2.0);
	    //float fx2 = float(quality) / 1.5;
	    
	    sum = sum + fx*fy / area2;
	    //vec4 dCol = ;
		
	    gl_FragColor += texColor * fx*fy /area2;
	}
    }
    
    gl_FragColor /= sum;
    /*
      vec4 texColor = texture2D(textureImage, gl_TexCoord[0].st);
      if (gamma[0] != 0.0) texColor = pow(texColor, gamma);

      gl_FragColor += texColor * (1.0-sum);
    */
	
    if (gamma0 != 0.0){
	vec4 gammaInv = vec4(1.0/gamma[0], 1.0/gamma[1], 1.0/gamma[2], 1.0/gamma[3]);
	gl_FragColor = pow(gl_FragColor, gammaInv);
    }
	
    //if ((z_eye > 14.8 ) && (z_eye < 16.2)) gl_FragColor[0] = 1;

    /*
      gl_FragColor[0] = (1 - alpha) * texColor[0] + alpha * texColor1[0];
      gl_FragColor[1] = (1 - alpha) * texColor[1] + alpha * texColor1[1];
      gl_FragColor[2] = (1 - alpha) * texColor[2] + alpha * texColor1[2];
      gl_FragColor[3] = (1 - alpha) * texColor[3] + alpha;
    */

    return;
}
