// (setq c-basic-offset 4)

#ifndef _COMMON_DEFINITIONS_SHADER_H_
#define _COMMON_DEFINITIONS_SHADER_H_

#define _SHADER_CLAMP_ALPHA  0
#define _SHADER_EXPOSURE     1
#define _SHADER_BLUR         2
#define _SHADER_FOCAL_BLUR   3
#define _SHADER_FOCAL_BLUR_B 4
#define _SHADER_GLARE        5
#define _SHADER_REMOVE_ALPHA 6
#define _SHADER_OVERLAY      7
#define _SHADER_SSAO         8
#define _SHADER_DEPTH        9
#define _SHADER_VOLUME_BASIC          10
#define _SHADER_VOLUME_PHONG          11
#define _SHADER_VOLUME_SHADOW         12
#define _SHADER_VOLUME_SCATTER        13
#define _SHADER_VOLUME_SCATTER_SHADOW 14
#define _SHADER_OBJECT_GOURAUD        15
#define _SHADER_OBJECT_PHONG          16
#define _SHADER_OBJECT_TOON           17
#define _SHADER_OBJECT_NORMAL         18  
#define _SHADER_LINE_BASIC            19
#define _SHADER_POINT_BASIC           20
#define _SHADER_POINT_BILLBOARD       21
#define _SHADER_SPHERE_GOURAUD        22
#define _SHADER_SPHERE_PHONG          23
#define _SHADER_SPHERE_TOON           24
#define _SHADER_SV_TRIANGLE_MESH      25
#define _SHADER_HF                    26
#define _SHADER_SV_TRIANGLE_MESH_HF   27
#define _SHADER_STREAMLINE_BASIC      28
#define _SHADER_STREAMLINE_TRIANGLE   29

#define _PARTCLE_POINTSHADER     0
#define _PARTCLE_BILLBOARDSHADER 1
#define _PARTCLE_SPHERESHADER    2

#define _POINTSHADER_POINT         0
#define _POINTSHADER_CIRCLE        1
#define _POINTSHADER_PSEUDO_SPHERE 2
#define _POINTSHADER_HIDE          3
#define _MAX_POINTSHADER           4

#define _SPHERESHADER_GOURAUD 0
#define _SPHERESHADER_PHONG   1
#define _SPHERESHADER_TOON    2
#define _SPHERESHADER_NORMAL  3
#define _SPHERESHADER_HIDE    4
#define _MAX_SPHERESHADER     5

#define _BILLBOARDSHADER_BILLBOARD     0
#define _BILLBOARDSHADER_PSEUDO_SPHERE 1
#define _BILLBOARDSHADER_PSEUDO_OBJECT 2
#define _BILLBOARDSHADER_HIDE          3
#define _MAX_BILLBOARDSHADER 4

#endif
