// -*- c -*-
// (setq c-basic-offset 4)
// "MyEndian.h"

#include <string.h>

namespace MyEndian{
    
    void SwapByte(void* pHead, unsigned int length){
	unsigned char *pBuf = new unsigned char [length];
	
	for (unsigned int i = 0; i < length; i++)
	    pBuf[i] = *((unsigned char*)pHead + i);

	for (unsigned int i = 0; i < length; i++)
	    *((unsigned char*)pHead + i) = pBuf[length - 1 - i];

	delete [] pBuf;
    }

    void SwapByte2x8(void* pHead){
	unsigned char pBuf[16];

	memcpy(pBuf, pHead, 16);
	*((unsigned char*)pHead + 0) = pBuf[1];
	*((unsigned char*)pHead + 1) = pBuf[0];
	*((unsigned char*)pHead + 2) = pBuf[3];
	*((unsigned char*)pHead + 3) = pBuf[2];
	*((unsigned char*)pHead + 4) = pBuf[5];
	*((unsigned char*)pHead + 5) = pBuf[4];
	*((unsigned char*)pHead + 6) = pBuf[7];
	*((unsigned char*)pHead + 7) = pBuf[6];
	*((unsigned char*)pHead + 8) = pBuf[9];
	*((unsigned char*)pHead + 9) = pBuf[8];
	*((unsigned char*)pHead + 10) = pBuf[11];
	*((unsigned char*)pHead + 11) = pBuf[10];
	*((unsigned char*)pHead + 12) = pBuf[13];
	*((unsigned char*)pHead + 13) = pBuf[12];
	*((unsigned char*)pHead + 14) = pBuf[15];
	*((unsigned char*)pHead + 15) = pBuf[14];
    }

    void SwapByte4x8(void *pHead){
	unsigned char pBuf[32];
	
	memcpy(pBuf, pHead, 32);
	*((unsigned char*)pHead + 0) = pBuf[3];
	*((unsigned char*)pHead + 1) = pBuf[2];
	*((unsigned char*)pHead + 2) = pBuf[1];
	*((unsigned char*)pHead + 3) = pBuf[0];

	*((unsigned char*)pHead + 4) = pBuf[7];
	*((unsigned char*)pHead + 5) = pBuf[6];
	*((unsigned char*)pHead + 6) = pBuf[5];
	*((unsigned char*)pHead + 7) = pBuf[4];

	*((unsigned char*)pHead + 8) = pBuf[11];
	*((unsigned char*)pHead + 9) = pBuf[10];
	*((unsigned char*)pHead + 10) = pBuf[9];
	*((unsigned char*)pHead + 11) = pBuf[8];

	*((unsigned char*)pHead + 12) = pBuf[15];
	*((unsigned char*)pHead + 13) = pBuf[14];
	*((unsigned char*)pHead + 14) = pBuf[13];
	*((unsigned char*)pHead + 15) = pBuf[12];

	*((unsigned char*)pHead + 16) = pBuf[19];
	*((unsigned char*)pHead + 17) = pBuf[18];
	*((unsigned char*)pHead + 18) = pBuf[17];
	*((unsigned char*)pHead + 19) = pBuf[16];

	*((unsigned char*)pHead + 20) = pBuf[23];
	*((unsigned char*)pHead + 21) = pBuf[22];
	*((unsigned char*)pHead + 22) = pBuf[21];
	*((unsigned char*)pHead + 23) = pBuf[20];

	*((unsigned char*)pHead + 24) = pBuf[27];
	*((unsigned char*)pHead + 25) = pBuf[26];
	*((unsigned char*)pHead + 26) = pBuf[25];
	*((unsigned char*)pHead + 27) = pBuf[24];

	*((unsigned char*)pHead + 28) = pBuf[31];
	*((unsigned char*)pHead + 29) = pBuf[30];
	*((unsigned char*)pHead + 30) = pBuf[29];
	*((unsigned char*)pHead + 31) = pBuf[28];
    }
    
};
