// "clsClassProvider.h"
// (setq c-basic-offset 4)

#include "clsClassProvider.h"
#include "clsThreadCommon.h"

#include "../COMMON/clsQueue.h"
extern Queue_cls *GpCQueue;
#include "../COMMON/clsHalton.h"
extern Halton_cls *GpCHalton;
#include "../FILTER/clsFilterCtrl.h"
extern FilterCtrl_cls *GpCFilterCtrl;
#include "../GLCANVAS/clsImageComposer.h"
extern ImageComposer_cls *GpCImageComposer;
#include "../GLCANVAS/clsStereogram.h"
extern Stereogram_cls *GpCStereogram;
#include "../GLOBJ/clsVBOCameraBox.h"
extern VBOCameraBox_cls *GpCVBOCameraBox;
#include "../GLOBJ/clsVBOCone.h"
extern VBOCone_cls *GpCVBOCone;
#include "../GLOBJ/clsVBOCube.h"
extern VBOCube_cls *GpCVBOCube;
#include "../GLOBJ/clsVBOCylinder.h"
extern VBOCylinder_cls *GpCVBOCylinder;
#include "../GLOBJ/clsVBOEmpty.h"
extern VBOEmpty_cls *GpCVBOEmpty;
#include "../GLOBJ/clsVBOHFProvider.h"
extern VBOHFProvider_cls *GpCVBOHFProvider;
#include "../GLOBJ/clsVBOPlane.h"
extern VBOPlane_cls *GpCVBOPlane;
#include "../GLOBJ/clsVBOSphere.h"
extern VBOSphere_cls *GpCVBOSphere;
#include "../GLSL/clsShaderCtrl.h"
extern ShaderCtrl_cls *GpCShaderCtrl;
#include "../GRAPHIC/clsImageOutput.h"
extern ImageOutput_cls *GpCImageOutput;
#include "../GRAPHIC/clsImageIO.h"
extern ImageIO_cls *GpCImageIO;
#include "../GRAPHIC/clsReadPNG.h"
extern ReadPNG_cls *GpCReadPNG;
#include "../LUA/clsLuaInterpreter.h"
extern LuaInterpreter_cls *GpCLuaInterpreter;
#include "../LUA/clsLuaMiniCalc.h"
extern LuaMiniCalc_cls *GpCLuaMinicalc;
#include "../MYGL/clsGLExtention.h"
extern GLExtentions_cls *GpCGLExtention;
#include "../MYGL/clsGLInfo.h"
extern GLInfo_cls *GpCGLInfo;
#include "../MYGL/clsGLSL.h"
extern GLSL_cls *GpCGLSL;
#include "../MYGL/clsShadowVolumeCtrl.h"
extern ShadowVolumeCtrl_cls *GpCShadowVolumeCtrl;
#include "../MYGL/clsTextureProvider.h"
extern TextureProvider_cls *GpCTextureProvider;
#include "../MYGL/clsTextureProvider1D.h"
extern TextureProvider1D_cls *GpCTextureProvider1D;
#include "../MYGL/clsWideCamera.h"
extern WideCamera_cls *GpCWideCamera;
#include "../DIALOG/clsParamDialog.h"
extern ParamDialog_cls *GpCParamDialog;
#include "../DIALOG/clsParamGroupDialog.h"
extern ParamGroupDialog_cls *GpCParamGroupDialog;
#include "../WIDGETCTRL/WX/clsPenBrushProvider.h"
extern PenBrushProvider_cls *GpCPenBrushProvider;
#include "../PREFERENCE/clsPreference.h"
extern Preference_cls *GpCPreference;
#include "../PREFERENCE/clsMousePreference.h"
extern MousePreference_cls *GpCMousePreference;
#include "../DIALOG/clsScene.h"
extern Scene_cls *GpCScene;
#include "../SCENEOBJ/clsCamera.h"
#include "../SCENEOBJ/clsSceneObjCtrl.h"
extern SceneObjCtrl_cls *GpCSceneObjCtrl;
#include "../SCENEOBJ/clsPrimitive.h"
#include "../SCENEOBJ/clsSceneObj.h"
#include "../SCENEOBJ/clsLightSource.h"
#include "../SCENEOBJ/clsWorld.h"
#include "../PREFERENCE/clsShortcut.h"
extern Shortcut_cls *GpCShortcut;
extern Shortcut_cls *GpCTextShortcut;
#include "../WIDGETCTRL/WX/clsSizeAdjuster.h"
extern SizeAdjuster_cls *GpCSizeAdjuster;
#include "../TIMELINE/clsEnsembleCtrl.h"
extern EnsembleCtrl_cls *GpCEnsembleCtrl;
#include "../TIMELINE/clsTimeCtrl.h"
extern TimeCtrl_cls *GpCTimeCtrl;
#include "../TIMELINE/clsMotionBlurCtrl.h"
extern MotionBlurCtrl_cls *GpCBlurCtrl;
#include "../UNDO/clsUndoManager.h"
extern UndoManager_cls *GpCUndo;
#include "../WIDGETCTRL/EX/clsColourDialogEX.h"
extern wxColourDialogEX *GpCClrDialog;
#include "../WIDGETCTRL/EX/clsFileDialogEX.h"
extern wxFileDialogEX *GpCFileDialog;
#include "../WIDGETCTRL/EX/wxLogGuiEX.h"
extern wxLogGuiEX *GpCwxLogGuiEX;
#include "../WIDGETCTRL/TEXT/clsAutoComplete.h"
extern AutoComplete_cls *GpCAutoCompleteLua;
extern AutoComplete_cls *GpCAutoCompleteGLSL;
#include "../WIDGETCTRL/WX/clsIconProvider.h"
extern IconProvider_cls *GpCIconProvider;
#include "../WIDGETCTRL/WX/clsColorCurveProvider.h"
extern ColorCurveProvider_cls *GpCColorCurveProvider;
#include "../WIDGETCTRL/WX/clsColorProvider.h"
extern ColorProvider_cls *GpCColorProvider;
#include "../WIDGETCTRL/WX/clsStringProvider.h"
extern StringProvider_cls *GpCStringProvider;

#include "../GLCANVAS/clsGLCanvas.h"

#include "../../clsMain.h"
#include "../../clsFrameMain.h"

#define CLS ClassProvider_cls

void CLS::
InitializeStaticMembers(){
    ThreadCommon_cls::msCPUCount = wxThread::GetCPUCount();
}

void CLS::
CreateGLInstances(){
}

void CLS::
DeleteGLInstances(){
}

void CLS::
CreateSingleton(){
    GpCAutoCompleteLua = new AutoComplete_cls(_AUTO_COMPLETE_LUA);
    GpCAutoCompleteGLSL = new AutoComplete_cls(_AUTO_COMPLETE_GLSL);
    GpCBlurCtrl = new MotionBlurCtrl_cls;
    GpCColorCurveProvider = new ColorCurveProvider_cls;
    GpCColorProvider = new ColorProvider_cls;
    GpCEnsembleCtrl = new EnsembleCtrl_cls;
    GpCFilterCtrl = new FilterCtrl_cls;
    GpCGLExtention = new GLExtentions_cls;
    GpCGLInfo = new GLInfo_cls;
    GpCGLSL = new GLSL_cls;
    GpCHalton = new Halton_cls;
    GpCTextureProvider = new TextureProvider_cls;
    GpCTextureProvider1D = new TextureProvider1D_cls;
    GpCWideCamera = new WideCamera_cls;
    GpCParamDialog = new ParamDialog_cls;
    GpCParamGroupDialog = new ParamGroupDialog_cls;
    GpCPenBrushProvider = new PenBrushProvider_cls;
    GpCPreference = new Preference_cls;
    GpCReadPNG = new ReadPNG_cls;
    GpCMousePreference = new MousePreference_cls;
    GpCImageOutput = new ImageOutput_cls;
    GpCImageIO = new ImageIO_cls;
    GpCClrDialog = new wxColourDialogEX(NULL);
    GpCFileDialog = new wxFileDialogEX;
    GpCImageComposer = new ImageComposer_cls;
    GpCStereogram = new Stereogram_cls;
    GpCStringProvider = new StringProvider_cls;
    GpCScene = new Scene_cls;
    GpCQueue = new Queue_cls;
    
    GpCSceneObjCtrl = new SceneObjCtrl_cls;
    GpCShaderCtrl = new ShaderCtrl_cls;
    GpCShadowVolumeCtrl = new ShadowVolumeCtrl_cls;
    GpCTimeCtrl = new TimeCtrl_cls;
    GpCShortcut = new Shortcut_cls(0);
    GpCSizeAdjuster = new SizeAdjuster_cls;
    GpCTextShortcut = new Shortcut_cls(1);
    GpCUndo = new UndoManager_cls;
    GpCLuaInterpreter = new LuaInterpreter_cls;
    GpCLuaMinicalc = new LuaMiniCalc_cls;
    GpCVBOCameraBox = new VBOCameraBox_cls;
    GpCVBOCone = new VBOCone_cls;
    GpCVBOCube = new VBOCube_cls;
    GpCVBOCylinder = new VBOCylinder_cls;
    GpCVBOEmpty = new VBOEmpty_cls;
    GpCVBOHFProvider = new VBOHFProvider_cls;
    GpCVBOPlane = new VBOPlane_cls;
    GpCVBOSphere = new VBOSphere_cls;

    GpCwxLogGuiEX = new wxLogGuiEX;
    wxLog::SetActiveTarget(GpCwxLogGuiEX);
    wxLog::SetLogLevel(wxLOG_Debug);

    /*
    for (int i = 0; i < 1; i++)
	GpCSceneObjCtrl->InsertSceneObjNative(new Primitive_cls(GpCSceneObjCtrl, "Box"), 0);
    */
    
    GpCSceneObjCtrl->InsertSceneObjNative(new Camera_cls(GpCSceneObjCtrl, "Camera"), 0);
    GpCSceneObjCtrl->InsertSceneObjNative(new Primitive_cls(GpCSceneObjCtrl, "Box", "Box"), 0);
    LightSource_cls *pCInitLight = new LightSource_cls(GpCSceneObjCtrl, "PointLight", "Initial Light");
    ParamGroup_cls *pCPosition = pCInitLight->GetPCParamGroup("Position");
    pCPosition->SetInitValue(5,5,5);
    ParamGroup_cls *pCRotateEuler = pCInitLight->GetPCParamGroup("RotationEuler");
    pCRotateEuler->SetInitValue(0, -45, 45);
    GpCSceneObjCtrl->InsertSceneObjNative(pCInitLight, 0); 
    GpCSceneObjCtrl->InsertSceneObjNative(new World_cls(GpCSceneObjCtrl, "World"), 0);
}

void CLS::
CreateSingletonSerial(){
    GpCIconProvider = new IconProvider_cls();
}

void CLS::
DeleteSingleton(){
    delete GpCTextureProvider;
    delete GpCTextureProvider1D;
    delete GpCAutoCompleteLua;
    delete GpCAutoCompleteGLSL;
    delete GpCBlurCtrl;
    delete GpCColorCurveProvider;
    delete GpCColorProvider;
    delete GpCEnsembleCtrl;
    delete GpCFilterCtrl;
    delete GpCGLExtention;
    delete GpCGLInfo;
    delete GpCGLSL;
    delete GpCHalton;
    delete GpCPenBrushProvider;
    delete GpCPreference;
    delete GpCReadPNG;
    delete GpCMousePreference;
    delete GpCIconProvider;
    delete GpCImageOutput;
    delete GpCImageIO; 
    delete GpCClrDialog;
    delete GpCFileDialog;
    delete GpCParamDialog;
    delete GpCParamGroupDialog;
    delete GpCQueue;
    delete GpCScene;
    delete GpCSceneObjCtrl;
    delete GpCShaderCtrl;
    delete GpCShadowVolumeCtrl;
    delete GpCShortcut;
    delete GpCSizeAdjuster;
    delete GpCImageComposer;
    delete GpCStereogram;
    delete GpCStringProvider;
    delete GpCTextShortcut;
    delete GpCWideCamera;
    delete GpCTimeCtrl;
    delete GpCVBOCameraBox;
    delete GpCVBOCone;
    delete GpCVBOCube;
    delete GpCVBOCylinder;
    delete GpCVBOEmpty;
    delete GpCVBOHFProvider;
    delete GpCVBOPlane;
    delete GpCVBOSphere;
    delete GpCUndo;
    delete GpCLuaInterpreter;
    delete GpCLuaMinicalc;
    wxLog::SetActiveTarget(NULL);
    delete GpCwxLogGuiEX;
    if (GLCanvasBase_cls::mspCGLContext != NULL)
	delete GLCanvasBase_cls::mspCGLContext;
}

wxWindow* CLS::
GetPCwxWindowTop(){ return GetPCFrameMain(); }

AutoComplete_cls* CLS::
GetPCAutoCompleteLua(){ return GpCAutoCompleteLua; }

AutoComplete_cls* CLS::
GetPCAutoCompleteGLSL(){ return GpCAutoCompleteGLSL; }

IconProvider_cls* CLS::
GetPCIconProvider(){ return GpCIconProvider; }

ColorCurveProvider_cls* CLS::
GetPCColorCurveProvider(){ return GpCColorCurveProvider; }

ColorProvider_cls* CLS::
GetPCColorProvider(){ return GpCColorProvider; }

EnsembleCtrl_cls* CLS::
GetPCEnsembleCtrl(){ return GpCEnsembleCtrl; }

ImageComposer_cls* CLS::
GetPCImageComposer(){ return GpCImageComposer; }

ImageOutput_cls* CLS::
GetPCImageOutput(){ return GpCImageOutput; }

ImageIO_cls* CLS::
GetPCImageIO(){ return GpCImageIO; }

LuaInterpreter_cls* CLS::
GetPCLuaInterpreter(){ return GpCLuaInterpreter; }

LuaMiniCalc_cls* CLS::
GetPCLuaMinicalc(){ return GpCLuaMinicalc; }

FilterCtrl_cls* CLS::
GetPCFilterCtrl(){ return GpCFilterCtrl; }

FrameMain_cls* CLS::
GetPCFrameMain(int index){
    if (index > mpCMainLink->mVpCFrame.size()) return NULL;
    return mpCMainLink->mVpCFrame[index];
}

GLExtentions_cls* CLS::
GetPCGLExtentions(){ return GpCGLExtention; }

GLInfo_cls* CLS::
GetPCGLInfo(){ return GpCGLInfo; }

GLSL_cls* CLS::
GetPCGLSL(){ return GpCGLSL; }

Halton_cls* CLS::
GetPCHalton(){ return GpCHalton; }

Main_cls* CLS::
GetPCMain(){ return mpCMainLink; }

ParamDialog_cls* CLS::
GetPCParamDialog(){ return GpCParamDialog; }

ParamGroupDialog_cls* CLS::
GetPCParamGroupDialog(){ return GpCParamGroupDialog; }

MousePreference_cls* CLS::
GetPCMousePreference(){ return GpCMousePreference; }

MotionBlurCtrl_cls* CLS::
GetPCBlurCtrl(){ return GpCBlurCtrl; }

PenBrushProvider_cls* CLS::
GetPCPenBrushProvider(){ return GpCPenBrushProvider; }

Preference_cls* CLS::
GetPCPreference(){ return GpCPreference; }

ReadPNG_cls* CLS::
GetPCReadPNG(){ return GpCReadPNG; }

Queue_cls* CLS::
GetPCQueue(){ return GpCQueue; }

Scene_cls* CLS::
GetPCScene(){ return GpCScene; }

SceneObjCtrl_cls* CLS::
GetPCSceneObjCtrl(){ return GpCSceneObjCtrl; }

ShaderCtrl_cls* CLS::
GetPCShaderCtrl(){ return GpCShaderCtrl; }

ShadowVolumeCtrl_cls* CLS::
GetPCShadowVolumeCtrl(){ return GpCShadowVolumeCtrl; }

Shortcut_cls* CLS::
GetPCShortcut() { return GpCShortcut; }

Shortcut_cls* CLS::
GetPCTextShortcut() { return GpCTextShortcut; }

SizeAdjuster_cls* CLS::
GetPCSizeAdjuster() { return GpCSizeAdjuster; }

StringProvider_cls* CLS::
GetPCStringProvider() { return GpCStringProvider; }

Stereogram_cls* CLS::
GetPCStereogram() { return GpCStereogram; }

TextureProvider_cls* CLS::
GetPCTextureProvider() { return GpCTextureProvider; }

TextureProvider1D_cls* CLS::
GetPCTextureProvider1D() { return GpCTextureProvider1D; }

TimeCtrl_cls* CLS::
GetPCTimeCtrl() { return GpCTimeCtrl; }

UndoManager_cls* CLS::
GetPCUndo() { return GpCUndo; }

VBOCameraBox_cls* CLS::
GetPCVBOCameraBox() { return GpCVBOCameraBox; }

VBOCone_cls* CLS::
GetPCVBOCone() { return GpCVBOCone; }

VBOCube_cls* CLS::
GetPCVBOCube() { return GpCVBOCube; }

VBOCylinder_cls* CLS::
GetPCVBOCylinder() { return GpCVBOCylinder; }

VBOEmpty_cls* CLS::
GetPCVBOEmpty() { return GpCVBOEmpty; }

VBOHFProvider_cls* CLS::
GetPCVBOHFProvider() { return GpCVBOHFProvider; }

VBOPlane_cls* CLS::
GetPCVBOPlane() { return GpCVBOPlane; }

VBOSphere_cls* CLS::
GetPCVBOSphere() { return GpCVBOSphere; }

WideCamera_cls* CLS::
GetPCWideCamera() { return GpCWideCamera; }

wxFileDialogEX* CLS::
GetPCFileDialog(){ return GpCFileDialog; }

wxColourDialogEX* CLS::
GetPCColourDialog(){ return GpCClrDialog; }

wxLogGuiEX* CLS::
GetPCwxLogGuiEX(){ return GpCwxLogGuiEX; }
