// (setq c-basic-offset 4)
// "clsClassProvider.cpp" 

#ifndef _CLASS_PROVIDER_H_
#define _CLASS_PROVIDER_H_

class AutoComplete_cls;
class ColorCurveProvider_cls;
class ColorProvider_cls;
class EnsembleCtrl_cls;
class FilterCtrl_cls;
class FrameMain_cls;
class Halton_cls;
class ImageComposer_cls;
class ImageIO_cls;
class LuaMiniCalc_cls;
class GLExtentions_cls;
class GLInfo_cls;
class GLSL_cls;
class IconProvider_cls;
class ImageOutput_cls;
class LuaInterpreter_cls;
class MousePreference_cls;
class Main_cls;
class MotionBlurCtrl_cls;
class ParamDialog_cls;
class ParamGroupDialog_cls;
class PenBrushProvider_cls;
class Preference_cls;
class ReadPNG_cls;
class Queue_cls;
class Scene_cls;
class SceneObjCtrl_cls;
class SizeAdjuster_cls;
class ShaderCtrl_cls;
class ShadowVolumeCtrl_cls;
class Shortcut_cls;
class SizeAdjuster_cls;
class Stereogram_cls;
class StringProvider_cls;
class TextureProvider_cls;
class TextureProvider1D_cls;
class TimeCtrl_cls;
class UndoManager_cls;
class VBOCameraBox_cls;
class VBOCone_cls;
class VBOCube_cls;
class VBOCylinder_cls;
class VBOEmpty_cls;
class VBOHFProvider_cls;
class VBOPlane_cls;
class VBOSphere_cls;
class WideCamera_cls;
class wxFileDialogEX;
class wxColourDialogEX;
class wxWindow;
class wxLogGuiEX;

class ClassProvider_cls{
public:
    Main_cls *mpCMainLink;

    void InitializeStaticMembers();

    void CreateGLInstances();
    void DeleteGLInstances();

    void CreateSingleton();
    void CreateSingletonSerial();
    void DeleteSingleton();

    wxWindow* GetPCwxWindowTop();
    AutoComplete_cls *GetPCAutoCompleteLua();
    AutoComplete_cls *GetPCAutoCompleteGLSL();
    ColorCurveProvider_cls *GetPCColorCurveProvider();
    ColorProvider_cls *GetPCColorProvider();
    EnsembleCtrl_cls *GetPCEnsembleCtrl();
    FilterCtrl_cls *GetPCFilterCtrl();
    FrameMain_cls *GetPCFrameMain(int index = 0);
    GLExtentions_cls *GetPCGLExtentions();
    GLInfo_cls *GetPCGLInfo();
    GLSL_cls *GetPCGLSL();
    Halton_cls *GetPCHalton();
    IconProvider_cls *GetPCIconProvider();
    ImageComposer_cls *GetPCImageComposer();
    ImageOutput_cls *GetPCImageOutput();
    ImageIO_cls *GetPCImageIO();
    LuaInterpreter_cls* GetPCLuaInterpreter();
    LuaMiniCalc_cls* GetPCLuaMinicalc();
    Main_cls *GetPCMain();
    ParamDialog_cls *GetPCParamDialog();
    ParamGroupDialog_cls *GetPCParamGroupDialog();
    MousePreference_cls *GetPCMousePreference();
    MotionBlurCtrl_cls *GetPCBlurCtrl();
    PenBrushProvider_cls *GetPCPenBrushProvider();
    Preference_cls *GetPCPreference();
    ReadPNG_cls *GetPCReadPNG();
    Queue_cls* GetPCQueue();
    Scene_cls* GetPCScene();
    SceneObjCtrl_cls* GetPCSceneObjCtrl();
    ShaderCtrl_cls* GetPCShaderCtrl();
    ShadowVolumeCtrl_cls* GetPCShadowVolumeCtrl();
    Shortcut_cls* GetPCShortcut();
    Shortcut_cls* GetPCTextShortcut();
    SizeAdjuster_cls* GetPCSizeAdjuster();
    Stereogram_cls* GetPCStereogram();
    StringProvider_cls* GetPCStringProvider();
    TextureProvider_cls* GetPCTextureProvider();
    TextureProvider1D_cls* GetPCTextureProvider1D();

    TimeCtrl_cls* GetPCTimeCtrl();
    UndoManager_cls* GetPCUndo();
    VBOCameraBox_cls* GetPCVBOCameraBox();
    VBOCone_cls* GetPCVBOCone();
    VBOCube_cls* GetPCVBOCube();
    VBOCylinder_cls* GetPCVBOCylinder();
    VBOEmpty_cls* GetPCVBOEmpty();
    VBOHFProvider_cls* GetPCVBOHFProvider();
    VBOPlane_cls*  GetPCVBOPlane();
    VBOSphere_cls* GetPCVBOSphere();    
    WideCamera_cls* GetPCWideCamera();
    wxFileDialogEX *GetPCFileDialog();
    wxColourDialogEX *GetPCColourDialog();
    wxLogGuiEX *GetPCwxLogGuiEX();
};

#endif
