// (setq-c-offset 4)
// "clsFileSequence.h"

#include "clsFileSequence.h"

#include "../LUA/clsLuaBase.h"
//#include "../LUA/clsLuaTable.h"

#include "CommonDefinitions.h"

#include <fstream>
#include <sstream>
#include <iomanip>

#include <wx/filename.h>

#define CLS FileSequence_cls

CLS::
FileSequence_cls() {
    mDigitLen = -1; 
    mSeqLen = -1; 
    mInterval = 1;
    mInit = -1;
    mbReadStatus = TRUE;
}

CLS::
FileSequence_cls(wxString pathStr) {
    Set(pathStr, 0, 1);
}

void CLS::
Set(const wxString strPath, int initSeqNum, int seqInterval){
    mInterval = seqInterval;
    mstrPath = strPath;
    if (strPath.IsEmpty() == TRUE) return;

    mbReadStatus = TRUE;

    // ŏ%d 񂪂ꍇ

    int formatPos = SequenceFormatPos();
    if (formatPos == wxNOT_FOUND) InitFormat(initSeqNum);
    else{
	SplitFormat(formatPos);
	mInit = initSeqNum;
    }
}

int CLS::
SequenceFormatPos(){
    for (int index = 1; index < 10; index++){
	wxString buf;
	buf.Printf(wxT("%s0%dd"), wxT("%"), index);
	int pos = mstrPath.Find(buf.c_str());
	if (pos != wxNOT_FOUND) {
	    mDigitLen = index;
	    mInit = 0;
	    return pos;
	}
    }
    return wxNOT_FOUND;
}

void CLS::
InitFormat(int initSeqNum){
    // %0[1-9]d甲
    for (int i = 1; i < 10; i++){
	wxString buf;
	buf.Printf(wxT("%s0%dd"), wxT("%"), i);
	if (mstrPath.Find(buf/*.c_str()*/) != wxNOT_FOUND) {
	    mDigitLen = i; 
	    mstrFormat = mstrPath;
	    mInit = initSeqNum;
	    return;
	}
    }

    // PȂ%dĂ
    if (mstrPath.Find(wxT("%d")) != wxNOT_FOUND){
	mDigitLen = 0;
	mstrFormat = mstrPath;
	mInit = initSeqNum;
	return;
    }

    wxFileName CFile(mstrPath);
    wxString strPathMinusExt;
    wxString strExt;
    while (TRUE){
	if (CFile.HasExt() == FALSE){
	    strPathMinusExt = CFile.GetPath() + _WXDELIM_ + CFile.GetName();
	    break;
	}
	strExt = wxT(".") + CFile.GetExt() + strExt;
	CFile = wxFileName(CFile.GetPathWithSep() + CFile.GetName());
    }

    int posTail = (int)strPathMinusExt.Len() - 1;
    if (posTail > 999) return;

    while (strPathMinusExt[posTail] >= '0' && 
	   strPathMinusExt[posTail] <= '9'){
	posTail--;
	if (posTail > 999) break;
    }

    posTail++;

    if (posTail == strPathMinusExt.Len()){
	mInit = 0; mDigitLen = -1;
	mstrFileHead = strPathMinusExt;
	mstrFormat = mstrPath;
	mstrExt = strExt;
	return;
    }
    
    wxString strFH = strPathMinusExt.SubString(0, posTail - 1);
    wxString strDigit = strPathMinusExt.c_str() + posTail;
    mInit = atoi(strDigit.ToAscii());
    mDigitLen = (int)(strPathMinusExt.Len() - posTail);
    wxString strFormatMain;
    strFormatMain.Printf(wxT("%s0%dd"), wxT("%"), mDigitLen);

    mstrFileHead = strFH;
    mstrFormat = strFH + strFormatMain + strExt;
    mstrExt = strExt;
}

void CLS::
SplitFormat(int pos){
    wxFileName CFile(mstrPath);
    mstrFileHead = CFile.GetFullPath().SubString(0, pos);
    mstrFormat = CFile.GetFullPath();
    mstrExt.Clear();
    if (CFile.HasExt() == TRUE)
	mstrExt << wxT(".") << CFile.GetExt();
}

void CLS::
CheckSingleFileValidity(){
    wxString strModifiedStr = mstrPath;//GetModifiedStr(0);
#ifdef WIN32
    std::wfstream ifstream(strModifiedStr.ToStdWstring(), std::ios::in);
#else
    wxString wxFileIn = wxConvFile.cWC2WX(strModifiedStr.c_str());
    std::ifstream ifstream(wxFileIn.ToAscii(), std::ios::in);
#endif
    if (ifstream.fail()) {// ȃt@C
	mbReadStatus = FALSE;
    }
}

bool CLS::
CalcMaxOffset(bool bShowWarning){

    if (mDigitLen == -1) {
	mSeqLen = 1;

	wxString strModifiedStr = GetModifiedStr(0);
#ifdef WIN32
	std::wfstream ifstream(strModifiedStr.ToStdWstring(), std::ios::in);
#else
	wxString wxFileIn = wxConvFile.cWC2WX(strModifiedStr.c_str());
	std::ifstream ifstream(wxFileIn.ToAscii(), std::ios::in);
#endif
	if (ifstream.fail()) {// ȃt@C
	    mbReadStatus = FALSE;
	}

	return TRUE;
    }

    mSeqLen    = 0; 
    int increment = 1000;
    int offset    = 0;

    wxString strModifiedStr = GetModifiedStr(offset);
    
#ifdef WIN32
    std::wfstream ifstream(strModifiedStr.ToStdWstring(), std::ios::in);
#else
    wxString wxFileIn = wxConvFile.cWC2WX(strModifiedStr.c_str());
    std::ifstream ifstream(wxFileIn.ToAscii(), std::ios::in);
#endif
    
    wxString wxMes = wxT("Can not open file");
    if (ifstream.fail()) {// ȃt@C
	wxString strMessage = wxString::Format(wxT("FileSequence_cls::CalcMaxOffset\n%ls"), GetModifiedStr(offset).c_str());
	if (bShowWarning == TRUE)
	    wxMessageBox(strMessage, _("File Open Failed"));
	mbReadStatus = FALSE;
	return FALSE; 
    }
    
    ifstream.close();

    bool exitFlag = FALSE;

    while (TRUE){
	do {
	    if (increment == 1){ // increment1J艺ȂI
		exitFlag = TRUE; break;
	    }
	    increment /= 10;
	    
	    ifstream.clear();

	    // gztǂݍ݌Ƃ
	    wxString strFileCandid0 = GetModifiedStr(offset + increment);
	    wxString strFileCandid1;
	    wxFileName CFile(strFileCandid0);
	    if (CFile.GetExt().IsSameAs(wxT("gz")))
		strFileCandid1 = strFileCandid0.Mid(0, strFileCandid0.Len()-3);
	    else
		strFileCandid1 = strFileCandid0 + wxT(".gz");
	    
#ifdef WIN32
	    ifstream.open(strFileCandid0.ToStdWstring(), std::ios::in);
	    if (ifstream.fail())
		ifstream.open(strFileCandid1.ToStdWstring(), std::ios::in);
#else
	    ifstream.open(strFileCandid0.ToAscii(), std::ios::in);
	    if (ifstream.fail())
	      ifstream.open(strFileCandid1.ToAscii(), std::ios::in);	    
#endif
	    if (!ifstream.fail()) ifstream.close();
	    	    
	} while (ifstream.fail()); // t@CincrementJ艺
	
	mSeqLen += increment;
	offset  += increment;
	if (exitFlag == TRUE) break;
	increment *= 10;
    }

    return TRUE;
}

int CLS::
GetIndexClamp(int index){
    if (index >= mSeqLen) index = mSeqLen - 1;
    if (index < 0) index = 0;
    return index;
}

int CLS::
GetIndexRepeat(int index){
    if (index < 0) index = 0;
    if (mSeqLen <= 1) return 0;
    return index % mSeqLen;
}

wxString CLS::
GetFormat(){
    return mstrFormat;
}

wxString CLS::
GetModifiedStr(int index, int stereo, wxString strScript){
    wxString strBuf;
    wxString strFormat = GetFormat();
    wxString strStereo;

    int seqIndex = mInit + index * mInterval;

    if (strScript.IsEmpty() == FALSE){
	LuaBase_cls CLuaBase;

	// sKAԂLua悤B
	// XNvgɁATableQƂR}h
	// o^
	/*
	std::vector < luaL_Reg > VCLibTable;
	LuaTable_cls::AppendLibTable(VCLibTable, strScript);
	VCLibTable.push_back(luaL_Reg{NULL, NULL});
	*/
	
	luaL_Reg **LuaTables = NULL;
	wxArrayString AstrLibraryName;

	wxString strFunction;
	strFunction << wxT("function script(index)") << ENDL;
	strFunction << strScript << ENDL;
	strFunction << wxT("end") << ENDL;
	
	CLuaBase.OpenLuaBase(strFunction, 0, AstrLibraryName, LuaTables);

	lua_getglobal(CLuaBase.mpLua, "script");
	lua_pushnumber(CLuaBase.mpLua, index);
	if (lua_pcall(CLuaBase.mpLua, 1, 1, 0) != 0){
	    LuaBase_cls::CheckErrorMessage(CLuaBase.mpLua, wxT("FileSequence"));
	}
	else{
	    seqIndex = lua_tonumber(CLuaBase.mpLua, -1);
	    lua_pop(CLuaBase.mpLua, 1); //SNA
	    CLuaBase.CloseLuaBase();
	}
    }

    if (stereo != 0){
	if (stereo == 1) strStereo = wxT("L");
	if (stereo == 2) strStereo = wxT("R");
	if (CountString(strFormat, wxT("%")) == 1){
	    strFormat.Replace(wxT("%"), wxT("%s%"));
	    strBuf.Printf(strFormat, strStereo.c_str(), seqIndex);
	}
	else{
	    wxFileName CFile(strFormat);
	    strBuf = CFile.GetPath() + _WXDELIM_ + CFile.GetName() + strStereo;
	    if (CFile.HasExt() == TRUE)
		strBuf << wxT(".") << CFile.GetExt();
	}
    }
    else
	strBuf.Printf(strFormat, seqIndex);
    
    return strBuf;
}

void CLS::
AppendDefaultSequenceTag(){
    Set(mstrFileHead+wxT("%04d")+mstrExt, 0, 1);
}
