// (setq-c-offset 4)
// "clsFileSequenceDual.h"

#include "clsFileSequenceDual.h"

#include "../LUA/clsLuaBase.h"

#include "CommonDefinitions.h"

#include <fstream>
#include <sstream>
#include <iomanip>

#include <wx/filename.h>

#define CLS FileSequenceDual_cls

CLS::
FileSequenceDual_cls() {
    mDigitLenT = -1; mDigitLenZ = -1;
    mSeqLenT = -1; mSeqLenZ = -1;
    mIntervalT = 1; mIntervalZ = 1;
    mInitT = -1; mInitZ = -1;
    mbTFirst = TRUE;
    mbReadStatusDual = TRUE;
}

CLS::
FileSequenceDual_cls(wxString pathStr) {
    SetDual(pathStr, 0, 1);
}

void CLS::
SetDual(const wxString strPath, 
	int initSeqNumT, int initSeqNumZ, int seqIntervalT, int seqIntervalZ){
    mIntervalT = seqIntervalT; 
    mIntervalZ = seqIntervalZ;
    mstrPathDual = strPath;
    if (strPath.IsEmpty() == TRUE) return;

    mbReadStatusDual = TRUE;

    // ŏ%d 񂪂ꍇ
    int digitLenA = -1, digitLenB = -1;
    int initA = -1, initB = -1;

    int formatPosA = SequenceFormatPos(mstrPathDual, digitLenA, initA);
    if (formatPosA == wxNOT_FOUND){
	InitFormat(initSeqNumT, initSeqNumZ, formatPosA, digitLenA, initA);
	
    }
    else{
	wxString strB = mstrPathDual.Mid(formatPosA + 4);
	int formatPosB = SequenceFormatPos(strB, digitLenB, initB);
	if (formatPosB == wxNOT_FOUND)
	    InitFormat(initSeqNumT, initSeqNumZ, formatPosA, digitLenA, initA);
	else{
	    SplitFormat(formatPosA, formatPosB);
	    if (mbTFirst == TRUE){
		mDigitLenT = digitLenA; mDigitLenZ = digitLenB;
		mInitT = initA; mInitZ = initB;
	    }
	    else{
		mDigitLenT = digitLenB; mDigitLenZ = digitLenA;
		mInitT = initB; mInitZ = initA;
	    }
	}
    }
}

int CLS::
SequenceFormatPos(wxString strPath, int &digitLen, int &init){
    for (int index = 1; index < 10; index++){
	wxString buf;
	buf.Printf(wxT("%s0%dd"), wxT("%"), index);
	int pos = strPath.Find(buf.c_str());
	if (pos != wxNOT_FOUND) {
	    digitLen = index;
	    init = 0;
	    //mDigitLenT = index;
	    //mInitT = 0;
	    return pos;
	}
    }
    return wxNOT_FOUND;
}

void CLS::
InitFormat(int initSeqNumT, int initSeqNumZ, 
	   int posA, int digitLenA, int initA){
    wxString strOrg = mstrPathDual;

    // 0n%d ƘAԂ̊mFɎזȂ̂Œu
    if (posA != wxNOT_FOUND)
	mstrPathDual.replace(posA, 4, "####");

    wxFileName CFile(strOrg);
    wxString strPathMinusExt;
    wxString strExt;
    while (TRUE){
	if (CFile.HasExt() == FALSE){
	    strPathMinusExt = CFile.GetPath() + _WXDELIM_ + CFile.GetName();
	    break;
	}
	strExt = wxT(".") + CFile.GetExt() + strExt;
	CFile = wxFileName(CFile.GetPathWithSep() + CFile.GetName());
    }

    int posTail = (int)strPathMinusExt.Len() - 1;
    if (posTail > 999) return;

    while (strPathMinusExt[posTail] >= '0' && 
	   strPathMinusExt[posTail] <= '9'){
	posTail--;
	if (posTail > 999) break;
    }

    posTail++;

    // ł
    if (posTail == strPathMinusExt.Len()){
	// ZD
	mInitT = 0; mDigitLenT = -1;
	mInitZ = initA; mDigitLenZ = digitLenA;
	mstrFileHeadDual = strPathMinusExt;
	mstrExtDual = strExt;
	mstrPathDual = strOrg;
	mstrFormatDual = mstrPathDual;
	return;
    }

    int posB = posTail;
    wxString strFH = strPathMinusExt.SubString(0, posTail - 1);

    wxString strDigit = strPathMinusExt.c_str() + posTail;
    int initB = atoi(strDigit.ToAscii());
    int digitLenB = (int)(strPathMinusExt.Len() - posTail);
    wxString strFormatMain;
    strFormatMain.Printf(wxT("%s0%dd"), wxT("%"), digitLenB);

    if (posA < posB)
	mstrFileHeadDual = strPathMinusExt.SubString(0, posA-1);
    else
	mstrFileHeadDual = strPathMinusExt.SubString(0, posB-1);

    mstrFormatDual = strFH + strFormatMain + strExt;
    mstrExtDual = strExt;
    mstrPathDual = strOrg;
    if (mbTFirst == TRUE){
	mInitT = initA;	mInitZ = initB;
	mDigitLenT = digitLenA; mDigitLenZ = digitLenB;
    }
    else{
	mInitT = initB;	mInitZ = initA;
	mDigitLenT = digitLenB; mDigitLenZ = digitLenA;
    }
}

void CLS::
SplitFormat(int posFH, int posLH){
    wxFileName CFile(mstrPathDual);
    mstrFileHeadDual = CFile.GetFullPath().SubString(0, posFH);
    mstrFormatDual = CFile.GetFullPath();
    mstrExtDual.Clear();
    if (CFile.HasExt() == TRUE)
	mstrExtDual << wxT(".") << CFile.GetExt();
}

bool CLS::
CalcMaxOffsetZ(int frame, bool bShowWarning){
    if (mDigitLenZ == -1){
	mSeqLenZ = 1;

	wxString strModifiedStr = GetModifiedStrDual(frame, 0);
	
#ifdef WIN32
	std::wfstream ifstream(strModifiedStr.ToStdWstring(), std::ios::in);
#else
	wxString wxFileIn = wxConvFile.cWC2WX(strModifiedStr.c_str());
	std::ifstream ifstream(wxFileIn.ToAscii(), std::ios::in);
#endif
	if (ifstream.fail()) {// ȃt@C
	    mbReadStatusDual = FALSE;
	}

	return TRUE;
    }

    mSeqLenZ = 0;
    
    int increment = 1000;
    int offset    = 0;

    wxString strModifiedStr = GetModifiedStrDual(frame, offset);

    #ifdef WIN32
    std::wfstream ifstream(strModifiedStr.ToStdWstring(), std::ios::in);
#else
    wxString wxFileIn = wxConvFile.cWC2WX(strModifiedStr.c_str());
    std::ifstream ifstream(wxFileIn.ToAscii(), std::ios::in);
#endif

    if (ifstream.fail()) {// ȃt@C
	wxString strMessage = wxString::Format(wxT("FileSequenceDual_cls::CalcMaxOffsetZ\n%ls"), GetModifiedStrDual(offset, 0).c_str());
	if (bShowWarning == TRUE)
	    wxMessageBox(strMessage, _("File Open Failed"));
	mbReadStatusDual = FALSE;
	return FALSE; 
    }

    ifstream.close();

    bool exitFlag = FALSE;

    while (TRUE){
	do {
	    if (increment == 1){ // increment1J艺ȂI
		exitFlag = TRUE; break;
	    }
	    increment /= 10;
	    
	    ifstream.clear();

	    // gztǂݍ݌Ƃ
	    wxString strFileCandid0 = GetModifiedStrDual(frame, offset + increment);
	    wxString strFileCandid1;
	    wxFileName CFile(strFileCandid0);
	    if (CFile.GetExt().IsSameAs(wxT("gz")))
		strFileCandid1 = strFileCandid0.Mid(0, strFileCandid0.Len()-3);
	    else
		strFileCandid1 = strFileCandid0 + wxT(".gz");
	    
#ifdef WIN32
	    ifstream.open(strFileCandid0.ToStdWstring(), std::ios::in);
	    if (ifstream.fail())
		ifstream.open(strFileCandid1.ToStdWstring(), std::ios::in);
#else
	    ifstream.open(strFileCandid0.ToAscii(), std::ios::in);
	    if (ifstream.fail())
	      ifstream.open(strFileCandid1.ToAscii(), std::ios::in);	    
#endif
	    if (!ifstream.fail()) ifstream.close();
	    	    
	} while (ifstream.fail()); // t@CincrementJ艺
	
	mSeqLenZ += increment;
	offset  += increment;
	if (exitFlag == TRUE) break;
	increment *= 10;
    }

    return TRUE;
}

bool CLS::
CalcMaxOffsetDual(bool bShowWarning){
    if (mDigitLenT == -1){
	mSeqLenT = 1;

	wxString strModifiedStr = GetModifiedStrDual(0, 0);
#ifdef WIN32
	std::wfstream ifstream(strModifiedStr.ToStdWstring(), std::ios::in);
#else
	wxString wxFileIn = wxConvFile.cWC2WX(strModifiedStr.c_str());
	std::ifstream ifstream(wxFileIn.ToAscii(), std::ios::in);
#endif
	if (ifstream.fail()) {// ȃt@C
	    mbReadStatusDual = FALSE;
	}
	
	return TRUE;
    }

    mSeqLenT    = 0; 
    int increment = 1000;
    int offset    = 0;

    wxString strModifiedStr = GetModifiedStrDual(offset, 0);
    
#ifdef WIN32
    std::wfstream ifstream(strModifiedStr.ToStdWstring(), std::ios::in);
#else
    wxString wxFileIn = wxConvFile.cWC2WX(strModifiedStr.c_str());
    std::ifstream ifstream(wxFileIn.ToAscii(), std::ios::in);
#endif
    
    wxString wxMes = wxT("Can not open file");
    if (ifstream.fail()) {// ȃt@C
	wxString strMessage = wxString::Format(wxT("FileSequenceDual_cls::CalcMaxOffsetDual\n%ls"), GetModifiedStrDual(offset, 0).c_str());
	if (bShowWarning == TRUE)
	    wxMessageBox(strMessage, _("File Open Failed"));
	mbReadStatusDual = FALSE;
	return FALSE; 
    }
    
    ifstream.close();

    bool exitFlag = FALSE;

    while (TRUE){
	do {
	    if (increment == 1){ // increment1J艺ȂI
		exitFlag = TRUE; break;
	    }
	    increment /= 10;
	    
	    ifstream.clear();

	    // gztǂݍ݌Ƃ
	    wxString strFileCandid0 = GetModifiedStrDual(offset + increment, 0);
	    wxString strFileCandid1;
	    wxFileName CFile(strFileCandid0);
	    if (CFile.GetExt().IsSameAs(wxT("gz")))
		strFileCandid1 = strFileCandid0.Mid(0, strFileCandid0.Len()-3);
	    else
		strFileCandid1 = strFileCandid0 + wxT(".gz");
	    
#ifdef WIN32
	    ifstream.open(strFileCandid0.ToStdWstring(), std::ios::in);
	    if (ifstream.fail())
		ifstream.open(strFileCandid1.ToStdWstring(), std::ios::in);
#else
	    ifstream.open(strFileCandid0.ToAscii(), std::ios::in);
	    if (ifstream.fail())
	      ifstream.open(strFileCandid1.ToAscii(), std::ios::in);	    
#endif
	    if (!ifstream.fail()) ifstream.close();
	    	    
	} while (ifstream.fail()); // t@CincrementJ艺
	
	mSeqLenT += increment;
	offset  += increment;
	if (exitFlag == TRUE) break;
	increment *= 10;
    }

    return TRUE;
}

wxString CLS::
GetFormatDual(){
    return mstrFormatDual;
}

wxString CLS::
GetModifiedStrDual(int indexT, int indexZ, int stereo, wxString strScript){
    wxString strBuf;
    wxString strFormat = GetFormatDual();
    wxString strStereo;

    int seqIndexT = mInitT + indexT * mIntervalT;
    int seqIndexZ = mInitZ + indexZ * mIntervalZ;

    if (strScript.IsEmpty() == FALSE){
	LuaBase_cls CLuaBase;

	// sKAԂLua悤B
	// XNvgɁATableQƂR}h
	// o^
	/*
	std::vector < luaL_Reg > VCLibTable;
	LuaTable_cls::AppendLibTable(VCLibTable, strScript);
	VCLibTable.push_back(luaL_Reg{NULL, NULL});
	*/
	
	luaL_Reg **LuaTables = NULL;
	wxArrayString AstrLibraryName;

	wxString strFunction;
	strFunction << wxT("function script(index)") << ENDL;
	strFunction << strScript << ENDL;
	strFunction << wxT("end") << ENDL;
	
	CLuaBase.OpenLuaBase(strFunction, 0, AstrLibraryName, LuaTables);

	lua_getglobal(CLuaBase.mpLua, "script");
	lua_pushnumber(CLuaBase.mpLua, indexT);
	if (lua_pcall(CLuaBase.mpLua, 1, 1, 0) != 0){
	    LuaBase_cls::CheckErrorMessage(CLuaBase.mpLua, wxT("FileSequence"));
	}
	else{
	    seqIndexT = lua_tonumber(CLuaBase.mpLua, -1);
	    lua_pop(CLuaBase.mpLua, 1); //SNA
	    CLuaBase.CloseLuaBase();
	}
    }

    if (stereo != 0){
	if (stereo == 1) strStereo = wxT("L");
	if (stereo == 2) strStereo = wxT("R");
	if (CountString(strFormat, wxT("%")) == 1){
	    strFormat.Replace(wxT("%"), wxT("%s%"));
	    strBuf.Printf(strFormat, strStereo.c_str(), seqIndexZ);
	}
	else if (CountString(strFormat, wxT("%")) == 2){
	    strFormat.Replace(wxT("%"), wxT("%s%"));
	    if (mbTFirst == TRUE)
		strBuf.Printf(strFormat, strStereo.c_str(), seqIndexT, seqIndexZ);
	    else
		strBuf.Printf(strFormat, strStereo.c_str(), seqIndexZ, seqIndexT);
	}
	else{
	    wxFileName CFile(strFormat);
	    strBuf = CFile.GetPath() + _WXDELIM_ + CFile.GetName() + strStereo;
	    if (CFile.HasExt() == TRUE)
		strBuf << wxT(".") << CFile.GetExt();
	}
    }
    else{
	if (CountString(strFormat, wxT("%")) == 1){
	    strBuf.Printf(strFormat, seqIndexZ);
	}
	else if (CountString(strFormat, wxT("%")) == 2){
	    if (mbTFirst == TRUE)
		strBuf.Printf(strFormat, seqIndexT, seqIndexZ);
	    else
		strBuf.Printf(strFormat, seqIndexZ, seqIndexT);
	}
    }
    
    return strBuf;
}
