// -*- c -*- 
// (setq c-basic-offset 4)
// "clsHalton.cpp"

#include "clsHalton.h"

#include <cstddef>

#define CLS Halton_cls

CLS::
Halton_cls(){
    //if (mAHaltonX[0] != -1) return;

    int i = 0;
    for (int idash = 0; i < 256; idash++){
	//Halton
	int base = 7;
	float result = 0;
	float f = 1.0f/ base;
	int i_ = idash + 1;
	while (i_ > 0) {
	    result = result + f * (i_ % base);
	    i_ /= base;
	    f /= base;
        }
	mAHaltonX[i] = result;

	base = 3;
	result = 0;
	f = 1.0f/base;
	i_ = idash + 1;
	while (i_ > 0) {
	    result = result + f * (i_ % base);
	    i_ /= base;
	    f /= base;
        }
	mAHaltonY[i] = result;

	base = 5;
	result = 0;
	f = 1.0f/base;
	i_ = idash + 1;
	while (i_ > 0) {
	    result = result + f * (i_ % base);
	    i_ /= base;
	    f /= base;
        }
	mAHaltonZ[i] = result;
	
	if (mAHaltonX[i]*mAHaltonX[i] + mAHaltonY[i]*mAHaltonY[i] + mAHaltonZ[i]*mAHaltonZ[i] <= 1.0)
	    i++;
    }
}

float CLS::
GetX(int index){
    index = index % 256;
    return mAHaltonX[index];
}

float CLS::
GetY(int index){
    index = index % 256;
    return mAHaltonY[index];
}

float CLS::
GetZ(int index){
    index = index % 256;
    return mAHaltonZ[index];
}

Halton_cls *GpCHalton = NULL;

/*
float Halton_cls::msAHaltonX[256] = {-1};
float Halton_cls::msAHaltonY[256] = {-1};
float Halton_cls::msAHaltonZ[256] = {-1};
*/
