// (setq-c-offset 4)
// "clsSortParallel.cpp"

#include "clsSortParallel.h"
#include "../SIMDATA/clsArrayAndIndex.h"

#include <wx/wx.h>
#include <algorithm>

#define CLS ThreadSortParallel_cls

void CLS::
SetParameters(ArrayAndIndex_cls *pIndexAndZ){
    mpIndexAndZ = pIndexAndZ;
}

wxThread::ExitCode CLS::
Entry(){

    ArrayAndIndex_cls * const pIndexAndZ = mpIndexAndZ;

    std::sort(pIndexAndZ + mPIni, pIndexAndZ + mPFin);
    
    *mpbFinishedFlagLink = TRUE;
    return 0;
}

// ----

void ThreadSortMergeOrd_cls::
SetParameters(ArrayAndIndex_cls *pCTgt, 
	      ArrayAndIndex_cls *pCSrc,
	      int cacheIni0, int cacheFin0,
	      int cacheIni1, int cacheFin1, int block){
    
    mpCTgt = pCTgt;
    mpCSrc = pCSrc;
    mCacheIni0 = cacheIni0;
    mCacheFin0 = cacheFin0;
    mCacheIni1 = cacheIni1;
    mCacheFin1 = cacheFin1;
    //mSize  = cacheFin1 - cacheIni0;
    mBlock = block;
}

wxThread::ExitCode ThreadSortMergeOrd_cls::
Entry(){
    ArrayAndIndex_cls *pCTgt = mpCTgt;
    ArrayAndIndex_cls *pCSrc = mpCSrc;

    int cacheIni0 = mCacheIni0; int cacheFin0 = mCacheFin0;
    int cacheIni1 = mCacheIni1; int cacheFin1 = mCacheFin1;
    
    bool bFinished0 = FALSE;
    bool bFinished1 = FALSE;

    int current0 = cacheIni0;
    int current1 = cacheIni1;

    int block = mBlock;
    
    int index = cacheIni0 + 0;
    int indexTarget = cacheFin0;
    const int copyBlock = sizeof(ArrayAndIndex_cls) * block;
    
TAG_REMERGE:

    if (block == 1){
	while (TRUE){
	    if (bFinished1 == TRUE || (pCSrc[current0].mZ < pCSrc[current1].mZ && bFinished0 == FALSE)){
		//memcpy(pCTgt + index, pCSrc + current0, sizeof(ArrayAndIndex_cls));
		pCTgt[index] = pCSrc[current0];
		current0++;
		if (current0 == cacheFin0) 
		    bFinished0 = TRUE;
	    }
	    else{
		//memcpy(pCTgt + index, pCSrc + current1, sizeof(ArrayAndIndex_cls));
		pCTgt[index] = pCSrc[current1];
		current1++;
		if (current1 == cacheFin1) 
		    bFinished1 = TRUE;
	    }

	    index++;
	    if (index == indexTarget)
		break;
	}
    }
    else{
	while (TRUE){
	    int remain = indexTarget - (index + block);
	    if (index + 2*block >= indexTarget) {
		block = 1; goto TAG_REMERGE;
	    }
	    
	    if (pCSrc[current0].mZ < pCSrc[current1].mZ && bFinished0 == FALSE){

		if (current0 + 2*block >= cacheFin0){
		    block = 1; goto TAG_REMERGE;
		}
		
		int maxcand = current1 + remain;
		if (maxcand >= cacheFin1) maxcand = cacheFin1 - 1;
		
		if (pCSrc[current0 + block - 1] > pCSrc[maxcand]){
		    block = 1; goto TAG_REMERGE;
		}
		
		memcpy(pCTgt + index, pCSrc + current0, sizeof(ArrayAndIndex_cls) * block);
		current0 += block;
		index    += block;
		
		if (current0 == cacheFin0) bFinished0 = TRUE;
	    }
	    else{
		if (current1 + block >= cacheFin1) {
		    block = 1; goto TAG_REMERGE;
		}
		
		int maxcand = current0 + remain;
		if (maxcand >= cacheFin0) maxcand = cacheFin0 - 1;
		
		if (pCSrc[current1 + block - 1] > pCSrc[maxcand]){
		    block = 1; goto TAG_REMERGE;
		}
		
		memcpy(pCTgt + index, pCSrc + current1, sizeof(ArrayAndIndex_cls) * block);
		current1 += block;
		index    += block;
		
		if (current1 == cacheFin1) bFinished1 = TRUE;
	    }
	    
	    if (index == indexTarget)
		break;

	    if (bFinished0 == TRUE && bFinished1 == TRUE) exit(0);
	}
    }

    *mpbFinishedFlagLink = TRUE;
    return 0;
}

//--------------

void ThreadSortMergeInv_cls::
SetParameters(ArrayAndIndex_cls *pCTgt, 
	      ArrayAndIndex_cls *pCSrc,
	      int cacheIni0, int cacheFin0,
	      int cacheIni1, int cacheFin1, int block){
    
    mpCTgt = pCTgt;
    mpCSrc = pCSrc;
    mCacheIni0 = cacheIni0; mCacheFin0 = cacheFin0;
    mCacheIni1 = cacheIni1; mCacheFin1 = cacheFin1;
    //mSize  = cacheFin1 - cacheIni0;
    mBlock = block;
}

wxThread::ExitCode ThreadSortMergeInv_cls::
Entry(){
    ArrayAndIndex_cls *pCTgt = mpCTgt;
    ArrayAndIndex_cls *pCSrc = mpCSrc;
    
    int cacheIni0 = mCacheIni0; int cacheFin0 = mCacheFin0;
    int cacheIni1 = mCacheIni1; int cacheFin1 = mCacheFin1;
    
    bool bFinished0 = FALSE;
    bool bFinished1 = FALSE;
    int current0 = cacheFin0 - 1;
    int current1 = cacheFin1 - 1;

    int block = mBlock;
    
    int candidate = 0;
    int index = cacheFin1 - 1;
    int indexTarget = cacheFin0;
    const int copyBlock = sizeof(ArrayAndIndex_cls) * block;

TAG_REMERGE:

    if (block == 1){
	while (TRUE){
	    if (bFinished1 == TRUE || (pCSrc[current0].mZ >= pCSrc[current1].mZ && bFinished0 == FALSE)){
		//memcpy(pCTgt + index, pCSrc + current0, sizeof(ArrayAndIndex_cls));
		pCTgt[index] = pCSrc[current0];
		current0--;
		if (current0 == cacheIni0 - 1)
		    bFinished0 = TRUE;
	    }
	    else{
		//memcpy(pCTgt + index, pCSrc + current1, sizeof(ArrayAndIndex_cls));
		pCTgt[index] = pCSrc[current1];
		current1--;
		if (current1 == cacheIni1 - 1)
		    bFinished1 = TRUE;
	    }
	    
	    index--;
	    if (index == indexTarget - 1)
		break;
	}
    }
    else{
	while (TRUE){
	    int remain = (index - block) - indexTarget + 1;
	    if (index - 2*block < indexTarget){
		block = 1; goto TAG_REMERGE;
	    }
	    
	    if (pCSrc[current0].mZ >= pCSrc[current1].mZ && bFinished0 == FALSE){
		
		if (current0 - 2*block < cacheIni0){
		    block = 1; goto TAG_REMERGE;
		}

		int mincand = current1 - remain;
		if (mincand < cacheIni1) mincand = cacheIni1;

		if (pCSrc[current0 - block + 1] > pCSrc[mincand]){
		    block = 1; goto TAG_REMERGE;
		}

		memcpy(pCTgt + (index + 1 - block), 
		       pCSrc + (current0 + 1 - block), sizeof(ArrayAndIndex_cls) * block);
		current0 -= block;	    
		index    -= block;

		if (current0 == cacheIni0 - 1) bFinished0 = TRUE;

	    }
	    else{
		
		if (current1 - 2*block < cacheIni0){
		    block = 1; goto TAG_REMERGE;
		}

		int mincand = current0 - remain;
		if (mincand < cacheIni0) mincand = cacheIni0;

		if (pCSrc[current1 - block + 1] > pCSrc[mincand]){
		    block = 1; goto TAG_REMERGE;
		}

		memcpy(pCTgt + (index + 1 - block), 
		       pCSrc + (current1 + 1 - block), sizeof(ArrayAndIndex_cls) * block);
		current1 -= block;	    
		index    -= block;
		
		if (current1 == cacheIni1 - 1) bFinished1 = TRUE;

	    }

	    if (index == indexTarget - 1) break;

	    if (bFinished0 == TRUE && bFinished1 == TRUE) exit(0);
	}
    }
    
    *mpbFinishedFlagLink = TRUE;
    return 0;
}

#define CLS SortParallel_cls

void CLS::
SortParallel(ArrayAndIndex_cls *pIndexAndZ, int size){

    bool *bAFinished = new bool[4];
    for (int i = 0; i < 4; i++) bAFinished[i] = FALSE;

    ThreadSortParallel_cls *pCThread[4];
    
    int cacheIni[4], cacheFin[4];
    for (int thread = 0; thread  <4; thread++){
	GetIniAndFin(cacheIni[thread], cacheFin[thread], thread, 4, size);
	pCThread[thread] = new ThreadSortParallel_cls;
	pCThread[thread]->SetParameters(pIndexAndZ);
	pCThread[thread]->CreateThread
	    (&bAFinished[thread], cacheIni[thread], cacheFin[thread]);
    }

    for (int thread = 0; thread < 4; thread++)
	pCThread[thread]->Run();

    WaitThreadsAndDeleteFlag(bAFinished, 4, 2);

    // }[W
    ArrayAndIndex_cls *pCCache = new ArrayAndIndex_cls [size];

    int block = 1;
    /*
    switch (GCClassProvider.GetPCPreference()->mCSortType.mBody){
    case 0:
	block = 1; break;
    case 1:
	block = 10; break;
    case 2:
	block = 100; break;
    case 3:
	block = 1000; break;
    }
    */

    bAFinished = new bool[4];
    for (int i = 0; i < 4; i++){ bAFinished[i] = FALSE; }
    int dummy = 0;

    ThreadSortMergeOrd_cls *pCThreadAOrd = new ThreadSortMergeOrd_cls;
    pCThreadAOrd->SetParameters(pCCache, pIndexAndZ,
				cacheIni[0], cacheFin[0],
				cacheIni[1], cacheFin[1], block);
    pCThreadAOrd->CreateThread(&bAFinished[0], dummy, dummy);

    ThreadSortMergeInv_cls *pCThreadAInv = new ThreadSortMergeInv_cls;
    pCThreadAInv->SetParameters(pCCache, pIndexAndZ,
				cacheIni[0], cacheFin[0],
				cacheIni[1], cacheFin[1], block);
    pCThreadAInv->CreateThread(&bAFinished[1], dummy, dummy);

    ThreadSortMergeOrd_cls *pCThreadBOrd = new ThreadSortMergeOrd_cls;
    pCThreadBOrd->SetParameters(pCCache, pIndexAndZ, 
				cacheIni[2], cacheFin[2],
				cacheIni[3], cacheFin[3], block);
    pCThreadBOrd->CreateThread(&bAFinished[2], dummy, dummy);

    ThreadSortMergeInv_cls *pCThreadBInv = new ThreadSortMergeInv_cls;
    pCThreadBInv->SetParameters(pCCache, pIndexAndZ,
				cacheIni[2], cacheFin[2],
				cacheIni[3], cacheFin[3], block);
    pCThreadBInv->CreateThread(&bAFinished[3], dummy, dummy);
    
    pCThreadAOrd->Run(); pCThreadAInv->Run();
    pCThreadBOrd->Run(); pCThreadBInv->Run();

    WaitThreadsAndDeleteFlag(bAFinished, 4, 2);

    // }[W2i
    bAFinished = new bool [2];
    for (int i = 0; i < 2; i++){ bAFinished[i] = FALSE; }

    ThreadSortMergeOrd_cls *pCThreadCOrd = new ThreadSortMergeOrd_cls;
    pCThreadCOrd->SetParameters(pIndexAndZ, pCCache, 
				cacheIni[0], cacheFin[1],
				cacheIni[2], cacheFin[3], block);
    pCThreadCOrd->CreateThread(&bAFinished[0], dummy, dummy);
    
    ThreadSortMergeInv_cls *pCThreadCInv = new ThreadSortMergeInv_cls;
    pCThreadCInv->SetParameters(pIndexAndZ, pCCache, 
				cacheIni[0], cacheFin[1],
				cacheIni[2], cacheFin[3], block);
    pCThreadCInv->CreateThread(&bAFinished[1], dummy, dummy);

    pCThreadCOrd->Run(); pCThreadCInv->Run();

    WaitThreadsAndDeleteFlag(bAFinished, 2, 2);

    delete [] pCCache;
}
