// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsSortParallel.cpp"

#ifndef _SORT_PARALLEL_H_
#define _SORT_PARALLEL_H_

#include "clsThreadCommon.h"

class ArrayAndIndex_cls;

class ThreadSortParallel_cls : public ThreadInstance_cls {
 public:
    void SetParameters(ArrayAndIndex_cls *pIndexAndZ);

    ArrayAndIndex_cls *mpIndexAndZ;

    virtual ExitCode Entry();
};

class ThreadSortMergeOrd_cls : public ThreadInstance_cls {
public:
    void SetParameters(ArrayAndIndex_cls *pCSrc, 
		       ArrayAndIndex_cls *pCTgt,
		       int cacheIni0, int cacheFin0,
		       int cacheIni1, int cacheFin1, int block);

    ArrayAndIndex_cls *mpCSrc;
    ArrayAndIndex_cls *mpCTgt;

    int mCacheIni0, mCacheFin0;
    int mCacheIni1, mCacheFin1;
    int mBlock;

    virtual ExitCode Entry();
};

class ThreadSortMergeInv_cls : public ThreadInstance_cls {
public:
    void SetParameters(ArrayAndIndex_cls *pCSrc, 
		       ArrayAndIndex_cls *pCTgt,
		       int cacheIni0, int cacheFin0,
		       int cacheIni1, int cacheFin1, int block);

    ArrayAndIndex_cls *mpCSrc;
    ArrayAndIndex_cls *mpCTgt;

    int mCacheIni0, mCacheFin0;
    int mCacheIni1, mCacheFin1;
    int mBlock;
    
    virtual ExitCode Entry();
};

class SortParallel_cls : public ThreadCommon_cls{
 public:
    void SortParallel(ArrayAndIndex_cls *pIndexAndZ, int size);
};

#endif
