// -*- c -*-
// "clsTensor.cpp"
// (setq c-basic-offset 4)

#ifndef _TENSOR_MATH
#define _TENSOR_MATH

class TensorMath_cls{
 public:
    static void LoadIdentity(double matrix[16]);

    void Translate(double matrix[16], double pos[3]);
    void Scale(double matrix[16], double scale[3]);

    void RotateX(double matrix[16], double rotX);
    void RotateY(double matrix[16], double rotY);
    void RotateZ(double matrix[16], double rotZ);

    // m[3]=m[7]=m[11]=0m vec[3]=1 m̏ꍇ
    static void MultiplyVFast(double m[16], double vec[4]);
    static void MultiplyV(double m[16], double vec[4]);
    static void Multiply(double m[16], double matrix1[16]);
    static void Multiply(float m[16], float matrix1[16]);
    //void MultiplyInv(double matrix1[16], double m[16]);

    static double GetDeterminant3x3(double m[9]);
    static void GetSmallMatrix4to3(double src[16], double dst[9], int col, int row);
    static void Transpose4x4(double src[16], double dst[16], double div);
    static void Transpose4x4(float src[16], float dst[16], float div);
    static double GetInvMatrix4x4(double src[16], double dst[16]);
    static float GetInvMatrix4x4(float src[16], float dst[16]);

    static void ConvertToFloat(float *pf, double *pd, int dim);

    static void GetRotationMatrix4x4(float dst[16], float axis_[3],
				     float angle);

    static int sign[4][4];
};

#endif 
