
#include "clsThreadCommon.h"

#include <wx/wx.h>

#include "CommonDefinitions.h"
#include "CommonDefinitionsForH.h"

bool* ThreadCommon_cls::
GetNewPCbFinishList(int &threadNumber, int pNum, bool bLowPriority){
    threadNumber = 1;
    if (pNum > 10000) threadNumber = 2;
    if (pNum > 100000) threadNumber = 3;
    if (pNum > 1000000) threadNumber = 4;
    if (pNum > 10000000) threadNumber = 5;
    if (pNum > 100000000) threadNumber = 6;
    
    if (bLowPriority == TRUE) threadNumber--;
    if (threadNumber == 0) threadNumber = 1;
    
    if (threadNumber > 3)
	if (msCPUCount > 12) threadNumber *= 2;

    if (threadNumber > _MAX_THREAD_LUA_AND_INTERPOLATE)
	threadNumber = _MAX_THREAD_LUA_AND_INTERPOLATE;
    
    bool *bAFinished = new bool [threadNumber];
    for (int core = 0; core < threadNumber; core++)
	bAFinished[core] = FALSE;
    return bAFinished;
}

void ThreadCommon_cls::
GetIniAndFin(int &ini, int &fin, 
	     int core, int threadNumber, int PNum){
    ini = PNum / threadNumber * core;
    fin = PNum / threadNumber * (core + 1);
    if (core == threadNumber - 1) fin = PNum;
}

void ThreadCommon_cls::
WaitThreadsNOTDeleteFlag(bool *bAFinished, int threadNumber, int millisleep){
    for (int i = 0; i < threadNumber; i++)
	while (bAFinished[i] == FALSE) wxMilliSleep(millisleep);
}

void ThreadCommon_cls::
WaitThreadsAndDeleteFlag(bool *bAFinished, int threadNumber, int millisleep){
    for (int i = 0; i < threadNumber; i++)
	while (bAFinished[i] == FALSE) wxMilliSleep(millisleep);
    delete [] bAFinished;
}

int ThreadCommon_cls::msCPUCount = 0;

#define CLS ThreadInstance_cls

CLS::
ThreadInstance_cls() : wxThread(wxTHREAD_DETACHED){
    mPIni = 0; mPFin = 0;
}

bool CLS::
CreateThread(bool *pbFinishedFlag, int PIni, int PFin){
    mpbFinishedFlagLink = pbFinishedFlag;
    mPIni = PIni;
    mPFin = PFin;

    if ( Create() != wxTHREAD_NO_ERROR) 
	return FALSE;

    return TRUE;
}
