// -*- c -*- 
// (setq c-basic-offset 4)
// "clsConfItem.h"

#include "clsConfItem.h"

#include "../COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;

#include "../PREFERENCE/clsPreference.h"
#include "../UNDO/clsUndoManager.h"

#include "../../clsMain.h"

#include <fstream>
#include <sstream>
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <wx/filename.h>
#include <wx/filefn.h> 

#include "../COMMON/CommonDefinitions.h"

#define CLS ConfItemBase_cls

CLS::
ConfItemBase_cls(){
    mProcCounter = 0;
}

/*
int CLS::
GetInputParentNumber(){
if (mstrInputPanelName.IsEmpty() == TRUE) return 0;
    return mstrInputPanelName.Replace(wxT("::"), wxT("::")) +1;
}
*/

/*
void CLS::
AppendInputPanelName(wxString strInputPanelName){
    if (mstrInputPanelName.IsEmpty() == TRUE)
	mstrInputPanelName << strInputPanelName;
    else
	mstrInputPanelName << wxT("::") << strInputPanelName;
}

void CLS::
DetachInputPanelName(wxString strInputPanelName){
    if (mstrInputPanelName.Replace(strInputPanelName + wxT("::"), wxES, FALSE) == 0)
	mstrInputPanelName.Replace(strInputPanelName, wxES, FALSE);
}
*/

bool CLS::
GetBodyBOOL(){
    return (GetBodyINT() != 0);
}

long long CLS::
GetBodyINT(){
    long long value;
    value = atoll(mstrBody.ToAscii());
    return value;
}

wxString CLS::
GetBodySTR(){ return mstrBody; }

wxString CLS::
GetBodySTRShortString(){
    double value;
    mstrBody.ToDouble(&value);
    return wxString::Format("%g", value);
}

double CLS::
GetBodyDOUBLE(){
    double value;
    mstrBody.ToDouble(&value);
    return value;
}

wxColour CLS::
GetBodyWXColor(){
    std::vector < float > VClr = GetBodyFLOATARRAY();
    if (VClr.size() < 3) return wxColour(0, 0, 0);
    return wxColour(VClr[0]*255, VClr[1]*255, VClr[2]*255);
}

std::vector < int > CLS::
GetBodyINTARRAY(){
    std::vector < int > VValue;
    wxString strBody = mstrBody;
    if (strBody.IsEmpty()) return VValue;
    while(TRUE){
	int pos = strBody.Find(wxT(" "));
	wxString strItem = strBody.Mid(0, pos);
	long value;
	strItem.ToLong(&value);
	VValue.push_back(value);
	if (pos == wxNOT_FOUND) break;
	strBody = strBody.Mid(pos+1);
    }
    return VValue;
}

std::vector < bool > CLS::
GetBodyBOOLARRAY(){
    std::vector < bool > VValue;
    wxString strBody = mstrBody;
    if (strBody.IsEmpty()) return VValue;
    while(TRUE){
	int pos = strBody.Find(wxT(" "));
	wxString strItem = strBody.Mid(0, pos);
	long value;
	strItem.ToLong(&value);
	VValue.push_back((bool)value);
	if (pos == wxNOT_FOUND) break;
	strBody = strBody.Mid(pos+1);
    }
    return VValue;
}

std::vector < float > CLS::
GetBodyFLOATARRAY(){
    std::vector < float > VValue;
    wxString strBody = mstrBody;
    if (strBody.IsEmpty()) return VValue;
    while(TRUE){
	int pos = strBody.Find(wxT(" "));
	wxString strItem = strBody.Mid(0, pos);
	double value;
	strItem.ToDouble(&value);
	VValue.push_back(value);
	if (pos == wxNOT_FOUND) break;
	strBody = strBody.Mid(pos+1);
    }
    return VValue;
}


void CLS::
SetBodyFromDataBOOL(bool bValue){
    mstrBody.Clear();
    mstrBody << bValue;
    mProcCounter++;
}

void CLS::
SetBodyFromData(long long value){
    mstrBody.Clear();
    mstrBody << value;
    mProcCounter++;
}

void CLS::
SetBodyFromData(double value){
    mstrBody.Clear();
    mstrBody << value; // !! CHECK_ME LɂĂ͗vmF
    mProcCounter++;
}

void CLS::
SetBodyFromData(wxString strValue){
    mstrBody = strValue;
    mProcCounter++;
}

void CLS::
SetBodyFromData(float value){
    mstrBody.Clear();
    mstrBody << value; // !! CHECK_ME LɂĂ͗vmF
    mProcCounter++;
}

void CLS::
SetBodyFromData(std::vector < bool > VbValue){
    mstrBody.Clear();
    for (uint i = 0; i < VbValue.size(); i++){
	if (i != 0) mstrBody << wxT(" ");
	mstrBody << VbValue[i]; 
    }
    mProcCounter++;
}

void CLS::
SetBodyFromData(std::vector < float > VValue){
    mstrBody.Clear();
    for (uint i = 0; i < VValue.size(); i++){
	if (i != 0) mstrBody << wxT(" ");
	mstrBody << VValue[i]; 
    }
    mProcCounter++;
}

void CLS::
SetBodyFromData(std::vector < int > VValue){
    mstrBody.Clear();
    for (uint i = 0; i < VValue.size(); i++){
	if (i != 0) mstrBody << wxT(" ");
	mstrBody << VValue[i]; 
    }
    mProcCounter++;
}

void CLS::
Serialize(wxString& strOut){
    if (mConfType == _CONF_ITEM_STR)
	return ((ConfItemSTR_cls*)this)->Serialize(strOut);
    if (mConfType == _CONF_ITEM_STRINGARRAY)
	return ((ConfItemSTRINGARRAY_cls*)this)->Serialize(strOut);
    strOut << mstrHeader << mstrBody << ENDL;
}

void CLS::
SerializeSingleItem(wxString& strOut){
    if (mpstrParentTagLink != NULL)
	strOut << wxT("ConfItemList::Begin::") << *mpstrParentTagLink << ENDL;
    else
	strOut << wxT("ConfItemList::Begin::") << ENDL; 
    Serialize(strOut);
    strOut << wxT("ConfItemList::End");
}

void CLS::
PushCommandPair(wxString strData){
    wxString strUndo, strRedo;
    SerializeSingleItem(strUndo);
    SetBodyFromData(strData);
    SerializeSingleItem(strRedo);
    GCClassProvider.GetPCUndo()->PushCommandPair(strUndo, strRedo);
    GCClassProvider.GetPCUndo()->Redo();
}

// ---- 

ConfItem_cls::
ConfItem_cls(int type){
    mstrHeader = wxT("NONE");
    mstrBody   = wxT("NONE");
    mConfType = type;
    mpstrParentTagLink = NULL;
}

void ConfItem_cls::
SetParentListTag(wxString& strTag){
    mpstrParentTagLink = &strTag;
    if (strTag.IsSameAs("Box"))
	printf("!!");
}

void ConfItem_cls::
SetItem(wxString strHeader, wxString strBody){
    mstrHeader = strHeader;
    if (strBody.IsEmpty() == TRUE) return;
    mstrBody = strBody;
}

bool ConfItem_cls::
ReadStrLine(wxString strLine){
    if (mConfType == _CONF_ITEM_STRINGARRAY)
	return ((ConfItemSTRINGARRAY_cls*)this)->ReadStrLine(strLine);
    if (mConfType == _CONF_ITEM_STR)
	return ((ConfItemSTR_cls*)this)->ReadStrLine(strLine);
    strLine.Trim(FALSE);
    int loc = strLine.Find(mstrHeader);
    if (loc != 0) return FALSE;

    mstrBody = strLine.Mid(mstrHeader.Len());
    mstrBody.Replace(wxT("\\n"), wxT("\n"), TRUE);
    mProcCounter++;
    return TRUE;
}

void ConfItem_cls::
ReplaceSeparator(){
    for (uint i = 0; i < mstrBody.size(); i++){
	if (mstrBody[i] == '\\') mstrBody[i] = '/';
	if (mstrBody[i] == ' '){
	    mstrBody.insert(i, L"\\"); 
	    i++; }
    }
}

//----------------------------------

int ConfArray_cls::
CountDimension(wxString strBody){
    uint dimension = 0;
    std::wstring::size_type pos = 0;
    while (pos != std::wstring::npos){
	pos = strBody.find(L" ", pos + 1);
	dimension++;
    }
    return dimension;
}

//----------------------------------

ConfItemSTR_cls::
ConfItemSTR_cls() : ConfItem_cls (_CONF_ITEM_STR){
    mbFilePath = FALSE;
}

ConfItemSTR_cls::
ConfItemSTR_cls(wxString strHeader, wxString strBody) : 
ConfItem_cls (_CONF_ITEM_STR){
    SetItem(strHeader, strBody); }

bool ConfItemSTR_cls::
IsEmpty(){
    if (mstrBody.IsEmpty() == TRUE) return TRUE;
    if (mstrBody.IsSameAs("NONE")) return TRUE;
    return FALSE;
}

bool ConfItemSTR_cls::
DoesDirExist(){
    wxFileName CName(mstrBody);
    if (CName.IsAbsolute() == FALSE)
	CName.MakeAbsolute();
    return CName.DirExists();
}

bool ConfItemSTR_cls::
DoesFileExist(){
    wxFileName CName(mstrBody);
    if (CName.IsAbsolute() == FALSE)
	CName.MakeAbsolute();
    return CName.FileExists();
}

bool ConfItemSTR_cls::
ReadStrLine(wxString strLine){
    strLine.Trim(FALSE);
    int loc = strLine.Find(mstrHeader);
    if (loc != 0) return FALSE;

    mstrBody = strLine.Mid(mstrHeader.Len());
    if (mbFilePath == FALSE)
        mstrBody.Replace(wxT("\\n"), wxT("\n"), TRUE);
    mProcCounter++;
    return TRUE;
}

void ConfItemSTR_cls::
Serialize(wxString& strOut){
    if (mstrBody.IsSameAs("!!SKIP!!")) return;
    if (mbFilePath == TRUE){
	if (mstrBody.IsSameAs("None") == FALSE){
	    bool bRelative = GCClassProvider.GetPCPreference()->mCbRelativePath.GetBodyBOOL();
	    wxFileName CFile(mstrBody);
	    if (bRelative == TRUE){
		wxString strWorkingDir = wxGetCwd();
		if (CFile.MakeRelativeTo(strWorkingDir) == TRUE)
		    mstrBody = CFile.GetFullPath();
	    }
	    else
		if (CFile.MakeAbsolute() == TRUE)
		    mstrBody = CFile.GetFullPath();
	}
	
	strOut << mstrHeader << mstrBody << ENDL;
	return;
    }
    wxString strCompact = mstrBody.Clone();
    strCompact.Replace("\n", "\\n", TRUE);
    strOut << mstrHeader + strCompact + ENDL;
}

//------------------------------------

ConfItemINT_cls::
ConfItemINT_cls():
ConfItem_cls(_CONF_ITEM_INT){}

ConfItemINT_cls::
ConfItemINT_cls(wxString strHeader, wxString strBody) :
ConfItem_cls(_CONF_ITEM_INT){
    SetItem(strHeader, strBody); }

ConfItemINT_cls::
ConfItemINT_cls(wxString strHeader, long long init) :
ConfItem_cls(_CONF_ITEM_INT){
    wxString strBody; strBody << init;
    SetItem(strHeader, strBody); }

// -------------

ConfItemINTARRAY_cls::
ConfItemINTARRAY_cls() : ConfItem_cls(_CONF_ITEM_INTARRAY){
}

void ConfItemINTARRAY_cls::
SetItem(wxString strHeader, wxString strBody){
    mstrHeader = strHeader;
    if (strBody.IsEmpty() == TRUE) return;   
    mstrBody = strBody;
    mDimension = CountDimension(strBody);
    wxString strTmp;
    strTmp << mstrHeader.c_str() << strBody.c_str();
    ReadStrLine(strTmp);
}

//------------------------------------

ConfItemUINT_cls::
ConfItemUINT_cls() : ConfItem_cls (_CONF_ITEM_UINT) {
}

ConfItemUINT_cls::
ConfItemUINT_cls(wxString strHeader, wxString strBody) :
ConfItem_cls (_CONF_ITEM_UINT){
    SetItem(strHeader, strBody); }

ConfItemUINT_cls::
ConfItemUINT_cls(wxString strHeader, unsigned int init) :
ConfItem_cls (_CONF_ITEM_UINT){
    wxString strBody; strBody << init;
    SetItem(strHeader, strBody);
}

//-------------------------------------

ConfItemFLOAT_cls::
ConfItemFLOAT_cls():
ConfItem_cls(_CONF_ITEM_FLOAT){}

ConfItemFLOAT_cls::
ConfItemFLOAT_cls(wxString strHeader, wxString strBody) : 
ConfItem_cls(_CONF_ITEM_FLOAT){
    SetItem(strHeader, strBody); }

ConfItemFLOAT_cls::
ConfItemFLOAT_cls(wxString strHeader, float init) : 
ConfItem_cls(_CONF_ITEM_FLOAT){
    wxString strBody; strBody << init;
    SetItem(strHeader, strBody);
}

// ------------------------------------

ConfItemFLOATARRAY_cls::
ConfItemFLOATARRAY_cls() : ConfItem_cls (_CONF_ITEM_FLOATARRAY) {
}

ConfItemFLOATARRAY_cls::
ConfItemFLOATARRAY_cls(wxString strHeader, wxString strBody) : 
ConfItem_cls (_CONF_ITEM_FLOATARRAY)
{ SetItem(strHeader, strBody); }

void ConfItemFLOATARRAY_cls::
SetItem(wxString strHeader, wxString strBody){
    mstrHeader = strHeader;
    if (strBody.IsEmpty() == TRUE) return;
    mstrBody = strBody;
    mDimension = CountDimension(strBody);
    //wxString strTmp;
    //strTmp << mstrHeader.c_str() << strBody.c_str();
    //ReadStrLine(strTmp);
}

/*
bool ConfItemFLOATARRAY_cls::
ReadStrLine(wxString strLine){
    if (ReadStrLineBase(strLine) == FALSE) return FALSE;
    std::wstringstream strTmp(wxConvFile.cWX2WC(mstrBody));
    for (int i = 0; i < mDimension; i++)
	strTmp >> mpBody[i];
    return TRUE;
}

wxString ConfItemFLOATARRAY_cls::
Serialize(){
    wxString sOut;
    sOut << mstrHeader << mpBody[0];
    for (int i = 1; i < mDimension; i++)
	sOut << wxT(" ") << mpBody[i];
    sOut << ENDL;
    return sOut;
}

wxString ConfItemFLOATARRAY_cls::
GetItemStr(){
    wxString sOut;
    sOut << mpBody[0];
    for (int i = 0; i < mDimension; i++)
	sOut << wxT(" ") << mpBody[i];
    return sOut;
}
*/

// ------------------------------------


ConfItemBOOL_cls::
ConfItemBOOL_cls():ConfItem_cls(_CONF_ITEM_BOOL){
}

ConfItemBOOL_cls::
ConfItemBOOL_cls(wxString strHeader, wxString strBody) : 
ConfItem_cls(_CONF_ITEM_BOOL){
    SetItem(strHeader, strBody);
}

ConfItemBOOL_cls::
ConfItemBOOL_cls(wxString strHeader, bool bInit) : 
ConfItem_cls(_CONF_ITEM_BOOL){
    wxString strBody; strBody << bInit;
    SetItem(strHeader, strBody);
}



//-------------------------------------

ConfItemBOOLARRAY_cls::
ConfItemBOOLARRAY_cls() : ConfItem_cls(_CONF_ITEM_BOOLARRAY){
}

ConfItemBOOLARRAY_cls::
ConfItemBOOLARRAY_cls(wxString strHeader, wxString strBody) :
ConfItem_cls (_CONF_ITEM_BOOLARRAY)
{ SetItem(strHeader, strBody); }

void ConfItemBOOLARRAY_cls::
SetItem(wxString strHeader, wxString strBody){
    mstrHeader = strHeader;
    if (strBody.IsEmpty() == TRUE) return;
    mstrBody = strBody;
    mDimension = CountDimension(strBody);
}

// --------------------------------

ConfItemSTRINGARRAY_cls::
ConfItemSTRINGARRAY_cls() : ConfItem_cls(_CONF_ITEM_STRINGARRAY){
    mpAstrArrayLinked = NULL;
}

ConfItemSTRINGARRAY_cls::
ConfItemSTRINGARRAY_cls(wxString strHeader, wxString strBody) :
ConfItem_cls(_CONF_ITEM_STRINGARRAY)
{ SetItem(strHeader, "dummy"); }

void ConfItemSTRINGARRAY_cls::
SetLink(wxArrayString* pAstrArrayLinked)
{ mpAstrArrayLinked = pAstrArrayLinked; }

void ConfItemSTRINGARRAY_cls::
Serialize(wxString& strOut){
    if (mpAstrArrayLinked == NULL) return;
    strOut << mstrHeader;
    uint numArray = mpAstrArrayLinked->size();
    for (int i = 0; i < numArray; i++){
	wxString strCompact = (*mpAstrArrayLinked)[i].Clone();
	strCompact.Replace("\n", "\\n", TRUE);
	strOut << strCompact;
	if (i != numArray - 1) strOut << "::##::";
    }
    strOut << ENDL;
}

bool ConfItemSTRINGARRAY_cls::
ReadStrLine(wxString strLine){
    if (mpAstrArrayLinked == NULL) return FALSE;
    strLine.Trim(FALSE);
    int loc = strLine.Find(mstrHeader);
    if (loc != 0) return FALSE;

    mstrBody.Replace(wxT("\\n"), wxT("\n"), TRUE);
    strLine = strLine.Mid(mstrHeader.Len());

    mpAstrArrayLinked->clear();
    while(TRUE){
	int loc = strLine.Find("::##::");
	if (loc == wxNOT_FOUND){
	    if (strLine.IsEmpty() == FALSE)
		mpAstrArrayLinked->push_back(strLine);
	    break;
	}
	wxString strItem = strLine.Mid(0, loc);
	mpAstrArrayLinked->push_back(strItem);
	strLine = strLine.Mid(loc+6);
    }
    return TRUE;
}

// --------------------------------

ConfItemList_cls::
ConfItemList_cls(){
    //mbSetWithInitValue = TRUE;
}

void ConfItemList_cls::
SetTag(wxString strTag){
    mstrTag = strTag;
}

void ConfItemList_cls::
Clear(){
    mVpCList.clear();
}

void ConfItemList_cls::
DeleteAllItems(){
    uint numItem = mVpCList.size();
    for (uint i = 0; i < numItem; i++){
	int confType = mVpCList[i]->mConfType;
	switch(confType){
	case _CONF_ITEM_STR: 
	    delete (ConfItemSTR_cls*)mVpCList[i]; break;
	case _CONF_ITEM_INT: 
	    delete (ConfItemINT_cls*)mVpCList[i]; break;
	case _CONF_ITEM_INTARRAY:
	    delete (ConfItemINTARRAY_cls*)mVpCList[i]; break;
	case _CONF_ITEM_UINT: 
	    delete (ConfItemUINT_cls*)mVpCList[i]; break;
	case _CONF_ITEM_FLOAT:
	    delete (ConfItemFLOAT_cls*)mVpCList[i]; break;
	case _CONF_ITEM_FLOATARRAY:
	    delete (ConfItemFLOATARRAY_cls*)mVpCList[i]; break;
	case _CONF_ITEM_BOOL:
	    delete (ConfItemBOOL_cls*)mVpCList[i]; break;
	case _CONF_ITEM_BOOLARRAY:
	    delete (ConfItemBOOLARRAY_cls*)mVpCList[i]; break;
	case _CONF_ITEM_STRINGARRAY:
	    delete (ConfItemSTRINGARRAY_cls*)mVpCList[i]; break;
	}
    }
    Clear();
}

void ConfItemList_cls::
Add(ConfItem_cls* pC, wxString strHeader, wxString strBody, wxString strLinkedPanel){
    pC->SetItem(strHeader, strBody);
    pC->mstrLinkedPanel = strLinkedPanel;
    mVpCList.push_back(pC);
    pC->SetParentListTag(mstrTag);
}

void ConfItemList_cls::
Add(ConfItem_cls* pC, ConfItemList_cls &CSrc, wxString strHeader){
    ConfItem_cls *pCItemSrc = CSrc.GetPCItem(strHeader);
    if (pCItemSrc == NULL){
	Add(pC, strHeader, "None"); return;
    }
    Add(pC, strHeader, pCItemSrc->mstrBody, pCItemSrc->mstrLinkedPanel);
}

/*
void ConfItemList_cls::
Add(ConfItem_cls* pC, char *pHeader, char *pBody){
    pC->SetItem(wxString::FromAscii(pHeader), wxString::FromAscii(pBody));
    mVpCList.push_back(pC);
    pC->SetParentListTag(mstrTag);
}
*/


/*
wxString ConfItemList_cls::
GetHeaderStrFromPointer(void *pValue){
    wxString strHeader;
    for (uint i = 0; i < mVpCList.size(); i++){
	switch(mVpCList[i]->mConfType){
	case _CONF_ITEM_INT:
	    if (pValue == &(((ConfItemINT_cls*)mVpCList[i])->mBody))
		strHeader = mVpCList[i]->mstrHeader;
	    break;
	case _CONF_ITEM_INTARRAY:{
	    ConfItemINTARRAY_cls *pCItem =
		(ConfItemINTARRAY_cls*)mVpCList[i];
	    int dimension = pCItem->mDimension;
	    for (int dim = 0; dim < dimension; dim++)
		if (pValue == &(pCItem->mpBody[dim])){
		    strHeader = mVpCList[i]->mstrHeader;
		    strHeader << wxT("::DIM=") << dim;
		}
	    break; }
	case _CONF_ITEM_UINT:
	    if (pValue == &(((ConfItemUINT_cls*)mVpCList[i])->mBody))
		strHeader = mVpCList[i]->mstrHeader;
	    break;
	case _CONF_ITEM_BOOL:
	    if (pValue == &(((ConfItemBOOL_cls*)mVpCList[i])->mbBody))
		strHeader = mVpCList[i]->mstrHeader;
	    break;
	case _CONF_ITEM_FLOAT:
	    if (pValue == &(((ConfItemFLOAT_cls*)mVpCList[i])->mBody))
		strHeader = mVpCList[i]->mstrHeader;
	    break;
	case _CONF_ITEM_FLOATARRAY:{
	    ConfItemFLOATARRAY_cls *pCItem =
		(ConfItemFLOATARRAY_cls*)mVpCList[i];
	    int dimension = pCItem->mDimension;
	    for (int dim = 0; dim < dimension; dim++)
		if (pValue == &(pCItem->mpBody[dim])){
		    strHeader = mVpCList[i]->mstrHeader;
		    strHeader << wxT("::DIM=") << dim;
		}
	    break; }
	case _CONF_ITEM_DOUBLE:
	    if (pValue == &(((ConfItemDOUBLE_cls*)mVpCList[i])->mBody))
		strHeader = mVpCList[i]->mstrHeader;
	    break;
	case _CONF_ITEM_DOUBLEARRAY:{
	    ConfItemDOUBLEARRAY_cls *pCItem =
		(ConfItemDOUBLEARRAY_cls*)mVpCList[i];
	    int dimension = pCItem->mDimension;
	    for (int dim = 0; dim < dimension; dim++)
		if (pValue == &(pCItem->mpBody[dim])){
		    strHeader = mVpCList[i]->mstrHeader;
		    strHeader << wxT("::DIM=") << dim;
		}
	    break; }
	case _CONF_ITEM_STR:{
	    if (pValue == &(((ConfItemSTR_cls*)mVpCList[i])->mstrBody))
		strHeader = mVpCList[i]->mstrHeader;
	    break; }
	}
    }
    return strHeader;
}
*/

ConfItem_cls* ConfItemList_cls::
GetPCItem(wxString strHeader){
    if (strHeader.Right(1).IsSameAs("=") == FALSE)
	strHeader.Append("=");
    for (uint i = 0; i < mVpCList.size(); i++)
	if (strHeader.IsSameAs(mVpCList[i]->mstrHeader))
	    return mVpCList[i];
    wxString strLog;
    strLog << strHeader << " Not found" << ENDL;
    wxLogMessage(strLog);
    return NULL;
}

void ConfItemList_cls::
SyncFrom(ConfItemList_cls& CSrc){
    for (uint i = 0; i < mVpCList.size(); i++){
	ConfItem_cls* pCItem = CSrc.GetPCItem(mVpCList[i]->mstrHeader);
	if (pCItem == NULL) continue;
	mVpCList[i]->mstrBody = pCItem->mstrBody;
	mVpCList[i]->mProcCounter = pCItem->mProcCounter;
    }
}

void ConfItemList_cls::
SyncFromCommand(ConfItemList_cls& CSrc){
    for (uint i = 0; i < mVpCList.size(); i++){
	ConfItem_cls* pCItem = CSrc.GetPCItem(mVpCList[i]->mstrHeader);
	if (pCItem == NULL) continue;
	if (mVpCList[i]->mstrBody.IsSameAs(pCItem->mstrBody) == FALSE){
	    wxString strUndo, strRedo;
	    strUndo << wxT("ConfItemList::Begin::") << mstrTag << ENDL;
	    strRedo << wxT("ConfItemList::Begin::") << mstrTag << ENDL;
	    mVpCList[i]->Serialize(strUndo);
	    pCItem->Serialize(strRedo);
	    strUndo << wxT("ConfItemList::End");
	    strRedo << wxT("ConfItemList::End");
	    GetPCUndo()->PushCommandPair(strUndo, strRedo);
	    GetPCUndo()->Redo();
	}
    }
}

void ConfItemList_cls::
SerializeAllWithTag(wxString &strOut){
    strOut << wxT("ConfItemList::Begin::") << mstrTag << ENDL;
    strOut << SerializeAll();
    strOut << wxT("ConfItemList::End") << ENDL;
}

bool ConfItemList_cls::
ReadStrLineAllWithTag(std::wistream &istream, wxString strLine){
    bool bRet = FALSE;
    wxString strBeginTag;
    strBeginTag << wxT("Begin::") << mstrTag;
    
    if (strLine.IsSameAs(strBeginTag)){

	/*
	if (mstrTag.IsSameAs("Preference")){
	    printf("!!");
	}
	if (mstrTag.IsSameAs("ImageOutput")){
	    printf("!!");
	}
	*/

	bRet = TRUE;
	std::wstring wstrLine;
	while ( std::getline (istream, wstrLine)){
	    wxString strLine = wstrLine.c_str();
	    if (strLine.IsSameAs(wxT("ConfItemList::End"))) break;
	    /*
	    if (ReadStrLineAll(strLine) == TRUE){
		if (mVstrUpdatePanelTagCache.size() != 0)
		    SendUpdateMessage();
	    };
	    */
	    ReadStrLineAll(strLine);
	}
    }
    return bRet;
}

void ConfItemList_cls::
PushUpdateCache(wxString strPanelTag){
    if (strPanelTag.IsEmpty() == TRUE) return;
    bool bExist = FALSE;
    for (uint i = 0; i < mVstrUpdatePanelTagCache.size(); i++)
	if (strPanelTag.IsSameAs(mVstrUpdatePanelTagCache[i])){
	    bExist = TRUE; break;
	}
    
    if (bExist == FALSE)
	mVstrUpdatePanelTagCache.push_back(strPanelTag);
}

void ConfItemList_cls::
SendUpdateMessage(){
    wxString strPanelList;
    strPanelList << mVstrUpdatePanelTagCache[0];
    for (uint i = 1; i < mVstrUpdatePanelTagCache.size(); i++)
	strPanelList << wxT("::") << mVstrUpdatePanelTagCache[i];

    mVstrUpdatePanelTagCache.clear();
    GCClassProvider.GetPCMain()->UpdatePanels(strPanelList.ToStdString());
}

wxString ConfItemList_cls::
GetStrProcCounter(){
    wxString strCounter;
    uint numItem = mVpCList.size();
    for (uint i = 0; i < numItem; i++)
	strCounter << "::" << mVpCList[i]->mProcCounter;
    return strCounter;
}

wxString ConfItemList_cls::
SerializeAll(){
    wxString sOut;
    uint numItem = mVpCList.size();
    for (uint i = 0; i < numItem; i++) mVpCList[i]->Serialize(sOut);
    return sOut;
}

bool ConfItemList_cls::
ReadStrLineAll(wxString strLine){
    bool bRet = FALSE;
    if (strLine.Find("--") == 0) return bRet;
    for (uint i = 0; i < mVpCList.size(); i++)
	if (mVpCList[i]->ReadStrLine(strLine) == TRUE){
	    bRet = TRUE;
	    //PushUpdateCache(mVpCList[i]->mstrInputPanelName);
	    if (mVpCList[i]->mstrLinkedPanel.IsEmpty() == FALSE)
		PushUpdateCache(mVpCList[i]->mstrLinkedPanel);
	}

    if (bRet == TRUE)
	if (mVstrUpdatePanelTagCache.size() != 0)
	    SendUpdateMessage();

    return bRet;
}
