// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsConfItem.cpp"

#ifndef _CONF_ITEM_H_
#define _CONF_ITEM_H_

#include "../COMMON/clsGetPC.h"

#include "../COMMON/CommonDefinitionsWX.h"
#include <wx/wx.h>

#include <vector>

#define _CONF_ITEM_NONE      0
#define _CONF_ITEM_STR       1
#define _CONF_ITEM_INT       2
#define _CONF_ITEM_INTARRAY  3
#define _CONF_ITEM_UINT      4
#define _CONF_ITEM_FLOAT     5
#define _CONF_ITEM_FLOATARRAY  6
#define _CONF_ITEM_BOOL        7
#define _CONF_ITEM_BOOLARRAY   8
#define _CONF_ITEM_STRINGARRAY 9

//#define _CONFARRAY_MAX 16

class ConfItemBase_cls {
 public:
    ConfItemBase_cls();
    
    //wxString mstrInputPanelName;
    wxString *mpstrParentTagLink;
    wxString mstrHeader;
    wxString mstrBody;
    wxString mstrLinkedPanel;
    int    mConfType;
    int    mButtonWidth;
    int    mProcCounter;

    //int  GetInputParentNumber();
    //void AppendInputPanelName(wxString strInputPanelTag);
    //void DetachInputPanelName(wxString strInputPanelTag);
    bool      GetBodyBOOL();
    long long GetBodyINT();
    wxString  GetBodySTR();
    wxString  GetBodySTRShortString();
    double    GetBodyDOUBLE();
    wxColour   GetBodyWXColor();
    std::vector < int > GetBodyINTARRAY();
    std::vector < bool > GetBodyBOOLARRAY();
    std::vector < float > GetBodyFLOATARRAY();
    
    void SetBodyFromDataBOOL(bool bValue);
    void SetBodyFromData(long long value);
    void SetBodyFromData(wxString strValue);
    void SetBodyFromData(double value);
    void SetBodyFromData(float value);
    void SetBodyFromData(std::vector < bool > VbValue);
    void SetBodyFromData(std::vector < float > VValue);
    void SetBodyFromData(std::vector < int > VValue);
    void Serialize(wxString& strOut);
    void SerializeSingleItem(wxString& strOut);
    void PushCommandPair(wxString strData);
   
};

class ConfItem_cls : public ConfItemBase_cls{
 public:
    ConfItem_cls(int type);
    
    void SetParentListTag(wxString& strTag);

    void SetItem(wxString strHeader, wxString strBody);
    bool ReadStrLine(wxString strLine);
    void ReplaceSeparator();
};

class ConfArray_cls {
 public:
    int mDimension;
    int CountDimension(wxString strBody);
};

class ConfItemSTR_cls : public ConfItem_cls {
 public:
    ConfItemSTR_cls();
    ConfItemSTR_cls(wxString strHeader, wxString strBody);

    bool mbFilePath;
    bool IsEmpty();
    bool DoesDirExist();
    bool DoesFileExist();
    bool ReadStrLine(wxString strLine);
    void Serialize(wxString& strOut);
};

class ConfItemINT_cls : public ConfItem_cls {
 public:
    ConfItemINT_cls();
    ConfItemINT_cls(wxString strHeader, wxString strBody);
    ConfItemINT_cls(wxString strHeader, long long init);
};

class ConfItemINTARRAY_cls : public ConfItem_cls, public ConfArray_cls {
 public:
    ConfItemINTARRAY_cls();
    
    void SetItem(wxString strHeader, wxString strBody);
};

class ConfItemUINT_cls : public ConfItem_cls {
 public:
    ConfItemUINT_cls();
    ConfItemUINT_cls(wxString strHeader, wxString strBody);
    ConfItemUINT_cls(wxString strHeader, unsigned int init);
};

class ConfItemFLOAT_cls : public ConfItem_cls {
 public:
    ConfItemFLOAT_cls();
    ConfItemFLOAT_cls(wxString strHeader, wxString strBody);
    ConfItemFLOAT_cls(wxString strHeader, float init);
};

class ConfItemFLOATARRAY_cls : public ConfItem_cls, public ConfArray_cls {
 public:
    ConfItemFLOATARRAY_cls();
    ConfItemFLOATARRAY_cls(wxString strHeader, wxString strBody);

    void SetItem(wxString strHeader, wxString strBody);
};


class ConfItemDOUBLE_cls : public ConfItem_cls {
 public:
    ConfItemDOUBLE_cls();
    double mBody;
    
    void SetItem(wxString strHeader, wxString strBody);
    bool ReadStrLine(wxString strLine);
    wxString Serialize();
    wxString GetItemStr();
};

class ConfItemBOOL_cls : public ConfItem_cls {
 public:
    ConfItemBOOL_cls();
    ConfItemBOOL_cls(wxString strHeader, wxString strBody);
    ConfItemBOOL_cls(wxString strHeader, bool bInit);
};

class ConfItemBOOLARRAY_cls : public ConfItem_cls, public ConfArray_cls {
 public:
    ConfItemBOOLARRAY_cls();
    ConfItemBOOLARRAY_cls(wxString strHeader, wxString strBody);

    void SetItem(wxString strHeader, wxString strBody);
};

class ConfItemSTRINGARRAY_cls : public ConfItem_cls {
public:
    ConfItemSTRINGARRAY_cls();
    ConfItemSTRINGARRAY_cls(wxString strHeader, wxString strBody);
    
    wxArrayString *mpAstrArrayLinked;
    void SetLink(wxArrayString *pAstrArrayLinked);

    void Serialize(wxString& strOut);
    bool ReadStrLine(wxString strLine);
};

class ConfItemList_cls : public GetPC_cls {
 public:
    ConfItemList_cls();

    wxString mstrTag;

    std::vector < ConfItem_cls* > mVpCList;
    std::vector < wxString > mVstrUpdatePanelTagCache;

    void SetTag(wxString strTag);
    void Clear();
    void DeleteAllItems();
    void Add(ConfItem_cls* pC, wxString strHeader, wxString strBody = wxES, wxString strLinkedPanel = wxES);
    void Add(ConfItem_cls* pC, ConfItemList_cls &CSrc, wxString strHeader);
    
    ConfItem_cls* GetPCItem(wxString strHeader);

    void SyncFrom(ConfItemList_cls &CSrc);
    void SyncFromCommand(ConfItemList_cls &CSrc);

    void SerializeAllWithTag(wxString &strOut);
    bool ReadStrLineAllWithTag(std::wistream &istream, wxString strLine);
    void PushUpdateCache(wxString strPanelTag);
    void SendUpdateMessage();
    wxString GetStrProcCounter();

    wxString SerializeAll();
    bool ReadStrLineAll(wxString strLine);
};

#endif
