// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsConfListContainer.h"

#include "clsConfListContainer.h"

#include "../COMMON/CommonDefinitions.h"

#define CLS ConfListContainer_cls

CLS::
ConfListContainer_cls(){
    mbDeleteConfListAtDestroyer = FALSE;
}

CLS::
~ConfListContainer_cls(){
    if (mbDeleteConfListAtDestroyer == TRUE)
	mCConfList.DeleteAllItems();
}

wxArrayString CLS::
GetAstrItemList(){
    wxArrayString AstrList;
    uint num = mCConfList.mVpCList.size();
    for (uint i = 0; i < num; i++)
	AstrList.push_back(mCConfList.mVpCList[i]->mstrHeader);
    return AstrList;
}

ConfItem_cls* CLS::
GetPCItem(wxString strHeader){
    return mCConfList.GetPCItem(strHeader);
}

void CLS::
CloneConfListFrom(ConfListContainer_cls& CSrc){
    int itemNum = CSrc.mCConfList.mVpCList.size();

    mCConfList.Clear();
    for (int i = 0; i < itemNum; i++){
	ConfItem_cls *pCItem;
	int confType = CSrc.mCConfList.mVpCList[i]->mConfType;
	switch(confType){
	case _CONF_ITEM_STR:
	    pCItem = new ConfItemSTR_cls; break;
	case _CONF_ITEM_INT:
	    pCItem = new ConfItemINT_cls; break;
	case _CONF_ITEM_INTARRAY:
	    pCItem = new ConfItemINTARRAY_cls; break;
	case _CONF_ITEM_UINT:
	    pCItem = new ConfItemUINT_cls; break;
	case _CONF_ITEM_FLOAT:
	    pCItem = new ConfItemFLOAT_cls; break;
	case _CONF_ITEM_FLOATARRAY:
	    pCItem = new ConfItemFLOATARRAY_cls; break;
	case _CONF_ITEM_BOOL:
	    pCItem = new ConfItemBOOL_cls; break;
	case _CONF_ITEM_BOOLARRAY:
	    pCItem = new ConfItemBOOLARRAY_cls; break;
	case _CONF_ITEM_STRINGARRAY:
	    pCItem = new ConfItemSTRINGARRAY_cls; break;
	default:
	    pCItem = new ConfItem_cls(_CONF_ITEM_NONE); break;
	}
	pCItem->mstrHeader = CSrc.mCConfList.mVpCList[i]->mstrHeader;
	pCItem->mProcCounter = CSrc.mCConfList.mVpCList[i]->mProcCounter;
	mCConfList.mVpCList.push_back(pCItem);
    }
    mCConfList.SyncFrom(CSrc.mCConfList);
}

void CLS::
Serialize(wxString &strOut){
    mCConfList.SerializeAllWithTag(strOut);
}

bool CLS::
ReadStrLine(std::wistream &istream, wxString strFirstItem, wxString strLine){
    if (strFirstItem.IsSameAs(wxT("ConfItemList"))){
	return mCConfList.ReadStrLineAllWithTag(istream, strLine);
    }
    return FALSE;
}
