// (setq c-basic-offset 4)
// "clsDialogBase.h"

#include "clsDialogBase.h"

#include "../COMMON/CommonDefinitions.h"
#include "../WIDGETCTRL/WX/clsFontProvider.h"

#define CLS DialogBase_cls

CLS::
DialogBase_cls(wxWindow *pCParent, int id, wxString strTitle, wxPoint pos) :
    wxDialog(pCParent, id, strTitle, pos){
}

wxRect CLS::
GetCRectWindowFitting(wxRect COrg){
    wxRect rect = wxGetClientDisplayRect();

    if (COrg.GetRight() > rect.GetRight()){
	int offsetX = COrg.GetRight() - rect.GetRight();
	if (offsetX > COrg.GetLeft()) offsetX = COrg.GetLeft();
	COrg.Offset(-offsetX, 0);
    }
    if (COrg.GetBottom() > rect.GetBottom()){
	int offsetY = COrg.GetBottom() - rect.GetBottom();
	if (offsetY > COrg.GetTop()) offsetY = COrg.GetTop();
	COrg.Offset(0, -offsetY);
    }
    
    if (COrg.GetRight() > rect.GetRight()){
	int deflateX = COrg.GetRight() - rect.GetRight();
	COrg.Deflate(deflateX, 0);
    }
    if (COrg.GetBottom() > rect.GetBottom()){
	int deflateY = COrg.GetBottom() - rect.GetBottom();
	COrg.Deflate(0, deflateY);
    }
    
    return COrg;
}

void CLS::
AddBasicButtons(wxBoxSizer *pCSizer){
    wxBoxSizer *pCSizerH = new wxBoxSizer(wxHORIZONTAL);

    wxSize CSize = wxSize(-1, FontProvider_cls::GetButtonHeight());
    wxButton *pCBtnOK = new wxButton(this, wxID_OK, "OK", wxDP, CSize);
    wxButton *pCBtnCancel = new wxButton(this, wxID_CANCEL, "Cancel", wxDP, CSize);

    pCSizerH->AddStretchSpacer(1);
#ifdef WIN32
    pCSizerH->Add(pCBtnOK, 0, wxEXPAND);
    pCSizerH->Add(pCBtnCancel, 0, wxEXPAND);
#else
    pCSizerH->Add(pCBtnCancel, 0, wxEXPAND);
    pCSizerH->Add(pCBtnOK, 0, wxEXPAND);
#endif

    pCSizer->Add(pCSizerH, 0, wxEXPAND);
}

void CLS::
ResizeDialog(){
    GetSizer()->Layout();
    SetSizerAndFit(GetSizer());
    Refresh(TRUE);
}

void CLS::
AdjustWindowFitting(){
    wxRect CRect = GetRect();
    CRect = GetCRectWindowFitting(CRect);
    SetPosition(CRect.GetTopLeft());
}
