// (setq c-basic-offset 4)
// "clsScene.h"

#include "clsScene.h"
#include "clsDialogBase.h"

#include "../CONFITEM/clsConfItem.h"
#include "../TIMELINE/clsTimeCtrl.h"
#include "../UNDO/clsUndoManager.h"
#include "../WIDGETCTRL/MULTIINPUT/clsMultiInputPanel.h"
#include "../WIDGETCTRL/WX/myArtProv.h"
#include "../WIDGETCTRL/WX/clsFontProvider.h"
#include "../../clsMain.h"

#include "../COMMON/CommonDefinitions.h"

// --------------------

Scene_cls::
Scene_cls(){
    mCPos = wxDefaultPosition;
}

void Scene_cls::
OpenWindow(){
    DialogBase_cls *pCDLG = new DialogBase_cls(NULL, wxID_ANY, _("Scene Configure"), mCPos);
    
    ConfItemINT_cls CSceneLength, CWorkAreaMin, CWorkAreaMax;
    ConfItemUINT_cls CRemap;
    CSceneLength.SetItem("Dummy", GetPCTimeCtrl()->mCFrameMax.GetBodySTR());
    CWorkAreaMin.SetItem("Dummy", GetPCTimeCtrl()->mCWAMin.GetBodySTR());
    CWorkAreaMax.SetItem("Dummy", GetPCTimeCtrl()->mCWAMax.GetBodySTR());
    CRemap.SetItem("Dummy", "0");
    if (CWorkAreaMax.GetBodyINT() == CSceneLength.GetBodyINT())
	CWorkAreaMax.SetBodyFromData((long long) -1);

    int sceneLengthOrg = CSceneLength.GetBodyINT();
    
    wxBoxSizer *pCSizerMain = new wxBoxSizer(wxVERTICAL);
    MultiInputPanel_cls* pCMNum = new MultiInputPanel_cls(pCDLG, "Scene Config", TRUE);
    pCMNum->CombineConfItem(CSceneLength, _("Scene Length"));
    
    pCMNum->CombineSizer(2, _("Working Area"));
    pCMNum->CombineConfItem(CWorkAreaMin, "Dummy1");
    pCMNum->CombineConfItem(CWorkAreaMax, "Dummy2");

    wxString AstrChoiceType[2] = {_("do remap"), _("do not remap")};
    pCMNum->SetChoiceList(2, AstrChoiceType);
    pCMNum->CombineConfItem(CRemap, _("key remap"));

    pCMNum->FinishSetting();
    
    pCSizerMain->Add(pCMNum, 1, wxEXPAND);
    pCDLG->AddBasicButtons(pCSizerMain);

    pCDLG->SetSizerAndFit(pCSizerMain);

    if (pCDLG->ShowModal() == wxID_OK){
	pCMNum->SyncFromGUI();
	int frameMax = CSceneLength.GetBodyINT();
	int WAMin = CWorkAreaMin.GetBodyINT();
	int WAMax = CWorkAreaMax.GetBodyINT();
	if (WAMax == -1) WAMax = frameMax;
	if (frameMax < 1) frameMax = 1;
	if (WAMin < 0) WAMin = 0;
	if (WAMin > frameMax) WAMax = frameMax;
	if (WAMax > frameMax) WAMax = frameMax;
	if (WAMax < WAMin) WAMax = WAMin;
	int remap = CRemap.GetBodyINT();
	GetPCUndo()->OpenBlock("SceneConfigure");
	GetPCTimeCtrl()->SetFrameMaxCommand(frameMax);
	GetPCTimeCtrl()->SetWAMinCommand(WAMin);
	GetPCTimeCtrl()->SetWAMaxCommand(WAMax);
	if (CRemap.GetBodyINT() == 1)
	    GetPCMain()->RescaleParameters((double)sceneLengthOrg/frameMax);
	GetPCUndo()->CloseBlock("SceneConfigure");
    };

    mCPos = pCDLG->GetPosition();
    /*
    MultiInputDialog_cls *pCDLG = new
	MultiInputDialog_cls(mpCParent, wxID_ANY, _("Scene Config"),
			     mCPos, wxDS, FontProvider_cls::GetFont(0),
			     ARTWXFRAMEICON("wxART_SCENE"));
    
    pCDLG->SetPCPosInfoAtClose(&mCPos);

    MultiInputPanel_cls* pCurr = pCDLG->mpCPanel;

    int tmpMaxFrame = mpCTimeCtrlLink->mCMaxFrame.mBody;
    int tmpWAMin = mpCTimeCtrlLink->mCWAMin.mBody;
    int tmpWAMax = mpCTimeCtrlLink->mCWAMax.mBody;
    int tmpType = mpCTimeCtrlLink->mCSceneLengthType.mBody;
    int tmpWASubMin = mpCTimeCtrlLink->mCWASubMin.mBody;
    int tmpWASubMax = mpCTimeCtrlLink->mCWASubMax.mBody;

    pCurr->mTextWidth = 100;
    pCurr->mItemWidth = -1;

    pCurr->CombinePointer(_ITEM_INTEGER_SPIN, &tmpMaxFrame, _("Scene Length"));
    pCurr->SetRange(_ITEM_LASTITEM, 0, 65535);

    int boxWidth = 2;
    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Work Area"));
    pCurr->CombinePointer(_ITEM_INTEGER_SPIN, &tmpWAMin);
    pCurr->SetRange(_ITEM_LASTITEM, 0, 65535);
    pCurr->CombinePointer(_ITEM_INTEGER_SPIN, &tmpWAMax);
    pCurr->SetRange(_ITEM_LASTITEM,0, 65535);

    int indexSubstep = pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Substep"));
    pCurr->CombinePointer(_ITEM_INTEGER_SPIN, &tmpWASubMin);
    pCurr->SetRange(_ITEM_LASTITEM, 0, 65535);
    pCurr->CombinePointer(_ITEM_INTEGER_SPIN, &tmpWASubMax);
    pCurr->SetRange(_ITEM_LASTITEM,0, 65535);

    wxString strType[2] = {_("do remap"), _("do not remap")};
    pCurr->CombinePointerList(&tmpType, 2, strType, _("key remap"));
    pCDLG->MakeGeometry();

    if (mpCTimeCtrlLink->mCAnimInterp.mBody == 1)
	pCurr->EnableItem(indexSubstep, FALSE);

    pCDLG->UpdateValues();

    if (pCDLG->ShowModal() != wxID_OK) return;
    
    unsigned int initMaxFrame = mpCTimeCtrlLink->mCMaxFrame.mBody;
    if (tmpWAMin > tmpMaxFrame) tmpWAMin = tmpMaxFrame;
    if (tmpWAMax > tmpMaxFrame) tmpWAMax = tmpMaxFrame;
    if (tmpWAMax < tmpWAMin) {
	int tmp = tmpWAMax;
	tmpWAMax = tmpWAMin;
	tmpWAMin = tmp;
    }

    GCUndoList.OpenBlock();
    mpCTimeCtrlLink->SetWAMinCommand(tmpWAMin);
    mpCTimeCtrlLink->SetWAMaxCommand(tmpWAMax);
    mpCTimeCtrlLink->SetWASubMinCommand(tmpWASubMin);
    mpCTimeCtrlLink->SetWASubMaxCommand(tmpWASubMax);
    mpCTimeCtrlLink->SetMaxFrameCommand(tmpMaxFrame);
    mpCTimeCtrlLink->mCSceneLengthType.mBody = tmpType;
    if (tmpType == 1 &&
	tmpMaxFrame != initMaxFrame && tmpMaxFrame != 0){
	mpCTimeCtrlLink->RemapParameterKeys
	    (((double)initMaxFrame) / (tmpMaxFrame));
    }
    GCUndoList.CloseBlock();
    */
}

Scene_cls *GpCScene = NULL;
