// "clsAsciiReader.h"
// (c-basic-offset 4)

#include "clsAsciiReader.h"

#include "../COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;

#include "../../clsMain.h"

#include <stdlib.h>
#include <wx/textfile.h>

#include "../COMMON/CommonDefinitions.h"

#define CLS AsciiReader_cls

bool CLS::
GetStrFullFromFile(wxString strFile, wxString &strFull, bool bUseInitCwd){
    
    if (bUseInitCwd == TRUE)
	strFile = GCClassProvider.GetPCMain()->mstrInitWorkingDir + "/" + strFile;
    
    wxTextFile CFile(strFile);

    bool bFirstAttemp = CFile.Open(wxConvAuto());
    
    if (bFirstAttemp == FALSE){
	if (CFile.Open(wxConvLibc) == FALSE)
	    return FALSE;
    }

    for (strFull << CFile.GetFirstLine() << ENDL; !CFile.Eof();
	 strFull << CFile.GetNextLine() << ENDL);
    
    CFile.Close();

    return TRUE;
}

bool CLS::
IsCharExist(const char *ptr, char delim, char item){
    bool bExist = FALSE;
    while (TRUE){
	if (*ptr == delim) break;
	if (*ptr == item) bExist = TRUE;
	ptr++;
    }
    return bExist;
}

bool CLS::
SearchChar(const char **ptr, char item, char *bufferEnd){
    while (TRUE){
	if (**ptr == item) break;
	if ((*ptr) >= bufferEnd){
	    *ptr = NULL;
	    break;
	}
	(*ptr)++;
    }
    
    if (*ptr == NULL) return FALSE;
    return TRUE;
}

bool CLS::
SearchTagStr(const char **ptr, char *tag, char *bufferEnd, bool bProgress){
    const char *pOrg = *ptr;
    if (SearchChar(ptr, ' ', bufferEnd) == FALSE){
	*ptr = pOrg;
	return FALSE;
    }
    
    char strTag[512];
    memcpy(strTag, pOrg, *ptr-pOrg);
    strTag[*ptr-pOrg] = '\0';

    if (strcmp(strTag, tag) == 0){
	if (bProgress == FALSE) *ptr = pOrg; // ptri߂Ȃ
	return TRUE;
    }

    *ptr = pOrg;
    return FALSE;
}

void CLS::
GetStrUptoLineEnd(const char **ptr, char *str, char *bufferEnd){
    const char *pFileIni = *ptr;
    if (SearchChar(ptr, '\n', bufferEnd) == FALSE) return;
    const char *pFileFin = *ptr;
    memcpy(str, pFileIni, pFileFin - pFileIni);
    str[pFileFin - pFileIni] = '\0';
}

float CLS::
ReadFloat(const char **pptr, const char delim){
    //float value = fast_atof32(*pptr);
    float value = (float)atof(*pptr);
    while (**pptr != delim && **pptr != '\n' && **pptr != ' ') (*pptr)++;
    return value;
}

int CLS::
ReadInt(const char **pptr, const char delim){
    //int value = fast_atoi(*pptr);
    int value = atoi(*pptr);
    while (**pptr != delim && **pptr != '\n' && **pptr != ' ') (*pptr)++;
    return value;
}

long long CLS::
ReadLongLong(const char **pptr, const char delim){
    long long value = atoll(*pptr);
    while (**pptr != delim && **pptr != '\n' && **pptr != ' ') (*pptr)++;
    return value;
}

bool CLS::
ReadBool(const char **pptr, const char delim){
    bool bBool = FALSE;
    const char *ptmp = *pptr;
    while (**pptr != delim) (*pptr)++;
    if ((*pptr - ptmp) == 2){
	if (ptmp[0] == 'o' && ptmp[1] == 'n') bBool = TRUE;
    }
    if ((*pptr - ptmp) == 1){
	if (ptmp[0] == '1') bBool = TRUE;
    }
	
    return bBool;
}

char* AsciiReader_cls::
GetPNewBufferFromFile(wxString strFile, long &fileSize){
    FILE *fp = fopen(strFile.ToAscii(), "rb"); //!!
    if (fp == NULL) return NULL; 

    fseek( fp, 0, SEEK_END );
    fileSize = ftell( fp );
    fseek( fp, 0, SEEK_SET);
    
    char *pBuffer = new char [fileSize+1];
    fread( pBuffer, 1, fileSize, fp);
    fclose(fp);
    return pBuffer;
}
