// (setq c-basic-offset 4)
// "clsFilterCtrl.cpp"

#ifndef _FILTER_CTRL_H_
#define _FILTER_CTRL_H_

#include "../COMMON/clsGetPC.h"
#include "../CONFITEM/clsConfItem.h"
#include "../CONFITEM/clsConfListContainer.h"
#include "../FILEIO/clsParser.h"
//#include "../MYGL/clsGLExtention.h"
#include "../MYGL/clsPosition.h"
#include "../PARAMETER/clsParamGroup.h"
#include "../WIDGETCTRL/clsWidgetCommon.h"

class Attribute_cls;
class Camera_cls;
class FilterBase_cls;
class FBO_cls;
//class ParamGroup_cls;
//class Parameter_cls;

#include <list>
#include <vector>

class FilterCtrl_cls : public WidgetCommon_cls, public Parser_cls, public ConfListContainer_cls, public GetPC_cls{
public:
    FilterCtrl_cls();
    ~FilterCtrl_cls();

    Attribute_cls* mpCActiveFilter;
    std::vector < Attribute_cls* > mVpCSelectedFilter;
    std::list < Attribute_cls* > mVpCFilter;

    ConfItemSTR_cls mCstrActiveItemName;

    void SetToDefault();
    void Clear();
    void ClearSelection();
    wxString GetStrSelf();
    void GetVstrParamTag(std::vector < wxString > &VstrTag);
    FilterBase_cls* GetPCFromAddress(wxString strAddress);
    FilterBase_cls* GetPCFromName(wxString& strName);
    FilterBase_cls* GetPCFromIndex(int index);
    int GetIndexFromPC(Attribute_cls *pCAttrib);
    std::list < Attribute_cls* >::iterator GetIterFromIndex(int index);
    std::list < Attribute_cls* >::iterator GetIterFromPC(Attribute_cls *pCAttrib);
    ParamGroup_cls* GetPCParamGroup(wxString strTag);
    Parameter_cls* GetPCParameter(wxString strTag);
    bool IsSelected(Attribute_cls *pCAttrib);
    bool IsVaildFilterExist(wxString strAttributeName);
    bool IsFilterExist(wxString strName);

    FBO_cls* GetNewPCFilterProcessed(FBO_cls *pCFBOInSrc,
				     std::vector < float > VPasspartoutInfo,
				     PositionAndDirection_cls CCameraPos,
				     Camera_cls *pCCamera,
				     FBO_cls *pCFBODepth);

    void Select(wxString strObjName, bool bAdditional, bool bUpdateGUI = TRUE);

    wxString GetStrNewCandidate(wxString strCandidate);
    wxString GetStrUniqueName(wxString strName);

    void Detatch(Attribute_cls* pCAttrib);
    void DeleteFilter(Attribute_cls* pCAttrib);
    
    void DeselectKeyFrame(wxString strException);
    bool ChangeKeyTypeByModKey(wxString strTag, int keyIndex, 
			       bool bCtrl, bool bShift, bool bAlt);
    bool SelectKeyFrame(wxString strTag, int keyIndex, 
			bool bSelect, bool bAdditional,
			double resolution = _RES_DEFAULT);

    void SetSelectedTLKeyTypeCommand(int keyType, double ease);
    void MoveSelectedTLKeyCommand(double dNX, double dY);

    void AddFilterCommand(wxString strClassName, wxString strNameCandid);
    void DeleteFilterCommand(wxString strName);
    void MoveFilterNative(Attribute_cls *pCFrom, int indexTo);
    void MoveFilterCommand(wxString strName, int indexTo);
    void SetFilterValidityCommand(wxString strName, bool bValidity);

    bool ProcNew(std::wistream &istream, wxString strFirstItem, wxString strLine);
    bool ProcDelete(std::wistream &istream, wxString strFirstItem, wxString strLine);
    bool ProcMove(std::wistream &istream, wxString strFirstItem, wxString strLine);
    bool ProcReadAttribute(std::wistream &istream, wxString strFirstItem, wxString strLine);

    bool ReadStrLine(std::wistream &istream,
		     wxString strFirstItem, wxString strLine);

    void SerializePropertiesOnly(wxString& strOut);
    void Serialize(wxString &strOut);
};

#endif
