// (setq-c-offset 4)
// "clsFilterDepth.h"

#include "clsFilterDepth.h"
#include "clsFilterCtrl.h"

#include "../GLSL/clsShaderCtrl.h"
#include "../MYGL/clsFBO.h"

#include "../WIDGETCTRL/MULTIINPUT/clsMultiInputPanel.h"

#include "../COMMON/CommonDefinitionsGL.h"

#define CLS FilterDepth_cls

CLS::
FilterDepth_cls(wxString strName) : FilterBase_cls("FilterDepth_cls", strName){

    wxString strUpdate = "VIEW3D::PROPERTY_SCENE";
 
    wxString strConfListLabel = "FilterCtrl::"; strConfListLabel << strName;
    mCConfList.SetTag(strConfListLabel);
    
}

void CLS::
SyncFromBuffer(FilterDepthBuffer_cls *pCBuffer){

    mCConfList.SyncFromCommand(pCBuffer->mCConfList);
}

void CLS::
Begin(FBO_cls *pCFBO){
    GetPCShaderCtrl()->BeginShader("Depth", NULL);
}

void CLS::
End(){
    GetPCShaderCtrl()->EndShader();    
}

#define CLS FilterDepthBuffer_cls

CLS::
FilterDepthBuffer_cls(FilterDepth_cls *pCSrc) : FilterBase_cls(*pCSrc){
    mpCSrc = pCSrc;

    SyncFromSrc();
}

MultiInputPanel_cls* CLS::
GetPCNewPanel(wxWindow *pCWindow){
    MultiInputPanel_cls *pC =
		new MultiInputPanel_cls(pCWindow, GetStrName(), TRUE);

    pC->FinishSetting();
    return pC;
}

void CLS::
SyncFromSrc(){
    mCConfList.SyncFrom(mpCSrc->mCConfList);

}

void CLS::
ForceSrcToSyncBuffer(){ mpCSrc->SyncFromBuffer(this); }
