// (setq-c-offset 4)
// "clsOverlay.cpp"

#ifndef _LEGEND_H
#define _LEGEND_H

#include "clsFilterBase.h"

#include "../MYGL/clsGLTexture.h"
#include "../MYGL/clsMatrix2D.h"

class LegendBuffer_cls;

class ColorCurve_cls;
class FBO_cls;
class Tics_cls;
class MultiInputPanel_cls;

class Legend_cls : public FilterBase_cls, public Matrix2D_cls {
public:
    Legend_cls(wxString strName);
    ~Legend_cls();

    void SyncFromBuffer(LegendBuffer_cls *pCBuffer);

    FBO_cls *mpCFBOLegendLayer;
    Tics_cls *mpCTics;

    GLTexture_cls mCGLTexture;
    GLTexture_cls mCGLTic;

    ConfItemSTR_cls mCstrTarget;
    ConfItemSTR_cls mCstrFontDesc;
    ConfItemBOOL_cls mCbTime;
    ConfItemSTR_cls mCstrFormatTime;
    ConfItemUINT_cls mCTypeLayout;
    ConfItemFLOAT_cls mCTimeOffsetX, mCTimeOffsetY;
    ConfItemFLOAT_cls mCTimeScale;
    ConfItemBOOL_cls  mCbClrCurve;
    ConfItemFLOAT_cls mCClrCurveOffsetX, mCClrCurveOffsetY;
    ConfItemFLOAT_cls mCClrCurveScaleX, mCClrCurveScaleY;
    ConfItemINT_cls mCClrCurveTicFontSize, mCClrCurveTicScale;
    
    int mWidth, mHeight, mDescend;
 
    wxString mstrUsed, mstrFontUsed;
    
    void MakeTextTexture();
    void DrawColorCurve(ColorCurve_cls *pCClr,
			int offsetX, int offsetY, int width, int height);
    void DrawTics(ColorCurve_cls *pCClr,
		  int offsetX, int offsetY, int width, int height, 
		  int ticHeight, float aspect, 
		  int ticFontSize, int ticScale);
    void MakeLegendLayer(int width, int height,
			 std::vector < float > VPasspartoutInfo);
    void Begin(std::vector < float > VPasspartoutInfo);
    void End();
    void SelectObject(wxString strObjName);
};

class LegendBuffer_cls : public FilterBase_cls {
public:
    LegendBuffer_cls(Legend_cls *pCSrc);

    Legend_cls *mpCSrc;

    ConfItemSTR_cls mCstrTarget;
    ConfItemSTR_cls mCstrFontDesc;
    ConfItemBOOL_cls mCbTime;
    ConfItemSTR_cls mCstrFormatTime;
    ConfItemFLOAT_cls mCTimeOffsetX, mCTimeOffsetY;
    ConfItemFLOAT_cls mCTimeScale;
    ConfItemBOOL_cls  mCbClrCurve;
    ConfItemFLOAT_cls mCClrCurveOffsetX, mCClrCurveOffsetY;
    ConfItemFLOAT_cls mCClrCurveScaleX, mCClrCurveScaleY;
    ConfItemINT_cls mCClrCurveTicFontSize, mCClrCurveTicScale;
    
    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);
    void SyncFromSrc();
    void ForceSrcToSyncBuffer();
    void SelectObject(wxString strObjName);
    
};

#endif
