// (setq-c-offset 4)
// "clsOverlay.cpp"

#ifndef _OVERLAY_H
#define _OVERLAY_H

#include "clsFilterBase.h"

class ImageSequence_cls;
class OverlayBuffer_cls;
class MultiInputPanel_cls;

class Overlay_cls : public FilterBase_cls {
public:
    Overlay_cls(wxString strName);
    ~Overlay_cls();

    void SyncFromBuffer(OverlayBuffer_cls *pCBuffer);

    ImageSequence_cls *mpCImageSequence;

    wxString mstrPathChecked;
    
    ConfItemSTR_cls mCstrPath;
    ConfItemINT_cls mCSequenceOffset;
    ConfItemBOOL_cls mCbSequence;
    ConfItemBOOL_cls mCbFit;

    void CheckFileSequence();
    void ModFrame(int &frame, int seqLen, bool bRepeat);
    void Begin(std::vector < float > VPasspartoutInfo);
    void End();
};

class OverlayBuffer_cls : public FilterBase_cls {
public:
    OverlayBuffer_cls(Overlay_cls *pCSrc);

    Overlay_cls *mpCSrc;

    ConfItemSTR_cls mCstrPath;
    ConfItemINT_cls mCSequenceOffset;
    ConfItemBOOL_cls mCbSequence;
    ConfItemBOOL_cls mCbFit;
    ConfItemFLOAT_cls mCAlpha;

    void HideAndShow();

    int mIndexPath;

    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);
    void SyncFromSrc();
    void ForceSrcToSyncBuffer();
};

#endif
