// (setq-c-offset 4)
// "clsRemoveAlpha.h"

#include "clsRemoveAlpha.h"
#include "clsFilterCtrl.h"

#include "../GLSL/clsShaderCtrl.h"
#include "../MYGL/clsGLExtention.h"

#include "../WIDGETCTRL/MULTIINPUT/clsMultiInputPanel.h"

#define CLS RemoveAlpha_cls

CLS::
RemoveAlpha_cls(wxString strName) : FilterBase_cls("RemoveAlpha_cls", strName){
    
    wxString strConfListLabel = "FilterCtrl::"; strConfListLabel << strName;
    mCConfList.SetTag(strConfListLabel);
    mCConfList.Add(&mCbExtremeAlpha, "ExtremeAlpha=", "0", "VIEW3D");
    mCConfList.Add(&mCbConvert, "Convert=", "0", "VIEW3D");
    mCConfList.Add(&mCbBackgroundTile, "BackgroundTile=", "0", "VIEW3D");
}

void CLS::
SyncFromBuffer(RemoveAlphaBuffer_cls *pCBuffer){
    mCConfList.SyncFromCommand(pCBuffer->mCConfList);
}

void CLS::
Begin(){
    RemoveAlphaParam_cls CParam;
    CParam.mExtremeAlpha = mCbExtremeAlpha.GetBodyINT();
    CParam.mConvert = mCbConvert.GetBodyINT();
    CParam.mBackgroundTile = mCbBackgroundTile.GetBodyINT();
    GetPCShaderCtrl()->BeginShader("RemoveAlpha", &CParam);
}

void CLS::
End(){
    GetPCShaderCtrl()->EndShader();    
}

#define CLS RemoveAlphaBuffer_cls

CLS::
RemoveAlphaBuffer_cls(RemoveAlpha_cls *pCSrc) : FilterBase_cls(*pCSrc){
    mpCSrc = pCSrc;
    mCConfList.SetTag(pCSrc->mCConfList.mstrTag);
    mCConfList.Add(&mCbExtremeAlpha, "ExtremeAlpha=", "0");
    mCConfList.Add(&mCbConvert, "Convert=", "0");
    mCConfList.Add(&mCbBackgroundTile, "BackgroundTile=", "0");
    
    SyncFromSrc();
}

MultiInputPanel_cls* CLS::
GetPCNewPanel(wxWindow *pCWindow){
    MultiInputPanel_cls *pC =
	new MultiInputPanel_cls(pCWindow, GetStrName(), TRUE);

    pC->CombineSizer(3);
    pC->CombineConfItem(mCbExtremeAlpha, _("Extreme Alpha"));
    pC->CombineConfItem(mCbConvert, _("Convert to Gray"));
    pC->CombineConfItem(mCbBackgroundTile, _("Tiled BG"));

    pC->FinishSetting();
    return pC;
}

void CLS::
SyncFromSrc(){
    mCConfList.SyncFrom(mpCSrc->mCConfList);
}

void CLS::
ForceSrcToSyncBuffer(){ mpCSrc->SyncFromBuffer(this); }
