// "clsFocalBlur.cpp"

#ifndef _SSAO_H
#define _SSAO_H

#include "clsFilterBase.h"

#include <vector>

class FBO_cls;
class SSAOBuffer_cls;
class MultiInputPanel_cls;

class SSAO_cls : public FilterBase_cls {
public:
    SSAO_cls(wxString strName);

    ConfItemINT_cls mCQuality;
    ConfItemUINT_cls mCType;
    ConfItemFLOAT_cls mCFactor;
    ConfItemFLOAT_cls mCRadius;

    wxColor GetWXColor();
    void SetBaseColor(std::vector < float > VClr);

    void SyncFromBuffer(SSAOBuffer_cls *pCBuffer);
    void Begin(FBO_cls *pCFBO);
    void End();
};

class SSAOBuffer_cls : public FilterBase_cls {
public:
    SSAOBuffer_cls(SSAO_cls *pCSrc);
    
    SSAO_cls *mpCSrc;

    int mIndexBtnColor;

    ConfItemINT_cls mCQuality;
    ConfItemUINT_cls mCType;
    ConfItemFLOAT_cls mCFactor;
    ConfItemFLOAT_cls mCRadius;
    ConfItemFLOATARRAY_cls mCBaseColor;

    void UpdateButtonColor(MultiInputPanel_cls *pCMNum);
    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);
    void SyncFromSrc();
    void ForceSrcToSyncBuffer();
};

#endif
