// (setq c-basic-offset 4)
// "clsGLButton.cpp"

#ifndef _GL_BUTTON_H_
#define _GL_BUTTON_H_

#ifdef WIN32
#include <GL/gl.h>
#include <GL/glu.h>
#elif defined __WXMAC__
#include <OpenGL/glu.h>
#else
#include <GL/glu.h>
#endif

#include <wx/wx.h>

#ifndef _TOP_LEFT
#define _TOP_LEFT  0
#define _TOP_RIGHT 1
#define _BTM_LEFT  2
#define _BTM_RIGHT 3
#endif

class GLButton_cls {
 public:
    GLButton_cls(int offsetType, int offsetX, int offsetY);

    void MakeTextureFromImage(wxImage &CImage, bool bFlip = TRUE);
    int  GetCoordYFromGLtoWX(int y);
    void DrawButton(bool bState);
    bool CheckButtonDown(int mouseX, int mouseY);
    bool CheckButtonUp(int mouseX, int mouseY);
    bool IsMouseOnButton(int mouseX, int mouseY);
    bool UpdateStatus(wxSize CSizeCanvas, 
		      int mouseX, int mouseY);
    

    wxSize mCSizeImg, mCSizeCanvas;
    
    GLuint mTexID;
    bool   mbMouseOn, mbMouseDown;
    //int mWidth, mHeight;
    int mOffsetType, mOffsetX, mOffsetY;
};

#endif
