// (setq c-basic-offset 4)
// "clsHitTest.h"

#include "clsHitTest.h"

#include "../../WIDGETCTRL/WX/clsColorProvider.h"

#include "../../COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;

#include "../../MYGL/clsFBO.h"


#include "../../COMMON/CommonDefinitions.h"

#define CLS Hittest_cls

CLS::
Hittest_cls(){
    mpCHitFBO = NULL;
}

CLS::
~Hittest_cls(){
    if (mpCHitFBO != NULL) delete mpCHitFBO;
}

#include <limits.h>

void CLS::
ClearReferTable(){
    for (int i = 0; i < 100; i++)
	mABuffer4Selection[i] = UINT_MAX;
    mVpCSceneObjTable.clear(); 
}

void CLS::
SetReferTable(SceneObj_cls *pCSceneObj){
    mVpCSceneObjTable.push_back(pCSceneObj);
}

void CLS::
HitTestBegin(PositionAndDirection_cls CCamPos, double degreeV,
	     double posX, double posY, bool bHitTest){
    int sizeFBO = 128;

    if (mpCHitFBO == NULL){
	mpCHitFBO = new FBO_cls (sizeFBO, sizeFBO, NULL);
	mpCHitFBO->MakeFBO();
    }

    mpCHitFBO->Begin();
    ColorProvider_cls::SetGLClearColor("GLBG");
    glClear(GL_COLOR_BUFFER_BIT);
    
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    glEnable(GL_DEPTH_TEST);

    //glEnabel(GL_LIGHTING);
    glDisable(GL_TEXTURE_2D);

    GLPerspective_cls::SetProjection(sizeFBO, sizeFBO);
    GLPerspective_cls::SetFrustumPartial(sizeFBO, sizeFBO, degreeV, 0.1, 100,
					 posX, posY, 0.03);

    PositionAndDirection_cls CHitCameraPos;
    CHitCameraPos = CCamPos;
    
    GLPerspective_cls::SetModelView(CHitCameraPos, CHitCameraPos);

    glSelectBuffer(100, mABuffer4Selection);
    if (bHitTest == TRUE) glRenderMode(GL_SELECT);
    glInitNames();
}

SceneObj_cls* CLS::
HitTestEnd(bool bHitTest){
    mpCHitFBO->End();

    SceneObj_cls *pCObj = NULL;
    if (bHitTest == TRUE) 
	pCObj = GetPCFromBuffer();

    return pCObj;
}

SceneObj_cls* CLS::
GetPCFromBuffer(){
    int num = glRenderMode(GL_RENDER);
    if (num == 0) return NULL;
    int current = 0;
    unsigned int name = 0;
    for (int i = 0; i < num; i++){
	unsigned int stack = mABuffer4Selection[current];
	if (stack == 0) return NULL;
	
	unsigned int depthMin = mABuffer4Selection[current+1];
	unsigned int depthMax = mABuffer4Selection[current+2];
	name = mABuffer4Selection[current+3];
	// Ƃ肠Ōɕ`ʂ̂g
	current+=4;
    }

    if (name >= mVpCSceneObjTable.size()) return NULL;
    return mVpCSceneObjTable[name];
}

void CLS::
Draw(wxSize CSizeCanvas, wxSize CSizeImg){

    int x0 = 64;
    int y0 = 4;

    int x1 = x0 + CSizeImg.GetWidth();
    int y1 = y0 + CSizeImg.GetHeight();

    glPushAttrib(GL_ALL_ATTRIB_BITS);

    glEnable(GL_TEXTURE_2D);
    //glDisable(GL_TEXTURE_2D);
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); //At@

    mpCHitFBO->BindTexture();

    glColor4f(1.0, 1.0, 1.0, 1.0);

    glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S , GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T , GL_REPEAT);

    glBegin(GL_QUADS);

    glTexCoord2f(0, 0); glVertex2d(x0, y0);
    glTexCoord2f(1, 0); glVertex2d(x1, y0);
    glTexCoord2f(1, 1); glVertex2d(x1, y1);
    glTexCoord2f(0, 1); glVertex2d(x0, y1);

    glEnd();

    glPopAttrib();
}
