// -*- c -*-
// "clsGLCanvas.cpp"
//(setq c-basic-offset 4)

#ifndef _MAIN_GL_CANVAS_H_
#define _MAIN_GL_CANVAS_H_

#include "clsGLCanvasBase.h"
#include "clsGLCamera.h"

#include "../COMMON/clsGetPC.h"
#include "../COMMON/clsVectorMath.h"
#include "../COMMON/clsTensorMath.h"
#include "../MYGL/clsFBO.h"
#include "../MYGL/clsGLExtention.h"
#include "../MYGL/clsPosition.h"
#include "../WIDGETCTRL/clsWidgetCommon.h"

class Camera_cls;
class GLStrings2D_cls;
class Hittest_cls;
class MouseCtrl_cls;
class MouseNormalized_cls;
class Navigator_cls;
class SceneObj_cls;
class View3D_cls;

class GLButton_cls;

class GLCanvas_cls : 
public GLCanvasBase_cls,  public WidgetCommon_cls, public GetPC_cls, public GLCheckError_cls, public VectorMath_cls, public TensorMath_cls 
{
 public:
    GLCanvas_cls
	(View3D_cls *pCView3D, int *attribList,
	 long style, wxString name/*, unsigned int selfIndex = 0*/);

#ifdef WIN32
    GLCanvas_cls
	(View3D_cls *pCView3D, wxGLAttributes& CGLAttribute,
	 long style, wxString name/*, unsigned int selfIndex = 0*/);
#endif
    
    ~GLCanvas_cls();

    void Initialize();

    static bool msbInitializedCommon;
    static bool msbLockDragging;
    bool mbInitialized;
    bool mbStatusDrawing;
    bool mbInertia;
    bool mbRedrawQueue, mbHittestQueue, mbHittestQueueAdditive;
    bool mbViewDragged;
    double mScalingCurrent, mScalingInit;
    double mAngularCurrent, mAngularInit;
    double mAngularPre;
    int mAngularMod;
    int mInputMode;
    wxString mstrInputCommand;

    wxStopWatch mCStopWatchSnap;
    int    mMillisecondList[10];
    int    mMillisecondIndex;
    int    mMillisecondPrev;

    bool mbDragSnapping; //hbO𗣂Ƃ̏̔fłȂBێĂ
    double mDrag[3];
    double mMat16NavigatorModelview[16];
    double mMat16NavigatorModelOnly[16];
    bool mbOrtho; //hbOɏ񂪗v̂ŕێ
    double mSizeOrtho; //hbOɏ񂪗v̂ŕێ
    
    View3D_cls *mpCParent;
    GLButton_cls *mpCBtnNumPanel;
    GLCamera_cls mCCameraBase, mCCameraBaseNext;
    GLCamera_cls mCCameraInUse, mCCameraInUseNext;
    Navigator_cls *mpCNavigator;
    Hittest_cls *mpCHitTest;
    PositionAndDirection_cls mCPivot;
    Position_cls mCAutoPivot;

    GLStrings2D_cls *mpCGLString2D;

    FBO_cls *mpCFBOStereoDepth[2];
    FBO_cls *mpCFBOStereoBuffer[2];
    FBO_cls *mpCFBOStereoFiltered[2];
    
    FBO_cls *mpCFBOImageCompositBuffer;

    FBO_cls *mpCFBOCurrentLink; // _OFBO

    
    FBO_cls *mpCFBODepth;
    FBO_cls *mpCFBORenderOut; 
    FBO_cls *mpCFBOFinalOut; // ŏIIɉʂŏo FBO
    
    MouseCtrl_cls     *mpCMouseCtrl;
    MouseCtrl_cls     *mpCMouseInfoInertia;

    void ClearQueue();
    void ClearBuffer(wxString strClrTag);
    void InitGLUT();
    bool InitializeGLCommonIfNot();
    bool InitializeGLIfNot();

    void RefreshEX();

    int GetPercent(int fbo, int fboNum, int SVIdx, int SVSampleNum,
		   int ensemble, int ensembleSampleNum);
    double GetAspectRatio();
    double GetModByAspectX();
    double GetModByAspectY();

    Camera_cls* GetPCCamera();
    int GetCameraType();
    bool DoesUseDepthBuffer();
    int GetStereoNum();
    int GetEyeType();
    int GetImageCompositeNum();
    double GetViewAngle();
    double GetSizeOrtho();
    double GetRelativeAngleDeg(bool bForceSnap = FALSE);
    std::vector < double > GetVMinMax();
    double GetDomeTilt();
    void GetSampling(bool *pbUseEnsemble, bool *pbUseSV, bool *pbUseBlur,
		     int *pEnsembleSampleNum, 
		     int *pSVSampleIni, int *pSVSampleNum, 
		     int *pBlurSampleNum);

    bool IsMouseOnClient();
    bool ProcInertia();
    bool ProcViewOrItemDragging();
    bool ProcItemDragEnd();
    void ProcViewDragEnd();
    bool ProcInputCommand();
    //bool ProcDragging();
    void ProcessMouseEvent(wxMouseEvent& event);
    
    void SetCameraInfo();
    void AdjustAngleByScreenAspect(double& degreeV);
    void FollowCamera(Camera_cls *pCCam);
    void RepairCamera();
    void DefaultMatrix();
    void SetProjection();
    //void SetFrustum(double degreeV);
    void DrawPivot();
    void DrawGrid();
    void DrawMessage();
    void DrawDragginMessage();

    void DrawProtoProcess(FBO_cls *pCFBORenderTgt, int typeWideCamera);
    std::vector < float > GetVPasspartoutInfo();

    void SetModelViewForEachFBO(int eyeType, int stereo, int fbo, int ensemble,
				int typeWideCamera);
    void DrawEachFBO(int ensemble, int composit, 
		     float baseMat16[16], float baseMat16Inv[16],
		     float viewMat16[16], float viewMat16Inv[16],
		     bool bHitTest = FALSE);
    FBO_cls *GetPCNewFBOForRecord(int bufferSize);
    void BeginFBOAndSetStatus(FBO_cls *pCFBO, wxString strClearClolor,
			      double degreeV, double min, double max,
			      bool bUseDepthBuffer);

    void DummyDraw();
    void Paint();
    void PaintMain();
    void ProcSaveImage(int numOutput, FBO_cls *pCFBOForRecord[2],
		       int eyeType, int stereoOutType);
    void DrawGuideLineForRotScale(FBO_cls *pCFBORenderTgt,
				  SceneObj_cls *pCActiveObj);
    void DrawNavigator(FBO_cls *pCFBORenderTgt, SceneObj_cls *pCActiveObj,
		       double degreeV, double min, double max);
    void PrepareFBOForRecord(FBO_cls *pCFBOForRecord[2],
			     int fit, int numOutput);

    wxSize GetOutputImageSize();
    void SaveImageFromFBO(FBO_cls *pCFBO, int stereo);
    void SaveImageFromFBOScanLine(FBO_cls *pCFBO[2]);
    void OnPaint(wxPaintEvent &event);
    void FinishPaint(wxPaintEvent& event);

    void OnMouse(wxMouseEvent& event);
    void OnMouseMotion(wxMouseEvent& event);
    void OnKeyDown(wxKeyEvent& event);
    
    DECLARE_EVENT_TABLE();
};

#endif
