// "clsGLCanvasBase.h"
// (setq c-basic-offset 4)

#include "clsGLCanvasBase.h"

#include "../COMMON/CommonDefinitions.h"

#define CLS GLCanvasBase_cls

BEGIN_EVENT_TABLE(CLS, wxGLCanvas)
EVT_SIZE (CLS::OnSize)  
END_EVENT_TABLE()

CLS::
GLCanvasBase_cls(wxWindow *pCParent, int *attribList,
		 long style, wxString name) :
wxGLCanvas(pCParent, wxID_ANY, attribList, wxDPS, 
	   style | wxFULL_REPAINT_ON_RESIZE, name)
{
    mpCParentWXWindow = pCParent;
}

#ifdef WIN32
CLS::
GLCanvasBase_cls(wxWindow *pCParent, wxGLAttributes& CGLAttribute,
		 long style, wxString name) :
    wxGLCanvas(pCParent, CGLAttribute, wxID_ANY, wxDPS, 
	       style | wxFULL_REPAINT_ON_RESIZE, name)
{
    mpCParentWXWindow = pCParent;
}
#endif

void CLS::
SetGLContext(bool bSetCurrent){
    if (mspCGLContext == NULL)
	mspCGLContext = new wxGLContext(this);
    //mspCGLContext->SetCurrent(*this);
    if (SetCurrent(*mspCGLContext) == FALSE){
	wxLogMessage("Set Current Failed"); wxLogMessage(ENDL);
    }
}

void CLS::
GetWindowSize(int *pWidth, int *pHeight, int *pClientWidth, int *pClientHeight){
    *pWidth = mCWindowSize.GetWidth();
    *pHeight = mCWindowSize.GetHeight();
    *pClientWidth = GetClientSize().GetWidth();
    *pClientHeight = GetClientSize().GetHeight();
}

void CLS::
UpdateSize(){
    wxRect CRect = GetScreenRect();
    wxRect CRectParent = mpCParentWXWindow->GetScreenRect();
    mCWindowSize = CRectParent.Intersect(CRect).GetSize();
}

void CLS::
OnSize(wxSizeEvent& event){
    if (IsShownOnScreen()==FALSE) return;
    UpdateSize();
}

// Delete  ClassProvider_cls::DeleteSingleton() ōs
wxGLContext *GLCanvasBase_cls::mspCGLContext = NULL;
