// -*- c -*-
// "clsImageComposer.h"

#include "clsImageComposer.h"

#include "../GLSL/clsShaderCtrl.h"
#include "../MYGL/clsFBO.h"
#include "../MYGL/clsGLExtention.h"
#include "../TIMELINE/clsTimeCtrl.h"

#define CLS ImageComposer_cls

CLS::
ImageComposer_cls(){
}

void CLS::
StoreInBuffer(FBO_cls *pCFBOBuffer, FBO_cls *pCFBOSRC){
    int bufferSize = pCFBOBuffer->mWidthTex;
    pCFBOBuffer->Begin();

    //ExposureParams_cls CParam;
    //GetPCShaderCtrl()->BeginExposure(&CParam);
    
    glEnable(GL_BLEND);
    glDisable(GL_LIGHTING);

    GetPCGLExtentions()->
	BlendFuncSeparate(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA,
			  GL_ONE, GL_ONE_MINUS_SRC_ALPHA);
    pCFBOSRC->DrawOnScreen2D(bufferSize, bufferSize,
			     bufferSize, bufferSize, 
			     0, 0, FALSE);

    GetPCShaderCtrl()->EndShader();

    pCFBOBuffer->End();
}

void CLS::
OverlapBuffer(FBO_cls *pCFBOTgt, FBO_cls *pCFBOBuffer){
    int bufferSize = pCFBOBuffer->mWidthTex;
    pCFBOTgt->Begin(FALSE);

    glPushAttrib(GL_ALL_ATTRIB_BITS);

    float interpFactor = (float)GetPCTimeCtrl()->mInterpFactorForComposit;
    //ExposureParams_cls CParam;
    //GetPCShaderCtrl()->BeginExposure(&CParam);

    glEnable(GL_BLEND);
    glDisable(GL_LIGHTING);
    GetPCGLExtentions()->
	BlendFuncSeparate(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA,
			  GL_ONE, GL_ONE_MINUS_SRC_ALPHA);
    glColor4f(1, 1, 1, 1.0-interpFactor);
    pCFBOBuffer->DrawOnScreen2D(bufferSize, bufferSize,
				bufferSize, bufferSize, 
				0, 0, TRUE);

    glPopAttrib();

    GetPCShaderCtrl()->EndShader();
    
    pCFBOTgt->End();
}

ImageComposer_cls *GpCImageComposer = NULL;
