// -*- c -*-
// "clsStereogram.h"

#include "clsStereogram.h"

#include "../MYGL/clsFBO.h"
#include "../MYGL/clsGLPerspective.h"

#define CLS Stereogram_cls

#include <wx/wx.h>

#include "../COMMON/CommonDefinitions.h"

CLS::
Stereogram_cls(){
}

void CLS::
ColorMaskBegin(int stereo, int eyeType){
        
    //if (mCbFlip.mbBody == TRUE) stereo = 1 - stereo;
    glColor4f(1, 1, 1, 1);
    if (eyeType == _STEREO_RED_CYAN)
	switch(stereo){
	case 0: glColorMask(TRUE,  FALSE, FALSE, TRUE); return;
	case 1: glColorMask(FALSE, TRUE,  TRUE,  TRUE); return;
	}
    if (eyeType == _STEREO_YELLOW_BLUE)
	switch(stereo){
	case 0: glColorMask(TRUE,  TRUE,  FALSE, TRUE); return;
	case 1: glColorMask(FALSE, FALSE, TRUE,  TRUE); return;
	}
}

void CLS::
StencilMaskBegin(int width, int height){
    glPushAttrib(GL_ALL_ATTRIB_BITS);
    glEnable(GL_STENCIL_TEST);
    
    MakeStripePatternOnStencil(width, height, /*mCbFlip.mbBody*/FALSE);
    glStencilFunc( GL_EQUAL, 1, ~0); //1̃sNZɕ`
}

void CLS::
MakeStripePatternOnStencil(int width, int height, bool bOdd){
    GLPerspective_cls::Push2DMatrix(width, height);

    // XeṼNA
    glClear( GL_STENCIL_BUFFER_BIT);

    //ꂩ`悷̂̃XeVlɂׂĂP^O    
    glStencilFunc( GL_ALWAYS, 1, ~0); 
    glStencilOp(GL_REPLACE,GL_REPLACE,GL_REPLACE);
    
    //XeVobt@ȊÕobt@ɂ͏܂Ȃ
    glColorMask(0,0,0,0);
    glDepthMask(0);
    
    glLineWidth(1);
    for (int y = (int)bOdd; y < height; y+=2){
	glBegin(GL_LINES);
	glVertex2f(     0, y);
	glVertex2f( width, y);
	glEnd();
    }

    //̉
    glColorMask(1,1,1,1);
    glDepthMask(1);
    glStencilOp(GL_KEEP,GL_KEEP,GL_KEEP);

    GLPerspective_cls::Pop2DMatrix();
}

void CLS::
ColorMaskEnd(){
    glColorMask(TRUE, TRUE, TRUE, TRUE);
}

void CLS::
StencilMaskEnd(){
    glDisable(GL_STENCIL_TEST);
    glPopAttrib();
}


void CLS::
DrawAnaglyph(FBO_cls *pCFBOStereo[2], int eyeType){
    int bufferSize = pCFBOStereo[0]->mWidthTex;

    glPushAttrib(GL_ALL_ATTRIB_BITS);

    glClearColor(0, 0, 0, 1);
    glClear(GL_COLOR_BUFFER_BIT);

    glEnable(GL_BLEND);
    glDisable(GL_LIGHTING);
    //GLColorMaskFALSE̐ŏ㏑͂Ȃ悤Ȃ̂ŁAAlpha Blendŗǂ
    //GL_ONEɂƁAAlpha1ȏɂȂĂ܂ĐFȂ̂H
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glDisable(GL_DEPTH_TEST);
    for (int stereo = 0; stereo < 2; stereo++){
	ColorMaskBegin(stereo, eyeType);
	pCFBOStereo[stereo]->DrawOnScreen2D(bufferSize, bufferSize, 
					    bufferSize, bufferSize,
					    0, 0, TRUE);
	ColorMaskEnd();
    }
    glPopAttrib();
}

/*
void CLS::
DrawScanLine(FBO_cls *pCFBOStereo[2]){
    int bufferSize = pCFBOStereo[0]->mWidthTex;
    pCFBOStereo[0]->DrawOnScreen2D(bufferSize, bufferSize, 
				   bufferSize, bufferSize,
				   0, 0, FALSE);
    
    StencilMaskBegin(bufferSize, bufferSize);

    if (bRGBA == TRUE){
	MainGLCanvas_cls::mspCCheckerboard->DrawOnScreen2DTileFit
	    (mPanelWidth, mPanelHeight, 
	     (bFishEye == TRUE) ? _TEX_FIT_VERTICAL : _TEX_FIT_CORNER,
	     16, 16);
    }

    pCFBOStereo[1]->DrawOnScreen2D(bufferSize, bufferSize, 
				   bufferSize, bufferSize,
				   0, 0, FALSE);
    StencilMaskEnd();
}
*/

void CLS::
DrawScanLineOnScreen(FBO_cls *pCFBOStereo[2],
		     int clientWidth, int clientHeight, 
		     int fit, int offsetY){

    pCFBOStereo[0]->DrawOnScreen2DFit(clientWidth, clientHeight, fit,
				      FALSE, offsetY);

    StencilMaskBegin(clientWidth, clientHeight);

    pCFBOStereo[1]->DrawOnScreen2DFit(clientWidth, clientHeight, fit,
				      FALSE, offsetY);

    StencilMaskEnd();
    
}

void CLS::
DrawSideBySide(FBO_cls *pCFBOStereo[2]){
    int bufferSize = pCFBOStereo[0]->mWidthTex;

    pCFBOStereo[0]->DrawOnScreen2D(bufferSize, bufferSize,
				   bufferSize/2, bufferSize, 
				   0, 0, FALSE);
    pCFBOStereo[1]->DrawOnScreen2D(bufferSize, bufferSize,
				   bufferSize/2, bufferSize,
				   bufferSize/2, 0, FALSE);
				   
}

void CLS::
MergeStereogram(FBO_cls *pCFBOStereo[2], FBO_cls *pCFBORenderTarget,
		int eyeType){

    pCFBORenderTarget->Begin(TRUE);

    if (eyeType == _STEREO_RED_CYAN ||
	eyeType == _STEREO_YELLOW_BLUE) DrawAnaglyph(pCFBOStereo, eyeType);
	
    //if (eyeType == _STEREO_SCANLINE)   DrawScanLine(pCFBOStereo);
    if (eyeType == _STEREO_SIDEBYSIDE) DrawSideBySide(pCFBOStereo);

    pCFBORenderTarget->End();
}


Stereogram_cls *GpCStereogram = NULL;
