// -*- c -*-
// "clsStereogram.cpp"

#ifndef _STEREOGRAM_H_
#define _STEREOGRAM_H_

class FBO_cls;

#define _STEREO_NONE    0
#define _STEREO_OFFAXIS 1
#define _STEREO_TOEIN   2

#define _STEREO_LFT         1
#define _STEREO_RGT         2
#define _STEREO_SCANLINE    3
#define _STEREO_RED_CYAN    4
#define _STEREO_YELLOW_BLUE 5
#define _STEREO_SIDEBYSIDE  6
#define _STEREO_QUADBUFFER  7

class FBO_cls;

class Stereogram_cls {
 public:
    Stereogram_cls();

    void ColorMaskBegin(int stereo, int eyeType);
    void StencilMaskBegin(int width, int height);
    void MakeStripePatternOnStencil(int width, int height, bool bOdd);
    void ColorMaskEnd();
    void StencilMaskEnd();

    void DrawAnaglyph(FBO_cls *pCFBOStereo[2], int eyeType);
    //void DrawScanLine(FBO_cls *pCFBOStereo[2]);
    void DrawScanLineOnScreen(FBO_cls *pCFBOStereo[2],
			      int clientWidth, int clientHeight, 
			      int fit, int offsetY);
    void DrawSideBySide(FBO_cls *pCFBOStereo[2]);
    
    void MergeStereogram(FBO_cls *pCFBOStereo[2], FBO_cls *pCFBORenderTarget,
			 int eyeType);
};

#endif
