//(setq c-basic-offset 4)
// "clsGLCanvasCtrl.h"

#include "clsView3D.h"
#include "clsGLCanvas.h"
#include "clsGLNumericalPanel.h"

#include "clsGLAttribute.h"

//#include "../MISC/clsMisc.h"
#include "../MYGL/clsWideCamera.h"
#include "../PREFERENCE/clsShortcut.h"
#include "../SCENEOBJ/clsCamera.h"
#include "../SCENEOBJ/clsSceneObj.h"
#include "../SCENEOBJ/clsSceneObjCtrl.h"
#include "../SCENEOBJ/PROP/clsCameraProp.h"
#include "../SCENEOBJ/PROP/clsStereoProp.h"
#include "../TIMELINE/clsTimeCtrl.h"
#include "../UNDO/clsUndoManager.h"
#include "../WIDGETCTRL/EX/clsPanelBar.h"
#include "../WIDGETCTRL/WX/clsStringProvider.h"
#include "../WIDGETCTRL/WX/myArtProv.h"
#include "../WIDGETCTRL/WX/clsFontProvider.h"
#include "../WIDGETCTRL/INPUTITEM/clsTextButton.h"
#include "../WIDGETCTRL/INPUTITEM/clsVCenter.h"

#include "../../clsMain.h"

#include "../COMMON/CommonDefinitions.h"

#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"

#define CLS View3D_cls

BEGIN_EVENT_TABLE(CLS, wxPanelEX)
EVT_BUTTON(btnNumPanelHide, CLS::OnHideAndShowNumPanel)
EVT_BUTTON(menuPanelView, CLS::OnMenuView)
EVT_BUTTON(menuPanelSelect, CLS::OnMenuSelect)
EVT_BUTTON(menuView3DCamera, CLS::OnMenuCamera)
EVT_BUTTON(menuView3DNavi, CLS::OnMenuNavi)
EVT_BUTTON(btnNaviCoordMode, CLS::OnNaviCoordMode)
EVT_BUTTON(btnNavi,        CLS::OnDisplayNavi)
EVT_BUTTON(btnDisplayData, CLS::OnDisplayData)
EVT_BUTTON(btnDisplayGrid, CLS::OnDisplayGrid)
EVT_BUTTON(btnDisplayGuide, CLS::OnDisplayGuide)
EVT_BUTTON(btnDisplayLight, CLS::OnDisplayLight)
EVT_BUTTON(btnDisplayLoupe, CLS::OnDisplayLoupe)
EVT_BUTTON(btnDisplayPivot, CLS::OnDisplayPivot)
EVT_BUTTON(btnDropdown,  CLS::OnDropDown)
EVT_MENU(menuObjectDeselect, CLS::OnDeselect)
EVT_MENU(menuView3DSetPos, CLS::OnSetPos)
EVT_MENU(menuView3DSetPosRot, CLS::OnSetPosRot)
EVT_MENU(menuView3DSetRot, CLS::OnSetRot)
EVT_MENU(menuView3DLookAtPivot, CLS::OnLookAtPivot)
EVT_MENU(menuView3DLookAtTarget, CLS::OnLookAtTarget)
EVT_MENU(menuView3DFollowCamera, CLS::OnFollow)
EVT_MENU(menuView3DLockToCamera, CLS::OnLockToCamera)
EVT_MENU(menuView3DNaviX, CLS::OnNaviX)
EVT_MENU(menuView3DNaviY, CLS::OnNaviY)
EVT_MENU(menuView3DNaviZ, CLS::OnNaviZ)
EVT_MENU(menuView3DNaviXLock, CLS::OnNaviXLock)
EVT_MENU(menuView3DNaviYLock, CLS::OnNaviYLock)
EVT_MENU(menuView3DNaviZLock, CLS::OnNaviZLock)
EVT_MENU(menuView3DTranslate, CLS::OnNaviTranslate)
EVT_MENU(menuView3DRotate, CLS::OnNaviRotate)
EVT_MENU(menuView3DScale, CLS::OnNaviScale)
EVT_MENU(menuView3DFront, CLS::OnFront)
EVT_MENU(menuView3DBack, CLS::OnBack)
EVT_MENU(menuView3DRight, CLS::OnRight)
EVT_MENU(menuView3DLeft, CLS::OnLeft)
EVT_MENU(menuView3DTop, CLS::OnTop)
EVT_MENU(menuView3DBottom, CLS::OnBottom)
EVT_MENU(menuViewTogglePerspective, CLS::OnTogglePerspective)
EVT_MENU(menuEscape, CLS::OnEscape)
EVT_MENU(menuView3DPivotOrigin, CLS::OnPivotOrigin)
EVT_MENU(menuView3DPivotActiveObj, CLS::OnPivotActive)
EVT_MENU(menuView3DPivotViewCenter, CLS::OnPivotViewCenter)
EVT_MENU(menuView3DPivotFixToActiveObj, CLS::OnPivotFixToActive)
EVT_MENU(menuShowNumPanel, CLS::OnHideAndShowNumPanel)
EVT_MENU_RANGE(menuPop0, menuPop9, CLS::OnPopMenu)
//EVT_CHAR_HOOK (CLS::OnKeyDown)
EVT_PAINT(CLS::OnPaint)
END_EVENT_TABLE()

CLS::
View3D_cls(wxWindow *pCParent, wxWindowID id, const wxPoint &pos, const wxSize &size, long style) :
    wxPanelEX(pCParent, id, pos, size, style) {

    SetToDefaultParam();

    SetPanelType(_PANEL_VIEW3D);

    Freeze();
    
    int attribList[10] = {WX_GL_DOUBLEBUFFER, 1, WX_GL_STENCIL_SIZE, 8, WX_GL_DEPTH_SIZE, 24, 0, 0, 0, 0};
    
    bool bUseQuadBuffer = FALSE;
    if (bUseQuadBuffer == TRUE)
	attribList[6] = WX_GL_STEREO;
    
    mpCGLAttribute = new GLAttribute_cls(FALSE);
    
    if (mpCGLAttribute->SupportCheck() == FALSE){
	mbGLSupported = FALSE;
	mpCDummyPanel = new wxPanel(this);
	mpCGLCanvas = NULL;
    }
    else{
	mbGLSupported = TRUE;
	mpCDummyPanel = NULL;
	//mpCGLCanvas = new GLCanvas_cls(this, mpCGLAttribute->mCGLAttribute, 0, wxT("GLCanvas"));
	mpCGLCanvas = new GLCanvas_cls(this, attribList, 0, wxT("GLCanvas"));
	
	mpCGLCanvas->SetBackgroundColour(wxColour(0, 0, 0));
    }

    mpCPanelBar = new PanelBar_cls(this);
    mpCPanelBar->Freeze();
    mpCPanelBar->SetPanelType(_PANEL_CHILD, _PANEL_VIEW3D);

    wxBoxSizer *pBoxSizerSrc = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer *pBoxSizerBar = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer *pBoxSizerH = new wxBoxSizer(wxHORIZONTAL);

    ConstructTypeSelector(pBoxSizerBar);
    
    mpCTextMenuView = new TextButton_cls
	(mpCPanelBar, menuPanelView, GetPCStringProvider()->GetStrMenu("View"));
    mpCTextMenuView->SetEventTarget(this);
    VCenter_cls *pCMenuView = new VCenter_cls(mpCTextMenuView);

    mpCTextMenuSelect = new TextButton_cls
	(mpCPanelBar, menuPanelSelect, GetPCStringProvider()->GetStrMenu("Select"));
    mpCTextMenuSelect->SetEventTarget(this);
    VCenter_cls *pCMenuSelect = new VCenter_cls(mpCTextMenuSelect);

    mpCTextMenuCamera = new TextButton_cls
	(mpCPanelBar, menuView3DCamera, GetPCStringProvider()->GetStrMenu("Camera"));
    mpCTextMenuCamera->SetEventTarget(this);
    VCenter_cls *pCMenuCamera = new VCenter_cls(mpCTextMenuCamera);

    mpCTextMenuNavi = new TextButton_cls
	(mpCPanelBar, menuView3DNavi, GetPCStringProvider()->GetStrMenu("Navigator"));
    mpCTextMenuNavi->SetEventTarget(this);
    VCenter_cls *pCMenuNavi = new VCenter_cls(mpCTextMenuNavi);

    mpCCheckActive = new wxCheckBox(mpCPanelBar, cbActive, _("Active"));
    mpCCheckActive->SetValue(FALSE);
    VCenter_cls *pCCheckActiveCenter = new VCenter_cls(mpCCheckActive);

    wxSize CSize = wxSize(20, 20);

    mpCBtnDisplayData = new BitmapPanel_cls(mpCPanelBar, btnDisplayData, wxDP, CSize);
    mpCBtnDisplayData->AddBitmapStr("wxART_EYE_S_N");
    mpCBtnDisplayData->AddBitmapStr("wxART_EYE_S_P");
    mpCBtnDisplayData->mbButton = TRUE;
    mpCBtnDisplayData->SetBorder(2, 2);
    mpCBtnDisplayData->SetStatus(1);
    VCenter_cls *pCBtnDisplayDataCenter = new VCenter_cls(mpCBtnDisplayData);

    mpCBtnDisplayGrid = new BitmapPanel_cls(mpCPanelBar, btnDisplayGrid, wxDP, CSize);
    mpCBtnDisplayGrid->AddBitmapStr("wxART_GRID_N", "wxART_GRID_H_N");
    mpCBtnDisplayGrid->AddBitmapStr("wxART_GRID_P", "wxART_GRID_H_P");
    mpCBtnDisplayGrid->mbButton = TRUE;
    mpCBtnDisplayGrid->SetBorder(2, 2);
    mpCBtnDisplayGrid->SetStatus(1);
    mpCBtnDisplayGrid->SetToolTip(_("Show grid"));
    VCenter_cls *pCBtnDisplayGridCenter = new VCenter_cls(mpCBtnDisplayGrid);

    mpCBtnDisplayGuide = new BitmapPanel_cls(mpCPanelBar, btnDisplayGuide, wxDP, CSize);
    mpCBtnDisplayGuide->AddBitmapStr("wxART_GUIDE_N", "wxART_GUIDE_H_N");
    mpCBtnDisplayGuide->AddBitmapStr("wxART_GUIDE_P", "wxART_GUIDE_H_P");
    mpCBtnDisplayGuide->mbButton = TRUE;
    mpCBtnDisplayGuide->SetBorder(2, 2);
    mpCBtnDisplayGuide->SetStatus(1);
    mpCBtnDisplayGuide->SetToolTip(_("Show guide object"));
    VCenter_cls *pCBtnDisplayGuideCenter = new VCenter_cls(mpCBtnDisplayGuide);

    mpCBtnDisplayLight = new BitmapPanel_cls(mpCPanelBar, btnDisplayLight, wxDP, CSize);
    mpCBtnDisplayLight->AddBitmapStr("wxART_LIGHT_N", "wxART_LIGHT_H_N");
    mpCBtnDisplayLight->AddBitmapStr("wxART_LIGHT_P", "wxART_LIGHT_H_P");
    mpCBtnDisplayLight->mbButton = TRUE;
    mpCBtnDisplayLight->SetBorder(2, 2);
    mpCBtnDisplayLight->SetStatus(1);
    mpCBtnDisplayLight->SetToolTip(_("Show light and camera"));
    VCenter_cls *pCBtnDisplayLightCenter = new VCenter_cls(mpCBtnDisplayLight);

    mpCBtnNavi = new BitmapPanel_cls(mpCPanelBar, btnNavi, wxDP, CSize);
    mpCBtnNavi->AddBitmapStr("wxART_NAVI_N", "wxART_NAVI_H_N");
    mpCBtnNavi->AddBitmapStr("wxART_NAVI_P", "wxART_NAVI_H_P");
    mpCBtnNavi->mbButton = TRUE;
    mpCBtnNavi->SetBorder(2, 2);
    mpCBtnNavi->SetStatus(1);
    mpCBtnNavi->SetToolTip(_("Show navigator"));
    VCenter_cls *pCBtnNaviCenter = new VCenter_cls(mpCBtnNavi);

    mpCBtnDisplayLoupe = new BitmapPanel_cls(mpCPanelBar, btnDisplayLoupe, wxDP, CSize);
    mpCBtnDisplayLoupe->AddBitmapStr("wxART_LOUPE_N", "wxART_LOUPE_H_N");
    mpCBtnDisplayLoupe->AddBitmapStr("wxART_LOUPE_P", "wxART_LOUPE_H_P");
    mpCBtnDisplayLoupe->mbButton = TRUE;
    mpCBtnDisplayLoupe->SetBorder(2, 2);
    mpCBtnDisplayLoupe->SetStatus(1);
    mpCBtnDisplayLoupe->SetToolTip(_("Show loupe"));
    VCenter_cls *pCBtnDisplayLoupeCenter = new VCenter_cls(mpCBtnDisplayLoupe);

    mpCBtnDisplayPivot = new BitmapPanel_cls(mpCPanelBar, btnDisplayPivot, wxDP, CSize);
    mpCBtnDisplayPivot->AddBitmapStr("wxART_PIVOT_N", "wxART_PIVOT_H_N");
    mpCBtnDisplayPivot->AddBitmapStr("wxART_PIVOT_P", "wxART_PIVOT_H_P");
    mpCBtnDisplayPivot->mbButton = TRUE;
    mpCBtnDisplayPivot->SetBorder(2, 2);
    mpCBtnDisplayPivot->SetStatus(1);
    mpCBtnDisplayPivot->SetToolTip(_("Show loupe"));
    VCenter_cls *pCBtnDisplayPivotCenter = new VCenter_cls(mpCBtnDisplayPivot);
    
    BitmapPanel_cls *pCBtnNaviMode = new BitmapPanel_cls(mpCPanelBar, btnNaviCoordMode, wxDP, wxSize(16, 16));
    VCenter_cls *pCBtnNaviModeCenter = new VCenter_cls(pCBtnNaviMode);
    pCBtnNaviMode->AddBitmapStr("wxART_SELECTOR_N", "wxART_SELECTOR_P");
    pCBtnNaviMode->mbButton = TRUE;
    pCBtnNaviMode->SetBorder(1, 1);
    mpCNaviMode = new wxStaticText(mpCPanelBar, wxID_ANY, "local", wxDP, wxSize(50, 16));
    VCenter_cls *pCNaviModeCenter = new VCenter_cls(mpCNaviMode);

    pBoxSizerBar->Add(pCMenuView, 0, wxEXPAND);
    pBoxSizerBar->Add(pCMenuSelect, 0, wxEXPAND);
    pBoxSizerBar->Add(pCMenuCamera, 0, wxEXPAND);
    pBoxSizerBar->Add(pCMenuNavi, 0, wxEXPAND);
    pBoxSizerBar->AddSpacer(4);
    pBoxSizerBar->Add(pCBtnNaviModeCenter, 0, wxEXPAND);
    pBoxSizerBar->Add(pCNaviModeCenter, 0, wxEXPAND);
    pBoxSizerBar->AddSpacer(2);
    pBoxSizerBar->Add(pCBtnDisplayDataCenter, 0, wxEXPAND);
    pBoxSizerBar->Add(pCBtnNaviCenter, 0, wxEXPAND);
    pBoxSizerBar->Add(pCBtnDisplayGridCenter, 0, wxEXPAND);
    pBoxSizerBar->Add(pCBtnDisplayGuideCenter, 0, wxEXPAND);
    pBoxSizerBar->Add(pCBtnDisplayLightCenter, 0, wxEXPAND);
    pBoxSizerBar->Add(pCBtnDisplayPivotCenter, 0, wxEXPAND);
    pBoxSizerBar->Add(pCBtnDisplayLoupeCenter, 0, wxEXPAND);
    pBoxSizerBar->AddStretchSpacer(1);
    pBoxSizerBar->Add(pCCheckActiveCenter, 0, wxEXPAND);
    mpCPanelBar->ConstructBarItemDefault(pBoxSizerBar);
    mpCPanelBar->ConstructBarItemHideShow(pBoxSizerBar);

    mpCPanelBar->SetSizer(pBoxSizerBar);
    
    pBoxSizerSrc->Add(mpCPanelBar, 0, wxEXPAND);

    if (mpCGLCanvas != NULL)
	pBoxSizerH->Add(mpCGLCanvas, 1, wxEXPAND);
    if (mpCDummyPanel != NULL)
	pBoxSizerH->Add(mpCDummyPanel, 1, wxEXPAND);

    wxSize CSizeNumPanel = wxSize(265, -1);
    mpCNumPanel = new GLNumericalPanel_cls(this, CSizeNumPanel);

    mCClosedItem.SetLink(&mpCNumPanel->mAstrClosedItem);
    
    pBoxSizerH->Add(mpCNumPanel, 0, wxEXPAND);

    pBoxSizerSrc->Add(pBoxSizerH, 1, wxEXPAND);
    
    SetSizer(pBoxSizerSrc);
    
    SetActiveObjectInfo();
    
    mpCPanelBar->Thaw();
    Thaw();

    mbSnapX = mbSnapY = mbSnapZ = FALSE;
    mNavigatorMode = 0;
}

CLS::
~View3D_cls(){
    delete mpCGLAttribute;
}

void CLS::
SetToDefaultParam(){
    mCConfList.Clear();
    mCConfList.SetTag(wxT("View3DPanel"));
    mCConfList.Add(&mCbNumPanelShown, "NumPanelShown=", "1");
    mCConfList.Add(&mCClosedItem, "ColsedItem=", wxES);
    mCConfList.Add(&mCViewPos, "ViewPos=", "0 0 10");
    mCConfList.Add(&mCViewDirTgt, "DirTgt=", "0 0 -1");
    mCConfList.Add(&mCViewDirTop, "DirTop=", "0 1 0");
    mCConfList.Add(&mCViewDirRgt, "DirRgt=", "1 0 0");
    mCConfList.Add(&mCViewEuler, "Euler=", "0 90 90");
    mCConfList.Add(&mCPivotPos, "PivotPos=", "0 0 0");
    mCConfList.Add(&mCViewAngleL, "ViewAngleL=", "45");
    mCConfList.Add(&mCSizeOrthoL, "SizeOrthoL=", "10");
    mCConfList.Add(&mCstrPivotObject, "PivotObject=", "None");
    mCConfList.Add(&mCstrActiveObject, "ActiveObject=", "None");
    mCConfList.Add(&mCstrCamera, "Camera=", "Camera", "VIEW3D");
    mCConfList.Add(&mCbFollow, "Follow=", "0", "VIEW3D");
    mCConfList.Add(&mCbLockToCamera, "LockToCamer=", "0", "VIEW3D");
    mCConfList.Add(&mCObjectPos, "ObjPos=", "0 0 0");
    mCConfList.Add(&mCObjectRot, "ObjRot=", "0 0 0");
    mCConfList.Add(&mCObjectScale, "ObjScale=", "1 1 1");
    mCConfList.Add(&mCbDisplayGrid, "DispGrid=", "1", "VIEW3D");
    mCConfList.Add(&mCbDisplayGuideObjects, "DispGuideObj=", "1", "VIEW3D");
    mCConfList.Add(&mCbDisplayLightCam, "DispLightCam=", "1", "VIEW3D");
    mCConfList.Add(&mCbDisplayLoupe, "Loupe=", "0", "VIEW3D");
    mCConfList.Add(&mCbDisplayPivot, "Pivot=", "0", "VIEW3D");
    mCConfList.Add(&mCBufferSizeIndex, "BufSizeIdx=", "2", "VIEW3D"); 
    mCConfList.Add(&mC1stBufferSizeIndex, "1stBufSizeIdx=", "1", "VIEW3D"); 
    mCConfList.Add(&mCWideCameraType, "WideCameraType=", "0", "VIEW3D");
    mCConfList.Add(&mCLineWidth, "LineWidth=", "2", "VIEW3D");
    mCConfList.Add(&mCbDisplayNavigator, "DiaplayNavigator=", "1", "VIEW3D");
    mCConfList.Add(&mCbDisplayData, "DisplayData=", "1", "VIEW3D");
    mCConfList.Add(&mCNavigatorCoord, "NavigatorCoord=", "0", "VIEW3D");
    mCConfList.Add(&mCbActive, "Active=", "0", "VIEW3D");
}

bool CLS::
IsSnapNavi(){
    return mbSnapX | mbSnapY | mbSnapZ;
}

bool CLS::
IsUseCamera(){
    return mCbFollow.GetBodyBOOL() | mCbLockToCamera.GetBodyBOOL();
}

bool CLS::
IsStereogram(){
    if (IsUseCamera() == FALSE) return FALSE;
    
    Camera_cls *pCCamera = GetPCCamera();
    if (pCCamera == NULL) return FALSE;

    if (pCCamera->mpCStereoProp->mCStereoType.GetBodyINT() == 0) return FALSE;
    if (pCCamera->mpCStereoProp->mCEyeType.GetBodyINT() < 3) return FALSE;

    return TRUE;
}

void CLS::
GetSnapAxis(double vecX[3], double vecY[3], double vecZ[3]){
    LOOP_XYZ { vecX[xyz] = 0; vecY[xyz] = 0; vecZ[xyz] = 0; }
    if (mbSnapX == TRUE){ vecX[X] = 1; vecX[Y] = 0; vecX[Z] = 0; }
    if (mbSnapY == TRUE){ vecY[X] = 0; vecY[Y] = 1; vecY[Z] = 0; }
    if (mbSnapZ == TRUE){ vecZ[X] = 0; vecZ[Y] = 0; vecZ[Z] = 1; }
}

Camera_cls *CLS::
GetPCCamera(){ return mpCGLCanvas->GetPCCamera(); }

void CLS::
SetToActiveGLView(){
    mpCCheckActive->SetValue(TRUE);
    GetPCMain()->mActiveGLViewID = GetId();
    GetPCMain()->UpdatePanels("VIEW3D");
}

void CLS::
SetPositionView(Position_cls CPos){
    std::vector < float > VPos;
    LOOP_XYZ VPos.push_back(CPos.mPos[xyz]);
    mCViewPos.SetBodyFromData(VPos);
}

void CLS::
SetDirectionView(Direction_cls CDir){
    std::vector < float > VTgt, VTop, VRgt;
    LOOP_XYZ{
	VTgt.push_back(CDir.mTgt[xyz]);
	VTop.push_back(CDir.mTop[xyz]);
	VRgt.push_back(CDir.mRgt[xyz]);
	
    }
    VectorMath_cls::Normalize(VTgt.data(), 1.0f);
    VectorMath_cls::Normalize(VTop.data(), 1.0f);
    VectorMath_cls::Normalize(VRgt.data(), 1.0f);
    mCViewDirTgt.SetBodyFromData(VTgt);
    mCViewDirTop.SetBodyFromData(VTop);
    mCViewDirRgt.SetBodyFromData(VRgt);

    std::vector < float > VRPYorg = mCViewEuler.GetBodyFLOATARRAY();

    CDir.NormalizeAndOrthogonalize();
    std::vector < float > VRPY = CDir.GetRPY();

    LOOP_XYZ{ 
	if (VRPY[xyz] > VRPYorg[xyz] + 181) VRPY[xyz] -= 360;
	if (VRPY[xyz] < VRPYorg[xyz] - 181) VRPY[xyz] += 360;
    }

    mCViewEuler.SetBodyFromData(VRPY);
}

void CLS::
SetPositionPivot(Position_cls CPos){
    std::vector < float > VPos;
    LOOP_XYZ VPos.push_back(CPos.mPos[xyz]);
    mCPivotPos.SetBodyFromData(VPos);
    //mpCGLCanvas->SetCameraInfo();
    mpCGLCanvas->mCPivot.SetPos(VPos);
}

void CLS::
SetNullObjectInfo(){
    mCstrActiveObject.SetBodyFromData("None");
    mpCNumPanel->HideAndShow();
}

void CLS::
SetActiveObjectInfo(){
    SceneObj_cls* pCObj = GetPCSceneObjCtrl()->mpCActiveObject;
    if (pCObj == NULL) return SetNullObjectInfo();
    
    mCstrActiveObject.SetBodyFromData(pCObj->GetStrName());

    double time = GetPCTimeCtrl()->GetCurrentNT();
    ParamGroup_cls *pCParamGroupPos = pCObj->GetPCParamGroup("Position");
    mCObjectPos.SetBodyFromData(pCParamGroupPos->GetStrValues(time, FALSE));
    ParamGroup_cls *pCParamGroupRot = pCObj->GetPCParamGroup("RotationEuler");
    mCObjectRot.SetBodyFromData(pCParamGroupRot->GetStrValues(time, FALSE));
    ParamGroup_cls *pCParamGroupSize = pCObj->GetPCParamGroup("Scale");
    mCObjectScale.SetBodyFromData(pCParamGroupSize->GetStrValues(time, FALSE));

    mpCNumPanel->HideAndShow();
}

int CLS::
GetBufferSize(){
    int index = mCBufferSizeIndex.GetBodyINT();
    switch(index){
    case 0: return 256;
    case 1: return 512;
    case 2: return 1024;
    case 3: return 2048;
    case 4: return 4096;
    case 5: return 8192;
    case 6: return 16384;
    }
    return 256;
}

int CLS::
GetBufferSize1st(){
    int index = mC1stBufferSizeIndex.GetBodyINT();
    if (IsUseCamera() == TRUE){
	Camera_cls* pCCam = GetPCCamera();
	if (pCCam != NULL)
	    index = pCCam->mpCCameraProp->mC1stBufferSizeIndex.GetBodyINT();
    }
    switch(index){
    case 0: return 256;
    case 1: return 512;
    case 2: return 1024;
    case 3: return 2048;
    case 4: return 4096;
    case 5: return 8192;
    case 6: return 16384;
    }
    return 256;
}

Position_cls CLS::
GetPositionView(){
    Position_cls CPos(mCViewPos.GetBodyFLOATARRAY());
    return CPos;
}

Position_cls CLS::
GetPositionPivot(){
    wxString strName = mCstrPivotObject.GetBodySTR();

    SceneObj_cls *pCObj = GetPCSceneObjCtrl()->GetPCFromName(strName);
    if (pCObj != NULL){
	Position_cls CPos(pCObj->GetPositionGlobal(GetPCTimeCtrl()->GetCurrentNT()));
	return CPos;
    }
	
    Position_cls CPos(mCPivotPos.GetBodyFLOATARRAY());
    return CPos;

}

Direction_cls CLS::
GetDirectionView(){
    Direction_cls CDir(mCViewDirTgt.GetBodyFLOATARRAY(),
		       mCViewDirTop.GetBodyFLOATARRAY(),
		       mCViewDirRgt.GetBodyFLOATARRAY());
    return CDir;
}

Position_cls CLS::
GetAutoPivotPos(PositionAndDirection_cls CCam){

    Position_cls CPos(CCam);
    
    float dr[3];
    LOOP_XYZ dr[xyz] = CCam.mPos[xyz] - mCPivotPos.GetBodyFLOATARRAY()[xyz];
    float dist = VectorMath_cls::GetNorm(dr);

    LOOP_XYZ CPos.mPos[xyz] += CCam.mTgt[xyz] * dist;
    
    return CPos;
}

void CLS::
HideAndShowNumPanel(){
    if (mCbNumPanelShown.GetBodyBOOL() == TRUE &&
	mpCNumPanel->IsShown() == FALSE){
	//mpCPanelBar->Freeze();
	mpCNumPanel->Show();
	Layout();
	//mpCPanelBar->Thaw();
    }
    if (mCbNumPanelShown.GetBodyBOOL() == FALSE &&
	mpCNumPanel->IsShown() == TRUE){
	//mpCPanelBar->Freeze();
	mpCNumPanel->Hide();
	Layout();
	//mpCPanelBar->Thaw();
    }
}

void CLS::
OnHideAndShowNumPanel(wxComEvt& event){
    if (mpCNumPanel->IsShown() == TRUE){
	mCbNumPanelShown.SetBodyFromData((long long)0);
    }
    else{
	mCbNumPanelShown.SetBodyFromData((long long)1);
    }
    HideAndShowNumPanel();
}

void CLS::
OnPopMenu(wxComEvt& event){
    wxString strPopMenu = mCSelector.GetStr(event.GetId());
    if (strPopMenu.IsEmpty() == TRUE) return;

    wxString strTag = mCSelector.mstrTag;
    if (strTag.IsSameAs("ActiveObject"))
	GetPCSceneObjCtrl()->Select(strPopMenu, FALSE);
    if (strTag.IsSameAs("Camera")){
	mCstrCamera.SetBodyFromData(strPopMenu);
	UpdatePanels("ALL");
    }
}

void CLS::
OnMenuView(wxComEvt& event){
    Shortcut_cls *pCSC = GetPCShortcut();
    wxMenu CMenu;
    pCSC->SetMenuItem(&CMenu, menuView3DFront);
    pCSC->SetMenuItem(&CMenu, menuView3DBack);
    pCSC->SetMenuItem(&CMenu, menuView3DRight);
    pCSC->SetMenuItem(&CMenu, menuView3DLeft);
    pCSC->SetMenuItem(&CMenu, menuView3DTop);
    pCSC->SetMenuItem(&CMenu, menuView3DBottom);
    pCSC->SetMenuItem(&CMenu, menuViewTogglePerspective);
    CMenu.AppendSeparator();
    pCSC->SetMenuCheckItem(&CMenu, menuShowNumPanel, mCbNumPanelShown.GetBodyBOOL());
    CMenu.AppendSeparator();
    pCSC->SetMenuCheckItem(&CMenu, menuShowPanelManage, mpCPanelBar->mbShowItem);
    mpCTextMenuView->PopMenu(this, &CMenu);
}

void CLS::
OnMenuSelect(wxCommandEvent& event){
    wxMenu CMenu;
    bool bBarItem = mpCPanelBar->mbShowItem;
    CMenu.Append(menuObjectDeselect, GetPCShortcut()->GetMenuString(menuObjectDeselect));

    mpCTextMenuSelect->PopMenu(this, &CMenu);
}

void CLS::
OnMenuCamera(wxComEvt& event){
    wxMenu CMenu;
    Shortcut_cls *pCSC = GetPCShortcut();
    CMenu.Append(menuView3DSetPos, _("Set Position"));
    CMenu.Append(menuView3DSetPosRot, _("Set Pos/Rot"));
    CMenu.Append(menuView3DSetRot, _("Set Rotation"));
    CMenu.Append(menuView3DLookAtPivot, _("Look at Pivot"));
    CMenu.Append(menuView3DLookAtTarget, _("Look at Target"));
    CMenu.AppendSeparator();
    pCSC->SetMenuCheckItem(&CMenu, menuView3DFollowCamera, mCbFollow.GetBodyBOOL());
    pCSC->SetMenuCheckItem(&CMenu, menuView3DLockToCamera, mCbLockToCamera.GetBodyBOOL());
        
    mpCTextMenuCamera->PopMenu(this, &CMenu);
}

void CLS::
OnMenuNavi(wxComEvt& event){
    wxMenu CMenu;
    Shortcut_cls *pCSC = GetPCShortcut();
    pCSC->SetMenuItem(&CMenu, menuView3DTranslate);
    pCSC->SetMenuItem(&CMenu, menuView3DRotate);
    pCSC->SetMenuItem(&CMenu, menuView3DScale);
    pCSC->SetMenuItem(&CMenu, menuView3DNaviX);
    pCSC->SetMenuItem(&CMenu, menuView3DNaviY);
    pCSC->SetMenuItem(&CMenu, menuView3DNaviZ);
    pCSC->SetMenuItem(&CMenu, menuView3DNaviXLock);
    pCSC->SetMenuItem(&CMenu, menuView3DNaviYLock);
    pCSC->SetMenuItem(&CMenu, menuView3DNaviZLock);
    pCSC->SetMenuItem(&CMenu, menuEscape);
    CMenu.AppendSeparator();
    pCSC->SetMenuItem(&CMenu, menuView3DPivotOrigin);
    pCSC->SetMenuItem(&CMenu, menuView3DPivotActiveObj);
    pCSC->SetMenuItem(&CMenu, menuView3DPivotViewCenter);
    pCSC->SetMenuItem(&CMenu, menuView3DPivotFixToActiveObj);
    //
    mpCTextMenuNavi->PopMenu(this, &CMenu);
}


void CLS::
OnNaviCoordMode(wxComEvt& event){
    long long mode = mCNavigatorCoord.GetBodyINT();
    mode++;
    if (mode > 2) mode = 0;
    mpCNaviMode->SetLabel(GetPCStringProvider()->GetArrayString("COORDINATE")[mode]);
    mCNavigatorCoord.SetBodyFromData(mode);
    mpCGLCanvas->RefreshEX();
}

void CLS::
OnDisplayNavi(wxComEvt& event){
    mCbDisplayNavigator.SetBodyFromData((long long)(mpCBtnNavi->mState == 1));
    mpCGLCanvas->RefreshEX();
}

void CLS::
OnDisplayData(wxComEvt& event){
    mCbDisplayData.SetBodyFromData((long long)(mpCBtnDisplayData->mState == 1));
    mpCGLCanvas->RefreshEX();
}

void CLS::
OnDisplayGrid(wxComEvt& event){
    mCbDisplayGrid.SetBodyFromData((long long)(mpCBtnDisplayGrid->mState == 1));
    mpCGLCanvas->RefreshEX();
}

void CLS::
OnDisplayGuide(wxComEvt& event){
    mCbDisplayGuideObjects.SetBodyFromData((long long)(mpCBtnDisplayGuide->mState == 1));
    mpCGLCanvas->RefreshEX();
}

void CLS::
OnDisplayLight(wxComEvt& event){
    mCbDisplayLightCam.SetBodyFromData((long long)(mpCBtnDisplayLight->mState == 1));
    mpCGLCanvas->RefreshEX();
}

void CLS::
OnDisplayLoupe(wxComEvt& event){
    mCbDisplayLoupe.SetBodyFromData((long long)(mpCBtnDisplayLoupe->mState == 1));
    mpCGLCanvas->RefreshEX();
}

void CLS::
OnDisplayPivot(wxComEvt& event){
    mCbDisplayPivot.SetBodyFromData((long long)(mpCBtnDisplayPivot->mState == 1));
    mpCGLCanvas->RefreshEX();
}

void CLS::
OnDropDown(wxComEvt& event){
    wxString strCommand = event.GetString();
    if (strCommand.IsSameAs("ActiveObject"))
	mCSelector.PopupObjectSelector(this, strCommand, "ALL");//olid"FALSE);
    else
	mCSelector.PopupObjectSelector(this, strCommand, "Camera_cls");
}

void CLS::
OnDeselect(wxComEvt& event){
    GetPCSceneObjCtrl()->Select(wxES, FALSE); }

void CLS::
OnSetPos(wxComEvt& event){
    Camera_cls *pCObj = mpCGLCanvas->GetPCCamera();
    if (pCObj == NULL) return;

    GetPCUndo()->OpenBlock("SetPos");
    SyncronizeParam(pCObj, "Position", mCViewPos);
    GetPCUndo()->CloseBlock("SetPos");
}

void CLS::
OnSetPosRot(wxComEvt& event){ 
    Camera_cls *pCObj = mpCGLCanvas->GetPCCamera();
    if (pCObj == NULL) return;

    GetPCUndo()->OpenBlock("SetPosRot");
    SyncronizeParam(pCObj, "Position", mCViewPos);
    SyncronizeParam(pCObj, "RotationEuler", mCViewEuler);
    GetPCUndo()->CloseBlock("SetRot");
}

void CLS::
OnSetRot(wxComEvt& event){ 
    Camera_cls *pCObj = mpCGLCanvas->GetPCCamera();
    if (pCObj == NULL) return;

    GetPCUndo()->OpenBlock("SetRot");
    SyncronizeParam(pCObj, "RotationEuler", mCViewEuler);
    GetPCUndo()->CloseBlock("SetRot");
}

void CLS::
OnLookAtPivot(wxComEvt& event){

    Camera_cls *pCObj = mpCGLCanvas->GetPCCamera();
    if (pCObj == NULL) return;

    mpCGLCanvas->mCCameraBase.LookAtPivot();
    SetDirectionView(mpCGLCanvas->mCCameraBase);

    GetPCUndo()->OpenBlock("LookAtPivot");
    SyncronizeParam(pCObj, "RotationEuler", mCViewEuler);
    GetPCUndo()->CloseBlock("LookAtPivot");
}

void CLS::
OnLookAtTarget(wxComEvt& event){

    Camera_cls *pCObj = mpCGLCanvas->GetPCCamera();
    if (pCObj == NULL) return;

    SceneObj_cls *pCTgt = GetPCSceneObjCtrl()->mpCActiveObject;
    if (pCTgt == NULL) return;

    float pivotPos[3];
    LOOP_XYZ pivotPos[xyz] = mpCGLCanvas->mCCameraBase.mPivotPos[xyz];

    OnPivotActive(event);

    mpCGLCanvas->mCCameraBase.LookAtPivot();
    SetDirectionView(mpCGLCanvas->mCCameraBase);

    LOOP_XYZ mpCGLCanvas->mCCameraBase.mPivotPos[xyz] = pivotPos[xyz];
    
    GetPCUndo()->OpenBlock("LookAtPivot");
    SyncronizeParam(pCObj, "RotationEuler", mCViewEuler);
    GetPCUndo()->CloseBlock("LookAtPivot");
}

void CLS::
OnFollow(wxComEvt& event){
    mCbFollow.SetBodyFromData((long long)!mCbFollow.GetBodyBOOL());
    UpdatePanels("ALL");
}

void CLS::
OnLockToCamera(wxComEvt& event){
    if (mCbFollow.GetBodyBOOL() == FALSE) return;
    mCbLockToCamera.SetBodyFromData((long long)!mCbLockToCamera.GetBodyBOOL());
    UpdatePanels("ALL");
}

void CLS::
OnNaviX(wxComEvt& event){
    mbSnapX = !mbSnapX;
    mbSnapY = FALSE;
    mbSnapZ = FALSE;
    mpCGLCanvas->Refresh();
}

void CLS::
OnNaviY(wxComEvt& event){
    mbSnapX = FALSE;
    mbSnapY = !mbSnapY;
    mbSnapZ = FALSE;
    mpCGLCanvas->Refresh();
}

void CLS::
OnNaviZ(wxComEvt& event){
    mbSnapX = FALSE;
    mbSnapY = FALSE;
    mbSnapZ = !mbSnapZ;
    mpCGLCanvas->Refresh();
}

void CLS::
OnNaviXLock(wxComEvt& event){
    if (mbSnapX == FALSE && mbSnapY == TRUE && mbSnapZ == TRUE){
	mbSnapX = FALSE;
	mbSnapY = FALSE;
	mbSnapZ = FALSE;
    }
    else{
	mbSnapX = FALSE;
	mbSnapY = TRUE;
	mbSnapZ = TRUE;
    }
    mpCGLCanvas->Refresh();
}

void CLS::
OnNaviYLock(wxComEvt& event){
    if (mbSnapX == TRUE && mbSnapY == FALSE && mbSnapZ == TRUE){
	mbSnapX = FALSE;
	mbSnapY = FALSE;
	mbSnapZ = FALSE;
    }
    else{
	mbSnapX = TRUE;
	mbSnapY = FALSE;
	mbSnapZ = TRUE;
    }
    mpCGLCanvas->Refresh();
}

void CLS::
OnNaviZLock(wxComEvt& event){
        if (mbSnapX == TRUE && mbSnapY == TRUE && mbSnapZ == FALSE){
	mbSnapX = FALSE;
	mbSnapY = FALSE;
	mbSnapZ = FALSE;
    }
    else{
	mbSnapX = TRUE;
	mbSnapY = TRUE;
	mbSnapZ = FALSE;
    }
    mpCGLCanvas->Refresh();
}

void CLS::
OnNaviTranslate(wxComEvt& event){
    mNavigatorMode = 0;
    if (mpCGLCanvas->mInputMode == 0){
	mpCGLCanvas->mstrInputCommand << "G";
	mpCGLCanvas->mInputMode = 1;
    }
    mpCGLCanvas->Refresh();
}

void CLS::
OnNaviRotate(wxComEvt& event){
    mNavigatorMode = 1;
    mpCGLCanvas->Refresh();
}

void CLS::
OnNaviScale(wxComEvt& event){
    mNavigatorMode = 2;
    if (mpCGLCanvas->mInputMode == 0){
	mpCGLCanvas->mstrInputCommand << "S";
	mpCGLCanvas->mInputMode = 1;
    }
    mpCGLCanvas->Refresh();
}

void CLS::
ViewAlignAxis(float offset[3]){
    std::vector < float > VNewPos = mCViewPos.GetBodyFLOATARRAY();
    std::vector < float > VPivot = mCPivotPos.GetBodyFLOATARRAY();
    float distance = VectorMath_cls::GetDistance(VNewPos.data(), VPivot.data());
    VNewPos = VPivot;
    LOOP_XYZ VNewPos[xyz] += offset[xyz] * distance;
    mCViewPos.SetBodyFromData(VNewPos);
    mCbFollow.SetBodyFromData("0");
    mpCGLCanvas->SetCameraInfo();
    UpdatePanels("ALL");
}

void CLS::
OnFront(wxComEvt& event){
    std::vector < float > VTgt = { 0, 1, 0};
    std::vector < float > VTop = { 0, 0, 1};
    std::vector < float > VRgt = { 1, 0, 0};
    Direction_cls VDir(VTgt, VTop, VRgt);
    SetDirectionView(VDir);
    float offset[3] = {0, -1, 0};
    ViewAlignAxis(offset);
}

void CLS::
OnBack(wxComEvt& event){
    std::vector < float > VTgt = { 0,-1, 0}; 
    std::vector < float > VTop = { 0, 0, 1}; 
    std::vector < float > VRgt = {-1, 0, 0}; 
    Direction_cls VDir(VTgt, VTop, VRgt);
    SetDirectionView(VDir);
    float offset[3] = {0, +1, 0};
    ViewAlignAxis(offset);
}

void CLS::
OnRight(wxComEvt& event){
    std::vector < float > VTgt = {-1, 0, 0};
    std::vector < float > VTop = { 0, 0, 1};
    std::vector < float > VRgt = { 0, 1, 0};
    Direction_cls VDir(VTgt, VTop, VRgt);
    SetDirectionView(VDir);
    float offset[3] = {+1, 0, 0};
    ViewAlignAxis(offset);
}

void CLS::
OnLeft(wxComEvt& event){
    std::vector < float > VTgt = { 1, 0, 0};
    std::vector < float > VTop = { 0, 0, 1};
    std::vector < float > VRgt = { 0,-1, 0};
    Direction_cls VDir(VTgt, VTop, VRgt);
    SetDirectionView(VDir);
    float offset[3] = {-1, 0, 0};
    ViewAlignAxis(offset);
}

void CLS::
OnTop(wxComEvt& event){
    std::vector < float > VTgt = { 0, 0,-1};
    std::vector < float > VTop = { 0, 1, 0};
    std::vector < float > VRgt = { 1, 0, 0};
    Direction_cls VDir(VTgt, VTop, VRgt);
    SetDirectionView(VDir);
    float offset[3] = {0, 0, 1};
    ViewAlignAxis(offset);
}

void CLS::
OnBottom(wxComEvt& event){
    std::vector < float > VTgt = { 0, 0, 1};
    std::vector < float > VTop = { 0,-1, 0};
    std::vector < float > VRgt = { 1, 0, 0};
    Direction_cls VDir(VTgt, VTop, VRgt);
    SetDirectionView(VDir);
    float offset[3] = {0, 0,-1};
    ViewAlignAxis(offset);
}

void CLS::
OnTogglePerspective(wxComEvt& event){
    int camType = mCWideCameraType.GetBodyINT();
    if (camType == _WC_PERSPECTIVE)
	mCWideCameraType.SetBodyFromData((long long)1);
    if (camType == _WC_ORTHOGONAL)
	mCWideCameraType.SetBodyFromData((long long)0);
    mpCGLCanvas->SetCameraInfo();
    UpdatePanels("ALL");
}

void CLS::
OnEscape(wxComEvt& event){
    mbSnapX = FALSE;
    mbSnapY = FALSE;
    mbSnapZ = FALSE;
    mpCGLCanvas->Refresh();
}

void CLS::
OnPivotOrigin(wxComEvt& event){
    std::vector < float > VPos = {0, 0, 0};
    mCstrPivotObject.SetBodyFromData("None");
    mCPivotPos.SetBodyFromData(VPos);
    mpCGLCanvas->SetCameraInfo();
    UpdatePanels("ALL");
}

void CLS::
OnPivotActive(wxComEvt& event){
    SceneObj_cls* pCObj = GetPCSceneObjCtrl()->mpCActiveObject;
    if (pCObj == NULL) return;

    if (mCstrPivotObject.GetBodySTR().IsSameAs(pCObj->GetStrName()) == FALSE)
	mCstrPivotObject.SetBodyFromData("None");
    std::vector < double > VPosd = pCObj->GetPositionGlobal(GetPCTimeCtrl()->GetCurrentNT());
    std::vector < float > VPos(3);
    LOOP_XYZ VPos[xyz] = VPosd[xyz];
    mCPivotPos.SetBodyFromData(VPos);
    mpCGLCanvas->SetCameraInfo();
    UpdatePanels("ALL");
}

void CLS::
OnPivotViewCenter(wxComEvt& event){
    mpCGLCanvas->mCAutoPivot = GetAutoPivotPos(mpCGLCanvas->mCCameraBase);
    std::vector < float > VPos(3);
    LOOP_XYZ VPos[xyz] = mpCGLCanvas->mCAutoPivot.mPos[xyz];
    mCPivotPos.SetBodyFromData(VPos);
    mpCGLCanvas->SetCameraInfo();
    UpdatePanels("ALL");
}

void CLS::
OnPivotFixToActive(wxComEvt& event){
    SceneObj_cls* pCObj = GetPCSceneObjCtrl()->mpCActiveObject;
    if (pCObj == NULL) return;

    mCstrPivotObject.SetBodyFromData(pCObj->GetStrName());
    std::vector < double > VPosd = pCObj->GetPositionGlobal(GetPCTimeCtrl()->GetCurrentNT());
    std::vector < float > VPos(3);
    LOOP_XYZ VPos[xyz] = VPosd[xyz];
    mCPivotPos.SetBodyFromData(VPos);
    mpCGLCanvas->SetCameraInfo();
    UpdatePanels("ALL");
}
    
void CLS::
OnPaint(wxPaintEvent &event){
    mpCGLCanvas->Refresh(TRUE);
    //mpCGLCanvas->Update();
    mpCPanelBar->Refresh();
}

/*
void CLS::
OnKeyDown(wxKeyEvent& event){
    if (GetPCShortcut()->ProcShortcutKey(event, this) == FALSE)
	event.Skip();
}
*/

void CLS::
SyncronizeParam(SceneObj_cls *pCObj, wxString strParamGroup, 
		ConfItemFLOATARRAY_cls &CConf){
    double newValue[3];
    LOOP_XYZ newValue[xyz] = CConf.GetBodyFLOATARRAY()[xyz];
    pCObj->SetParam3Command(strParamGroup, newValue);
}

void CLS::
SyncronizeState(){
    mpCBtnDisplayData->SetStatus(mCbDisplayData.GetBodyBOOL());
    mpCBtnDisplayGrid->SetStatus(mCbDisplayGrid.GetBodyBOOL());
    mpCBtnDisplayGuide->SetStatus(mCbDisplayGuideObjects.GetBodyBOOL());
    mpCBtnDisplayLight->SetStatus(mCbDisplayLightCam.GetBodyBOOL());
    mpCBtnDisplayLoupe->SetStatus(mCbDisplayLoupe.GetBodyBOOL());
    mpCBtnDisplayPivot->SetStatus(mCbDisplayPivot.GetBodyBOOL());
    mpCBtnNavi->SetStatus(mCbDisplayNavigator.GetBodyBOOL());
    mpCNaviMode->SetLabel(GetPCStringProvider()->GetArrayString("COORDINATE")[mCNavigatorCoord.GetBodyINT()]);
    if (mCbActive.GetBodyBOOL() == TRUE){
	if (IsActive() == FALSE) 
	    SetToActiveGLView();
    }
}

void CLS::
SyncronizeObjToPanel(){
    SceneObj_cls* pCObj = GetPCSceneObjCtrl()->mpCActiveObject;
    if (pCObj == NULL) return;

    SyncronizeParam(pCObj, "Position", mCObjectPos);
    SyncronizeParam(pCObj, "RotationEuler", mCObjectRot);
    SyncronizeParam(pCObj, "Scale", mCObjectScale);
}

bool CLS::
IsActive(){
    return (GetPCMain()->mActiveGLViewID == GetId());
}

bool CLS::
IsInnertiaExist(){
    if (mpCGLCanvas->mbInertia == TRUE){
	if (mpCGLCanvas->ProcInertia() == TRUE){
	    mpCGLCanvas->mbRedrawQueue = TRUE;
	    mpCGLCanvas->Refresh();
	    mpCNumPanel->UpdateValues();
	}
	return TRUE;
    }
    return FALSE;
}

void CLS::
UpdateStatus(){
    if (GetPCMain()->mActiveGLViewID != GetId() &&
	mpCCheckActive->GetValue() == TRUE)
	mpCCheckActive->SetValue(FALSE);
}

void CLS::
UpdatePanels(const wxString& strPanelTag){
    if (strPanelTag.IsSameAs("IDLE")){
	if (mpCGLCanvas->ProcInertia() == TRUE){
	    printf("UpdateByIDLE. Not so good. Try another method if able.\n");
	    fflush(stdout);
	    mpCGLCanvas->RefreshEX();
	    mpCNumPanel->UpdateValues();
	}
    }

    if (strPanelTag.IsSameAs(GetName()) ||
	strPanelTag.IsSameAs("ALL")){
	UpdateStatus();
	mpCGLCanvas->mbRedrawQueue = TRUE;
	mpCGLCanvas->Refresh();
	SetActiveObjectInfo();
	mpCNumPanel->UpdateValues();
    }
}

void CLS::
Serialize(wxString& strOut){
    mCbActive.SetBodyFromData((long long)IsActive());
    ConfListContainer_cls::Serialize(strOut);
}

void CLS::
ReadStrLine(std::wistream &istream, wxString strFirstItem, wxString strLine){
    if (ConfListContainer_cls::ReadStrLine(istream, strFirstItem, strLine) == FALSE)
	return;
    
    HideAndShowNumPanel();
    mpCNumPanel->SyncStateToData();
    mpCNumPanel->LayoutNumPanels();
    SyncronizeState();
}
