// -*- c -*-
// "clsView3D.cpp"

#ifndef _VIEW3D_H_
#define _VIEW3D_H_

class GLCanvas_cls;
class GLNumericalPanel_cls;
class wxGLContext;

#include "../COMMON/clsGetPC.h"
#include "../CONFITEM/clsConfListContainer.h"
#include "../INPUTMETHOD/clsSelectorPopup.h"
#include "../MYGL/clsPosition.h"
#include "../WIDGETCTRL/EX/wxPanelEX.h"

#include "../COMMON/CommonDefinitionsWX.h"

#define _NAVI_TRANSLATE 0
#define _NAVI_ROTATION  1
#define _NAVI_SCALE     2


class BitmapPanel_cls;
class Camera_cls;
class GLAttribute_cls;
class ParamGroup_cls;
class SceneObj_cls;
class TextButton_cls;

class View3D_cls : public wxPanelEX, public ConfListContainer_cls, public GetPC_cls {
 public:
    View3D_cls(wxWindow *pCParent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDP, const wxSize &size=wxDS, long style=wxTAB_TRAVERSAL);
    ~View3D_cls();
    
    ConfItemBOOL_cls mCbNumPanelShown;
    ConfItemSTRINGARRAY_cls mCClosedItem;
    ConfItemBOOL_cls mCbFollow, mCbLockToCamera;
    ConfItemFLOATARRAY_cls mCViewPos;
    ConfItemFLOATARRAY_cls mCViewDirTgt;
    ConfItemFLOATARRAY_cls mCViewDirTop;
    ConfItemFLOATARRAY_cls mCViewDirRgt;
    ConfItemFLOATARRAY_cls mCViewEuler;
    ConfItemFLOAT_cls mCViewAngleL;
    ConfItemFLOAT_cls mCSizeOrthoL;
    ConfItemSTR_cls mCstrPivotObject;
    ConfItemFLOATARRAY_cls mCPivotPos;
    ConfItemUINT_cls mCBufferSizeIndex;
    ConfItemUINT_cls mC1stBufferSizeIndex;
    ConfItemUINT_cls mCWideCameraType;
    ConfItemINT_cls mCLineWidth;
    ConfItemBOOL_cls mCbDisplayGrid;
    ConfItemBOOL_cls mCbDisplayGuideObjects, mCbDisplayLightCam;
    ConfItemBOOL_cls mCbDisplayLoupe, mCbDisplayPivot;
    ConfItemBOOL_cls mCbDisplayNavigator;
    ConfItemBOOL_cls mCbDisplayData;
    ConfItemINT_cls mCNavigatorCoord;
    ConfItemBOOL_cls mCbActive;
    
    ConfItemSTR_cls mCstrActiveObject, mCstrCamera;
    ConfItemFLOATARRAY_cls mCObjectPos;
    ConfItemFLOATARRAY_cls mCObjectRot;
    ConfItemFLOATARRAY_cls mCObjectScale;

    void SetToDefaultParam();
    
    GLCanvas_cls *mpCGLCanvas;
    GLNumericalPanel_cls *mpCNumPanel;
    GLAttribute_cls *mpCGLAttribute;
    wxPanel *mpCDummyPanel;
    wxCheckBox *mpCCheckActive;
    BitmapPanel_cls *mpCBtnNavi, *mpCBtnDisplayData;
    BitmapPanel_cls *mpCBtnDisplayGrid, *mpCBtnDisplayGuide;
    BitmapPanel_cls *mpCBtnDisplayLight, *mpCBtnDisplayLoupe;
    BitmapPanel_cls *mpCBtnDisplayPivot;
    wxStaticText *mpCNaviMode;
    TextButton_cls *mpCTextMenuView, *mpCTextMenuSelect;
    TextButton_cls *mpCTextMenuCamera, *mpCTextMenuNavi;

    SelectorPopup_cls mCSelector;
    
    bool mbGLSupported;
    bool mbSnapX, mbSnapY, mbSnapZ;
    int  mNavigatorMode;

    bool IsSnapNavi();
    bool IsUseCamera();
    bool IsStereogram();
    void GetSnapAxis(double vecX[3], double vecY[3], double vecZ[3]);
    Camera_cls *GetPCCamera();
    //Direction_cls mCDirDummy;
    
    void SetToActiveGLView();
    void SetPositionView(Position_cls CPos);
    void SetDirectionView(Direction_cls CDir);
    void SetPositionPivot(Position_cls CPos);
    void SetNullObjectInfo();
    void SetActiveObjectInfo();
    //bool ZoomSizeOrtho(float wheelRotation);
    int GetBufferSize();
    int GetBufferSize1st();
    Position_cls GetPositionView();
    Position_cls GetPositionPivot();
    Position_cls GetAutoPivotPos(PositionAndDirection_cls CCam);
    Direction_cls GetDirectionView();

    void HideAndShowNumPanel();
    void OnHideAndShowNumPanel(wxComEvt& event);
    void OnShowPanelManage  (wxComEvt& event);
    void OnMenuView         (wxComEvt& event);
    void OnMenuSelect       (wxComEvt& event);
    void OnMenuCamera       (wxComEvt& event);
    void OnMenuNavi         (wxComEvt& event);
    void OnNaviCoordMode    (wxComEvt& event);
    void OnDisplayNavi      (wxComEvt& event);
    void OnDisplayData      (wxComEvt& event);
    void OnDisplayGrid      (wxComEvt& event);
    void OnDisplayGuide     (wxComEvt& event);
    void OnDisplayLight     (wxComEvt& event);
    void OnDisplayLoupe     (wxComEvt& event);
    void OnDisplayPivot     (wxComEvt& event);
    void OnPaint(wxPaintEvent& event);
    void OnKeyDown(wxKeyEvent& event);
    void OnDeselect         (wxComEvt& event);
    void OnSetPos           (wxComEvt& event);
    void OnSetPosRot        (wxComEvt& event);
    void OnSetRot           (wxComEvt& event);
    void OnLookAtPivot      (wxComEvt& event);
    void OnLookAtTarget     (wxComEvt& event);
    void OnDropDown         (wxComEvt& event);
    void OnFollow           (wxComEvt& event);
    void OnLockToCamera     (wxComEvt& event);
    void OnNaviX            (wxComEvt& event);
    void OnNaviY            (wxComEvt& event);
    void OnNaviZ            (wxComEvt& event);
    void OnNaviXLock        (wxComEvt& event);
    void OnNaviYLock        (wxComEvt& event);
    void OnNaviZLock        (wxComEvt& event);
    void OnNaviTranslate    (wxComEvt& event);
    void OnNaviRotate       (wxComEvt& event);
    void OnNaviScale        (wxComEvt& event);
    void ViewAlignAxis      (float offset[3]);
    void OnFront            (wxComEvt& event);
    void OnBack             (wxComEvt& event);
    void OnRight            (wxComEvt& event);
    void OnLeft             (wxComEvt& event);
    void OnTop              (wxComEvt& event);
    void OnBottom           (wxComEvt& event);
    void OnTogglePerspective(wxComEvt& event);
    void OnEscape           (wxComEvt& event);
    void OnPivotOrigin      (wxComEvt& event);
    void OnPivotActive      (wxComEvt& event);
    void OnPivotViewCenter  (wxComEvt& event);
    void OnPivotFixToActive (wxComEvt& event);
    void OnPopMenu          (wxComEvt& event);
  
    void SyncronizeState();
    void SyncronizeParam(SceneObj_cls *pCObj, wxString strParamGroup,
			 ConfItemFLOATARRAY_cls &CConf);
    void SyncronizeObjToPanel();

    bool IsActive();
    bool IsInnertiaExist();
    void UpdateStatus();
    void UpdatePanels(const wxString& strPanelTag);

    void Serialize(wxString& strOut);
    void ReadStrLine(std::wistream &istream, wxString strFirstItem, wxString strLine);
    
    DECLARE_EVENT_TABLE()
};

#endif
