// -*- c -*-
// "clsVBOBaseObject.cpp"
// (setq c-basic-offset 4)

#ifndef _VBO_BASE_OBJECT_H_
#define _VBO_BASE_OBJECT_H_

#define _UV_MAPPING_X 0
#define _UV_MAPPING_Y 1
#define _UV_MAPPING_Z 2
#define _UV_MAPPING_UV 3
#define _MAX_MAPPING_TYPE 5

#define _VBO_OBJECT           0
#define _VBO_SHADOW_VOLUME    1
#define _VBO_SHADOW_VOLUME_HF 2

// 1024*1024 }bNX̉\
// Triangle `̂ 3̔{łȂƂ܂
#define _VBO_INDICE_UNIT (1024 * 128 * 3)

#include "../COMMON/CommonDefinitionsForH.h"

#include <wx/wx.h>

#include <vector>

#ifndef TRUE
#define TRUE true
#define FALSE false
#endif

class VBOBaseObject_cls{
public:
    VBOBaseObject_cls();
    ~VBOBaseObject_cls();

    unsigned int mVBOVertex;
    unsigned int mVBONormal;
    unsigned int mVBOUV[5];
    
    std::vector < unsigned int > mVVBOIndiceTriangle;
    std::vector < unsigned int > mVVBOIndiceAdjacent;

    bool mbUseNormal;

    int mTotalIndiceTriangle;
    int mTotalIndiceAdjacent;
    
    std::vector < unsigned int > mVIndiceTriangle;
    std::vector < unsigned int > mVIndiceAdjacent;
    
    void Clear();
    void DeleteVBOIfGenerated(unsigned int &VBO);
    void DeleteVVBOIfGenerated(std::vector < unsigned int > &VVBO);
    void GenBuffersVertex(int UVNumber);
    int GetNumVBOTriangle();
    int GetNumVBOAdjacent();
    void GenBuffersIndice();

    void MakeVBO(float (*pVertex)[3], float (*pNormal)[3], float (*pUValongX)[2], float (*pUValongY)[2], float (*pUValongZ)[2], float (*pUVUV)[2], int totalVertex);
    unsigned int* GetPNewTriangle();
    unsigned int* GetPNewAdjucent();
    void MakeVBOIndicesTriangle(unsigned int *pIndiceTriangle);
    void MakeVBOIndicesAdjacent(unsigned int *pIndiceAdjucent);

    void PrepareClientState(bool bTexture, int mapType, bool bShadow,
			    int VBOIndex = 0);
    void Draw(int objectState, int mapType, bool bPrepareClientState = TRUE);
    void DrawFast();

    static void FinishClientState();
};

#endif
