// -*- c -*-
// "clsVBOCameraBox.h"
// (setq c-basic-offset 4)

#include "clsVBOCameraBox.h"

#include "../COMMON/CommonDefinitionsGL.h"

#ifdef WIN32
extern PFNGLBINDBUFFERPROC glBindBuffer;
extern PFNGLBUFFERDATAPROC glBufferData;
#endif

#define CLS VBOCameraBox_cls

void CLS::
Initialize(){
    SetGeometry(&mCObject);
}

void CLS::
Draw(){
    mCObject.Draw();
}

void CLS::
SetGeometry(VBOWireObject_cls *pCTgt){

    pCTgt->Clear();
    pCTgt->GenBuffers();

    int line = 12;
    int totalVertex = 8;

    pCTgt->mTotalIndiceLine = line * 2;

    float (*pVertex)[3] = new float [totalVertex][3];

    unsigned int *pIndiceLine = new unsigned int [pCTgt->mTotalIndiceLine];

    Set3f(pVertex[0], -1, -1, -1);
    Set3f(pVertex[1], +1, -1, -1);
    Set3f(pVertex[2], +1, +1, -1);
    Set3f(pVertex[3], -1, +1, -1);
    Set3f(pVertex[4], -1, -1, +1);
    Set3f(pVertex[5], +1, -1, +1);
    Set3f(pVertex[6], +1, +1, +1);
    Set3f(pVertex[7], -1, +1, +1);

    SetLine(pIndiceLine,  0, 0, 1);
    SetLine(pIndiceLine,  1, 1, 2);
    SetLine(pIndiceLine,  2, 2, 3);
    SetLine(pIndiceLine,  3, 3, 0);
    SetLine(pIndiceLine,  4, 0, 4);
    SetLine(pIndiceLine,  5, 1, 5);
    SetLine(pIndiceLine,  6, 2, 6);
    SetLine(pIndiceLine,  7, 3, 7);
    SetLine(pIndiceLine,  8, 4, 5);
    SetLine(pIndiceLine,  9, 5, 6);
    SetLine(pIndiceLine, 10, 6, 7);
    SetLine(pIndiceLine, 11, 7, 4);

    pCTgt->MakeVBO(pVertex, totalVertex);
    
    glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, pCTgt->mVBOIndicesLine);
    glBufferData(GL_ELEMENT_ARRAY_BUFFER, pCTgt->mTotalIndiceLine * sizeof(unsigned int), pIndiceLine, GL_STATIC_DRAW_ARB);
    
    delete [] pVertex;
    delete [] pIndiceLine;

    glBindBuffer(GL_ARRAY_BUFFER, 0);
    glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);
}

VBOCameraBox_cls *GpCVBOCameraBox = NULL;
