// -*- c -*-
// "clsVBOEmpty.h"
// (setq c-basic-offset 4)

#include "clsVBOEmpty.h"

#include "../COMMON/CommonDefinitionsGL.h"

#ifdef WIN32
extern PFNGLBINDBUFFERPROC glBindBuffer;
extern PFNGLBUFFERDATAPROC glBufferData;
#endif

#define CLS VBOEmpty_cls

void CLS::
Initialize(){
    SetGeometry(&mCObject);
}

void CLS::
Draw(){
    mCObject.Draw();
}

void CLS::
SetGeometry(VBOWireObject_cls *pCTgt){

    pCTgt->Clear();
    pCTgt->GenBuffers();

    int line = 3;
    int totalVertex = 6;

    pCTgt->mTotalIndiceLine = line * 2;

    float (*pVertex)[3] = new float [totalVertex][3];

    unsigned int *pIndiceLine = new unsigned int [pCTgt->mTotalIndiceLine];

    Set3f(pVertex[0], -1, 0, 0);
    Set3f(pVertex[1], +1, 0, 0);
    Set3f(pVertex[2], 0, -1, 0);
    Set3f(pVertex[3], 0, +1, 0);
    Set3f(pVertex[4], 0, 0, -1);
    Set3f(pVertex[5], 0, 0, +1);
    for (int i = 0; i < pCTgt->mTotalIndiceLine; i++)
	pIndiceLine[i] = i;

    pCTgt->MakeVBO(pVertex, totalVertex);

    glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, pCTgt->mVBOIndicesLine);
    glBufferData(GL_ELEMENT_ARRAY_BUFFER, pCTgt->mTotalIndiceLine * sizeof(unsigned int), pIndiceLine, GL_STATIC_DRAW_ARB);

    delete [] pVertex;
    delete [] pIndiceLine;

    glBindBuffer(GL_ARRAY_BUFFER, 0);
    glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);
}

VBOEmpty_cls *GpCVBOEmpty = NULL;
