// -*- c -*-
// "clsVBOSphere.cpp"
// (setq c-basic-offset 4)

#ifndef _VBO_SPHERE_H_
#define _VBO_SPHERE_H_

#include "clsVBOCommon.h"
#include "clsVBOBaseObject.h"

#include "../COMMON/clsVectorMath.h"

class ArrayAndIndex_cls;
class VBOBaseObject_cls;

class VBOSphere_cls : public VBOCommon_cls, public VectorMath_cls {
public:
    VBOSphere_cls();

    VBOBaseObject_cls mCObject[5];//, mCShadowVolume[5];
    
    void Initialize();
    void Draw(int objectState, int mapType, int depth);
    void DrawFast(int depth); // 炦(PrepareClientStateς)

    // ---

    float mVerexIcosahedron[12][3];
    int   mFaceIcosahedron[20][3];

    float mDummytex2D[2];

    void ChangeCoordinate3Dto2D(float vec3D[3], float vec2D[2]);
    void AdjustVec2DOverBoundary(float vector[2], float vectormem[2]);

    int GetTotalVertexCandid(int depth);
    int GetTotalTriangle(int depth);

    int GetVertex(int currentVertex, 
		  float (*pVertex)[3], float vertex[3],
		  float (*pUVUV)[2], float texCoord[2]);
    void DivideTriangle(float (*pVertex)[3], float (*pNormal)[3], 
			float (*pUValongX)[2], float (*pUValongY)[2], 
			float (*pUValongZ)[2], float (*pUVUV)[2],
			unsigned int *pIndiceTriangle, 
			int depth, int &currentVertex, int &currentFace,
			int vertex1, int vertex2, int vertex3);
    void SetTriangle(unsigned int *pIndiceTriangle, int &currentFace,
		     int vertex1, int vertex2, int vertex3);

    int SearchSameVertex(int ibase_, int iComp, ArrayAndIndex_cls* pCIdxAndZ,
			 float (*pVertex)[3]);
    int SearchSameVertex(int ibase_, int iComp, ArrayAndIndex_cls* pCIdxAndZ,
			 float (*pVertex)[3],
			 float (*pUValongX)[2], float (*pUValongY)[2], 
			 float (*pUValongZ)[2], float (*pUVUV)[2]);
    int RemoveDouble(unsigned int *pIndiceTriangle, 
		     int &numIndicesTriangle, int &numVertex, 
		     float (*pVertex)[3], float (*pNormal)[3], 
		     float (*pUValongX)[2], float (*pUValongY)[2], 
		     float (*pUValongZ)[2], float (*pUVUV)[2]);

    
    int ConstructTriangles(float (*pVertex)[3], float (*pNormal)[3], 
			    float (*pUValongX)[2], float (*pUValongY)[2], 
			    float (*pUValongZ)[2], float (*pUVUV)[2],
			    unsigned int *pIndiceTriangle, int depth);
    
    void SetGeometry(VBOBaseObject_cls *pCTgt, int depth);
    //void SetShadowGeometry(VBOBaseObject_cls *pCTgt, int depth);
};

#endif

