// -*- c -*-
// "clsVBOWireObject.h"
// (setq c-basic-offset 4)

#include "clsVBOWireObject.h"

//#include "../COMMON/CommonDefinitions.h"
#include "../COMMON/CommonDefinitionsGL.h"

#ifdef WIN32
extern PFNGLDELETEBUFFERSPROC glDeleteBuffers;
extern PFNGLGENBUFFERSPROC glGenBuffers;
extern PFNGLBINDBUFFERPROC glBindBuffer;
extern PFNGLBUFFERDATAPROC glBufferData;
#endif

#define CLS VBOWireObject_cls

CLS::
VBOWireObject_cls(){
    mVBOVertex = 0;
    mVBOIndicesLine = 0;
}

CLS::
~VBOWireObject_cls(){
    Clear();
}

void CLS::
Clear(){
    DeleteVBOIfGenerated(mVBOVertex);
    DeleteVBOIfGenerated(mVBOIndicesLine);
}

void CLS::
DeleteVBOIfGenerated(unsigned int &VBO){
    if (VBO != 0){
	glDeleteBuffers(1, &VBO);
	VBO = 0;
    }
}

void CLS::
GenBuffers(){
    glGenBuffers(1, &mVBOVertex); 
    glGenBuffers(1, &mVBOIndicesLine);
}

void CLS::
MakeVBO(float (*pVertex)[3], int totalVertex){
    glBindBuffer(GL_ARRAY_BUFFER, mVBOVertex);
    glBufferData(GL_ARRAY_BUFFER, 3*totalVertex * sizeof(float), pVertex, GL_STATIC_DRAW);
    
}

void CLS::
PrepareClientState(){
    
    glDisableClientState(GL_COLOR_ARRAY);
    glDisableClientState(GL_TEXTURE_COORD_ARRAY);
    glDisableClientState(GL_NORMAL_ARRAY);
    
    glEnableClientState(GL_VERTEX_ARRAY);

    glBindBuffer(GL_ARRAY_BUFFER, mVBOVertex);
    glVertexPointer(3, GL_FLOAT, 0, 0);

    glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, mVBOIndicesLine);
}

void CLS::
Draw(bool bPrepareClientState){
    if (bPrepareClientState == TRUE) PrepareClientState();
    glDrawElements(GL_LINES, mTotalIndiceLine,
		   GL_UNSIGNED_INT, NULL);
}

void CLS::
FinishClientState(){
    //glDisableClientState(GL_COLOR_ARRAY);
    //glDisableClientState(GL_TEXTURE_COORD_ARRAY);
    //glDisableClientState(GL_VERTEX_ARRAY);
    //glDisableClientState(GL_NORMAL_ARRAY);

    glBindBuffer(GL_ARRAY_BUFFER, 0);
    glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);
}
