// -*- c -*-
// "clsShaderItem.cpp"

#ifndef _SHADER_ITEM_H_
#define _SHADER_ITEM_H_

#include "../FILEIO/clsAsciiReader.h"

#include "../COMMON/CommonDefinitionsGL.h"

#include <wx/wx.h>

#include <vector>

#define _GLSL_SHADER  0
#define _GLSL_PROGRAM 1

class ShaderStatusVolumeCoord_cls {
public:
    ShaderStatusVolumeCoord_cls();
    void Clear();
    void Update();

    bool mbUse, mbUseCompiled;
    int mType, mTypeCompiled;
    float mRMin, mRMinCompiled;
    float mRMax, mRMaxCompiled;
    float mCustom0, mCustom0Compiled;
    float mCustom1, mCustom1Compiled;
    float mCustom2, mCustom2Compiled;
    wxString mstrCustom, mstrCustomCompiled;
};

class ShaderStatusVolumeMask_cls {
 public:
    ShaderStatusVolumeMask_cls();
    void Clear();
    void Update();

    bool mbUse, mbUseCompiled;
    int mMaskType, mMaskTypeCompiled;
    float mXMin, mXMinCompiled;
    float mYMin, mYMinCompiled;
    float mZMin, mZMinCompiled;
    float mXMax, mXMaxCompiled;
    float mYMax, mYMaxCompiled;
    float mZMax, mZMaxCompiled;
};

class ShaderItem_cls : AsciiReader_cls {
 public:
    ShaderItem_cls(wxString strName);

    wxString mstrShaderName;
    wxString mstrShaderPathBase;
    //int mShaderID;
    wxString mstrVertSrc, mstrGeomSrc, mstrFragSrc;
    wxString mstrVert, mstrGeom, mstrFrag;

    GLuint mProgram;
    bool mbShaderAvailable;
    bool mbCompileTried;
    
    ShaderStatusVolumeCoord_cls mCStatusVolumeCoord;
    ShaderStatusVolumeMask_cls mCStatusVolumeMask;

    std::vector < wxString > mVstrUniform;
    std::vector < int > mVIdUniform;

    std::vector < wxString > mVstrAttrib;
    
    bool mbDissolve;
    bool mbFog;
    int mIdEnsembleParamA, mIdEnsembleParamB, mIdEnsembleParamC;
    int mIdFogMode, mIdProjInv11, mIdProjInv15;
    
    void Clear();
    void SetDefault();
    void SetShaderPath(wxString strPathBase);
    
    int GetGLGeometryConstant(wxString strWord);
    void ReadGeometryShaderStrForParameter(wxString strLine,
					   int &geometryInput,
					   int &geometryOutput,
					   long &geometryVertices);
    
    bool ReadShaderString(GLuint& shader, wxString& strShader);
    void MakeShader();

    void AppendLog(int shader_or_program, wxString strTag, int type);
};

#endif
