// (setq c-basic-offset 4)
// "clsColorCurveEditor.cpp"

#ifndef _COLOR_CURVE_EDITOR_H_
#define _COLOR_CURVE_EDITOR_H_

#include "clsEditorBase.h"

#include "../CONFITEM/clsConfListContainer.h"
#include "../FILEIO/clsParser.h"
#include "../INPUTMETHOD/clsSelectorPopup.h"
#include "../TIMELINE/clsDefaultKey.h"
#include "../WIDGETCTRL/EX/wxPanelEX.h"

class BitmapPanel_cls;
class GraphColorCurve_cls;
class IconSelector_cls;

class ColorCurveEditor_cls : public DefaultKey_cls, public EditorBase_cls, public Parser_cls {
 public:
    ColorCurveEditor_cls(wxWindow *pCParent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDP, const wxSize &size=wxDS, long style=wxTAB_TRAVERSAL);

    ConfItemINT_cls mCColorCurveMode;
    ConfItemBOOL_cls mCbTemplateAlpha;

    ConfItemFLOAT_cls mCXRange[2];

    void SetToDefaultParam();
    
    SelectorPopup_cls mCSelector;

    wxStaticText *mpCTicsMode;
    wxButton *mpCBtnRescale;
    IconSelector_cls *mpCIconSelectorAlpha;
    GraphColorCurve_cls *mpCColorCurve;
    
    BitmapPanel_cls *mpCBtnNumPanelHide;
    //wxButton *mpCBtnSingle[4];
    BitmapPanel_cls *mpCBtnColor;
    wxButton *mpCBtnFlipColor, *mpCBtnSwapRGB;
    TextButton_cls *mpCTextMenuEdit;

    void SyncronizeParamToPanelXRange();
    void SetColorCurveTemplate(int index);
    void ProcAfterMath(const wxString& strCommand, wxString strTag, bool bForce = FALSE);

    void HideAndShowNumPanel();
    void OnHideAndShowNumPanel(wxComEvt& event);
    void OnMenuView (wxComEvt& event);
    void OnMenuKey  (wxComEvt& event);
    void OnMenuEdit (wxComEvt& event);
    void OnMenuZoom (wxComEvt& event);
    void OnDropDown (wxComEvt& event);
    void OnRescale  (wxComEvt& event);
    void OnTicsMode (wxComEvt& event);
    void OnPopMenu  (wxComEvt& event);
    //void OnDeleteSelectedKey(wxComEvt& event);
    void OnSelector (wxComEvt& event);
    void OnKeyColor (wxComEvt& event);
    void OnFlipColor(wxComEvt& event);
    void OnSwapRGB  (wxComEvt& event);
    void OnCopyToClipboard   (wxComEvt& event);
    void OnPasteFromClipboard(wxComEvt& event);
    void OnCopyColor(wxComEvt& event);
    void OnPasteColor(wxComEvt& event);

    void OnBtnColorRight(wxMouseEvent& event);
    
    void OnCmbDefaultKey     (wxComEvt &event); 
    void OnButtonDefaultKey  (wxComEvt &event);

    void UpdateColorBar();
    void UpdateColorButton();
    void UpdatePanels(const wxString& strPanelTag, bool bUpdateBar = FALSE);

    void Serialize(wxString& strOut);
    void ReadStrLine(std::wistream &istream, wxString strFirstItem, wxString strLine);
private:
    DECLARE_EVENT_TABLE();
};

#endif
