// (setq c-basic-offset 4)
// "clsEditorBase.cpp"

#ifndef _EDITOR_BASE_H_
#define _EDITOR_BASE_H_

#include "../TIMELINE/clsTimeline.h"

#include "../CONFITEM/clsConfItem.h"

#include <wx/wx.h>

class BitmapPanel_cls;
class GraphNumericalPanel_cls;
class GraphEditorTics_cls;
class GraphNaviCurrent_cls;
class GraphPanel_cls;
class ParamGroup_cls;
class Parameter_cls;
class TextButton_cls;
class TimelineAA_cls;

class EditorBase_cls : public Timeline_cls{
 public:
    EditorBase_cls(wxString strClassName, wxWindow *pCParent);

    void SetToDefaultParamBase();

    int mPastUpdateTimeStamp;
    wxStopWatch mCStopWatch;

    wxString mstrClassName;
    
    ConfItemSTR_cls mCstrLinkedParamGroup;
    ConfItemFLOAT_cls mCCurrent[4];
    ConfItemFLOAT_cls mCActiveKeyXnorm, mCActiveKeyValue;
    ConfItemFLOAT_cls mCActiveKeyEaseFactor;
    ConfItemUINT_cls mCActiveKeyType;
    ConfItemINT_cls mCActiveParamIndex;
    ConfItemFLOAT_cls mCNaviCurrent;
    ConfItemBOOL_cls mCbPinned;
    ConfItemBOOL_cls mCbNumPanelShown;

    ConfItemFLOATARRAY_cls mCViewY;
    ConfItemSTRINGARRAY_cls mCClosedItem;

    GraphNumericalPanel_cls *mpCNumPanel;
    TextButton_cls *mpCTextMenuView, *mpCTextMenuKey;
    TimelineAA_cls *mpCTimelineAA;
    wxStaticText *mpCLinkedParamGroup;
    BitmapPanel_cls *mpCBtnLinked;
    
    GraphEditorTics_cls *mpCTicsX, *mpCTicsY;
    GraphNaviCurrent_cls *mpCNaviCurrent;
    GraphPanel_cls *mpCGraphPanel;

    wxButton *mpCBtnAddKey, *mpCBtnRemKey;
    wxButton *mpCBtnLft, *mpCBtnRgt;

    wxStaticText *mpCLockGroup[4];
    BitmapPanel_cls *mpCBtnLock[4];
    
    ParamGroup_cls* mpCParamGroupUsed;
    ParamGroup_cls* GetPCParamGroup();
    Parameter_cls* GetPCParameterActive();

    double GetNaviCurrent();

    void MoveNextKey(int direction);
    
    bool IsUpdateTooFast();
    void UpdateNumPanels();
    void UpdateGraphs();
    void UpdateLock();
    void DisableLock();

    void OnPinMode(wxCommandEvent& event);
    void OnLinked(wxCommandEvent& event);
    void OnLock(wxCommandEvent& event);
    void OnLR(wxCommandEvent& event);
    void OnAddKey(wxCommandEvent& event);
    void OnRemKey(wxCommandEvent& event);
    void OnDeleteSelectedKey(wxCommandEvent& event);
    void OnSize(wxSizeEvent& event);
    void OnKeyDown(wxKeyEvent& event);

    void SyncronizeParamToPanel(bool bUndoGroup = FALSE);
    void SyncronizeKeyToPanel();
    void SyncronizeTicsToGraph();

 private:
    DECLARE_EVENT_TABLE();
};

#endif
