// -*- c++ -*-
// "clsGraphColorCurve.h"

#include "clsGraphColorCurve.h"
#include "clsEditorBase.h"

#include "../TIMELINE/clsTimeCtrl.h"

#define CLS GraphColorCurve_cls

BEGIN_EVENT_TABLE(CLS, TimelineBase_cls)
EVT_PAINT       (CLS::OnPaint)
//EVT_MOUSE_EVENTS(CLS::OnMouse)
END_EVENT_TABLE()

CLS::
GraphColorCurve_cls(EditorBase_cls *pCParent) :
TimelineBase_cls(pCParent, _TL_GRAPH, wxSize(-1, 25)){
    mpCParent = pCParent;
    //mCIcon.CopyFromBitmap(ART("wxART_NAVISLIDER"));
}

void CLS::
UpdateDisplay(wxAutoBufferedPaintDC &dc){
    dc.SetBackground(wxBrush(wxColour(216,216,216), wxSOLID));
    dc.Clear();
    
    UpdateState();
    SetTLRegion(mAAMinNormalized, mAAMaxNormalized);
    
    DrawCurrentTime(dc, 0);

    int draggingX = 0;
    int sliderX = GetDevCoordFromN(mpCParent->mCNaviCurrent.GetBodyDOUBLE(), 0)-7, sliderY = 4;
    
    if (mSelected == _TL_SEL_SLIDER){
	sliderX = GetDevCoordFromN(mQuantizedTimeDragging, 0)-7;
	draggingX = sliderX; }

    for (int i = 0; i < 100; i++){
	double x0 = (double)i / 100;
	double x1 = (double)(i+1) / 100;
	int posX0 = GetDevCoordFromN(x0, 0);
	int posX1 = GetDevCoordFromN(x1, 0);
	dc.SetPen(wxColour(i*2, 255-i*2, 128));
	dc.SetBrush(wxColour(i*2, 255-i*2, 128));
	dc.DrawRectangle(posX0, 0, posX1-posX0, 24);
    }

    /*
    //dc.DrawIcon(mCIcon, sliderX, sliderY);
    //mRectSlider = wxRect(sliderX, sliderY, 15, 18);
    
    // bZ[W`
    int offset = 0;
    if (draggingX > mPanelWidth * 0.7) offset = -40;

    if (HasCapture() == TRUE){
	wxString Mes;
	Mes << mFrameDragging;
	dc.SetFont(*wxNORMAL_FONT);
	dc.SetTextForeground(*wxWHITE);
	dc.DrawText(Mes, draggingX + 15 + offset, 0);
    }
    */
}

/*
void CLS::
OnMouse(wxMouseEvent& event){
}
*/

void CLS::
OnPaint(wxPaintEvent& event){
    wxAutoBufferedPaintDC dc(this);
    UpdateDisplay(dc);
}


