// (setq c-basic-offset 4)
// "clsGraphEditor.cpp"

#ifndef _GRAPH_EDITOR_H_
#define _GRAPH_EDITOR_H_

#include "clsEditorBase.h"

#include "../CONFITEM/clsConfListContainer.h"
#include "../FILEIO/clsParser.h"
#include "../INPUTMETHOD/clsSelectorPopup.h"
#include "../TIMELINE/clsDefaultKey.h"
#include "../WIDGETCTRL/EX/wxPanelEX.h"

class BitmapPanel_cls;
class TextButton_cls;

class GraphEditor_cls : public DefaultKey_cls, public EditorBase_cls, public Parser_cls {
 public:
    GraphEditor_cls(wxWindow *pCParent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDP, const wxSize &size=wxDS, long style=wxTAB_TRAVERSAL);
    
    ConfItemBOOL_cls mCbZoomAuto;
    
    void SetToDefaultParam();

    SelectorPopup_cls mCSelector;

    wxStaticText *mpCTicsMode;
    
    BitmapPanel_cls *mpCBtnNumPanelHide;
    //wxButton *mpCBtnSingle[4];
    wxButton *mpCBtnZoomPlus, *mpCBtnZoomMinus, *mpCBtnZoomAuto;
    wxButton *mpCBtnRescale;
    TextButton_cls *mpCTextMenuChannel;
    
    wxCheckBox *mpCCheckSnap;

    void Rescale(bool bCallUpdate = TRUE);
    
    void ProcAfterMath(const wxString& strCommand, wxString strTag, bool bForce = FALSE);
    
    void HideAndShowNumPanel();
    void OnHideAndShowNumPanel(wxCommandEvent& event);
    void OnMenuView(wxCommandEvent& event);
    void OnMenuChannel(wxCommandEvent& event);
    void OnMenuKey(wxCommandEvent& event);
    void OnMenuExtrapolate(wxCommandEvent& event);
    void OnMenuZoom(wxCommandEvent& event);
    void OnDropDown(wxCommandEvent& event);
    void OnPopMenu(wxCommandEvent& event);
    void OnTicsMode(wxCommandEvent& event);
    void OnRescale(wxCommandEvent& event);
    void OnZoom(wxCommandEvent& event);
    void OnZoomAuto(wxCommandEvent& event);
    void OnCmbDefaultKey     (wxComEvt &event); 
    void OnButtonDefaultKey  (wxComEvt &event);

    void SyncronizeKeyToPanel();
    void SyncronizeTicsToGraph();
    void UpdateButtonsXYZ();
    void UpdatePanels(const wxString& strPanelTag, bool bUpdateBar = FALSE);

    void Serialize(wxString& strOut);
    void ReadStrLine(std::wistream &istream, wxString strFirstItem, wxString strLine);
private:
    DECLARE_EVENT_TABLE();
};

#endif
