// -*- c++ -*-
// "clsGraphEditoreTics.h"

#include "clsGraphNaviCurrent.h"
#include "clsEditorBase.h"

#include "../SCENEOBJ/DATAVIEWER/clsColorCurve.h"
#include "../TIMELINE/clsTimeCtrl.h"

#include "../WIDGETCTRL/WX/myArtProv.h"
#include "../WIDGETCTRL/WX/clsColorProvider.h"

#define CLS GraphNaviCurrent_cls

BEGIN_EVENT_TABLE(CLS, TimelineBase_cls)
EVT_PAINT       (CLS::OnPaint)
EVT_MOUSE_EVENTS(CLS::OnMouse)
END_EVENT_TABLE()

CLS::
GraphNaviCurrent_cls(EditorBase_cls *pCParent) :
TimelineBase_cls(pCParent, _TL_GRAPH, wxSize(-1, 23)), mCBitmapTextBuffer(96, 24), mCMemoryDCTextBuffer(mCBitmapTextBuffer) {
    mpCParent = pCParent;
    mCIcon.CopyFromBitmap(ART("wxART_NAVISLIDER"));
}

void CLS::
DrawStr(wxAutoBufferedPaintDC &dc, int pos, wxString strMes){
    wxCoord singleW, singleH, singleD;
    mCMemoryDCTextBuffer.GetTextExtent(strMes, &singleW, &singleH, &singleD);
    int offset = 0;
    if (pos > mPanelWidth * 0.7) offset = - 14 - singleW;
    dc.DrawText(strMes, pos + offset, 0);
}

void CLS::
UpdateDisplay(wxAutoBufferedPaintDC &dc){
    dc.SetBackground(wxBrush(wxColour(216,216,216), wxSOLID));
    dc.Clear();
    
    UpdateState();
    SetTLRegion(mAAMinNormalized, mAAMaxNormalized);
    
    if (mbForColorCurve == FALSE) DrawCurrentTime(dc, 0);

    int draggingX = 0;
    int sliderX = GetDevCoordFromN(mpCParent->mCNaviCurrent.GetBodyDOUBLE(), 0)-7, sliderY = 4;
    
    if (mSelected == _TL_SEL_SLIDER){
	sliderX = GetDevCoordFromN(mQuantizedTimeDragging, 0)-7;
	draggingX = sliderX; }
    
    dc.DrawIcon(mCIcon, sliderX, sliderY);
    mRectSlider = wxRect(sliderX, sliderY, 15, 18);

    int framePos = sliderX;
    int frameCurrent;
    if (mbForColorCurve == TRUE) 
	frameCurrent = floor(mpCParent->mCNaviCurrent.GetBodyDOUBLE() * _COLOR_CURVE_RESOLUTION + 0.5);
    else
	frameCurrent = floor(mpCParent->mCNaviCurrent.GetBodyDOUBLE() * GetPCTimeCtrl()->mCFrameMax.GetBodyINT());

    if (HasCapture() == TRUE){
	frameCurrent = mFrameDragging;
	framePos = draggingX;
	dc.SetTextForeground(*wxWHITE);
    }
    else
	dc.SetTextForeground(GetPCColorProvider()->GetColor("TextWeak"));
    
    wxString strMes;
    strMes << frameCurrent;

    dc.SetFont(*wxNORMAL_FONT);
    
    DrawStr(dc, framePos + 15, strMes);

    /*
    // bZ[W`
    int offset = 0;
    if (draggingX > mPanelWidth * 0.7) offset = -40;

    if (HasCapture() == TRUE){
	wxString Mes;
	Mes << mFrameDragging;
	dc.SetFont(*wxNORMAL_FONT);
	dc.SetTextForeground(*wxWHITE);
	dc.DrawText(Mes, draggingX + 15 + offset, 0);
    }
    */
}

void CLS::
OnMouse(wxMouseEvent& event){
    ProcMouseEventBase(event, 0);
    
    if (event.ButtonUp(wxMOUSE_BTN_LEFT)) ProcMouseRelease();
    
    event.Skip();
}

void CLS::
OnPaint(wxPaintEvent& event){
    wxAutoBufferedPaintDC dc(this);
    UpdateDisplay(dc);
}

void CLS::
ProcMouseRelease(){
    if (mSelected == _TL_SEL_SLIDER) {
	mpCParent->mCNaviCurrent.SetBodyFromData(mQuantizedTimeDragging);
	
    }
    ProcMouseReleaseBase();
    Refresh();
}
