// (setq c-basic-offset 4)
// "clsGraphNumericalPanel.cpp"

#ifndef _GRAPH_NUMERICAL_PANEL_
#define _GRAPH_NUMERICAL_PANEL_

#include "../WIDGETCTRL/clsWidgetCommon.h"
#include "../WIDGETCTRL/MULTIINPUT/clsMNumPainBase.h"
#include "../WIDGETCTRL/MULTIINPUT/clsHookCtrl.h"
#include "../WIDGETCTRL/WX/clsColorCurveProvider.h"

class EditorBase_cls;
class HideAndShowButton_cls;
class ParamGroup_cls;
class MultiInputPanel_cls;

class GraphNumericalPanel_cls : public MNumPainBase_cls, public HookItem_cls, public WidgetCommon_cls {
public:
    GraphNumericalPanel_cls(EditorBase_cls *pCParent, wxSize& size);
    
    EditorBase_cls *mpCParent;
    MultiInputPanel_cls* mpCMNumValue, *mpCMNumKey;
    MultiInputPanel_cls* mpCMNumTemplate;
    HideAndShowButton_cls* mpClHSValue, *mpCHSKey;

    wxArrayString mAstrClosedItem;
    
    int mIndexRange, mIndexRGB;
    int mIndexCurrent;
    int mIndexKey, mIndexKeyFrameType, mIndexEaseFactor;
    int mIndexTemplate[_COLORCURVE_TEMPLATE_MAX];

    void SetMNumValue();
    void SetMNumKey();
    void SetMNumTemplate();

    void UpdateLabels(ParamGroup_cls* pCParamGroup);
    void UpdateTemplateButtons();
    
    void HookFunc01(wxCommandEvent& event){OnNumChange(event);}
    void HookFunc02(wxCommandEvent& event){OnKeyChange(event);}
    void HookFunc03(wxCommandEvent& event){OnTemplateChange(event);}
    void OnNumChange(wxCommandEvent& event);
    void OnKeyChange(wxCommandEvent& event);
    void OnTemplateChange(wxCommandEvent& event);

    void OnTemplate(wxCommandEvent& event);

 private:
    DECLARE_EVENT_TABLE();
};

#endif
