// (setq c-basic-offset 4)
// "clsTics.cpp"

#ifndef _TICS_H_
#define _TICS_H_

#include "clsParamDrawBase.h"

#include <wx/wx.h>
#include <wx/dcbuffer.h>

class Tics_cls : public ParamDrawBase_cls {
 public:
    Tics_cls(bool bVertical = false);

    static wxString msAstrTicsMode[3];
    static wxString msAstrTicsModeCC[2];

    wxColour /*mBGColor,*/ mFGColor1, mFGColor2;
    bool mbUseFloat, mbVertical;
    double mRegionMin, mRegionMax;

    int mTicWidth, mTicHeight;
    //int mTicOffset;
    int mTicBorderXmin, mTicBorderXmax;
    int mTicBorderYmin, mTicBorderYmax;

    long long int mStepLarge, mStepMiddle, mStepSmall;

    float mStepFloatScaling;
    int mStepFloatOrder;

    float mFloatStepLarge, mFloatStepSmall;
    
    void SetParameter(wxSize size, float min, float max);
    void SetBorderX(int borderXmin, int borderXmax);
    void SetBorderY(int borderYmin, int borderYmax);
    void SetRegion(double regionMin, double regionMax);
    void SetColorParameter
	(/*wxColour BGColor,*/wxColour FGColor1, wxColour FGColor2);

    void DrawTextVerticalTic(wxDC &dc, wxString strMes, int ticsY, int mesOffset);
    void DrawTicsVertical(wxDC &dc);
    void DrawTics(wxDC &dc, bool bClear = TRUE, bool bUseWhite = FALSE,
		  int fontSize = 1);

    int GetTicDeviceX(float x);
    int GetTicDeviceY(float y);
    void CalcTicDeviceCoordinateX(int *pX0, int *pX1, 
				  float frame0, float frame1);
    void CalcTicDeviceCoordinateY(int *pY0, int *pY1, 
				  float frame0, float frame1);
};

#endif

