// (setq c-basic-offset 4)

#ifndef _HDRIMAGE_H_
#define _HDRIMAGE_H_

#include <string>
#include <wx/wx.h>
#include <wx/thread.h>

#ifdef _USE_EXR
#include <ImfOutputFile.h>

#define _HDRI_HALF_FLOAT 0
#define _HDRI_FLOAT      1

#define _HDRI_ZIP   0
#define _HDRI_PIZ   1
#define _HDRI_RLE   2
#define _HDRI_PXR24 3

class ThreadHDRISave_cls : public wxThread {
public:
    ThreadHDRISave_cls(bool *pbFinishedFlag);

    void SetParameters(float *pBufferSrc, wxSize CSizeFBO, wxSize CSizeImage,
		       wxString strFileOut, int channelSRC,
		       int depth, int compress,
		       float projMatrix14, float projMatrix10);
    
    OPENEXR_IMF_NAMESPACE::Compression GetCompress();
    float GetAverage(double bufferX, double bufferY,
		     double bufferX2, double bufferY2, int rgb, int bufferChannel);
    void Save1chHalf();
    void Save1chFloat();
    void Save3or4ch();
    void Save3or4chFloat();
		      
    bool *mpbFinishedFlagLink;
    wxString mstrFileOut;
    float *mpBufferSRC;
    int    mBufferWidth, mBufferHeight;
    int    mWidthOut, mHeightOut;
    int    mChannelSRC;
    int    mDepth, mCompress;
    float  mProjMatrix14, mProjMatrix10;

    virtual ExitCode Entry();
};

#endif

#endif

