// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsImageIO.cpp"

#ifndef _IMAGE_IO_H_
#define _IMAGE_IO_H_

#include <wx/wx.h>

class FBO_cls;
class ThreadHDRISave_cls;

#define _IMAGE_OUT_MAX_THREAD 4

class ThreadImageSave_cls : public wxThread {
public:
    ThreadImageSave_cls(bool *pbFinishedFlag);

    void SetParameters(wxSize CSizeSrc, wxSize CSizeTgt,
		       wxString strFileName, bool bAlpha);
	
    bool *mpbFinishedFlagLink;
    wxSize mCSizeSrc, mCSizeTgt;
    wxString mstrFileName;

    unsigned char *mpBufferSRC;
    unsigned char *mpBufferOUT;

    unsigned char *mpBufferAlphaSRC;
    unsigned char *mpBufferAlphaOUT;

    void GetAverageRGB(int widthSrc, int heightSrc,
		       double srcX1, double srcY1, double srcX2, double srcY2,
		       unsigned char* pBufferSRC, unsigned char* pBufferTGT);
    void ResizeImageRGB();
    void GetAverageAlpha(int widthSrc, int heightSrc,
			 double srcX1, double srcY1, double srcX2, double srcY2,
			 unsigned char* pBufferSRC, unsigned char* pBufferTGT);
    void ResizeImageAlpha();

    virtual ExitCode Entry();
};

class ThreadImageSaveScanline_cls : public ThreadImageSave_cls {
public:
    ThreadImageSaveScanline_cls(bool *pbFinishedFlag);

    // Alpha t̕ۑ͖

    unsigned char *mpBufferSRC_1;
    void AllocateBufferSRC1();

    void ResizeImageRGBScanline();

    virtual ExitCode Entry();
};

class ImageIO_cls{
 public:
    ImageIO_cls();

    bool mbThreadActive[_IMAGE_OUT_MAX_THREAD];
    bool mbThreadFinished[_IMAGE_OUT_MAX_THREAD];
    ThreadImageSave_cls *mpCThread[_IMAGE_OUT_MAX_THREAD];
    ThreadHDRISave_cls *mpCThreadHDRI[_IMAGE_OUT_MAX_THREAD];

    float mProjMatrix10, mProjMatrix14;
    void PrepareViewportInfo();
    
    bool SaveEXRFromFBO(FBO_cls *pCFBOMain, wxSize CSizeImage,
			wxString strFileName, bool bAlpha);
    bool SaveImageFromFBO(FBO_cls *pCFBOMain, wxSize CSizeImage,
			  wxString strFileName, bool bAlpha);
    bool SaveImageFromFBOScanLine(FBO_cls *pCFBOMain[2], wxSize CSizeImage,
				  wxString strFileName);

    int mActiveThread;
};

#endif
