// -*- c -*-
// "clsImageOutput.h"
// (setq c-basic-offset 4)

#include "clsImageOutput.h"

#define CLS ImageOutput_cls

#include <wx/file.h>
#include <wx/filename.h>

CLS::
ImageOutput_cls(){
    SetToDefaultParam();
}

void CLS::
SetToDefaultParam(){
    ConfItemList_cls *pCList = &mCConfList;
    pCList->Clear();

    wxString strUpdate = "VIEW3D::PropertyRender";
    wxString strUpdateRender = "PropertyRender";

    pCList->SetTag("ImageOutput");
    pCList->Add(&mCImageType, "ImageType=", "0", strUpdateRender);
    pCList->Add(&mCImageAlpha, "ImageAlpha=", "0", strUpdateRender);
    pCList->Add(&mCStereoOutput, "StereoOutput=", "0", strUpdateRender);
    pCList->Add(&mCstrFileFormat, "FileFormat=", "preview.png", strUpdateRender);
    pCList->Add(&mCWidth, "Width=", "640", strUpdate);
    pCList->Add(&mCHeight, "Height=", "360", strUpdate);
    pCList->Add(&mCSizeType, "SizeType=", "1", strUpdate);
    pCList->Add(&mCSizeIndex, "SizeIndex=", "6", strUpdate);
    pCList->Add(&mCbRenderFromWorkAreaIn, "RenderFromIn=", "1", strUpdate);

    mCstrFileFormat.mbFilePath = TRUE;
}

double CLS::
GetAspectRatioWonH(){
    return mCWidth.GetBodyDOUBLE()/mCHeight.GetBodyDOUBLE();
}

bool CLS::
CheckFileSequence(){
    wxFileName CFile(mCstrFileFormat.GetBodySTR());
    if (CFile.IsAbsolute() == FALSE)
	CFile.MakeAbsolute();
    if (wxDirExists(CFile.GetPath()) == FALSE) return FALSE;
    mCFileSequence.Set(CFile.GetFullPath()/*mCstrFileFormat.GetBodySTR()*/, 0, 1);
    return TRUE;
}

wxString CLS::
GetModifiedStr(int index, int stereo){
    //CheckFileSequence();
    return mCFileSequence.GetModifiedStr(index, stereo);
}

wxSize CLS::
GetSize(){
    return wxSize(mCWidth.GetBodyINT(), mCHeight.GetBodyINT());
}

ImageOutput_cls* GpCImageOutput;
