// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsReadPNG.h"

#include "clsReadPNG.h"



#define CLS ReadPNG_cls

void CLS::
ReadPNGMain8bit(png_structp png_ptr, png_bytep buf,
		int width, int height, int channels, wxImage &CImg){

    int imageSize = width * height;
    int imgFullSize = width * height * channels;
    int imgBufSize = width * height * 3;
    unsigned char *pData = (unsigned char *) malloc(imgBufSize);

    //PCÂǂݍłB
    png_uint_32 i_png = 0;
    int offset_point = 0;
    while(i_png < height){
	png_read_row(png_ptr, buf + offset_point, NULL);
	offset_point += width * channels;
	i_png++;
    }

    if (channels == 1){
	for (int i = 0; i < imgFullSize; i++){
	    unsigned char data = *(unsigned char*)(buf + i);
	    pData[i*3+0] = data; 
	    pData[i*3+1] = data; 
	    pData[i*3+2] = data; 
	}
    }
    if (channels == 3){
	for (int i = 0; i < imgFullSize; i++){
	    unsigned char data = *(unsigned char*)(buf + i);
	    pData[i] = data;
	}
    }
    if (channels == 4){
	int dataIndex = 0;
	for (int i = 0; i < imgFullSize; i++){
	    unsigned char data = *(unsigned char*)(buf + i);
	    if ((i % 4) != 3){
		pData[dataIndex] = data;
		dataIndex++;
	    }
	}
	wxMilliSleep(1);
    }

    CImg.Create(width, height, pData);
    // At@`l͎gȂA
    // t@CłƂ̂߂Ă
    if (channels == 4) CImg.SetAlpha(NULL);
}

void CLS::
ReadPNGMain16bit(png_structp png_ptr, png_bytep buf, 
		int width, int height, int channels, 
		 wxImage &CImg, wxImage &CImgDW){

    int imageSize = width * height;
    int imgFullSize = width * height * channels;
    int imgBufSize = width * height * 3;
    unsigned char *pDataHW = (unsigned char *) malloc(imgBufSize);
    unsigned char *pDataDW = (unsigned char *) malloc(imgBufSize);
    
    png_set_swap(png_ptr);

    //PCÂǂݍłB
    png_uint_32 i_png = 0;
    int offset_point = 0;
    while(i_png < height){
	png_read_row(png_ptr, buf + offset_point, NULL);
	offset_point += width * 2 * channels;
	i_png++;
    }

    if (channels == 1){
	for (int i = 0; i < imgFullSize; i++){
	    unsigned short data = *(unsigned short*)(buf + i*2);
	    unsigned char HW = data / 256;
	    unsigned char DW = data % 256;
	    memset(&pDataHW[i*3], HW, 3);
	    memset(&pDataDW[i*3], DW, 3);
	}
    }
    if (channels == 3){
	for (int i = 0; i < imgFullSize; i++){
	    unsigned short data = *(unsigned short*)(buf + i*2);
	    pDataHW[i] = data / 256;
	    pDataDW[i] = data % 256;
	}
    }
    if (channels == 4){
	int dataIndex = 0;
	for (int i = 0; i < imgFullSize; i++){
	    unsigned char data = *(unsigned char*)(buf + i);
	    if (i % 4 != 3) {
		pDataHW[dataIndex] = data / 256;
		pDataDW[dataIndex] = data % 256;
		dataIndex++;
	    }
	}
    }

    CImg.Create(width, height, pDataHW);
    CImgDW.Create(width, height, pDataDW);
    // At@`l͎gȂA
    // t@CłƂ̂߂Ă
    if (channels == 4){
	CImg.SetAlpha(NULL);
	CImgDW.SetAlpha(NULL);
    }
}

bool CLS::
ReadPNG(FILE *&fp, wxString strPath, wxImage &CImg, wxImage &CImgDW){

    if (CImg.IsOk() == TRUE) CImg.Destroy();
    if (CImgDW.IsOk() == TRUE) CImgDW.Destroy();
    
    int number = 4;
    unsigned char header[4];
    fread(header, 1, number, fp);

    bool is_png = !png_sig_cmp(header, 0, number);
    if (is_png == FALSE) return FALSE;

    // png_struct \̂̏
    png_structp png_ptr = png_create_read_struct (
	PNG_LIBPNG_VER_STRING, (png_voidp)NULL, NULL, NULL);
    if (!png_ptr){
	png_destroy_read_struct(&png_ptr, (png_infopp)NULL, (png_infopp)NULL);
	return FALSE;
    }

    // png_info \̂̏i摜f[^̑Oɂ`Npj
    png_infop info_ptr = png_create_info_struct(png_ptr);
    if (!info_ptr) {
	png_destroy_read_struct(&png_ptr, (png_infopp)NULL, (png_infopp)NULL);
	return FALSE;
    }

    // png_info \̂̏i摜f[^̌ɂ`Npj
    png_infop end_info = png_create_info_struct(png_ptr);
    if (!end_info) {
	png_destroy_read_struct(&png_ptr, &info_ptr, (png_infopp)NULL);
	return FALSE;
    }
 
    // G[炱ɔł悤ɓo^
    if (setjmp(png_jmpbuf(png_ptr))) {
	png_destroy_read_struct(&png_ptr, &info_ptr, &end_info);
	return FALSE;
    }

    png_init_io(png_ptr, fp);
    // OɃVOl`ǍmFςȂAt@C擪ǂݔ΂ĂoCgm点
    png_set_sig_bytes(png_ptr, number);  
    png_read_info(png_ptr, info_ptr);

    png_uint_32 width, height;
    int bit_depth;
    int color_type;
    int interlace_type;
    int compression_type;
    int filter_method;
    
    png_get_IHDR(png_ptr, info_ptr, &width, &height,
		 &bit_depth, &color_type, &interlace_type,
		 &compression_type, &filter_method);

    int channels = png_get_channels(png_ptr, info_ptr);

    // !!_FIX_ME_!! At@f[^͓ǂ܂Ȃ悤ɂȂĂ̂ŁA
    // ̓At@tꍇ wxImage ɔC
    if (channels == 2 || channels == 4){
	png_destroy_read_struct(&png_ptr, &info_ptr, &end_info);
	fp = NULL;
	return FALSE;
    }

    //C^[X̏ꍇ́A炩̎ԂKvKvŁAʓ|Ȃ̂őΉȂƂɂ܂tt
    if( interlace_type != PNG_INTERLACE_NONE ){
	png_destroy_read_struct(&png_ptr, &info_ptr, &end_info);
	fp = NULL;
	return FALSE;
    }

    if (bit_depth != 8 && bit_depth != 16){
	png_destroy_read_struct(&png_ptr, &info_ptr, &end_info);
	fp = NULL;
	return FALSE;
    }

    int depthFactor = bit_depth / 8;
    int bufSize =  width * height * channels * depthFactor;
    png_bytep buf = new png_byte[ bufSize ]; 

    if( buf == NULL ){	
	png_destroy_read_struct(&png_ptr, &info_ptr, &end_info);
	fp = NULL;
	return FALSE;
    }

    if (bit_depth == 8)
	ReadPNGMain8bit(png_ptr, buf,
			width, height, channels, CImg);

    if (bit_depth == 16)
	ReadPNGMain16bit(png_ptr, buf, 
			 width, height, channels, CImg, CImgDW);

    delete [] buf;

    png_destroy_read_struct(&png_ptr, &info_ptr, &end_info);

    return TRUE;
}

ReadPNG_cls *GpCReadPNG = NULL;
