// -*- c++ -*- 
// "clsClickInfoCtrl.h"
// (setq c-basic-offset 4)

#include "clsClickInfoCtrl.h"

#include "../COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;
#include "../WIDGETCTRL/WX/clsPenBrushProvider.h"

#define CLS ClickInfoCtrl_cls

CLS::
ClickInfoCtrl_cls(){
    mbDraggingRegion = FALSE;
}

wxPoint CLS::
GetPointAtDown(){
    return wxPoint(mMouseXAtDown, mMouseYAtDown);
}

void CLS::
DrawDraggingRegion(wxDC &dc, wxRect CIntersect){
    if (mbDraggingRegion == FALSE) return;

    dc.SetBrush(*wxTRANSPARENT_BRUSH);
    dc.SetPen(GCClassProvider.GetPCPenBrushProvider()->GetPen(_PEN_DASH_LONG));

    wxPoint CAtDown(mMouseXAtDown, mMouseYAtDown);
    wxPoint CCurrent(mMouseXCurrent, mMouseYCurrent);
    mCRectSelectRegion = wxRect(CAtDown, CCurrent);
    if (CIntersect.GetSize().GetWidth() != 0)
	mCRectSelectRegion.Intersect(CIntersect);
    
    dc.DrawRectangle(mCRectSelectRegion);
}

void CLS::
LeftDownBase(wxMouseEvent& event){
    mMouseYAtDown = event.GetY();
    mMouseXAtDown = event.GetX();
    mMouseXPrev = mMouseXAtDown;
    mMouseYPrev = mMouseYAtDown;

    mbShiftDown = event.m_shiftDown;
    mbControlDown = event.m_controlDown;
    mbAltDown = event.m_altDown;
}
