// -*- c -*-
// "clsMouseCtrl.cpp"

#include "../COMMON/clsGetPC.h"

#ifndef _MOUSE_CTRL_H_
#define _MOUSE_CTRL_H_

#define _MOUSE_BTN_LEFT   0
#define _MOUSE_BTN_MIDDLE 1
#define _MOUSE_BTN_RIGHT  2

#define _MOUSE_SHIFT 0
#define _MOUSE_CTRL 1
#define _MOUSE_ALT 2

#define _GYRATION_FREE 0
#define _GYRATION_FIXPOS 1

#include <wx/wx.h>

class MouseCtrl_cls : public GetPC_cls {
 public:

    void SetMouseInformation(wxMouseEvent& event, bool bModulate = TRUE);
    void SetPreviousPosition();
    void SetGyrationMode(wxSize sz);

    bool IsGyration();
    bool IsZoom();
    bool IsMoveCenter();
    bool IsMoveItem();
    bool IsMoveSnap();
    bool IsWheel();
    bool IsInertia();

    bool IsShowMenu();
    bool IsHitTest();
    bool IsHitTestAdditive();
    bool IsButton(int btnType);
    bool IsButtonDown();
    bool IsButtonUp();
    bool IsMouseDragging();

    bool mbAModifier[4];
    bool mbAMouseBTN[4];
    long mMouseX, mMouseY;
    long mPrevX , mPrevY;
    long mMouseAtDownX, mMouseAtDownY;
    
    bool mbButtonDown;
    bool mbButtonUp;
    bool mbMouseDragging;
    bool mbMouseWheel;
    int  mWheelRotationNormalized;
    int  mGyrationMode;
};

class MouseNormalized_cls{
 public:
    MouseNormalized_cls(MouseCtrl_cls *pCMouseCtrl, wxSize sz);
    
    float mPrevX, mPrevY;
    float mCurrX, mCurrY;
    float mDownX, mDownY;
    int mGyrationMode;

    void LimitMove();
    void Invert();
    double GetDX();
    double GetDY();
};


#endif
