// (setq c-basic-offset 4)
// "clsSelectorPopup.h"

#include "clsSelectorPopup.h"

#include "../SCENEOBJ/clsAttribute.h"
#include "../SCENEOBJ/clsSceneObj.h"
#include "../SCENEOBJ/clsSceneObjCtrl.h"

#include "../COMMON/CommonDefinitions.h"
#include "../../wxWidgetEnumMenu.h"

#define CLS SelectorPopup_cls

// ----

CLS::
SelectorPopup_cls(){
}

bool CLS::
IsDelimiterTail(wxString str){
    int len = str.Len();
    if (str.Mid(len-2).IsSameAs("::")) return TRUE;
    return FALSE;
}

wxString CLS::
GetChildStr(int id){
    int index = id - menuPop1;
    return wxES;
}

wxString CLS::
GetStr(int id){
    int index = id - menuPop1;

    if (index >= 0){
	wxString strLong = mAstrListLong[index + mMenuOffset];
	if (IsDelimiterTail(strLong) == TRUE){
	    if (mType == 1)
		ChildMenu(strLong);
	    if (mType == 2)
		ChildMenuColorCurve(strLong);
	    return wxES;
	}
	return strLong;
    }
    
    else
	NextMenu();
    return wxES;
}

void CLS::
ChildMenu(wxString strTag){
    
    mMenuOffset = 0;
    mDepth++;

    mAstrListShort.clear();
    mAstrListLong.clear();

    if (mDepth == 1){
	int len = strTag.Len();
	wxString strObjName = strTag.Mid(0, len-2);
	SceneObj_cls* pCObj = GetPCSceneObjCtrl()->GetPCFromName(strObjName);
	uint numParamGroup = pCObj->mVpCParamGroup.size();
	for (uint i = 0; i < numParamGroup; i++){
	    wxString strParamGroup = pCObj->mVpCParamGroup[i]->GetStrName();
	    mAstrListShort.push_back(strParamGroup);
	    mAstrListLong.push_back(strTag + strParamGroup);
	}
	if (pCObj->mstrClassName.IsSameAs("Particle_cls")){
	    mAstrListShort.push_back("Classify");
	    mAstrListLong.push_back(strTag + "Classify");
	}
	uint numAttrib = pCObj->mVpCAttribute.size();
	for (uint i = 0; i < numAttrib; i++){
	    wxString strAttrib = pCObj->GetPCAttributeFromIndex(i)->GetStrName();
	    mAstrListShort.push_back(strAttrib + "  >");
	    mAstrListLong.push_back(strTag + strAttrib + "::");
	}
    }

    if (mDepth == 2){
	int len = strTag.Len();
	wxString strAddress = strTag.Mid(0, len-2);
	Attribute_cls *pCAttrib = GetPCSceneObjCtrl()->GetPCAttributeFromAddress(strAddress);

	uint numParamGroup = pCAttrib->mVpCParamGroup.size();
	for (uint i = 0; i < numParamGroup; i++){
	    wxString strParamGroup = pCAttrib->mVpCParamGroup[i]->GetStrName();
	    mAstrListShort.push_back(strParamGroup);
	    mAstrListLong.push_back(strTag + strParamGroup);
	}

	wxString strAttribName = pCAttrib->GetStrAttributeName();
	if (pCAttrib->GetStrAttributeName().IsSameAs("VolumeCoord_cls")){
	    mAstrListShort.push_back("CustomCoord");
	    mAstrListLong.push_back(strTag + "CustomCoord");
	}
    }

    wxMenu CMenu;
    ConstructMenu(&CMenu);
        
    mpCParent->PopupMenu(&CMenu, mCPos);
}

void CLS::
ChildMenuColorCurve(wxString strTag){
    mMenuOffset = 0;
    mDepth++;

    mAstrListShort.clear();
    mAstrListLong.clear();

    if (mDepth == 1){
	int len = strTag.Len();
	wxString strObjName = strTag.Mid(0, len-2);
	SceneObj_cls* pCObj = GetPCSceneObjCtrl()->GetPCFromName(strObjName);
	uint numAttrib = pCObj->mVpCAttribute.size();
	for (uint i = 0; i < numAttrib; i++){
	    Attribute_cls *pCAttrib = pCObj->GetPCAttributeFromIndex(i);
	    if (pCAttrib->GetStrAttributeName().IsSameAs("ColorCurve_cls")){
		mAstrListShort.push_back(pCAttrib->GetStrName());
		mAstrListLong.push_back(strTag + pCAttrib->GetStrName());
	    }
	}
    }
    
    wxMenu CMenu;
    ConstructMenu(&CMenu);
        
    mpCParent->PopupMenu(&CMenu, mCPos);
}

void CLS::
NextMenu(){
    
    wxMenu CMenu;
    
    mMenuOffset += 9;
    int num = mAstrListShort.GetCount();
    if (mMenuOffset >= num) mMenuOffset = 0;
    
    for (int i = mMenuOffset; i < num; i++){
	if (i >= mMenuOffset+9) break;
	CMenu.Append(menuPop1+(i-mMenuOffset), mAstrListShort[i]);
    }

    CMenu.AppendSeparator();
    CMenu.Append(menuPop0, _("Next")); 

    mpCParent->PopupMenu(&CMenu, mCPos);
}

#include <wx/utils.h> 

void CLS::
ConstructMenu(wxMenu *pCMenu){
    int num = mAstrListShort.GetCount();
    for (int i = 0; i < num; i++){
	if (i >= 9) break;
	wxString strShort = mAstrListShort[i];
	strShort.Replace(wxT(")"), wxES);
	strShort.Replace(wxT("("), wxES);
	pCMenu->Append(menuPop1+i, strShort);
    }

    if (num > 9){
	pCMenu->AppendSeparator();
	pCMenu->Append(menuPop0, _("Next")); 
    }
}

void CLS::
ShowPopupMenu(wxWindow *pCParent){
    wxMenu CMenu;
    ConstructMenu(&CMenu);
    wxPoint CPosParent = pCParent->GetScreenPosition();
    mCPos = wxGetMouseState().GetPosition() - CPosParent;
    pCParent->PopupMenu(&CMenu, mCPos);
}

void CLS::
ClearState(){
    mMenuOffset = 0;
    mDepth = 0;
    mAstrListShort.clear();
    mAstrListLong.clear();
}

void CLS::
NoItem(){
    mAstrListShort.push_back("No Item");
    mAstrListLong.push_back(wxES);
}

void CLS::
PopupObjectSelectorFiltered(wxWindow *pCParent, 
			    std::vector < wxString > VstrFilter,
			    wxString strTag, wxString strException){
    
    mpCParent = pCParent;
    mstrTag = strTag;
    ClearState();
    mType = 0;
    
    std::vector < SceneObj_cls* > VpCList;
    GetPCSceneObjCtrl()->GetVPCList(VpCList);

    int itemNum = 0;
    uint numObj = VpCList.size();
    uint filterNum = VstrFilter.size();
    for (uint i = 0; i < numObj; i++){
	bool bExist = FALSE;
	for (uint j = 0; j < filterNum; j++)
	    if (VpCList[i]->mstrClassName.IsSameAs(VstrFilter[j]))
		bExist = TRUE;
	/*
	if (VpCList[i]->mstrClassName.IsSameAs("Primitive_cls") ||
	    VpCList[i]->mstrClassName.IsSameAs("MeshObj_cls")){
	*/
	if (bExist){
	    wxString strName = VpCList[i]->GetStrName();
	    if (strName.IsSameAs(strException) == FALSE){
		mAstrListShort.push_back(strName);
		mAstrListLong.push_back(strName);
		itemNum++;
	    }
	}
    }
    
    if (itemNum == 0) NoItem();
    ShowPopupMenu(pCParent);
}

void CLS::
PopupObjectSelector(wxWindow *pCParent, wxString strTag, wxString strType, wxString strException){

    if (strType.IsSameAs("SOLID")){
	std::vector < wxString > VstrFilter = {"Primitive_cls", "MeshObj_cls"};
	return PopupObjectSelectorFiltered(pCParent, VstrFilter, strTag, strException);
    }
	
    if (strType.IsSameAs("VOLUME")){
	std::vector < wxString > VstrFilter = {"VolumeBox_cls"};
	return PopupObjectSelectorFiltered(pCParent, VstrFilter, strTag, strException);
    }
    if (strType.IsSameAs("PARTICLE")){
	std::vector < wxString > VstrFilter = {"Particle_cls"};
	return PopupObjectSelectorFiltered(pCParent, VstrFilter, strTag, strException);
    }

    mpCParent = pCParent;
    mstrTag = strTag;
    ClearState();
    mType = 0;
    
    std::vector < SceneObj_cls* > VpCList;
    GetPCSceneObjCtrl()->GetVPCList(VpCList);

    int itemNum = 0;
    uint numObj = VpCList.size();
    for (uint i = 0; i < numObj; i++){
	if (strType.Contains(VpCList[i]->mstrClassName) || strType.IsSameAs("ALL")){
	    wxString strName = VpCList[i]->GetStrName();
	    if (strName.IsSameAs(strException) == FALSE){
		mAstrListShort.push_back(strName);
		mAstrListLong.push_back(strName);
		itemNum++;
	    }
	}
    }
    
    if (itemNum == 0) NoItem();
    ShowPopupMenu(pCParent);
}

/*
void CLS::
PopupVolumeSelector(wxWindow *pCParent, wxString strTag){

    mpCParent = pCParent;
    mstrTag = strTag;
    ClearState();
    mType = 0;
    
    std::vector < SceneObj_cls* > VpCList;
    GetPCSceneObjCtrl()->GetVPCList(VpCList);

    int itemNum = 0;
    uint numObj = VpCList.size();
    for (uint i = 0; i < numObj; i++){
	if (VpCList[i]->mstrClassName.IsSameAs("VolumeBox_cls")){
		mAstrListShort.push_back(VpCList[i]->GetStrName());
		mAstrListLong.push_back(VpCList[i]->GetStrName());
		itemNum++;
	}
    }
    
    if (itemNum == 0) NoItem();
    ShowPopupMenu(pCParent);
}
*/

void CLS::
PopupParamGroupSelector(wxWindow *pCParent){

    mpCParent = pCParent;
    ClearState();
    mType = 1;

    std::vector < SceneObj_cls* > VpCList;
    GetPCSceneObjCtrl()->GetVPCList(VpCList);

    int itemNum = 0;
    uint numObj = VpCList.size();
    for (uint i = 0; i < numObj; i++){
	mAstrListShort.push_back(VpCList[i]->GetStrName() + "  >");
	mAstrListLong.push_back(VpCList[i]->GetStrName() + "::");
	itemNum++;
    }

    

    if (itemNum == 0) NoItem();
    ShowPopupMenu(pCParent);
}

void CLS::
PopupColorCurveSelector(wxWindow *pCParent){

    mpCParent = pCParent;
    ClearState();
    mType = 2;

    std::vector < SceneObj_cls* > VpCList;
    GetPCSceneObjCtrl()->GetVPCList(VpCList);

    int itemNum = 0;
    uint numObj = VpCList.size();
    for (uint i = 0; i < numObj; i++){
	wxString strClassName = VpCList[i]->mstrClassName;
	if (strClassName.IsSameAs("VolumeBox_cls") ||
	    strClassName.IsSameAs("Particle_cls") ||
	    strClassName.IsSameAs("HeightField_cls") ||
	    strClassName.IsSameAs("Streamline_cls")) {
	    mAstrListShort.push_back(VpCList[i]->GetStrName() + " >");
	    mAstrListLong.push_back(VpCList[i]->GetStrName() + "::");
	    itemNum++;
	}
    }

    if (itemNum == 0) NoItem();
    ShowPopupMenu(pCParent);
}
