// -*- c -*-
// "clsMeshBase.cpp"

#ifndef _MESH_BASE_H
#define _MESH_BASE_H

#include <vector>
#include <wx/wx.h>

#define _MESH_MATERIAL -1
#define _MESH_POLYGONS_ARRAY -2

class ArrayAndIndex_cls;
class VBOBaseObject_cls;

class CallBackMaterial_cls {
 public:
    virtual void CallMaterial(int type) = 0;
};

class MeshBase_cls {
 public:
    MeshBase_cls (CallBackMaterial_cls *pCCallBackParent);
    CallBackMaterial_cls *mpCCallBackParent;

    std::vector < float > mVVertex;
    std::vector < float > mVNormal;
    std::vector < float > mVUV2;

    std::vector < unsigned int > mVFaceIndexVertex;
    std::vector < unsigned int > mVFaceIndexNormal;
    std::vector < unsigned int > mVFaceIndexUV2;
    std::vector < int > mVMaterialAndPolygon;

    bool mbFullyTriangular;

    // 434343...  ngonׂ
    // -1(_MESH_MATERIAL)ƁA}eAύX
    // -2(_MESH_POLYGONS_ARRAY)̌ɂ́AGL_QUADSGL_TRIANGLESĂ̌[face]̐
    
    std::vector < unsigned int > mVFaceIndexVertexAdj;
    // adjacent p̍\
	
    void ClearAll();
    void MinimizeMemoryUse();
    bool IsFullyTriangular();

    void ReserveVertexNumber(int num);
    void ReserveFaceNumber(int num);
    void SetVertexNumber(int num);
    void SetFaceNumber(int num);
    //void SetMaterialAndPolygonNumber(int num);

    int  SearchAdjTriangle(int ibase, int vertex0, int vertex1);
    int  SearchAdjTriangleB(int ibase_, ArrayAndIndex_cls *pCIndexAndZ, 
			    int vertex0, int vertex1);
    void ConstructAdjStructure();
    
    void GLDrawUseNormalUseTexture();
    void GLDrawUseNormal();
    void GLDraw(bool bUseNornal = true, bool bUseUV = true);
    void GLDrawArrayMesh(int polyType, int faceNum,
			 int &faceIndexOffset,
			 bool bUseNornal, bool bUseUV);
    //void GLDrawTrianglesAdj();
    void SetVBOShadowGeometry(VBOBaseObject_cls *pCTgt);
};

#endif
