// (setq c-basic-offset 4)
// "clsLuaBase.h"

#include "clsLuaBase.h"

#include "../COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;

#include "../../clsFrameMain.h"

#include "../COMMON/CommonDefinitions.h"

#include "../../wxWidgetEnumMenu.h"

#include <iostream>

#define CLS LuaBase_cls


CLS::
LuaBase_cls(){
    mpLua = NULL;
}

CLS::
LuaBase_cls(const LuaBase_cls& obj){
    mpLua = NULL; // Rs[\[Xׂ|C^Ȃ̂ŁARs[̓NA
}

CLS::
~LuaBase_cls(){
    CloseLuaBase();
}

bool CLS::
IsWordExist(wxString strFunction, wxString strWord){
    bool bExist = FALSE;
    wxString strCpy = wxString(strFunction.c_str());
    while (TRUE){
	int pos = strCpy.Find(strWord);
	if (pos == wxNOT_FOUND) break;
	char pre = strCpy.Mid(pos-1, 1).c_str()[0];
	if (! ((pre >= 'a' && pre <= 'z') || (pre >= 'A' && pre < 'Z') ||
	       pre == '_')){
	    char post = strCpy.Mid(pos + strWord.Length(), 1).c_str()[0];
	    if (! ((pre >= 'a' && pre <= 'z') || (pre >= 'A' && pre < 'Z') ||
	       pre == '_')){
		bExist = TRUE;
	    }
	}
	strCpy = strCpy.Mid(pos+1);
    }
    return bExist;
}

void CLS::
OpenLuaBase(wxString strFunction, int libNum, wxArrayString AstrLibraryName, luaL_Reg* CLibTables[]){
    if (mpLua == NULL){
	mpLua = luaL_newstate();
	luaL_openlibs(mpLua);
	for (int i = 0; i < libNum; i++){
	    
	    wxString strLibraryFull = AstrLibraryName[i];
	    wxString strLibraryName = PopStrItemFromStrLine(strLibraryFull, wxT("."));
	    wxString strSubLibrary = strLibraryFull;

	    int tmp0 = lua_gettop(mpLua);
	    int tmp1 = lua_gettop(mpLua);
	    
	    if (strSubLibrary.IsEmpty() == TRUE){
		lua_newtable(mpLua);
		luaL_setfuncs(mpLua, CLibTables[i], 0);
	    }
	    else{
		//̃Cu͂łɂ
		lua_getglobal(mpLua, strLibraryName.ToAscii());

		lua_newtable(mpLua);
		luaL_setfuncs(mpLua, CLibTables[i], 0);
		lua_setfield(mpLua, -2, strSubLibrary.ToAscii());
	    }
	    int tmp3 = lua_gettop(mpLua);
	    lua_setglobal(mpLua, strLibraryName.ToAscii());
	    int tmp4 = lua_gettop(mpLua);
	}

	std::vector < luaL_Reg > VCLibTablePrint;
	VCLibTablePrint.push_back(luaL_Reg{"print", l_my_print});
	VCLibTablePrint.push_back(luaL_Reg{NULL, NULL});

	lua_newtable(mpLua);
	lua_getglobal(mpLua, "_G");
	luaL_setfuncs(mpLua, VCLibTablePrint.data(), 0);
	lua_setglobal(mpLua, "_G");

    }
    int ret = luaL_dostring(mpLua, strFunction.mb_str(wxConvUTF8));
}

int CLS::
l_my_print(lua_State* L) { 
    int nargs = lua_gettop(L); 
    for (int i=1; i <= nargs; ++i) { 
	const char *pChar = luaL_checkstring(L, i);
	if (pChar != NULL)
	    std::cout << pChar << ' ';//lua_tostring(L, i); 
    } 
    std::cout << std::endl; 

    lua_pop(L, lua_gettop(L));

    return 0; 
} 


void CLS::
CloseLuaBase(){
    if (mpLua != NULL){
	lua_close(mpLua);
	mpLua = NULL;
    }
}

void CLS::
ClearLuaStack(){
    int stackSize = lua_gettop(mpLua);
    lua_pop(mpLua, stackSize); // SNA
}

void CLS::
COutErrorMessage(){
    std::cout << lua_tostring(mpLua, -1) << std::endl;
    ClearLuaStack();
}

void CLS::
SetVariable(double value, char *pcharTag){
    SetVariable(mpLua, value, pcharTag);
}

void CLS::
SetVariable(int value, char *pcharTag){
    SetVariable(mpLua, value, pcharTag);
}

void CLS::
SetVariable(lua_State *pLua,  double value, char *pcharTag){
    lua_pushnumber(pLua, value);
    lua_setglobal(pLua, pcharTag);
}

void CLS::
SetVariable(lua_State *pLua, int value, char *pcharTag){
    lua_pushnumber(pLua, value);
    lua_setglobal(pLua, pcharTag);
}

void CLS::
CheckErrorMessage(lua_State *pLua, wxString strTag){
    const char *err = lua_tostring(pLua, -1);

    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuLog);
    wxString strMessage = wxString::FromAscii(err);
    strMessage << "::" << strTag;
    
    com.SetString(strMessage);
    GCClassProvider.GetPCFrameMain(0)->GetEventHandler()->AddPendingEvent(com);
}

wxString CLS::msstrErr;
