// (setq c-basic-offset 4)
// "clsLuaInterpreter.h"

#include "clsLuaInterpreter.h"

#include "../COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;

#include "../SCENEOBJ/clsAttribute.h"
#include "../SCENEOBJ/clsCamera.h"
#include "../SCENEOBJ/clsLightSource.h"
#include "../SCENEOBJ/clsPrimitive.h"
#include "../SCENEOBJ/clsSceneObjCtrl.h"
#include "../TIMELINE/clsTimeCtrl.h"
#include "../UNDO/clsUndoManager.h"

#include "../../clsMain.h"

#include "../COMMON/CommonDefinitions.h"

#define CLS LuaInterpreter_cls

CLS::
LuaInterpreter_cls(){
    // Ops.
    mVLibTableOps.push_back(luaL_Reg{"AddPrimitive", AddPrimitive});
    mVLibTableOps.push_back(luaL_Reg{"AddCamera", AddCamera});
    mVLibTableOps.push_back(luaL_Reg{"AddLight", AddLight});
    mVLibTableOps.push_back(luaL_Reg{"AddMesh", AddMesh});
    mVLibTableOps.push_back(luaL_Reg{"AddEmpty", AddEmpty});
    mVLibTableOps.push_back(luaL_Reg{"AddWorld", AddWorld});
    mVLibTableOps.push_back(luaL_Reg{"AddVolumeBox", AddVolumeBox});
    mVLibTableOps.push_back(luaL_Reg{"AddParticle", AddParticle});
    mVLibTableOps.push_back(luaL_Reg{"AddStreamline", AddStreamline});
    mVLibTableOps.push_back(luaL_Reg{"AddHeightField", AddHeightField});
    
    mVLibTableOps.push_back(luaL_Reg{"DeleteObject", DeleteObject});
    mVLibTableOps.push_back(luaL_Reg{"DeselectObject", DeselectObject});
    mVLibTableOps.push_back(luaL_Reg{"SelectObject", SelectObject});
    mVLibTableOps.push_back(luaL_Reg{NULL, NULL});

    // Ops.ActiveObj.
    mVLibTableOpsActiveObj.push_back(luaL_Reg{"Delete", DeleteActive});
    mVLibTableOpsActiveObj.push_back(luaL_Reg{"Rename", RenameActive});
    mVLibTableOpsActiveObj.push_back(luaL_Reg{"GetVisibility", GetVisibilityActive});
    mVLibTableOpsActiveObj.push_back(luaL_Reg{"SetVisibility", SetVisibilityActive});
    mVLibTableOpsActiveObj.push_back(luaL_Reg{"GetValidity", GetValidityActive});
    mVLibTableOpsActiveObj.push_back(luaL_Reg{"SetValidity", SetValidityActive});
    mVLibTableOpsActiveObj.push_back(luaL_Reg{"GetShy", GetShyActive});
    mVLibTableOpsActiveObj.push_back(luaL_Reg{"SetShy", SetShyActive});
    mVLibTableOpsActiveObj.push_back(luaL_Reg{"GetParameterLink", GetParameterLinkActive});
    mVLibTableOpsActiveObj.push_back(luaL_Reg{"SetParameterLink", SetParameterLinkActive});
    mVLibTableOpsActiveObj.push_back(luaL_Reg{NULL, NULL});
    
    // Ops.SelectedObj.
    mVLibTableOpsSelectedObj.push_back(luaL_Reg{"MoveTo", ObjectsMoveTo});
    mVLibTableOpsSelectedObj.push_back(luaL_Reg{"SetChildTo", ObjectsSetChildTo});
    mVLibTableOpsSelectedObj.push_back(luaL_Reg{"Delete", DeleteSelected});
    mVLibTableOpsSelectedObj.push_back(luaL_Reg{"SetVisibility", SetVisibilitySelected});
    mVLibTableOpsSelectedObj.push_back(luaL_Reg{"SetValidity", SetValiditySelected});
    mVLibTableOpsSelectedObj.push_back(luaL_Reg{NULL, NULL});
    
    // Data.
    mVLibTableData.push_back(luaL_Reg{"GetName", GetName});
    mVLibTableData.push_back(luaL_Reg{"GetActiveObject", GetActiveObject});
    mVLibTableData.push_back(luaL_Reg{"GetParent", GetParent});
    mVLibTableData.push_back(luaL_Reg{"GetChild", GetChild});
    mVLibTableData.push_back(luaL_Reg{"GetChildList", GetChildList});
    mVLibTableData.push_back(luaL_Reg{"GetPosition", GetPosition});
    mVLibTableData.push_back(luaL_Reg{"GetRotationEuler", GetRotationEuler});
    mVLibTableData.push_back(luaL_Reg{"GetScale", GetScale});
    /*
    mVLibTableData.push_back(luaL_Reg{"GetVisibility", GetVisibility});
    mVLibTableData.push_back(luaL_Reg{"SetVisibility", SetVisibility});
    mVLibTableData.push_back(luaL_Reg{"GetValidity", GetValidity});
    mVLibTableData.push_back(luaL_Reg{"SetValidity", SetValidity});
    mVLibTableData.push_back(luaL_Reg{"GetShy", GetShy});
    mVLibTableData.push_back(luaL_Reg{"SetShy", SetShy});
    */
    mVLibTableData.push_back(luaL_Reg{NULL, NULL});

    // clsConsoleCtrl.cpp::ProcessOneLinerɃo[֐̂
    // ł̐ݒKv
    // o֐oĂ̊֐Ăяo
    //ParamgGroup
    mVLibTableParamGroup.push_back(luaL_Reg{"GetDimension", GetDimension});
    mVLibTableParamGroup.push_back(luaL_Reg{"GetValueAt", GetValueAt});
    mVLibTableParamGroup.push_back(luaL_Reg{"SetValueAt", SetValueAt});
    mVLibTableParamGroup.push_back(luaL_Reg{"GetLink", GetLink});
    mVLibTableParamGroup.push_back(luaL_Reg{"SetLink", SetLink});
    mVLibTableParamGroup.push_back(luaL_Reg{"GetShy", GetParamGroupShy});
    mVLibTableParamGroup.push_back(luaL_Reg{"SetShy", SetParamGroupShy});
    mVLibTableParamGroup.push_back(luaL_Reg{"GetUseExpression", GetUseExpression});
    mVLibTableParamGroup.push_back(luaL_Reg{"SetUseExpression", SetUseExpression});
    mVLibTableParamGroup.push_back(luaL_Reg{"GetExpression", GetExpression});
    mVLibTableParamGroup.push_back(luaL_Reg{"SetExpression", SetExpression});
    mVLibTableParamGroup.push_back(luaL_Reg{"GetTimeDependency", GetTimeDependency});
    mVLibTableParamGroup.push_back(luaL_Reg{"SetTimeDependency", SetTimeDependency});
    mVLibTableParamGroup.push_back(luaL_Reg{NULL, NULL});

    //Object
    mVLibTableObject.push_back(luaL_Reg{"GetShy", GetObjectShy});
    mVLibTableObject.push_back(luaL_Reg{"SetShy", SetObjectShy});
    mVLibTableObject.push_back(luaL_Reg{"GetVisibility", GetVisibility});
    mVLibTableObject.push_back(luaL_Reg{"SetVisibility", SetVisibility});
    mVLibTableObject.push_back(luaL_Reg{"GetValid", GetValidity});
    mVLibTableObject.push_back(luaL_Reg{"SetValid", SetValidity});
    mVLibTableObject.push_back(luaL_Reg{"GetConfList", GetObjectConfList});
    mVLibTableObject.push_back(luaL_Reg{"GetConfItem", GetObjectConfItem});
    mVLibTableObject.push_back(luaL_Reg{"GetAttribList", GetObjectAttribList});
    mVLibTableObject.push_back(luaL_Reg{"GetAttribConfList", GetObjectAttribConfList});
    mVLibTableObject.push_back(luaL_Reg{"GetAttribConfItem", GetObjectAttribConfItem});
    mVLibTableObject.push_back(luaL_Reg{NULL, NULL});
    
    //ParamGroup  Expression
    //This. 
    mVLibTableThis.push_back(luaL_Reg{"GetValueAt", ThisGetValueAt});
    mVLibTableThis.push_back(luaL_Reg{"GetKeyNum", ThisGetKeyNum});
    mVLibTableThis.push_back(luaL_Reg{NULL, NULL});
    
}

SceneObjCtrl_cls* CLS::
GetPCSceneObjCtrl(){
    return GCClassProvider.GetPCSceneObjCtrl(); }

SceneObj_cls* CLS::
GetPCSceneObjFromFirstArg(lua_State *L){
    wxString strTgt = wxString::FromAscii(lua_tostring(L, 1));
    return GetPCSceneObjCtrl()->GetPCFromName(strTgt);
}

UndoManager_cls* CLS::
GetPCUndo(){
    return GCClassProvider.GetPCUndo(); }

Main_cls* CLS::
GetPCMain(){
    return GCClassProvider.GetPCMain(); }

int CLS::
ReturnInteger(lua_State *L, int integer){
    lua_pushinteger(L, integer);
    return 1;
}

int CLS::
ReturnFalse(lua_State *L){
    lua_pushinteger(L, 0);
    return 1;
}

int CLS::
ReturnTrue(lua_State *L){
    lua_pushinteger(L, 1);
    return 1;
}

bool CLS::
GetBool(wxString strArg){
    if (strArg.IsEmpty() == TRUE) return FALSE;
    if (strArg.IsSameAs("TRUE") || strArg.IsSameAs("true")) return TRUE;
    if (strArg.IsSameAs("FALSE") || strArg.IsSameAs("false")) return FALSE;
    long value;
    strArg.ToLong(&value);
    return (bool) value;
}

void CLS::
AddSceneObjBase(lua_State *L, wxString strBaseName){
    wxString strNewName = wxString::FromAscii(lua_tostring(L, 1));
    lua_pop(L, lua_gettop(L));

    GetPCUndo()->OpenBlock(strBaseName+" Adding");
    wxString strName = GetPCSceneObjCtrl()->AppendSceneObjCommand(strBaseName);
    if (strNewName.IsEmpty() == FALSE){
	GetPCSceneObjCtrl()->RenameCommand(strName, strNewName);
	strName = strNewName;
    }
    GetPCUndo()->CloseBlock(strBaseName+" Adding");

    lua_pushstring(L, strName.ToAscii());
}

int CLS::
AddPrimitive(lua_State *L){
    wxString strType = wxString::FromAscii(lua_tostring(L, 1));
    wxString strNewName = wxString::FromAscii(lua_tostring(L, 2));
    //lua_pop(L, lua_gettop(L));
    lua_pop(L, lua_gettop(L));
    
    if (strType.IsEmpty() == TRUE) strType = wxT("Empty");
    int type = Primitive_cls::GetTypeFromStr(strType);

    GetPCUndo()->OpenBlock(wxT("AddPrimitive"));
    wxString strName = GetPCSceneObjCtrl()->AppendPrimitiveCommand(type);
    if (strNewName.IsEmpty() == FALSE &&
	strName.IsSameAs(strNewName) == FALSE){
	GetPCSceneObjCtrl()->RenameCommand(strName, strNewName);
	strName = strNewName;
    }
    GetPCUndo()->CloseBlock(wxT("AddPrimitive"));

    lua_pushstring(L, strName.ToAscii());
    return 1;
}

int CLS::
AddCamera(lua_State *L){
    AddSceneObjBase(L, "Camera");
    return 1;
}

int CLS::
AddLight(lua_State *L){
    wxString strType = wxString::FromAscii(lua_tostring(L, 1));
    wxString strNewName = wxString::FromAscii(lua_tostring(L, 2));
    lua_pop(L, lua_gettop(L));
    
    if (strType.IsEmpty() == TRUE) strType = wxT("ParallelLight");
    int type = LightSource_cls::GetTypeFromStr(strType);

    GetPCUndo()->OpenBlock(wxT("AddLightSource"));
    wxString strName = GetPCSceneObjCtrl()->AppendLightCommand(type);
    if (strNewName.IsEmpty() == FALSE){
	GetPCSceneObjCtrl()->RenameCommand(strName, strNewName);
	strName = strNewName;
    }
    GetPCUndo()->CloseBlock(wxT("AddLightSource"));


    lua_pushstring(L, strName.ToAscii());
    return 1;
}

int CLS::
AddMesh(lua_State *L){
    AddSceneObjBase(L, "Mesh");

    /*
    wxString strNewName = wxString::FromAscii(lua_tostring(L, 1));
    lua_pop(L, lua_gettop(L));
    
    GetPCUndo()->OpenBlock(wxT("AddMesh"));
    wxString strName = GetPCSceneObjCtrl()->AppendSceneObjCommand("MeshObj");
    if (strNewName.IsEmpty() == FALSE){
	GetPCSceneObjCtrl()->RenameCommand(strName, strNewName);
	strName = strNewName;
    }
    GetPCUndo()->CloseBlock(wxT("AddMesh"));

    lua_pushstring(L, strName.ToAscii());
    */
    return 1;
}

int CLS::
AddEmpty(lua_State *L){
    wxString strNewName = wxString::FromAscii(lua_tostring(L, 1));
    lua_pop(L, lua_gettop(L));

    GetPCUndo()->OpenBlock("AddEmpty");
    wxString strName = GetPCSceneObjCtrl()->AppendPrimitiveCommand(0);
    if (strNewName.IsEmpty() == FALSE){
	GetPCSceneObjCtrl()->RenameCommand(strName, strNewName);
	strName = strNewName;
    }
    GetPCUndo()->CloseBlock("AddEmpty");

    lua_pushstring(L, strName.ToAscii());
    return 1;
}

int CLS::
AddWorld(lua_State *L){
    AddSceneObjBase(L, "World");
    return 1;
}

int CLS::
AddVolumeBox(lua_State *L){
    AddSceneObjBase(L, "VolumeBox");
    /*
    wxString strNewName = wxString::FromAscii(lua_tostring(L, 1));
    lua_pop(L, lua_gettop(L));
    
    GetPCUndo()->OpenBlock(wxT("AddVolumeBox"));
    wxString strName = GetPCSceneObjCtrl()->AppendSceneObjCommand("VolumeBox");
    if (strNewName.IsEmpty() == FALSE){
	GetPCSceneObjCtrl()->RenameCommand(strName, strNewName);
	strName = strNewName;
    }
    GetPCUndo()->CloseBlock(wxT("AddVolumeBox"));

    lua_pushstring(L, strName.ToAscii());
    */
    return 1;
}

int CLS::
AddParticle(lua_State *L){
    AddSceneObjBase(L, "Particle");
    /*
    wxString strNewName = wxString::FromAscii(lua_tostring(L, 1));
    lua_pop(L, lua_gettop(L));
    
    GetPCUndo()->OpenBlock(wxT("AddParticle"));
    wxString strName = GetPCSceneObjCtrl()->AppendSceneObjCommand("Particle");
    if (strNewName.IsEmpty() == FALSE){
	GetPCSceneObjCtrl()->RenameCommand(strName, strNewName);
	strName = strNewName;
    }
    GetPCUndo()->CloseBlock(wxT("AddParticle"));

    lua_pushstring(L, strName.ToAscii());
    */
    return 1;
}

int CLS::
AddStreamline(lua_State *L){
    AddSceneObjBase(L, "Streamline");
    /*
    wxString strNewName = wxString::FromAscii(lua_tostring(L, 1));
    lua_pop(L, lua_gettop(L));
    
    GetPCUndo()->OpenBlock(wxT("AddStreamline"));
    wxString strName = GetPCSceneObjCtrl()->AppendSceneObjCommand("Streamline");
    if (strNewName.IsEmpty() == FALSE){
	GetPCSceneObjCtrl()->RenameCommand(strName, strNewName);
	strName = strNewName;
    }
    GetPCUndo()->CloseBlock(wxT("AddStreamline"));

    lua_pushstring(L, strName.ToAscii());
    */
    return 1;
}

int CLS::
AddHeightField(lua_State *L){
    AddSceneObjBase(L, "HeightField");
    /*
    wxString strNewName = wxString::FromAscii(lua_tostring(L, 1));
    lua_pop(L, lua_gettop(L));
    
    GetPCUndo()->OpenBlock(wxT("AddHeightField"));
    wxString strName = GetPCSceneObjCtrl()->AppendSceneObjCommand("HeightField");
    if (strNewName.IsEmpty() == FALSE){
	GetPCSceneObjCtrl()->RenameCommand(strName, strNewName);
	strName = strNewName;
    }
    GetPCUndo()->CloseBlock(wxT("AddHeightField"));

    lua_pushstring(L, strName.ToAscii());
    */
    return 1;
}

int CLS::
DeleteObject(lua_State *L){
    wxString strTgt = wxString::FromAscii(lua_tostring(L, 1));
    lua_pop(L, lua_gettop(L));
    
    GetPCSceneObjCtrl()->Select(strTgt, FALSE);
    GetPCSceneObjCtrl()->DeleteItemsCommand();

    return 0;
}

int CLS::
SelectObject(lua_State *L){
    wxString strTgt = wxString::FromAscii(lua_tostring(L, 1));
    wxString strArg = wxString::FromAscii(lua_tostring(L, 2));
    lua_pop(L, lua_gettop(L));
	
    bool bAdditive = GetBool(strArg);
	
    GetPCSceneObjCtrl()->Select(strTgt, bAdditive);

    return 0;
}

/*
int CLS::
SetVisible(lua_State *L){
    wxString strTgt = wxString::FromAscii(lua_tostring(L, 1));
    wxString strArg = wxString::FromAscii(lua_tostring(L, 2));
    lua_pop(L, lua_gettop(L));

    bool bVisible = GetBool(strArg);
    GetPCSceneObjCtrl()->SetVisibleCommand(strTgt, bVisible);
    
    return 0;
}

int CLS::
SetValid(lua_State *L){
    wxString strTgt = wxString::FromAscii(lua_tostring(L, 1));
    wxString strArg = wxString::FromAscii(lua_tostring(L, 2));
    lua_pop(L, lua_gettop(L));

    bool bValid = GetBool(strArg);
    GetPCSceneObjCtrl()->SetValidCommand(strTgt, bValid);

    return 0;
}
*/

int CLS::
DeselectObject(lua_State *L){
    wxString strTgt = wxString::FromAscii(lua_tostring(L, 1));
    lua_pop(L, lua_gettop(L));
  	
    GetPCSceneObjCtrl()->Deselect(strTgt);
    return 0;
}

int CLS::
DeleteActive(lua_State *L){
    GetPCSceneObjCtrl()->SelectActitiveObjectOnly();
    GetPCSceneObjCtrl()->DeleteItemsCommand();
    lua_pop(L, 0);
    return 0;
}

int CLS::
RenameActive(lua_State *L){
    wxString strNameNew = wxString::FromAscii(lua_tostring(L, 1));
    lua_pop(L, lua_gettop(L));

    wxString strNameOld = GetPCSceneObjCtrl()->GetActiveObjectName();
    if (strNameOld.IsEmpty() == FALSE)
	GetPCSceneObjCtrl()->RenameCommand(strNameOld, strNameNew);
    
    return 0;
}

int CLS::
GetVisibilityActive(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjCtrl()->mpCActiveObject;
    
    lua_pop(L, lua_gettop(L));
    int retVal = 0;
    if (pCObj != NULL) retVal = pCObj->mCbVisible.GetBodyINT();
    return ReturnInteger(L, retVal);
}

int CLS::
SetVisibilityActive(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjCtrl()->mpCActiveObject;
    bool bVisibility = GetBool(lua_tostring(L, 1));
    
    lua_pop(L, lua_gettop(L));
    if (pCObj == NULL) return ReturnFalse(L);

    wxString strData; strData << bVisibility;
    pCObj->mCbVisible.PushCommandPair(strData);
    return ReturnTrue(L);
}

int CLS::
GetValidityActive(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjCtrl()->mpCActiveObject;

    lua_pop(L, lua_gettop(L));
    int retVal = 0;
    if (pCObj != NULL)
	if (pCObj->mstrClassName.IsSameAs("LightSource_cls"))
	    retVal = ((LightSource_cls*)pCObj)->mCbValid.GetBodyINT();
    return ReturnInteger(L, retVal);
}

int CLS::
SetValidityActive(lua_State *L){
    
    SceneObj_cls *pCObj = GetPCSceneObjCtrl()->mpCActiveObject;
    bool bValidity = GetBool(lua_tostring(L, 1));

    lua_pop(L, lua_gettop(L));
    if (pCObj == NULL) return ReturnFalse(L);

    if (pCObj->mstrClassName.IsSameAs("LightSource_cls") == FALSE) 
	return ReturnFalse(L);

    wxString strData; strData << bValidity;
    ((LightSource_cls*)pCObj)->mCbValid.PushCommandPair(strData);

    return ReturnTrue(L);
}

int CLS::
GetShyActive(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjCtrl()->mpCActiveObject;

    lua_pop(L, lua_gettop(L));
    int retVal = 0;
    if (pCObj != NULL)
	retVal = pCObj->mCbShy.GetBodyINT();
    return ReturnInteger(L, retVal);
}

int CLS::
SetShyActive(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjCtrl()->mpCActiveObject;
    bool bShy = GetBool(lua_tostring(L, 1));
    
    lua_pop(L, lua_gettop(L));
    if (pCObj == NULL) return ReturnFalse(L);

    wxString strData; strData << bShy;
    pCObj->mCbShy.PushCommandPair(strData);
    return ReturnTrue(L);
}

int CLS::
GetParameterLinkActive(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjCtrl()->mpCActiveObject;
    wxString strParam = wxString::FromAscii(lua_tostring(L, 1));
    
    lua_pop(L, lua_gettop(L));
    int retVal = 0;
    if (pCObj != NULL){
	ParamGroup_cls *pCParamGroup = pCObj->GetPCParamGroup(strParam);
	if (pCParamGroup != NULL)
	    retVal = pCParamGroup->mCbLinked.GetBodyINT();
    }
    return ReturnInteger(L, retVal);
}

int CLS::
SetParameterLinkActive(lua_State *L){
    wxString strTgt = GetPCSceneObjCtrl()->GetActiveObjectName();
    SceneObj_cls *pCObj = GetPCSceneObjCtrl()->mpCActiveObject;
    wxString strParam = wxString::FromAscii(lua_tostring(L, 1));
    wxString strArg = wxString::FromAscii(lua_tostring(L, 2));

    lua_pop(L, lua_gettop(L));
    if (pCObj == NULL) return ReturnFalse(L);
    
    bool bLink = GetBool(strArg);
    if (GetPCMain()->SetParamGroupConfCommand(strTgt+wxT("::")+strParam, "Linked=", bLink) == FALSE) return ReturnFalse(L);
    return ReturnTrue(L);
}

int CLS::
ObjectsMoveTo(lua_State *L){
    wxString strTgt = wxString::FromAscii(lua_tostring(L, 1));
    wxString strArg = wxString::FromAscii(lua_tostring(L, 2));
    lua_pop(L, lua_gettop(L));

    bool bAdditive = GetBool(strArg);
    GetPCSceneObjCtrl()->MoveItemToCommand(strTgt, bAdditive);
    return 0;
}

int CLS::
ObjectsSetChildTo(lua_State *L){
    wxString strTgt = wxString::FromAscii(lua_tostring(L, 1));
    lua_pop(L, lua_gettop(L));

    GetPCSceneObjCtrl()->SetToChildCommand(strTgt);
    return 0;
}

int CLS::
DeleteSelected(lua_State *L){
    lua_pop(L, 0);
    GetPCSceneObjCtrl()->DeleteItemsCommand();
    return 0;
}

int CLS::
SetVisibilitySelected(lua_State *L){
    wxString strArg = wxString::FromAscii(lua_tostring(L, 1));
    lua_pop(L, lua_gettop(L));

    bool bVisible = GetBool(strArg);
    GetPCSceneObjCtrl()->SetVisibleMultipleCommand(bVisible);
    return 0;
}

int CLS::
SetValiditySelected(lua_State *L){
    wxString strArg = wxString::FromAscii(lua_tostring(L, 1));
    lua_pop(L, lua_gettop(L));

    bool bValid = GetBool(strArg);
    GetPCSceneObjCtrl()->SetValidMultipleCommand(bValid);
    return 0;
}

int CLS::
GetName(lua_State *L){
    wxString strTgt = wxString::FromAscii(lua_tostring(L, 1));
    lua_pop(L, lua_gettop(L));

    lua_pushstring(L, strTgt.ToAscii());
    return 1;
}

int CLS::
GetActiveObject(lua_State *L){
    lua_pop(L, 0);
    SceneObj_cls *pCActive = GetPCSceneObjCtrl()->mpCActiveObject;
    if (pCActive == NULL)
	lua_pushstring(L, "None");
    else
	lua_pushstring(L, pCActive->mCstrName.mstrBody.ToAscii());
    return 1;
}

int CLS::
GetParent(lua_State *L){
    wxString strTgt = wxString::FromAscii(lua_tostring(L, 1));
    lua_pop(L, lua_gettop(L));
    
    SceneObj_cls *pCObj = GetPCSceneObjCtrl()->GetPCFromName(strTgt);
    
    if (pCObj == NULL)
	lua_pushstring(L, "None");
    else{
	if (pCObj->mpCParentObj->mParentObjType == _PARENTOBJ_ROOT)
	    lua_pushstring(L, "ROOT");
	else
	    lua_pushstring(L, ((SceneObj_cls *)(pCObj->mpCParentObj))->mCstrName.mstrBody.ToAscii());
    }
    return 1;
}

int CLS::
GetChild(lua_State *L){
    //wxString strTgt = wxString::FromAscii(lua_tostring(L, 1));
    //SceneObj_cls *pCObj = GetPCSceneObjCtrl()->GetPCFromName(strTgt);
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    long long index; wxString::FromAscii(lua_tostring(L, 2)).ToLongLong(&index);
    lua_pop(L, lua_gettop(L));

    if (pCObj == NULL)
	lua_pushstring(L, "None");
    else{
	int childNum = pCObj->mVpCObj.size();
	if (index < 0 || index >= childNum)
	    lua_pushstring(L, "None");
	else{
	    lua_pushstring(L, pCObj->GetPCFromIndex(index)->mCstrName.mstrBody.ToAscii());
	}
    }
    return 1;
}

int CLS::
GetChildList(lua_State *L){
    wxString strTgt = wxString::FromAscii(lua_tostring(L, 1));
    lua_pop(L, lua_gettop(L));

    if (strTgt.IsSameAs("ROOT")){
	ParentObj_cls *pCRoot = GetPCSceneObjCtrl();
	wxArrayString AstrChilds;
	pCRoot->GetDirectChildrensName(AstrChilds);
	int num = AstrChilds.GetCount();
	for (int i = 0; i < num; i++)
	    lua_pushstring(L, AstrChilds[i].ToAscii());
	return num;
    }
    
    SceneObj_cls *pCObj = GetPCSceneObjCtrl()->GetPCFromName(strTgt);

    if (pCObj == NULL)
	lua_pushstring(L, "None");
    else{
	wxArrayString AstrChilds;
	pCObj->GetDirectChildrensName(AstrChilds);
	int num = AstrChilds.GetCount();
	for (int i = 0; i < num; i++)
	    lua_pushstring(L, AstrChilds[i].ToAscii());
	return num;
    }

    return 1;
}

int CLS::
GetVisibility(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    lua_pop(L, lua_gettop(L));

    int retVal = 0;
    if (pCObj != NULL) retVal = pCObj->mCbVisible.GetBodyINT();
    return ReturnInteger(L, retVal);
}

int CLS::
SetVisibility(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);

    bool bVisibility = GetBool(lua_tostring(L, 2));
    lua_pop(L, lua_gettop(L));
    if (pCObj == NULL) return ReturnFalse(L);

    wxString strData; strData << bVisibility;
    pCObj->mCbVisible.PushCommandPair(strData);
    return ReturnTrue(L);
}

int CLS::
GetValidity(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    lua_pop(L, lua_gettop(L));

    int retVal = 0;
    if (pCObj != NULL)
	if (pCObj->mstrClassName.IsSameAs("LightSource_cls"))
	    retVal = ((LightSource_cls*)pCObj)->mCbValid.GetBodyINT();
    return ReturnInteger(L, retVal);
}

int CLS::
SetValidity(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    bool bValid = GetBool(lua_tostring(L, 2));

    lua_pop(L, lua_gettop(L));
    if (pCObj == NULL) return ReturnFalse(L);
    if (pCObj->mstrClassName.IsSameAs("LightSource_cls") == FALSE)
	return ReturnFalse(L);

    wxString strData; strData << bValid;
    ((LightSource_cls*)pCObj)->mCbValid.PushCommandPair(strData);
    return ReturnTrue(L);
}

int CLS::
GetPosition(lua_State *L){
    return GetParameterValue(L, "Position");
}

int CLS::
GetRotationEuler(lua_State *L){
    return GetParameterValue(L, "RotationEuler");
}

int CLS::
GetScale(lua_State *L){
    return GetParameterValue(L, "Scale");
}

int CLS::
GetParameterValue(lua_State* L, wxString strParamGroup){
    //wxString strTgt = wxString::FromAscii(lua_tostring(L, 1));
    //SceneObj_cls *pCObj = GetPCSceneObjCtrl()->GetPCFromName(strTgt);
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    if (strParamGroup.IsEmpty() == TRUE){
	wxString strParamGroup = wxString::FromAscii(lua_tostring(L, 2));
    }
    lua_pop(L, lua_gettop(L));
    
    if (pCObj == NULL) return 0;

    ParamGroup_cls *pCParamGroup = pCObj->GetPCParamGroup(strParamGroup);
    if (pCParamGroup == NULL) return 0;

    //lua_getglobal(L, "ParamGroupInit");
    //ParamGroup_cls* pCInit = (ParamGroup_cls*)lua_touserdata(L, 1);
    
    double nt = GCClassProvider.GetPCTimeCtrl()->GetCurrentNT();
    std::vector < double > VValue = pCParamGroup->GetVInterpolatedValue(nt, TRUE, NULL, TRUE);

    uint num = VValue.size();
    for (uint i = 0; i < num; i++)
	lua_pushnumber(L, VValue[i]);
    return num;
}

int CLS::
GetDimension(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    wxString strParamGroup = lua_tostring(L, 2);
    lua_pop(L, lua_gettop(L));
        
    if (pCObj == NULL) return 0;

    ParamGroup_cls* pCParamGroup = pCObj->GetPCParamGroup(strParamGroup);
    if (pCParamGroup != NULL){
	uint num = pCParamGroup->mVCParam.size();
	lua_pushinteger(L, num);
	return 1;
    }
    return 0;
}

int CLS::
GetValueAt(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    wxString strParamGroup = lua_tostring(L, 2);
    double nt;wxString::FromAscii(lua_tostring(L, 3)).ToDouble(&nt);
    lua_pop(L, lua_gettop(L));
        
    if (pCObj == NULL) return 0;
    
    ParamGroup_cls* pCParamGroup = pCObj->GetPCParamGroup(strParamGroup);
    if (pCParamGroup != NULL){
	std::vector < double > VValue = pCParamGroup->GetVInterpolatedValue(nt, FALSE);
	uint num = VValue.size();
	for (uint i = 0; i < num; i++)
	    lua_pushnumber(L, VValue[i]);
	return num;
    }

    return 0;
}

int CLS::
SetValueAt(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    wxString strParamGroup = lua_tostring(L, 2);
    double nt;wxString::FromAscii(lua_tostring(L, 3)).ToDouble(&nt);
    int top = lua_gettop(L);
    std::vector < double > VValue;
    for (int i = 4; i <= top; i++){
	double value;wxString::FromAscii(lua_tostring(L, i)).ToDouble(&value);
	VValue.push_back(value);
    }

    lua_pop(L, lua_gettop(L));
    if (pCObj == NULL) return ReturnFalse(L);

    ParamGroup_cls* pCParamGroup = pCObj->GetPCParamGroup(strParamGroup);
    if (pCParamGroup == NULL) return ReturnFalse(L);

    if (pCParamGroup->mVCParam.size() != VValue.size()) return ReturnFalse(L);

    wxString strTag = pCObj->GetStrTag(pCParamGroup) << "::";
    
    uint num = VValue.size();
    for (uint i = 0; i < num; i++){
	wxString strTagParam = pCParamGroup->mVCParam[i].GetStrName();
	pCParamGroup->mVCParam[i].SetValueAtCommand(nt, VValue[i], strTag + strTagParam);
    }
    
    return ReturnTrue(L);
}

int CLS::
GetLink(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    wxString strParamGroup = lua_tostring(L, 2);
    lua_pop(L, lua_gettop(L));
    if (pCObj == NULL) return 0;
    
    ParamGroup_cls* pCParamGroup = pCObj->GetPCParamGroup(strParamGroup);
    if (pCParamGroup != NULL){
	bool bLinked = pCParamGroup->mCbLinked.GetBodyBOOL();
	return ReturnInteger(L, (int)bLinked);
    }
    return 0;
}

int CLS::
SetLink(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    wxString strParamGroup = lua_tostring(L, 2);
    bool bLink = GetBool(lua_tostring(L, 3));

    lua_pop(L, lua_gettop(L));
    if (pCObj == NULL) return ReturnFalse(L);
    
    ParamGroup_cls* pCParamGroup = pCObj->GetPCParamGroup(strParamGroup);
    if (pCParamGroup == NULL) return ReturnFalse(L);
    
    wxString strItem = pCObj->GetStrTag(pCParamGroup) << "::";
    GetPCMain()->SetParamGroupConfCommand(strItem, "Linked=", bLink);
    
    return ReturnTrue(L);
}

int CLS::
GetParamGroupShy(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    wxString strParamGroup = lua_tostring(L, 2);
    lua_pop(L, lua_gettop(L));
    if (pCObj == NULL) return 0;
    
    ParamGroup_cls* pCParamGroup = pCObj->GetPCParamGroup(strParamGroup);
    if (pCParamGroup != NULL){
	bool bShy = pCParamGroup->mCbShy.GetBodyBOOL();
	return ReturnInteger(L, (int)bShy);
    }
    return 0;
}

int CLS::
SetParamGroupShy(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    wxString strParamGroup = lua_tostring(L, 2);
    bool bShy = GetBool(lua_tostring(L, 3));

    lua_pop(L, lua_gettop(L));
    if (pCObj == NULL) return ReturnFalse(L);
    
    ParamGroup_cls* pCParamGroup = pCObj->GetPCParamGroup(strParamGroup);
    if (pCParamGroup == NULL) return ReturnFalse(L);
    
    wxString strItem = pCObj->GetStrTag(pCParamGroup) << "::";
    GetPCMain()->SetParamGroupConfCommand(strItem, "Shy=", bShy);
    
    return ReturnTrue(L);
}

int CLS::
GetUseExpression(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    wxString strParamGroup = lua_tostring(L, 2);
    lua_pop(L, lua_gettop(L));
    if (pCObj == NULL) return 0;
    
    ParamGroup_cls* pCParamGroup = pCObj->GetPCParamGroup(strParamGroup);
    if (pCParamGroup != NULL){
	bool bShy = pCParamGroup->mCbExpression.GetBodyBOOL();
	return ReturnInteger(L, (int)bShy);
    }
    return 0;
}

int CLS::
SetUseExpression(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    wxString strParamGroup = lua_tostring(L, 2);
    bool bUse = GetBool(lua_tostring(L, 3));

    lua_pop(L, lua_gettop(L));
    if (pCObj == NULL) return ReturnFalse(L);
    
    ParamGroup_cls* pCParamGroup = pCObj->GetPCParamGroup(strParamGroup);
    if (pCParamGroup == NULL) return ReturnFalse(L);
    
    wxString strItem = pCObj->GetStrTag(pCParamGroup) << "::";
    GetPCMain()->SetParamGroupConfCommand(strItem, "UseExpr=", bUse);
    
    return ReturnTrue(L);
}

int CLS::
GetExpression(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    wxString strParamGroup = lua_tostring(L, 2);
    lua_pop(L, lua_gettop(L));
    if (pCObj == NULL) return 0;
    
    ParamGroup_cls* pCParamGroup = pCObj->GetPCParamGroup(strParamGroup);
    if (pCParamGroup != NULL){
	wxString strExpr = pCParamGroup->mCbExpression.GetBodySTR();
	lua_pushstring(L, strExpr);
	return 1;
    }
    return 0;
}

int CLS::
SetExpression(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    wxString strParamGroup = lua_tostring(L, 2);
    wxString strExpr = lua_tostring(L, 3);

    lua_pop(L, lua_gettop(L));
    if (pCObj == NULL) return ReturnFalse(L);
    
    ParamGroup_cls* pCParamGroup = pCObj->GetPCParamGroup(strParamGroup);
    if (pCParamGroup == NULL) return ReturnFalse(L);
    
    wxString strItem = pCObj->GetStrTag(pCParamGroup) << "::";
    GetPCMain()->SetParamGroupConfCommand(strItem, "Expression=", strExpr);
    
    return ReturnTrue(L);
}

int CLS::
GetTimeDependency(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    wxString strParamGroup = lua_tostring(L, 2);
    lua_pop(L, lua_gettop(L));
    if (pCObj == NULL) return 0;

    ParamGroup_cls* pCParamGroup = pCObj->GetPCParamGroup(strParamGroup);
    if (pCParamGroup != NULL){
	uint num = pCParamGroup->mVCParam.size();
	for (uint i = 0; i < num; i++)
	    lua_pushnumber(L, pCParamGroup->mVCParam[i].mCbTimeDepend.GetBodyBOOL());
	return num;
    }
    return 0;
}

int CLS::
SetTimeDependency(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    wxString strParamGroup = lua_tostring(L, 2);
    int top = lua_gettop(L);
    std::vector < bool > VbValue;
    for (int i = 3; i <= top; i++){
	wxString strArg = wxString::FromAscii(lua_tostring(L, i));
	bool bValue = GetBool(strArg);
	VbValue.push_back(bValue);
    }

    lua_pop(L, lua_gettop(L));
    if (pCObj == NULL) return ReturnFalse(L);

    ParamGroup_cls* pCParamGroup = pCObj->GetPCParamGroup(strParamGroup);
    if (pCParamGroup == NULL) return ReturnFalse(L);

    if (pCParamGroup->mVCParam.size() != VbValue.size()) return ReturnFalse(L);
    
    wxString strTag = pCObj->GetStrTag(pCParamGroup) << "::";
    uint num = VbValue.size();
    bool bLinked = pCParamGroup->mCbLinked.GetBodyBOOL();
    pCParamGroup->mCbLinked.SetBodyFromData((long long)0);
    GetPCUndo()->OpenBlock("SetTimeDependency");
    for (uint i = 0; i < num; i++){
	wxString strTagParam = pCParamGroup->mVCParam[i].GetStrName();
	GetPCMain()->SetParameterConfCommand(strTag + strTagParam, "TimeDepend=", VbValue[i]);
    }
    GetPCUndo()->CloseBlock("SetTimeDependency");
    pCParamGroup->mCbLinked.SetBodyFromData((long long)bLinked);

    lua_pop(L, lua_gettop(L));
    if (pCObj == NULL) return ReturnFalse(L);
    
    return ReturnTrue(L);
}

int CLS::
GetObjectShy(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);

    lua_pop(L, lua_gettop(L));
    if (pCObj == NULL) return 0;

    lua_pushinteger(L, pCObj->mCbShy.GetBodyBOOL());
    return 1;
}

int CLS::
SetObjectShy(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    bool bShy = GetBool(lua_tostring(L, 2));
    
    lua_pop(L, lua_gettop(L));
    if (pCObj == NULL) return ReturnFalse(L);

    wxString strData; strData << bShy;
    pCObj->mCbShy.PushCommandPair(strData);
    return ReturnTrue(L);
}

int CLS::
GetObjectConfList(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    if (pCObj == NULL) return 0;

    wxArrayString AstrList = pCObj->GetAstrItemList();
    uint num = AstrList.size();
    for (uint i = 0; i < num; i++)
	lua_pushstring(L, AstrList[i].RemoveLast().ToAscii());
    return num;
}

int CLS::
GetObjectConfItem(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    wxString strConfItem = lua_tostring(L, 2);
    if (pCObj == NULL) return 0;

    ConfItemBase_cls *pCConf = pCObj->GetPCItem(strConfItem);
    if (pCConf == NULL) return 0;

    lua_pushstring(L, pCConf->GetBodySTR().ToAscii());
    return 1;
}

int CLS::
GetObjectAttribList(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    if (pCObj == NULL) return 0;

    wxArrayString AstrList = pCObj->GetAstrAttribList();
    uint num = AstrList.size();
    for (uint i = 0; i < num; i++)
	lua_pushstring(L, AstrList[i].ToAscii());
    return num;
}

int CLS::
GetObjectAttribConfList(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    wxString strAttribItem = lua_tostring(L, 2);
    if (pCObj == NULL) return 0;

    Attribute_cls *pCAttrib = pCObj->GetPCAttribute(strAttribItem);
    if (pCAttrib == NULL) return 0;

    wxArrayString AstrList = pCAttrib->GetAstrItemList();
    uint num = AstrList.size();
    for (uint i = 0; i < num; i++)
	lua_pushstring(L, AstrList[i].RemoveLast().ToAscii());
    return num;
}

int CLS::
GetObjectAttribConfItem(lua_State *L){
    SceneObj_cls *pCObj = GetPCSceneObjFromFirstArg(L);
    wxString strAttribItem = lua_tostring(L, 2);
    wxString strConfItem = lua_tostring(L, 3);
    if (pCObj == NULL) return 0;

    Attribute_cls *pCAttrib = pCObj->GetPCAttribute(strAttribItem);
    if (pCAttrib == NULL) return 0;

    ConfItemBase_cls *pCConf = pCAttrib->GetPCItem(strConfItem);
    if (pCConf == NULL) return 0;
    
    lua_pushstring(L, pCConf->GetBodySTR().ToAscii());
    return 1;
}

int CLS::
ThisGetValueAt(lua_State *L){
    double nt;wxString::FromAscii(lua_tostring(L, 1)).ToDouble(&nt);
    lua_pop(L, lua_gettop(L));
    
    lua_getglobal(L, "ParamGroup");
    ParamGroup_cls* pCParamGroup = (ParamGroup_cls*)lua_touserdata(L, 1);
    if (pCParamGroup != NULL){
	std::vector < double > VValue = pCParamGroup->GetVInterpolatedValue(nt, FALSE);
	uint num = VValue.size();
	for (uint i = 0; i < num; i++)
	    lua_pushnumber(L, VValue[i]);
	return num;
    }

    return 0;
}

int CLS::
ThisGetKeyNum(lua_State *L){
    long i;wxString::FromAscii(lua_tostring(L, 1)).ToLong(&i);
    lua_pop(L, lua_gettop(L));

    lua_getglobal(L, "ParamGroup");
    ParamGroup_cls* pCParamGroup = (ParamGroup_cls*)lua_touserdata(L, 1);
    if (pCParamGroup != NULL){
	uint num = pCParamGroup->mVCParam.size();
	if (i < 0 || i >= num) return 0;
	lua_pushnumber(L, pCParamGroup->mVCParam[i].mVCKeys.size());
	
	return 1;
    }
    
    return 0;
}

LuaInterpreter_cls* GpCLuaInterpreter = NULL;
