// -*- c++ -*- 
// "clsLuaMiniCalc.h"
// (setq c-basic-offset 4)

#include "clsLuaMiniCalc.h"
#include "clsLuaBase.h"

#include "../COMMON/CommonDefinitions.h"

bool LuaMiniCalc_cls::
IsStringExpression(wxString &str){
    if (str.find(wxT("+")) != wxNOT_FOUND) return TRUE;
    if (str.find(wxT("-")) != wxNOT_FOUND) return TRUE;
    if (str.find(wxT("*")) != wxNOT_FOUND) return TRUE;
    if (str.find(wxT("/")) != wxNOT_FOUND) return TRUE;
    return FALSE;
}

float LuaMiniCalc_cls::
GetValue(wxString strExp){
    wxString strFunction;
    strFunction << wxT("function script()") << ENDL;
    strFunction << wxT("return ") << strExp << ENDL;
    strFunction << wxT("end") << ENDL;

    lua_State *pLua = luaL_newstate();
    if (pLua == NULL) return 0;

    luaL_openlibs(pLua);
    
    if (luaL_dostring(pLua, strFunction.ToAscii()) != 0){
	LuaBase_cls::CheckErrorMessage(pLua, wxT("MiniCalc::DoString::"));
	lua_close(pLua);
	return 0;
    }
	
    lua_getglobal(pLua, "script");
    if (lua_pcall(pLua, 0, 1, 0) != 0){
	LuaBase_cls::CheckErrorMessage(pLua, wxT("MiniCalc::"));
	lua_close(pLua);
	return 0;
    }
    
    float value = lua_tonumber(pLua, -1);
    lua_pop(pLua, 1);
	    
    lua_close(pLua);

    return value;
}

LuaMiniCalc_cls *GpCLuaMinicalc = NULL;
