// (setq c-basic-offset 4)
// "clsPropertyBase.h"

#include "clsPropertyBase.h"

#include "../../COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;
#include "../../SCENEOBJ/clsSceneObjCtrl.h"
#include "../../WIDGETCTRL/clsBitmapPanel.h"
#include "../../WIDGETCTRL/INPUTITEM/clsVCenter.h"
#include "../../WIDGETCTRL/MULTIINPUT/clsMNumPainBase.h"
#include "../../WIDGETCTRL/EX/clsColourDialogEX.h"
#include "../../WIDGETCTRL/WX/clsSizeAdjuster.h"

#include <wx/wx.h>

#include "../../COMMON/CommonDefinitions.h"
#include "../../../wxWidgetEnum.h"

#define CLS PropertyBase_cls

CLS::
PropertyBase_cls(Property_cls *pCParent){
    mpCParent = pCParent;
}

MNumPainBase_cls* CLS::
GetPCNewPain(wxWindow *pCParent, bool bPanelForObject){
    wxString strActiveObj = GetPCSceneObjCtrl()->GetActiveObjectName();
    wxSize CSize = wxDS;
    MNumPainBase_cls *pCPain = new MNumPainBase_cls(pCParent, CSize, FALSE);
    pCPain->mbHideButton = FALSE;
    if (bPanelForObject == TRUE)
	pCPain->mstrTag = GetPCSceneObjCtrl()->GetStrSelf() << "Obj::" << strActiveObj;
    else
	pCPain->mstrTag = GetPCSceneObjCtrl()->GetStrSelf() << "None";
    return pCPain;
}

SceneObj_cls* CLS::
GetPCLinkedObj(){
    wxString strTgt = mCstrLinkedObject.GetBodySTR();
    if (strTgt.IsSameAs("None")) return NULL;
    if (strTgt.IsEmpty() == TRUE) return NULL;

    wxString strController = PopStrItemFromStrLine(strTgt, "::");
    ASSERT(strController.IsSameAs("SceneObjCtrl"));
    PopStrItemFromStrLine(strTgt, "::");
    wxString strObj = PopStrItemFromStrLine(strTgt, "::");

    return GetPCSceneObjCtrl()->GetPCFromName(strObj);
}

wxBoxSizer* CLS::
GetNewPCBoxSizerInfoWithItems(wxWindow *pCParent){
    wxBoxSizer *pBoxSizerInfo = new wxBoxSizer(wxHORIZONTAL);

    BitmapPanel_cls *pCBtnPinMode = new BitmapPanel_cls(pCParent, btnGraphPin, wxDP, wxSize(20, 20));
    pCBtnPinMode->AddBitmapStr("wxART_UNPIN_N", "wxART_UNPIN_P");
    pCBtnPinMode->AddBitmapStr("wxART_PIN_N", "wxART_PIN_P");
    pCBtnPinMode->mbButton = TRUE;
    pCBtnPinMode->SetBorder(1, 1);
    BitmapPanel_cls *pCBtnDropDown = new BitmapPanel_cls(pCParent, btnDropdown, wxDP, wxSize(14, 14));
    pCBtnDropDown->AddBitmapStr("wxART_DROPDOWN");
    pCBtnDropDown->mbButton = TRUE;
    pCBtnPinMode->SetBorder(1, 1);
    VCenter_cls *pCVCenterDropDown = new VCenter_cls(pCBtnDropDown);
    
    mpCLinkedObject = new wxStaticText(pCParent, wxID_ANY, "dummy");
    pBoxSizerInfo->Add(pCBtnPinMode, 0, wxEXPAND);
    pBoxSizerInfo->Add(mpCLinkedObject, 0, wxEXPAND);
    pBoxSizerInfo->AddSpacer(4);
    pBoxSizerInfo->Add(pCVCenterDropDown, 0, wxEXPAND);
    
    pBoxSizerInfo->AddStretchSpacer(1);

    return pBoxSizerInfo;
}

std::vector < float > CLS::
GetColorFromDialog(wxColour CInitColor){
    std::vector < float > VClr;

    wxColourDialogEX *pCDLG = GetPCColourDialog();
    pCDLG->SetColour(CInitColor);

    wxRect CRect(wxGetMousePosition()-wxPoint(250, 250), wxSize(545, 385));
    GCClassProvider.GetPCSizeAdjuster()->AdjustWindowFitting(pCDLG, CRect);

    if (pCDLG->ShowModal() == wxID_CANCEL) return VClr;

    VClr.push_back((float)pCDLG->GetR()/255);
    VClr.push_back((float)pCDLG->GetG()/255);
    VClr.push_back((float)pCDLG->GetB()/255);

    return VClr;
}

void CLS::
ProcAfterMathProperty(const wxString& strCommand, wxString strItem, bool bForce){
	
    if (strCommand.IsSameAs("DeleteObject")){

	wxString strTgt = mCstrLinkedObject.GetBodySTR();
	wxString strController = PopStrItemFromStrLine(strTgt, "::");
	if (strController.IsSameAs("SceneObjCtrl")){
	    PopStrItemFromStrLine(strTgt, "::");
	    wxString strObj = PopStrItemFromStrLine(strTgt, "::");
	    if (strObj.IsSameAs(strItem)){
		mCstrLinkedObject.SetBodyFromData("None");
		mpCLinkedObject->SetLabel(mCstrLinkedObject.GetBodySTR());
	    }
	    Reconnect();
	}
    }
    if (strCommand.IsSameAs("RenameObject")){
	wxString strNameOld = PopStrItemFromStrLine(strItem, "::");
	wxString strNameNew = strItem;

	wxString strTgt = mCstrLinkedObject.GetBodySTR();
	wxString strController = PopStrItemFromStrLine(strTgt, "::");
	if (strController.IsSameAs("SceneObjCtrl")){
	    PopStrItemFromStrLine(strTgt, "::");
	    wxString strObj = PopStrItemFromStrLine(strTgt, "::");
	    if (strObj.IsSameAs(strNameOld)){
		mCstrLinkedObject.mstrBody.Replace(strNameOld, strNameNew);
		mpCLinkedObject->SetLabel(mCstrLinkedObject.GetBodySTR());
	    }
	    Reconnect();
	}
    }
    if (strCommand.IsSameAs("SelectObject")){
	if (bForce == FALSE && mCbPinned.GetBodyBOOL() == TRUE){
	    // Ô̂Select̂́AăRlNgړÎƂ̂
	    // PinĂĂ
	    if (mCstrLinkedObject.GetBodySTR().IsSameAs(strItem) == FALSE)
		return;
	}

	mCstrLinkedObject.SetBodyFromData(strItem);
	mpCLinkedObject->SetLabel(strItem);
	Reconnect();
	UpdatePanels("ALL");
    }

    if (strCommand.IsSameAs("ColorCurveChange")){
	UpdatePanels("ALL");
    }
	
}
