// (setq c-basic-offset 4)
// "clsPropertyFormat.cpp"

#ifndef _PROPERTY_FORMAT_H
#define _PROPERTY_FORMAT_H

#include "clsPropertyBase.h"

#include "../../CONFITEM/clsConfListContainer.h"
#include "../../INPUTMETHOD/clsSelectorPopup.h"
#include "../../WIDGETCTRL/EX/wxPanelEX.h"
#include "../../WIDGETCTRL/MULTIINPUT/clsHookCtrl.h"

class MeshObj_cls;
class MultiInputPanel_cls;
class MNumPainBase_cls;
class Particle_cls;
class Property_cls;
class Streamline_cls;

#include "../../COMMON/CommonDefinitionsWX.h"
#include "../../../wxWidgetEnum.h"

class PropertyFormat_cls : public wxPanelEX, public PropertyBase_cls, public ConfListContainer_cls, public HookItem_cls {
public:
    PropertyFormat_cls(Property_cls *pCParent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDP, const wxSize &size=wxDS, long style=wxTAB_TRAVERSAL);

    wxArrayString mAstrClosedItem;

    void SetToDefaultParam();

    //wxStaticText *mpCTextFormat;
    //int mLineNumber;
    int  mCurrentDataType;

    SelectorPopup_cls mCSelector;

    void ClearPanels();
    void Disconnect();
    void Reconnect();
    void ConnectParticle(Particle_cls* pCObj);
    void ConnectStreamline(Streamline_cls* pCObj);
    void ConnectMesh(MeshObj_cls* pCObj);
    
    //void CheckLineNumber(wxString strInfo);
    void CheckFormat();
    void UpdatePanels(const wxString& strPanelTag);

    void HookFunc01(wxCommandEvent& event){OnHeaderChange(event);}
    void OnHeaderChange(wxCommandEvent& event);
    void HookFunc02(wxCommandEvent& event){OnBodyChange(event);}
    void OnBodyChange(wxCommandEvent& event);

    void OnDropDown(wxCommandEvent& event);
    void OnPinMode(wxCommandEvent& event);
    void OnPopMenu(wxCommandEvent& event);
    void OnDeleteHeader(wxCommandEvent& event);
    void OnAddHeader(wxCommandEvent& event);
    void OnUpHeader(wxCommandEvent& event);
    void OnDownHeader(wxCommandEvent& event);
    void OnDeleteBody(wxCommandEvent& event);
    void OnAddBody(wxCommandEvent& event);
    void OnUpBody(wxCommandEvent& event);
    void OnDownBody(wxCommandEvent& event);

    DECLARE_EVENT_TABLE()
};

#endif
