// (setq c-basic-offset 4)
// "clsPropertyInfo.cpp"

#ifndef _PROPERTY_INFO_H
#define _PROPERTY_INFO_H

#include "clsPropertyBase.h"

#include "../../CONFITEM/clsConfListContainer.h"
#include "../../INPUTMETHOD/clsSelectorPopup.h"
#include "../../WIDGETCTRL/EX/wxPanelEX.h"

class MultiInputPanel_cls;
class MNumPainBase_cls;
class Particle_cls;
class Property_cls;
class VolumeBox_cls;

#include "../../COMMON/CommonDefinitionsWX.h"
#include "../../../wxWidgetEnum.h"

class PropertyInfo_cls : public wxPanelEX, public PropertyBase_cls, public ConfListContainer_cls {
public:
    PropertyInfo_cls(Property_cls *pCParent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDP, const wxSize &size=wxDS, long style=wxTAB_TRAVERSAL);

    wxArrayString mAstrClosedItem;

    void SetToDefaultParam();

    wxStaticText *mpCTextInfo;
    int mLineNumber;

    SelectorPopup_cls mCSelector;

    void ClearPanels();
    void Disconnect();
    void Reconnect();
    void ConnectParticle(Particle_cls* pCObj);
    void ConnectVolume(VolumeBox_cls* pCObj);
    
    void CheckLineNumber(wxString strInfo);
    void UpdatePanels(const wxString& strPanelTag);

    void OnDropDown(wxCommandEvent& event);
    void OnPinMode(wxCommandEvent& event);
    void OnPopMenu(wxCommandEvent& event);
    void OnIDSearch(wxCommandEvent& event);

    DECLARE_EVENT_TABLE()
};

#endif
