//(setq c-basic-offset 4)
// "clsPropertyMaterial.h"

#include "clsPropertyMaterial.h"
#include "../clsProperty.h"

#include "../../COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;

#include "../../SCENEOBJ/clsMaterial.h"
#include "../../SCENEOBJ/clsMaterialLight.h"
#include "../../SCENEOBJ/clsMeshObj.h"
#include "../../SCENEOBJ/clsLightSource.h"
#include "../../SCENEOBJ/clsPrimitive.h"
#include "../../SCENEOBJ/clsSceneObj.h"
#include "../../SCENEOBJ/clsSceneObjCtrl.h"
#include "../../SCENEOBJ/clsTextObj.h"
#include "../../SCENEOBJ/DATAVIEWER/clsColorCurve.h"
#include "../../SCENEOBJ/DATAVIEWER/clsHeightField.h"
#include "../../SCENEOBJ/DATAVIEWER/clsMaterialParticle.h"
#include "../../SCENEOBJ/DATAVIEWER/clsMaterialStreamline.h"
#include "../../SCENEOBJ/DATAVIEWER/clsVolumeBox.h"
#include "../../SCENEOBJ/DATAVIEWER/clsIsosurface.h"
#include "../../SCENEOBJ/DATAVIEWER/clsParticle.h"
#include "../../SCENEOBJ/DATAVIEWER/clsStreamline.h"
#include "../../TIMELINE/clsTimeCtrl.h"
#include "../../UNDO/clsUndoManager.h"
#include "../../WIDGETCTRL/clsBitmapPanel.h"
#include "../../WIDGETCTRL/MULTIINPUT/clsMultiInputPanel.h"
#include "../../WIDGETCTRL/MULTIINPUT/clsMNumPainBase.h"
#include "../../WIDGETCTRL/EX/clsFileDialogEX.h"
#include "../../WIDGETCTRL/WX/clsStringProvider.h"

#include "../../../clsMain.h"

#include <wx/clipbrd.h>

#include "../../COMMON/CommonDefinitions.h"
#include "../../../wxWidgetEnum.h"
#include "../../../wxWidgetEnumMenu.h"

#define CLS PropertyMaterial_cls

#define EVT_BUTTON_RANGE(id1, id2, func) wx__DECLARE_EVT2(wxEVT_COMMAND_BUTTON_CLICKED, id1, id2, wxCommandEventHandler(func))

BEGIN_EVENT_TABLE(CLS, wxPanelEX)
EVT_BUTTON(btnGraphPin, CLS::OnPinMode)
EVT_BUTTON(btnDropdown, CLS::OnDropDown)
EVT_BUTTON(btnMaterialClearLink, CLS::OnClearLink)
EVT_BUTTON(btnAddMaterial, CLS::OnAddItem)
EVT_BUTTON(btnMaterialAmbient, CLS::OnBtnAmbient)
EVT_BUTTON(btnMaterialDiffuse, CLS::OnBtnDiffuse)
EVT_BUTTON(btnMaterialSpecular, CLS::OnBtnSpecular)
EVT_BUTTON(btnMaterialTexture, CLS::OnTexture)
EVT_BUTTON(btnMaterialClearTexture, CLS::OnClearTexture)
EVT_BUTTON_RANGE(btnParticleTexture0, btnParticleTexture2, CLS::OnParticleTexture)
EVT_BUTTON_RANGE(btnParticleClearTexture0, btnParticleClearTexture2, CLS::OnClearParticleTexture)
EVT_BUTTON_RANGE(btnMaterialEmit0, btnMaterialEmit9, CLS::OnBtnMaterialEmit)
EVT_BUTTON_RANGE(btnMaterialDiffuse0, btnMaterialDiffuse9, CLS::OnBtnMaterialDiffuse)
EVT_BUTTON_RANGE(btnMaterialSpecular0, btnMaterialSpecular9, CLS::OnBtnMaterialSpecular)

EVT_BUTTON_RANGE(btnMaterialColorCurve0, btnMaterialColorCurve9, CLS::OnColorCurve)
EVT_BUTTON(btnMaterialColorCurveAdd, CLS::OnAddColorCurve)
EVT_BUTTON(btnMaterialColorCurveDelete, CLS::OnDeleteColorCurve)
EVT_BUTTON(btnParticleTextureAdd, CLS::OnAddTexture)
EVT_BUTTON(btnParticleTextureDelete, CLS::OnDeleteTexture)
EVT_BUTTON(btnMaterialMaterialDelete, CLS::OnDeleteMaterial)
EVT_MENU_RANGE(menuPop0, menuPop9, CLS::OnPopMenu)
//EVT_CHAR (PropertyRender_cls::OnKeyDown)
EVT_MENU(menuCopyColor, CLS::OnCopyColor)
EVT_MENU(menuPasteColor, CLS::OnPasteColor)
EVT_MENU(menuCopyColorCurve, CLS::OnCopyColorCurve)
EVT_MENU(menuPasteColorCurve, CLS::OnPasteColorCurve)
END_EVENT_TABLE()

CLS::
PropertyMaterial_cls(Property_cls *pCParent, wxWindowID id, const wxPoint &pos, const wxSize &size, long style) :
wxPanelEX(pCParent, id, pos, size, style), PropertyBase_cls(pCParent)
{
    SetPanelType(_PANEL_PROPERTY_MATERIAL);

    SetToDefaultParam();

    mpCBoxSizerSrc  = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer *pBoxSizerInfo = GetNewPCBoxSizerInfoWithItems(this);

    //mpCBtnAddItem = new wxButton(this, btnAddMaterial, _("Add Material"));
    //mpCBtnAddItem->Hide();
    
    mIndexBtnAmbient = mIndexBtnDiffuse = mIndexBtnSpecular = -1;
	
    SetMNumLink();

    mpCPain = GetPCNewPain(this);
    
    mpCBoxSizerSrc->Add(pBoxSizerInfo, 0, wxEXPAND);
    //mpCBoxSizerSrc->Add(mpCBtnAddItem, 0, wxEXPAND);
    mpCBoxSizerSrc->Add(mpCMNumLink, 0, wxEXPAND);
    mpCBoxSizerSrc->Add(mpCPain);
    
    SetSizerAndFit(mpCBoxSizerSrc);

    wxString strActiveObj = GetPCSceneObjCtrl()->GetActiveObjectName();
    if (strActiveObj.IsEmpty())
	Disconnect();
    else{
	wxString strTag;
	strTag << GetPCSceneObjCtrl()->GetStrSelf() << "Obj::" << strActiveObj;
	mCstrLinkedObject.SetBodyFromData(strTag);
	mpCLinkedObject->SetLabel(strTag);
	Reconnect();
    }
}

void CLS::
HideAndShow(){
    SceneObj_cls *pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;

    bool bChange = FALSE;
    MultiInputPanel_cls* pCMNumShader = mpCPain->GetPCMNum("Shader");
    if (pCMNumShader != NULL){
	bChange |= HideAndShowShader(pCMNumShader, pCObj->GetPCMaterial());
    }

    if (pCObj->mstrClassName.IsSameAs("Particle_cls")){
	Particle_cls* pCParticle = (Particle_cls*)pCObj;
	bChange |= pCParticle->HideAndShowMaterialCommon(mpCPain);
	int numMaterial = pCParticle->GetNumAttribute("MaterialParticle_cls");
	for (int i = 0; i < numMaterial; i++){
	    MaterialParticle_cls *pCMat = (MaterialParticle_cls*)pCObj->GetPCAttributeFromAttribName("MaterialParticle_cls", i);
	    MultiInputPanel_cls* pCMNumMat = mpCPain->GetPCMNum(pCMat->mstrMNumName);
	    if (pCMNumMat != NULL)
		bChange |= pCMat->HideAndShowMaterial(pCMNumMat);
	}
    }

    if (pCObj->mstrClassName.IsSameAs("Primitive_cls")){
	Primitive_cls* pCPrimitive = (Primitive_cls*)pCObj;
	MultiInputPanel_cls* pCMNumTex = mpCPain->GetPCMNum("Texture");
	bChange |= pCPrimitive->HideAndShowTexture(pCMNumTex, mIndexTexturePath);
    }

    if (pCObj->mstrClassName.IsSameAs("Streamline_cls")){
	Streamline_cls* pCStreamline = (Streamline_cls*)pCObj;
	MultiInputPanel_cls *pCMNumShader = mpCPain->GetPCMNum("StreamlineShader");
	bChange |= pCStreamline->HideAndShowShader(pCMNumShader);
	MultiInputPanel_cls* pCMNumTex = mpCPain->GetPCMNum("Texture");
	bChange |= pCStreamline->HideAndShowTexture(pCMNumTex, mIndexTexturePath);
    }

    if (pCObj->mstrClassName.IsSameAs("HeightField_cls")){
	HeightField_cls* pCHF = (HeightField_cls*)pCObj;
	MultiInputPanel_cls* pCMNumTex = mpCPain->GetPCMNum("Texture");
	bChange |= pCHF->HideAndShowTexture(pCMNumTex, mIndexTexturePath);
    }

    if (bChange == TRUE){
	Layout();
	GetParent()->Layout();
    }
}

bool CLS::
HideAndShowShader(MultiInputPanel_cls *pCMNum, Material_cls *pCMaterial){
    bool bFlat = FALSE, bThreshld = FALSE;
    int type = pCMaterial->mCShaderType.GetBodyINT();
    if (type == _MATERIAL_SHADER_PHONG ||
	type == _MATERIAL_SHADER_TOON ||
	type == _MATERIAL_SHADER_NORMAL) bFlat = TRUE;
    if (type == _MATERIAL_SHADER_TOON) bThreshld = TRUE;
    
    bool bChange = FALSE;
    bChange |= pCMNum->mVCItem[mIndexFlat].Show(bFlat);
    bChange |= pCMNum->mVCItem[mIndexThreshold].Show(bThreshld);

    return bChange;
}

void CLS::
SetToDefaultParam(){
    mCConfList.Clear();
    mCConfList.SetTag("PropertyMaterial");
    mCConfList.Add(&mCstrLinkedObject, "LinkedObject=", "None");
    mCConfList.Add(&mCbPinned, "Pinned=", "0");

    mCAmbient.SetItem("Ambient=", "0.2 0.2 0.2");
    mCDiffuse.SetItem("Diffuse=", "0.8 0.8 0.8");
    mCSpecular.SetItem("Specular=", "0.2 0.2 0.2");
    mCShininess.SetItem("Shininess=", "24");
    mCAlpha.SetItem("Alpha=", "1");
    mCStrength.SetItem("Strength=", "1");
}

void CLS::
SetMNumLink(){
    MultiInputPanel_cls *pC = 
	MultiInputPanel_cls::Initialize(&mpCMNumLink, this,
					wxT("PropertyMaterialLink"));

    pC->mTextWidth = 80;
    pC->CombineSizer(3, _("Link"));
    pC->CombineBitmapPanel(btnDropdown, wxES, 14);
    pC->mVCItem.back().mBitmapTemplate = _BITMAP_BTN_DROPDOWN;
    pC->mVCItem.back().mbUseVCenter = TRUE;
    pC->mVCItem.back().mstrCommandStr = "Link";
    mIndexLink = pC->CombineConfItem(mCDummySTR);
    mIndexLinkCancel = pC->CombineBitmapPanel(btnMaterialClearLink, "Clear", 24);
    pC->mVCItem.back().mbUseVCenter = TRUE;

    pC->FinishSetting();

    BitmapPanel_cls *pCBitmap = (BitmapPanel_cls*)pC->mVCItem[mIndexLinkCancel].mpCWindowLink;
    pCBitmap->mbButton = TRUE;
    pCBitmap->AddBitmapStr("wxART_CLOSE_PANEL", "wxART_CLOSE_PANEL_P");
    pCBitmap->SetBitmapStrDisable("wxART_CLOSE_PANEL_D");
    pCBitmap->mBorderX = 4;
    pCBitmap->mBorderY = 4;

    pC->SetHook(this, &HookItem_cls::HookFunc01, wxEVT_COMMAND_TEXT_ENTER);
}

MultiInputPanel_cls* CLS::
GetPCNewPanelMaterial(wxWindow *pCWindow){

    MultiInputPanel_cls *pC = 
	new MultiInputPanel_cls(pCWindow, "Coloring"/*, TRUE*/);
    
    pC->mTextWidth = 80;

    pC->CombineSizer(2, _("Ambient"));
    pC->SetLimit(0, 1);
    pC->mDragScale = 0.1;
    mIndexAmbient = pC->CombineConfItem(mCAmbient);
    pC->mContextMenuType = _ITEM_MENU_COLOR;
    mIndexBtnAmbient = pC->CombineBitmapPanel(btnMaterialAmbient, " ",  30);

    pC->CombineSizer(2, _("Diffuse"));
    pC->SetLimit(0, 1);
    pC->mDragScale = 0.1;
    mIndexDiffuse = pC->CombineConfItem(mCDiffuse);
    pC->mContextMenuType = _ITEM_MENU_COLOR;
    mIndexBtnDiffuse = pC->CombineBitmapPanel(btnMaterialDiffuse, " ",  30);

    pC->CombineSizer(2, _("Specular"));
    pC->SetLimit(0, 1);
    pC->mDragScale = 0.1;
    mIndexSpecular = pC->CombineConfItem(mCSpecular);
    pC->mContextMenuType = _ITEM_MENU_COLOR;
    mIndexBtnSpecular = pC->CombineBitmapPanel(btnMaterialSpecular, " ", 30);
    
    mIndexShineAlpha = pC->CombineSizer(2, _("Alpha/Shine"));
    pC->SetLimit(0, 127);
    pC->mDragScale = 0.2;
    pC->CombineConfItem(mCAlpha);
    pC->SetLimit(0, 127);
    pC->mDragScale = 50;
    pC->CombineConfItem(mCShininess);
    
    
    pC->mDragScale = 0.1;
    mIndexStrength = pC->CombineConfItem(mCStrength, _("Strength"));

    pC->FinishSetting();

    //pC->mVCItem[mIndexBtnAmbient].mpCWindowLink->SetBackgroundStyle(wxBG_STYLE_PAINT);
    //pC->mVCItem[mIndexBtnDiffuse].mpCWindowLink->SetBackgroundStyle(wxBG_STYLE_PAINT);
    //pC->mVCItem[mIndexBtnSpecular].mpCWindowLink->SetBackgroundStyle(wxBG_STYLE_PAINT);

    BitmapPanel_cls *pCBitmapAmbient = (BitmapPanel_cls*)pC->mVCItem[mIndexBtnAmbient].mpCWindowLink;
    pCBitmapAmbient->mbButton = TRUE;
    
    BitmapPanel_cls *pCBitmapDiffuse = (BitmapPanel_cls*)pC->mVCItem[mIndexBtnDiffuse].mpCWindowLink;
    pCBitmapDiffuse->mbButton = TRUE;
    
    BitmapPanel_cls *pCBitmapSpecular = (BitmapPanel_cls*)pC->mVCItem[mIndexBtnSpecular].mpCWindowLink;
    pCBitmapSpecular->mbButton = TRUE;
    

    pC->SetHook(this, &HookItem_cls::HookFunc02, wxEVT_COMMAND_TEXT_ENTER);

    return pC;
}

MultiInputPanel_cls* CLS::
GetPCNewPanelShader(wxWindow *pCWindow, Material_cls *pCMaterial){
    MultiInputPanel_cls *pC = 
	new MultiInputPanel_cls(pCWindow, "Shader"/*, TRUE*/);

    pC->mTextWidth = 100;
    pC->CombineSizer(2, _("Shader"));

    if (pCMaterial->mstrParentClassName.IsSameAs("HeightField_cls")){
	mIndexFlat = pC->CombineConfItem(pCMaterial->mCbShaderFlat, _("Flat"));
	
	pC->SetChoiceList(3, GetPCStringProvider()->GetAstr("ShaderDissolve"));
	pC->CombineConfItem(pCMaterial->mCShaderDissolve);
    }
    else{
	pC->SetChoiceList(6, GetPCStringProvider()->GetAstr("ShaderObject"));
	pC->CombineConfItem(pCMaterial->mCShaderType);
	
	pC->SetChoiceList(3, GetPCStringProvider()->GetAstr("ShaderDissolve"));
	pC->CombineConfItem(pCMaterial->mCShaderDissolve);

	mIndexFlat = pC->CombineConfItem(pCMaterial->mCbShaderFlat, _("Flat"));
    }
    
    mIndexThreshold = pC->CombineSizer(2, _("Threshold/Bold"));
    pC->SetLimit(0, 1);
    pC->mDragScale = 0.1;
    pC->CombineConfItem(pCMaterial->mCToonThreshold);
    pC->SetLimit(0, 1);
    pC->mDragScale = 0.1;
    pC->CombineConfItem(pCMaterial->mCToonBoldness);
    
    pC->FinishSetting();
    return pC;
}

void CLS::
ClearPanels(){
    if (mpCPain != NULL){
	mpCBoxSizerSrc->Detach(mpCPain);
	uint num = mpCPain->mVpCMNumPanelLink.size();
	for (uint i = 0; i < num; i++)
	    mpCPain->mVpCMNumPanelLink[i]->mbVolatile = TRUE;
	delete mpCPain;
	mpCPain = NULL;
    }
}

void CLS::
Disconnect(){
    SetMinSize(wxSize(-1, -1));
    mpCMNumLink->CombineToDummy(mIndexLink, mCDummySTR);
    
    ClearPanels();
    Layout();
}

void CLS::
UseLink(bool bUse){
    if (bUse == TRUE){
	mpCMNumLink->mVCItem[mIndexLink].Show();
	mpCMNumLink->mVCItem[mIndexLinkCancel].Show();
    }
    else{
	mpCMNumLink->mVCItem[mIndexLink].Hide();
	mpCMNumLink->mVCItem[mIndexLinkCancel].Hide();
    }
}

void CLS::
ConnectPrimitive(Primitive_cls* pCObj){
    //wxString strMNumName = mpCMNumTexture->GetName();

    MultiInputPanel_cls *pCMNum = GetPCNewPanelMaterial(mpCPain);
    mpCPain->SetMNum(pCMNum, mAstrClosedItem, "Coloring", TRUE, TRUE);

    mpCPain->GetPCMNum("Coloring")->mVCItem[mIndexStrength].Hide();

    MultiInputPanel_cls *pCMNumTex = pCObj->mpCMaterial->GetPCNewPanelTexture
	(mpCPain, mCDummySTR, mIndexTexturePath);
    mpCPain->SetMNum(pCMNumTex, mAstrClosedItem, "Texture", TRUE, TRUE);
    
    MultiInputPanel_cls *pCMNumShader = GetPCNewPanelShader(mpCPain, pCObj->mpCMaterial);
    mpCPain->SetMNum(pCMNumShader, mAstrClosedItem, "Shader", TRUE, TRUE);

    MultiInputPanel_cls *pCMNumOption = pCObj->mpCMaterial->GetPCNewPanelOption(mpCPain);
    mpCPain->SetMNum(pCMNumOption, mAstrClosedItem, "Option", TRUE, TRUE);
    
    mpCMNumLink->mVCItem[mIndexLink].RecombineConfItem(pCObj->mpCMaterial->mCstrLink, mpCMNumLink->GetName());
    UseLink(TRUE);
    
    mpCPain->LayoutNumPanels();
    HideAndShow();
    Layout();
}

void CLS::
ConnectMeshObj(MeshObj_cls* pCObj){
    //wxString strMNumName = mpCMNumTexture->GetName();

    MultiInputPanel_cls *pCMNum = GetPCNewPanelMaterial(mpCPain);
    mpCPain->SetMNum(pCMNum, mAstrClosedItem, "Coloring", TRUE, TRUE);

    mpCPain->GetPCMNum("Coloring")->mVCItem[mIndexStrength].Hide();

    MultiInputPanel_cls *pCMNumShader = GetPCNewPanelShader(mpCPain, pCObj->mpCMaterial);
    mpCPain->SetMNum(pCMNumShader, mAstrClosedItem, "Shader", TRUE, TRUE);

    MultiInputPanel_cls *pCMNumOption = pCObj->mpCMaterial->GetPCNewPanelOption(mpCPain);
    mpCPain->SetMNum(pCMNumOption, mAstrClosedItem, "Option", TRUE, TRUE);
    
    mpCMNumLink->mVCItem[mIndexLink].RecombineConfItem(pCObj->mpCMaterial->mCstrLink, mpCMNumLink->GetName());
    UseLink(TRUE);
        
    mpCPain->LayoutNumPanels();
    HideAndShow();
    Layout();
}

void CLS::
ConnectTextObj(TextObj_cls *pCObj){
    MultiInputPanel_cls *pCMNum = GetPCNewPanelMaterial(mpCPain);
    mpCPain->SetMNum(pCMNum, mAstrClosedItem, "Coloring", TRUE, TRUE);
    
    mpCPain->GetPCMNum("Coloring")->mVCItem[mIndexStrength].Hide();

    MultiInputPanel_cls *pCMNumShader = GetPCNewPanelShader(mpCPain, pCObj->mpCMaterial);
    mpCPain->SetMNum(pCMNumShader, mAstrClosedItem, "Shader", TRUE, TRUE);

     MultiInputPanel_cls *pCMNumOption = pCObj->mpCMaterial->GetPCNewPanelOption(mpCPain);
    mpCPain->SetMNum(pCMNumOption, mAstrClosedItem, "Option", TRUE, TRUE);
    
    UseLink(FALSE);

    mpCPain->LayoutNumPanels();
    HideAndShow();
    Layout();
}

void CLS::
ConnectLightSource(LightSource_cls* pCObj){

    MultiInputPanel_cls *pCMNum = GetPCNewPanelMaterial(mpCPain);
    mpCPain->SetMNum(pCMNum, mAstrClosedItem, "Coloring", TRUE, TRUE);

    mpCPain->GetPCMNum("Coloring")->mVCItem[mIndexShineAlpha].Hide();
    mpCPain->GetPCMNum("Coloring")->mVCItem[mIndexStrength].Show();

    UseLink(FALSE);
    
    mpCPain->LayoutNumPanels();
    HideAndShow();
    Layout();
}

void CLS::
ConnectVolumeBox(VolumeBox_cls* pCObj){

    MultiInputPanel_cls *pCMNum = GetPCNewPanelMaterial(mpCPain);
    mpCPain->SetMNum(pCMNum, mAstrClosedItem, "Coloring", TRUE, TRUE);

    mpCPain->GetPCMNum("Coloring")->mVCItem[mIndexStrength].Hide();

    mpCMNumLink->mVCItem[mIndexLink].RecombineConfItem(pCObj->mpCMaterial->mCstrLink, mpCMNumLink->GetName());
    UseLink(TRUE);
    
    MultiInputPanel_cls *pCMNumTex = pCObj->GetPCNewPanelTexture(mpCPain);
    mpCPain->SetMNum(pCMNumTex, mAstrClosedItem, "Texture", TRUE, TRUE);

    MultiInputPanel_cls *pCMNumShader = pCObj->GetPCNewPanelShader(mpCPain);
    mpCPain->SetMNum(pCMNumShader, mAstrClosedItem, "VolumeShader", TRUE, TRUE);
    
    MultiInputPanel_cls *pCMNumCC = pCObj->GetPCNewPanelColorCurve(mpCPain, NULL, &(pCObj->mCbRepeatCC));
    mpCPain->SetMNum(pCMNumCC, mAstrClosedItem, "ColorCurve", TRUE, TRUE);

    MultiInputPanel_cls *pCMNumOption = pCObj->GetPCNewPanelOption(mpCPain);
    mpCPain->SetMNum(pCMNumOption, mAstrClosedItem, "Option", TRUE, TRUE);

    mpCPain->LayoutNumPanels();
    HideAndShow();
    Layout();
}

void CLS::
ConnectIsosurface(Isosurface_cls* pCObj){
    MultiInputPanel_cls *pCMNum = GetPCNewPanelMaterial(mpCPain);
    mpCPain->SetMNum(pCMNum, mAstrClosedItem, "Coloring", TRUE, TRUE);

    mpCPain->GetPCMNum("Coloring")->mVCItem[mIndexStrength].Hide();

    mpCMNumLink->mVCItem[mIndexLink].RecombineConfItem(pCObj->mpCMaterial->mCstrLink, mpCMNumLink->GetName());
    UseLink(TRUE);
    
    MultiInputPanel_cls *pCMNumShader = GetPCNewPanelShader(mpCPain, pCObj->mpCMaterial);
    mpCPain->SetMNum(pCMNumShader, mAstrClosedItem, "Shader", TRUE, TRUE);

    MultiInputPanel_cls *pCMNumOption = pCObj->mpCMaterial->GetPCNewPanelOption(mpCPain);
    mpCPain->SetMNum(pCMNumOption, mAstrClosedItem, "Option", TRUE, TRUE);
    
    mpCPain->LayoutNumPanels();
    HideAndShow();
    Layout();
}

void CLS::
ConnectParticle(Particle_cls* pCObj){

    mpCMNumLink->mVCItem[mIndexLink].RecombineConfItem(pCObj->mCstrLink, mpCMNumLink->GetName());
    UseLink(TRUE);
    
    MultiInputPanel_cls *pCMNumCommon = pCObj->GetPCNewPanelCommon(mpCPain);
    mpCPain->SetMNum(pCMNumCommon, mAstrClosedItem, "Material.Common", TRUE, TRUE);

    int numMaterial = pCObj->GetNumAttribute("MaterialParticle_cls");
    for (int i = 0; i < numMaterial; i++){
	MultiInputPanel_cls *pCMNumMat = pCObj->GetPCNewPanelMaterial(mpCPain, i);
	pCMNumMat->SetHook(this, &HookItem_cls::HookFunc02, wxEVT_COMMAND_TEXT_ENTER);
	
	wxString strAttrib = "Material";
	strAttrib << "." << i;
	mpCPain->SetMNum(pCMNumMat, mAstrClosedItem, strAttrib, TRUE, TRUE);
    }
    mCountMaterial = numMaterial;
	    
    MultiInputPanel_cls *pCMNumCC = pCObj->GetPCNewPanelColorCurve(mpCPain);
    mpCPain->SetMNum(pCMNumCC, mAstrClosedItem, "ColorCurve", TRUE, TRUE);

    mCountColorCurve = pCObj->GetNumAttribute("ColorCurve_cls");
    mCountTexture = pCObj->mCTextureNum.GetBodyINT();

    mpCPain->LayoutNumPanels(FALSE);
    
    HideAndShow();
    Layout();
}

void CLS::
ConnectStreamline(Streamline_cls* pCObj){

    MultiInputPanel_cls *pCMNumLineProp = pCObj->GetPCNewPanelLineProp(mpCPain);
    pCMNumLineProp->SetHook(this, &HookItem_cls::HookFunc02, wxEVT_COMMAND_TEXT_ENTER);
    mpCPain->SetMNum(pCMNumLineProp, mAstrClosedItem, "LineProperty", TRUE, TRUE);

    int numMaterial = pCObj->GetNumAttribute("MaterialStreamline_cls");
    for (int i = 0; i < numMaterial; i++){
	MultiInputPanel_cls *pCMNumMat = pCObj->GetPCNewPanelMaterial(mpCPain, i);
	pCMNumMat->SetHook(this, &HookItem_cls::HookFunc02, wxEVT_COMMAND_TEXT_ENTER);
	
	wxString strAttrib = "Material";
	strAttrib << "." << i;
	mpCPain->SetMNum(pCMNumMat, mAstrClosedItem, strAttrib, TRUE, TRUE);
    }
    mCountMaterial = numMaterial;

    MultiInputPanel_cls *pCMNumShader = pCObj->GetPCNewPanelShader(mpCPain);
    mpCPain->SetMNum(pCMNumShader, mAstrClosedItem, "StreamlineShader", TRUE, TRUE);

    MaterialStreamline_cls *pCMat = (MaterialStreamline_cls*)(pCObj->GetPCAttributeFromAttribName("MaterialStreamline_cls", 0));

    MultiInputPanel_cls *pCMNumTex = pCMat->GetPCNewPanelTexture(mpCPain, mCDummySTR, mIndexTexturePath);
    mpCPain->SetMNum(pCMNumTex, mAstrClosedItem, "Texture", TRUE, TRUE);
    
    MultiInputPanel_cls *pCMNumCC = pCObj->GetPCNewPanelColorCurve(mpCPain, &(pCObj->mCbUseClrCurve), &(pCObj->mCbRepeatCC));
    mpCPain->SetMNum(pCMNumCC, mAstrClosedItem, "ColorCurve", TRUE, TRUE);

    MultiInputPanel_cls *pCMNumOption = pCMat->GetPCNewPanelOption(mpCPain, FALSE, TRUE);
    mpCPain->SetMNum(pCMNumOption, mAstrClosedItem, "Option", TRUE, TRUE);

    mpCPain->LayoutNumPanels();
    HideAndShow();
    Layout();
}

void CLS::
ConnectHF(HeightField_cls* pCObj){
    
    MultiInputPanel_cls *pCMNum = GetPCNewPanelMaterial(mpCPain);
    mpCPain->SetMNum(pCMNum, mAstrClosedItem, "Coloring", TRUE, TRUE);

    mpCPain->GetPCMNum("Coloring")->mVCItem[mIndexStrength].Hide();

    MultiInputPanel_cls *pCMNumTex = pCObj->mpCMaterial->GetPCNewPanelTexture(mpCPain, mCDummySTR, mIndexTexturePath);
    mpCPain->SetMNum(pCMNumTex, mAstrClosedItem, "Texture", TRUE, TRUE);
    
    MultiInputPanel_cls *pCMNumCC = pCObj->GetPCNewPanelColorCurve(mpCPain, &pCObj->mCbUseClrCurve);
    mpCPain->SetMNum(pCMNumCC, mAstrClosedItem, "ColorCurve", TRUE, TRUE);

    MultiInputPanel_cls *pCMNumShader = GetPCNewPanelShader(mpCPain, pCObj->mpCMaterial);
    mpCPain->SetMNum(pCMNumShader, mAstrClosedItem, "Shader", TRUE, TRUE);

    MultiInputPanel_cls *pCMNumOption = pCObj->mpCMaterial->GetPCNewPanelOption(mpCPain/*, pCObj->mpCMaterial*/);
    mpCPain->SetMNum(pCMNumOption, mAstrClosedItem, "Option", TRUE, TRUE);
    
    mpCMNumLink->mVCItem[mIndexLink].RecombineConfItem(pCObj->mpCMaterial->mCstrLink, mpCMNumLink->GetName());
    UseLink(TRUE);
    
    mpCPain->LayoutNumPanels();
    HideAndShow();
    Layout();
}

void CLS::
Reconnect(){
    Disconnect();

    SceneObj_cls *pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;

    SetMinSize(wxSize(-1, -1));

    if (mpCPain == NULL){
	mpCPain = GetPCNewPain(this);
    }

    //mpCBtnAddItem->Hide();
    
    wxString strClassName = pCObj->mstrClassName;
    if (strClassName.IsSameAs("Primitive_cls"))
	ConnectPrimitive((Primitive_cls*)pCObj);
    if (strClassName.IsSameAs("MeshObj_cls"))
	ConnectMeshObj((MeshObj_cls*)pCObj);
    if (strClassName.IsSameAs("TextObj_cls"))
	ConnectTextObj((TextObj_cls*)pCObj);
    if (strClassName.IsSameAs("LightSource_cls"))
	ConnectLightSource((LightSource_cls*)pCObj);
    if (strClassName.IsSameAs("VolumeBox_cls"))
	ConnectVolumeBox((VolumeBox_cls*)pCObj);
    if (strClassName.IsSameAs("Isosurface_cls"))
	ConnectIsosurface((Isosurface_cls*)pCObj);
    if (strClassName.IsSameAs("Particle_cls"))
	ConnectParticle((Particle_cls*)pCObj);
    if (strClassName.IsSameAs("Streamline_cls"))
	ConnectStreamline((Streamline_cls*)pCObj);
    if (strClassName.IsSameAs("HeightField_cls"))
	ConnectHF((HeightField_cls*)pCObj);
    if (strClassName.IsSameAs("World_cls"))
	UseLink(FALSE);
    if (strClassName.IsSameAs("Camera_cls"))
	UseLink(FALSE);

    wxBoxSizer *pCSizerForPain = new wxBoxSizer(wxVERTICAL);
    mpCPain->InitLayoutNumPanels(pCSizerForPain);
    mpCPain->SetSizer(pCSizerForPain);

    mpCBoxSizerSrc->Add(mpCPain, 0, wxEXPAND);
}

void CLS::
UpdateButtonColor(){
    if (mpCPain == NULL) return;

    SceneObj_cls *pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;
    if (pCObj->mstrClassName.IsSameAs("Particle_cls"))
	return UpdateButtonColorParticle();
    if (pCObj->mstrClassName.IsSameAs("Streamline_cls"))
	return UpdateButtonColorStreamline();

    MultiInputPanel_cls* pCurr = mpCPain->GetPCMNum("Coloring");
    if (pCurr == NULL) return;
    
    pCurr->mVCItem[mIndexBtnAmbient].mpCWindowLink->SetBackgroundColour(mCAmbient.GetBodyWXColor());
    pCurr->mVCItem[mIndexBtnDiffuse].mpCWindowLink->SetBackgroundColour(mCDiffuse.GetBodyWXColor());
    pCurr->mVCItem[mIndexBtnSpecular].mpCWindowLink->SetBackgroundColour(mCSpecular.GetBodyWXColor());
}

void CLS::
UpdateButtonColorParticle(){
    Particle_cls *pCObj = (Particle_cls*)GetPCLinkedObj();
    pCObj->UpdateButtonColorMaterial(mpCPain);
}

void CLS::
UpdateButtonColorStreamline(){
    Streamline_cls *pCObj = (Streamline_cls*)GetPCLinkedObj();
    pCObj->UpdateButtonColor(mpCPain);
}

void CLS::
SetMaterialInfo(){
    SceneObj_cls *pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;
    if (pCObj->mstrClassName.IsSameAs("Particle_cls"))
	return SetMaterialInfoParticle();
    if (pCObj->mstrClassName.IsSameAs("Streamline_cls"))
	return SetMaterialInfoStreamline();

    if (pCObj->mstrClassName.IsSameAs("LightSource_cls"))
	return SetMaterialInfoLightSource();
    
    Material_cls *pCMat = pCObj->GetPCMaterial();
    if (pCMat == NULL) return;
    
    double time = GetPCTimeCtrl()->GetCurrentNT();
    
    mCAmbient.SetBodyFromData
	(pCMat->GetPCParamGroup("Ambient")->GetStrValues(time, FALSE));
    mCDiffuse.SetBodyFromData
	(pCMat->GetPCParamGroup("Diffuse")->GetStrValues(time, FALSE));
    mCSpecular.SetBodyFromData
	(pCMat->GetPCParamGroup("Specular")->GetStrValues(time, FALSE));

    if (pCMat->GetPCParamGroup("Alpha") != NULL){
	mCShininess.SetBodyFromData
	    (pCMat->GetPCParamGroup("Shininess")->GetStrValues(time, FALSE));
	mCAlpha.SetBodyFromData
	    (pCMat->GetPCParamGroup("Alpha")->GetStrValues(time, FALSE));
    }
    /*
    if (pCObj->mstrClassName.IsSameAs("Primitive_cls") ||
	pCObj->mstrClassName.IsSameAs("MeshObj_cls") ||
	pCObj->mstrClassName.IsSameAs("HeightField_cls") ||
	pCObj->mstrClassName.IsSameAs("VolumeBox_cls")){
	mCShininess.SetBodyFromData
	    (pCMat->GetPCParamGroup("Shininess")->GetStrValues(time, FALSE));
	mCAlpha.SetBodyFromData
	    (pCMat->GetPCParamGroup("Alpha")->GetStrValues(time, FALSE));
    }
    */
    /*
    if (pCObj->mstrClassName.IsSameAs("LightSource_cls"))
	mCStrength.SetBodyFromData
	    (pCMat->GetPCParamGroup("Strength")->GetStrValues(time, FALSE));
    */
    /*
    if (pCObj->mstrClassName.IsSameAs("VolumeBox_cls")){
	mCShininess.SetBodyFromData
	    (pCMat->GetPCParamGroup("Shininess")->GetStrValues(time, FALSE));
	mCAlpha.SetBodyFromData
	    (pCMat->GetPCParamGroup("Alpha")->GetStrValues(time, FALSE));
    }
    */
}

void CLS::
SetMaterialInfoLightSource(){
    LightSource_cls *pCObj = (LightSource_cls*)GetPCLinkedObj();
    MaterialLight_cls *pCMat = pCObj->GetPCMaterial();
    if (pCMat == NULL) return;

    double time = GetPCTimeCtrl()->GetCurrentNT();
    mCAmbient.SetBodyFromData
	(pCMat->GetPCParamGroup("Ambient")->GetStrValues(time, FALSE));
    mCDiffuse.SetBodyFromData
	(pCMat->GetPCParamGroup("Diffuse")->GetStrValues(time, FALSE));
    mCSpecular.SetBodyFromData
	(pCMat->GetPCParamGroup("Specular")->GetStrValues(time, FALSE));
    if (pCObj->mstrClassName.IsSameAs("LightSource_cls"))
	mCStrength.SetBodyFromData
	    (pCMat->GetPCParamGroup("Strength")->GetStrValues(time, FALSE));
}

void CLS::
SetMaterialInfoParticle(){
    Particle_cls *pCObj = (Particle_cls*)GetPCLinkedObj();
    pCObj->SetMaterialInfo(mpCPain);
}

void CLS::
SetMaterialInfoStreamline(){
    Streamline_cls *pCObj = (Streamline_cls*)GetPCLinkedObj();
    pCObj->SetMaterialInfo(mpCPain);
}

void CLS::
CheckColorCurveAndTexture(){
    SceneObj_cls *pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;
    
    bool bUpdate = FALSE;
    if (pCObj->IsSameAs("Particle_cls")){
	Particle_cls *pCParticle = (Particle_cls*)pCObj;
	if (mCountColorCurve != pCParticle->GetNumAttribute("ColorCurve_cls"))
	    bUpdate = TRUE;
	if (mCountMaterial != pCParticle->GetNumAttribute("MaterialParticle_cls"))
	    bUpdate = TRUE;
	if (mCountTexture != pCParticle->mCTextureNum.GetBodyINT())
	    bUpdate = TRUE;
	
	
    }

    if (pCObj->IsSameAs("Streamline_cls")){
	Streamline_cls *pCStreamline = (Streamline_cls*)pCObj;
	if (mCountMaterial != pCStreamline->GetNumAttribute("MaterialStreamline_cls"))
	    bUpdate = TRUE;
    }
    
    if (bUpdate == TRUE)
	GetPCMain()->ProcAfterMath("SelectObject", mCstrLinkedObject.GetBodySTR());
}

void CLS::
OnLinkChange(wxCommandEvent& event){
    HideAndShow();
    Layout();
}

void CLS::
SyncMaterial(bool bGroup){
    SceneObj_cls *pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;

    if (pCObj->mstrClassName.IsSameAs("Particle_cls"))
	return SyncMaterialParticle(bGroup);

    if (pCObj->mstrClassName.IsSameAs("Streamline_cls"))
	return SyncMaterialStreamline(bGroup);

    Attribute_cls *pCMat;
    
    if (pCObj->mstrClassName.IsSameAs("LightSource_cls"))
	pCMat = ((LightSource_cls*)pCObj)->GetPCMaterial();
    else
	pCMat = pCObj->GetPCMaterial();
    if (pCMat == NULL) return;

    if (bGroup == TRUE) GetPCUndo()->OpenBlock("ClrChange");

    wxString strObj = pCObj->GetStrName();
    pCMat->SyncronizeParamAndConf3(strObj, "Ambient", mCAmbient);
    pCMat->SyncronizeParamAndConf3(strObj, "Diffuse", mCDiffuse);
    pCMat->SyncronizeParamAndConf3(strObj, "Specular", mCSpecular);
    
    if (pCMat->GetPCParamGroup("Alpha") != NULL){
	pCMat->SyncronizeParamAndConf(strObj, "Shininess", mCShininess);
	pCMat->SyncronizeParamAndConf(strObj, "Alpha", mCAlpha);
    }
    if (pCMat->GetPCParamGroup("Strength") != NULL){
	pCMat->SyncronizeParamAndConf(strObj, "Strength", mCStrength);
    }

    if (bGroup == TRUE) GetPCUndo()->CloseBlock("ClrChange");
}

void CLS::
SyncMaterialParticle(bool bGroup){
    Particle_cls* pCObj = (Particle_cls*)GetPCLinkedObj();

    if (bGroup == TRUE) GetPCUndo()->OpenBlock("ClrChange");
    pCObj->SyncMaterialParticle();
    if (bGroup == TRUE) GetPCUndo()->CloseBlock("ClrChange");
}

void CLS::
SyncMaterialStreamline(bool bGroup){
    Streamline_cls* pCObj = (Streamline_cls*)GetPCLinkedObj();

    if (bGroup == TRUE) GetPCUndo()->OpenBlock("ClrChange");
    pCObj->SyncMaterialStreamline();
    if (bGroup == TRUE) GetPCUndo()->CloseBlock("ClrChange");
}

void CLS::
OnMaterialChange(wxCommandEvent& event){
    SyncMaterial(FALSE);
}

void CLS::
OnDropDown(wxCommandEvent& event){
    wxString strCommand = event.GetString();
    SceneObj_cls *pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;
    wxString strName = pCObj->GetStrName();

    if (pCObj->IsSameAs("VolumeBox_cls"))
	return mCSelector.PopupObjectSelector(this, strCommand, "VolumeBox_cls", strName);
    if (pCObj->IsSameAs("Particle_cls"))
	return mCSelector.PopupObjectSelector(this, strCommand, "Particle_cls", strName);
    
    mCSelector.PopupObjectSelector(this, strCommand, "SOLID", strName);
}

void CLS::
OnClearLink(wxCommandEvent& event){
    mpCMNumLink->SetItemSTR(mIndexLink, "None");
    //mpCPain->GetPCMNum("Texture")->SetItemSTR(mIndexTexturePath+1, "None");
}

void CLS::
OnBtnAmbient(wxCommandEvent& event){
    std::vector < float > VClr = GetColorFromDialog(mCAmbient.GetBodyWXColor());
    if (VClr.size() == 0) return;

    mCAmbient.SetBodyFromData(VClr);
    SyncMaterial(TRUE);
}

void CLS::
OnBtnDiffuse(wxCommandEvent& event){
    std::vector < float > VClr = GetColorFromDialog(mCDiffuse.GetBodyWXColor());
    if (VClr.size() == 0) return;

    mCDiffuse.SetBodyFromData(VClr);
    SyncMaterial(TRUE);
}

void CLS::
OnBtnSpecular(wxCommandEvent& event){
    std::vector < float > VClr = GetColorFromDialog(mCSpecular.GetBodyWXColor());
    if (VClr.size() == 0) return;

    mCSpecular.SetBodyFromData(VClr);
    SyncMaterial(TRUE);
}

void CLS::
OnTexture(wxCommandEvent& event){
    wxFileDialogEX *pCDLG = GCClassProvider.GetPCFileDialog();
    pCDLG->MakeDialog(this);
    pCDLG->SetMessage("Select Texture");
    pCDLG->SetWildcard("IMAGE");
    // !! IMPLEMENT_ME !! LastOpened ֌W
    if (pCDLG->ShowModal() == wxID_OK) 
	mpCPain->GetPCMNum("Texture")->SetItemSTR(mIndexTexturePath+1, pCDLG->GetPath());
    pCDLG->DestroyDialog();
}

void CLS::
OnClearTexture(wxCommandEvent& event){
    mpCPain->GetPCMNum("Texture")->SetItemSTR(mIndexTexturePath+1, "None");
}

void CLS::
OnParticleTexture(wxCommandEvent& event){
    Particle_cls* pCObj = (Particle_cls*)GetPCLinkedObj();
    if (pCObj == NULL) return;

    int index = event.GetId() - btnParticleTexture0;
    
    wxFileDialogEX *pCDLG = GCClassProvider.GetPCFileDialog();
    pCDLG->MakeDialog(this);
    pCDLG->SetMessage("Select Texture");
    pCDLG->SetWildcard("IMAGE");
    // !! IMPLEMENT_ME !! LastOpened ֌W
    if (pCDLG->ShowModal() == wxID_OK){
	mpCPain->GetPCMNum("Material.Common")->SetItemSTR(pCObj->mIndexParticleTexturePath[index]+1, pCDLG->GetPath());
    }
    pCDLG->DestroyDialog();
}

void CLS::
OnClearParticleTexture(wxCommandEvent& event){
}

void CLS::
OnBtnMaterialEmit(wxCommandEvent& event){
    int index = event.GetId() - btnMaterialEmit0;
    SceneObj_cls* pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;
    
    //Particle_cls* pCObj = (Particle_cls*)GetPCLinkedObj();

    ConfItemFLOATARRAY_cls *pCEmit = NULL;
    if (pCObj->mstrClassName.IsSameAs("Particle_cls"))
	pCEmit = &((MaterialParticle_cls*)(((Particle_cls*)pCObj)->GetPCAttributeFromAttribName("MaterialParticle_cls", index)))->mCEmit;
    if (pCObj->mstrClassName.IsSameAs("Streamline_cls"))
	pCEmit = &((MaterialStreamline_cls*)(((Streamline_cls*)pCObj)->GetPCAttributeFromAttribName("MaterialStreamline_cls", index)))->mCEmit;
	
    //MaterialParticle_cls *pCMat = (MaterialParticle_cls*)pCObj->GetPCAttributeFromAttribName("MaterialParticle_cls", index);

    std::vector < float > VClr = GetColorFromDialog(pCEmit->GetBodyWXColor()/*pCMat->mCEmit.GetBodyWXColor()*/);
    if (VClr.size() == 0) return;

    /*pCMat->mCEmit.*/pCEmit->SetBodyFromData(VClr);
    SyncMaterial(TRUE);
}

void CLS::
OnBtnMaterialDiffuse(wxCommandEvent& event){
    int index = event.GetId() - btnMaterialDiffuse0;
    Particle_cls* pCObj = (Particle_cls*)GetPCLinkedObj();
    if (pCObj == NULL) return;

    MaterialParticle_cls *pCMat = (MaterialParticle_cls*)pCObj->GetPCAttributeFromAttribName("MaterialParticle_cls", index);

    std::vector < float > VClr = GetColorFromDialog(pCMat->mCDiffuse.GetBodyWXColor());
    if (VClr.size() == 0) return;

    pCMat->mCDiffuse.SetBodyFromData(VClr);
    SyncMaterial(TRUE);
}

void CLS::
OnBtnMaterialSpecular(wxCommandEvent& event){
    int index = event.GetId() - btnMaterialSpecular0;
    Particle_cls* pCObj = (Particle_cls*)GetPCLinkedObj();
    if (pCObj == NULL) return;

    MaterialParticle_cls *pCMat = (MaterialParticle_cls*)pCObj->GetPCAttributeFromAttribName("MaterialParticle_cls", index);

    std::vector < float > VClr = GetColorFromDialog(pCMat->mCSpecular.GetBodyWXColor());
    if (VClr.size() == 0) return;

    pCMat->mCSpecular.SetBodyFromData(VClr);
    SyncMaterial(TRUE);
}

void CLS::
OnColorCurve(wxCommandEvent& event){
    int clrCurveIdx = event.GetId() - btnMaterialColorCurve0;
    
    SceneObj_cls* pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;

    if (pCObj->mstrClassName.IsSameAs("VolumeBox_cls")){
	wxString strColorCurve = _("ColorCurve");
	((VolumeBox_cls*)pCObj)->ClearTexture();
	wxString strTagLong;
	strTagLong = GetPCSceneObjCtrl()->GetStrSelf() << "Obj::" << pCObj->GetStrName() << "::" << strColorCurve;
	GetPCMain()->ProcAfterMath("SelectColorCurve", strTagLong);
    }

    if (pCObj->mstrClassName.IsSameAs("HeightField_cls")){
	wxString strColorCurve = _("ColorCurve");
	((HeightField_cls*)pCObj)->ClearTexture();
	wxString strTagLong;
	strTagLong = GetPCSceneObjCtrl()->GetStrSelf() << "Obj::" << pCObj->GetStrName() << "::" << strColorCurve;
	GetPCMain()->ProcAfterMath("SelectColorCurve", strTagLong);
    }
    
    if (pCObj->mstrClassName.IsSameAs("Particle_cls")){
	wxString strColorCurve = _("ColorCurve");
	strColorCurve << "." << clrCurveIdx;
	wxString strTagLong;
	strTagLong = GetPCSceneObjCtrl()->GetStrSelf() << "Obj::" << pCObj->GetStrName() << "::" << strColorCurve;
	GetPCMain()->ProcAfterMath("SelectColorCurve", strTagLong);
    }

    if (pCObj->mstrClassName.IsSameAs("Streamline_cls")){
	wxString strColorCurve = _("ColorCurve");
	strColorCurve << "." << clrCurveIdx;
	((Streamline_cls*)pCObj)->ClearTexture();
	wxString strTagLong;
	strTagLong = GetPCSceneObjCtrl()->GetStrSelf() << "Obj::" << pCObj->GetStrName() << "::" << strColorCurve;
	GetPCMain()->ProcAfterMath("SelectColorCurve", strTagLong);
    }
}

void CLS::
OnAddColorCurve(wxCommandEvent& event){
    SceneObj_cls* pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;

    wxString strTag = GetPCSceneObjCtrl()->GetStrSelf() << "Obj::" << pCObj->GetStrName();
    
    wxString strUndo(strTag), strRedo(strTag);
    int num = ((Particle_cls*)pCObj)->GetNumAttribute("ColorCurve_cls");
    wxString strName = _("ColorCurve");
    strName << "." << num;

    strUndo << "::Delete::ColorCurve::" << strName;
    strRedo << "::New::ColorCurve::" << strName;
    
    GetPCUndo()->PushCommandPair(strUndo, strRedo);
    GetPCUndo()->Redo();
}

void CLS::
OnDeleteColorCurve(wxCommandEvent& event){
    SceneObj_cls* pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;

    wxString strTag = GetPCSceneObjCtrl()->GetStrSelf() << "Obj::" << pCObj->GetStrName();

    int index =  ((Particle_cls*)pCObj)->GetNumAttribute("ColorCurve_cls") - 1;

    ColorCurve_cls *pCClrCurve = (ColorCurve_cls*)pCObj->GetPCAttributeFromAttribName("ColorCurve_cls", index);
    wxString strName = pCClrCurve->GetStrName();

    wxString strUndo1(strTag), strRedo1(strTag);
    wxString strUndo2(strTag), strRedo2(strTag);

    GetPCUndo()->OpenBlock("ColorCurveDelete");
    
    strUndo1 << "::"; pCClrCurve->Serialize(strUndo1); strUndo1.Trim(TRUE);
    strRedo1 << "::Skip";
    GetPCUndo()->PushCommandPair(strUndo1, strRedo1);
    GetPCUndo()->Redo();

    strUndo2 << "::New::ColorCurve::" << strName;
    strRedo2 << "::Delete::ColorCurve::" << strName;
    GetPCUndo()->PushCommandPair(strUndo2, strRedo2);
    GetPCUndo()->Redo();
    
    GetPCUndo()->CloseBlock("ColorCurveDelete");
}

void CLS::
OnAddTexture(wxCommandEvent& event){
    Particle_cls* pCObj = (Particle_cls*)GetPCLinkedObj();
    if (pCObj == NULL) return;
    pCObj->AddTextureCommand();
}

void CLS::
OnDeleteTexture(wxCommandEvent& event){
    Particle_cls* pCObj = (Particle_cls*)GetPCLinkedObj();
    if (pCObj == NULL) return;
    pCObj->DeleteTextureCommand();
}

void CLS::
OnDeleteMaterial(wxCommandEvent& event){
    SceneObj_cls* pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;

    //wxString strTag = GetPCSceneObjCtrl()->GetStrSelf() << "Obj::" << pCObj->GetStrName();
    if (pCObj->IsSameAs("Particle_cls")){
	Particle_cls *pCParticle = (Particle_cls*)pCObj;
	int index =  pCParticle->GetNumAttribute("MaterialParticle_cls") - 1;
	return pCParticle->ProcDeleteMaterial(index);
    }

    if (pCObj->IsSameAs("Streamline_cls")){
	Streamline_cls *pCStreamline = (Streamline_cls*)pCObj;
	int index = pCStreamline->GetNumAttribute("MaterialStreamline_cls") - 1;
	return pCStreamline->ProcDeleteMaterial(index);
    }

}

void CLS::
OnPinMode(wxCommandEvent& event){
    long long pinned = event.GetInt();
    mCbPinned.SetBodyFromData(pinned);
}

void CLS::
OnAddItem(wxCommandEvent& event){
    SceneObj_cls *pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;

    pCObj->AddMaterialCommand();
}

void CLS::
OnPopMenu(wxCommandEvent& event){
    wxString strPopMenu = mCSelector.GetStr(event.GetId());
    if (strPopMenu.IsEmpty() == TRUE) return;

    wxString strTag = mCSelector.mstrTag;
    if (strTag.IsSameAs("Link")){
	mpCMNumLink->mVCItem[mIndexLink].mpCConfItemLink->PushCommandPair(strPopMenu);
    }
    else
	mpCParent->SelectObject(strPopMenu);
}

ConfItemFLOATARRAY_cls* CLS::
GetPCItemColor(int buttonId){
    ConfItemFLOATARRAY_cls *pCItem = NULL;
    if (buttonId == btnMaterialAmbient) pCItem = &mCAmbient;
    if (buttonId == btnMaterialDiffuse) pCItem = &mCDiffuse;
    if (buttonId == btnMaterialSpecular) pCItem = &mCSpecular;

    SceneObj_cls *pCObj = GetPCLinkedObj();
    if (pCObj != NULL && pCObj->IsSameAs("Particle_cls")){
	Particle_cls *pCParticle = (Particle_cls*)pCObj; 
	if (buttonId >= btnMaterialEmit0 && buttonId <= btnMaterialEmit9){
	    int materiaxIndex = buttonId - btnMaterialEmit0;
	    MaterialParticle_cls *pCMat = (MaterialParticle_cls*)pCParticle->GetPCAttributeFromAttribName("MaterialParticle_cls", materiaxIndex);
	    pCItem = &(pCMat->mCEmit);
	}
    }

    return pCItem;
}

void CLS::
OnCopyColor(wxComEvt& event){
    int id = event.GetId();
    int buttonId = event.GetInt();

    wxString strColor, strSerialize;
    ConfItemFLOATARRAY_cls *pCItem = GetPCItemColor(buttonId);
    
    /*
    
    if (buttonId == btnMaterialAmbient) pCItem = &mCAmbient;
    if (buttonId == btnMaterialDiffuse) pCItem = &mCDiffuse;
    if (buttonId == btnMaterialSpecular) pCItem = &mCSpecular;

    SceneObj_cls *pCObj = GetPCLinkedObj();
    if (pCObj != NULL && pCObj->IsSameAs("Particle_cls")){
	Particle_cls *pCParticle = (Particle_cls*)pCObj; 
	if (buttonId >= btnMaterialEmit0 && buttonId <= btnMaterialEmit9){
	    int materiaxIndex = buttonId - btnMaterialEmit0;
	    MaterialParticle_cls *pCMat = (MaterialParticle_cls*)pCParticle->GetPCAttributeFromAttribName("MaterialParticle_cls", materiaxIndex);
	    pCItem = &(pCMat->mCEmit);
	}
    }
    */
    
    if (pCItem == NULL) return;

    pCItem->Serialize(strColor);

    strColor.Replace(pCItem->mstrHeader, wxES);
    wxString strTag = wxT("COLOR=");
    strSerialize << strTag << strColor;
    
    wxTextDataObject *pCData = new wxTextDataObject(strSerialize);
    wxTheClipboard->Open();
    wxTheClipboard->SetData(pCData);
    wxTheClipboard->Close();
}

void CLS::
OnPasteColor(wxComEvt& event){
    int id = event.GetId();
    int buttonId = event.GetInt();

    ConfItemFLOATARRAY_cls *pCItem = GetPCItemColor(buttonId);
    /*
    if (buttonId == btnMaterialAmbient) pCItem = &mCAmbient;
    if (buttonId == btnMaterialDiffuse) pCItem = &mCDiffuse;
    if (buttonId == btnMaterialSpecular) pCItem = &mCSpecular;
    */

    if (pCItem == NULL) return;

    if (wxTheClipboard->IsSupported(wxDataFormat(wxDF_TEXT)) == FALSE) return;
    wxTextDataObject CData;
    wxTheClipboard->Open();
    wxTheClipboard->GetData(CData);
    wxTheClipboard->Close();
    wxString strData = CData.GetText();

    if (strData.Matches(wxT("COLOR=*")) == TRUE){
	ConfItemFLOATARRAY_cls CArray(wxT("COLOR="), wxT("0.5 0.5 0.5 1"));
	CArray.ReadStrLine(strData);
	
	pCItem->SetBodyFromData(CArray.GetBodyFLOATARRAY());
	SyncMaterial(TRUE);
    }
}

ColorCurve_cls* CLS::
GetPCColorCurve(int curveIdx){
    
    SceneObj_cls *pCObj = GetPCLinkedObj();
    ColorCurve_cls *pCColorCurve = NULL;
    if (pCObj->IsSameAs("Particle_cls")){
	Particle_cls *pCParticle = (Particle_cls*)pCObj ;
	int ccIdx = pCParticle->GetIndexColorCurveInit() + curveIdx;
	pCColorCurve = (ColorCurve_cls*)pCParticle->GetPCAttributeFromIndex(ccIdx);
    }
    if (pCObj->IsSameAs("VolumeBox_cls")){
	VolumeBox_cls *pCVolumeBox = (VolumeBox_cls*)pCObj;
	pCColorCurve = pCVolumeBox->GetPCColorCurve(0);
    }
    if (pCObj->IsSameAs("HeightField_cls")){
	HeightField_cls *pCHeightField = (HeightField_cls*)pCObj;
	pCColorCurve = pCHeightField->GetPCColorCurve(0);
    }
    if (pCObj->IsSameAs("Streamline_cls")){
	Streamline_cls *pCStreamline = (Streamline_cls*)pCObj;
	pCColorCurve = pCStreamline->GetPCColorCurve(0);
    }

    return pCColorCurve;
}

void CLS::
OnCopyColorCurve(wxComEvt& event){
    int id = event.GetId();
    int buttonId = event.GetInt();

    int curveIdx = buttonId - btnMaterialColorCurve0;
    
    ColorCurve_cls *pCColorCurve = GetPCColorCurve(curveIdx);
    
    if (pCColorCurve == NULL) return;
    
    wxString strSerialize;
    pCColorCurve->Serialize(strSerialize);
    wxTextDataObject *pCData = new wxTextDataObject(strSerialize);
    wxTheClipboard->Open();
    wxTheClipboard->SetData(pCData);
    wxTheClipboard->Close();
}

void CLS::
OnPasteColorCurve(wxComEvt& event){

    int id = event.GetId();
    int buttonId = event.GetInt();

    int curveIdx = buttonId - btnMaterialColorCurve0;
    
    SceneObj_cls *pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;

    ColorCurve_cls *pCColorCurve = GetPCColorCurve(curveIdx);

    if (pCColorCurve != NULL){
	if (wxTheClipboard->IsSupported(wxDataFormat(wxDF_TEXT)) == FALSE)
	    return;
	wxTextDataObject CData;
	wxTheClipboard->Open();
	wxTheClipboard->GetData(CData);
	wxTheClipboard->Close();
	wxString strData = CData.GetText();

	if (strData.IsEmpty() == FALSE)
	    pCColorCurve->Paste(strData, pCObj->GetStrTag());
    }

}

void CLS::
UpdatePanels(const wxString& strPanelTag){
    wxString strName = GetName();
    if (GetName().IsSameAs(strPanelTag) ||
	strPanelTag.IsSameAs("ALL")){
	SetMaterialInfo();
	CheckColorCurveAndTexture();
	HideAndShow();
	mpCMNumLink->UpdateValues(_MN_ALLITEM);
	if (mpCPain != NULL) mpCPain->UpdateValues();
	UpdateButtonColor();
    }
}
