//(setq c-basic-offset 4)
// "clsPropertyModifier.h"

#include "clsPropertyModifier.h"
#include "../clsProperty.h"

#include "../../COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;

#include "../../MODIFIER/clsTracking.h"
#include "../../MODIFIER/clsArrayCopy.h"
#include "../../MODIFIER/clsModifyApparentSize.h"
#include "../../MODIFIER/clsModifyParticleSize.h"
#include "../../MODIFIER/clsNestedVolume.h"
#include "../../MODIFIER/clsTrimming.h"
#include "../../MODIFIER/clsTexSpaceMod.h"
#include "../../MODIFIER/clsSequenceRemap.h"
#include "../../MODIFIER/clsParticleBoolean.h"
#include "../../MODIFIER/clsParticleExclude.h"
#include "../../MODIFIER/clsParticleFiltering.h"
#include "../../MODIFIER/clsParticleTweak.h"
#include "../../MODIFIER/clsParticleDownsize.h"
#include "../../MODIFIER/clsParticleMerge.h"
#include "../../MODIFIER/clsStreamFiltering.h"
#include "../../MODIFIER/clsStreamSetAlpha.h"
#include "../../MODIFIER/clsStreamTransform.h"
#include "../../MODIFIER/clsVolumeBoolean.h"
#include "../../MODIFIER/clsVolumeCoord.h"
#include "../../MODIFIER/clsVolumeDownsize.h"
#include "../../MODIFIER/clsVolumeMask.h"
#include "../../SCENEOBJ/clsLightSource.h"
#include "../../SCENEOBJ/clsPrimitive.h"
#include "../../SCENEOBJ/clsSceneObj.h"
#include "../../SCENEOBJ/clsSceneObjCtrl.h"
#include "../../WIDGETCTRL/clsBitmapPanel.h"
#include "../../WIDGETCTRL/INPUTITEM/clsVCenter.h"
#include "../../WIDGETCTRL/MULTIINPUT/clsMultiInputPanel.h"
#include "../../WIDGETCTRL/MULTIINPUT/clsMNumPainBase.h"

#include "../../COMMON/CommonDefinitions.h"
#include "../../../clsMain.h"
#include "../../../wxWidgetEnum.h"
#include "../../../wxWidgetEnumMenu.h"

#define CLS PropertyModifier_cls

BEGIN_EVENT_TABLE(CLS, wxPanelEX)
EVT_BUTTON(btnGraphPin, CLS::OnPinMode)
EVT_BUTTON(btnDropdown, CLS::OnDropDown)
EVT_BUTTON(btnAddModifier, CLS::OnAddItem)
EVT_BUTTON(btnNumPanelDelete, CLS::OnDeleteModifier)
EVT_BUTTON(btnNumPanelValidity, CLS::OnToggleValidity)
EVT_BUTTON(btnVolumeCoordEdit, CLS::OnVolumeCoordEdit)
EVT_MENU(menuModifierTracking, CLS::OnAddTracking)
EVT_MENU(menuModifierArrayCopy, CLS::OnAddArrayCopy)
EVT_MENU(menuModifierModifyApparentSize, CLS::OnAddModifyApparentSize)
EVT_MENU(menuModifierModifyParticleSize, CLS::OnAddModifyParticleSize)
EVT_MENU(menuModifierNestedVolume, CLS::OnAddNestedVolume)
EVT_MENU(menuModifierParticleBoolean, CLS::OnAddParticleBoolean)
EVT_MENU(menuModifierParticleFiltering, CLS::OnAddParticleFiltering)
EVT_MENU(menuModifierParticleTweak, CLS::OnAddParticleTweak)
EVT_MENU(menuModifierTrimming, CLS::OnAddTrimming)
EVT_MENU(menuModifierTexSpaceMod, CLS::OnAddTexSpaceMod)
EVT_MENU(menuModifierSequenceRemap, CLS::OnAddSequenceRemap)
EVT_MENU(menuModifierVolumeCoord, CLS::OnAddVolumeCoord)
EVT_MENU(menuModifierVolumeMask, CLS::OnAddVolumeMask)
EVT_MENU(menuDProcVolumeBoolean, CLS::OnAddVolumeBoolean)
EVT_MENU(menuDProcVolumeDownsize, CLS::OnAddVolumeDownsize)
EVT_MENU(menuDProcParticleDownsizing, CLS::OnAddParticleDownsizing)
EVT_MENU(menuDProcParticleExclude, CLS::OnAddParticleExclude)
EVT_MENU(menuDProcParticleMerge, CLS::OnAddParticleMerge)
EVT_MENU(menuDProcStreamFiltering, CLS::OnAddStreamFiltering)
EVT_MENU(menuDProcStreamSetAlpha, CLS::OnAddStreamSetAlpha)
EVT_MENU(menuDProcStreamTransform, CLS::OnAddStreamTransform)
EVT_MENU_RANGE(menuPop0, menuPop9, CLS::OnPopMenu)
//EVT_CHAR (PropertyRender_cls::OnKeyDown)
END_EVENT_TABLE()

CLS::
PropertyModifier_cls(Property_cls *pCParent, int type, wxWindowID id, const wxPoint &pos, const wxSize &size, long style) :
wxPanelEX(pCParent, id, pos, size, style), PropertyBase_cls(pCParent)
{

    //mType = type;
    switch(type){
    case _MOD_MODIFIER:
	SetPanelType(_PANEL_PROPERTY_MODIFIER); break;
    case _MOD_DATAPROC:
	SetPanelType(_PANEL_PROPERTY_DATAPROC); break;
    }

    SetToDefaultParam();

    mpCBoxSizerSrc  = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer *pBoxSizerInfo = GetNewPCBoxSizerInfoWithItems(this);
    
    if (mPanelType == _PANEL_PROPERTY_MODIFIER)
	mpCBtnAddItem = new wxButton(this, btnAddModifier, _("Add Modifier"));
    else
	mpCBtnAddItem = new wxButton(this, btnAddModifier, _("Add Processor"));
    wxString strActiveObj = GetPCSceneObjCtrl()->GetActiveObjectName();
    
    mpCPain = GetPCNewPain(this);
    mpCPain->mbDeleteButton = TRUE;
    mpCPain->mbInsertTarget = TRUE;
    
    
    mpCPainInRefuge = NULL;
    
    mpCBoxSizerSrc->Add(pBoxSizerInfo, 0, wxEXPAND);
    mpCBoxSizerSrc->Add(mpCBtnAddItem, 0, wxEXPAND);
    mpCBoxSizerSrc->Add(mpCPain, 0, wxEXPAND);
    //pCBoxSizerSrc->Add(mpCMNum, 0, wxEXPAND);

    if (strActiveObj.IsEmpty())
	Disconnect();
    else{
	wxString strTag;
	strTag << GetPCSceneObjCtrl()->GetStrSelf() << "Obj::" << strActiveObj << "::";
	mCstrLinkedObject.SetBodyFromData(strTag);
	mpCLinkedObject->SetLabel(strTag);
	Reconnect();
    }

    SetSizer(mpCBoxSizerSrc);
}

void CLS::
SetToDefaultParam(){
    mCConfList.Clear();
    mCConfList.SetTag("PropertyModifier");
    mCConfList.Add(&mCstrLinkedObject, "LinkedObject=", "None");
    mCConfList.Add(&mCbPinned, "Pinned=", "0");
}

void CLS::
ClearPanels(){
    if (mpCPain != NULL){
	mpCBoxSizerSrc->Detach(mpCPain);
	delete mpCPain;
	mpCPain = NULL;
    }

    mVpCMNum.clear();
    int numBuffer = mVpCAttributeBuffer.size(); 
    for (int i = 0; i < numBuffer; i++)
	Attribute_cls::DeleteBuffer(mVpCAttributeBuffer[i]);
    mVpCAttributeBuffer.clear();
}

void CLS::
SavePanelInfoToRefuge(){
    if (mpCPain != NULL){
	mpCBoxSizerSrc->Detach(mpCPain);
	mpCPainInRefuge = mpCPain;
	mpCPain = NULL;
    }

    mVpCMNumInRefuge = mVpCMNum;
    mVpCMNum.clear();

    mVpCAttributeBufferInRefuge = mVpCAttributeBuffer;
    mVpCAttributeBuffer.clear();
}

void CLS::
ClearRefuge(){
    if (mpCPainInRefuge != NULL){
	delete mpCPainInRefuge;
	mpCPainInRefuge = NULL;
    }

    mVpCMNumInRefuge.clear();

    int numBuffer = mVpCAttributeBufferInRefuge.size(); 
    for (int i = 0; i < numBuffer; i++)	
	Attribute_cls::DeleteBuffer(mVpCAttributeBufferInRefuge[i]);

    mVpCAttributeBufferInRefuge.clear();
}

MultiInputPanel_cls* CLS::
GetPCMNumForReuse(Attribute_cls *pCAttrib){
    if (mpCPainInRefuge == NULL) 
	return NULL;
    if (mpCPainInRefuge->mstrTag.IsSameAs(mpCPain->mstrTag) == FALSE) 
	return NULL;
    
    wxString strAttribName = pCAttrib->GetStrName();
    uint numAttribInRefuge = mVpCMNumInRefuge.size();
    
    for (uint i = 0; i < numAttribInRefuge; i++){
	if (mVpCMNumInRefuge[i]->GetName().IsSameAs(strAttribName)){
	    Attribute_cls *pCBuffer = mVpCAttributeBufferInRefuge[i];
	    MultiInputPanel_cls *pCMNum = mVpCMNumInRefuge[i];
	    
	    mVpCMNum.push_back(pCMNum);
	    mVpCAttributeBuffer.push_back(pCBuffer);
	    
	    mVpCAttributeBufferInRefuge.erase(mVpCAttributeBufferInRefuge.begin() + i);
	    mVpCMNumInRefuge.erase(mVpCMNumInRefuge.begin() + i);
	    return pCMNum;
	}
    }
    
    return NULL;
}

std::vector < bool > CLS::
GetVbValidity(){
    std::vector < bool > VbValidity;

    SceneObj_cls *pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return VbValidity;

    if (mPanelType == _PANEL_PROPERTY_MODIFIER){
	int modifierInit = pCObj->GetIndexModifierInit();
	int numAttrib = pCObj->mVpCAttribute.size();
	for (int i = modifierInit; i < numAttrib; i++){
	    //Attribute_cls* pCAttrib = pCObj->GetPCAttributeFromIndex(i);
	    ModifierBase_cls* pCModifier = (ModifierBase_cls*)pCObj->GetPCAttributeFromIndex(i);
	    VbValidity.push_back(pCModifier->mCbValidity.GetBodyBOOL());
	}
    }

    if (mPanelType == _PANEL_PROPERTY_DATAPROC){
	int numAttrib = pCObj->mVpCDataProc.size();
	for (int i = 0; i < numAttrib; i++)
	    VbValidity.push_back(pCObj->GetPCDataProcFromIndex(i)->mCbValidity.GetBodyBOOL());
    }

    return VbValidity;
}

void CLS::
Disconnect(){
    ClearPanels();
    mpCBtnAddItem->Disable();
    
    Layout();
}

void CLS::
ConnectCommon(){
    mpCBtnAddItem->Enable();
    Layout();
}

void CLS::
Reconnect(){
    SceneObj_cls *pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return Disconnect();

    SavePanelInfoToRefuge();

    
    if (mpCPain == NULL){
	mpCPain = GetPCNewPain(this);
	mpCPain->mbDeleteButton = TRUE;
	mpCPain->mbInsertTarget = TRUE;
	mAstrClosedItem.clear();
    }

    int _MODIFIER = _PANEL_PROPERTY_MODIFIER;
    int _DATAPROC = _PANEL_PROPERTY_DATAPROC;

    int numAttrib = 0;
    if (mPanelType == _MODIFIER) numAttrib = pCObj->mVpCAttribute.size();
    if (mPanelType == _DATAPROC) numAttrib = pCObj->mVpCDataProc.size();
    
    for (int i = 0; i < numAttrib; i++){
	ModifierBase_cls *pCModifier = NULL;
	if (mPanelType == _MODIFIER)
	    pCModifier = (ModifierBase_cls*)pCObj->GetPCAttributeFromIndex(i);
	if (mPanelType == _DATAPROC)
	    pCModifier = (ModifierBase_cls*)pCObj->GetPCDataProcFromIndex(i);
	
	MultiInputPanel_cls *pCReuse = GetPCMNumForReuse(pCModifier);
	if (pCReuse != NULL){
	    ASSERT(mpCPainInRefuge != NULL);
	    mpCPainInRefuge->GetSizer()->Detach(pCReuse);
	    pCReuse->Reparent(mpCPain);
	    //!! etւ
	    mpCPain->SetMNum(pCReuse, mAstrClosedItem, pCReuse->GetName(), pCModifier->mCbValidity.GetBodyBOOL(), TRUE);
	    continue;
	}
	
	MultiInputPanel_cls *pCMNum = NULL;
	wxString strModifiterName;
	
	if (pCModifier->IsAttributeSameAs("Tracking_cls")){
	    Tracking_cls *pCTracking = (Tracking_cls*)pCModifier;
	    TrackingBuffer_cls *pCBuffer = new TrackingBuffer_cls(pCTracking);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain);
	    mVpCAttributeBuffer.push_back(pCBuffer);	    
	}

	if (pCModifier->IsAttributeSameAs("ArrayCopy_cls")){
	    ArrayCopy_cls *pCArrayCopy = (ArrayCopy_cls*)pCModifier;
	    ArrayCopyBuffer_cls *pCBuffer = new ArrayCopyBuffer_cls(pCArrayCopy);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain);
	    mVpCAttributeBuffer.push_back(pCBuffer);	    
	}

	if (pCModifier->IsAttributeSameAs("ModifyApparentSize_cls")){
	    ModifyApparentSize_cls *pCModifyApparentSize = (ModifyApparentSize_cls*)pCModifier;
	    ModifyApparentSizeBuffer_cls *pCBuffer = new ModifyApparentSizeBuffer_cls(pCModifyApparentSize);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain);
	    mVpCAttributeBuffer.push_back(pCBuffer);	    
	}

	if (pCModifier->IsAttributeSameAs("ModifyParticleSize_cls")){
	    ModifyParticleSize_cls *pCModifyParticleSize = (ModifyParticleSize_cls*)pCModifier;
	    ModifyParticleSizeBuffer_cls *pCBuffer = new ModifyParticleSizeBuffer_cls(pCModifyParticleSize);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain);
	    mVpCAttributeBuffer.push_back(pCBuffer);	    
	}

	if (pCModifier->IsAttributeSameAs("NestedVolume_cls")){
	    NestedVolume_cls *pCNestedVolume = (NestedVolume_cls*)pCModifier;
	    NestedVolumeBuffer_cls *pCBuffer = new NestedVolumeBuffer_cls(pCNestedVolume);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain);
	    mVpCAttributeBuffer.push_back(pCBuffer);	    
	}

	if (pCModifier->IsAttributeSameAs("Trimming_cls")){
	    Trimming_cls *pCTrimming = (Trimming_cls*)pCModifier;
	    TrimmingBuffer_cls *pCBuffer = new TrimmingBuffer_cls(pCTrimming);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain, pCObj->mstrClassName);
	    mVpCAttributeBuffer.push_back(pCBuffer);
	}

	if (pCModifier->IsAttributeSameAs("TexSpaceMod_cls")){
	    TexSpaceMod_cls *pCTexSpaceMod = (TexSpaceMod_cls*)pCModifier;
	    TexSpaceModBuffer_cls *pCBuffer = new TexSpaceModBuffer_cls(pCTexSpaceMod);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain);
	    mVpCAttributeBuffer.push_back(pCBuffer);
	}

	if (pCModifier->IsAttributeSameAs("SequenceRemap_cls")){
	    SequenceRemap_cls *pCSequenceRemap = (SequenceRemap_cls*)pCModifier;
	    SequenceRemapBuffer_cls *pCBuffer = new SequenceRemapBuffer_cls(pCSequenceRemap);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain);
	    mVpCAttributeBuffer.push_back(pCBuffer);
	}

	if (pCModifier->IsAttributeSameAs("VolumeMask_cls")){
	    VolumeMask_cls *pCVolumeMask = (VolumeMask_cls*)pCModifier;
	    VolumeMaskBuffer_cls *pCBuffer = new VolumeMaskBuffer_cls(pCVolumeMask);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain);
	    mVpCAttributeBuffer.push_back(pCBuffer);
	}

	if (pCModifier->IsAttributeSameAs("VolumeCoord_cls")){
	    VolumeCoord_cls *pCVolumeCoord = (VolumeCoord_cls*)pCModifier;
	    VolumeCoordBuffer_cls *pCBuffer = new VolumeCoordBuffer_cls(pCVolumeCoord);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain);
	    mVpCAttributeBuffer.push_back(pCBuffer);
	}

	if (pCModifier->IsAttributeSameAs("VolumeBoolean_cls")){
	    VolumeBoolean_cls *pCVolumeBoolean = (VolumeBoolean_cls*)pCModifier;
	    VolumeBooleanBuffer_cls *pCBuffer = new VolumeBooleanBuffer_cls(pCVolumeBoolean);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain);
	    mVpCAttributeBuffer.push_back(pCBuffer);
	}

	if (pCModifier->IsAttributeSameAs("VolumeDownsize_cls")){
	    VolumeDownsize_cls *pCVolumeDownsize = (VolumeDownsize_cls*)pCModifier;
	    VolumeDownsizeBuffer_cls *pCBuffer = new VolumeDownsizeBuffer_cls(pCVolumeDownsize);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain);
	    mVpCAttributeBuffer.push_back(pCBuffer);
	}

	if (pCModifier->IsAttributeSameAs("ParticleBoolean_cls")){
	    ParticleBoolean_cls *pCParticleBoolean = (ParticleBoolean_cls*)pCModifier;
	    ParticleBooleanBuffer_cls *pCBuffer = new ParticleBooleanBuffer_cls(pCParticleBoolean);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain);
	    mVpCAttributeBuffer.push_back(pCBuffer);
	}

	if (pCModifier->IsAttributeSameAs("ParticleFiltering_cls")){
	    ParticleFiltering_cls *pCParticleFiltering = (ParticleFiltering_cls*)pCModifier;
	    ParticleFilteringBuffer_cls *pCBuffer = new ParticleFilteringBuffer_cls(pCParticleFiltering);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain);
	    mVpCAttributeBuffer.push_back(pCBuffer);
	}

	if (pCModifier->IsAttributeSameAs("ParticleTweak_cls")){
	    ParticleTweak_cls *pCParticleTweak = (ParticleTweak_cls*)pCModifier;
	    ParticleTweakBuffer_cls *pCBuffer = new ParticleTweakBuffer_cls(pCParticleTweak);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain);
	    mVpCAttributeBuffer.push_back(pCBuffer);
	}

	if (pCModifier->IsAttributeSameAs("ParticleDownsizing_cls")){
	    ParticleDownsizing_cls *pCParticleDownsizing = (ParticleDownsizing_cls*)pCModifier;
	    ParticleDownsizingBuffer_cls *pCBuffer = new ParticleDownsizingBuffer_cls(pCParticleDownsizing);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain);
	    mVpCAttributeBuffer.push_back(pCBuffer);
	}

	if (pCModifier->IsAttributeSameAs("ParticleExclude_cls")){
	    ParticleExclude_cls *pCParticleExclude = (ParticleExclude_cls*)pCModifier;
	    ParticleExcludeBuffer_cls *pCBuffer = new ParticleExcludeBuffer_cls(pCParticleExclude);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain);
	    mVpCAttributeBuffer.push_back(pCBuffer);
	}

	if (pCModifier->IsAttributeSameAs("ParticleMerge_cls")){
	    ParticleMerge_cls *pCParticleMerge = (ParticleMerge_cls*)pCModifier;
	    ParticleMergeBuffer_cls *pCBuffer = new ParticleMergeBuffer_cls(pCParticleMerge);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain);
	    mVpCAttributeBuffer.push_back(pCBuffer);
	}

	if (pCModifier->IsAttributeSameAs("StreamFiltering_cls")){
	    StreamFiltering_cls *pCStreamFiltering = (StreamFiltering_cls*)pCModifier;
	    StreamFilteringBuffer_cls *pCBuffer = new StreamFilteringBuffer_cls(pCStreamFiltering);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain);
	    mVpCAttributeBuffer.push_back(pCBuffer);
	}

	if (pCModifier->IsAttributeSameAs("StreamSetAlpha_cls")){
	    StreamSetAlpha_cls *pCStreamSetAlpha = (StreamSetAlpha_cls*)pCModifier;
	    StreamSetAlphaBuffer_cls *pCBuffer = new StreamSetAlphaBuffer_cls(pCStreamSetAlpha);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain);
	    mVpCAttributeBuffer.push_back(pCBuffer);
	}

	if (pCModifier->IsAttributeSameAs("StreamTransform_cls")){
	    StreamTransform_cls *pCStreamTransform = (StreamTransform_cls*)pCModifier;
	    StreamTransformBuffer_cls *pCBuffer = new StreamTransformBuffer_cls(pCStreamTransform);
	    pCMNum = pCBuffer->GetPCNewPanel(mpCPain);
	    mVpCAttributeBuffer.push_back(pCBuffer);
	}

	if (pCMNum != NULL){ // ʏ
	    strModifiterName = pCModifier->GetStrName();
	    pCMNum->SetHook(this, &HookItem_cls::HookFunc01, wxEVT_COMMAND_TEXT_ENTER, wxID_ANY, strModifiterName);
	    pCMNum->SetHook(this, &HookItem_cls::HookFunc01, wxEVT_COMMAND_COMBOBOX_SELECTED, wxID_ANY, strModifiterName);
	    pCMNum->SetHook(this, &HookItem_cls::HookFunc01, wxEVT_CHECKBOX, wxID_ANY, strModifiterName);
	    mVpCMNum.push_back(pCMNum);
	    mpCPain->SetMNum(pCMNum, mAstrClosedItem, strModifiterName, pCModifier->mCbValidity.GetBodyBOOL(), TRUE);
	}
    }
    
    wxBoxSizer *pCSizerForPain = new wxBoxSizer(wxVERTICAL);
    mpCPain->InitLayoutNumPanels(pCSizerForPain);
    mpCPain->SetSizer(pCSizerForPain);

    ConnectCommon();
    
    ClearRefuge();

    uint numPanel = mVpCMNum.size();
    for (uint i = 0; i < numPanel; i++){
	mVpCMNum[i]->UpdateValues(_MN_ALLITEM);
    }
    
    mpCBoxSizerSrc->Add(mpCPain, 0, wxEXPAND);
    Layout();
    
    wxSize CCurrentSize = GetSize();
    wxSize CBestSize = GetBestSize();
    SetSize(wxSize(-1, CBestSize.GetHeight()));
    
}

void CLS::
SetAttributeInfo(){
    uint numBuffer = mVpCAttributeBuffer.size();
    for (uint i = 0; i < numBuffer; i++){
	mVpCAttributeBuffer[i]->SyncBufferFromSrc();
    }
}

void CLS::
ProcAfterMathModifier(wxString strCommand, wxString strTag){
    if (strCommand.IsSameAs("ModifierChange") ||
	strCommand.IsSameAs("DataProcChange") ){
	SceneObj_cls *pCObj = GetPCLinkedObj();
	if (pCObj == NULL) return;
	if (pCObj->GetStrName().IsSameAs(strTag))
	    Reconnect();
    }

}

void CLS::
CheckPanelOrder(){
    uint numPanel = mVpCMNum.size();
    SceneObj_cls *pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;

    if (mPanelType == _PANEL_PROPERTY_MODIFIER){
	uint numAttrib = pCObj->mVpCAttribute.size();
	int init = pCObj->GetIndexModifierInit();
	uint numFilter = numAttrib - init;
	ASSERT(numPanel == numFilter);

	bool bDiff = FALSE;
	for (uint i = 0; i < numPanel; i++){
	    if (mVpCMNum[i]->GetName().IsSameAs(pCObj->GetPCAttributeFromIndex(i + init)->GetStrName()) == FALSE)
		bDiff = TRUE;
	}
	if (bDiff == TRUE) Reconnect();
    }
    if (mPanelType == _PANEL_PROPERTY_DATAPROC){
	uint numFilter = pCObj->mVpCDataProc.size();
	ASSERT(numPanel == numFilter);

	bool bDiff = FALSE;
	for (uint i = 0; i < numPanel; i++){
	    if (mVpCMNum[i]->GetName().IsSameAs(pCObj->GetPCDataProcFromIndex(i)->GetStrName()) == FALSE)
		bDiff = TRUE;
	}
	if (bDiff == TRUE) Reconnect();
    }
}

void CLS::
HideAndShow(){
    
    uint numAttribBuffer = mVpCAttributeBuffer.size();
    
    bool bChange = FALSE;
    for (uint i = 0; i < numAttribBuffer; i++){	
	Attribute_cls *pCAttrib = mVpCAttributeBuffer[i];
	if (pCAttrib->IsAttributeSameAs("ParticleBoolean_cls"))
	    bChange |= ((ParticleBooleanBuffer_cls*)pCAttrib)->HideAndShow();
	if (pCAttrib->IsAttributeSameAs("VolumeCoord_cls"))
	    bChange |= ((VolumeCoordBuffer_cls*)pCAttrib)->HideAndShow();
	if (pCAttrib->IsAttributeSameAs("VolumeBoolean_cls"))
	    bChange |= ((VolumeBooleanBuffer_cls*)pCAttrib)->HideAndShow();
	if (pCAttrib->IsAttributeSameAs("ModifyApparentSize_cls")){
	    SceneObj_cls *pCObj = GetPCLinkedObj();
	    if (pCObj == NULL) return;
	    bChange |= ((ModifyApparentSizeBuffer_cls*)pCAttrib)->HideAndShow((Particle_cls*)pCObj);
	}
    }

    if (bChange == TRUE){
	Layout();
	GetParent()->Layout();
    }
}

void CLS::
UpdatePanels(const wxString& strPanelTag){
    if (GetName().IsSameAs(strPanelTag) ||
	strPanelTag.IsSameAs("ALL")){
	CheckPanelOrder();
	SetAttributeInfo();
	HideAndShow();
	/*
	uint numPanel = mVpCMNum.size();
	for (uint i = 0; i < numPanel; i++)
	    mVpCMNum[i]->UpdateValues(_MN_ALLITEM);
	*/
	if (mpCPain != NULL){
	    mpCPain->SyncValidityToData(GetVbValidity());
	    mpCPain->UpdateValues();
	}
    }
}

void CLS::
OnAttributeChange(wxComEvt& event){

    wxString strName = event.GetString();
    SceneObj_cls *pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;
    
    uint numAttribBuffer = mVpCAttributeBuffer.size();
    for (uint i = 0; i < numAttribBuffer; i++){
	Attribute_cls *pCAttrib = mVpCAttributeBuffer[i];
	if (pCAttrib->GetStrName().IsSameAs(strName))
	    pCAttrib->SyncSrcFromBuffer(pCObj);
    }
}

void CLS::
OnDropDown(wxComEvt& event){
    wxString strCommand = event.GetString();
    wxString strType = "ALL";
    //bool bSolidOnly = FALSE;
    if (strCommand.Find(_("VolumeBoolean")) != wxNOT_FOUND) strType = "SOLID";
    if (strCommand.Find(_("NestedVolume")) != wxNOT_FOUND) strType = "VOLUME";
    if (strCommand.Find(_("ParticleMerge")) != wxNOT_FOUND) strType = "PARTICLE";
    wxString strLinkedObj = GetPCLinkedObj()->GetStrName();
    mCSelector.PopupObjectSelector(this, strCommand, strType, strLinkedObj);
}

void CLS::
OnPinMode(wxComEvt& event){
    long long pinned = event.GetInt();
    mCbPinned.SetBodyFromData(pinned);
}

void CLS::
OnAddItem(wxComEvt& event){

    SceneObj_cls *pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;

    wxString strClassName = pCObj->mstrClassName;
    wxMenu *pCPopMenu = new wxMenu;

    if (mPanelType == _PANEL_PROPERTY_MODIFIER){
	pCPopMenu->Append(menuModifierTracking, _("Tracking"));
	pCPopMenu->Append(menuModifierArrayCopy, _("ArrayCopy"));

	if (strClassName.IsSameAs("Primitive_cls")){
	    pCPopMenu->Append(menuModifierTexSpaceMod, _("Texture Space Modifier"));
	}

	if (strClassName.IsSameAs("VolumeBox_cls")){
	    pCPopMenu->Append(menuModifierTrimming, _("Trimming"));
	    pCPopMenu->Append(menuModifierTexSpaceMod, _("Texture Space Modifier"));
	    pCPopMenu->Append(menuModifierSequenceRemap, _("Sequence Remap"));
	    pCPopMenu->Append(menuModifierVolumeMask, _("Volume Mask"));
	    pCPopMenu->Append(menuModifierVolumeCoord, _("Volume Coordinates"));
	    pCPopMenu->Append(menuModifierNestedVolume, _("Nested Volume"));
	}
	if (strClassName.IsSameAs("Particle_cls")){
	    pCPopMenu->Append(menuModifierParticleBoolean, _("Particle Boolean"));
	    pCPopMenu->Append(menuModifierParticleFiltering, _("Particle Filtering"));
	    pCPopMenu->Append(menuModifierParticleTweak, _("Particle Tweak"));
	    pCPopMenu->Append(menuModifierModifyApparentSize, _("Modify Apparent Size"));
	    pCPopMenu->Append(menuModifierModifyParticleSize, _("Modify Particle Size or Alpha"));
	    pCPopMenu->Append(menuModifierSequenceRemap, _("Sequence Remap"));
	}

	if (strClassName.IsSameAs("Streamline_cls")){
	    pCPopMenu->Append(menuModifierSequenceRemap, _("Sequence Remap"));
	    pCPopMenu->Append(menuModifierTrimming, _("Trimming"));
	    pCPopMenu->Append(menuModifierTexSpaceMod, _("Texture Space Modifier"));
	}

	if (strClassName.IsSameAs("HeightField_cls")){
	    pCPopMenu->Append(menuModifierSequenceRemap, _("Sequence Remap"));
	    pCPopMenu->Append(menuModifierTexSpaceMod, _("Texture Space Modifier"));
	}
    }

    if (mPanelType == _PANEL_PROPERTY_DATAPROC){
	if (strClassName.IsSameAs("VolumeBox_cls")){
	    pCPopMenu->Append(menuDProcVolumeBoolean, _("Volume Boolean"));
	    pCPopMenu->Append(menuDProcVolumeDownsize, _("Volume Downsize"));
	}
	if (strClassName.IsSameAs("Particle_cls")){
	    pCPopMenu->Append(menuDProcParticleDownsizing, _("Particle Downsizing"));
	    pCPopMenu->Append(menuDProcParticleExclude, _("Particle Exclude"));
	    pCPopMenu->Append(menuDProcParticleMerge, _("Particle Merge"));
	    
	}
	if (strClassName.IsSameAs("Streamline_cls")){
	    pCPopMenu->Append(menuDProcStreamFiltering, _("Streamline Filtering"));
	    pCPopMenu->Append(menuDProcStreamSetAlpha, _("Streamline SetAlph"));
	    pCPopMenu->Append(menuDProcStreamTransform, _("Streamline Transform"));
	}
    }
    
    PopupMenu(pCPopMenu);

    delete pCPopMenu;
}

void CLS::
AddModifierCommand(wxString strClassName, wxString strNameCandid){
    SceneObj_cls *pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;
    pCObj->AddModifierCommand(strClassName, strNameCandid);
}

void CLS::
AddDProcCommand(wxString strClassName, wxString strNameCandid){
    SceneObj_cls *pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;
    pCObj->AddDataProcCommand(strClassName, strNameCandid);
}

void CLS::
OnAddTracking(wxComEvt& event){
    AddModifierCommand("Tracking_cls", "Tracking"); }

void CLS::
OnAddArrayCopy(wxComEvt& event){
    AddModifierCommand("ArrayCopy_cls", "ArrayCopy"); }

void CLS::
OnAddModifyApparentSize(wxComEvt& event){
    AddModifierCommand("ModifyApparentSize_cls", "ModifyApparentSize"); }

void CLS::
OnAddModifyParticleSize(wxComEvt& event){
    AddModifierCommand("ModifyParticleSize_cls", "ModifyParticleSizeOrAlpha"); }

void CLS::
OnAddNestedVolume(wxComEvt& event){
    AddModifierCommand("NestedVolume_cls", "NestedVolume"); }

void CLS::
OnAddParticleBoolean(wxComEvt& event){
    AddModifierCommand("ParticleBoolean_cls", "ParticleBoolean"); }

void CLS::
OnAddParticleFiltering(wxComEvt& event){
    AddModifierCommand("ParticleFiltering_cls", "ParticleFiltering"); }

void CLS::
OnAddParticleTweak(wxComEvt& event){
    AddModifierCommand("ParticleTweak_cls", "ParticleTweak"); }

void CLS::
OnAddTrimming(wxComEvt& event){
    AddModifierCommand("Trimming_cls", "Trimming"); }

void CLS::
OnAddTexSpaceMod(wxComEvt& event){
    AddModifierCommand("TexSpaceMod_cls", "TextureSpaceModifier"); }

void CLS::
OnAddSequenceRemap(wxComEvt& event){
    AddModifierCommand("SequenceRemap_cls", "SequenceRemap"); }

void CLS::
OnAddVolumeMask(wxComEvt& event){
    AddModifierCommand("VolumeMask_cls", "VolumeMask"); }

void CLS::
OnAddVolumeCoord(wxComEvt& event){
    AddModifierCommand("VolumeCoord_cls", "VolumeCoordinate"); }

void CLS::
OnAddVolumeBoolean(wxComEvt& event){
    AddDProcCommand("VolumeBoolean_cls", "VolumeBoolean"); }

void CLS::
OnAddVolumeDownsize(wxComEvt& event){
    AddDProcCommand("VolumeDownsize_cls", "VolumeDownsize"); }

void CLS::
OnAddParticleDownsizing(wxComEvt& event){
    AddDProcCommand("ParticleDownsizing_cls", "ParticleDownsizing"); }

void CLS::
OnAddParticleExclude(wxComEvt& event){
    AddDProcCommand("ParticleExclude_cls", "ParticleExclude"); }

void CLS::
OnAddParticleMerge(wxComEvt& event){
    AddDProcCommand("ParticleMerge_cls", "ParticleMerge"); }

void CLS::
OnAddStreamFiltering(wxComEvt& event){
    AddDProcCommand("StreamFiltering_cls", "StreamFiltering"); }

void CLS::
OnAddStreamSetAlpha(wxComEvt& event){
    AddDProcCommand("StreamSetAlpha_cls", "StreamSetAlpha"); }

void CLS::
OnAddStreamTransform(wxComEvt& event){
    AddDProcCommand("StreamTransform_cls", "StreamTransform"); }

void CLS::
OnDeleteModifier(wxComEvt& event){
    wxString strTgt = event.GetString();

    SceneObj_cls *pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;

    if (mPanelType == _PANEL_PROPERTY_MODIFIER)
	pCObj->DeleteModifierCommand(strTgt);
    if (mPanelType == _PANEL_PROPERTY_DATAPROC)
	pCObj->DeleteDataProcCommand(strTgt);
}

void CLS::
OnToggleValidity(wxComEvt& event){
    wxString strTgt = event.GetString();
    int state = event.GetInt();

    SceneObj_cls *pCObj = GetPCLinkedObj();
    if (pCObj == NULL) return;

    if (mPanelType == _PANEL_PROPERTY_MODIFIER)
	pCObj->SetModifierValidityCommand(strTgt, state == 1);
    if (mPanelType == _PANEL_PROPERTY_DATAPROC)
	pCObj->SetDataProcValidityCommand(strTgt, state == 1);
}

void CLS::
OnVolumeCoordEdit(wxComEvt& event){
    wxString strTgt = event.GetString();

    GetPCMain()->ProcAfterMath("SelectConfItem", strTgt);
}

void CLS::
OnPopMenu(wxComEvt& event){
    wxString strPopMenu = mCSelector.GetStr(event.GetId());
    if (strPopMenu.IsEmpty() == TRUE) return;
    
    wxString strTag = mCSelector.mstrTag;
    if (strTag.IsEmpty() == FALSE){
	SceneObj_cls *pCObj = GetPCLinkedObj();
	if (pCObj == NULL) return;

	Attribute_cls* pCAttrib = pCObj->GetPCAttribute(strTag);
	if (pCAttrib != NULL){
	    if (pCAttrib->IsAttributeSameAs("Tracking_cls"))
		((Tracking_cls*)pCAttrib)->SelectObject(strPopMenu);
	    if (pCAttrib->IsAttributeSameAs("ParticleBoolean_cls"))
		((ParticleBoolean_cls*)pCAttrib)->SelectObject(strPopMenu);
	    if (pCAttrib->IsAttributeSameAs("NestedVolume_cls"))
		((ParticleMerge_cls*)pCAttrib)->SelectObject(strPopMenu);
	    return;
	}
	
	Attribute_cls* pCDataProc = pCObj->GetPCDataProc(strTag);
	if (pCDataProc != NULL){
	    if (pCDataProc->IsAttributeSameAs("ParticleMerge_cls"))
		((ParticleMerge_cls*)pCDataProc)->SelectObject(strPopMenu);
	    if (pCDataProc->IsAttributeSameAs("VolumeBoolean_cls"))
		((VolumeBoolean_cls*)pCDataProc)->SelectObject(strPopMenu);
	    return; 
	}
    }
    
    mpCParent->SelectObject(strPopMenu);
}
