// (setq c-basic-offset 4)
// "clsPropertyModifier.cpp"

#ifndef _PROPERTY_MODIFIER_H
#define _PROPERTY_MODIFIER_H

#include "clsPropertyBase.h"

#include "../../CONFITEM/clsConfListContainer.h"
#include "../../INPUTMETHOD/clsSelectorPopup.h"
#include "../../WIDGETCTRL/EX/wxPanelEX.h"
#include "../../WIDGETCTRL/MULTIINPUT/clsHookCtrl.h"

#include "../../COMMON/CommonDefinitionsWX.h"

class Attribute_cls;
class Camera_cls;
class LightSource_cls;
class MultiInputPanel_cls;
class MNumPainBase_cls;
class Primitive_cls;
class Property_cls;
class VolumeBox_cls;

#define _MOD_MODIFIER 0
#define _MOD_DATAPROC 1

#include "../../COMMON/CommonDefinitionsWX.h"

class PropertyModifier_cls : public wxPanelEX, public PropertyBase_cls, public ConfListContainer_cls, public HookItem_cls {
public:
    PropertyModifier_cls(Property_cls *pCParent, int type, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDP, const wxSize &size=wxDS, long style=wxTAB_TRAVERSAL);

    ConfItemUINT_cls mCDummyUINT;
    ConfItemINT_cls mCDummyINT;

    void SetToDefaultParam();

    wxButton *mpCBtnAddItem;
    MNumPainBase_cls *mpCPainInRefuge;
        
    SelectorPopup_cls mCSelector;

    std::vector < MultiInputPanel_cls* > mVpCMNum;
    std::vector < Attribute_cls* > mVpCAttributeBuffer;
    
    std::vector < MultiInputPanel_cls* > mVpCMNumInRefuge;
    std::vector < Attribute_cls* > mVpCAttributeBufferInRefuge;

    wxArrayString mAstrClosedItem;

    void ClearPanels();
    void SavePanelInfoToRefuge();
    void ClearRefuge();
    MultiInputPanel_cls* GetPCMNumForReuse(Attribute_cls *pCAttrib);
    std::vector < bool > GetVbValidity();

    void Disconnect();
    void ConnectCommon();
    void Reconnect();
    void SetAttributeInfo();

    void ProcAfterMathModifier(wxString strCommand, wxString strTag);
    void CheckPanelOrder();
    void HideAndShow();
    void UpdatePanels(const wxString& strPanelTag);
    
    void HookFunc01(wxComEvt& event){OnAttributeChange(event);}
    void OnAttributeChange(wxComEvt& event);

    void OnDropDown(wxComEvt& event);
    void OnPinMode (wxComEvt& event);
    void OnAddItem (wxComEvt& event);
    void AddModifierCommand(wxString strClassName, wxString strNameCandid);
    void AddDProcCommand(wxString strClassName, wxString strNameCandid);
    void OnAddTracking      (wxComEvt& event);
    void OnAddArrayCopy     (wxComEvt& event);
    void OnAddModifyApparentSize(wxComEvt& event);
    void OnAddModifyParticleSize(wxComEvt& event);
    void OnAddNestedVolume  (wxComEvt& event);
    void OnAddTrimming      (wxComEvt& event);
    void OnAddTexSpaceMod   (wxComEvt& event);
    void OnAddSequenceRemap (wxComEvt& event);
    void OnAddVolumeBoolean (wxComEvt& event);
    void OnAddVolumeDownsize(wxComEvt& event);
    void OnAddVolumeCoord   (wxComEvt& event);
    void OnAddVolumeMask    (wxComEvt& event);
    void OnAddParticleBoolean  (wxComEvt& event);
    void OnAddParticleExclude  (wxComEvt& event);
    void OnAddParticleFiltering(wxComEvt& event);
    void OnAddParticleTweak(wxComEvt& event);
    void OnAddParticleDownsizing(wxComEvt& event);
    void OnAddParticleMerge(wxComEvt& event);
    void OnAddStreamFiltering(wxComEvt& event);
    void OnAddStreamSetAlpha (wxComEvt& event);
    void OnAddStreamTransform(wxComEvt& event);
    void OnDeleteModifier (wxComEvt& event);
    void OnToggleValidity (wxComEvt& event);
    void OnVolumeCoordEdit(wxComEvt& event);
    void OnPopMenu(wxComEvt& event);
    void OnKeyDown(wxKeyEvent& event);

    DECLARE_EVENT_TABLE()
};

#endif
