// (setq c-basic-offset 4)
// "clsPropertyObject.cpp"

#ifndef _PROPERTY_OBJECT_H
#define _PROPERTY_OBJECT_H

#include "clsPropertyBase.h"

#include "../../CONFITEM/clsConfListContainer.h"
#include "../../INPUTMETHOD/clsSelectorPopup.h"
#include "../../WIDGETCTRL/EX/wxPanelEX.h"
#include "../../WIDGETCTRL/MULTIINPUT/clsHookCtrl.h"

class Attribute_cls;
class Camera_cls;
class Isosurface_cls;
class LightSource_cls;
class MeshObj_cls;
class MultiInputPanel_cls;
class MNumPainBase_cls;
class ParamGroup_cls;
class Parameter_cls;
class Particle_cls;
class Primitive_cls;
class Property_cls;
class Streamline_cls;
class TextObj_cls;
class VolumeBox_cls;
class HeightField_cls;
class World_cls;

#include "../../COMMON/CommonDefinitionsWX.h"

class PropertyObject_cls : public wxPanelEX, public PropertyBase_cls, public ConfListContainer_cls, public HookItem_cls {
public:
    PropertyObject_cls(Property_cls *pCParent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDP, const wxSize &size=wxDS, long style=wxTAB_TRAVERSAL);
    ~PropertyObject_cls();

    ConfItemUINT_cls mCDummyUINT;
    ConfItemINT_cls mCDummyINT;
    ConfItemBOOL_cls mCDummyBOOL;
    ConfItemFLOAT_cls mCDummyFLOAT;
    ConfItemSTR_cls mCDummyName;
    ConfItemSTR_cls mCDummySTR;

    SelectorPopup_cls mCSelector;

    wxArrayString mAstrClosedItem;

    void SetToDefaultParam();
    
    int mIndexName;
        
    MultiInputPanel_cls* mpCMNum;
    void SetMNum();

    void HideAndShow();

    void ClearPanels();
    void Disconnect();
    void LayoutForConnect();
    void ConnectPrimitive(Primitive_cls* pCObj);
    void ConnectMesh(MeshObj_cls* pCObj);
    void ConnectTextObj(TextObj_cls* pCObj);
    void ConnectLightSource(LightSource_cls* pCObj);
    void ConnectCamera(Camera_cls* pCObj);
    void ConnectWorld(World_cls* pCObj);
    void ConnectVolumeBox(VolumeBox_cls* pCObj);
    void ConnectIsosurface(Isosurface_cls* pCObj);
    void ConnectParticle(Particle_cls* pCObj);
    void ConnectStreamline(Streamline_cls* pCObj);
    void ConnectHeightField(HeightField_cls* pCObj);
    void Reconnect();
    void UpdateButtonColor();
    void UpdateButtonColorWorld();
    void UpdateButtonColorParticle();

    void SetObjectInfo();

    void UpdatePanels(const wxString& strPanelTag);

    void HookFunc01    (wxComEvt& event){OnObjectChange(event);}
    void OnObjectChange(wxComEvt& event);
    void HookFunc02    (wxComEvt& event){OnParamChange(event);}
    void CheckParamChange(SceneObj_cls *pCObj, Attribute_cls *pCProp,
			  ParamGroup_cls *pCPG, int paramIndex,
			  float time, float newValue);
    void OnParamChange (wxComEvt& event);
    void SyncProp(bool bGroup = FALSE);
    void SyncPropWorld(bool bGroup = FALSE);
    
    void OnDropDown    (wxComEvt& event);
    void OnAutoscale   (wxComEvt& event);
    void OnReload      (wxComEvt& event);
    void OnExport      (wxComEvt& event);
    void OnExportFormat(wxComEvt& event);
    void OnClassify    (wxComEvt& event);
    void OnVolumePath  (wxComEvt& event);
    void OnParticlePath(wxComEvt& event);
    void OnParticlePathExporter(wxComEvt& event);
    void OnStreamlinePath(wxComEvt& event);
    void OnHFPath      (wxComEvt& event);
    void OnMeshPath    (wxComEvt& event);
    void OnTextFont    (wxComEvt& event);
    void OnBtnFogColor (wxComEvt& event);
    void OnPinMode     (wxComEvt& event);
    void OnPopMenu     (wxComEvt& event);
    void OnKeyDown(wxKeyEvent& event);

    DECLARE_EVENT_TABLE()
};

#endif
