// (setq c-basic-offset 4)
// "clsPropertyRender.cpp"

#ifndef _PROPERTY_RENDER_H
#define _PROPERTY_RENDER_H

#include "../../COMMON/clsGetPC.h"
#include "../../CONFITEM/clsConfItem.h"
#include "../../GRAPHIC/clsImgSizeTemplate.h"
#include "../../WIDGETCTRL/EX/wxPanelEX.h"

class MultiInputPanel_cls;
class MNumPainBase_cls;
class Property_cls;

#include "clsPropertyBase.h"

#include "../../COMMON/CommonDefinitionsWX.h"

class PropertyRender_cls : public wxPanelEX, public PropertyBase_cls, public ImgSizeTemplate_cls  {
public:
    PropertyRender_cls(Property_cls *pCParent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDP, const wxSize &size=wxDS, long style=wxTAB_TRAVERSAL);

    ConfItemINT_cls mCDummyWidth, mCDummyHeight;

    wxArrayString mAstrClosedItem;
    
    void SetToDefaultParam();

    int mIndexGLBG, mIndexMaskBG;
    int mIndexTemplate[4];
    int mIndexDummyWidth, mIndexDummyHeight;
    int mIndexWidth, mIndexHeight;
    int mIndexRenderPath, mIndexStereoOutput;
    int mIndexRenderSnap, mIndexRenderAnim;
    int mIndexLengthSV/*, mIndexGammaSV*/, mIndexOptionSV, mIndexTransparentShadow;
    int mIndexBlur, mIndexGammaBlur;
    int mIndexSample, mIndexGammaEnsemble;

    MultiInputPanel_cls* mpCMNum;
    void SetMNum();
    MultiInputPanel_cls* GetPCNewPanelBG(wxWindow *pCWindow);
    MultiInputPanel_cls* GetPCNewPanelOutput(wxWindow *pCWindow);
    MultiInputPanel_cls* GetPCNewPanelShadowVolume(wxWindow *pCWindow);
    MultiInputPanel_cls* GetPCNewPanelMotionBlur(wxWindow *pCWindow);
    MultiInputPanel_cls* GetPCNewPanelEnsemble(wxWindow *pCWindow);

    void Reconnect();
    void HideAndShow();

    bool IsBGTransparent();

    void SyncDummySize();
    void UpdateButtonColor();
    void UpdatePanels(const wxString& strPanelTag);
    void OpenColorDialog(wxString strClrTag);
    
    void OnGLBG(wxCommandEvent& event);
    void OnMaskBG(wxCommandEvent& event);
    void OnRenderSnap(wxCommandEvent& event);
    void OnRenderAnim(wxCommandEvent& event);
    void OnRenderPath(wxCommandEvent& event);
    //void OnKeyDown(wxKeyEvent& event);
    void OnCopyColor(wxCommandEvent& event);
    void OnPasteColor(wxCommandEvent& event);

    DECLARE_EVENT_TABLE();
};

#endif
