// (setq c-basic-offset 4)
// "clsPropertyScene.cpp"

#ifndef _PROPERTY_SCENE_H
#define _PROPERTY_SCENE_H

#include "clsPropertyBase.h"

#include "../../CONFITEM/clsConfListContainer.h"
#include "../../INPUTMETHOD/clsSelectorPopup.h"
#include "../../WIDGETCTRL/EX/wxPanelEX.h"

class MultiInputPanel_cls;
class MNumPainBase_cls;

#include "../../COMMON/clsGetPC.h"
#include "../../COMMON/CommonDefinitionsWX.h"
#include "../../WIDGETCTRL/MULTIINPUT/clsHookCtrl.h"

class Attribute_cls;
class MultiInputPanel_cls;
class Property_cls;

class PropertyScene_cls : public wxPanelEX, public ConfListContainer_cls, public PropertyBase_cls, public HookItem_cls {
public:
    PropertyScene_cls(Property_cls *pCParent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDP, const wxSize &size=wxDS, long style=wxTAB_TRAVERSAL);

    void SetToDefaultParam();

    wxButton *mpCBtnAddFilter;
    MNumPainBase_cls *mpCPainInRefuge;

    SelectorPopup_cls mCSelector;

    std::vector < MultiInputPanel_cls* > mVpCMNum;
    std::vector < Attribute_cls* > mVpCAttributeBuffer;
    
    std::vector < MultiInputPanel_cls* > mVpCMNumInRefuge;
    std::vector < Attribute_cls* > mVpCAttributeBufferInRefuge;

    wxArrayString mAstrClosedItem;

    void ClearPanels();
    void SavePanelInfoToRefuge();
    void ClearRefuge();
    MultiInputPanel_cls* GetPCMNumForReuse(Attribute_cls *pCAttrib);
    std::vector < bool > GetVbValidity();
    
    void Disconnect();
    void Reconnect();
    void SetAttributeInfo();
    void ProcAfterMathScene(wxString strCommand, wxString strTag);
    void CheckPanelOrder();
    void UpdateButtonColor();
    void UpdatePanels(const wxString& strPanelTag);

    void HookFunc01(wxComEvt& event){OnAttributeChange(event);}
    void OnAttributeChange(wxComEvt& event);

    void OnDropDown(wxComEvt& event);
    void OnBtnColorSSAO  (wxComEvt& event);
    void OnAddFilter     (wxComEvt& event);
    void OnAddExposure   (wxComEvt& event);
    void OnAddBlur       (wxComEvt& event);
    void OnAddFocalBlur  (wxComEvt& event);
    void OnAddGlare      (wxComEvt& event);
    void OnAddRemoveAlpha(wxComEvt& event);
    void OnAddOverlay    (wxComEvt& event);
    void OnAddLegend     (wxComEvt& event);
    void OnAddSSAO       (wxComEvt& event);
    void OnAddFilterDepth(wxComEvt& event);
    void OnDeleteFilter  (wxComEvt& event);
    void OnToggleValidity(wxComEvt& event);
    void OnOverlayPath   (wxComEvt& event);
    void OnLegendTargetClear(wxComEvt& event);
    void OnLegendFont    (wxComEvt& event);
    void OnPopMenu(wxComEvt& event);

    DECLARE_EVENT_TABLE();
};

#endif
