// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsProperty.cpp"

#ifndef _PROPERTY_H
#define _PROPERTY_H

#include "../COMMON/clsGetPC.h"
#include "../CONFITEM/clsConfListContainer.h"
#include "../WIDGETCTRL/EX/wxPanelEX.h"

#include "../COMMON/CommonDefinitionsWX.h"

class IconSelector_cls;
class PropertyRender_cls;
class PropertyScene_cls;
class PropertyObject_cls;
class PropertyMaterial_cls;
class PropertyModifier_cls;
class PropertyFormat_cls;
class PropertyInfo_cls;
class TextButton_cls;

#define _PROPERTY_RENDER 0
#define _PROPERTY_SCENE  1
#define _PROPERTY_OBEJCT 2
#define _PROPERTY_MATERIAL 3
#define _PROPERTY_MODIFIER 4
#define _PROPERTY_DATAPROC 5
#define _PROPERTY_FORMAT 6
#define _PROPERTY_INFORMATION 7

class Property_cls : public wxPanelEX, public GetPC_cls, public ConfListContainer_cls {
 public:
    Property_cls(wxWindow *pCParent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDP, const wxSize &size=wxDS, long style=wxTAB_TRAVERSAL);

    ConfItemSTR_cls mCSelectorMode;
    
    TextButton_cls *mpCTextMenuView;
    IconSelector_cls *mpCIconSelector;
    PropertyRender_cls *mpCRender;
    PropertyScene_cls *mpCScene;
    PropertyObject_cls *mpCObject;
    PropertyMaterial_cls *mpCMaterial;
    PropertyModifier_cls *mpCModifier;
    PropertyModifier_cls *mpCDataProc;
    PropertyFormat_cls *mpCFormat;
    PropertyInfo_cls *mpCInfo;
    
    wxStaticText *mpCText;

    void SetDefault();
    void HideAndShow();

    void SelectObject(wxString strObj);
    void ProcAfterMath(const wxString& strCommand, wxString strTag, bool bForce = FALSE);

    void UpdatePanels(const wxString& strPanelTag);
    void OnMenuView(wxCommandEvent& event);
    void OnKeyDown(wxKeyEvent& event);
    void OnSelector(wxCommandEvent& event);

    void Serialize(wxString& strOut);
    void ReadStrLine(std::wistream &istream, wxString strFirstItem, wxString strLine);

    DECLARE_EVENT_TABLE()
};

#endif
