// -*- c++ -*- 
// "clsRibbonUI.cpp"
// (setq c-basic-offset 4)

#ifndef _RIBBONUI_H_
#define _RIBBONUI_H_

class wxWindow;
class wxRibbonBar;
class wxRibbonPage;
class wxRibbonPanel;
class wxRibbonToolBar;

#include <wx/wx.h>
#include <wx/ribbon/toolbar.h>
#include <vector>

#include "../COMMON/clsGetPC.h"

#define _RBN_HOME 0
#define _RBN_HELP 1

#define _RBN_PANEL_HOME 0 
#define _RBN_PANEL_DATA 1
#define _RBN_PANEL_OBJECT 2
#define _RBN_PANEL_PREFERENCE 3

#define _RBN_PANEL_HELP 0

class RibbonPage_cls : public wxRibbonPage {
 public:
    RibbonPage_cls(wxRibbonBar* pCParentBar,
		   wxString strTab, std::vector < wxString > VstrPanels);
    
    std::vector < wxRibbonPanel* > mVpCRbnPanel;
    std::vector < wxRibbonToolBar* > mVpCRbnToolBar;
};

class RibbonUI_cls : public GetPC_cls {
 public:
    RibbonUI_cls(wxWindow *pCParentLink);

    wxWindow *mpCParentLink;

    wxRibbonBar *mpCRbnBar;
    std::vector < RibbonPage_cls* > mVpCRibbonPage;

    int mCurrentTabIndex, mCurrentPanelIndex;

    void UpdateRibbonHelp(bool bUse = TRUE);
    void UpdateRibbonState();
    wxRibbonToolBar* GetPToolBar();
    void AddTool(int id, wxString strIcon, wxSize sz, wxString strHelpString);
};

#endif
