// -*- c -*-
// "clsMeshBase2.h"
//(setq c-basic-offset 4)

#include "clsMeshBase2.h"

#include "../COMMON/clsArrayAndIndex.h"
#include "../COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;

#include "../PREFERENCE/clsPreference.h"

#include <algorithm>

#include "../COMMON/CommonDefinitions.h"
#include "../COMMON/CommonDefinitionsGL.h"

#ifdef WIN32
extern PFNGLBINDBUFFERPROC glBindBuffer;
extern PFNGLBUFFERDATAPROC glBufferData;
#endif

#include <wx/file.h>
#include <wx/filename.h>

MaterialStock_cls::
MaterialStock_cls(int matIndex, int vertIndexNum){
    mMatIndex = matIndex;
    mVertIndexNum = vertIndexNum;
}

#define CLS MeshBase2_cls

CLS::
MeshBase2_cls() : mCTree(0, 5) {
}

bool CLS::
IsInsideRegionBox(float fX, float fY, float fZ){
    if (fX < mRangeMin[0] || fX > mRangeMax[0]) return FALSE;
    if (fY < mRangeMin[1] || fY > mRangeMax[1]) return FALSE;
    if (fZ < mRangeMin[2] || fZ > mRangeMax[2]) return FALSE;
    return TRUE;
}

int CLS::
GetTagBufferSize(){
    return mVVertex.size()/3;
}

bool CLS::
IsInside(float fX, float fY, float fZ, int tagBufferSize, int *pVertexTag){
    if (mVFaceIndexVertex.size() == 0)
	return TRUE;

    if (IsInsideRegionBox(fX, fY, fZ) == FALSE) return FALSE;

    //int numVertex = mVVertex.size()/3;
    //    int *pVertexTag = new int [numVertex];
    
    for (int i = 0; i < tagBufferSize; i++) pVertexTag[i] = 0;

    Tree2D_cls *pCTreeTgt = mCTree.GetPCTree(fX, fY);
    
    int count = 0;
    bool bInsideFlag = FALSE;
    uint numFace = pCTreeTgt->mVItemIndex.size();
    //uint faceNum = mVFaceIndexVertex.size() / 3;
    for (uint i_ = 0; i_ < numFace; i_++){
	int i = pCTreeTgt->mVItemIndex[i_];
	// XY ʂɓeĎOp`̓O
	const int indexA = mVFaceIndexVertex[i*3+0];
	const int indexB = mVFaceIndexVertex[i*3+1];
	const int indexC = mVFaceIndexVertex[i*3+2];
	float * const posA = &mVVertex[indexA*3];
	float * const posB = &mVVertex[indexB*3];
	float * const posC = &mVVertex[indexC*3];

	const float vecBA_2[3] = {posA[0]-posB[0],posA[1]-posB[1],posA[2]-posB[2]};
	const float vecCA_2[3] = {posA[0]-posC[0],posA[1]-posC[1],posA[2]-posC[2]};
	float vecCrossBC[3];
	GetCrossedVector(vecBA_2, vecCA_2, vecCrossBC);
	// Sɗ|S͔ɉeȂ
	if (vecCrossBC[2] == 0) continue;
	
	// XYʏŎOp`̓ɋB
	const float vecBA[3] = {posA[0]-posB[0],posA[1]-posB[1], 0};
	const float vecCB[3] = {posB[0]-posC[0],posB[1]-posC[1], 0};
	const float vecAC[3] = {posC[0]-posA[0],posC[1]-posA[1], 0};
	const float vecAP[3] = {fX-posA[0], fY-posA[1], 0};
	const float vecBP[3] = {fX-posB[0], fY-posB[1], 0};
	const float vecCP[3] = {fX-posC[0], fY-posC[1], 0};
	float vecCrossAZ = GetCrossedVectorZ(vecBA, vecAP);
	float vecCrossBZ = GetCrossedVectorZ(vecCB, vecBP);
	float vecCrossCZ = GetCrossedVectorZ(vecAC, vecCP);
	int insideSingle = 0;
	if ((vecCrossAZ >= 0 && vecCrossBZ >= 0 && vecCrossCZ >= 0) ||
	    (vecCrossAZ <= 0 && vecCrossBZ <= 0 && vecCrossCZ <= 0)){
	    int zeroCount = 0;
	    if (vecCrossAZ == 0) zeroCount++;
	    if (vecCrossBZ == 0) zeroCount++;
	    if (vecCrossCZ == 0) zeroCount++;

	    // d_ŏdȂĔ肳ꍇ
	    // ̃|SŃJEgȂ߂̃`FbN
	    // {͗ƕ\ʂ̃^OKv !! FIX_ME !!
	    if (zeroCount >= 2){ // őł2 ̂͂
		if (vecCrossAZ == 0 && vecCrossBZ == 0){
		    if (pVertexTag[indexB] == 1) continue;
		    else pVertexTag[indexB] = 1;
		}
		if (vecCrossBZ == 0 && vecCrossCZ == 0){
		    if (pVertexTag[indexC] == 1) continue;
		    else pVertexTag[indexC] = 1;
		}
		if (vecCrossCZ == 0 && vecCrossAZ == 0){
		    if (pVertexTag[indexA] == 1) continue;
		    else pVertexTag[indexA] = 1;
		}
		insideSingle = 2;
	    }
	    
	    else{
		// ʏ2ɂ (zero=1)2|SŋL̂1
		insideSingle = 2 - zeroCount;
	    }
	}
	
	if (insideSingle != 0){
	    float vecAP_2[3] = {fX-posA[0], fY-posA[1], fZ-posA[2]};
	    float scalar = GetScalarProduct(vecCrossBC, vecAP_2);
	    
	    bInsideFlag = TRUE;
	    if (scalar >= 0) count -= insideSingle;
	    else             count += insideSingle;
	}
    }
    if (bInsideFlag == TRUE && count != 4) bInsideFlag = FALSE;

    //delete [] pVertexTag;

    return bInsideFlag;
}

void CLS::
ClearAll(){
    std::vector < float >().swap(mVVertex);
    std::vector < float >().swap(mVNormal);
    std::vector < float >().swap(mVUV2);
    std::vector < uint >().swap(mVFaceIndexVertex);
    std::vector < uint >().swap(mVFaceIndexNormal);
    std::vector < uint >().swap(mVFaceIndexUV2);
    std::vector < MaterialStock_cls >().swap(mVMaterialStock);

    std::vector < uint >().swap(mVFaceIndexVertexAdj);

    mCWFMaterial.Clear();
    mstrLoaded.Clear();
    mCVBO.Clear();
}

void CLS::
MinimizeMemoryUse(){
    std::vector < float >(mVVertex).swap(mVVertex);
    std::vector < float >(mVNormal).swap(mVNormal);
    std::vector < float >(mVUV2).swap(mVUV2);
    std::vector < uint >(mVFaceIndexVertex).swap(mVFaceIndexVertex);
    std::vector < uint >(mVFaceIndexNormal).swap(mVFaceIndexNormal);
    std::vector < uint >(mVFaceIndexUV2).swap(mVFaceIndexUV2);
    std::vector < MaterialStock_cls >(mVMaterialStock).swap(mVMaterialStock);

    std::vector < uint >(mVFaceIndexVertexAdj).swap(mVFaceIndexVertexAdj);
}

void CLS::
CheckRange(){
    if (mstrRangeChecked.IsSameAs(mstrLoaded)) return;
    mstrRangeChecked = mstrLoaded;

    mRangeMin[0] = mRangeMin[1] = mRangeMin[2] = +1e15;
    mRangeMax[0] = mRangeMax[1] = mRangeMax[2] = -1e15;
    uint numVertex = mVVertex.size()/3;
    for (uint i = 0; i < numVertex; i++){
	float x = mVVertex[i*3+0], y = mVVertex[i*3+1], z = mVVertex[i*3+2];
	if (mRangeMin[0] > x) mRangeMin[0] = x;
	if (mRangeMax[0] < x) mRangeMax[0] = x;
	if (mRangeMin[1] > y) mRangeMin[1] = y;
	if (mRangeMax[1] < y) mRangeMax[1] = y;
	if (mRangeMin[2] > z) mRangeMin[2] = z;
	if (mRangeMax[2] < z) mRangeMax[2] = z;
    }
}

void CLS::
CheckTree(){
    if (mstrTreeChecked.IsSameAs(mstrLoaded)) return;
    mstrTreeChecked = mstrLoaded;

    CheckRange();
    mCTree.SetRange(mRangeMin[0], mRangeMax[0], 
		    mRangeMin[1], mRangeMax[1]);

    mCTree.Clear();
    uint numFace = mVFaceIndexVertex.size() / 3;
    std::vector < uint > VTemp(numFace);
    for (uint i = 0; i < numFace; i++) VTemp[i] = i;
    mCTree.CheckTreeItem(VTemp, mVFaceIndexVertex, mVVertex, 0);
}

void CLS::
ConvertCoord(int order[3]){
    uint numVert = mVVertex.size()/3;
    for (uint i = 0; i < numVert; i++){
	float buf[3] = {mVVertex[i*3+0], mVVertex[i*3+1], mVVertex[i*3+2]};
	mVVertex[i*3+0] = buf[order[0]];
	mVVertex[i*3+1] = buf[order[1]];
	mVVertex[i*3+2] = buf[order[2]];
    }

    uint numNormal = mVNormal.size()/3;
    for (uint i = 0; i < numNormal; i++){
	float buf[3] = {mVNormal[i*3+0], mVNormal[i*3+1], mVNormal[i*3+2]};
	mVNormal[i*3+0] = buf[order[0]];
	mVNormal[i*3+1] = buf[order[1]];
	mVNormal[i*3+2] = buf[order[2]];
    }
}

void CLS::
ConstructNormalVectors(){
    //_ASSERT(mVFaceIndexNormal.size() == 0);
    
    mVNormal.resize(mVVertex.size());
    
    int normalSize = (int)mVNormal.size(); //_*3()
    for (int i = 0; i < normalSize; i++) mVNormal[i] = 0;
    int normalNum = normalSize / 3; // _
    
    // _͕̖ʂQƂ̂ŁA
    // flat shading ͒_Ɠ Normal  \Ȃ
    // smooth shading ɂȂB ̂悤Ȓ_ Normal ͕ωB
    std::vector < unsigned char > VOverlap(normalNum);
    
    int indexVertBase = 0;
    int faceNum = mVFaceIndexVertex.size() / 3;
    for (int i = 0; i < faceNum; i++){
	// ŏ3_normal߂
	int index0 = mVFaceIndexVertex[indexVertBase + 0];
	int index1 = mVFaceIndexVertex[indexVertBase + 1];
	int index2 = mVFaceIndexVertex[indexVertBase + 2];

	float *p0 = &mVVertex[index0*3];
	float *p1 = &mVVertex[index1*3];
	float *p2 = &mVVertex[index2*3];

	double normal[3];
	normal[X] = (p1[Y]-p0[Y])*(p2[Z]-p1[Z]) - (p1[Z]-p0[Z])*(p2[Y]-p1[Y]);
	normal[Y] = (p1[Z]-p0[Z])*(p2[X]-p1[X]) - (p1[X]-p0[X])*(p2[Z]-p1[Z]);
	normal[Z] = (p1[X]-p0[X])*(p2[Y]-p1[Y]) - (p1[Y]-p0[Y])*(p2[X]-p1[X]);
	
	if (GetNorm(normal) == 0){
	    normal[X] = 0;
	    normal[Y] = 0;
	    normal[Z] = 1;
	}
	else
	    Normalize(normal, 1);

	for (int i = 0; i < 3; i++){
	    int index = mVFaceIndexVertex[indexVertBase + i];
	    VOverlap[index]++;
	    int overlap = VOverlap[index];
	    LOOP_XYZ mVNormal[index*3 + xyz] =
		(mVNormal[index*3 + xyz] * (overlap - 1) + normal[xyz]) / overlap;
	}
	indexVertBase += 3;
    }

    for (int i = 0; i < normalNum; i++){
	if (GetNorm(&mVNormal[i*3]) == 0){
	    mVNormal[i*3+X] = 0;
	    mVNormal[i*3+Y] = 0;
	    mVNormal[i*3+Z] = 1;
	}
	Normalize(&mVNormal[i*3], 1);
    }

    mVFaceIndexNormal.clear();
    mVFaceIndexNormal.reserve(mVFaceIndexVertex.size());
    std::copy(mVFaceIndexVertex.begin(), mVFaceIndexVertex.end(),
	      std::back_inserter(mVFaceIndexNormal));
}

int CLS::
TriangulateNgon(int ngon){
    int baseVert = mVFaceIndexVertex.size() - ngon;
    int baseTex = mVFaceIndexUV2.size() - ngon;
    int baseNormal = mVFaceIndexNormal.size() - ngon;

    if (ngon % 3 == 1){
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert]);
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert + ngon - 2]);
	if (baseTex >= 0){
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex]);
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex + ngon -2]);
	}
	if (baseNormal >= 0){
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal]);
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal+ ngon-2]);
	}
    }

    if (ngon % 3 == 2){
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert]);
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert]);
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert + ngon - 3]);
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert + ngon - 2]);
	if (baseTex >= 0){
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex]);
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex]);
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex + ngon - 3]);
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex + ngon - 2]);
	}
	if (baseNormal >= 0){
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal]);
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal]);
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal+ ngon- 3]);
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal+ ngon- 2]);
	}
	
    }

    int trianglesAlreadyMade = ngon / 3;
    for (int i = 1; i < trianglesAlreadyMade; i++){
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert]);
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert+i*3-1]);
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert+i*3]);
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert]);
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert+i*3]);
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert+i*3+2]);
	if (baseTex >= 0){
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex]);
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex+i*3-1]);
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex+i*3]);
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex]);
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex+i*3]);
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex+i*3+2]);
	}
	if (baseNormal >= 0){
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal]);
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal+i*3-1]);
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal+i*3]);
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal]);
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal+i*3]);
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal+i*3+2]);
	}
    }
    
    return ngon - 2;
}

int CLS::
TriangulateLastItem(int ngon){
    if (ngon >= 6)
	return TriangulateNgon(ngon);

    // 6p|S܂őΉ
    int baseVert = mVFaceIndexVertex.size() - ngon;
    int baseTex = mVFaceIndexUV2.size() - ngon;
    int baseNormal = mVFaceIndexNormal.size() - ngon;

    if (ngon >= 6){
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert]);
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert+2]);
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert+3]);
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert]);
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert+3]);
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert+5]);
	if (baseTex >= 0){
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex]);
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex+2]);
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex+3]);
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex]);
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex+3]);
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex+5]);
	}
	if (baseNormal >= 0){
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal]);
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal+2]);
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal+3]);
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal]);
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal+3]);
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal+5]);
	}
	return 4;
    }
    else if (ngon == 5){
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert]);
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert+2]);
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert+3]);
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert]);
	if (baseTex >= 0){
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex]);
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex+2]);
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex+3]);
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex]);
	}
	if (baseNormal >= 0){
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal]);
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal+2]);
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal+3]);
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal]);
	}
	return 3;
    }
    else if (ngon == 4){
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert]);
	mVFaceIndexVertex.push_back(mVFaceIndexVertex[baseVert+2]);
	if (baseTex >= 0){
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex]);
	    mVFaceIndexUV2.push_back(mVFaceIndexUV2[baseTex+2]);
	}
	if (baseNormal >= 0){
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal]);
	    mVFaceIndexNormal.push_back(mVFaceIndexNormal[baseNormal+2]);
	}
	return 2;
    }
    return 1; // FIX_ME_!!
}

class VertexTag_cls{
public:
    VertexTag_cls();
    int mVertIndex, mNormalIndex, mTexIndex, mNextCandidate;
};

VertexTag_cls::
VertexTag_cls(){
    mVertIndex = mNormalIndex = mTexIndex = -1;
    mNextCandidate = -1;
}

void CLS::
DuplicateDouble(){
    // _͈ꏏ Normal  UV ̈Ⴄ_ʒ_ɂ

    bool bNormal = FALSE, bTex = FALSE;
    if (mVFaceIndexNormal.size() != 0) bNormal = TRUE;
    if (mVFaceIndexUV2.size() != 0) bTex = TRUE;

    int numVert = mVVertex.size()/3;
    int numFaceVertex = mVFaceIndexVertex.size();

    std::vector < VertexTag_cls > VVertexTag(numVert);

    for (int i = 0; i < numFaceVertex; i++){
	
	int vertexIndex = mVFaceIndexVertex[i];
	int normalIndex = -1;
	int texIndex = -1;
	if (bNormal == TRUE) normalIndex = mVFaceIndexNormal[i];
	if (bTex == TRUE) texIndex = mVFaceIndexUV2[i];

	int candidate = vertexIndex;

	while(TRUE){

	    //_ASSERT(candidate < VVertexTag.size());

	    VertexTag_cls &CTag = VVertexTag[candidate];
	    if (CTag.mVertIndex == -1){
		CTag.mVertIndex = vertexIndex;
		CTag.mNormalIndex = normalIndex;
		CTag.mTexIndex = texIndex;
		mVFaceIndexVertex[i] = candidate;
		if (bNormal == TRUE)
		    mVFaceIndexNormal[i] = normalIndex;
		if (bTex == TRUE)
		    mVFaceIndexUV2[i] = texIndex;
		break;
	    }

	    if (CTag.mVertIndex == vertexIndex &&
		CTag.mNormalIndex == normalIndex &&
		CTag.mTexIndex == texIndex){
		mVFaceIndexVertex[i] = candidate;
		if (bNormal == TRUE)
		    mVFaceIndexNormal[i] = normalIndex;
		if (bTex == TRUE)
		    mVFaceIndexUV2[i] = texIndex;
		break;
	    }

	    if (CTag.mNextCandidate != -1){
		candidate = CTag.mNextCandidate;
		continue;
	    }

	    int dummy = 0;
	    
	    // VK_쐬
	    int newIndex = mVVertex.size() / 3;
	    mVVertex.push_back(mVVertex[vertexIndex*3+0]);
	    mVVertex.push_back(mVVertex[vertexIndex*3+1]);
	    mVVertex.push_back(mVVertex[vertexIndex*3+2]);
	    mVFaceIndexVertex[i] = newIndex;
	    
	    int newNormalIndex = mVNormal.size() / 3;
	    mVNormal.push_back(mVNormal[normalIndex*3+0]);
	    mVNormal.push_back(mVNormal[normalIndex*3+1]);
	    mVNormal.push_back(mVNormal[normalIndex*3+2]);
	    if (bNormal == TRUE) mVFaceIndexNormal[i] = newNormalIndex;
	    
	    if (bTex == TRUE){
		int newTexIndex = mVUV2.size() / 2;
		mVUV2.push_back(mVUV2[texIndex*2+0]);
		mVUV2.push_back(mVUV2[texIndex*2+1]);
		mVFaceIndexUV2[i] = newTexIndex;
	    }

	    VertexTag_cls CTagNew;
	    CTagNew.mVertIndex = vertexIndex;
	    CTagNew.mNormalIndex = normalIndex;
	    CTagNew.mTexIndex = texIndex;
	    VVertexTag.push_back(CTagNew);

	    VVertexTag[candidate].mNextCandidate = newIndex;

	    candidate = newIndex;//break;
	}
    }
}



void CLS::
ReconstructStructure(){
    
    std::vector < float > VNormalOrg(mVNormal);
    std::vector < float > VUV2Org(mVUV2);

    bool bNormal = FALSE, bTex = FALSE;
    if (mVFaceIndexNormal.size() != 0) bNormal = TRUE;
    if (mVFaceIndexUV2.size() != 0) bTex = TRUE;

    if (bNormal == TRUE) mVNormal.resize(mVVertex.size());
    if (bTex == TRUE) mVUV2.resize(mVVertex.size() / 3 * 2); 

    int numFaceVertex = mVFaceIndexVertex.size();
    for (int i = 0; i < numFaceVertex; i++){
	int vertexIndex = mVFaceIndexVertex[i];
	int normalIndex = vertexIndex;
	if (bNormal == TRUE) normalIndex = mVFaceIndexNormal[i];
	
	mVNormal[vertexIndex*3 + 0] = VNormalOrg[normalIndex*3+0];
	mVNormal[vertexIndex*3 + 1] = VNormalOrg[normalIndex*3+1];
	mVNormal[vertexIndex*3 + 2] = VNormalOrg[normalIndex*3+2];

	if (bTex == TRUE){
	    int texIndex = mVFaceIndexUV2[i];
	    mVUV2[vertexIndex*2 + 0] = VUV2Org[texIndex*2 + 0];
	    mVUV2[vertexIndex*2 + 1] = VUV2Org[texIndex*2 + 1];
	}
    }
}

bool CLS::
ReadObjFile(wxString strFile, int coord, bool bUseEmit){

    if (mstrLoaded == strFile) return FALSE;

    mstrLoadedObjectName.clear();

    long filesize;
    char *pBuffer = GetPNewBufferFromFile(strFile, filesize);

    if (pBuffer == NULL){
	ClearAll();
	mstrLoaded = strFile;
	return FALSE;
    }

    const char *ptr = (const char*)pBuffer;
    char *pEnd = pBuffer + filesize;

    bool bSmooth;

    ClearAll();

    mCWFMaterial.mbUseEmitAsAmbient = bUseEmit;

    //mVMaterialAndPolygon.reserve(filesize / 3 / 7);
    ReserveVertexNumber(filesize/10);
    ReserveFaceNumber(filesize/7);

    bool bMaterialExist = FALSE; 

    int faceVertexNum = 0; // }eAƂ̖(x3vertex)
    int mtlIndex = -1; //

    while (TRUE){
	if (ptr >= pEnd) break;	
	if (*ptr == '#'){
	    if (SearchChar(&ptr, '\n', pEnd) == FALSE) break;
	}
	if (*ptr == 'm'){ // mtllib
	    if (SearchChar(&ptr, ' ', pEnd) == FALSE) break;
	    ptr++;

	    char strMtlFile[256];
	    GetStrUptoLineEnd(&ptr, strMtlFile, pEnd);

	    wxFileName CSplit(strFile);
	    mCWFMaterial.ReadMtllib(CSplit.GetPath(), 
				    wxString::FromAscii(strMtlFile));
	    bMaterialExist = TRUE;
	}

	if (*ptr == 'u'){ //usemtl
	    if (SearchChar(&ptr, ' ', pEnd) == FALSE) break;
	    ptr++;

	    char strMtlTag[256];
	    GetStrUptoLineEnd(&ptr, strMtlTag, pEnd);

	    if (faceVertexNum != 0){
		MaterialStock_cls CMatStock(mtlIndex, faceVertexNum);
		mVMaterialStock.push_back(CMatStock);
	    }

	    mtlIndex = mCWFMaterial.
		GetIndexFromTag(wxString::FromAscii(strMtlTag));

	    faceVertexNum = 0;
	}

	if (*ptr == 'g'){
	    ptr++;
	    if (SearchChar(&ptr, '\n', pEnd) == FALSE) break;
	}
	if (*ptr == 'o'){
	    if (SearchChar(&ptr, ' ', pEnd) == FALSE) break;
	    ptr++;

	    char strObjName[256];
	    GetStrUptoLineEnd(&ptr, strObjName, pEnd);
	    mstrLoadedObjectName << strObjName;
	    //if (SearchChar(&ptr, '\n', pEnd) == FALSE) break;
	}
	if (*ptr == 'v'){
	    if (*(ptr+1) == 'n'){
		ptr++; ptr++; while ((*ptr) == ' ') ptr++;
		mVNormal.push_back(ReadFloat(&ptr, ' ')); ptr++;
		mVNormal.push_back(ReadFloat(&ptr, ' ')); ptr++;
		mVNormal.push_back(ReadFloat(&ptr, '\n'));
	    }
	    if (*(ptr+1) == 't'){
		ptr++; ptr++; while ((*ptr) == ' ') ptr++;
		mVUV2.push_back(ReadFloat(&ptr, ' ')); ptr++;
		mVUV2.push_back(ReadFloat(&ptr, '\n'));
	    }
	    if (*(ptr+1) == ' '){
		ptr++; while ((*ptr) == ' ') ptr++;
		mVVertex.push_back(ReadFloat(&ptr, ' ')); ptr++;
		mVVertex.push_back(ReadFloat(&ptr, ' ')); ptr++;
		mVVertex.push_back(ReadFloat(&ptr, '\n'));
	    }
	}
	if (*ptr == 's'){
	    ptr++; ptr++;
	    bSmooth = ReadBool(&ptr, '\n');
	}

	if (*ptr == 'f'){
	    ptr++; ptr++;
	    if (IsCharExist(ptr, ' ', '/') == TRUE){
		int ngon = 0;
		while(TRUE){
		    if (*ptr == ' ') ptr++;
		    if (*ptr == '\r') ptr++;
		    if (*ptr == '\n') break;
		    ngon++;
		    mVFaceIndexVertex.push_back(ReadInt(&ptr, '/') - 1);
		    ptr++;
		    if (*ptr != '/'){
			mVFaceIndexUV2.push_back(ReadInt(&ptr, '/') - 1);
			if (*ptr == '/') ptr++;
		    }
		    else
			ptr++;
		    if (*ptr != ' ' && *ptr != '\n')
			mVFaceIndexNormal.push_back(ReadInt(&ptr, ' ') - 1);
		    if (*ptr == '\n') break;
		    if (ptr > pEnd) break;
		    ptr++;
		}

		int faceNum = 1;
		if (ngon != 3) faceNum = TriangulateLastItem(ngon);

		faceVertexNum += faceNum * 3;
	    }
	    else{
		int ngon = 0;
		while (TRUE){
		    if (*ptr == ' ') ptr++;
		    if (*ptr == '\r') ptr++;
		    if (*ptr == '\n') break;
		    ngon++;
		    int index = ReadInt(&ptr, ' ') - 1;
		    mVFaceIndexVertex.push_back(index);
		    //VFaceIndexUV2.push_back(index);
		    //VFaceIndexNormal.push_back(index);
		    if (*ptr == '\n') break;
		    if (ptr > pEnd) break;
		    ptr++;
		}

		int faceNum = 1;
		if (ngon != 3) faceNum = TriangulateLastItem(ngon);
		
		faceVertexNum += faceNum*3;
	    }
	    if (mVFaceIndexVertex.size() % 3 != 0)
		printf("!!\n");
	}
	ptr++;
    }

    MaterialStock_cls CMatStock(mtlIndex, faceVertexNum);
    mVMaterialStock.push_back(CMatStock);

    delete pBuffer;
    mstrLoaded = strFile;

    // Wϊ
    int order[3] = {0, 1, 2};
    switch(coord){
    case 1: order[0] = 1; order[1] = 2; order[2] = 0; break; // y-z-x
    case 2: order[0] = 2; order[1] = 0; order[2] = 1; break; // z-x-y

    case 3: order[0] = 0; order[1] = 2; order[2] = 1; break; // x-z-y
    case 4: order[0] = 2; order[1] = 1; order[2] = 0; break; // z-y-x
    case 5: order[0] = 1; order[1] = 0; order[2] = 2; break; // y-x-z
    }
    if (coord != 0) ConvertCoord(order);

    // @xNg
    if (mVNormal.size() == 0) ConstructNormalVectors();

    // UVm[}̃CfbNXႤƂ̂
    // _ƃCfbNXg悤ɍč\z
    DuplicateDouble();
    ReconstructStructure();

    //mbMaterialExist = bMaterialExist;
    // }eA
    if (bMaterialExist == FALSE) mCWFMaterial.MakeMaterialIfEmpty();

    // ep\
    ConstructAdjStructure();

    return TRUE;
}

void CLS::
ReadBeginFromData(){
    mVertexOffset = 0;
}

void CLS::
ReadAppendFromData(int vertexSize, int faceSize, 
		   float *pVertices, float *pNormals, int *pFaceIndex){
    // ł
    for (int i = 0; i < vertexSize; i++)
	mVVertex.push_back(pVertices[i]);
    for (int i = 0; i < vertexSize; i++)
	mVNormal.push_back(pNormals[i]);
    for (int i = 0; i < faceSize*3; i++){
	mVFaceIndexVertex.push_back(mVertexOffset + pFaceIndex[i]);
    }
    mVertexOffset += vertexSize/3;
}

bool CLS::
ReadFinishFromData(bool bUseSV){
    /*
    uint sizeVertex = mVVertex.size()/3;
    for (uint i = 0; i < sizeVertex; i++)
	mVFaceIndexVertex.push_back(i);
    */

    MaterialStock_cls CMatStock(0, mVFaceIndexVertex.size());
    mVMaterialStock.push_back(CMatStock);
    
    // }eA
    mCWFMaterial.MakeMaterialIfEmpty();

    if (bUseSV == TRUE) ConstructAdjStructure();

    return TRUE;
}

void CLS::ReserveVertexNumber(int num){
    mVVertex.reserve(num*3);
    mVNormal.reserve(num*3);
    mVUV2.reserve(num*2);
}

void CLS::ReserveFaceNumber(int num){
    mVFaceIndexVertex.reserve(num*4);
    mVFaceIndexNormal.reserve(num*4);
    mVFaceIndexUV2.reserve(num*4);
}

void CLS::SetVertexNumber(int num){
    mVVertex.resize(num*3);
    mVNormal.resize(num*3);
    mVUV2.resize(num*2);
}

void CLS::SetFaceNumber(int num){
    mVFaceIndexVertex.resize(num*4);
    mVFaceIndexNormal.resize(num*4);
    mVFaceIndexUV2.resize(num*4);
}

int CLS::
SearchAdjTriangle(int ibase, int vertex0, int vertex1){
    int size = mVFaceIndexVertex.size();
    int ini = ibase - 99, fin = ibase + 99;
    if (ini < 0) ini = 0;
    if (fin > size) fin = size;

    for (int i = ini; i < fin; i+=3){
	int vertexA = mVFaceIndexVertex[i];
	int vertexB = mVFaceIndexVertex[i+1];
	int vertexC = mVFaceIndexVertex[i+2];
	if (vertexB == vertex0 && vertexA == vertex1) return vertexC;
	if (vertexC == vertex0 && vertexB == vertex1) return vertexA;
	if (vertexA == vertex0 && vertexC == vertex1) return vertexB;
    }
    return -1;
}

int CLS::
SearchAdjTriangleB(int ibase_, ArrayAndIndex_cls *pCIdxAndZ, 
		   int vertex0, int vertex1){
    const int searchRange = 599;
    int triangleNum = mVFaceIndexVertex.size() / 3;
    int ini = ibase_ - searchRange, fin = ibase_ + searchRange;
    if (ini < 0) ini = 0;
    if (fin > triangleNum) fin = triangleNum;
    
    for (int i_ = ini; i_ < fin; i_++){
	int i = pCIdxAndZ[i_].index;
	int vertexA = mVFaceIndexVertex[i*3];
	int vertexB = mVFaceIndexVertex[i*3+1];
	int vertexC = mVFaceIndexVertex[i*3+2];
	if (vertexB == vertex0 && vertexA == vertex1) return vertexC;
	if (vertexC == vertex0 && vertexB == vertex1) return vertexA;
	if (vertexA == vertex0 && vertexC == vertex1) return vertexB;
    }
    return -1;
}

void CLS::
ConstructAdjStructure(){
    
    mVFaceIndexVertexAdj.clear();

    //traiangle only ł邱Ƃ肷
    
    int size = mVFaceIndexVertex.size();
    int triangleNum = size / 3;

    ArrayAndIndex_cls *pCIdxAndZ = new ArrayAndIndex_cls [triangleNum];
    ArrayAndIndex_cls *pCIdxAndX = new ArrayAndIndex_cls [triangleNum];

    // 2ɉĒT΁AȂTvłsƉB
    // SɎɉĐƂƔj]̉\͂B
    
    for (int i = 0; i < triangleNum; i++){
	pCIdxAndZ[i].index = i;
	pCIdxAndX[i].index = i;

	// 
	float x0 = mVVertex[mVFaceIndexVertex[i*3]*3];
	float x1 = mVVertex[mVFaceIndexVertex[i*3+1]*3];
	float x2 = mVVertex[mVFaceIndexVertex[i*3+2]*3];
	float z0 = mVVertex[mVFaceIndexVertex[i*3]*3+2];
	float z1 = mVVertex[mVFaceIndexVertex[i*3+1]*3+2];
	float z2 = mVVertex[mVFaceIndexVertex[i*3+2]*3+2];

	pCIdxAndZ[i].z = (z0 + z1 + z2) + (x0 + x1 + x2) / 3;
	pCIdxAndX[i].z = (z0 + z1 + z2) - (x0 + x1 + x2) / 3;
    }
    
    std::sort(pCIdxAndZ, pCIdxAndZ+triangleNum);

    for (int i_ = 0; i_ < triangleNum; i_++){
	int i = pCIdxAndZ[i_].index;
	int vertexA = mVFaceIndexVertex[i*3];
	int vertexB = mVFaceIndexVertex[i*3+1];
	int vertexC = mVFaceIndexVertex[i*3+2];
	int vertexABdash = SearchAdjTriangleB(i_, pCIdxAndZ, vertexA, vertexB);
	int vertexBCdash = SearchAdjTriangleB(i_, pCIdxAndZ, vertexB, vertexC);
	int vertexCAdash = SearchAdjTriangleB(i_, pCIdxAndZ, vertexC, vertexA);
	if (vertexABdash == -1){
	    vertexABdash = SearchAdjTriangleB(i_, pCIdxAndX, vertexA, vertexB);
	    if (vertexABdash == -1) vertexABdash = vertexC;
	}
	if (vertexBCdash == -1){
	    vertexBCdash = SearchAdjTriangleB(i_, pCIdxAndX, vertexB, vertexC);
	    if (vertexBCdash == -1) vertexBCdash = vertexA;
	}
	if (vertexCAdash == -1){
	    vertexCAdash = SearchAdjTriangleB(i_, pCIdxAndX, vertexC, vertexA);
	    if (vertexCAdash == -1) vertexCAdash = vertexB;
	}
	mVFaceIndexVertexAdj.push_back(vertexA);
	mVFaceIndexVertexAdj.push_back(vertexABdash);
	mVFaceIndexVertexAdj.push_back(vertexB);
	mVFaceIndexVertexAdj.push_back(vertexBCdash);
	mVFaceIndexVertexAdj.push_back(vertexC);
	mVFaceIndexVertexAdj.push_back(vertexCAdash);
    }

    delete [] pCIdxAndZ;
    delete [] pCIdxAndX;
}

#define BUFFER_OFFSET(bytes) ((GLubyte *)NULL + (bytes))

void CLS::
GLDraw(bool bUseNormal, bool bUseUV, bool bUseMaterial,
       float alphaFactor, float shininess){

    /*
    if (bUseNornal == TRUE && bUseUV == TRUE){
	//GLDrawUseNormalUseTexture();
	return;
    }

    if (bUseNornal == TRUE && bUseUV == FALSE){
	//GLDrawUseNormal();
	return;
    }
    */

    if (mCVBO.mVBOVertex == 0) return;

    // 傫VBOĂꍇ
    int numVBO = mCVBO.mVVBOIndiceTriangle.size();
    int VBOIndex = 0, VBOIndexUsed = 0;
    
    mCVBO.PrepareClientState(bUseUV, 0, FALSE, VBOIndex);

    int matStockIndex = 0;
    int matFaceIndex = 0;
    int faceVertexIndex = 0; //[v̍ŏ ł _Index

    mCWFMaterial.mAlphaFactor = alphaFactor;
    mCWFMaterial.mShininess = shininess;
    while (TRUE){
	if (VBOIndexUsed != VBOIndex){
	    glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, mCVBO.mVVBOIndiceTriangle[VBOIndex]);
	    VBOIndexUsed = VBOIndex;
	}
	
	mCWFMaterial.GLSetMaterial
	    (mVMaterialStock[matStockIndex].mMatIndex, bUseMaterial);
	
	// ̃}eAŕ`悷鐔
	int num0 = mVMaterialStock[matStockIndex].mVertIndexNum;
	int numVBOMax = mCVBO.mVIndiceTriangle[VBOIndex];
	int num = num0 - matFaceIndex;

	if (faceVertexIndex + num > numVBOMax)
	    num = numVBOMax - faceVertexIndex;
	    
	if (num != 0)
	    glDrawElements(GL_TRIANGLES, num, GL_UNSIGNED_INT, BUFFER_OFFSET(faceVertexIndex * sizeof(unsigned int)));

	matFaceIndex += num;
	faceVertexIndex += num;
	if (matFaceIndex >= num0){
	    matStockIndex++;
	    matFaceIndex = 0;
	}

	if (faceVertexIndex >= numVBOMax){
	    VBOIndex++;
	    faceVertexIndex=0;
	    //int limit = GCClassProvider.GetPCPreference()->mCParamForDebugINT.GetBodyINT();
	    //if (VBOIndex > limit) break;
	}

	// ԈႦĂȂ΁Aɂ҂ɂȂ͂
	if (VBOIndex >= mCVBO.mVIndiceTriangle.size())
	    break;
	if (matStockIndex >= mCWFMaterial.mVCItems.size())
	    break;
    }
    
    mCVBO.FinishClientState();
}

void CLS::
SetVBO(bool bUseSV){

    int totalVertex = mVVertex.size();

    mCVBO.Clear();

    if (totalVertex == 0) return;

    mCVBO.GenBuffersVertex(1);

    mCVBO.mbUseNormal = TRUE;

    glBindBuffer(GL_ARRAY_BUFFER, mCVBO.mVBOVertex);
    glBufferData(GL_ARRAY_BUFFER, totalVertex * sizeof(float),
		 mVVertex.data(), GL_STATIC_DRAW);
    
    int totalNormal = mVNormal.size();
    glBindBuffer(GL_ARRAY_BUFFER, mCVBO.mVBONormal);
    glBufferData(GL_ARRAY_BUFFER, totalNormal * sizeof(float),
		 mVNormal.data(), GL_STATIC_DRAW);

    int totalUV2 = mVUV2.size();
    if (totalUV2 != 0){
	glBindBuffer(GL_ARRAY_BUFFER, mCVBO.mVBOUV[0]);
	glBufferData(GL_ARRAY_BUFFER, totalUV2 * sizeof(float), mVUV2.data(), GL_STATIC_DRAW);
    }
    
    //int totalIndices = mVFaceIndexVertexAdj.size() / 6;
    //pCTgt->mTotalIndiceTriangle = 0; // ʏ핔͎͕`Fêݎg
    mCVBO.mTotalIndiceTriangle = mVFaceIndexVertex.size();
    mCVBO.mTotalIndiceAdjacent = mVFaceIndexVertexAdj.size();

    mCVBO.GenBuffersIndice();
    mCVBO.MakeVBOIndicesTriangle(mVFaceIndexVertex.data());
    if (bUseSV == TRUE)
	mCVBO.MakeVBOIndicesAdjacent(mVFaceIndexVertexAdj.data());
    
    glBindBuffer(GL_ARRAY_BUFFER, 0);
    glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);
}
