// -*- c -*-
// "clsTree2D.cpp"
// (setq c-basic-offset 4)

#ifndef _TREE_2D_H
#define _TREE_2D_H

#include "../COMMON/clsVectorMath.h"

#include <vector>

class Tree2D_cls : public VectorMath_cls {
 public:
    Tree2D_cls(int depth, int depthMax);
    ~Tree2D_cls();

    void Clear();
    
    int mDepth;

    void SetRange(float minX, float maxX, float minY, float maxY);
    float mMinX, mMaxX;
    float mMinY, mMaxY;
    std::vector < unsigned int > mVItemIndex;
    int mItemNum;

    Tree2D_cls *mpCChild[4];
    
    Tree2D_cls* GetPCTree(float fX, float fY);
    bool IsVerticesFullyOutsideBox(float *posA, float *posB, float *posC);
    bool IsVertexInsideBox(float *posA);
    bool IsVerticesInsideBox(float *posA, float *posB, float *posC);
    bool IsVertexInsidePolygon
	(float *posTgt, float *posA, float *posB, float *posC,
	 float *vecBA, float *vecCB, float *vecAC);
    bool IsBoxInsidePolygon(float *posA, float *posB, float *posC);
    bool IsLineSegmentIntersect(float *posA0, float *posA1, 
				float *posB0, float *posB1);
    bool IsBoxAndVerticesIntersect(float *posA, float *posB, float *posC);
    void CheckTreeItem(std::vector < unsigned int > &mVItemParent,
		       std::vector < unsigned int > &VFaceIndexVertex,
		       std::vector < float > &VVertex, int depth);
};

#endif
