// "clsWavefrontMaterial.cpp"
// (c-basic-offset 4)

#ifndef _POV_WAVEFRONT_MTL_H_
#define _POV_WAVEFRONT_MTL_H_

#include "../COMMON/clsGetPC.h"
#include "../FILEIO/clsAsciiReader.h"
#include "../MYGL/clsGLTexture.h"
//#include "../clsPovSerialize.h"

#include <wx/wx.h>
#include <vector>

class WavefrontMaterialItem_cls : public AsciiReader_cls, public GetPC_cls {
 public:
    WavefrontMaterialItem_cls(wxString strName, wxString strDir, const char **ptr, char *bufferEnd, bool bUseEmit);
    wxString mstrName;

    float mDiffuse[4];
    float mAmbient[4];
    float mSpecular[4];
    float mAlphaFactor;
    float mShininess;
    float mTransmission[4];
    int  mIllumMode;
    float mIOR;

    wxString GetStrTexDiffuse();
    void GLSetMaterial(bool bUseMaterialColor);
    void GLOverwriteTexture(wxString strTexture);

    wxString mstrTexDiffuse;
    wxString mstrOverwriteTexture;
    GLTexture_cls mCTexture;

    //static void GetAlphaForMultiLayer2(float &alpha);
    void GetClrInfo(float clr0[3][4], float *clrOvwr);
};

class WavefrontMaterialCtrl_cls : public AsciiReader_cls {
 public:
    WavefrontMaterialCtrl_cls();
    
    std::vector < WavefrontMaterialItem_cls > mVCItems;
    
    bool mbUseEmitAsAmbient;
    float mAlphaFactor;
    float mShininess;
    
    void Clear();
    void ReadMtllib(wxString strDir, wxString strFile);
    void MakeMaterialIfEmpty();

    int GetIndexFromTag(wxString strTag);
    void GLSetMaterial(int index, bool bUseMaterialColor);
    void GLOverwriteTexture(wxString strTexture);
    void SetTexWrap(int texWrap);

    wxString mstrDirectory;
    wxString mstrOverwriteTexture;
};

#endif
