// (setq c-basic-offset 4)
// "clsInitializeParallel.h"

#include "clsInitializeParallel.h"

#include "../COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;

#include "../WIDGETCTRL/EX/clsFileDialogEX.h"
extern wxFileDialogEX *GpCFileDialog;

#include "../../clsMain.h"
#include "../../wxWidgetString.h"

#ifdef WIN32
#include <wx/msw/registry.h>
#endif

#include "../COMMON/CommonDefinitions.h"

InitializeParallel_cls::
InitializeParallel_cls() : wxThread(wxTHREAD_DETACHED) {
}

void InitializeParallel_cls::
SetParameters(bool *pbFinishedFlagLink, int *pInitializeTime){
    mpbFinishedFlagLink =  pbFinishedFlagLink;
    mpInitializeTime = pInitializeTime;

    if ( Create() != wxTHREAD_NO_ERROR) return;
    //MsgBoxExit(NULL, "Error!", "Can't create thread");
}

void InitializeParallel_cls::
InitializeParallel(){
    GCClassProvider.InitializeStaticMembers();
    GCClassProvider.CreateSingleton();
    Main_cls *pCMain = GCClassProvider.GetPCMain();
    pCMain->OpenRecentFile(pCMain->mstrExecuteDir + _WXDELIM_ + _RECENT_FILE);
#ifdef WIN32
    wxRegKey key(wxRegKey::HKCU, "Control Panel\\DeskTop");
    if (key.Exists() == TRUE &&
	key.HasValue(wxT("HungAppTimeout")) == TRUE){
	wxString keyvaluestr;
	if (key.QueryValue(wxT("HungAppTimeout"), keyvaluestr) == TRUE)
	    keyvaluestr.ToLong(&pCMain->mHungAppTimeoutMS);
    }
    else
	pCMain->mHungAppTimeoutMS = -1;
    
    wxRegKey key2(wxRegKey::HKLM, "SYSTEM\\CurrentControlSet\\Control\\GraphicsDrivers");
    if (key2.Exists() == TRUE &&
	key.HasValue(wxT("TdrDelay")) == TRUE){
	wxString keyvaluestr;
	if (key.QueryValue(wxT("TdrDelay"), keyvaluestr) == TRUE)
	    keyvaluestr.ToLong(&pCMain->mTdrDelay);
    }
    else
	pCMain->mTdrDelay = -1;
#endif
}

wxThread::ExitCode InitializeParallel_cls::
Entry(){
    wxStopWatch CStopWatch;
    CStopWatch.Start();
    
    InitializeParallel();
    *mpbFinishedFlagLink = TRUE;
    *mpInitializeTime = CStopWatch.Time();
    return 0;
}
