// (setq-c-offset 4)
// "clsArrayCopy.cpp"

#ifndef _ARRAY_COPY_H
#define _ARRAY_COPY_H

#include "clsModifierBase.h"

#include "../COMMON/clsTensorMath.h"

class ArrayCopyBuffer_cls;
class MultiInputPanel_cls;
class SceneObj_cls;
class SceneObjInstance_cls;

#include <vector>

class ArrayCopy_cls : public ModifierBase_cls, public TensorMath_cls {
 public:
    ArrayCopy_cls(wxString strName, wxString strObjName);

    ConfItemSTR_cls mCstrTarget;
    ConfItemUINT_cls mCCoord;

    void Execute(SceneObj_cls *pCObj, 
		 std::vector < SceneObjInstance_cls* > &VPCInstance,
		 int modifierDepth);

    void SyncFromBuffer(ArrayCopyBuffer_cls *pCBuffer, SceneObj_cls *pCObj);
};

class ArrayCopyBuffer_cls : public ModifierBase_cls {
 public:
    ArrayCopyBuffer_cls(ArrayCopy_cls *pCSrc);

    ArrayCopy_cls *mpCSrc;

    ConfItemSTR_cls mCstrTarget;
    ConfItemUINT_cls mCCoord;
    ConfItemINT_cls mCXMin, mCXMax;
    ConfItemINT_cls mCYMin, mCYMax;
    ConfItemINT_cls mCZMin, mCZMax;
    ConfItemFLOATARRAY_cls mCAxisX;
    ConfItemFLOATARRAY_cls mCAxisY;
    ConfItemFLOATARRAY_cls mCAxisZ;
    
    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);
    void SyncFromSrc();
    void ForceSrcToSyncBuffer(SceneObj_cls *pCObj);
};

#endif
