// (setq-c-offset 4)
// "clsVolumeBase.cpp"

#ifndef _BOOLEAN_BASE_H
#define _BOOLEAN_BASE_H

#include "clsModifierBase.h"

#include "../COMMON/clsTensorMath.h"

class BooleanBufferBase_cls;
class MultiInputPanel_cls;
class ViewerClone_cls;

#define _BOOL_INTERSECT 0
#define _BOOL_DIFFERECE 1
#define _BOOL_ADD       2

#define _BOOL_BOX       0
#define _BOOL_SPHERE    1
#define _BOOL_OBJECT    2

class BooleanBase_cls : public TensorMath_cls, public ModifierBase_cls {
public:
    BooleanBase_cls(wxString strClassName, wxString strName, wxString strObjName);
    ConfItemUINT_cls mCShapeType;
    ConfItemSTR_cls mCstrBoolObject;
    ConfItemUINT_cls mCBooleanType;

    void SyncFromBuffer(BooleanBufferBase_cls *pCBuffer, SceneObj_cls *pCObj);

    void SelectObject(wxString strObjName);
    wxString GetStrProcCounterParam(SceneObj_cls *pCObj, double NT);

    // TgtObj̑̓N[ł͂Ȃ̂
    // 쒆ɕύXNȉ\L
    static void GetMatrix16TgtInv
	(AttributeClone_cls *pCMod, double matrix16TgtInv[16], double NT);
    static wxString GetStrProcCounterForTgtObj(wxString strObj, double NT);

    static wxString GetStrProcCounterClone(ViewerClone_cls *pCViewerClone, AttributeClone_cls *pC, double NT);
};

class BooleanBufferBase_cls : public TensorMath_cls, public ModifierBase_cls {
public:
    BooleanBufferBase_cls(BooleanBase_cls *pCSrc);

    BooleanBase_cls *mpCSrc;

    int mIndexTgtObj;
    int mIndexRangeX, mIndexRangeY, mIndexRangeZ;
    int mIndexRadius;

    ConfItemUINT_cls mCShapeType;
    ConfItemSTR_cls mCstrBoolObject; 
    ConfItemUINT_cls mCBooleanType;
    ConfItemFLOAT_cls mCXMin, mCXMax;
    ConfItemFLOAT_cls mCYMin, mCYMax;
    ConfItemFLOAT_cls mCZMin, mCZMax;
    ConfItemFLOAT_cls mCRadius;

    MultiInputPanel_cls *mpCMNumPanelLink;
    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);
    void SyncFromSrc();
    void ForceSrcToSyncBuffer(SceneObj_cls *pCObj);

    bool HideAndShow();
};

#endif
