// (setq-c-offset 4)
// "clsModifyApparentSize.h"

#include "clsModifyApparentSize.h"

#include "../SCENEOBJ/clsSceneObj.h"
#include "../SCENEOBJ/DATAVIEWER/clsParticle.h"
#include "../SIMDATA/clsArrayAndIndex.h"
#include "../TIMELINE/clsTimeCtrl.h"
#include "../WIDGETCTRL/clsBitmapPanel.h"
#include "../WIDGETCTRL/MULTIINPUT/clsMultiInputPanel.h"

#define CLS ModifyApparentSize_cls

CLS::
ModifyApparentSize_cls(wxString strName, wxString strObjName) : ModifierBase_cls ("ModifyApparentSize_cls", strName){

    wxString strUpdate = "VIEW3D::PROPERTY_DATAPROC";

    SetConfListTagForSceneObjAttribute(strName, strObjName);
    mCConfList.Add(&mCbLimitApparentMin, "LimitApparentMin=", "1", strUpdate);
    mCConfList.Add(&mCbModifyAlphaMin, "ModifyAlphaMin=", "1", strUpdate);
    mCConfList.Add(&mCPowerAlphaMin, "PowerAlphaMin=", "2", strUpdate);

    mCConfList.Add(&mCbLimitApparentMax, "LimitApparentMax=", "0", strUpdate);
    mCConfList.Add(&mCbModifyAlphaMax, "ModifyAlphaMax=", "0", strUpdate);
    mCConfList.Add(&mCPowerAlphaMax, "PowerAlphaMax=", "3", strUpdate);

    mCConfList.Add(&mCTargetType, "TargetType=", "0", strUpdate);
    //mCConfList.Add(&mCMaxApparent, "MaxApparent=", "1", strUpdate);
    //ParamGroup_cls *pCParam = GetPCNewParamGroup("Parameters", "Near", "Far", "Max");
    //InitializeAndPushParam(pCParam, 1, 10, 2);

    ParamGroup_cls *pCParam = GetPCNewParamGroup("Parameters", "Min", "Max");
    InitializeAndPushParam(pCParam, 0.001, 0.01);
}

void CLS::
SyncFromBuffer(ModifyApparentSizeBuffer_cls *pCBuffer, SceneObj_cls *pCObj){

    mCConfList.SyncFromCommand(pCBuffer->mCConfList);

    std::vector < float > VParam;
    //VParam.push_back(pCBuffer->mCNearDistance.GetBodyDOUBLE());
    //VParam.push_back(pCBuffer->mCFarDistance.GetBodyDOUBLE());
    //VParam.push_back(pCBuffer->mCMaxBlur.GetBodyDOUBLE());
    VParam.push_back(pCBuffer->mCMinApparent.GetBodyDOUBLE());
    VParam.push_back(pCBuffer->mCMaxApparent.GetBodyDOUBLE());
    SyncronizeParamForModifier("Parameters", VParam, pCObj);
}

wxString CLS::
GetStrProcCounterClone(AttributeClone_cls *pC, double NT){
    wxString strCounter;
    if (pC->GetPCItem("Validity=")->GetBodyBOOL() == FALSE)
	return strCounter;
    
    strCounter << pC->GetPCParamGroup("Parameters")->GetStrValues(NT);
    strCounter << pC->GetPCItem("LimitApparentMin=")->GetBodyBOOL();
    strCounter << pC->GetPCItem("ModifyAlphaMin=")->GetBodyBOOL();
    strCounter << pC->GetPCItem("PowerAlphaMin=")->GetBodyINT();
    strCounter << pC->GetPCItem("TargetType=")->GetBodyINT();
    //strCounter << pC->GetPCItem("MaxApparent=")->GetBodyDOUBLE();
    strCounter << pC->GetPCItem("LimitApparentMax=")->GetBodyBOOL();
    strCounter << pC->GetPCItem("ModifyAlphaMax=")->GetBodyBOOL();
    strCounter << pC->GetPCItem("PowerAlphaMax=")->GetBodyINT();
    return strCounter;
}

#define CLS ModifyApparentSizeBuffer_cls

CLS::
ModifyApparentSizeBuffer_cls(ModifyApparentSize_cls *pCSrc) : ModifierBase_cls(*pCSrc){
    mpCSrc = pCSrc;
    mCConfList.SetTag(pCSrc->mCConfList.mstrTag);
    mCConfList.Add(&mCbLimitApparentMin, "LimitApparentMin=", "0");
    mCConfList.Add(&mCbModifyAlphaMin, "ModifyAlphaMin=", "0");
    mCConfList.Add(&mCPowerAlphaMin, "PowerAlphaMin=", "2");
    mCConfList.Add(&mCTargetType, "TargetType=", "0");
    //mCConfList.Add(&mCMaxApparent, "MaxApparent=", "1");
    mCConfList.Add(&mCbLimitApparentMax, "LimitApparentMax=", "0");
    mCConfList.Add(&mCbModifyAlphaMax, "ModifyAlphaMax=", "0");
    mCConfList.Add(&mCPowerAlphaMax, "PowerAlphaMax=", "3");

    mCConfList.Add(&mCMinApparent, "MinApparent=", "0.001");
    mCConfList.Add(&mCMaxApparent, "MaxApparent=", "0.01");

    //mCConfList.Add(&mCNearDistance, "NearDistance=", "1");
    //mCConfList.Add(&mCFarDistance, "FarDistance=", "10");
    //mCConfList.Add(&mCMaxBlur, "MaxBlur=", "2");
    
}

MultiInputPanel_cls* CLS::
GetPCNewPanel(wxWindow *pCWindow){
    MultiInputPanel_cls *pC =
	new MultiInputPanel_cls(pCWindow, GetStrName(), TRUE);

    /*
    pC->CombineSizer(2, _("Near/Far"));
    pC->CombineConfItem(mCNearDistance);
    pC->CombineConfItem(mCFarDistance);

    pC->CombineSizer(2, _("Max Blur"));
    pC->CombineConfItem(mCMaxBlur);
    */

    pC->CombineSizer(2, _("Target Type"));
    wxString strTarget[5] = {_("All"), "type 0", "type 1", "type 2","type 3" };
    pC->SetChoiceList(5, strTarget);
    pC->CombineConfItem(mCTargetType);

    mIndexWarning = pC->CombineBitmapPanel(wxID_ANY, wxES, 24);

    pC->CombineSizer(2);
    pC->CombineConfItem(mCbLimitApparentMin, _("Limit Apparent Size Min"));
    pC->CombineConfItem(mCbModifyAlphaMin, _("Modify Alpha"));
    
    pC->CombineSizer(2, _("Min Apparent"));
    pC->SetLimit(0, 1);
    pC->mDragScale = 0.01;
    pC->CombineConfItem(mCMinApparent);

    wxString strPower[4] = {"power 0.5", "power 1", "power 1.5", "power 2"};
    pC->SetChoiceList(4, strPower);
    pC->CombineConfItem(mCPowerAlphaMin);

    pC->CombineSizer(2);
    pC->CombineConfItem(mCbLimitApparentMax, _("Limit Apparent Size Max"));
    pC->CombineConfItem(mCbModifyAlphaMax, _("Modify Alpha"));
    
    pC->CombineSizer(2, _("Max Apparent"));
    pC->SetLimit(0, 1);
    pC->mDragScale = 0.01;
    pC->CombineConfItem(mCMaxApparent);
    
    pC->SetChoiceList(4, strPower);
    pC->CombineConfItem(mCPowerAlphaMax);
    
    pC->FinishSetting();

    BitmapPanel_cls *pCBitmap = (BitmapPanel_cls*)pC->mVCItem[mIndexWarning].mpCWindowLink;
    pCBitmap->AddBitmapStr("wxART_WARNING");
    pCBitmap->mBorderX = 4;
    pCBitmap->mBorderY = 4;
    pCBitmap->SetToolTip(_("Warning: Modification is performed during sorting process, but sorting is set to be ignored. See object property panel."));

    mpCMNumPanelLink = pC;
    return pC;
}

void CLS::
SyncFromSrc(){
    mCConfList.SyncFrom(mpCSrc->mCConfList);
    double time = GetPCTimeCtrl()->GetCurrentNT();
    std::vector < float > VParam = mpCSrc->GetPCParamGroup("Parameters")->GetVInterpolatedValue((float)time, FALSE);

    mCMinApparent.SetBodyFromData(VParam[0]);
    mCMaxApparent.SetBodyFromData(VParam[1]);

    //mCNearDistance.SetBodyFromData(VParam[0]);
    //mCFarDistance.SetBodyFromData(VParam[1]);
    //mCMaxBlur.SetBodyFromData(VParam[2]);
}

void CLS::
ForceSrcToSyncBuffer(SceneObj_cls *pCObj){
    mpCSrc->SyncFromBuffer(this, pCObj);
}

bool CLS::
HideAndShow(Particle_cls *pCObj){
    bool bChange = FALSE;
    
    if (pCObj->mCSortType.GetBodyINT() == _SORT_NONE)
	bChange |= mpCMNumPanelLink->mVCItem[mIndexWarning].Show(TRUE);
    else
	bChange |= mpCMNumPanelLink->mVCItem[mIndexWarning].Show(FALSE);

    return bChange;
}

#define CLS ThreadModifyApparentSize_cls

void CLS::
SetParameters(float *pFilterAlpha, float *pSize, float *pSizeMod,
	      unsigned char *pType,
	      ArrayAndIndex_cls *pIndexAndZ, int sortType, int type,
	      float minApparent, int powerAlphaMin,
	      bool bLimitApparentMin, bool bModifyAlphaMin,
	      float maxApparent, int powerAlphaMax,
	      bool bLimitApparentMax, bool bModifyAlphaMax){
    
    mpFilterAlpha = pFilterAlpha;
    mpSize = pSize;
    mpSizeMod = pSizeMod;
    mpType = pType;
    mpIndexAndZ = pIndexAndZ;
    mSortType = sortType;
    mType = type;
    
    mMinApparent = minApparent;
    mPowerAlphaMin = powerAlphaMin;
    mbLimitApparentMin = bLimitApparentMin;
    mbModifyAlphaMin = bModifyAlphaMin;

    mMaxApparent = maxApparent;
    mPowerAlphaMax = powerAlphaMax;
    mbLimitApparentMax = bLimitApparentMax;
    mbModifyAlphaMax = bModifyAlphaMax;
}

/*
float CLS::
GetRange(){
    float range = mFarDistance - mNearDistance;
    if (range == 0) range = 1;
    return range;
}
*/

wxThread::ExitCode CLS::
Entry(){
    DummyEntry();
    return 0;
}

void CLS::
DummyEntry(){
    DummyEntryMain();
    *mpbFinishedFlagLink = TRUE;
}

void CLS::
DummyEntryMain(){
    const int PIni = mPIni, PFin = mPFin;
    float * const pFilterAlpha = mpFilterAlpha;
    const float * const pSize = mpSize;
    float * const pSizeMod = mpSizeMod;
    const unsigned char * const pType = mpType;
    const ArrayAndIndex_cls * const pIndexAndZ = mpIndexAndZ;
    
    const int sortType = mSortType;
    const int type = mType;
    //const float range = GetRange();

    if (mbLimitApparentMin == TRUE) ProcessMin();
    if (mbLimitApparentMax == TRUE) ProcessMax();

    
}

void CLS::
ProcessMin(){
    
    const int PIni = mPIni, PFin = mPFin;
    float * const pFilterAlpha = mpFilterAlpha;
    const float * const pSize = mpSize;
    float * const pSizeMod = mpSizeMod;
    const unsigned char * const pType = mpType;
    const ArrayAndIndex_cls * const pIndexAndZ = mpIndexAndZ;
    
    const int sortType = mSortType;
    const int type = mType;

    const float minApparent = mMinApparent;
    
    if (mbModifyAlphaMin == FALSE){
	if (sortType == _SORT_DISTANCE || sortType == _SORT_Z ||
	    sortType == _SORT_DISTANCE_ONLY)
	    for (int i = PIni; i < PFin; i++){
		if (type != -1 && pType[i] != type) continue;
		if (pFilterAlpha[i] == 0) continue;
		float distance = - pIndexAndZ[i].mZ ;
		if (distance == 0) continue;
		
		float appearent = pSize[i] * pSizeMod[i] / distance;
	    
		float sizeMod = minApparent / appearent;
		if (sizeMod < 1) continue;
		
		pSizeMod[i] *= sizeMod;
	    }
	if (sortType == _SORT_DISTANCE_INV || sortType == _SORT_Z_INV)
	    for (int i = PIni; i < PFin; i++){
		if (type != -1 && pType[i] != type) continue;
		if (pFilterAlpha[i] == 0) continue;
		float distance = pIndexAndZ[i].mZ ;
		if (distance == 0) continue;
		
		float appearent = pSize[i] * pSizeMod[i] / distance;
	    
		float sizeMod = minApparent / appearent;
		if (sizeMod < 1) continue;
		
		pSizeMod[i] *= sizeMod;
	    }
	return; 
    }
    
    if (mPowerAlphaMin == 0){ // pow 0.5
	if (sortType == _SORT_DISTANCE || sortType == _SORT_Z ||
	    sortType == _SORT_DISTANCE_ONLY)
	    for (int i = PIni; i < PFin; i++){
		if (type != -1 && pType[i] != type) continue;
		if (pFilterAlpha[i] == 0) continue;
		float distance = - pIndexAndZ[i].mZ ;
		if (distance == 0) continue;
		
		float appearent = pSize[i] * pSizeMod[i] / distance;
		
		float sizeMod = minApparent / appearent;
		if (sizeMod < 1) continue;
		
		pSizeMod[i] *= sizeMod;
		pFilterAlpha[i] = 1.0 / sqrt(sizeMod);
	    }
	if (sortType == _SORT_DISTANCE_INV || _SORT_Z_INV)
	    for (int i = PIni; i < PFin; i++){
		if (type != -1 && pType[i] != type) continue;
		if (pFilterAlpha[i] == 0) continue;
		float distance = pIndexAndZ[i].mZ ;
		if (distance == 0) continue;
		
		float appearent = pSize[i] * pSizeMod[i] / distance;
		
		float sizeMod = minApparent / appearent;
		if (sizeMod < 1) continue;
		
		pSizeMod[i] *= sizeMod;
		pFilterAlpha[i] = 1.0 / sqrt(sizeMod);
	    }
    }

    if (mPowerAlphaMin == 1){ // pow 1
	if (sortType == _SORT_DISTANCE || sortType == _SORT_Z || 
	    sortType == _SORT_DISTANCE_ONLY)
	    for (int i = PIni; i < PFin; i++){
		if (type != -1 && pType[i] != type) continue;
		if (pFilterAlpha[i] == 0) continue;
		float distance = - pIndexAndZ[i].mZ ;
		if (distance == 0) continue;
		
		float appearent = pSize[i] * pSizeMod[i] / distance;
		
		float sizeMod = minApparent / appearent;
		if (sizeMod < 1) continue;
		
		pSizeMod[i] *= sizeMod;
		pFilterAlpha[i] = 1.0 / sizeMod;
	    }
	if (sortType == _SORT_DISTANCE_INV || sortType == _SORT_Z_INV)
	    for (int i = PIni; i < PFin; i++){
		if (type != -1 && pType[i] != type) continue;
		if (pFilterAlpha[i] == 0) continue;
		float distance = pIndexAndZ[i].mZ ;
		if (distance == 0) continue;
		
		float appearent = pSize[i] * pSizeMod[i] / distance;
		
		float sizeMod = minApparent / appearent;
		if (sizeMod < 1) continue;
		
		pSizeMod[i] *= sizeMod;
		pFilterAlpha[i] = 1.0 / sizeMod;
	    }
    }

    if (mPowerAlphaMin == 2){ // pow 1.5
	if (sortType == _SORT_DISTANCE || sortType == _SORT_Z ||
	    sortType == _SORT_DISTANCE_ONLY)
	    for (int i = PIni; i < PFin; i++){
		if (type != -1 && pType[i] != type) continue;
		if (pFilterAlpha[i] == 0) continue;
		float distance = - pIndexAndZ[i].mZ ;
		if (distance == 0) continue;
		
		float appearent = pSize[i] * pSizeMod[i] / distance;
		
		float sizeMod = minApparent / appearent;
		if (sizeMod < 1) continue;
		
		pSizeMod[i] *= sizeMod;
		pFilterAlpha[i] = 1.0 / sizeMod / sqrt(sizeMod);
	    }
	if (sortType == _SORT_DISTANCE_INV || sortType == _SORT_Z_INV)
	    for (int i = PIni; i < PFin; i++){
		if (type != -1 && pType[i] != type) continue;
		if (pFilterAlpha[i] == 0) continue;
		float distance = pIndexAndZ[i].mZ ;
		if (distance == 0) continue;
		
		float appearent = pSize[i] * pSizeMod[i] / distance;
		
		float sizeMod = minApparent / appearent;
		if (sizeMod < 1) continue;
		
		pSizeMod[i] *= sizeMod;
		pFilterAlpha[i] = 1.0 / sizeMod / sqrt(sizeMod);
	    }
    }

    if (mPowerAlphaMin == 3){ // pow 2
	if (sortType == _SORT_DISTANCE || sortType == _SORT_Z ||
	    sortType == _SORT_DISTANCE_ONLY)
	    for (int i = PIni; i < PFin; i++){
		if (type != -1 && pType[i] != type) continue;
		if (pFilterAlpha[i] == 0) continue;
		float distance = - pIndexAndZ[i].mZ ;
		if (distance == 0) continue;
		
		float appearent = pSize[i] * pSizeMod[i] / distance;
		
		float sizeMod = minApparent / appearent;
		if (sizeMod < 1) continue;
		
		pSizeMod[i] *= sizeMod;
		pFilterAlpha[i] = 1.0 / sizeMod / sizeMod;
	    }
	if (sortType == _SORT_DISTANCE_INV || sortType == _SORT_Z_INV)
	    for (int i = PIni; i < PFin; i++){
		if (type != -1 && pType[i] != type) continue;
		if (pFilterAlpha[i] == 0) continue;
		float distance = pIndexAndZ[i].mZ ;
		if (distance == 0) continue;
		
		float appearent = pSize[i] * pSizeMod[i] / distance;
		
		float sizeMod = minApparent / appearent;
		if (sizeMod < 1) continue;
		
		pSizeMod[i] *= sizeMod;
		pFilterAlpha[i] = 1.0 / sizeMod / sizeMod;
	    }
    }
    
}

void CLS::
ProcessMax(){
    
    const int PIni = mPIni, PFin = mPFin;
    float * const pFilterAlpha = mpFilterAlpha;
    const float * const pSize = mpSize;
    float * const pSizeMod = mpSizeMod;
    const unsigned char * const pType = mpType;
    const ArrayAndIndex_cls * const pIndexAndZ = mpIndexAndZ;
    
    const int sortType = mSortType;
    const int type = mType;

    const float maxApparent = mMaxApparent;
    
    if (mbModifyAlphaMax == FALSE){
	if (sortType == _SORT_DISTANCE || sortType == _SORT_Z ||
	    sortType == _SORT_DISTANCE_ONLY)
	    for (int i = PIni; i < PFin; i++){
		if (type != -1 && pType[i] != type) continue;
		if (pFilterAlpha[i] == 0) continue;
		float distance = - pIndexAndZ[i].mZ ;
		if (distance == 0) continue;
		
		float appearent = pSize[i] * pSizeMod[i] / distance;
		
		float sizeMod = maxApparent / appearent;
		if (sizeMod > 1) continue;
		
		pSizeMod[i] *= sizeMod;
	    }
	if (sortType == _SORT_DISTANCE_INV || sortType == _SORT_Z_INV)
	    for (int i = PIni; i < PFin; i++){
		if (type != -1 && pType[i] != type) continue;
		if (pFilterAlpha[i] == 0) continue;
		float distance = pIndexAndZ[i].mZ ;
		if (distance == 0) continue;
		
		float appearent = pSize[i] * pSizeMod[i] / distance;
		
		float sizeMod = maxApparent / appearent;
		if (sizeMod > 1) continue;
		
		pSizeMod[i] *= sizeMod;
	    }
	return; 
    }
    
    if (mPowerAlphaMax == 0){ // pow 0.5
	if (sortType == _SORT_DISTANCE || sortType == _SORT_Z ||
	    sortType == _SORT_DISTANCE_ONLY)
	    for (int i = PIni; i < PFin; i++){
		if (type != -1 && pType[i] != type) continue;
		if (pFilterAlpha[i] == 0) continue;
		float distance = - pIndexAndZ[i].mZ ;
		if (distance == 0) continue;
		
		float appearent = pSize[i] * pSizeMod[i] / distance;
		
		float sizeMod = maxApparent / appearent;
		if (sizeMod > 1) continue;
		
		pSizeMod[i] *= sizeMod;
		pFilterAlpha[i] = 1.0 / sqrt(sizeMod);
	    }
	if (sortType == _SORT_DISTANCE_INV || sortType == _SORT_Z_INV)
	    for (int i = PIni; i < PFin; i++){
		if (type != -1 && pType[i] != type) continue;
		if (pFilterAlpha[i] == 0) continue;
		float distance = pIndexAndZ[i].mZ ;
		if (distance == 0) continue;
		
		float appearent = pSize[i] * pSizeMod[i] / distance;
		
		float sizeMod = maxApparent / appearent;
		if (sizeMod > 1) continue;
		
		pSizeMod[i] *= sizeMod;
		pFilterAlpha[i] = 1.0 / sqrt(sizeMod);
	    }
    }

    if (mPowerAlphaMax == 1){ // pow 1
	if (sortType == _SORT_DISTANCE || sortType == _SORT_Z ||
	    sortType == _SORT_DISTANCE_ONLY)
	    for (int i = PIni; i < PFin; i++){
		if (type != -1 && pType[i] != type) continue;
		if (pFilterAlpha[i] == 0) continue;
		float distance = - pIndexAndZ[i].mZ ;
		if (distance == 0) continue;
		
		float appearent = pSize[i] * pSizeMod[i] / distance;
		
		float sizeMod = maxApparent / appearent;
		if (sizeMod > 1) continue;
		
		pSizeMod[i] *= sizeMod;
		pFilterAlpha[i] = 1.0 / sizeMod;
	    }
	if (sortType == _SORT_DISTANCE_INV || sortType == _SORT_Z_INV)
	    for (int i = PIni; i < PFin; i++){
		if (type != -1 && pType[i] != type) continue;
		if (pFilterAlpha[i] == 0) continue;
		float distance = pIndexAndZ[i].mZ ;
		if (distance == 0) continue;
		
		float appearent = pSize[i] * pSizeMod[i] / distance;
		
		float sizeMod = maxApparent / appearent;
		if (sizeMod > 1) continue;
		
		pSizeMod[i] *= sizeMod;
		pFilterAlpha[i] = 1.0 / sizeMod;
	    }
    }

    if (mPowerAlphaMax == 2){ // pow 1.5
	if (sortType == _SORT_DISTANCE || sortType == _SORT_Z ||
	    sortType == _SORT_DISTANCE_ONLY)
	    for (int i = PIni; i < PFin; i++){
		if (type != -1 && pType[i] != type) continue;
		if (pFilterAlpha[i] == 0) continue;
		float distance = - pIndexAndZ[i].mZ ;
		if (distance == 0) continue;
		
		float appearent = pSize[i] * pSizeMod[i] / distance;
		
		float sizeMod = maxApparent / appearent;
		if (sizeMod > 1) continue;
		
		pSizeMod[i] *= sizeMod;
		pFilterAlpha[i] = 1.0 / sizeMod / sqrt(sizeMod);
	    }
	if (sortType == _SORT_DISTANCE_INV || sortType == _SORT_Z_INV)
	    for (int i = PIni; i < PFin; i++){
		if (type != -1 && pType[i] != type) continue;
		if (pFilterAlpha[i] == 0) continue;
		float distance = pIndexAndZ[i].mZ ;
		if (distance == 0) continue;
		
		float appearent = pSize[i] * pSizeMod[i] / distance;
		
		float sizeMod = maxApparent / appearent;
		if (sizeMod > 1) continue;
		
		pSizeMod[i] *= sizeMod;
		pFilterAlpha[i] = 1.0 / sizeMod / sqrt(sizeMod);
	    }
    }

    if (mPowerAlphaMax == 3){ // pow 2
	if (sortType == _SORT_DISTANCE || sortType == _SORT_Z || 
	    sortType == _SORT_DISTANCE_ONLY)
	    for (int i = PIni; i < PFin; i++){
		if (type != -1 && pType[i] != type) continue;
		if (pFilterAlpha[i] == 0) continue;
		float distance = - pIndexAndZ[i].mZ ;
		if (distance == 0) continue;
		
		float appearent = pSize[i] * pSizeMod[i] / distance;
		
		float sizeMod = maxApparent / appearent;
		if (sizeMod > 1) continue;
		
		pSizeMod[i] *= sizeMod;
		pFilterAlpha[i] = 1.0 / sizeMod / sizeMod;
	    }
	if (sortType == _SORT_DISTANCE_INV || sortType == _SORT_Z_INV)
	    for (int i = PIni; i < PFin; i++){
		if (type != -1 && pType[i] != type) continue;
		if (pFilterAlpha[i] == 0) continue;
		float distance = pIndexAndZ[i].mZ ;
		if (distance == 0) continue;
		
		float appearent = pSize[i] * pSizeMod[i] / distance;
		
		float sizeMod = maxApparent / appearent;
		if (sizeMod > 1) continue;
		
		pSizeMod[i] *= sizeMod;
		pFilterAlpha[i] = 1.0 / sizeMod / sizeMod;
	    }
    }
    
}

#define CLS ModifyApparentSizeExec_cls

CLS::
ModifyApparentSizeExec_cls(AttributeClone_cls* pCSrc, double NT){
    mbValid = pCSrc->GetPCItem("Validity=")->GetBodyBOOL();
    //mNearDistance = pCSrc->GetPCParamGroup("Parameters")->GetVInterpolatedValue(NT)[0];
    //mFarDistance = pCSrc->GetPCParamGroup("Parameters")->GetVInterpolatedValue(NT)[1];
    //mMaxBlur = pCSrc->GetPCParamGroup("Parameters")->GetVInterpolatedValue(NT)[2];
    //mPower = pCSrc->GetPCItem("Power=")->GetBodyINT();
    mType = pCSrc->GetPCItem("TargetType=")->GetBodyINT() - 1; 

    mMinApparent = pCSrc->GetPCParamGroup("Parameters")->GetVInterpolatedValue(NT)[0];
    mMaxApparent = pCSrc->GetPCParamGroup("Parameters")->GetVInterpolatedValue(NT)[1];
    
    mbLimitApparentMin = pCSrc->GetPCItem("LimitApparentMin=")->GetBodyBOOL();
    mbModifyAlphaMin = pCSrc->GetPCItem("ModifyAlphaMin=")->GetBodyBOOL();
    mPowerAlphaMin = pCSrc->GetPCItem("PowerAlphaMin=")->GetBodyINT();
    mPowerAlphaMax = pCSrc->GetPCItem("PowerAlphaMax=")->GetBodyINT();
    //mMaxApparent = pCSrc->GetPCItem("MaxApparent=")->GetBodyDOUBLE();
    mbLimitApparentMax = pCSrc->GetPCItem("LimitApparentMax=")->GetBodyBOOL();
    mbModifyAlphaMax = pCSrc->GetPCItem("ModifyAlphaMax=")->GetBodyBOOL();
}

void CLS::
Execute(float *pFilterAlpha, float *pSize, float *pSizeMod, 
	unsigned char *pType, 
	ArrayAndIndex_cls *pIndexAndZ, int sortType,
	long long numParticle, bool bNext){
    if (mbValid == FALSE) return;

    int threadNumber;
    bool *bAFinished = GetNewPCbFinishList(threadNumber, numParticle, bNext);

    ThreadModifyApparentSize_cls **ppCThread = 
	new ThreadModifyApparentSize_cls* [threadNumber];

    for (int core = 0; core < threadNumber; core++){
	ppCThread[core] = 
	    new ThreadModifyApparentSize_cls;

	int PIni, PFin;
	GetIniAndFin(PIni, PFin, core, threadNumber, numParticle);

	ppCThread[core]->SetParameters(pFilterAlpha, pSize, pSizeMod,
				       pType, pIndexAndZ, sortType, mType, 
				       //mNearDistance, mFarDistance, mMaxBlur,
				       mMinApparent, mPowerAlphaMin, 
				       mbLimitApparentMin, mbModifyAlphaMin,
				       mMaxApparent, mPowerAlphaMax,
				       mbLimitApparentMax, mbModifyAlphaMax);

	ppCThread[core]->CreateThread(&bAFinished[core], PIni, PFin);
	if (threadNumber == 1){
	    ppCThread[core]->DummyEntry();
	    delete ppCThread[core];
	}
	else
	    ppCThread[core]->Run();
    }

    WaitThreadsAndDeleteFlag(bAFinished, threadNumber, 1);
    delete [] ppCThread;
    
}
