// (setq-c-offset 4)
// "clsModifyApparentSize.cpp"

#ifndef _MODIFY_APPARENT_SIZE_H
#define _MODIFY_APPARENT_SIZE_H

#include "clsModifierBase.h"

#include "../COMMON/clsThreadCommon.h"

class ArrayAndIndex_cls;
class ModifyApparentSizeBuffer_cls;
class MultiInputPanel_cls;
class Particle_cls;

class ModifyApparentSize_cls : public ModifierBase_cls {
public:
    ModifyApparentSize_cls(wxString strName, wxString strObjName);

    ConfItemUINT_cls  mCPowerAlphaMax, mCPowerAlphaMin;
    ConfItemUINT_cls  mCTargetType;
    //ConfItemFLOAT_cls mCMaxApparent;
    ConfItemBOOL_cls  mCbLimitApparentMax, mCbLimitApparentMin;
    ConfItemBOOL_cls  mCbModifyAlphaMax, mCbModifyAlphaMin;
    //ConfItemUINT_cls  mCPowerAlpha;

    void SyncFromBuffer(ModifyApparentSizeBuffer_cls *pCBuffer, SceneObj_cls *pCObj);

    static wxString GetStrProcCounterClone(AttributeClone_cls *pC, double NT);
};

class ModifyApparentSizeBuffer_cls : public ModifierBase_cls {
public:
    ModifyApparentSizeBuffer_cls(ModifyApparentSize_cls *pCSrc);

    ModifyApparentSize_cls *mpCSrc;
    
    ConfItemUINT_cls  mCPowerAlphaMax, mCPowerAlphaMin;
    ConfItemUINT_cls  mCTargetType;
    //ConfItemFLOAT_cls mCMaxApparent;
    ConfItemBOOL_cls  mCbLimitApparentMax, mCbLimitApparentMin;
    ConfItemBOOL_cls  mCbModifyAlphaMax, mCbModifyAlphaMin;
    //ConfItemUINT_cls  mCPowerAlpha;

    //ConfItemFLOAT_cls mCNearDistance;
    //ConfItemFLOAT_cls mCFarDistance;
    //ConfItemFLOAT_cls mCMaxBlur;

    ConfItemFLOAT_cls mCMinApparent, mCMaxApparent;

    int mIndexWarning;
    
    MultiInputPanel_cls *mpCMNumPanelLink;
    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);
    void SyncFromSrc();
    void ForceSrcToSyncBuffer(SceneObj_cls *pCObj);

    bool HideAndShow(Particle_cls* pCObj);
};

class ThreadModifyApparentSize_cls : public ThreadInstance_cls {
 public:
    void SetParameters
	(float *pFilterAlpha, float *pSize, float *pSizeMod,
	 unsigned char *pType,
	 ArrayAndIndex_cls *pIndexAndZ, int sortType, int type,
	 float minApparent, int powerAlphaMin,
	 bool bLimitApparentMin, bool bModifyAlphaMin,
	 float maxApparent, int powerAlphaMax,
	 bool bLimitApparentMax, bool bModifyAlphaMax);
	 

    float *mpFilterAlpha, *mpSize, *mpSizeMod;
    unsigned char *mpType;
    ArrayAndIndex_cls *mpIndexAndZ;
    int mSortType;

    //float mNearDistance, mFarDistance;
    //float mMaxBlur;
    float mMinApparent, mMaxApparent;

    int mPowerAlphaMin, mPowerAlphaMax;
    int mType;
    bool mbLimitApparentMin, mbModifyAlphaMin;
    bool mbLimitApparentMax, mbModifyAlphaMax;
    
    //float GetRange();
    virtual ExitCode Entry();
    void DummyEntry();
    void DummyEntryMain();
    void ProcessMin();
    void ProcessMax();
};

class ModifyApparentSizeExec_cls : public ThreadCommon_cls {
public:
    ModifyApparentSizeExec_cls(AttributeClone_cls* pCSrc, double NT);

    void Execute(float *pFilterAlpha, float *pSize, 
		 float *pSizeMod, unsigned char *pType, 
		 ArrayAndIndex_cls *pIndexAndZ, int sortType,
		 long long numParticle, bool bNext);
    
    bool mbValid;
    float mNearDistance, mFarDistance;
    float mMaxBlur;
    int mPower, mPowerAlpha;
    int mType;
    float mMinApparent, mMaxApparent;
    int mPowerAlphaMax, mPowerAlphaMin;
    bool mbLimitApparentMax, mbModifyAlphaMax;
    bool mbLimitApparentMin, mbModifyAlphaMin;

};

#endif
