// (setq-c-offset 4)
// "clsBlurDistantParticle.cpp"

#ifndef _MODIFY_PARTICLE_SIZE_H
#define _MODIFY_PARTICLE_SIZE_H

#include "clsModifierBase.h"

#include "../COMMON/clsThreadCommon.h"

class ArrayAndIndex_cls;
class ModifyParticleSizeBuffer_cls;
class MultiInputPanel_cls;
class ParticleSnap_cls;
class ParticleForRender_cls;
class ViewerClone_cls;

class ModifyParticleSize_cls : public ModifierBase_cls {
 public:
    ModifyParticleSize_cls(wxString strName, wxString strObjName);

    ConfItemUINT_cls mCTargetType;
    ConfItemUINT_cls mCTargetAttrib;
    ConfItemUINT_cls mCDependType;
    ConfItemINT_cls mCColorCurveIndex;
    ConfItemUINT_cls mCChannelType;

    void SyncFromBuffer(ModifyParticleSizeBuffer_cls *pCBuffer, SceneObj_cls *pCObj);
};

class ModifyParticleSizeBuffer_cls : public ModifierBase_cls {
 public:
    ModifyParticleSizeBuffer_cls(ModifyParticleSize_cls *pCSrc);

    ModifyParticleSize_cls *mpCSrc;

    ConfItemUINT_cls mCTargetType;
    ConfItemUINT_cls mCTargetAttrib;
    ConfItemUINT_cls mCDependType;
    ConfItemINT_cls mCColorCurveIndex;
    ConfItemUINT_cls mCChannelType;

    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);
    void SyncFromSrc();
    void ForceSrcToSyncBuffer(SceneObj_cls *pCObj);
    
    
};

class ThreadModifyParticleSize_cls : public ThreadInstance_cls {
public:
    void SetParameters
	(int dependType, 
	 int *pID, long long *pID1LongLong, float (*pX)[3], float *pValue, 
	 float *pFilterAlpha, float *pSizeMod, unsigned char *pType,
	 double factor, int type, int attrib,
	 float *pTable,
	 std::vector < double > VRange);
    
    int   *mpID;
    long long *mpIDLongLong;
    float *mpValue;
    float (*mpX)[3];
    float *mpFilterAlpha, *mpSizeMod;
    unsigned char *mpType;
    double mFactor;
    std::vector < double > mVRange;
    float *mpTable;
    int mType, mAttrib;
    int mDependType;

    double GetRemapX(const double width, const double min, const double x0);
    //double GetRemapX(std::vector < double > &VRange, double x0);    

    virtual ExitCode Entry();
    void DummyEntry();
    void ProcessByValue();
    void ProcessByID();
    void ProcessByIndex();
    void ProcessByX(const int axis);
};

class ModifyParticleSizeExec_cls : public ThreadCommon_cls {
 public:
    ModifyParticleSizeExec_cls(AttributeClone_cls* pCSrc);

    void Execute(ViewerClone_cls *pCParticle, 
		 ParticleForRender_cls *pCCurrent, 
		 double factor, double NT, bool bNext);

    bool mbValid;
    bool mbUseID;
    int mType, mAttrib;
    int mDependType, mColorIndex, mChannelType;
    float mTable[1024];
};

#endif
