// (setq-c-offset 4)
// "clsNestedVolume.h"

#include "clsNestedVolume.h"

#include "../SCENEOBJ/clsSceneObj.h"
#include "../WIDGETCTRL/MULTIINPUT/clsMultiInputPanel.h"

#include "../../wxWidgetEnum.h"

#define CLS NestedVolume_cls

CLS::
NestedVolume_cls(wxString strName, wxString strObjName) : ModifierBase_cls ("NestedVolume_cls", strName){
    
    wxString strUpdate = "VIEW3D::PROPERTY_DATAPROC";

    SetConfListTagForSceneObjAttribute(strName, strObjName);
    mCConfList.Add(&mCstrTarget, "Target=", "None", strUpdate);
}

void CLS::
SyncFromBuffer(NestedVolumeBuffer_cls *pCBuffer, SceneObj_cls *pCObj){
    mCConfList.SyncFromCommand(pCBuffer->mCConfList);
}

void CLS::
SelectObject(wxString strObjName){
    mCstrTarget.PushCommandPair(strObjName);
}

#define CLS NestedVolumeBuffer_cls 

CLS::
NestedVolumeBuffer_cls(NestedVolume_cls *pCSrc) : ModifierBase_cls(*pCSrc){
    mpCSrc = pCSrc;
    mCConfList.SetTag(pCSrc->mCConfList.mstrTag);
    mCConfList.Add(&mCstrTarget, "Target=", "None");
}

MultiInputPanel_cls* CLS::
GetPCNewPanel(wxWindow *pCWindow){
    MultiInputPanel_cls *pC =
	new MultiInputPanel_cls(pCWindow, GetStrName(), TRUE);

    pC->CombineSizer(2, _("Target"));
    pC->CombineBitmapPanel(btnDropdown, wxES, 14);
    pC->mVCItem.back().mBitmapTemplate = _BITMAP_BTN_DROPDOWN;
    pC->mVCItem.back().mbUseVCenter = TRUE;
    pC->mVCItem.back().mstrCommandStr = mCstrName.GetBodySTR();
    pC->CombineConfItem(mCstrTarget);

    pC->FinishSetting();
    return pC;
}

void CLS::
SyncFromSrc(){
    mCConfList.SyncFrom(mpCSrc->mCConfList);
}

void CLS::
ForceSrcToSyncBuffer(SceneObj_cls *pCObj){
    mpCSrc->SyncFromBuffer(this, pCObj);
}

