// (setq-c-offset 4)
// "clsParticleBoolean.cpp"

#ifndef _PARTICLE_BOOLEAN_H
#define _PARTICLE_BOOLEAN_H

#include "clsBooleanBase.h"

#include "../COMMON/clsTensorMath.h"
#include "../COMMON/clsThreadCommon.h"

class ViewerClone_cls;
class ParticleBooleanBuffer_cls;
class SceneObj_cls;
class MultiInputPanel_cls;

class ParticleBoolean_cls : public BooleanBase_cls {
 public:
    ParticleBoolean_cls(wxString strName, wxString strObjName);
};    

class ParticleBooleanBuffer_cls : public BooleanBufferBase_cls {
 public:
    ParticleBooleanBuffer_cls(BooleanBase_cls *pCSrc);
};

class ThreadParticleBoolean_cls : public ThreadInstance_cls, public TensorMath_cls {
 public:
    float mXMin, mXMax;
    float mYMin, mYMax;
    float mZMin, mZMax;
    float mRadius;
    int mBooleanType, mBooleanShape;
    float *mpFilterAlpha;
    float (*mpX)[3];
    double mMatrix16[16], mMatrix16TgtInv[16]; 
    SceneObj_cls *mpCObj;
    double mNT;

    void SetParameters(int booleanType, int booleanShape,
		       float XMin, float XMax, 
		       float YMin, float YMax, float ZMin, float ZMax,
		       float radius,
		       float *pFilterAlpha, float (*pX)[3],
		       double matrix16[16], double matrix16TgtInv[16],
		       SceneObj_cls *pCObj);
    
    virtual ExitCode Entry();
};

class ParticleBooleanExec_cls : public ThreadCommon_cls {
 public:
    ParticleBooleanExec_cls(AttributeClone_cls* pCSrc, double NT,
			    double matrix16[16], double matrix16TgtInv[16],
			    SceneObj_cls *pCObj);

    bool mbValid;
    int  mBooleanType, mBooleanShape;
    wxString mstrBooleanObject;
    double mNT;
    AttributeClone_cls* mpCSrc;

    double mMatrix16[16], mMatrix16TgtInv[16];
    SceneObj_cls *mpCObj;
    
    
    float mXMin, mXMax;
    float mYMin, mYMax;
    float mZMin, mZMax;
    float mRadius;

    void CheckBoolean(float *pFilterAlpha, float (*pX)[3],
		      long long numParticle, bool bNext);
};

#endif
