// (setq-c-offset 4)
// "clsPartilceDownsize.h"

#include "clsParticleDownsize.h"

#include "../SCENEOBJ/clsSceneObj.h"
#include "../WIDGETCTRL/MULTIINPUT/clsMultiInputPanel.h"

#define CLS ParticleDownsizing_cls

CLS::
ParticleDownsizing_cls(wxString strName, wxString strObjName) : ModifierBase_cls ("ParticleDownsizing_cls", strName){
    
    wxString strUpdate = "VIEW3D::PROPERTY_DATAPROC";

    SetConfListTagForSceneObjAttribute(strName, strObjName);
    mCConfList.Add(&mCDownsizeType, "DownsizeType=", "0", strUpdate);
    mCConfList.Add(&mCDownsize, "Downsize=", "1", strUpdate);
}

void CLS::
SyncFromBuffer(ParticleDownsizingBuffer_cls *pCBuffer, SceneObj_cls *pCObj){

    mCConfList.SyncFromCommand(pCBuffer->mCConfList);
}

#define CLS ParticleDownsizingBuffer_cls

CLS::
ParticleDownsizingBuffer_cls(ParticleDownsizing_cls *pCSrc) : ModifierBase_cls(*pCSrc){
    mpCSrc = pCSrc;
    mCConfList.SetTag(pCSrc->mCConfList.mstrTag);
    mCConfList.Add(&mCDownsizeType, "DownsizeType=", "0");
    mCConfList.Add(&mCDownsize, "Downsize=", "0");
}

MultiInputPanel_cls* CLS::
GetPCNewPanel(wxWindow *pCWindow){
    MultiInputPanel_cls *pC =
	new MultiInputPanel_cls(pCWindow, GetStrName(), TRUE);

    wxString AstrDownsizeType[3] =
	{_("by index"), _("by ID")};
    pC->SetChoiceList(2, AstrDownsizeType);
    pC->CombineConfItem(mCDownsizeType, _("Downsizing Type"));
    
    pC->SetLimit(1, 10000);
    pC->mDragScale = 3;
    pC->CombineConfItem(mCDownsize);

    pC->FinishSetting();
    return pC;
}

void CLS::
SyncFromSrc(){
    mCConfList.SyncFrom(mpCSrc->mCConfList);
}

void CLS::
ForceSrcToSyncBuffer(SceneObj_cls *pCObj){
    mpCSrc->SyncFromBuffer(this, pCObj);
}
