// (setq-c-offset 4)
// "clsParticleFiltering.cpp"

#ifndef _PARTICLE_FILTERING_H
#define _PARTICLE_FILTERING_H

#include "clsModifierBase.h"

#include "../COMMON/clsParserNumeric.h"

class ArrayAndIndex_cls;
class ParticleFilteringBuffer_cls;
class ParticleForRender_cls;
class MultiInputPanel_cls;

#define _FILTERING_SHOW 0
#define _FILTERING_HIDE 1
#define _FILTERING_ADD  2

class ParticleFilteringBuffer_cls;

class ParticleFiltering_cls : public ModifierBase_cls {
 public:
    ParticleFiltering_cls(wxString strName, wxString strObjName);
    
    ConfItemUINT_cls mCFilteringType;
    ConfItemUINT_cls mCIndexType;
    ConfItemSTR_cls mCstrString;

    void SyncFromBuffer(ParticleFilteringBuffer_cls *pCBuffer, SceneObj_cls *pCObj);
};

class ParticleFilteringBuffer_cls : public ModifierBase_cls {
 public:
    ParticleFilteringBuffer_cls(ParticleFiltering_cls *pCSrc);

    ParticleFiltering_cls *mpCSrc;

    ConfItemUINT_cls mCFilteringType;
    ConfItemUINT_cls mCIndexType;
    ConfItemSTR_cls mCstrString;

    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);
    void SyncFromSrc();
    void ForceSrcToSyncBuffer(SceneObj_cls *pCObj);
    
};

class ParticleFilteringExec_cls : public ParserNumeric_cls{
 public:
    ParticleFilteringExec_cls(AttributeClone_cls* pCSrc);

    void CheckFilteringIDLongLong(float *pFilterAlpha, ArrayAndIndex_cls *pIndexAndZ, bool *pbFilterList, long long numParticle, long long *pIDLongLong);
    void CheckFilteringID(float *pFilterAlpha, ArrayAndIndex_cls *pIndexAndZ, bool *pbFilterList, long long numParticle, int *pID);
    void CheckFiltering(float *pFilterAlpha, ArrayAndIndex_cls *pIndexAndZ,
			ParticleForRender_cls *pCParticle);
    bool* GetNewPbFilterList(int numParticle);

    long long mFilterListMax;

    bool mbValid;
    int mType, mIndexType;
    wxString mstrString;
};

#endif
