// (setq-c-offset 4)
// "clsPartilceDownsize.h"

#include "clsParticleMerge.h"

#include "../SCENEOBJ/clsSceneObj.h"
#include "../SIMDATA/clsParticleForRender.h"
#include "../WIDGETCTRL/MULTIINPUT/clsMultiInputPanel.h"

#include "../../wxWidgetEnum.h"

#define CLS ParticleMerge_cls

CLS::
ParticleMerge_cls(wxString strName, wxString strObjName) : ModifierBase_cls ("ParticleMerge_cls", strName){
    
    wxString strUpdate = "VIEW3D::PROPERTY_DATAPROC";

    SetConfListTagForSceneObjAttribute(strName, strObjName);
    mCConfList.Add(&mCstrTarget, "Target=", "None", strUpdate);
}

void CLS::
SyncFromBuffer(ParticleMergeBuffer_cls *pCBuffer, SceneObj_cls *pCObj){

    mCConfList.SyncFromCommand(pCBuffer->mCConfList);
}

void CLS::
SelectObject(wxString strObjName){
    mCstrTarget.PushCommandPair(strObjName);
}


#define CLS ParticleMergeBuffer_cls

CLS::
ParticleMergeBuffer_cls(ParticleMerge_cls *pCSrc) : ModifierBase_cls(*pCSrc){
    mpCSrc = pCSrc;
    mCConfList.SetTag(pCSrc->mCConfList.mstrTag);
    mCConfList.Add(&mCstrTarget, "Target=", "None");
}

MultiInputPanel_cls* CLS::
GetPCNewPanel(wxWindow *pCWindow){
    MultiInputPanel_cls *pC =
	new MultiInputPanel_cls(pCWindow, GetStrName(), TRUE);

    pC->CombineSizer(2, _("Target"));
    pC->CombineBitmapPanel(btnDropdown, wxES, 14);
    pC->mVCItem.back().mBitmapTemplate = _BITMAP_BTN_DROPDOWN;
    pC->mVCItem.back().mbUseVCenter = TRUE;
    pC->mVCItem.back().mstrCommandStr = mCstrName.GetBodySTR();
    pC->CombineConfItem(mCstrTarget);

    pC->FinishSetting();
    return pC;
}

void CLS::
SyncFromSrc(){
    mCConfList.SyncFrom(mpCSrc->mCConfList);
}

void CLS::
ForceSrcToSyncBuffer(SceneObj_cls *pCObj){
    mpCSrc->SyncFromBuffer(this, pCObj);
}

#define CLS ParticleMergeExe_cls

CLS::
ParticleMergeExe_cls(AttributeClone_cls* pCSrc, ParticleForRender_cls *pCTo, ParticleForRender_cls *pCFrom){
    mpCTo = pCTo;
    mpCFrom = pCFrom;
}

void CLS::
Execute(){

    if (mpCFrom->mPNum <= 0) return;
 
    int numTo = mpCTo->mPNum;
    int numFrom = mpCFrom->mPNum;
    int numTotal = numTo + numFrom;

    float (*pXNew)[3] = new float [numTotal][3];
    memcpy(pXNew, mpCTo->mpX, sizeof(float)*3*numTo);
    memcpy(pXNew+numTo, mpCFrom->mpX, sizeof(float)*3*numFrom);
    delete [] mpCTo->mpX;
    mpCTo->mpX = pXNew;

    float *pClrCurveSNew = new float [numTotal];
    memcpy(pClrCurveSNew, mpCTo->mpClrCurveS, sizeof(float)*numTo);
    memcpy(pClrCurveSNew+numTo, mpCFrom->mpClrCurveS, sizeof(float)*numFrom);
    delete [] mpCTo->mpClrCurveS;
    mpCTo->mpClrCurveS = pClrCurveSNew;

    float *pClrCurveTNew = new float [numTotal];
    memcpy(pClrCurveTNew, mpCTo->mpClrCurveT, sizeof(float)*numTo);
    memcpy(pClrCurveTNew+numTo, mpCFrom->mpClrCurveT, sizeof(float)*numFrom);
    delete [] mpCTo->mpClrCurveT;
    mpCTo->mpClrCurveT = pClrCurveTNew;
    
    if (mpCTo->mpFilterAlpha != NULL){
	float *pFilterAlpha = new float [numTotal];
	memcpy(pFilterAlpha, mpCTo->mpFilterAlpha, sizeof(float)*numTo);
	if (mpCFrom->mpFilterAlpha != NULL)
	    memcpy(pFilterAlpha+numTo, mpCFrom->mpFilterAlpha, sizeof(float)*numFrom);
	else{
	    for (int i = numTo; i < numTo+numFrom; i++) pFilterAlpha[i] = 1;
	    
	}

	delete [] mpCTo->mpFilterAlpha;
	mpCTo->mpFilterAlpha = pFilterAlpha;
    }
	
    if (mpCTo->mpSizeAlpha != NULL){
	float *pSizeAlpha = new float [numTotal];
	memcpy(pSizeAlpha, mpCTo->mpSizeAlpha, sizeof(float)*numTo);
	if (mpCFrom->mpSizeAlpha != NULL)
	    memcpy(pSizeAlpha+numTo, mpCFrom->mpSizeAlpha, sizeof(float)*numFrom);
	else{
	    for (int i = numTo; i < numTo+numFrom; i++) pSizeAlpha[i] = 1;
	}
	delete [] mpCTo->mpSizeAlpha;
	mpCTo->mpSizeAlpha = pSizeAlpha;
    }

    unsigned char *pParamBitNew = new unsigned char [numTotal];
    memcpy(pParamBitNew, mpCTo->mpParamBit, sizeof(unsigned char)*numTo);
    memcpy(pParamBitNew+numTo, mpCFrom->mpParamBit, sizeof(unsigned char)*numFrom);
    delete [] mpCTo->mpParamBit;
    mpCTo->mpParamBit = pParamBitNew;

    ArrayAndIndex_cls *pIndexAndZNew = new ArrayAndIndex_cls [numTotal];
    memcpy(pIndexAndZNew, mpCTo->mpIndexAndZ, sizeof(ArrayAndIndex_cls)*numTo);
    memcpy(pIndexAndZNew+numTo, mpCFrom->mpIndexAndZ, sizeof(ArrayAndIndex_cls)*numFrom);
    delete [] mpCTo->mpIndexAndZ;
    mpCTo->mpIndexAndZ = pIndexAndZNew;
    
    float *pSizeNew = new float [numTotal];
    memcpy(pSizeNew, mpCTo->mpSize, sizeof(float)*numTo);
    memcpy(pSizeNew+numTo, mpCFrom->mpSize, sizeof(float)*numFrom);
    delete [] mpCTo->mpSize;
    mpCTo->mpSize = pSizeNew;

    if (mpCTo->mpSizeMod != NULL){
	float *pSizeModNew = new float [numTotal];
	memcpy(pSizeModNew, mpCTo->mpSizeMod, sizeof(float)*numTo);
	if (mpCFrom->mpSizeMod != NULL)
	    memcpy(pSizeModNew+numTo, mpCFrom->mpSizeMod, sizeof(float)*numFrom);
	else
	    memcpy(pSizeModNew+numTo, mpCFrom->mpSize, sizeof(float)*numFrom);
	delete [] mpCTo->mpSizeMod;
	mpCTo->mpSizeMod = pSizeModNew;
    }

    unsigned char *pTypeNew = new unsigned char [numTotal];
    memcpy(pTypeNew, mpCTo->mpType, sizeof(unsigned char)*numTo);
    memcpy(pTypeNew+numTo, mpCFrom->mpType, sizeof(unsigned char)*numFrom);
    delete [] mpCTo->mpType;
    mpCTo->mpType = pTypeNew;

    if (mpCTo->mpID != NULL){
	int *pIDNew = new int [numTotal];
	memcpy(pIDNew, mpCTo->mpID, sizeof(int)*numTo);
	if (mpCFrom->mpID != NULL)
	    memcpy(pIDNew+numTo, mpCFrom->mpID, sizeof(unsigned char)*numFrom);
	else
	    for (int i = numTo; i < numTo+numFrom; i++) pIDNew[i] = i;
	
	delete [] mpCTo->mpID;
	mpCTo->mpID = pIDNew;
    }

    if (mpCTo->mpIDLongLong != NULL){
	long long *pIDLongLongNew = new long long [numTotal];
	memcpy(pIDLongLongNew, mpCTo->mpIDLongLong, sizeof(long long)*numTo);
	if (mpCFrom->mpIDLongLong != NULL)
	    memcpy(pIDLongLongNew+numTo, mpCFrom->mpIDLongLong, sizeof(unsigned char)*numFrom);
	else
	    for (int i = numTo; i < numTo+numFrom; i++) pIDLongLongNew[i] = i;
	
	delete [] mpCTo->mpIDLongLong;
	mpCTo->mpIDLongLong = pIDLongLongNew;
    }

    mpCTo->mPNum = numTotal;
}
