// (setq-c-offset 4)
// "clsStreamFiltering.cpp"

#ifndef _STREAM_FILTERING_H
#define _STREAM_FILTERING_H

#include "clsModifierBase.h"

#include "../COMMON/clsParserNumeric.h"

class ArrayAndIndex_cls;
class StreamFilteringBuffer_cls;
class MultiInputPanel_cls;

#define _FILTERING_SHOW 0
#define _FILTERING_HIDE 1
#define _FILTERING_ADD  2

class StreamFiltering_cls : public ModifierBase_cls {
 public:
    StreamFiltering_cls(wxString strName, wxString strObjName);
    
    ConfItemUINT_cls mCFilteringType;
    ConfItemUINT_cls mCIndexType;
    ConfItemSTR_cls mCstrString;

    void SyncFromBuffer(StreamFilteringBuffer_cls *pCBuffer, SceneObj_cls *pCObj);
};

class StreamFilteringBuffer_cls : public ModifierBase_cls {
 public:
    StreamFilteringBuffer_cls(StreamFiltering_cls *pCSrc);

    StreamFiltering_cls *mpCSrc;

    ConfItemUINT_cls mCFilteringType;
    //ConfItemUINT_cls mCIndexType;
    ConfItemSTR_cls mCstrString;

    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);
    void SyncFromSrc();
    void ForceSrcToSyncBuffer(SceneObj_cls *pCObj);
    
};

class StreamFilteringExec_cls : public ParserNumeric_cls{
 public:
    StreamFilteringExec_cls(AttributeClone_cls* pCSrc);

    void CheckFiltering(float *pFilterAlpha, int *mpLineIndex,
			long long numStreamVertex);
    bool* GetNewPbFilterList(int numStreamVertex);

    long long mFilterListMax;

    bool mbValid;
    int mType, mIndexType;
    wxString mstrString;
};

#endif
