// (setq-c-offset 4)
// "clsStreamSetAlpha.h"

#include "clsStreamSetAlpha.h"

#include "../SCENEOBJ/clsSceneObj.h"
#include "../WIDGETCTRL/MULTIINPUT/clsMultiInputPanel.h"

#define CLS StreamSetAlpha_cls

CLS::
StreamSetAlpha_cls(wxString strName, wxString strObjName) : ModifierBase_cls ("StreamSetAlpha_cls", strName){
    
    wxString strUpdate = "VIEW3D::PROPERTY_DATAPROC";

    SetConfListTagForSceneObjAttribute(strName, strObjName);
    mCConfList.Add(&mCSetAlphaType, "SetAlphaType=", "0", strUpdate);
    mCConfList.Add(&mCCrit, "Crit=", "0", strUpdate);
}

void CLS::
SyncFromBuffer(StreamSetAlphaBuffer_cls *pCBuffer, SceneObj_cls *pCObj){

    mCConfList.SyncFromCommand(pCBuffer->mCConfList);
}

#define CLS StreamSetAlphaBuffer_cls

CLS::
StreamSetAlphaBuffer_cls(StreamSetAlpha_cls *pCSrc) : ModifierBase_cls(*pCSrc){
    mpCSrc = pCSrc;
    mCConfList.SetTag(pCSrc->mCConfList.mstrTag);
    mCConfList.Add(&mCSetAlphaType, "SetAlphaType=", "0");
    mCConfList.Add(&mCCrit, "Crit=", "0");
}

MultiInputPanel_cls* CLS::
GetPCNewPanel(wxWindow *pCWindow){
    MultiInputPanel_cls *pC =
	new MultiInputPanel_cls(pCWindow, GetStrName(), TRUE);

    wxString AstrSetAlphaType[2] =
	{_("Larger than crit"), _("Less than crit")};
    pC->SetChoiceList(2, AstrSetAlphaType);
    pC->CombineConfItem(mCSetAlphaType, _("SetAlphaType"));

    pC->mDragScale = 1;
    pC->CombineConfItem(mCCrit, _("Crit"));

    pC->FinishSetting();
    return pC;
}

void CLS::
SyncFromSrc(){
    mCConfList.SyncFrom(mpCSrc->mCConfList);
}

void CLS::
ForceSrcToSyncBuffer(SceneObj_cls *pCObj){
    mpCSrc->SyncFromBuffer(this, pCObj);
}

#define CLS StreamSetAlphaExec_cls

CLS::
StreamSetAlphaExec_cls(AttributeClone_cls* pCSrc){
    mbValid = pCSrc->GetPCItem("Validity=")->GetBodyBOOL();
    mType = pCSrc->GetPCItem("SetAlphaType=")->GetBodyINT();
    mCrit = pCSrc->GetPCItem("Crit=")->GetBodyDOUBLE();
}

void CLS::
SetAlpha(float *pFilterAlpha, float *pValue, 
	      long long numStreamVertex){
    if (mbValid == FALSE) return;

    switch(mType){
    case 0:
	for (int i = 0; i < numStreamVertex; i++){
	    if (pValue[i] > mCrit) pFilterAlpha[i] *= 0;
	}
	break;
    case 1:
	for (int i = 0; i < numStreamVertex; i++){
	    if (pValue[i] < mCrit) pFilterAlpha[i] *= 0;
	}
	break;
    }
}
