// (setq-c-offset 4)
// "clsStreamFiltering.cpp"

#ifndef _STREAM_TRANSFORM_H
#define _STREAM_TRANSFORM_H

#include "../COMMON/clsParserNumeric.h"
#include "clsModifierBase.h"

class ArrayAndIndex_cls;
class StreamTransformBuffer_cls;
class MultiInputPanel_cls;

class StreamTransform_cls : public ModifierBase_cls {
 public:
    StreamTransform_cls(wxString strName, wxString strObjName);
    
    ConfItemFLOATARRAY_cls mCOffset;
    ConfItemFLOATARRAY_cls mCRotate;
    ConfItemUINT_cls mCRotateOrder;
    ConfItemFLOATARRAY_cls mCScale;
    
    void SyncFromBuffer(StreamTransformBuffer_cls *pCBuffer, SceneObj_cls *pCObj);
};

class StreamTransformBuffer_cls : public ModifierBase_cls {
public:
    StreamTransformBuffer_cls(StreamTransform_cls *pCSrc);

    StreamTransform_cls *mpCSrc;

    ConfItemFLOATARRAY_cls mCOffset;
    ConfItemFLOATARRAY_cls mCRotate;
    ConfItemUINT_cls mCRotateOrder;
    ConfItemFLOATARRAY_cls mCScale;

    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);
    void SyncFromSrc();
    void ForceSrcToSyncBuffer(SceneObj_cls *pCObj);
};

class StreamTransformExec_cls : public ParserNumeric_cls{
 public:
    StreamTransformExec_cls(AttributeClone_cls* pCSrc);

    void RotateX(float (*pPos)[3], int SNum, float radianX);
    void RotateY(float (*pPos)[3], int SNum, float radianY);
    void RotateZ(float (*pPos)[3], int SNum, float radianZ);
    void Transform(float (*pPos)[3], int SNum);
    
    bool mbValid;
    std::vector < double > mVOffset;
    std::vector < double > mVRotate;
    std::vector < double > mVScale;
    int mRotateOrder;
    
};

#endif
