// (setq-c-offset 4)
// "clsTracking.cpp"

#ifndef _TRACKING_H
#define _TRACKING_H

#include "clsModifierBase.h"

#include "../COMMON/clsTensorMath.h"

class TrackingBuffer_cls;
class SceneObj_cls;
class MultiInputPanel_cls;

class Tracking_cls : public ModifierBase_cls, public TensorMath_cls {
 public:
    Tracking_cls(wxString strName, wxString strObjName);

    ConfItemSTR_cls mCstrTarget;
    ConfItemUINT_cls mCBaseDirection;
    ConfItemUINT_cls mCBaseTopDirection;
    
    void Execute(double matrix[16], double matrixLocal[16]);
    void SyncFromBuffer(TrackingBuffer_cls *pCBuffer, SceneObj_cls *pCObj);
    void SelectObject(wxString strObjName);
};

class TrackingBuffer_cls : public ModifierBase_cls {
 public:
    TrackingBuffer_cls(Tracking_cls *pCSrc);

    Tracking_cls *mpCSrc;

    ConfItemSTR_cls mCstrTarget;
    ConfItemUINT_cls mCBaseDirection;
    ConfItemUINT_cls mCBaseTopDirection;
    ConfItemFLOAT_cls mCInfluence;
    ConfItemFLOAT_cls mCRotate;
    

    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);
    void SyncFromSrc();
    void ForceSrcToSyncBuffer(SceneObj_cls *pCObj);
};

#endif
