// (setq-c-offset 4)
// "clsVolumeBoolean.h"

#include "clsVolumeBoolean.h"

#include "../COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;
#include "../GLSL/clsShaderItem.h"
#include "../SCENEOBJ/clsMeshObj.h"
#include "../SCENEOBJ/clsPrimitive.h"
#include "../SCENEOBJ/clsSceneObj.h"
#include "../SCENEOBJ/clsSceneObjCtrl.h"

#define CLS ThreadVolumeBoolGather_cls

void CLS::
SetParameters(unsigned char *pData, unsigned short *pData_ushort,
	      char *pMask,
	      int sizeX, int sizeY, int sizeZ){
    mpData = pData;
    mpData_ushort = pData_ushort;
    mpMask = pMask;
    mSizeX = sizeX; mSizeY = sizeY; mSizeZ = sizeZ;
}

bool CLS::
CreateThread(bool *pbFinishedFlag, int ZIni, int ZFin){
    mpbFinishedFlagLink = pbFinishedFlag;
    mZIni = ZIni;
    mZFin = ZFin;

    if ( Create() != wxTHREAD_NO_ERROR) 
	return FALSE;

    return TRUE;
}

wxThread::ExitCode CLS::
Entry(){
    const int sizeX = mSizeX;
    const int sizeY = mSizeY;
    const int sizeZ = mSizeZ;
    
    char * const pMask = mpMask;
    
    if (mpData_ushort != NULL){
	unsigned short * const pData = mpData_ushort;
	for (int z = 0; z < sizeZ; z++){
	    const int indexz = z * sizeX * sizeY;
	    for (int y = 0; y < sizeY; y++){
		const int indexy = indexz + y * sizeX;
		for (int x = 0; x < sizeX; x++){
		    const int index = indexy + x;
		pData[index] *= pMask[index];
		}
	    }
	}
    }

    if (mpData != NULL){
	unsigned char * const pData = mpData;
	for (int z = 0; z < sizeZ; z++){
	    const int indexz = z * sizeX * sizeY;
	    for (int y = 0; y < sizeY; y++){
		const int indexy = indexz + y * sizeX;
		for (int x = 0; x < sizeX; x++){
		    const int index = indexy + x;
		pData[index] *= pMask[index];
		}
	    }
	}
    }

    *mpbFinishedFlagLink = TRUE;
    return 0;
}

#define CLS ThreadVolumeBooleanBase_cls

bool CLS::
CreateThread(bool *pbFinishedFlag, int ZIni, int ZFin){
    mpbFinishedFlagLink = pbFinishedFlag;
    mZIni = ZIni;
    mZFin = ZFin;

    if ( Create() != wxTHREAD_NO_ERROR) 
	return FALSE;
    return TRUE;
}

#define CLS ThreadVolumeBooleanBox_cls

void CLS::
SetParameters(char *pMask, int sizeX, int sizeY, int sizeZ, int type,
	      std::vector < double > VXMinMax,
	      std::vector < double > VYMinMax,
	      std::vector < double > VZMinMax){
    mpMask = pMask;
    mSizeX = sizeX; mSizeY = sizeY; mSizeZ = sizeZ;
    mType = type;
    mVXMinMax = VXMinMax; mVYMinMax = VYMinMax; mVZMinMax = VZMinMax;
}

wxThread::ExitCode CLS::
Entry(){
    const int sizeX = mSizeX;
    const int sizeY = mSizeY;
    const int sizeZ = mSizeZ;
    const int type = mType;
    const int ZIni = mZIni;
    const int ZFin = mZFin;
    //const std::vector < double > VXMinMax = mVXMinMax;
    //const std::vector < double > VYMinMax = mVYMinMax;
    //const std::vector < double > VZMinMax = mVZMinMax;
    
    double VXMin = mVXMinMax[0];
    double VXMax = mVXMinMax[1];
    const double VYMin = mVYMinMax[0];
    const double VYMax = mVYMinMax[1];
    const double VZMin = mVZMinMax[0];
    const double VZMax = mVZMinMax[1];

    char * const pMask = mpMask;
    
    // `̏ꍇPɏčłB
    // [v̍Ő[͔͈͂ő

    if (VXMin < 0) VXMin = 0;
    if (VXMin > 1) VXMin = 1;
    if (VXMax < 0) VXMax = 0;
    if (VXMax > 1) VXMax = 1;

    int xIndexIni = VXMin*sizeX;
    int xIndexFin = VXMax*sizeX;
    
    if (type == _BOOL_INTERSECT) 
	for (int z = ZIni; z < ZFin; z++){
	    const int indexz = z * sizeX * sizeY;
	    const float fZ = (float)(z + 0.5) / sizeZ;
	    if (fZ < VZMin || fZ > VZMax){ 
		// Z Ŕ͈͊Om
		for (int y = 0; y < sizeY; y++){
		    const int indexy = indexz + y * sizeX;
		    memset(pMask+indexy, 0, sizeX);
		}
	    }
	    else
		// XY `FbN
		for (int y = 0; y < sizeY; y++){
		    const int indexy = indexz + y * sizeX;
		    const float fY = (float)(y + 0.5) / sizeY;
		    if (fY < VYMin || fY > VYMax){
			// Y Ŕ͈͊Om
			memset(pMask+indexy, 0, sizeX);
		    }
		    else{
			// X ͔͈k܂Ă
			memset(pMask+indexy, 0, xIndexIni);
			memset(pMask+indexy+xIndexFin, 0, sizeX-xIndexFin);
		    }
		}
	}
    
    if (type == _BOOL_DIFFERECE) 
	for (int z = ZIni; z < ZFin; z++){
	    const int indexz = z * sizeX * sizeY;
	    const float fZ = (float)(z + 0.5) / sizeZ;
	    if (fZ < VZMax && fZ > VZMin){
		for (int y = 0; y < sizeY; y++){
		    const int indexy = indexz + y * sizeX;
		    const float fY = (float)(y + 0.5) / sizeY;
		    if (fY < VYMax && fY > VYMin){
			if (xIndexFin > xIndexIni)
			    memset(pMask+indexy+xIndexIni, 0, xIndexFin-xIndexIni);
		    }
		}
	    }
	}
    
    if (type == _BOOL_ADD) 
	for (int z = ZIni; z < ZFin; z++){
	    const int indexz = z * sizeX * sizeY;
	    const float fZ = (float)(z + 0.5) / sizeZ;
	    if (fZ < VZMax && fZ > VZMin){
		for (int y = 0; y < sizeY; y++){
		    const int indexy = indexz + y * sizeX;
		    const float fY = (float)(y + 0.5) / sizeY;
		    if (fY < VYMax && fY > VYMin){
			if (xIndexFin > xIndexIni)
			    memset(pMask+indexy+xIndexIni, 1, xIndexFin-xIndexIni);
		    }
		}
	    }
	}
    
    *mpbFinishedFlagLink = TRUE;
    return 0;
}

#define CLS ThreadVolumeBooleanSphere_cls

void CLS::
SetParameters(char *pMask, int sizeX, int sizeY, int sizeZ, int type,
	      float radius){
    mpMask = pMask;
    mSizeX = sizeX; mSizeY = sizeY; mSizeZ = sizeZ;
    mType = type;
    mRadius = radius;
}

wxThread::ExitCode CLS::
Entry(){
    const int sizeX = mSizeX;
    const int sizeY = mSizeY;
    const int sizeZ = mSizeZ;
    const int type = mType;
    const int ZIni = mZIni;
    const int ZFin = mZFin;
    
    const double radius2 = mRadius * mRadius;
    
    char * const pMask = mpMask;
    
    if (type == 0) // Intersect
	for (int z = ZIni; z < ZFin; z++){
	    const int indexz = z * sizeX * sizeY;
	    const float fZ = (float)(z + 0.5) / sizeZ * 2 - 1 ;
	    for (int y = 0; y < sizeY; y++){
		const int indexy = indexz + y * sizeX;
		const float fY = (float)(y+0.5) / sizeY * 2 - 1;
		for (int x = 0; x < sizeX; x++){
		    const int index = indexy + x;
		    const float fX = (float)(x+0.5) / sizeX * 2 - 1;
		    bool bInside = 
			(fX*fX + fY*fY + fZ*fZ) < radius2;
		    if (bInside == FALSE) pMask[index] = 0;
		}
	    }
	}

    if (type == 1) // Differenc
	for (int z = ZIni; z < ZFin; z++){
	    const int indexz = z * sizeX * sizeY;
	    const float fZ = (float)(z + 0.5) / sizeZ * 2 - 1 ;
	    for (int y = 0; y < sizeY; y++){
		const int indexy = indexz + y * sizeX;
		const float fY = (float)(y+0.5) / sizeY * 2 - 1;
		for (int x = 0; x < sizeX; x++){
		    const int index = indexy + x;
		    const float fX = (float)(x+0.5) / sizeX * 2 - 1;
		    bool bInside = 
			(fX*fX + fY*fY + fZ*fZ) < radius2;
		    if (bInside == TRUE) pMask[index] = 0;
		}
	    }
	}

    if (type == 1) // Add
	for (int z = ZIni; z < ZFin; z++){
	    const int indexz = z * sizeX * sizeY;
	    const float fZ = (float)(z + 0.5) / sizeZ * 2 - 1 ;
	    for (int y = 0; y < sizeY; y++){
		const int indexy = indexz + y * sizeX;
		const float fY = (float)(y+0.5) / sizeY * 2 - 1;
		for (int x = 0; x < sizeX; x++){
		    const int index = indexy + x;
		    const float fX = (float)(x+0.5) / sizeX * 2 - 1;
		    bool bInside = 
			(fX*fX + fY*fY + fZ*fZ) < radius2;
		    if (bInside == TRUE) pMask[index] = 1;
		}
	    }
	}
    
    *mpbFinishedFlagLink = TRUE;
    return 0;
}


#define CLS ThreadVolumeBooleanPrimitive_cls

void CLS::
SetParameters(char *pMask, int sizeX, int sizeY, int sizeZ, int type,
	      Primitive_cls *pCPrimitive, 
	      double matrix16[16], double matrix16TgtInv[16]){
    mpMask = pMask;
    mSizeX = sizeX; mSizeY = sizeY; mSizeZ = sizeZ;
    mType = type;
    mpCPrimitive = pCPrimitive;
    memcpy(mMatrix16, matrix16, sizeof(double)*16);
    memcpy(mMatrix16TgtInv, matrix16TgtInv, sizeof(double)*16);
}

wxThread::ExitCode CLS::
Entry(){
    const int sizeX = mSizeX;
    const int sizeY = mSizeY;
    const int sizeZ = mSizeZ;
    const int type = mType;
    const int ZIni = mZIni;
    const int ZFin = mZFin;

    //double matrix16Full[16];
    Multiply(mMatrix16TgtInv, mMatrix16);

    char * const pMask = mpMask;

    Primitive_cls * const pCPrimitive = mpCPrimitive;

    if (type == 0) // Intersect
	for (int z = ZIni; z < ZFin; z++){
	    const int indexz = z * sizeX * sizeY;
	    const float fZ = (float)(z + 0.5) / sizeZ * 2 - 1 ;
	    for (int y = 0; y < sizeY; y++){
		const int indexy = indexz + y * sizeX;
		const float fY = (float)(y+0.5) / sizeY * 2 - 1;
		for (int x = 0; x < sizeX; x++){
		    const int index = indexy + x;
		    const float fX = (float)(x+0.5) / sizeX * 2 - 1;
		    double pos[4] = {fX, fY, fZ, 1};
		    MultiplyVFast(mMatrix16, pos);
		    bool bInside = 
			pCPrimitive->IsInside(pos[0], pos[1], pos[2]);
		    if (bInside == FALSE) pMask[index] = 0;
		}
	    }
	}

    if (type == 1) // Difference
	for (int z = ZIni; z < ZFin; z++){
	    const int indexz = z * sizeX * sizeY;
	    const float fZ = (float)(z + 0.5) / sizeZ * 2 - 1;
	    for (int y = 0; y < sizeY; y++){
		const int indexy = indexz + y * sizeX;
		const float fY = (float)(y+0.5) / sizeY * 2 - 1;
		for (int x = 0; x < sizeX; x++){
		    const int index = indexy + x;
		    const float fX = (float)(x+0.5) / sizeX * 2 - 1;
		    double pos[4] = {fX, fY, fZ, 1};
		    MultiplyVFast(mMatrix16, pos);
		    bool bInside = 
			pCPrimitive->IsInside(pos[0], pos[1], pos[2]);
		    if (bInside == TRUE) pMask[index] = 0;
		}
	    }
	}

    if (type == 2) // Add
	for (int z = ZIni; z < ZFin; z++){
	    const int indexz = z * sizeX * sizeY;
	    const float fZ = (float)(z + 0.5) / sizeZ * 2 - 1;
	    for (int y = 0; y < sizeY; y++){
		const int indexy = indexz + y * sizeX;
		const float fY = (float)(y+0.5) / sizeY * 2 - 1;
		for (int x = 0; x < sizeX; x++){
		    const int index = indexy + x;
		    const float fX = (float)(x+0.5) / sizeX * 2 - 1;
		    double pos[4] = {fX, fY, fZ, 1};
		    MultiplyVFast(mMatrix16, pos);
		    bool bInside = 
			pCPrimitive->IsInside(pos[0], pos[1], pos[2]);
		    if (bInside == TRUE) pMask[index] = TRUE;
		}
	    }
	}

    *mpbFinishedFlagLink = TRUE;
    return 0;
}

#define CLS ThreadVolumeBooleanMesh_cls

void CLS::
SetParameters(char *pMask, int sizeX, int sizeY, int sizeZ, int type,
	      MeshObj_cls *pCMesh, 
	      double matrix16[16], double matrix16TgtInv[16]){
    mpMask = pMask;
    mSizeX = sizeX; mSizeY = sizeY; mSizeZ = sizeZ;
    mType = type;
    mpCMesh = pCMesh;
    memcpy(mMatrix16, matrix16, sizeof(double)*16);
    memcpy(mMatrix16TgtInv, matrix16TgtInv, sizeof(double)*16);
}

wxThread::ExitCode CLS::
Entry(){
    const int sizeX = mSizeX;
    const int sizeY = mSizeY;
    const int sizeZ = mSizeZ;
    const int type = mType;
    const int ZIni = mZIni;
    const int ZFin = mZFin;

    //double matrix16Full[16];
    Multiply(mMatrix16TgtInv, mMatrix16);

    char * const pMask = mpMask;

    MeshObj_cls * const pCMesh = mpCMesh;
    MeshBase2_cls &CMesh2 = pCMesh->mCMesh2;

    int tagBufferSize = CMesh2.GetTagBufferSize();

    int *pVertexTag = new int [tagBufferSize];
    
    if (type == 0) // Intersect
	for (int z = ZIni; z < ZFin; z++){
	    const int indexz = z * sizeX * sizeY;
	    const float fZ = (float)(z + 0.5) / sizeZ * 2 - 1 ;
	    for (int y = 0; y < sizeY; y++){
		const int indexy = indexz + y * sizeX;
		const float fY = (float)(y+0.5) / sizeY * 2 - 1;
		for (int x = 0; x < sizeX; x++){
		    const int index = indexy + x;
		    const float fX = (float)(x+0.5) / sizeX * 2 - 1;
		    double pos[4] = {fX, fY, fZ, 1};
		    MultiplyVFast(mMatrix16, pos);
		    bool bInside = CMesh2.IsInside(pos[0], pos[1], pos[2],
						   tagBufferSize, pVertexTag);
		    if (bInside == FALSE)
			pMask[index] = 0;
		}
	    }
	}

    if (type == 1) // Difference
	for (int z = ZIni; z < ZFin; z++){
	    const int indexz = z * sizeX * sizeY;
	    const float fZ = (float)(z + 0.5) / sizeZ * 2 - 1;
	    for (int y = 0; y < sizeY; y++){
		const int indexy = indexz + y * sizeX;
		const float fY = (float)(y+0.5) / sizeY * 2 - 1;
		for (int x = 0; x < sizeX; x++){
		    const int index = indexy + x;
		    const float fX = (float)(x+0.5) / sizeX * 2 - 1;
		    double pos[4] = {fX, fY, fZ, 1};
		    MultiplyVFast(mMatrix16, pos);
		    bool bInside = CMesh2.IsInside(pos[0], pos[1], pos[2],
						   tagBufferSize, pVertexTag);
		    if (bInside == TRUE)
			pMask[index] = 0;
		}
	    }
	}

    if (type == 2) // Add
	for (int z = ZIni; z < ZFin; z++){
	    const int indexz = z * sizeX * sizeY;
	    const float fZ = (float)(z + 0.5) / sizeZ * 2 - 1;
	    for (int y = 0; y < sizeY; y++){
		const int indexy = indexz + y * sizeX;
		const float fY = (float)(y+0.5) / sizeY * 2 - 1;
		for (int x = 0; x < sizeX; x++){
		    const int index = indexy + x;
		    const float fX = (float)(x+0.5) / sizeX * 2 - 1;
		    double pos[4] = {fX, fY, fZ, 1};
		    MultiplyVFast(mMatrix16, pos);
		    bool bInside = CMesh2.IsInside(pos[0], pos[1], pos[2],
						   tagBufferSize, pVertexTag);
		    if (bInside == TRUE)
			pMask[index] = TRUE;
		}
	    }
	}

    delete [] pVertexTag;
    
    *mpbFinishedFlagLink = TRUE;
    return 0;
}

#define CLS VolumeBoolean_cls

CLS::
VolumeBoolean_cls(wxString strName, wxString strObjName) : BooleanBase_cls ("VolumeBoolean_cls", strName, strObjName){
}



int CLS::
GetThreadNumber(long long totalSize, int sizeZ, float factor){
    int threadNumber = 1;
    long long base = 1024*1024;
    if (totalSize >= base * factor * 8 && sizeZ > 2) threadNumber++;
    if (totalSize >= base * factor * 16 && sizeZ > 3) threadNumber++;
    if (totalSize >= base * factor * 32 && sizeZ > 4) threadNumber++;
    if (totalSize >= base * factor * 64 && sizeZ > 5) threadNumber++;
    if (totalSize >= base * factor * 128 && sizeZ > 6) threadNumber++;
    return threadNumber;
}

// ł͂ȂăN[̒lQƂKvB
void CLS::
SetBooleanMaskBox(AttributeClone_cls &CClone, char *pMask, int sizeX, int sizeY, int sizeZ, double NT){
    //double NT = GCClassProvider.GetPCTimeCtrl()->GetCurrentNT();
    std::vector < double > VXMinMax = CClone.GetPCParamGroup("X Min/Max")->GetVInterpolatedValue(NT);
    std::vector < double > VYMinMax = CClone.GetPCParamGroup("Y Min/Max")->GetVInterpolatedValue(NT);
    std::vector < double > VZMinMax = CClone.GetPCParamGroup("Z Min/Max")->GetVInterpolatedValue(NT);

    int type = CClone.GetPCItem("BooleanType=")->GetBodyINT();

    long long totalSize = (long long)sizeX * (long long)sizeY * (long long)sizeZ;
    int threadNumber = GetThreadNumber(totalSize, sizeZ);
        
    bool *bAFinished = new bool [threadNumber];
    
    ThreadVolumeBooleanBox_cls **ppCThread = new ThreadVolumeBooleanBox_cls* [threadNumber];
    for (int i = 0; i < threadNumber; i++){
	bAFinished[i] = FALSE;
	ppCThread[i] = new ThreadVolumeBooleanBox_cls;
	ppCThread[i]->SetParameters(pMask, sizeX, sizeY, sizeZ,
				    type, VXMinMax, VYMinMax, VZMinMax);
    }
	
    for (int i = 0; i < threadNumber; i++){
	int Zini = sizeZ * i / threadNumber;
	int Zfin = sizeZ * (i+1) / threadNumber;
	ppCThread[i]->CreateThread(&bAFinished[i], Zini, Zfin);
	ppCThread[i]->Run();
    }

    WaitThreadsAndDeleteFlag(bAFinished, threadNumber, 3);
    delete [] ppCThread;
}

void CLS::
SetBooleanMaskSphere(AttributeClone_cls &CClone, char *pMask, int sizeX, int sizeY, int sizeZ, double NT){
    
    int type = CClone.GetPCItem("BooleanType=")->GetBodyINT();

    std::vector < double > VRadius = CClone.GetPCParamGroup("Radius")->GetVInterpolatedValue(NT);
    
    long long totalSize = (long long)sizeX * (long long)sizeY * (long long)sizeZ;
    int threadNumber = GetThreadNumber(totalSize, sizeZ);
        
    bool *bAFinished = new bool [threadNumber];

    ThreadVolumeBooleanSphere_cls **ppCThread = new ThreadVolumeBooleanSphere_cls* [threadNumber];
    for (int i = 0; i < threadNumber; i++){
	bAFinished[i] = FALSE;
	ppCThread[i] = new ThreadVolumeBooleanSphere_cls;
	ppCThread[i]->SetParameters(pMask, sizeX, sizeY, sizeZ, type, VRadius[0]);
    }
    
    for (int i = 0; i < threadNumber; i++){
	int Zini = sizeZ * i / threadNumber;
	int Zfin = sizeZ * (i+1) / threadNumber;
	ppCThread[i]->CreateThread(&bAFinished[i], Zini, Zfin);
	ppCThread[i]->Run();
    }

    WaitThreadsAndDeleteFlag(bAFinished, threadNumber, 3);
    delete [] ppCThread;
}

void CLS::
SetBooleanMaskPrimitive(AttributeClone_cls &CClone, char *pMask, int sizeX, int sizeY, int sizeZ, double matrix16[16], double matrix16TgtInv[16], SceneObj_cls *pCObj){
    int type = CClone.GetPCItem("BooleanType=")->GetBodyINT();
    Primitive_cls *pCPrim = (Primitive_cls*)pCObj;

    long long totalSize = (long long)sizeX * (long long)sizeY * (long long)sizeZ;
    int threadNumber = GetThreadNumber(totalSize, sizeZ, 1.0/64);

    bool *bAFinished = new bool [threadNumber];

    ThreadVolumeBooleanPrimitive_cls **ppCThread = new ThreadVolumeBooleanPrimitive_cls* [threadNumber];
    for (int i = 0; i < threadNumber; i++){
	bAFinished[i] = FALSE;
	ppCThread[i] = new ThreadVolumeBooleanPrimitive_cls;
	ppCThread[i]->SetParameters(pMask, sizeX, sizeY, sizeZ,
				    type, pCPrim, matrix16, matrix16TgtInv);
    }

    for (int i = 0; i < threadNumber; i++){
	int Zini = sizeZ * i / threadNumber;
	int Zfin = sizeZ * (i+1) / threadNumber;
	ppCThread[i]->CreateThread(&bAFinished[i], Zini, Zfin);
	ppCThread[i]->Run();
    }

    WaitThreadsAndDeleteFlag(bAFinished, threadNumber, 3);
    delete [] ppCThread;
}

void CLS::
SetBooleanMaskObject(AttributeClone_cls &CClone, char *pMask, int sizeX, int sizeY, int sizeZ, double matrix16[16], double matrix16TgtInv[16]){

    int type = CClone.GetPCItem("BooleanType=")->GetBodyINT();
    wxString strTgt = CClone.GetPCItem("BooleanObject=")->GetBodySTR();
    SceneObj_cls* pCObj = GCClassProvider.GetPCSceneObjCtrl()->GetPCFromName(strTgt);
    if (pCObj == NULL) return;
    if (pCObj->mstrClassName.IsSameAs("Primitive_cls"))
	return SetBooleanMaskPrimitive(CClone, pMask, sizeX, sizeY, sizeZ, matrix16, matrix16TgtInv, pCObj);
	    
    if (pCObj->mstrClassName.IsSameAs("MeshObj_cls") == FALSE) return;
    MeshObj_cls* pCMesh = (MeshObj_cls*)pCObj;

    pCMesh->CheckLoad();
    pCMesh->CheckTree();

    long long totalSize = (long long)sizeX * (long long)sizeY * (long long)sizeZ;
    int threadNumber = GetThreadNumber(totalSize, sizeZ, 1.0/64);

    bool *bAFinished = new bool [threadNumber];
    
    ThreadVolumeBooleanMesh_cls **ppCThread = new ThreadVolumeBooleanMesh_cls* [threadNumber];
    for (int i = 0; i < threadNumber; i++){
	bAFinished[i] = FALSE;
	ppCThread[i] = new ThreadVolumeBooleanMesh_cls;
	ppCThread[i]->SetParameters(pMask, sizeX, sizeY, sizeZ,
				    type, pCMesh, matrix16, matrix16TgtInv);
    }

    for (int i = 0; i < threadNumber; i++){
	int Zini = sizeZ * i / threadNumber;
	int Zfin = sizeZ * (i+1) / threadNumber;
	ppCThread[i]->CreateThread(&bAFinished[i], Zini, Zfin);
	ppCThread[i]->Run();
    }

    WaitThreadsAndDeleteFlag(bAFinished, threadNumber, 3);
    delete [] ppCThread;
}

void CLS::
GatherBooleanMask(unsigned char *pData, 
		  unsigned short *pData_ushort,
		  char *pMask,
		  int sizeX, int sizeY, int sizeZ){
    int threadNumber = 1;
    long long totalSize = (long long)sizeX * (long long)sizeY * (long long)sizeZ;
    if (totalSize >= (long long)1024 * 1024 * 8 && sizeZ > 2) threadNumber++;
    if (totalSize >= (long long)1024 * 1024 * 16 && sizeZ > 3) threadNumber++;
    if (totalSize >= (long long)1024 * 1024 * 32 && sizeZ > 4) threadNumber++;
    
    bool *bAFinished = new bool [threadNumber];
    
    ThreadVolumeBoolGather_cls **ppCThread = new ThreadVolumeBoolGather_cls* [threadNumber];
    
    for (int i = 0; i < threadNumber; i++){
	bAFinished[i] = FALSE;
	ppCThread[i] = new ThreadVolumeBoolGather_cls;
	ppCThread[i]->SetParameters(pData, pData_ushort,
				    pMask, sizeX, sizeY, sizeZ);
    }
    
    for (int i = 0; i < threadNumber; i++){
	int Zini = sizeZ * i / threadNumber;
	int Zfin = sizeZ * (i+1) / threadNumber;
	ppCThread[i]->CreateThread(&bAFinished[i], Zini, Zfin);
	ppCThread[i]->Run();
    }

    WaitThreadsAndDeleteFlag(bAFinished, threadNumber, 3);
    delete [] ppCThread;
}

#define CLS VolumeBooleanBuffer_cls

CLS::
VolumeBooleanBuffer_cls(BooleanBase_cls *pCSrc) : BooleanBufferBase_cls(pCSrc){
}


