// (setq-c-offset 4)
// "clsVolumeBoolean.cpp"

#ifndef _VOLUME_BOOLEAN_H
#define _VOLUME_BOOLEAN_H

#include "clsBooleanBase.h"

#include "../COMMON/clsThreadCommon.h"
#include "../FILEIO/clsAsciiReader.h"

class MeshObj_cls;
class MultiInputPanel_cls;
class Primitive_cls;
class ShaderStatusVolumeBoolean_cls;
class ViewerClone_cls;
class VolumeBooleanBuffer_cls;
class VolumeBox_cls;

class ThreadVolumeBoolGather_cls : public ThreadInstance_cls{
 public:
    void SetParameters(unsigned char *pData, unsigned short *pData_ushort,
		       char *pMask, 
		       int sizeX, int sizeY, int sizeZ);
    bool CreateThread(bool *pbFinishedFlag, int ZIni, int ZFin);

    unsigned char *mpData;
    unsigned short *mpData_ushort;

    char *mpMask;
    int mSizeX, mSizeY, mSizeZ, mZIni, mZFin;
    
    virtual ExitCode Entry();
};

class ThreadVolumeBooleanBase_cls : public ThreadInstance_cls {
 public:
    char *mpMask;
    int mSizeX, mSizeY, mSizeZ, mZIni, mZFin;
    int mType;

    bool CreateThread(bool *pbFinishedFlag, int ZIni, int ZFin);
};

class ThreadVolumeBooleanBox_cls : public ThreadVolumeBooleanBase_cls{
 public:
    void SetParameters(char *pMask, int sizeX, int sizeY, int sizeZ,
		       int type,
		       std::vector < double > VXMinMax,
		       std::vector < double > VYMinMax,
		       std::vector < double > VZMinMax);
    std::vector < double > mVXMinMax, mVYMinMax, mVZMinMax;
        
    virtual ExitCode Entry();
};

class ThreadVolumeBooleanSphere_cls : public ThreadVolumeBooleanBase_cls{
 public:
    void SetParameters(char *pMask, int sizeX, int sizeY, int sizeZ,
		       int type, float radius);
    float mRadius;
        
    virtual ExitCode Entry();
};

class ThreadVolumeBooleanPrimitive_cls : public TensorMath_cls, public ThreadVolumeBooleanBase_cls {
 public:
    void SetParameters(char *pMask, int sizeX, int sizeY, int sizeZ,
		       int type, Primitive_cls* pCPrimitive,
		       double matrix16[16], double matrix16TgtInv[16]);
    Primitive_cls *mpCPrimitive;
    double mMatrix16[16];
    double mMatrix16TgtInv[16];
    
    virtual ExitCode Entry();
};

class ThreadVolumeBooleanMesh_cls : public TensorMath_cls, public ThreadVolumeBooleanBase_cls {
 public:
    void SetParameters(char *pMask, int sizeX, int sizeY, int sizeZ,
		       int type, MeshObj_cls* pCMesh,
		       double matrix16[16], double matrix16TgtInv[16]);
    MeshObj_cls *mpCMesh;
    double mMatrix16[16];
    double mMatrix16TgtInv[16];
    
    virtual ExitCode Entry();
};

class VolumeBoolean_cls : public BooleanBase_cls, public AsciiReader_cls, public ThreadCommon_cls {
 public:
    VolumeBoolean_cls(wxString strName, wxString strObjName);
    
    // ł͂ȂăN[̒lQƂKvB
    static int GetThreadNumber(long long totalSize, int sizeZ, float factor = 1);
    static void SetBooleanMaskBox
	(AttributeClone_cls &CClone,
	 char *pMask, int sizeX, int sizeY, int sizeZ, double NT);
    static void SetBooleanMaskSphere
	(AttributeClone_cls &CClone,
	 char *pMask, int sizeX, int sizeY, int sizeZ, double NT);
    static void SetBooleanMaskPrimitive
	(AttributeClone_cls &CClone,
	 char *pMask, int sizeX, int sizeY, int sizeZ,
	 double matrix16[16], double matrix16TgtInv[16], SceneObj_cls *pCObj);
    static void SetBooleanMaskObject
	(AttributeClone_cls &CClone,
	 char *pMask, int sizeX, int sizeY, int sizeZ,
	 double matrix16[16], double matrix16TgtInv[16]);
    static void GatherBooleanMask(unsigned char *pData, 
				  unsigned short *pData_ushort,
				  char *pMask,
				  int sizeX, int sizeY, int sizeZ);
};

class VolumeBooleanBuffer_cls : public BooleanBufferBase_cls {
 public:
    VolumeBooleanBuffer_cls(BooleanBase_cls *pCSrc);
};

#endif
