// (setq-c-offset 4)
// "clsVolumeCoord.cpp"

#ifndef _VOLUME_COORD_H
#define _VOLUME_COORD_H

#include "clsModifierBase.h"

#include "../FILEIO/clsAsciiReader.h"
#include "../WIDGETCTRL/MULTIINPUT/clsHookCtrl.h"

class VolumeCoordBuffer_cls;
class MultiInputPanel_cls;
class SceneObj_cls;
class ShaderStatusVolumeCoord_cls;

class VolumeCoord_cls : public ModifierBase_cls, public AsciiReader_cls {
 public:
    VolumeCoord_cls(wxString strName, wxString strObjName);

    ConfItemUINT_cls mCCoordType;
    ConfItemSTR_cls  mCstrCustomCoord;
    
    void SyncFromBuffer(VolumeCoordBuffer_cls *pCBuffer, SceneObj_cls *pCObj);
    bool IsStatusChanged(ShaderStatusVolumeCoord_cls &CStatus);
    void SetStatus(ShaderStatusVolumeCoord_cls &CStatus);

    wxString GetStrSpherical(wxString &strFrag, wxString strTagFin,
			     int ini, int fin);
    wxString GetStrCustom(wxString &strFrag, wxString strTagFin,
			  int ini, int fin);
    wxString GetStrModifiedShader(wxString strFragSrc);

    static wxString smstrFunc;
};

class VolumeCoordBuffer_cls : public ModifierBase_cls {
 public:
    VolumeCoordBuffer_cls(VolumeCoord_cls *pCSrc);

    VolumeCoord_cls *mpCSrc;

    int mIndexRMinMax;
    int mIndexCustomParam;
    int mIndexEdit;
    
    ConfItemUINT_cls  mCCoordType;
    //ConfItemSTR_cls mCstrCustomCoord;
    ConfItemFLOAT_cls mCRMin, mCRMax;
    ConfItemFLOATARRAY_cls mCCustomParam;
    
    MultiInputPanel_cls *mpCMNumPanelLink;
    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);
    void SyncFromSrc();
    void ForceSrcToSyncBuffer(SceneObj_cls *pCObj);

    bool HideAndShow();
};

#endif
