// (setq-c-offset 4)
// "clsVolumeDownsize.h"

#include "clsVolumeDownsize.h"

#include "../WIDGETCTRL/MULTIINPUT/clsMultiInputPanel.h"

#include "../../wxWidgetEnum.h"

#define CLS VolumeDownsize_cls

CLS::
VolumeDownsize_cls(wxString strName, wxString strObjName) : ModifierBase_cls ("VolumeDownsize_cls", strName){
    
    wxString strUpdate = "VIEW3D::PROPERTY_DATAPROC";

    SetConfListTagForSceneObjAttribute(strName, strObjName);
    mCConfList.Add(&mCDownsizeX, "DownsizeX=", "2", strUpdate);
    mCConfList.Add(&mCDownsizeY, "DownsizeY=", "2", strUpdate);
    mCConfList.Add(&mCDownsizeZ, "DownsizeZ=", "2", strUpdate);
}

void CLS::
SyncFromBuffer(VolumeDownsizeBuffer_cls *pCBuffer, SceneObj_cls *pCObj){

    mCConfList.SyncFromCommand(pCBuffer->mCConfList);
}
    
#define CLS VolumeDownsizeBuffer_cls

CLS::
VolumeDownsizeBuffer_cls(VolumeDownsize_cls *pCSrc) : ModifierBase_cls(*pCSrc){
    mpCSrc = pCSrc;
    mCConfList.SetTag(pCSrc->mCConfList.mstrTag);

    mCConfList.Add(&mCDownsizeX, "DownsizeX=", "2");
    mCConfList.Add(&mCDownsizeY, "DownsizeY=", "2");
    mCConfList.Add(&mCDownsizeZ, "DownsizeZ=", "2");
}

MultiInputPanel_cls* CLS::
GetPCNewPanel(wxWindow *pCWindow){
    MultiInputPanel_cls *pC =
	new MultiInputPanel_cls(pCWindow, GetStrName(), TRUE);

    pC->CombineSizer(3, _("Downsize"));

    pC->SetLimit(1,16);
    pC->mDragScale = 3;
    pC->CombineConfItem(mCDownsizeX);
    pC->SetLimit(1,16);
    pC->mDragScale = 3;
    pC->CombineConfItem(mCDownsizeY);
    pC->SetLimit(1,16);
    pC->mDragScale = 3;
    pC->CombineConfItem(mCDownsizeZ);

    pC->FinishSetting();

    mpCMNumPanelLink = pC;
    return pC;
}

void CLS::
SyncFromSrc(){
    mCConfList.SyncFrom(mpCSrc->mCConfList);
}

void CLS::
ForceSrcToSyncBuffer(SceneObj_cls *pCObj){
    mpCSrc->SyncFromBuffer(this, pCObj);
}
