// "clsFBO.h"
// (setq c-basic-offset 4)

#ifndef _FBO_DRAW_H_
#define _FBO_DRAW_H_

#define _FBO_USE_RGBA true

#include "clsTextureBase.h"
#include "clsGLExtention.h"

#include "../COMMON/clsGetPC.h"

#include "../COMMON/CommonDefinitionsForH.h"
#include "../COMMON/CommonDefinitionsGL.h"

#define _FBO_ADD  true
#define _FBO_DRAW false

#include <vector>

class GLCanvas_cls;

class FBO_cls : public TextureBase_cls, public GLCheckError_cls, public GetPC_cls {
 public:
    FBO_cls(int width, int height, GLCanvas_cls *pCGLCanvasParent);
    ~FBO_cls();

    static void Initialize();
    static bool msbInitialized;
    static bool msbSupported;
    //static std::vector < FBO_cls* > msVpCStack;

    GLCanvas_cls *mpCGLCanvasParent;
    FBO_cls *mpCStackFBO;

    TextureBase_cls *mpCDepthTexture;

    int mWidthFBO, mHeightFBO;
    bool mbClear;
    bool mbGenerated;

    void SetGeometryFBO(int width, int height);
    void SetColorDepth(int depth);

    int mColorDepth;
    int mColorDepthGenerated;
    int mDepthIndexGenerated;
    bool mbAlphaGenerated;
    bool mbDepthTextureUsed;
    
    void MakeFBO(bool bUseRGBA = FALSE, bool bUseDepthTexture = FALSE);
    void ClearFBO();
    void Begin(bool bClear = TRUE, bool bCalledInFBOStack = FALSE);
    void End();

    void SetProjection();
    void SetFrustum(double degreeV, double min, double max);
    void SetOrtho(double sizeOrtho, double min, double max);

    GLuint mRBIdDepthStencil;
    GLuint mFBOId;

    float  GetLineWidthFactor();
    
};

#endif
