// "clsMainGLCanvas.h"
// (setq c-basic-offset 4)

#include "clsGLExtention.h"

#include "../COMMON/CommonDefinitionsGL.h"
#include "../COMMON/CommonDefinitions.h"

#include <stdio.h>

#include <wx/wx.h>

#define CLS GLExtentions_cls

#ifdef WIN32
PFNGLBINDBUFFERPROC glBindBuffer = NULL; 
PFNGLGENBUFFERSPROC glGenBuffers = NULL;
PFNGLDELETEBUFFERSPROC glDeleteBuffers = NULL;
PFNGLBUFFERDATAPROC glBufferData = NULL;

PFNGLGENFRAMEBUFFERSPROC glGenFramebuffers = NULL;
PFNGLDELETEFRAMEBUFFERSPROC glDeleteFramebuffers = NULL;
PFNGLBINDFRAMEBUFFERPROC glBindFramebuffer = NULL;
PFNGLFRAMEBUFFERTEXTURE2DPROC glFramebufferTexture2D = NULL;
PFNGLGENRENDERBUFFERSPROC glGenRenderbuffers = NULL;
PFNGLDELETERENDERBUFFERSPROC glDeleteRenderbuffers = NULL;
PFNGLBINDRENDERBUFFERPROC glBindRenderbuffer = NULL;
PFNGLRENDERBUFFERSTORAGEPROC glRenderbufferStorage = NULL;
PFNGLFRAMEBUFFERRENDERBUFFERPROC glFramebufferRenderbuffer = NULL;
PFNGLCHECKFRAMEBUFFERSTATUSPROC glCheckFramebufferStatus = NULL;
PFNGLBLITFRAMEBUFFERPROC glBlitFramebuffer = NULL;

PFNGLBLENDFUNCSEPARATEPROC glBlendFuncSeparate = NULL;
PFNGLTEXIMAGE3DPROC glTexImage3D = NULL;
PFNGLACTIVETEXTUREPROC glActiveTexture = NULL;
PFNGLCLAMPCOLORPROC glClampColor = NULL;
PFNGLPROGRAMPARAMETERIEXTPROC glProgramParameteri = NULL;
PFNGLVERTEXATTRIBIPOINTERPROC glVertexAttribIPointer = NULL;
PFNGLVERTEXATTRIBI1IPROC glVertexAttribI1i = NULL;

PFNGLCOPYIMAGESUBDATANVPROC glCopyImageSubData = NULL;
#endif

CLS::
GLExtentions_cls(){
    mbBlendFuncSeparate = TRUE;
}

void CLS::
InitializeFunctions(){
#ifdef WIN32
    glBindBuffer = (PFNGLBINDBUFFERPROC)wglGetProcAddress("glBindBuffer");
    glGenBuffers = (PFNGLGENBUFFERSPROC)wglGetProcAddress("glGenBuffers");
    glDeleteBuffers = (PFNGLDELETEBUFFERSPROC)wglGetProcAddress("glDeleteBuffers");
    glBufferData = (PFNGLBUFFERDATAPROC)wglGetProcAddress("glBufferData");

    glGenFramebuffers =(PFNGLGENFRAMEBUFFERSPROC)wglGetProcAddress("glGenFramebuffers");
    glDeleteFramebuffers = (PFNGLDELETEFRAMEBUFFERSPROC)wglGetProcAddress("glDeleteFramebuffers");
    glBindFramebuffer = (PFNGLBINDFRAMEBUFFERPROC)wglGetProcAddress("glBindFramebuffer");
    glFramebufferTexture2D = (PFNGLFRAMEBUFFERTEXTURE2DPROC)wglGetProcAddress("glFramebufferTexture2D");
    glGenRenderbuffers = (PFNGLGENRENDERBUFFERSPROC)wglGetProcAddress("glGenRenderbuffers");
    glDeleteRenderbuffers = (PFNGLDELETERENDERBUFFERSPROC)wglGetProcAddress("glDeleteRenderbuffers");
    
    glBindRenderbuffer = (PFNGLBINDRENDERBUFFERPROC)wglGetProcAddress("glBindRenderbuffer");
    glRenderbufferStorage = (PFNGLRENDERBUFFERSTORAGEPROC)wglGetProcAddress("glRenderbufferStorage");
    glFramebufferRenderbuffer = (PFNGLFRAMEBUFFERRENDERBUFFERPROC)wglGetProcAddress("glFramebufferRenderbuffer");
    glCheckFramebufferStatus = (PFNGLCHECKFRAMEBUFFERSTATUSPROC)wglGetProcAddress("glCheckFramebufferStatus");
    //if (glCheckFramebufferStatusEXT == NULL) msbSupported = FALSE;

    glBlitFramebuffer = (PFNGLBLITFRAMEBUFFERPROC)wglGetProcAddress("glBlitFramebuffer");

    glBlendFuncSeparate = (PFNGLBLENDFUNCSEPARATEPROC) wglGetProcAddress("glBlendFuncSeparate");
    if (glBlendFuncSeparate == NULL) mbBlendFuncSeparate = FALSE;
    
    glTexImage3D = (PFNGLTEXIMAGE3DPROC) wglGetProcAddress("glTexImage3D");

    glActiveTexture = (PFNGLACTIVETEXTUREPROC) wglGetProcAddress("glActiveTexture");

    glClampColor = (PFNGLCLAMPCOLORPROC)wglGetProcAddress("glClampColor");

    glProgramParameteri = (PFNGLPROGRAMPARAMETERIEXTPROC)wglGetProcAddress("glProgramParameteri");
    
    glVertexAttribIPointer = (PFNGLVERTEXATTRIBIPOINTERPROC)wglGetProcAddress("glVertexAttribIPointer");
    
    glVertexAttribI1i = (PFNGLVERTEXATTRIBI1IPROC)wglGetProcAddress("glVertexAttribI1i");

    glCopyImageSubData = (PFNGLCOPYIMAGESUBDATANVPROC)wglGetProcAddress("glCopyImageSubData");
#endif
}

void CLS::
BlendFuncSeparate(int arg1, int arg2, int arg3, int arg4){
    if (mbBlendFuncSeparate == TRUE)
	glBlendFuncSeparate(arg1, arg2, arg3, arg4);
    else
	glBlendFunc(arg1, arg2);
}

void CLS::
ClampColor(int arg1){
    if (glClampColor != NULL){
	glClampColor(GL_CLAMP_READ_COLOR, arg1);
	glClampColor(GL_CLAMP_VERTEX_COLOR, arg1);
	glClampColor(GL_CLAMP_FRAGMENT_COLOR, arg1);
    }
}

bool GLCheckError_cls::
CheckGLError(const char *tag) {
    
    //݂̑X^bÑTCY
    int stacksize = 0;
    glGetIntegerv(GL_ATTRIB_STACK_DEPTH, &stacksize); 

    GLenum error_code= glGetError();
    if( error_code != GL_NO_ERROR){
	/*
	printf("error=%d at %s\n", error_code, tag);
	fflush(stdout);
	*/

	wxString strErrType;
	switch( error_code ){
        case GL_INVALID_ENUM:      strErrType = "INVALID_ENUM";      break;
        case GL_INVALID_VALUE:     strErrType = "INVALID_VALUE";     break;
        case GL_INVALID_OPERATION: strErrType = "INVALID_OPERATION"; break;
        case GL_OUT_OF_MEMORY:     strErrType = "OUT_OF_MEMORY";     break;
        case GL_INVALID_FRAMEBUFFER_OPERATION:  strErrType = "INVALID_FRAMEBUFFER_OPERATION"; break;
        default:  strErrType = "Unknown"; break;
	}
	    
	wxString strLog = "error = "; strLog << error_code << "::" << strErrType << "::" << tag << ENDL;
	wxLogMessage(strLog);
	return FALSE;
    }

    return TRUE;
}

GLExtentions_cls *GpCGLExtention = NULL;
