// -*- c -*-
// "clsGLPerspective.cpp"
// (setq c-basic-offset 4)

#ifndef _GL_PERSPECTIVE_H_
#define _GL_PERSPECTIVE_H_

#include "clsPosition.h"

class GLPerspective_cls{ 
 public:
    static void GetWindowCoordv(double pos[3], double winPos[3]);
    
    static void SetFrustum(int width, int height, double degreeV,
			   double min, double max);
    static void SetFrustumTiled(int width, int height, double degreeV,
				double min, double max,
				int tileMaxX, int tileMaxY,
				int tileIndexX, int tileIndexY);
    static void SetFrustumPartial(int width, int height, double degreeV,
				  double min, double max,
				  double posX, double posY, double part);
    static void SetOrthoTiled(double sizeOrtho,
			      double min, double max,
			      int tileMaxX, int tileMaxY,
			      int tileIndexX, int tileIndexY);
    static double GetScaleForFixSizedObject(float matrixA[16],
					    float matrixB[16]);

    static void SetProjection(int width, int height);
    static void SetModelView(Position_cls CPos, Direction_cls CDir);

    
    
    static void Push2DMatrix(int width, int height);
    static void Pop2DMatrix();

};

#endif
