// -*- c++ -*-
// (setq c-basic-offset 4)
// "clsShadowVolumeCtrl.cpp"

#ifndef _SHADOWVOLUME_CTRL_H
#define _SHADOWVOLUME_CTRL_H

#include "../COMMON/clsGetPC.h"
#include "../CONFITEM/clsConfItem.h"
#include "../CONFITEM/clsConfListContainer.h"

class FBO_cls;
class SceneObj_cls;

class ShadowVolumeCtrl_cls : public ConfListContainer_cls, public GetPC_cls {
 public:
    ShadowVolumeCtrl_cls();
    ~ShadowVolumeCtrl_cls();

    void SetToDefaultParam();

    ConfItemBOOL_cls mCbUseShadowVolume;
    ConfItemFLOAT_cls mCShadowLength;
    ConfItemFLOAT_cls mCOffsetFactor;
    ConfItemBOOL_cls mCbUseGammaForSV;
    ConfItemBOOL_cls mCbForClosed;
    ConfItemBOOL_cls mCbClipCheck;
    ConfItemBOOL_cls mCbTransparentShadowForEnsemble;

    int mSVIni;    
    int mSVStep;
    int mSVState;
    //int mEnsembleSampleNum;
    FBO_cls *mpCFBOBuffer;

    void ClearFBOBuffer();
    void SetShadowVolumeStep(int shadowVolumeStep, int shadowVolumeIni);
    //void SetEnsembleSampleNum(int ensembleSampleNum);
    int GetShadowVolumeSampleIni();
    int GetShadowVolumeSampleNum();
    bool IsFirstStep();
    bool IsSkip(float alpha, int ensemble, SceneObj_cls *pCObj, 
		int offsetBase = 0);

    void PushState();
    void SetStencilState();
    void SettingFront();
    void SettingBack();
    void SetShadowedArea();
    void PopState();

    void BeginShader();
    void SetCullingSide(int step);
    void BeginShaderHF();
    void SetCullingSideHF(int step);
    void EndShader();

    void PrepareBuffer(FBO_cls *pCFBOSrc);
    void DrawOnBuffer(FBO_cls *pCFBOSrc);
    void DrawFromBuffer(FBO_cls *pCFBOTgt);
};

#endif
