// "clsTextureBase.h"
// (setq c-basic-offset 4)

#include "clsTextureBaseBase.h"

#include "../COMMON/CommonDefinitionsGL.h"
#include "../COMMON/CommonDefinitions.h"

#define CLS TextureBaseBase_cls

CLS::
TextureBaseBase_cls(int textureDimension) : 
    mTextureDimension(textureDimension){
    mTextureID = 0;
    mWidthTex = 0;
    mHeightTex = 0;

    mTagCounter = 0;
    mTextureID = 0;
    mTexWrap = GL_CLAMP;
    mMinFilter = GL_LINEAR;
    mMagFilter = GL_LINEAR;
    mDepth = 0;
}

CLS::
~TextureBaseBase_cls()  {
    if (mTextureID != 0)
	glDeleteTextures(1, &mTextureID);
}

bool CLS::
ClearImage(){
    if (mTextureID != 0){
	glDeleteTextures(1, &mTextureID);
	mTextureID = 0;
	mDepth = 0;
	mWidthTex = 0;
	mHeightTex = 0;
	return TRUE;
    }
    return FALSE;
}


int CLS::
GetByte(){
    return mWidthTex * mHeightTex * mDepth / 8 * 3;
}

void CLS::
SetAlignment(int width){
    if (width % 8 == 0)
	glPixelStorei(GL_UNPACK_ALIGNMENT, 8);
    else if (width % 4 == 0)
	glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
    else if (width % 2 == 0)
	glPixelStorei(GL_UNPACK_ALIGNMENT, 2);
    else
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
}

// mTextureDimension = GL_TEXTURE_2D or GL_TEXTURE_1D

void CLS::
GenerateAndBindTexture(){
    glGenTextures(1, &mTextureID);
    glBindTexture(mTextureDimension, mTextureID);
}

void CLS::
BindTexture(){
    glBindTexture(mTextureDimension, mTextureID);
}

void CLS::
SetEmptyImage(){
    if (mTextureID == 0)
	glGenTextures(1, &mTextureID);

    glBindTexture(mTextureDimension, mTextureID);

    //glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, mTexWrap);
    //glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, mTexWrap);
    glTexParameteri(mTextureDimension, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameteri(mTextureDimension, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

    unsigned char buf[4] = {0, 0, 0, 0};
    switch(mTextureDimension){
    case GL_TEXTURE_1D:
	glTexImage1D(GL_TEXTURE_1D, 0, GL_RGBA,
		     1, 0,
		     GL_RGBA, GL_UNSIGNED_BYTE, buf);
	break;
    case GL_TEXTURE_2D:
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA,
		     1, 1, 0,
		     GL_RGBA, GL_UNSIGNED_BYTE, buf);
	break;
    }

    mWidthTex  = 1;
    mHeightTex = 1;
    mDepth     = 8;
    
}
