// -*- c++ -*- 
// "clsTexturePrivoder.h"
// (setq c-basic-offset 4)

#include "clsTextureProvider1D.h"

#include "../MYGL/clsGLTexture1D.h"
#include "../PREFERENCE/clsPreference.h"

#include "../COMMON/CommonDefinitions.h"
#include "../COMMON/CommonDefinitionsGL.h"

#ifdef WIN32
extern PFNGLACTIVETEXTUREPROC glActiveTexture;
#endif

#define CLS TextureProvider1D_cls

CLS::
TextureProvider1D_cls(){
    mCounter = 0;
    mUsedMemoryByte = 0;
}

CLS::
~TextureProvider1D_cls(){
    ClearAll();
}

void CLS::
ClearAll(){
    uint num = mVpCGLTexture.size();
    for (uint i = 0; i < num; i++)
	delete mVpCGLTexture[i];
    mVpCGLTexture.clear();
    mUsedMemoryByte = 0;
}

unsigned char* CLS::
GetPNewColorData(wxString strColor){
    unsigned char *pData = new unsigned char [8*4];
    const char *ptr = strColor.c_str();
    unsigned char R = ReadInt(&ptr, ':'); ptr++;
    unsigned char G = ReadInt(&ptr, ':'); ptr++;
    unsigned char B = ReadInt(&ptr, ':'); ptr++;
    unsigned char A = ReadInt(&ptr, ':'); ptr++;

    for (int idx = 0; idx < 8; idx++){
	pData[idx*4+0] = R;
	pData[idx*4+1] = G;
	pData[idx*4+2] = B;
	pData[idx*4+3] = A;
    }
    
    return pData;
}

int CLS::
BindTexture1D(wxString strImagePath){
    
    uint num = mVpCGLTexture.size();
    for (uint i = 0; i < num; i++){
	if (mVpCGLTexture[i]->mstrImageLoaded.IsSameAs(strImagePath)){
	    mVpCGLTexture[i]->BindTexture();
	    return i;
	}
    }

    GLTexture1D_cls *pCGLTexture = new GLTexture1D_cls;

    if (strImagePath.Mid(0, 3).IsSameAs("***")){
	unsigned char *pData = GetPNewColorData(strImagePath.Mid(3));
	pCGLTexture->CopyFromDataRGBA(pData, 8);
	pCGLTexture->mstrImageLoaded = strImagePath;
	delete pData;
    }
    else
	;//pCGLTexture->LoadImage(strImagePath, TRUE);
    
    mVpCGLTexture.push_back(pCGLTexture);

    mUsedMemoryByte += pCGLTexture->GetByte(); 

    pCGLTexture->BindTexture();
    //pCGLTexture->mTagCounter = mCounter;
    //mCounter++;
    //ReleaseOldImages(); 

    return mVpCGLTexture.size()-1;
}

void CLS::
BindColorTexture1D(float R, float G, float B, float A, int active){

    switch(active){
    case 0:
	glActiveTexture(GL_TEXTURE0); break;
    case 1:
	glActiveTexture(GL_TEXTURE1); break;
    case 2:
	glActiveTexture(GL_TEXTURE2); break;
    case 3:
	glActiveTexture(GL_TEXTURE3); break;
    }

    int iR = R * 255, iG = G*255, iB = B * 255, iA = A*255;
    wxString strColor = "***";
    strColor << iR << ":" << iG << ":" << iB << ":" << iA << ":";
    BindTexture1D(strColor);
    
    glTexParameteri(GL_TEXTURE_1D, GL_TEXTURE_WRAP_S , GL_CLAMP_TO_EDGE);
    //glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T , GL_CLAMP_TO_EDGE);
    glActiveTexture(GL_TEXTURE0);
}

TextureProvider1D_cls *GpCTextureProvider1D = NULL;
