// (setq c-basic-offset 4)
// "clsKeyFrame.cpp"

#ifndef _KEYFRAME_H
#define _KEYFRAME_H

#include "../COMMON/clsGetPC.h"
#include "../FILEIO/clsParser.h"

#include <wx/wx.h>

class TLPanelGeom_cls;

#define _KEY_STEP         0
#define _KEY_LINEAR       1
#define _KEY_HERMITE_AUTO 2

class KeyFrame_cls : public Parser_cls, public GetPC_cls {
public:
    KeyFrame_cls();
    KeyFrame_cls(wxString& strInit);

    bool mbSelected, mbActive, mbLocked;
    double mXNormalized, mValue, mEaseFactor;
    long mKeyType;
    
    double mVelocityCache;

    wxIcon* GetPCIcon(bool bSelected, bool bLocked);

    bool Select(double posX, double resolution, bool bSelect);
    bool DrawTL(wxDC &dc, TLPanelGeom_cls* pCGeom,
		int sashX, int panelWidth, int height,
		int& posX, int index);
    void DrawTLGhost(wxDC &dc, TLPanelGeom_cls* pCGeom,
		   int sashX, int panelWidth, int height, double dX);
    void DrawKey(wxDC &dc, int posX, int posY);
    void DrawKeyGhost(wxDC &dc, int posX, int posY);
    
    bool ReadStrOneLiner(wxString strFirstItem, wxString strLine);
    
    void Serialize(wxString &strOut);
    void ReadStrLine(wxString strLine);

    int operator < (KeyFrame_cls rhs) const{
	return (mXNormalized < rhs.mXNormalized); }
    int operator <= (KeyFrame_cls rhs) const{
	return (mXNormalized <= rhs.mXNormalized); }
    int operator > (KeyFrame_cls rhs) const{
	return (mXNormalized > rhs.mXNormalized);}
    int operator >= (KeyFrame_cls rhs) const{
	return (mXNormalized >= rhs.mXNormalized);}
};

#endif
