// (setq c-basic-offset 4)
// "clsParamGroup.cpp"

#ifndef _PARAM_GROUP_H_
#define _PARAM_GROUP_H_

#include "clsParameter.h"
#include "clsParamDrawTLBase.h"

#include "../CONFITEM/clsConfListContainer.h"
#include "../CONFITEM/clsStrName.h"
#include "../COMMON/clsGetPC.h"
#include "../LUA/clsLuaBase.h"

#include <wx/wx.h>
#include <vector>

class TLPanelGeom_cls;

class ParamGroup_cls : public ParamDrawTLBase_cls, public LuaBase_cls, virtual public ConfListContainer_cls, virtual public GetPC_cls, virtual public StrName_cls {
 public:
    ParamGroup_cls(wxString strName, wxArrayString AstrItemName);
    ~ParamGroup_cls();
    ConfItemBOOL_cls mCbLinked;
    ConfItemBOOL_cls mCbShy, mCbExpression;
    ConfItemSTR_cls mCstrExpression;
    
    int mReferenceCounter;
    
    bool mbForColorCurve;
    wxString mstrExpressionDefined;

    std::vector < Parameter_cls > mVCParam;
    Parameter_cls* GetPCParameter(wxString strTag);

    wxString GetStrProcCounter();
    wxString GetStrMemberListCSV();
    wxString GetStrExpressionMessage();
    void CheckTag(wxString& strTag);
    void PrecalcBegin();
    void PrecalcEnd();
    void OpenLua(ParamGroup_cls *pCInit);
    void CloseLua();
    std::vector < double > CallLuaExpression(std::vector < double > VOrg, double NT);
    std::vector < double > GetVExpression(double Xnormalized, std::vector < double > VOrg, ParamGroup_cls *pCInit, bool bFromExpression);
    std::vector < double > GetVInterpolatedValue(double Xnormalized, bool bUseExpression = TRUE, ParamGroup_cls *pCInit = NULL, bool bFromExpression = FALSE);
    std::vector < float > GetVInterpolatedValue(float Xnormalized, bool bUseExpression = TRUE, ParamGroup_cls *pCInit = NULL, bool bFromExpression = FALSE);
    bool IsTimeDepend();
    bool IsSelectedKeyExist();
    bool IsKeyExistAll(double Xnormalized);
    wxString GetStrValues(double Xnormalized, bool bUseExpression = TRUE);
    void SetInitValue(double v0, double v1 = 0, double v2 = 0, double v3 = 0);
    void SetInitKeyframes(int keynum, double (*comp)[5]);
    
    bool CheckCalledAsLink(wxString& strTag);
    void SetNewKeyCommand(double newValue, double Xnormalized, wxString strTag,
			  int keyType, double easeFactor);
    void InsertKeyCommand(double Xnormalized, wxString strTag, 
			  int keyType, double easeFactor);
    void DeleteKeyCommand(double Xnormalized, wxString strTag);
    void DeleteSelectedTLKeyCommand(wxString strTag);
    void SetSelectedTLKeyTypeCommand(wxString strTag, int keyType, double ease);
    void MoveSelectedTLKeyCommand(double dNX, double dY, wxString strTag);
    //void SetExpression(wxString strNewExpression, wxString strTag);
    void RescaleParametersCommand(double scale, wxString strTag);

    bool ChangeKeyTypeByModKey(wxString strTag, double posX, int newKeyType,
			       double resolution = _RES_DEFAULT);
    void DeselectKey(wxString strException);
    bool SelectKey(double posX, bool bSelect, bool bAdditional, 
		   double resolution = _RES_DEFAULT);
    void SelectKeyAll();

    void Flip();
    void SwapRGB();

    void DrawTL(wxDC& dc, TLPanelGeom_cls* pCGeom,
		wxBitmap &CBitmapBuffer, 
		int sashX, int posY, int width, int height,
		double normalizedWAMin, double normalizedWAMax);

    void Serialize(wxString& strOut);
    bool ReadStrOneLiner(wxString strFirstItem, wxString strLine);
    bool ReadStrLine(std::wistream &istream,
		     wxString strFirstItem, wxString strLine);
};

#endif
