// (setq c-basic-offset 4)
// "clsMousePreference.h"

#include "clsMousePreference.h"

#define CLS MousePreference_cls

CLS::
MousePreference_cls(){
    SetToDefault();
}

void CLS::
SetToDefault(){
    ConfItemList_cls *pCList = &mCConfList;
    pCList->Clear();
    pCList->SetTag(wxT("MousePreference"));

    switch(0){
    case 0:
	pCList->Add(&mCGyrationMouse,   "GYRATION=",        "0");
	pCList->Add(&mCbGyrationMod,    "GYRATION_MOD=",    "0 0 0");
	pCList->Add(&mCbGyrationInvert, "GYRATION_INVERT=", "0 ");
	pCList->Add(&mCZoomMouse,       "ZOOM=",            "1");
	pCList->Add(&mCbZoomMod,        "ZOOM_MOD=",        "0 0 0");
	pCList->Add(&mCbZoomInvert,     "ZOOM_INVERT=",     "0");
	pCList->Add(&mCCenterMouse,     "CENTER=",          "0");
	pCList->Add(&mCbCenterMod,      "CENTER_MOD=",      "1 1 0");
	pCList->Add(&mCItemMouse,       "ITEM=",            "0");
	pCList->Add(&mCbItemMod,        "ITEM_MOD=",        "1 0 0");
	pCList->Add(&mCItemSnapMouse,   "ITEMSNAP=",        "0");
	pCList->Add(&mCbItemSnapMod,    "ITEMSANP_MOD=",    "1 0 1");
	pCList->Add(&mCItemSnapMouse,   "ITEMSNAP=",        "1 0 1");
	pCList->Add(&mCMenuMouse,       "MENU=",            "2");
	pCList->Add(&mCbMenuMod,        "MENU_MOD=",        "0 0 0");
	pCList->Add(&mCHitTestMouse,    "HITTEST=",         "2");
	pCList->Add(&mCbHitTestMod,     "HITTEST_MOD=",     "1 0 0");
	pCList->Add(&mCHitTestAdditiveMouse, "HITTEST_ADD=","2");
	pCList->Add(&mCbHitTestAdditiveMod,  "HITTEST_ADD_MOD=", "1 0 1");
	pCList->Add(&mCInertiaMouse,    "INERTIA=",         "0");
	pCList->Add(&mCbInertiaMod,     "INERTIA_MOD=",     "0 1 0");
	pCList->Add(&mCMButtonEmulate,  "MBUTTON_EMULATE=", "2");
	break;
    case 1:
	pCList->Add(&mCGyrationMouse,   "GYRATION=",          "1");
	pCList->Add(&mCbGyrationMod,    "GYRATION_MOD=",      "0 0 0");
	pCList->Add(&mCbGyrationInvert, "GYRATION_INVERT=",   "0");
	pCList->Add(&mCZoomMouse,       "ZOOM=",              "1");
	pCList->Add(&mCbZoomMod,        "ZOOM_MOD=",          "0 1 0");
	pCList->Add(&mCbZoomInvert,     "ZOOM_INVERT=",       "1");
	pCList->Add(&mCCenterMouse,     "CENTER=",            "1");
	pCList->Add(&mCbCenterMod,      "CENTER_MOD=",        "1 0 0");
	pCList->Add(&mCItemMouse,       "ITEM=",              "0");
	pCList->Add(&mCbItemMod,        "ITEM_MOD=",          "0 0 0");
	pCList->Add(&mCItemSnapMouse,   "ITEMSNAP=",          "0");
	pCList->Add(&mCbItemSnapMod,    "ITEMSANP_MOD=",      "0 0 1");
	pCList->Add(&mCMenuMouse,       "MENU=",              "2");
	pCList->Add(&mCbMenuMod,        "MENU_MOD=",          "1 0 0");
	pCList->Add(&mCHitTestMouse,    "HITTEST=",           "2");
	pCList->Add(&mCbHitTestMod,     "HITTEST_MOD=",       "0 0 0");
	pCList->Add(&mCHitTestAdditiveMouse, "HITTEST_ADD=",  "2");
	pCList->Add(&mCbHitTestAdditiveMod,  "HITTEST_ADD_MOD=", "1 0 0");
	pCList->Add(&mCInertiaMouse,    "INERTIA=",           "0");
	pCList->Add(&mCbInertiaMod,     "INERTIA_MOD=",       "0 1 0");
	pCList->Add(&mCMButtonEmulate,  "MBUTTON_EMULATE=",   "2");
	break;
    }
}

bool CLS::
IsMiddleButton(int btn, int mod){
    if (btn == _MOUSE_BTN_LEFT && mod == mCMButtonEmulate.GetBodyINT())
	return TRUE;
    return FALSE; 
}


// {^sꍇ
void CLS::
ModulateBTN(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[0] == TRUE){
	if (bAModifier[mCMButtonEmulate.GetBodyINT()] == TRUE){
	    bAMouseBTN[_MOUSE_BTN_LEFT] = FALSE;
	    bAMouseBTN[_MOUSE_BTN_MIDDLE] = TRUE;
	}
	bAModifier[mCMButtonEmulate.GetBodyINT()] = FALSE;
    }
}

bool CLS::
IsMouse4Gyration(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCGyrationMouse.GetBodyINT()] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++){
	bool condition = mCbGyrationMod.GetBodyBOOLARRAY()[i];
	if (i == mCMButtonEmulate.GetBodyINT()) condition = FALSE;
	if (bAModifier[i] != condition) return FALSE;
    }
    return TRUE;
}

bool CLS::
IsMouse4Zoom(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCZoomMouse.GetBodyINT()] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++)
	if (bAModifier[i] != mCbZoomMod.GetBodyBOOLARRAY()[i]) return FALSE;
    return TRUE;
}

bool CLS::
IsMouse4MoveCenter(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCCenterMouse.GetBodyINT()] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++){
	bool condition = mCbCenterMod.GetBodyBOOLARRAY()[i];
	if (i == mCMButtonEmulate.GetBodyINT()) condition = FALSE;
	if (bAModifier[i] != condition) return FALSE;
    }
    return TRUE;
}

bool CLS::
IsMouse4MoveItemBase(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCItemMouse.GetBodyINT()] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++){
	bool condition = mCbItemMod.GetBodyBOOLARRAY()[i];
	if (i == mCMButtonEmulate.GetBodyINT()) condition = FALSE;
	if (bAModifier[i] != condition) return FALSE;
    }
    return TRUE;
}

bool CLS::
IsMouse4MoveItemSnap(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCItemSnapMouse.GetBodyINT()] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++){
	bool condition = mCbItemSnapMod.GetBodyBOOLARRAY()[i];
	if (i == mCMButtonEmulate.GetBodyINT()) condition = FALSE;
	if (bAModifier[i] != condition) return FALSE;
    }
    return TRUE;
}

bool CLS::
IsMouse4MoveItem(bool bAModifier[4], bool bAMouseBTN[4]){
    return 
	IsMouse4MoveItemBase(bAModifier, bAMouseBTN) |
	IsMouse4MoveItemSnap(bAModifier, bAMouseBTN) ;
}

bool CLS::
IsMouse4Menu(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCMenuMouse.GetBodyINT()] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++)
	if (bAModifier[i] != mCbMenuMod.GetBodyBOOLARRAY()[i])
	    return FALSE;
    return TRUE;
}

bool CLS::
IsMouse4HitTest(bool bAModifier[4], bool bAMouseBTN[4]){
    int btn = mCHitTestMouse.GetBodyINT();
    if (bAMouseBTN[btn] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++){
	bool condition = mCbHitTestMod.GetBodyBOOLARRAY()[i];
	if (IsMiddleButton(btn, i) == TRUE) condition = FALSE;
	if (bAModifier[i] != condition) return FALSE;
    }
    return TRUE;
}

bool CLS::
IsMouse4HitTestAdditive(bool bAModifier[4], bool bAMouseBTN[4]){
    int btn = mCHitTestAdditiveMouse.GetBodyINT();
    if (bAMouseBTN[btn] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++){
	bool condition = mCbHitTestAdditiveMod.GetBodyBOOLARRAY()[i];
	if (IsMiddleButton(btn, i) == TRUE) condition = FALSE;
	if (bAModifier[i] != condition) return FALSE;
    }
    return TRUE;
}

bool CLS::
IsMouse4Inertia(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCInertiaMouse.GetBodyINT()] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++){
	bool condition = mCbInertiaMod.GetBodyBOOLARRAY()[i];
	if (i == mCMButtonEmulate.GetBodyINT()) condition = FALSE;
	if (bAModifier[i] != condition) return FALSE;
    }
    return TRUE;
}

MousePreference_cls* GpCMousePreference;
