// (setq c-basic-offset 4)
// "clsMousePreference.cpp"

#ifndef _MOUSE_PREFERENCE_H_
#define _MOUSE_PREFERENCE_H_

#include "../CONFITEM/clsConfItem.h"
#include "../CONFITEM/clsConfListContainer.h"

#define _MOUSE_BTN_LEFT   0
#define _MOUSE_BTN_MIDDLE 1
#define _MOUSE_BTN_RIGHT  2

class MousePreference_cls : public ConfListContainer_cls {
 public:
    MousePreference_cls();

    void SetToDefault();

    ConfItemUINT_cls       mCGyrationMouse;
    ConfItemBOOLARRAY_cls  mCbGyrationMod;
    ConfItemUINT_cls       mCZoomMouse;
    ConfItemBOOLARRAY_cls  mCbZoomMod;
    ConfItemUINT_cls       mCCenterMouse;
    ConfItemBOOLARRAY_cls  mCbCenterMod;
    ConfItemUINT_cls       mCItemMouse;
    ConfItemBOOLARRAY_cls  mCbItemMod;
    ConfItemUINT_cls       mCItemSnapMouse;
    ConfItemBOOLARRAY_cls  mCbItemSnapMod;
    ConfItemUINT_cls       mCMenuMouse;
    ConfItemBOOLARRAY_cls  mCbMenuMod;

    ConfItemUINT_cls       mCHitTestMouse;
    ConfItemBOOLARRAY_cls  mCbHitTestMod;
    ConfItemUINT_cls       mCHitTestAdditiveMouse;
    ConfItemBOOLARRAY_cls  mCbHitTestAdditiveMod;
    ConfItemUINT_cls       mCInertiaMouse;
    ConfItemBOOLARRAY_cls  mCbInertiaMod;

    ConfItemBOOL_cls       mCbZoomInvert, mCbGyrationInvert;    
    ConfItemUINT_cls       mCMButtonEmulate;

    bool IsMiddleButton(int btn, int mod);
    
    void ModulateBTN     (bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4Gyration(bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4Zoom    (bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4MoveCenter(bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4MoveItemBase(bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4MoveItemSnap(bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4MoveItem(bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4Menu    (bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4HitTest (bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4HitTestAdditive (bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4Inertia  (bool bAModifier[4], bool bAMouseBTN[4]);
};

#endif
