// -*- c -*-
// "clsPreference.h"

#include "clsPreference.h"
#include "clsPreferenceGUI.h"

#include "../COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;

Preference_cls::
Preference_cls(){
    mpCGUI = NULL;
    SetToDefaultParam();
}

void Preference_cls::
SetToDefaultParam(){
    
    mCConfList.Clear();

    wxString strUpdate = "VIEW3D";
    
    mCConfList.SetTag("Preference");
    mCConfList.Add(&mCGZQuality, "PrefGZQuality=", "0");
    mCConfList.Add(&mCShortcutTemplate, "PrefShortcutTemplate=", "1");
    mCConfList.Add(&mCTextShortcutTemplate, "PrefTextShortcutTemplate=", "1");
    mCConfList.Add(&mCGLDepthIndex, "GLDepthIndex=", "0");
    mCConfList.Add(&mCGLDepthMin, "GLDepthMin=", "0.01", strUpdate);
    mCConfList.Add(&mCGLDepthMax, "GLDepthMax=", "1000", strUpdate);
    mCConfList.Add(&mCstrTest, "PrefStrTest=", "strTest");
    mCConfList.Add(&mCMemoryLimitMB, "MemoryLimitMB=", "1024");
    mCConfList.Add(&mCMemoryLimitTexMB, "MemoryLimitTexMB=", "512");
    mCConfList.Add(&mCPrefetchLength, "PrefetchLength=", "10");
    mCConfList.Add(&mCParticleMax, "ParticleMax=", "20000");
    mCConfList.Add(&mCParticleVBOMax, "ParticleVBOMax=", "2000");
    mCConfList.Add(&mCbRelativePath, "RelativePath=", "0");
    mCConfList.Add(&mCParamForDebugINT, "ParamForDebugInt=", "1");
    mCConfList.Add(&mCbToolTip, "ToolTip=", "1");
    
}

PreferenceGUI_cls* Preference_cls::
GetPCGUI(){
    return (PreferenceGUI_cls*)mpCGUI;
}

void Preference_cls::
InitGUI(){
    mpCGUI = new PreferenceGUI_cls(this, GCClassProvider.GetPCwxWindowTop());
}

void Preference_cls::
UpdatePanels(wxString strPanelTag){
    if (GetPCGUI() != NULL)
	GetPCGUI()->UpdatePanels(strPanelTag);
}

Preference_cls* GpCPreference;
