// -*- c -*-
// "clsPreferenceGUI.h"
// (setq c-basic-offset 4)

#include "clsPreferenceGUI.h"
#include "clsPreference.h"
#include "clsMousePreference.h"

#include "../COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;
#include "../PREFERENCE/clsShortcut.h"
#include "../WIDGETCTRL/EX/clsListCtrlEX.h"
#include "../WIDGETCTRL/MULTIINPUT/clsMultiInputPanel.h"
#include "../WIDGETCTRL/WX/myArtProv.h"
#include "../WIDGETCTRL/WX/clsFontProvider.h"

#include "../WIDGETCTRL/WX/myArtProv.h"

#define CLS PreferenceGUI_cls

// ÓIɃCxgт
BEGIN_EVENT_TABLE(CLS, wxFrameEX)
EVT_CLOSE(CLS::OnClose)
EVT_LIST_ITEM_ACTIVATED(wxID_ANY, CLS::OnListClick)
EVT_SIZE(CLS::OnSize)
END_EVENT_TABLE()

/*
void CLS::
OnSizeA(wxSizeEvent& event){
  printf("SizeA\n");
  event.Skip();
}
*/

CLS::
PreferenceGUI_cls(Preference_cls* pCCtrlLink, wxWindow *pC) :
wxFrameEX(pC, wxID_ANY, _("Preference"), wxDPS, ARTWX("wxART_PREFERENCE"), wxCLOSE_BOX | wxCAPTION | wxCLIP_CHILDREN) {
  
    mpCCtrlLink = pCCtrlLink;

    wxBoxSizer    *pBoxSizerSrc  = new wxBoxSizer(wxVERTICAL);
    
    mpCBook = new wxNotebook(this, wxID_ANY);
    mpCBook->SetFont(FontProvider_cls::GetFont(0));

    SetMNumMouseParam();
    mpCBook->AddPage(mpCMNumMouseParam, _("Mouse"));

    wxSize bestSize = mpCMNumMouseParam->GetBestSize();
    int listCtrlWidth = bestSize.GetWidth();
    int listCtrlHeight = bestSize.GetHeight();

    SetMNumPerformance();
    mpCBook->AddPage(mpCMNumPerformance, _("Performance"));
    
    SetMNumGL();
    mpCBook->AddPage(mpCMNumGL, "GL");

    mpCShortcutPanel = new wxPanel(mpCBook, wxID_ANY, wxDefaultPosition, wxSize(listCtrlWidth, listCtrlHeight));

    SetMNumShortcut(mpCShortcutPanel);
    wxBoxSizer *pBoxSizerShortcut = new wxBoxSizer(wxVERTICAL);

    mpCListCtrlShortcut = new wxListCtrlEX
      (mpCShortcutPanel, wxID_ANY, wxDPS, 
       wxLC_REPORT | wxSUNKEN_BORDER);
    
    GCClassProvider.GetPCShortcut()->SetList(mpCListCtrlShortcut);

    pBoxSizerShortcut->Add( mpCMNumShortcut, 0, wxEXPAND);    
    pBoxSizerShortcut->Add( mpCListCtrlShortcut, 1, wxEXPAND);

    mpCShortcutPanel->SetSizerAndFit(pBoxSizerShortcut);

    mpCTextShortcutPanel = new wxPanel(mpCBook, wxID_ANY, wxDefaultPosition, wxSize(listCtrlWidth, listCtrlHeight));
    
    SetMNumTextShortcut(mpCTextShortcutPanel);
    wxBoxSizer *pBoxSizerTextShortcut = new wxBoxSizer(wxVERTICAL);
    
    mpCListCtrlTextShortcut = new wxListCtrlEX
	(mpCTextShortcutPanel, wxID_ANY, wxDPS, 
	 wxLC_REPORT | wxSUNKEN_BORDER);

    GCClassProvider.GetPCTextShortcut()->SetList(mpCListCtrlTextShortcut);

    pBoxSizerTextShortcut->Add( mpCMNumTextShortcut, 0, wxEXPAND);
    pBoxSizerTextShortcut->Add( mpCListCtrlTextShortcut, 1, wxEXPAND);
    
    mpCTextShortcutPanel->SetSizerAndFit(pBoxSizerTextShortcut);

    mpCBook->AddPage(mpCShortcutPanel, _("Shortcut"));
    //mpCBook->AddPage(mpCListCtrlShortcut, "test");
    mpCBook->AddPage(mpCTextShortcutPanel, _("Text Editor"));

    pBoxSizerSrc->Add( mpCBook, 1, wxEXPAND);
    //pBoxSizerSrc->Add(mpCListCtrlShortcut);
    
    
    SetSizerAndFit(pBoxSizerSrc);
}

void CLS::
SetMNumMouseParam(){
    MultiInputPanel_cls *pC = 
	MultiInputPanel_cls::Initialize(&mpCMNumMouseParam, mpCBook,
					wxT("MouseParam"));
    pC->mMinWidth = 460;
    
    /*
    wxString AstrChoiceGZ[2] = {wxT("low"), wxT("high")};
    pC->SetChoiceList(2, AstrChoiceGZ);
    pC->CombineConfItem(mpCCtrlLink->mCGZQuality, _(".gz Quality"));
    pC->CombineConfItem(mpCCtrlLink->mCstrTest, _("strTest"));
    pC->CombineConfItem(mpCCtrlLink->mCstrTest, _("strTest"));
    */

    MousePreference_cls *pCMousePref = GCClassProvider.GetPCMousePreference();

    wxString AstrMouseBtn[4] = {
	_("Left Mouse BTN"), _("Middle Mouse BTN"), _("Right Mouse BTN"), _("Not Assigned")};

    wxString strMod = "Shift Ctrl Alt";

    pC->CombineSizer(2, _("Gyration"));
    pC->mItemSize = 2;
    pC->SetChoiceList(4, AstrMouseBtn);
    pC->CombineConfItem(pCMousePref->mCGyrationMouse);
    pC->mItemSize = 1;
    pC->CombineConfItem(pCMousePref->mCbGyrationMod, strMod);

    pC->CombineSizer(2, _("Zoom"));
    pC->mItemSize = 2;
    pC->SetChoiceList(4, AstrMouseBtn);
    pC->CombineConfItem(pCMousePref->mCZoomMouse);
    pC->mItemSize = 1;
    pC->CombineConfItem(pCMousePref->mCbZoomMod, strMod);

    pC->CombineSizer(2, _("Move Center"));
    pC->mItemSize = 2;
    pC->SetChoiceList(4, AstrMouseBtn);
    pC->CombineConfItem(pCMousePref->mCCenterMouse);
    pC->mItemSize = 1;
    pC->CombineConfItem(pCMousePref->mCbCenterMod, strMod);

    pC->CombineSizer(2, _("Move Item"));
    pC->mItemSize = 2;
    pC->SetChoiceList(4, AstrMouseBtn);
    pC->CombineConfItem(pCMousePref->mCItemMouse);
    pC->mItemSize = 1;
    pC->CombineConfItem(pCMousePref->mCbItemMod, strMod);

    pC->CombineSizer(2, _("Move with Snap"));
    pC->mItemSize = 2;
    pC->SetChoiceList(4, AstrMouseBtn);
    pC->CombineConfItem(pCMousePref->mCItemSnapMouse);
    pC->mItemSize = 1;
    pC->CombineConfItem(pCMousePref->mCbItemSnapMod, strMod);

    pC->CombineSizer(2, _("Menu"));
    pC->mItemSize = 2;
    pC->SetChoiceList(4, AstrMouseBtn);
    pC->CombineConfItem(pCMousePref->mCMenuMouse);
    pC->mItemSize = 1;
    pC->CombineConfItem(pCMousePref->mCbMenuMod, strMod);

    pC->CombineSizer(2, _("Item Selection"));
    pC->mItemSize = 2;
    pC->SetChoiceList(4, AstrMouseBtn);
    pC->CombineConfItem(pCMousePref->mCHitTestMouse);
    pC->mItemSize = 1;
    pC->CombineConfItem(pCMousePref->mCbHitTestMod, strMod);

    pC->CombineSizer(2, _("Select Additive"));
    pC->mItemSize = 2;
    pC->SetChoiceList(4, AstrMouseBtn);
    pC->CombineConfItem(pCMousePref->mCHitTestAdditiveMouse);
    pC->mItemSize = 1;
    pC->CombineConfItem(pCMousePref->mCbHitTestAdditiveMod, strMod);

    pC->CombineSizer(2, _("Innertia"));
    pC->mItemSize = 2;
    pC->SetChoiceList(4, AstrMouseBtn);
    pC->CombineConfItem(pCMousePref->mCInertiaMouse);
    pC->mItemSize = 1;
    pC->CombineConfItem(pCMousePref->mCbInertiaMod, strMod);

    wxString AstrListB[4] = { _("Left BTN + Shift"), _("Left BTN + Ctrl"), _("Left BTN + Alt"), _("Not Assigned")};
    pC->SetChoiceList(4, AstrListB);
    pC->CombineConfItem(pCMousePref->mCMButtonEmulate, _("MButton Emulate"));

    pC->CombineSizer(2, _("Invert"));
    pC->CombineConfItem(pCMousePref->mCbZoomInvert, _("Zoom"));
    pC->CombineConfItem(pCMousePref->mCbGyrationInvert, _("Gyration"));
    
    pC->FinishSetting();
}

void CLS::
SetMNumPerformance(){
    MultiInputPanel_cls *pC = 
	MultiInputPanel_cls::Initialize(&mpCMNumPerformance, mpCBook,
					wxT("PerformanceParam"));

    pC->mTextWidth = 180;
    pC->mMin = 4;
    pC->CombineConfItem(mpCCtrlLink->mCMemoryLimitMB, _("Memory Limit(MB)"));
    pC->mMin = 4;
    pC->CombineConfItem(mpCCtrlLink->mCMemoryLimitTexMB, _("Texture Limit(MB)"));
    pC->mMin = 1;
    pC->CombineConfItem(mpCCtrlLink->mCPrefetchLength, _("Prefetch Length"));
    pC->CombineConfItem(mpCCtrlLink->mCParticleMax, _("Particle Max (x1000)"));
    pC->CombineConfItem(mpCCtrlLink->mCbRelativePath, _("Relative Path"));
    pC->CombineConfItem(mpCCtrlLink->mCParamForDebugINT, "Param for debug");

    pC->FinishSetting();
}

void CLS::
SetMNumGL(){
    MultiInputPanel_cls *pC = 
	MultiInputPanel_cls::Initialize(&mpCMNumGL, mpCBook,
					wxT("GL"));
    
    pC->mTextWidth = 180;

    wxString AstrListDepth[2] = {
	"GL_DEPTH24_STENCIL8", "GL_DEPTH32F_STENCIL8" };
    pC->SetChoiceList(2, AstrListDepth);
    pC->CombineConfItem(mpCCtrlLink->mCGLDepthIndex, "Depth");

    pC->CombineConfItem(mpCCtrlLink->mCParticleVBOMax, "Particle VBO Max (x1000)");

    pC->CombineSizer(2, _("Clip Min/Max"));
    pC->CombineConfItem(mpCCtrlLink->mCGLDepthMin);
    pC->CombineConfItem(mpCCtrlLink->mCGLDepthMax);
    
    pC->FinishSetting();
}

void CLS::
SetMNumShortcut(wxWindow *pCParent){
    MultiInputPanel_cls *pC = 
	MultiInputPanel_cls::Initialize(&mpCMNumShortcut, pCParent,
					wxT("Shortcut"));

    wxString AstrTemplate[3] = { _("Custom"), _("Defalut"), _("Blender Like")};
    pC->SetChoiceList(3, AstrTemplate);
    pC->CombineConfItem(mpCCtrlLink->mCShortcutTemplate, _("Template"));

    pC->FinishSetting();

    pC->SetHook(this, &HookItem_cls::HookFunc01, wxEVT_COMMAND_COMBOBOX_SELECTED);
}

void CLS::
SetMNumTextShortcut(wxWindow *pCParent){
    MultiInputPanel_cls *pC = 
	MultiInputPanel_cls::Initialize(&mpCMNumTextShortcut, pCParent,
					wxT("Text Editor"));

    wxString AstrTemplate[3] = { _("Custom"), _("Default"), _("Emacs Like")};
    pC->SetChoiceList(3, AstrTemplate);
    pC->CombineConfItem(mpCCtrlLink->mCTextShortcutTemplate, _("Template"));
    
    pC->FinishSetting();

    pC->SetHook(this, &HookItem_cls::HookFunc02, wxEVT_COMMAND_COMBOBOX_SELECTED);
}

void CLS::
OnTemplate(wxCommandEvent& event){
}

void CLS::
OnTextTemplate(wxCommandEvent& event){
    if (event.GetString().IsSameAs(_("Default")))
	GCClassProvider.GetPCTextShortcut()->SetTextDefault(0);
    if (event.GetString().IsSameAs(_("Emacs Like")))
	GCClassProvider.GetPCTextShortcut()->SetTextDefault(1);
    GCClassProvider.GetPCTextShortcut()->UpdateListItem(mpCListCtrlTextShortcut, -1);
}

void CLS::
UpdatePanels(wxString strPanelTag){
    if (mpCMNumMouseParam->GetName().IsSameAs(strPanelTag) ||
	strPanelTag.IsSameAs("ALL"))
	mpCMNumMouseParam->UpdateValues(_MN_ALLITEM);
    if (mpCMNumPerformance->GetName().IsSameAs(strPanelTag) ||
	strPanelTag.IsSameAs("ALL"))
	mpCMNumPerformance->UpdateValues(_MN_ALLITEM);
    if (mpCMNumGL->GetName().IsSameAs(strPanelTag) ||
	strPanelTag.IsSameAs("ALL"))
	mpCMNumGL->UpdateValues(_MN_ALLITEM);
}

void CLS::
OnListClick(wxListEvent &event){
    int id = event.GetId();
    Shortcut_cls *pCShortcut = NULL;
    wxListCtrlEX *pCListShortcut = NULL;
    if (mpCListCtrlShortcut->GetId() == id){
	pCShortcut = GCClassProvider.GetPCShortcut();
	pCListShortcut = mpCListCtrlShortcut;
    }
    if (mpCListCtrlTextShortcut->GetId() == id){
	pCShortcut = GCClassProvider.GetPCTextShortcut();
	pCListShortcut = mpCListCtrlTextShortcut;
    }

    if (pCShortcut == NULL) return;
    
    if (pCShortcut->PopupEditor(event.GetIndex(), this) == FALSE) return;
    if (pCShortcut->mConflict != -1)
      pCShortcut->UpdateListItem(pCListShortcut, pCShortcut->mConflict);

    pCShortcut->UpdateListItem(pCListShortcut, event.GetIndex());

    //GCClassProvider.GetPCShortcut()->UpdateListItem(mpCListCtrlShortcut, event.GetIndex());
    
    //mpCParent->mpCParentFrame->UpdateMenu();
}
