// -*- c -*-
// "clsPreferenceGUI.cpp"
// (setq c-basic-offset 4)

#ifndef _PREFERENCE_GUI_H_
#define _PREFERENCE_GUI_H_

#include "../WIDGETCTRL/MULTIINPUT/clsFrameEX.h"
#include "../WIDGETCTRL/MULTIINPUT/clsHookCtrl.h"

class Preference_cls; 
class wxNotebook;
class wxListCtrl;
class wxListCtrlEX;
class wxListEvent;
class MultiInputPanel_cls;

#include <wx/notebook.h>

#include "../COMMON/CommonDefinitions.h"

class PreferenceGUI_cls : public wxFrameEX, public HookItem_cls {
 public:
    PreferenceGUI_cls(Preference_cls* pCCtrlLink, wxWindow *pC);

    Preference_cls *mpCCtrlLink;
    wxNotebook     *mpCBook;

    wxListCtrlEX   *mpCListCtrlShortcut;
    wxListCtrlEX   *mpCListCtrlTextShortcut; 
    
    MultiInputPanel_cls* mpCMNumMouseParam;
    MultiInputPanel_cls* mpCMNumPerformance;
    MultiInputPanel_cls* mpCMNumShortcut;
    MultiInputPanel_cls* mpCMNumTextShortcut;
    MultiInputPanel_cls* mpCMNumGL;
    wxPanel *mpCShortcutPanel;
    wxPanel *mpCTextShortcutPanel;

    void SetMNumMouseParam();
    void SetMNumGL();
    void SetMNumPerformance();
    void SetMNumShortcut(wxWindow *pCParent);
    void SetMNumTextShortcut(wxWindow *pCParent);
    void UpdatePanels(wxString strPanelTag);
    void OnListClick(wxListEvent& event);

    void OnGLBG(wxCommandEvent& event);
    
    void HookFunc01(wxCommandEvent& event){OnTemplate(event);}
    void HookFunc02(wxCommandEvent& event){OnTextTemplate(event);}
    void OnTemplate(wxCommandEvent& event);
    void OnTextTemplate(wxCommandEvent& event);

    //void OnSizeA(wxSizeEvent& event);

    DECLARE_EVENT_TABLE()
};

#endif
