// (setq c-basic-offset 4)
// "clsShortcut.h"

#include "clsShortcut.h"

#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"

#include "../COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;
#include "../WIDGETCTRL/EX/clsListCtrlEX.h"
#include "../WIDGETCTRL/EX/wxDialogEX.h"
#include "../WIDGETCTRL/EX/wxPanelEX.h"
#include "../WIDGETCTRL/MULTIINPUT/clsMultiInputPanel.h"
#include "../WIDGETCTRL/WX/myArtProv.h"
#include "../WIDGETCTRL/WX/clsFontProvider.h"

#include "../../clsMain.h"

#include <wx/ribbon/toolbar.h>

#include "../COMMON/CommonDefinitions.h"

#define CLS Shortcut_cls

ShortcutItem_cls::
ShortcutItem_cls(int type,  wxString strBase, wxString strName,
		 int charactor, bool bShift, bool bCtrl, bool bAlt,
		 wxString strTgtList){
    mShortcutItemType = type;
    mstrBase = strBase;
    mstrName = strName;
    mChar = charactor;
    mbShift = bShift;
    mbCtrl = bCtrl;
    mbAlt = bAlt;
    mstrTgtList = strTgtList;
}

int ShortcutItem_cls::
GetType(int code, bool bShift, bool bCtrl, bool bAlt, wxString strTgtName){
    if (code == mChar && bShift == mbShift && bCtrl == mbCtrl && bAlt == mbAlt){
	if (strTgtName.IsEmpty() == TRUE || mstrTgtList.IsEmpty() == TRUE)
	    return mShortcutItemType;
	if (mstrTgtList.Find(strTgtName) != wxNOT_FOUND)
	    return mShortcutItemType;
    }
    return -1;
}

// ------

RbnCommandItem_cls::
RbnCommandItem_cls(int type, int rbnID, bool bDropdown){
    mType = type;
    mRbnID = rbnID;
    mbDropwown = bDropdown;
}

// ------

MenuCommandItem_cls::
MenuCommandItem_cls(int type, int menuID){
    mType = type;
    mMenuID = menuID;
}

// ------

Shortcut_cls::
Shortcut_cls(int type){
    mShortcutType = type;
    if (mShortcutType == 0){ // ʏV[gJbg 
	mstrSelf = wxT("Frame");
	SetDefault(0);
	
	AddRbnCommand(_SC_OPEN_PROJECT,  rBtnOpenProject);
	AddRbnCommand(_SC_OPEN_RECENT, rBtnOpenRecent);
	AddRbnCommand(_SC_SAVE_PROJECT,  rBtnSaveProject);
	AddRbnCommand(_SC_SAVE_PROJECT_AS, rBtnSaveProjectAs);
	AddRbnCommand(_SC_SCENE, rBtnScene);
	AddRbnCommand(_SC_UNDO, rBtnUndo);
	AddRbnCommand(_SC_REDO, rBtnRedo);
	AddRbnCommand(_SC_PREFERENCE, rBtnPreference);
	AddRbnCommand(_SC_OBJECTS, rBtnObjects, TRUE);
	AddRbnCommand(_SC_DUPLICATE, rBtnDuplicate);
	AddRbnCommand(_SC_DELETE, rBtnDelete);
	AddRbnCommand(_SC_INFO, rBtnInfo);
	AddRbnCommand(_SC_HELP, rBtnHelp);
	AddRbnCommand(_SC_TIP, rBtnToolTip);
	AddRbnCommand(_SC_INFO_GL, rBtnInfoGL);
	AddRbnCommand(_SC_INFO_STATUS, rBtnInfoStatus);

	AddMenuCommand(_SC_ESCAPE, menuEscape);
	AddMenuCommand(_SC_QUIT, Minimal_Quit);
	AddMenuCommand(_SC_SHOW_NUM_PANEL, menuShowNumPanel);
	AddMenuCommand(_SC_SHOW_PANEL_MANAGE, menuShowPanelManage);
	AddMenuCommand(_SC_FOLLOW_CAMERA, menuView3DFollowCamera);
	AddMenuCommand(_SC_LOCK_TO_CAMERA, menuView3DLockToCamera);
	AddMenuCommand(_SC_OBJECT_DESELECT, menuObjectDeselect);
	AddMenuCommand(_SC_NAVI_TRANSLATE, menuView3DTranslate);
	AddMenuCommand(_SC_NAVI_ROTATE, menuView3DRotate);
	AddMenuCommand(_SC_NAVI_SCALE, menuView3DScale);
	AddMenuCommand(_SC_NAVI_X, menuView3DNaviX);
	AddMenuCommand(_SC_NAVI_Y, menuView3DNaviY);
	AddMenuCommand(_SC_NAVI_Z, menuView3DNaviZ);
	AddMenuCommand(_SC_NAVI_X_LOCK, menuView3DNaviXLock);
	AddMenuCommand(_SC_NAVI_Y_LOCK, menuView3DNaviYLock);
	AddMenuCommand(_SC_NAVI_Z_LOCK, menuView3DNaviZLock);
	AddMenuCommand(_SC_PIVOT_ORIGIN, menuView3DPivotOrigin);
	AddMenuCommand(_SC_PIVOT_ACTIVEOBJ, menuView3DPivotActiveObj);
	AddMenuCommand(_SC_PIVOT_VIEWCENTER, menuView3DPivotViewCenter);
	AddMenuCommand(_SC_PIVOT_FIX_ACTIVEOBJ, menuView3DPivotFixToActiveObj);
	AddMenuCommand(_SC_VIEW_FRONT, menuView3DFront);
	AddMenuCommand(_SC_VIEW_BACK, menuView3DBack);
	AddMenuCommand(_SC_VIEW_RIGHT, menuView3DRight);
	AddMenuCommand(_SC_VIEW_LEFT, menuView3DLeft);
	AddMenuCommand(_SC_VIEW_TOP, menuView3DTop);
	AddMenuCommand(_SC_VIEW_BOTTOM, menuView3DBottom);
	AddMenuCommand(_SC_VIEW_TOGGLE_PERS, menuViewTogglePerspective);
	AddMenuCommand(_SC_ZOOM_PLUS, menuZoomPlus);
	AddMenuCommand(_SC_ZOOM_MINUS, menuZoomMinus);
	AddMenuCommand(_SC_COPY_TO_CLIPBARD, menuCopyToClipboard);
	AddMenuCommand(_SC_PASTE_FROM_CLIPBOARD, menuPasteFromClipboard);

	AddMenuCommand(_SC_DELETE, menuDelete);

	AddMenuCommand(_SC_TL_TIMEDEPEND, menuTLTimeDepend);
	AddMenuCommand(_SC_TL_SHY, menuTLShy);
	AddMenuCommand(_SC_TL_IN, menuTLIn);
	AddMenuCommand(_SC_TL_OUT, menuTLOut);
	
	AddMenuCommand(_SC_CLEAR_CACHE_TEXTURE, menuClearCacheTexture);
	AddMenuCommand(_SC_CLEAR_CACHE_VBO, menuClearCacheVBO);

	AddMenuCommand(_SC_TIMELINE, menuPopTimeline);
	AddMenuCommand(_SC_OUTLINER, menuPopOutliner);
	AddMenuCommand(_SC_PROPERTY, menuPopProperty);
	AddMenuCommand(_SC_VIEW3D, menuPopView3D);
	AddMenuCommand(_SC_GRAPH, menuPopGraph);
	AddMenuCommand(_SC_COLORCURVE, menuPopColorCurve);
	AddMenuCommand(_SC_TEXTEDITOR, menuPopTextEditor);
	AddMenuCommand(_SC_CONSOLE, menuPopConsole);

    }
    if (mShortcutType == 1){ // eLXgGfB^
	mstrSelf = wxT("Text");
	SetTextDefault(0);
    }
    mbSkipShortcut = FALSE;
};


void CLS::
SetDefault(int type){
    /*
    if (type != 0){
	switch (type){
	case 1:
	    ReadTemplate(wxT("Resource/SCTemplateBlender.txt"));
	    break;
	}
	return;
    }
    */

    mVCItems.clear();

    Add(_SC_OPEN_PROJECT, "Open Project", _("Open Project"),
	'O', FALSE, TRUE);
    Add(_SC_OPEN_RECENT, "Open Recent", _("Open Recent"),
	'P', TRUE, TRUE, TRUE);
    Add(_SC_SAVE_PROJECT, "Save Project", _("Save Project"),
	'S', FALSE, TRUE);
    Add(_SC_SAVE_PROJECT_AS, "Save Project as", _("Save Project as"),
	'S', FALSE, TRUE, TRUE);
    Add(_SC_SCENE, "Scene Configure", _("Scene Configure"),
	'K', FALSE, TRUE, FALSE);
    Add(_SC_UNDO, "Undo", wxT("Undo"),
	'Z', FALSE, TRUE);
    Add(_SC_REDO, "Redo", wxT("Redo"),
	'Y', FALSE, TRUE);
    Add(_SC_PREFERENCE, "Preference", _("Preference"), 
	'P', FALSE, TRUE, TRUE);
    Add(_SC_OBJECTS, "Add Objects", _("Add Objects"),
	'A', TRUE);
    Add(_SC_DUPLICATE, "Duplicate", _("Duplicate"),
	'D', TRUE);
    Add(_SC_DELETE, "Delete", _("Delete"),
	'X', FALSE, TRUE, FALSE, "VIEW3D::TIMELINE::OUTLINER::GRAPH::COLOR_CURVE");
    Add(_SC_INFO, "Info", _("Info"),
	WXK_F1, FALSE, TRUE);
    Add(_SC_HELP, "Help", _("Help"),
	WXK_F1);
    Add(_SC_TIP, "Show Tooltip", _("Show Tooltip"),
	WXK_F1, FALSE, FALSE, TRUE);
    Add(_SC_INFO_GL, "OpenGL Info", _("OpenGL Info"),
	WXK_F1, FALSE, TRUE, TRUE);
    Add(_SC_INFO_STATUS, "Status Info", _("Status Info"),
	WXK_F1, TRUE, FALSE, TRUE);


    Add(_SC_TL_TIMEDEPEND, "Show time dependent item", _("Show time dependent item"),
	'U');
    Add(_SC_TL_SHY, "Toggle shy mode", _("Toggle shy mode"),
	'S', FALSE, FALSE, TRUE, "TIMELINE");
    Add(_SC_TL_IN, "Set workarea in point", _("Set workarea in point"),
	'B');
    Add(_SC_TL_OUT, "Set workarea out point", _("Set workarea out point"),
	'N');

    Add(_SC_CLEAR_CACHE_TEXTURE, "Clear Cache Texture", _("Clear Cache Texture"),
	WXK_F5, FALSE, FALSE, FALSE);
    Add(_SC_CLEAR_CACHE_VBO, "Clear Cache VBO", _("Clear Cache VBO"),
	WXK_F5, FALSE, TRUE, FALSE);
    
    Add(_SC_ESCAPE, "Escape", _("Escape"),
	WXK_ESCAPE);

    Add(_SC_TIMELINE, "Timeline", _("Timeline"),
	WXK_F2, TRUE, FALSE, FALSE);
    Add(_SC_OUTLINER, "Outliner", _("Outliner"),
	WXK_F9, TRUE, FALSE, FALSE);
    Add(_SC_PROPERTY, "Property", _("Property"),
	WXK_F7, TRUE, FALSE, FALSE);
    Add(_SC_VIEW3D, "View3D", _("View 3D"),
	WXK_F5, TRUE, FALSE, FALSE);
    Add(_SC_GRAPH, "Graph Editor", _("Graph Editor"),
	WXK_F6, TRUE, FALSE, FALSE);
    Add(_SC_COLORCURVE, "Color Curve", _("Color Curve"),
	WXK_F3, TRUE, FALSE, FALSE);
    Add(_SC_TEXTEDITOR, "Text Editor", _("Text Editor"),
	WXK_F11, TRUE, FALSE, FALSE);
    Add(_SC_CONSOLE, "Console", _("Console"),
	WXK_F4, TRUE, FALSE, FALSE);

    Add(_SC_SHOW_NUM_PANEL, "Numerical Panel", _("Numerical Panel"),
	'N', FALSE, FALSE, TRUE, "VIEW3D::GRAPH::COLOR_CURVE");
    Add(_SC_SHOW_PANEL_MANAGE, wxT("Panel Manage Buttons"), _("Panel Mange Buttons"),
	'N', TRUE, FALSE, TRUE, "VIEW3D::TIMELINE::GRAPH::COLOR_CURVE::OUTLINER::PROPERTY");
    Add(_SC_FOLLOW_CAMERA, "Follow Camera", _("Follow Camera"),
	'F', FALSE, FALSE, FALSE, "VIEW3D");
    Add(_SC_LOCK_TO_CAMERA, "Lock to Camera", _("Lock to Camera"),
	'F', FALSE, TRUE, FALSE, "VIEW3D");
    Add(_SC_OBJECT_DESELECT, "Object Deselect", _("Object Deselect"),
	'A', FALSE, FALSE, FALSE,
	"VIEW3D::OUTLINER::TIMELINE");
    Add(_SC_NAVI_TRANSLATE, "Translate", _("Translate"),
	'G', FALSE, FALSE, FALSE, "VIEW3D");
    Add(_SC_NAVI_ROTATE, "Rotate", _("Rotate"),
	'R', FALSE, FALSE, FALSE, "VIEW3D");
    Add(_SC_NAVI_SCALE, "Scale", _("Scale"),
	'S', FALSE, FALSE, FALSE, "VIEW3D");
    Add(_SC_NAVI_X, "Snap to X", _("Snap to X"),
	'X', FALSE, FALSE, FALSE, "VIEW3D");
    Add(_SC_NAVI_Y, "Snap to Y", _("Snap to Y"),
	'Y', FALSE, FALSE, FALSE, "VIEW3D");
    Add(_SC_NAVI_Z, "Snap to Z", _("Snap to Z"),
	'Z', FALSE, FALSE, FALSE, "VIEW3D");
    Add(_SC_NAVI_X_LOCK, "Lock X", _("Lock X"),
	'X', TRUE, FALSE, FALSE, "VIEW3D");
    Add(_SC_NAVI_Y_LOCK, "Lock Y", _("Lock Y"),
	'Y', TRUE, FALSE, FALSE, "VIEW3D");
    Add(_SC_NAVI_Z_LOCK, "Lock Z", _("Lock Z"),
	'Z', TRUE, FALSE, FALSE, "VIEW3D");
    Add(_SC_PIVOT_ORIGIN, "Pivot to origin", _("Pivot to origin"),
	'.', FALSE, FALSE, FALSE, "VIEW3D");
    Add(_SC_PIVOT_ACTIVEOBJ, "Pivot to active", _("Pivot to active"),
	'.', FALSE, TRUE, FALSE, "VIEW3D");
    Add(_SC_PIVOT_VIEWCENTER, "Pivot to view center", _("Pivot to view center"),
	',', FALSE, FALSE, FALSE, "VIEW3D");
    Add(_SC_PIVOT_FIX_ACTIVEOBJ, "Fix pivot to active", _("Fix pivot to active"),
	'.', FALSE, TRUE, TRUE);
    Add(_SC_VIEW_FRONT, "View Front", _("View Front"), WXK_NUMPAD1, FALSE, FALSE, FALSE);
    Add(_SC_VIEW_BACK, "View Back", _("View Back"), WXK_NUMPAD1, FALSE, TRUE, FALSE);
    Add(_SC_VIEW_RIGHT, "View Right", _("View Right"), WXK_NUMPAD3, FALSE, FALSE, FALSE);
    Add(_SC_VIEW_LEFT, "View Left", _("View Letf"), WXK_NUMPAD3, FALSE, TRUE, FALSE);
    Add(_SC_VIEW_TOP, "View Top", _("View Top"), WXK_NUMPAD7, FALSE, FALSE, FALSE);
    Add(_SC_VIEW_BOTTOM, "View Bottom", _("View Bottom"), WXK_NUMPAD7, FALSE, TRUE, FALSE);
    Add(_SC_VIEW_TOGGLE_PERS, "Toogle Perspective", _("Toggle Perspective"), WXK_NUMPAD5, FALSE, FALSE, FALSE);
    
    Add(_SC_ZOOM_PLUS, "Zoom Plus", _("Zoom Plus"),
	'^', FALSE, FALSE, FALSE, "TIMELINE::COLOR_CURVE::GRAPH");
    Add(_SC_ZOOM_MINUS, "Zoom Minus", _("Zoom Minus"),
	'-', FALSE, FALSE, FALSE, "TIMELINE::COLOR_CURVE::GRAPH");
    Add(_SC_COPY_TO_CLIPBARD, "Copy to Clipboard", _("Copy to clipboard"),
	'C', FALSE, TRUE);
    Add(_SC_PASTE_FROM_CLIPBOARD, "Paste from Clipboard", _("Paste from clipboard"),
	'V', FALSE, TRUE);
}

void CLS::
SetTextDefault(int type){
    if (type != 0){
	switch (type){
	case 1:
	    GCClassProvider.GetPCMain()->OpenProjectMain("Resource/SHORTCUT/TextEmacs.txt", FALSE);
	    break;
	}
	return;
    }
    
    mVCItems.clear();

    Add(_SC_TEXT_BEGINNING_LINE, wxT("Beginning of Line"), _("Beginning of Line"),
	WXK_HOME);
    Add(_SC_TEXT_END_LINE, wxT("End of Line"), _("End of Line"), 
	WXK_END);
    Add(_SC_TEXT_SELECT_ALL, wxT("Select All"), _("Select All"),
	'A', FALSE, TRUE);
    Add(_SC_TEXT_KILL_LINE, wxT("Kill Line"), _("Kill Line"), -1);
}

void CLS::
Add(int type, wxString strBase, wxString strName, int charactor, 
    bool bShift, bool bCtrl, bool bAlt, wxString strTgtList){
    if (strName.IsEmpty() == TRUE) strName = strBase;
    mVCItems.push_back(ShortcutItem_cls(type, strBase, strName, charactor,
					bShift, bCtrl, bAlt, strTgtList));
}

void CLS::
AddRbnCommand(int type, int rbnID, bool bDropdown){
    mVCRbnCommand.push_back(RbnCommandItem_cls(type, rbnID, bDropdown));
}

void CLS::
AddMenuCommand(int type, int menuID){
    mVCMenuCommand.push_back(MenuCommandItem_cls(type, menuID));
}

// DELETE KEY IS PRESERVED FOR DELETE KEYFRAMES

int CLS::
GetSpecialKeyFromIndex(int index){
    switch(index){
    case 1: return WXK_F1;
    case 2: return WXK_F2;
    case 3: return WXK_F3;
    case 4: return WXK_F4;
    case 5: return WXK_F5;
    case 6: return WXK_F6;
    case 7: return WXK_F7;
    case 8: return WXK_F8;
    case 9: return WXK_F9;
    case 10: return WXK_F10;
    case 11: return WXK_F11;
    case 12: return WXK_F12;
    case 13: return WXK_LEFT;
    case 14: return WXK_RIGHT;
    case 15: return WXK_SPACE;
    case 16: return WXK_ESCAPE;
    case 17: return WXK_RETURN;
    case 18: return WXK_NUMPAD0;
    case 19: return WXK_NUMPAD1;
    case 20: return WXK_NUMPAD2;
    case 21: return WXK_NUMPAD3;
    case 22: return WXK_NUMPAD4;
    case 23: return WXK_NUMPAD5;
    case 24: return WXK_NUMPAD6;
    case 25: return WXK_NUMPAD7;
    case 26: return WXK_NUMPAD8;
    case 27: return WXK_NUMPAD9;
    case 28: return WXK_HOME;
    case 29: return WXK_END;
    }
    return 0;
}

int CLS::
GetSpecialKeyIndex(int keyChar){
    switch(keyChar){
    case WXK_F1: return 1;
    case WXK_F2: return 2;
    case WXK_F3: return 3;
    case WXK_F4: return 4;
    case WXK_F5: return 5;
    case WXK_F6: return 6;
    case WXK_F7: return 7;
    case WXK_F8: return 8;
    case WXK_F9: return 9;
    case WXK_F10: return 10;
    case WXK_F11: return 11;
    case WXK_F12: return 12;
    case WXK_LEFT: return 13;
    case WXK_RIGHT: return 14;
    case WXK_SPACE: return 15;
    case WXK_ESCAPE: return 16;
    case WXK_RETURN: return 17;
    case WXK_NUMPAD0: return 18;
    case WXK_NUMPAD1: return 19;
    case WXK_NUMPAD2: return 20;
    case WXK_NUMPAD3: return 21;
    case WXK_NUMPAD4: return 22;
    case WXK_NUMPAD5: return 23;
    case WXK_NUMPAD6: return 24;
    case WXK_NUMPAD7: return 25;
    case WXK_NUMPAD8: return 26;
    case WXK_NUMPAD9: return 27;
    case WXK_HOME: return 28;
    case WXK_END: return 29;
    }
    return 0;
}

wxString CLS::
GetStrSpecialKey(int keyChar){
    switch(keyChar){
    case WXK_F1: return "F1";
    case WXK_F2: return "F2";
    case WXK_F3: return "F3";
    case WXK_F4: return "F4";
    case WXK_F5: return "F5";
    case WXK_F6: return "F6";
    case WXK_F7: return "F7";
    case WXK_F8: return "F8";
    case WXK_F9: return "F9";
    case WXK_F10: return "F10";
    case WXK_F11: return "F11";
    case WXK_F12: return "F12";
    case WXK_LEFT: return "LEFT";
    case WXK_RIGHT: return "RIGHT";
    case WXK_SPACE: return "SPACE";
    case WXK_ESCAPE: return "ESC";
    case WXK_RETURN: return "RET";
    case WXK_NUMPAD0: return "NUM0";
    case WXK_NUMPAD1: return "NUM1";
    case WXK_NUMPAD2: return "NUM2";
    case WXK_NUMPAD3: return "NUM3";
    case WXK_NUMPAD4: return "NUM4";
    case WXK_NUMPAD5: return "NUM5";
    case WXK_NUMPAD6: return "NUM6";
    case WXK_NUMPAD7: return "NUM7";
    case WXK_NUMPAD8: return "NUM8";
    case WXK_NUMPAD9: return "NUM9";
    case WXK_HOME: return "HOME";
    case WXK_END: return "END";
    }
    return wxEmptyString;
}

wxString CLS::
GetStrShortcut(int index){
    wxString strShortcut;
    
    if (mVCItems[index].mbAlt == TRUE) strShortcut << "Alt-";
    if (mVCItems[index].mbShift == TRUE) strShortcut << "Shift-";
    if (mVCItems[index].mbCtrl == TRUE) strShortcut << "Ctrl-";
    
    wxString strSpecialKey = GetStrSpecialKey(mVCItems[index].mChar);
    if (strSpecialKey.IsEmpty() == TRUE)
	strShortcut << wxString::FromAscii((char)mVCItems[index].mChar);
    else
	strShortcut << strSpecialKey;

    return strShortcut;
}

wxString CLS::
GetStrFullString(int type, bool bShortCut){
    for (unsigned int i = 0; i < mVCItems.size(); i++){
	if (type == mVCItems[i].mShortcutItemType){
	    wxString strCommand = mVCItems[i].mstrName;
	    if (mVCItems[i].mChar == '\0') return strCommand;
	    if (bShortCut == TRUE){
		strCommand << wxT("\t");
		strCommand << GetStrShortcut(i);
	    }
	    return strCommand;
	}
    }
    return wxT("Find");
}

std::vector < wxString > CLS::
GetVstrItem(int index){
    std::vector < wxString > VstrItem;
    
    if (mVCItems[index].mbShift == TRUE) VstrItem.push_back(wxT("shift"));
    else                                 VstrItem.push_back(wxT(" "));
    if (mVCItems[index].mbCtrl  == TRUE) VstrItem.push_back(wxT("ctrl"));
    else                                 VstrItem.push_back(wxT(" "));
    if (mVCItems[index].mbAlt   == TRUE) VstrItem.push_back(wxT("alt"));
    else                                 VstrItem.push_back(wxT(" "));
    
    wxString strChar;
    wxString strSpecialKey = GetStrSpecialKey(mVCItems[index].mChar);
    if (strSpecialKey.IsEmpty() == TRUE){
	if (mVCItems[index].mChar == -1)
	    strChar << wxES;//wxT("NONE");
	else
	    strChar << wxString::FromAscii((char)mVCItems[index].mChar);
    }
    else
	strChar << strSpecialKey;
    VstrItem.push_back(strChar);
    VstrItem.push_back(mVCItems[index].mstrName);

    return VstrItem;
}

int CLS::
GetIndexFromBase(wxString strLine){
    int count = mVCItems.size();
    for (int i = 0; i < count; i++)
	if (strLine.IsSameAs(mVCItems[i].mstrBase)) return i;
    return -1;
}

void CLS::
SetRbnHelpString(wxRibbonToolBar *pBar, bool bUse){
    if (bUse == FALSE)
	return ClearRbnHelpString(pBar);
    for (unsigned int i = 0; i < mVCRbnCommand.size(); i++){
	if (pBar->FindById(mVCRbnCommand[i].mRbnID) != NULL){
	    wxString strFullString = GetStrFullString(mVCRbnCommand[i].mType);
	    pBar->SetToolHelpString(mVCRbnCommand[i].mRbnID, strFullString);
	}
    }
}

void CLS::
ClearRbnHelpString(wxRibbonToolBar *pBar){
    for (unsigned int i = 0; i < mVCRbnCommand.size(); i++){
	if (pBar->FindById(mVCRbnCommand[i].mRbnID) != NULL){
	    pBar->SetToolHelpString(mVCRbnCommand[i].mRbnID, wxES);
	}
    }
}

wxString CLS::
GetMenuString(int ID){
    for (unsigned int i = 0; i < mVCMenuCommand.size(); i++){
	if (mVCMenuCommand[i].mMenuID == ID)
	    return GetStrFullString(mVCMenuCommand[i].mType);
    }
    return wxEmptyString;
}

wxMenuItem* CLS::
GetPNewMenuItem(wxMenu *pMenu, int ID){
    return new wxMenuItem(pMenu, ID, GetMenuString(ID));
}

void CLS::
SetMenuItem(wxMenu *pMenu, int ID, wxString strMenuBitmap){
    wxMenuItem *pItem = GetPNewMenuItem(pMenu, ID);
    if (strMenuBitmap.IsEmpty() != TRUE)
	pItem->SetBitmap(ART(strMenuBitmap));
    pMenu->Append(pItem);
}

void CLS::
SetMenuCheckItem(wxMenu *pMenu, int ID, bool bCheck){
    pMenu->AppendCheckItem(ID, GetMenuString(ID))->Check(bCheck);
}

int CLS::
GetShortcutEnum(wxKeyEvent& event, wxString strTgtName){
    int code = event.GetKeyCode();
    bool bShift = event.m_shiftDown, bCtrl = event.m_controlDown, bAlt = event.m_altDown;
    int type = -1;
    int size = (int)mVCItems.size();

    for (int i = 0; i < size; i++){
	type = mVCItems[i].GetType(code, bShift, bCtrl, bAlt, strTgtName);
	if (type != -1) break;
    }
    
    return type;
}

// return TRUE ƑSplXV
bool CLS::
ProcFromList(wxKeyEvent& event, wxWindow *pCTgt){

    wxString strTgtName = pCTgt->GetName();
    int type = GetShortcutEnum(event, strTgtName);

    //printf("type=%d\n", type);

    if (type == -1) return FALSE;

    

    for (unsigned int i = 0; i < mVCMenuCommand.size(); i++)
	if (type == mVCMenuCommand[i].mType){
	    SendMenuEvent(pCTgt, mVCMenuCommand[i].mMenuID);
	    return TRUE;
	}

    for (unsigned int i = 0; i < mVCRbnCommand.size(); i++)
	if (type == mVCRbnCommand[i].mType){
	    if (mVCRbnCommand[i].mbDropwown == TRUE)
		SendRbnEventDropdown(pCTgt, mVCRbnCommand[i].mRbnID);
	    else
		SendRbnEvent(pCTgt, mVCRbnCommand[i].mRbnID);
	    return TRUE;
	}

    return FALSE;
}

bool CLS::
ProcShortcutKey(wxKeyEvent& event, wxWindow *pCTgt){

    if (mbSkipShortcut == TRUE) return FALSE;

    bool bProcessed = FALSE;

    if (pCTgt->GetName().IsSameAs("CONSOLE")) return FALSE;
    if (pCTgt->GetName().IsSameAs("TEXT_EDITOR")) return FALSE;
    
    bProcessed |= ProcFromList(event,pCTgt);

    //printf("proc %s %d\n",pCTgt->GetName().mb_str().data(), bProcessed);

    /*
    if (bRefreshGLPanel == TRUE) 
	GCClassProvider.GetPCMain()->
	    UpdatePanels(wxPanelEX::msVstrPanelName[_PANEL_VIEW3D].ToStdString());
    */
    
    return bProcessed;
}

void CLS::
SetList(wxListCtrlEX *pCList){
    pCList->SetFont(FontProvider_cls::GetFont(0));
    int widthShift = FontProvider_cls::GetTextWidth(0, wxT("shift")) + 14;
    int widthCtrl  = FontProvider_cls::GetTextWidth(0, wxT("ctrl")) + 14;
    int widthAlt   = FontProvider_cls::GetTextWidth(0, wxT("alt")) + 14;
    int widthKey   = FontProvider_cls::GetTextWidth(0, wxT("RIGHT")) + 14;
    pCList->InsertColumn(0,wxES, wxLIST_FORMAT_CENTER, widthShift);
    pCList->InsertColumn(1,wxES, wxLIST_FORMAT_CENTER, widthCtrl);
    pCList->InsertColumn(2,wxES, wxLIST_FORMAT_CENTER, widthAlt);
    pCList->InsertColumn(3,wxES, wxLIST_FORMAT_LEFT, widthKey);
    pCList->InsertColumn(4,wxT("function"), wxLIST_FORMAT_LEFT, 380 - widthShift - widthCtrl - widthAlt - widthKey);

    int num = mVCItems.size();
    for (int i = 0; i < num; i++)
	pCList->AddListItem(-1, GetVstrItem(i));
}

void CLS::
UpdateListItem(wxListCtrlEX *pCList, int index){
    if (index == -1)
	for (unsigned int i = 0; i < mVCItems.size(); i++)
	    pCList->SetListItem(i, GetVstrItem(i));
    else
	pCList->SetListItem(index, GetVstrItem(index));
}

bool CLS::
PopupEditor(int index, wxWindow *pC){

    wxDialogEX *pCDLG = new 
	wxDialogEX(pC, wxID_ANY, mVCItems[index].mstrName);

    MultiInputPanel_cls *pCPanel = new
	MultiInputPanel_cls(pCDLG, wxT("ShortcutChange"), _MN_VOLATILE);

    wxBoxSizer *pCBoxSizer = new wxBoxSizer(wxVERTICAL);
    pCBoxSizer->Add(pCPanel, 1, wxEXPAND);
    
    bool bShift = mVCItems[index].mbShift;
    bool bCtrl = mVCItems[index].mbCtrl;
    bool bAlt = mVCItems[index].mbAlt;
    ConfItemUINT_cls CKeyType(wxES, wxT("0"));
    ConfItemSTR_cls CKeyStr(wxES, wxES);
    ConfItemBOOL_cls CbModShift(wxES, bShift), CbModCtrl(wxES, bCtrl), CbModAlt(wxES, bAlt);
    //wxString strKey;
    
    if (GetStrSpecialKey(mVCItems[index].mChar).IsEmpty() == FALSE){
	//CKeyStr.mstrBody = wxES;
	CKeyType.mstrBody = GetStrSpecialKey(mVCItems[index].mChar);
    }
    else{
	if (mVCItems[index].mChar == -1)
	    CKeyType.mstrBody = wxT("NONE");
	else
	    CKeyStr.mstrBody = wxString::FromAscii('\0'+mVCItems[index].mChar);
    }

    wxString AstrKeyList[30] = 
	{ "Basic Key", 
	  "F1", "F2", "F3", "F4", "F5",
	  "F6", "F7", "F8", "F9", "F10",
	  "F11", "F12",
	  "LEFT", "RIGHT",
	  "SPACE", "ESCAPE", "ENTER",
	  "NUM 0", "NUM 1", "NUM 2", "NUM 3", "NUM 4",
	  "NUM 5", "NUM 6", "NUM 7", "NUM 8", "NUM 9",
	  "HOME", "END"};

    pCPanel->CombineSizer(2);
    pCPanel->SetChoiceList(30, AstrKeyList);
    pCPanel->CombineConfItem(CKeyType);
    pCPanel->CombineConfItem(CKeyStr);

    pCPanel->CombineSizer(3);
    pCPanel->CombineConfItem(CbModShift, "Shift");
    pCPanel->CombineConfItem(CbModCtrl, "Ctrl");
    pCPanel->CombineConfItem(CbModAlt, "Alt");
    
    pCPanel->FinishSetting();

    pCDLG->CreateDefaultButtons(pCBoxSizer);

    pCDLG->SetSizerAndFit(pCBoxSizer);

    if (pCDLG->ShowModal() != wxID_OK) return FALSE;

    pCPanel->SyncFromGUI();

    pCDLG->Destroy();

    int keyChar = 0;
    if (CKeyType.GetBodyINT() != 0){
	keyChar = GetSpecialKeyFromIndex(CKeyType.GetBodyINT());
    }
    else{
	CKeyStr.mstrBody.MakeUpper();
	if (CKeyStr.mstrBody.IsEmpty() == FALSE) 
	    keyChar = (int)CKeyStr.mstrBody[0];
    }

    bShift = (bool)CbModShift.GetBodyINT();
    bCtrl = (bool)CbModCtrl.GetBodyINT();
    bAlt = (bool)CbModAlt.GetBodyINT();

    if (mVCItems[index].mChar == keyChar &&
	mVCItems[index].mbShift == bShift &&
	mVCItems[index].mbCtrl == bCtrl &&
	mVCItems[index].mbAlt == bAlt) return FALSE;

    if (keyChar == 0){
	bShift = FALSE;
	bCtrl = FALSE;
	bAlt = FALSE;
    }

    int conflict = -1;
    int type = -1;
    int size = (int)mVCItems.size();
    for (int i = 0; i < size; i++){
	type = mVCItems[i].GetType(keyChar, bShift, bCtrl, bAlt, wxES);
	if (type != -1){
	    conflict = i;
	    i = size; continue;
	}
    }
    if (type != -1 && (conflict != index && conflict != -1) && keyChar != 0){
	wxString strMessage;
	strMessage << GetStrShortcut(conflict) << ENDL;
	strMessage << _("is already used in") << ENDL;
	strMessage << mVCItems[conflict].mstrName << ENDL;
	strMessage << _("Overwrite it ?") << ENDL;
	if (wxMessageBox(strMessage, _("Conflict"), wxYES_NO | wxICON_QUESTION) != wxYES)
	    return FALSE;
	
	mVCItems[conflict].mChar = 0;
	mVCItems[conflict].mbShift = FALSE;
	mVCItems[conflict].mbCtrl = FALSE;
	mVCItems[conflict].mbAlt = FALSE;
	mConflict = conflict;
    }
    else
	mConflict = -1;
    
    mVCItems[index].mChar = keyChar;
    mVCItems[index].mbShift = bShift;
    mVCItems[index].mbCtrl = bCtrl;
    mVCItems[index].mbAlt = bAlt;
    
 
    return TRUE;
}

void CLS::
ReadStrLine(std::wistream &istream, wxString strFirstItem, wxString strLine){
    if (strFirstItem.IsSameAs(wxT("Shortcut"))){
	strFirstItem = PopStrItemFromStrLine(strLine, wxT("::"));
	if (strFirstItem.IsSameAs(mstrSelf)){
	    
	    std::wstring wstrLine;
	    wxString strLine;
	    while ( std::getline (istream, wstrLine)){
		strLine = wstrLine.c_str();
		if (strLine.IsSameAs(wxT("Shortcut::Close")) == TRUE) return;
		int index = GetIndexFromBase(strLine);
		
		if (index == -1) continue;
		
		std::getline (istream, wstrLine);
		strLine = wstrLine.c_str();
		
		bool bShift, bCtrl, bAlt;
		int  charCode;
		std::string strBuffer = (char*)strLine.char_str();
		std::stringstream strTmp(strBuffer);
		strTmp >> bShift >> bCtrl >> bAlt >> charCode;
		
		mVCItems[index].mbShift = bShift;
		mVCItems[index].mbCtrl = bCtrl;
		mVCItems[index].mbAlt = bAlt;
		mVCItems[index].mChar = charCode;
	    }
	}
    }
}

void CLS::
Serialize(wxString &strOut){
   
    strOut << wxT("Shortcut::") << mstrSelf << ENDL;
    int count = mVCItems.size();
    for (int i = 0; i < count; i++){
	strOut << mVCItems[i].mstrBase << ENDL;
	strOut << mVCItems[i].mbShift << wxT(" ") << mVCItems[i].mbCtrl << wxT(" ") << mVCItems[i].mbAlt << wxT(" ") << mVCItems[i].mChar << ENDL;
    }

    strOut << wxT("Shortcut::Close") << ENDL;

}

Shortcut_cls *GpCShortcut = NULL;
Shortcut_cls *GpCTextShortcut = NULL;
