// (setq c-basic-offset 4)
// "clsPreference.cpp"

#ifndef _SHORTCUT_H_
#define _SHORTCUT_H_

#include "../FILEIO/clsParser.h"

#include "../WIDGETCTRL/clsWidgetCommon.h"

#include <vector>
#include <fstream>
#include <sstream>

#include <wx/wx.h>

class wxListCtrl;
class wxListCtrlEX;
class wxRibbonToolBar;

enum{
    _SC_QUIT = 0,
    _SC_OPEN_PROJECT,
    _SC_OPEN_RECENT,
    _SC_SAVE_PROJECT,
    _SC_SAVE_PROJECT_AS,
    _SC_SCENE,
    _SC_UNDO,
    _SC_REDO,
    _SC_PREFERENCE,
    _SC_OBJECTS,
    _SC_DUPLICATE, 
    _SC_DELETE,
    _SC_OBJECT_DESELECT,
    _SC_INFO,
    _SC_HELP,
    _SC_TIP,
    _SC_INFO_GL,
    _SC_INFO_STATUS,
    _SC_SHOW_NUM_PANEL,
    _SC_SHOW_PANEL_MANAGE,
    _SC_FOLLOW_CAMERA,
    _SC_LOCK_TO_CAMERA,
    _SC_NAVI_TRANSLATE,
    _SC_NAVI_ROTATE,
    _SC_NAVI_SCALE,
    _SC_NAVI_X,
    _SC_NAVI_Y,
    _SC_NAVI_Z,
    _SC_NAVI_X_LOCK,
    _SC_NAVI_Y_LOCK,
    _SC_NAVI_Z_LOCK,
    _SC_PIVOT_ORIGIN,
    _SC_PIVOT_ACTIVEOBJ,
    _SC_PIVOT_VIEWCENTER,
    _SC_PIVOT_FIX_ACTIVEOBJ,
    _SC_VIEW_FRONT,
    _SC_VIEW_BACK,
    _SC_VIEW_RIGHT,
    _SC_VIEW_LEFT,
    _SC_VIEW_TOP,
    _SC_VIEW_BOTTOM,
    _SC_VIEW_TOGGLE_PERS,
    _SC_ZOOM_PLUS,
    _SC_ZOOM_MINUS,
    _SC_COPY_TO_CLIPBARD,
    _SC_PASTE_FROM_CLIPBOARD,
    
    _SC_TL_TIMEDEPEND,
    _SC_TL_SHY,
    _SC_TL_IN,
    _SC_TL_OUT,

    _SC_CLEAR_CACHE_TEXTURE,
    _SC_CLEAR_CACHE_VBO,

    _SC_ESCAPE,
    _SC_TIMELINE,
    _SC_OUTLINER,
    _SC_PROPERTY,
    _SC_VIEW3D,
    _SC_GRAPH,
    _SC_COLORCURVE,
    _SC_TEXTEDITOR,
    _SC_CONSOLE,
    
    _SC_TEXT_BEGINNING_LINE,
    _SC_TEXT_END_LINE,
    _SC_TEXT_SELECT_ALL,
    _SC_TEXT_KILL_LINE,
};

class ShortcutItem_cls {
 public:
    ShortcutItem_cls(int type, wxString strBase, wxString strName, 
		     int charactor, bool bShift, bool bCtrl, bool bAlt,
		     wxString strTgtList);
    int GetType(int code, bool bShift, bool bCtrl, bool bAlt,
		wxString strTgtName);
    
    int mShortcutItemType;
    wxString mstrBase;
    wxString mstrName;
    wxString mstrTgtList;
    int mChar;
    bool mbShift, mbCtrl, mbAlt;
};

class RbnCommandItem_cls {
 public:
    RbnCommandItem_cls(int type, int rbnID, bool bDropdown);
    int mType;
    int mRbnID;
    bool mbDropwown;
};

class MenuCommandItem_cls {
 public:
    MenuCommandItem_cls(int type, int menuID);
    int mType;
    int mMenuID;
    wxString mstrTgtClass();
};

class Shortcut_cls : public WidgetCommon_cls, public Parser_cls {
 public:
    Shortcut_cls(int type);

    std::vector < ShortcutItem_cls > mVCItems;

    std::vector < RbnCommandItem_cls > mVCRbnCommand;
    std::vector < MenuCommandItem_cls > mVCMenuCommand;

    int mShortcutType;
    wxString mstrSelf;
    int mConflict; //Փ˂ňꏏɍXVꂽV[gJbg
    bool mbSkipShortcut;

    void SetDefault(int type);
    void SetTextDefault(int type);

    void Add(int type, wxString strBase, wxString strName, int charactor, 
	     bool bShift = FALSE, bool bCtrl = FALSE, bool bAlt = FALSE,
	     wxString strTgtList = wxEmptyString);
    void AddRbnCommand(int type, int rbnID, bool bDropdown = FALSE);
    void AddMenuCommand(int type, int menuID);

    int      GetSpecialKeyFromIndex(int index);
    int      GetSpecialKeyIndex(int keyChar);
    wxString GetStrSpecialKey(int keyChar);
    wxString GetStrShortcut(int index);
    wxString GetStrFullString(int type, bool bShortCut = TRUE);
    std::vector < wxString > GetVstrItem(int index);
    int      GetIndexFromBase(wxString strBase);
    void SetRbnHelpString(wxRibbonToolBar *pBar, bool bUse);
    void ClearRbnHelpString(wxRibbonToolBar *pBar);
    wxString GetMenuString(int ID);
    wxMenuItem* GetPNewMenuItem(wxMenu *pMenu, int ID);
    
    void SetMenuItem(wxMenu *pMenu, int ID, 
		     wxString strMenuBitmap = wxEmptyString);
    void SetMenuCheckItem(wxMenu *pMenu, int ID, bool bCheck);

    int GetShortcutEnum(wxKeyEvent& event, wxString strTgtName);
    bool ProcFromList(wxKeyEvent &event, wxWindow *pCTgt);
    bool ProcShortcutKey(wxKeyEvent& event, wxWindow *pCTgt);
    void SetList(wxListCtrlEX* pCList);
    void UpdateListItem(wxListCtrlEX *pCList, int index);
    bool PopupEditor(int index, wxWindow *pC);

    void ReadStrLine(std::wistream &istream, wxString strFirstItem, wxString strLine);
    void Serialize(wxString &strOut);
};

#endif
