// (setq-c-offset 4)
// "clsMCThread.cpp"

#ifndef _MC_THREAD_H
#define _MC_THREAD_H

#include "../../../COMMON/clsThreadCommonTypeB.h"
#include "../../../COMMON/CommonDefinitionsGL.h"

class MCThread_cls : public ThreadInstanceTypeB_cls {
 public:
    MCThread_cls(unsigned char *pDataLink,
		 int *pAllocSize, int *pFaceNum,
		 float **ppVertices, float **ppNormals, int **ppFaceIndex,
		 int bufferSize);

    unsigned char * const mpData;
    float *mpTmpVertices;
    float *mpTmpNormal;
    int mArrayIndex;

    int * const mpAllocSize;
    int * const mpFaceNum;
    float ** mppVertices;
    float ** mppNormals;
    int   ** mppFaceIndex;
    
    int mBufferSize;
    int mDataBoxFullSize;
    int mSize[3];
    int mInitX, mFinX;
    int mInitY, mFinY;
    int mInitZ, mFinZ;

    int mOffsetZ, mOffsetY;
    int mBaseIndex;
    float mTargetValue, mTargetValue255;

    void SetParameters
	(int size[3], 
	 int initZ, int finZ, int initY, int finY, int initX, int finX,
	 float targetValue);

    GLfloat GetOffset(GLfloat fValue1, GLfloat fValue2, GLfloat fValueDesired);


    float GetInterpolatedValue
	(const unsigned char *pData,
	 const int lBaseIndex, const float fx, const float fy, const float fz);

    float GetInterpolatedValue2
	(const unsigned char *pData,
	 int x, int y, int z,
	 const float fx, const float fy, const float fz);

     void GetNormalPrecise2
	(GLfloat ANorm[3], const unsigned char *pData,
	 const int x, const GLfloat fX, 
	 const int y, const GLfloat fY,
	 const int z, const GLfloat fZ);
    void GetNormalPrecise
	(GLfloat ANorm[3], const unsigned char *pData,
	 const int x, const GLfloat fX, 
	 const int y, const GLfloat fY,
	 const int z, const GLfloat fZ);

    void ProcessBorder(const int x, const int y, const int z,
		       const unsigned char *pDataIndex, GLfloat afCubeValue[8]);

    int MarchCubeMainThread(const unsigned char *pData,
			    const int x, const int y, const int z);
    int MarchCubeLOOPX1(const unsigned char *pData, int y, int z,
			int startX, int finX);
    int MarchCubeLOOPY(const unsigned char *pData, int z,
		       int startY, int finY, int startX, int finX);
    
    bool CopyResults();
    virtual ExitCode Entry();

    static GLint   VOffset[8][3];
    static const GLint   a2iEdgeConnection[12][2];
    static const GLfloat a2fEdgeDirection[12][3];

    static const GLint aiCubeEdgeFlags[256];
    static const GLint a2iTriangleConnectionTable[256][16];
};

#endif
