// (setq-c-offset 4)
// "clsMarchingCube.cpp"

#ifndef _MARCHING_CUBE_H
#define _MARCHING_CUBE_H

#include "../../../COMMON/clsThreadCommonTypeB.h"
#include "../../../MESH/clsMeshBase2.h"

class VolumeFoRender_cls;

class MarchingCube_cls : public ThreadCommonTypeB_cls {
 public:
    MarchingCube_cls();
    ~MarchingCube_cls();

    // 8x8x8 ̋ɕČvZ邱Ƃߑł
    unsigned char mSectionMinValue[8][8][8];
    unsigned char mSectionMaxValue[8][8][8];

    // f̃|Sf[^
    std::vector < float* > mVpVertices; //_*3 (xyzȂ̂)
    std::vector < float* > mVpNormals;  //_*3 (xyzȂ̂)
    std::vector < int* > mVpFaceIndex; 

    std::vector < int > mVFaceNum; // |S
    std::vector < int > mVAllocSize; // _*3BœKƌ
    std::vector < int > mVVertexNumOrg;

    // --Mesh2
    
    MeshBase2_cls mCMesh2[8*8*8];

    int mSize[3];
    float mTargetValue;
    
    VolumeFoRender_cls *mpCVolumeForRenderUsed, *mpCVolumeForRenderVBO;
    int mPrepareCounterUsed, mPrepareCounterVBO;
    float mTargetValueUsed, mTargetValueVBO;
    bool mbOptimizeUsed, mbOptimizeVBO;
    bool mbUseSVVBO;

    wxString mstrSnap1LoadedBody, mstrSnap2LoadedBody;
    float mFactor;
    
    void Clear();
    std::vector < unsigned char > GetMinMaxValue
	(unsigned char *pData, 
	 int initZ, int finZ, int initY, int finY, int initX, int finX);
    void CalcMaxAndMin(unsigned char *pDataLink);
    bool IsItSameVolumeData(VolumeFoRender_cls *pCVolumeForRender);
    void ConstructVertices(VolumeFoRender_cls *pCVolumeForRender,
			   float threshold, bool bOptimize);
    void ConstructThreadControl(unsigned char* pDataLink);
    void OptimizeThreadControl();
    void SetVBO(bool bUseSV);

    void GLDraw(bool bUseVBO);
    void GLDrawSV(int section);
};

#endif
