// (setq-c-offset 4)
// "clsPrimitive.cpp"

#ifndef _COLOR_CURVE_H
#define _COLOR_CURVE_H

#include "../clsAttribute.h"
#include "../../PARAMETER/clsParamGroup.h"

#define _COLOR_CURVE_RGB  0
#define _COLOR_CURVE_RGBA 1

#define _COLOR_CURVE_RESOLUTION 1024

class ColorCurve_cls : public Attribute_cls, public ParamGroup_cls {
public:
    ColorCurve_cls(wxString strName, wxArrayString AstrItemName/*, wxString strAttribName = "ColorCurve"*/);
    ~ColorCurve_cls();
  
    unsigned int mTexture1D;
    wxString strCounterAtTexGen;
    
    void Paste(wxString& strData, wxString strTag);
    void CopyColorCurveCommand(ColorCurve_cls *pCNew, wxString strTag, bool bAlpha);
    void CopyColorCurveFromP(ColorCurve_cls *pCFrom);
    void CopyColorCurveFromString(wxString strSerialize, bool bSelf = TRUE);
    
    void ClearTexture();
    double GetRemapX(double x0);
    wxColour GetColor(double x0, double *pAlpha = NULL);
    void TrimColorVector(std::vector < double > &VClr);
    void PrepareTexture(bool bRepeat = FALSE, float alphaFactor = 1,
			bool bUseRemap = TRUE);
    void BindTexture(int active = 1, bool bRepeat = FALSE);

    static wxColour AlphaBlend(wxColour ClrBase, wxColour ClrBlend, 
			       double alpha);

    
    bool ReadStrLine(std::wistream &istream, wxString strFirstItem, wxString strLine, bool bSelf = TRUE);
    void Serialize(wxString& strOut);
};

#endif
