// -*- c -*-
// "clsDrawParticle.cpp"

#ifndef _DRAW_PARTICLE_H
#define _DRAW_PARTICLE_H

#include "clsDrawParticleBase.h"

#include "../../COMMON/CommonDefinitionsForH.h"
#include "../../COMMON/CommonDefinitionsShader.h"

class ArrayAndIndex_cls;
class MaterialParticle_cls;
class ParticleForRender_cls;
class SphereGouraudParam_cls;
class SpherePhongParam_cls;
class SphereToonParam_cls;

#include <wx/wx.h>

class DrawParticle_cls : public DrawParticleBase_cls {
 public:
    DrawParticle_cls();
    ~DrawParticle_cls();

    unsigned int *mpElementArrayBuffer;
    int *mpParamBitArrayBuffer;
    int mAllocateNumArrayBuffer, mAllocateNumParamBitBuffer;

    int mIDClrCurveST[_MAX_SPHERESHADER];
    int mIDFilterAlpha[_MAX_SPHERESHADER];
    int mIDParamBit[_MAX_SPHERESHADER];
    
    void ClearVBO();

    void AllocateElemenyArray(int num);
    void AllocateParamBitArray(int num);
    void SetVBOElementArrayAll
	(int EAindex, int PNum, 
	 ArrayAndIndex_cls *pIndexAndZ, float *pFilterAlpha);
    void SetVBOElementArraySelective
	(int EAindex, int PNum, 
	 ArrayAndIndex_cls *pIndexAndZ, float *pFilterAlpha,
	 unsigned char *pParamBit, unsigned char blendType);
    
    void SetVBOBuffer
	(ParticleForRender_cls *pCSnapForRender, bool bTwoPass);
    
    void DrawSphereSV(ParticleForRender_cls *pCSnapForRender, int sphereDepth,
		      int ensemble,
		      MaterialParticle_cls *pCMatParticle[_MAX_PARTICLE_TYPE]);

    SphereGouraudParam_cls* GetPCNewGouraudParam(int lightNum, int ensemble, int dissolve);
    SpherePhongParam_cls* GetPCNewPhongParam(int lightNum, int ensemble, int dissolve, bool bFlat);
    SphereToonParam_cls* GetPCNewToonParam(int lightNum, int ensemble, int dissolve, float threshold, float boldness, bool bFlat);
    
    void DrawSphere(ParticleForRender_cls *pCSnapForRender, 
		    int lightNum, int ensemble, int dissolve, int sphereDepth,
		    bool bSingle, 
		    MaterialParticle_cls *pCMatParticle[_MAX_PARTICLE_TYPE]);

    void DrawSereal(ParticleForRender_cls *pCSnapForRender,
		    int lightNum, int ensemble, int dissolve, int sphereDepth,
		    int twist,
		    MaterialParticle_cls *pCMatParticle[_MAX_PARTICLE_TYPE],
		    float baseMatrix16[16], float baseMatrix16Inv[16],
		    float viewMatrix16[16], float viewMatrix16Inv[16] );

};

#endif
