// -*- c -*-
// "clsDrawParticleBase.cpp"

#ifndef _DRAW_PARTICLE_BASE_H
#define _DRAW_PARTICLE_BASE_H

#include "../../COMMON/clsGetPC.h"
#include "../../MYGL/clsGLExtention.h"

#include <wx/wx.h>

class ParticleForRender_cls;
class ShaderItem_cls;

class DrawParticleBase_cls : public GetPC_cls, public GLCheckError_cls {
 public:
    DrawParticleBase_cls();
    void ClearVBOBase();
    
    int mNumValid[2]; // n-path

    ParticleForRender_cls *mpCSnapForRenderUsed;
    int mDrawCountUsed, mDrawCountIndexUsed;

    int mIDPointSize;
    int mIDPointClrCurveS, mIDPointClrCurveT;
    int mIDPointFilterAlpha;
    int mIDPointParamBit;

    int mIDBillboardSize;
    int mIDBillboardClrCurveS, mIDBillboardClrCurveT;
    int mIDBillboardFilterAlpha;
    int mIDBillboardParamBit;
    int mIDBillboardTwistID;
    
    unsigned int mVBOVertexPoint;
    
    unsigned int mVBOClrCurveSPoint;
    unsigned int mVBOClrCurveTPoint;
    unsigned int mVBOFilterAlpha;
    
    unsigned int mVBOSizePoint;
    unsigned int mVBOParamBitPoint;
    unsigned int mVBOTwistID;
    unsigned int mVBOElementArrayPoint[2]; //n-path

    void BindParticleTextureMain(wxString strPath, int textureUnit);
    void BindParticleTexture(ParticleForRender_cls *pCSnapForRender);

    void SetPointAttribLocation(ShaderItem_cls &CItem);
    void SetBillboardAttribLocation(ShaderItem_cls &CItem);

    void DrawPoints(ParticleForRender_cls *pCSnapForRender, 
		    int lightNum, int ensemble, int dissolve);
    void DrawBillboards(ParticleForRender_cls *pCSnapForRender, 
			int lightNum, int ensemble, int dissolve, int twist,
			float baseMatrix16[16], float baseMatrix16Inv[16],
			float viewMatrix16[16], float viewMatrix16Inv[16]);
};

#endif
