// -*- c -*-
// "clsDrawParticleLargeVBO.cpp"

#ifndef _DRAW_PARTICLE_LARGE_VBO_H
#define _DRAW_PARTICLE_LARGE_VBO_H

#include "clsDrawParticleBase.h"

#include "../../COMMON/CommonDefinitionsForH.h"
#include "../../COMMON/clsThreadCommonTypeB.h"

class ArrayAndIndex_cls;
class MaterialParticle_cls;
class ParticleForRender_cls;

#include <wx/wx.h>

class DrawParticleLargeVBO_cls;

class ThreadPrepareNextVBOParticleCount_cls : public ThreadInstanceTypeB_cls {
public:
    bool mbFinThread;
    ParticleForRender_cls *mpCSnapForRender;
    int mIni, mFin, mOffset;
    int *mpCounter;
    
    void SetParameters(ParticleForRender_cls *pCSnapForRender,
		       int ini, int fin, int offset,
		       int *pCounter);

    virtual ExitCode Entry();
};

class ThreadPrepareNextBase_cls : public ThreadInstanceTypeB_cls {
public:
    ParticleForRender_cls *mpCSnapForRender;
    DrawParticleLargeVBO_cls *mpCCtrl;

    int mPNum;
    int mOffset, mTgtOffset;
    bool mbFullCopy;

    void SetParametersBase(ParticleForRender_cls *pCSnapForRender, 
			   DrawParticleLargeVBO_cls *pCCtrl,
			   int PNum, int offset, int tgtOffset,
			   bool bFullCopy);
};

class ThreadPrepareNextVBOParticleDataPos_cls : public ThreadPrepareNextBase_cls{
public:
    bool mbFinThread;
    bool *mpbFullCopy;
    
    void SetParameters(ParticleForRender_cls *pCSnapForRender, 
		       DrawParticleLargeVBO_cls *pCCtrl,
		       int PNum, int offset, int tgtOffset,
		       bool *pbFullCopy, bool bFinThread = FALSE);
    virtual ExitCode Entry();
};

class ThreadPrepareNextVBOParticleDataST_cls : public ThreadPrepareNextBase_cls {
public:
    void SetParameters(ParticleForRender_cls *pCSnapForRender, 
		       DrawParticleLargeVBO_cls *pCCtrl,
		       int PNum, int offset, int tgtOffset,
		       bool bFullCopy);
    virtual ExitCode Entry();
};

class ThreadPrepareNextVBOParticleDataAlpha_cls : public ThreadPrepareNextBase_cls{
    public:
    void SetParameters(ParticleForRender_cls *pCSnapForRender, 
		       DrawParticleLargeVBO_cls *pCCtrl,
		       int PNum, int offset, int tgtOffset,
		       bool bFullCopy);
    virtual ExitCode Entry();
};

class ThreadPrepareNextVBOParticleDataOther_cls : public ThreadPrepareNextBase_cls{
public:
    void SetParameters(ParticleForRender_cls *pCSnapForRender, 
		       DrawParticleLargeVBO_cls *pCCtrl,
		       int PNum, int offset, int tgtOffset,
		       bool bFullCopy);
    virtual ExitCode Entry();
};

class ThreadPrepareNextVBOParticleDataElement_cls : public ThreadInstanceTypeB_cls{
public:
    //ParticleForRender_cls *mpCSnapForRender;
    DrawParticleLargeVBO_cls *mpCCtrl;
    int mPNum;
    bool mbTwoPass;

    void SetParameters(DrawParticleLargeVBO_cls *pCCtrl, int PNum, bool bTwoPass);
    virtual ExitCode Entry();
};

class DrawParticleLargeVBO_cls : public DrawParticleBase_cls, public ThreadCommonTypeB_cls {
public:
    DrawParticleLargeVBO_cls();
    ~DrawParticleLargeVBO_cls();

    int *mpStatusFlagListCount;
    int *mpStatusFlagListDataPos, *mpStatusFlagListDataST, *mpStatusFlagListDataAlpha, *mpStatusFlagListDataOther;
    int *mpStatusFlagListDataElement;
    
    int mTgtOffset1, mTgtOffset2, mTgtOffset3;
    
    int mNumValidNext[2]; // n-path
    int mNumNext;

    int mNumPack;
    float (*mpX)[3];
    float *mpSize;
    float *mpClrCurveS;
    float *mpClrCurveT;
    float *mpFilterAlpha;
    unsigned char *mpType;
    int *mpParamBit;
    int *mpTwistID;
    unsigned int *mpElementArray0, *mpElementArray1;

    void ClearVBO();
    void Allocate(int numPack, bool bTwoPass);
    void ReleaseMemoryData();

    bool mbFullCopy[4];
    void PrepareNextDataPos(ParticleForRender_cls *pCSnapForRender, int offset);
    void PrepareNextDataST(ParticleForRender_cls *pCSnapForRender, int offset);
    void PrepareNextDataAlpha(ParticleForRender_cls *pCSnapForRender, int offset);
    void PrepareNextDataOther(ParticleForRender_cls *pCSnapForRender, int offset);
    
    void PrepareNextDataElement(bool bTwoPass);

    /*
    void SetVBOElementArrayAll
	(int EAindex, int PNum);
    void SetVBOElementArraySelective
	(int EAindex, int PNum, unsigned char blendType);
    */
    void SetNextVBOPos();
    void SetNextVBOST();
    void SetNextVBOAlpha(); // alphaƃTCY
    void SetNextVBOOther(bool bTwoPass);
    void SetNextVBOElement(bool bTwoPass);
    

    void FinishPrepareNextPos();
    void FinishPrepareNextST();
    void FinishPrepareNextAlpha();
    void FinishPrepareNextOther();
    void FinishPrepareNextElement();

};

#endif
