// -*- c -*-
// "clsDrawStreamline.cpp"

#ifndef _DRAW_STREAMLINE_H
#define _DRAW_STREAMLINE_H

#include "../../COMMON/clsGetPC.h"
#include "../../MYGL/clsGLExtention.h"

#include "../../COMMON/CommonDefinitionsForH.h"

#include <wx/wx.h>

class StreamlineForRender_cls;

class DrawStreamline_cls : public GetPC_cls, public GLCheckError_cls {
 public:
    DrawStreamline_cls();
    ~DrawStreamline_cls();

    StreamlineForRender_cls *mpCSnapForRenderUsed;
    int mDrawCountUsed;
    
    int mSNum;
    
    unsigned int mVBOVertex;
    unsigned int mVBOU;
    unsigned int mVBOLineIndex;
    unsigned int mVBOAlpha;
    unsigned int mVBOElementArray;

    void SetVBOElementArray(int SNum);
    void SetVBOBuffer(StreamlineForRender_cls *pCSnapForRender);

    int mNumValid[2]; // n-path

    void Draw(StreamlineForRender_cls *pCSnapForRender, 
	      int shaderType, float lineWidth, int mappingType,
	      int textureMode, int lightNum, int ensemble, int dissolve,
	      double clipBoxMin[3], double clipBoxMax[3],
	      double matrix16[16], float smoothWidth, float thinningFactor);

};

#endif
