// (setq-c-offset 4)
// "clsPrimitive.cpp"

#ifndef _HEIGHT_FIELD_H
#define _HEIGHT_FIELD_H

#include "clsDataViewerBase.h"
//#include "../clsSceneObj.h"

#include "../../GLOBJ/clsVBOBaseObject.h"
#include "../../GLOBJ/clsVBOCommon.h"

class ImageSequence_cls;
class MultiInputPanel_cls;

class HeightField_cls : public DataViewerBase_cls, public VBOCommon_cls {
public:
    HeightField_cls(ParentObj_cls *pCParentObj,
		    wxString strName = wxES);
    ~HeightField_cls();

    ImageSequence_cls *mpCImageSequence;

    ConfItemUINT_cls mCChannel;
    ConfItemBOOL_cls mCbUseClrCurve;
    ConfItemBOOL_cls mCbCastShadow;
    ConfItemBOOL_cls mCbXRay;
    ConfItemBOOL_cls mCbRim;

    Material_cls *mpCMaterial;

    //int mIndexImagePath;

    //VBOBaseObject_cls mCVBOBasePlane;
    VBOBaseObject_cls mCVBOBaseRim;
    VBOBaseObject_cls mCVBOBaseFloor;
    wxSize mCVBOSize;

    void SyncConfListTagHeightField();

    wxString GetStrInfo();
    wxString GetStrPathCandid();
    bool IsDataValid();

    void CheckFileSequence();

    void ConstructVBO( wxSize CSizeImage, VBOBaseObject_cls *pCVBOBasePlane);
    void ConstructVBORim(wxSize CSizeImage);
    void ConstructVBOFloor();
    void GLDrawSVUnit(VBOBaseObject_cls *pCVBOBasePlane);
    void GLDrawSV(wxString strImg, VBOBaseObject_cls *pCVBOBasePlane);
    void GLDrawBox(int status);
    void GLDraw(bool bDrawGuideObject, 
		int lightNum, int ensemble, int composit, int status, bool bHittest = FALSE);

    void SetPathGUI(MultiInputPanel_cls *pCMNum, wxString strPath);

    void Reload();

    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);
    bool HideAndShowTexture(MultiInputPanel_cls *pCMNumTex, 
			    int indexTexturePath);

    bool ReadStrLineMaterial(std::wistream &istream, wxString strFirstItem, wxString strLine);
    void SerializeMaterial(wxString& strOut);
};

#endif
