// (setq-c-offset 4)
// "clsIsosurface.cpp"

#ifndef _ISOSURFACE_H
#define _ISOSURFACE_H

#include "clsDataViewerBase.h"

#include "../clsBox.h"

class IsosurfProp_cls;
class MultiInputPanel_cls;
class MarchingCube_cls;

class Isosurface_cls : public DataViewerBase_cls, public Box_cls {
 public:
    Isosurface_cls(ParentObj_cls *pCParentObj, wxString strName = wxES);
    ~Isosurface_cls();

    IsosurfProp_cls *mpCIsosurfProp;

    ConfItemSTR_cls mCstrVolumeLink;
    ConfItemUINT_cls mCOptimize;
    ConfItemBOOL_cls mCbCastShadow;
    ConfItemBOOL_cls mCbUseVBO;
    ConfItemBOOL_cls mCbXRay;

    int mIndexThreshold;

    Material_cls *mpCMaterial;

    MarchingCube_cls *mpCMarchingCube;

    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);

    void SyncConfListTagIsosurf();

    void GLDrawSV();
    void GLDraw(bool bDrawGuideObject,
		int lightNum, int ensemble, int composit, int status,
		bool bHittest = FALSE);

    //static wxString GetStrInitNameCandidate();

    bool ReadStrLineMaterial(std::wistream &istream, wxString strFirstItem, wxString strLine);
    void SerializeMaterial(wxString& strOut);
};

#endif
