// (setq-c-offset 4)
// "clsParticle.cpp"

#ifndef _PARTICLE_H
#define _PARTICLE_H

#include "clsDataViewerBase.h"
#include "../clsAttribute.h"
//#include "../clsSceneObj.h"

#include "../../COMMON/clsThreadCommon.h"
#include "../../GLOBJ/clsVBOBaseObject.h"

class DrawParticle_cls;
class DrawParticleLargeVBO_cls;
class FileSequence_cls;
class MultiInputPanel_cls;
class MNumPainBase_cls;
class ParticleFormat_cls;
class ParticleForRender_cls;
class ParticleSequence_cls;
class ParticleSnap_cls;
class ViewerClone_cls;

#define _SORT_NONE      0
#define _SORT_Z         1
#define _SORT_Z_INV     2
#define _SORT_DISTANCE  3
#define _SORT_DISTANCE_INV 4
#define _SORT_TYPE      5
#define _SORT_OBJECT    6
#define _SORT_DISTANCE_ONLY 7

#define _PARTICLE_POINT  0
#define _PARTICLE_BILLBOARD 1
#define _PARTICLE_SPHERE 2

#define _P_INTERP_BY_INDEX 0
#define _P_INTERP_BY_ID    1

class ThreadParticlePrepareNext_cls : public ThreadInstance_cls {
 public:
    void SetParameters(ParticleForRender_cls *pCNext,
		       ParticleSnap_cls *pCSnap1, ParticleSnap_cls *pCSnap2,
		       ParticleSnap_cls *pCSnap0, ParticleSnap_cls *pCSnap3,
		       int frame1, int subframe, int seq, float interpFactor,
		       ViewerClone_cls *pCParticleClone,
		       ViewerClone_cls *pCParticleCloneForMat,
		       double NTNext, PositionAndDirection_cls CSortPos,
		       bool bStoreValue);
    ParticleForRender_cls *mpCNext;
    ParticleSnap_cls *mpCSnap1, *mpCSnap2, *mpCSnap0, *mpCSnap3;
    int mFrame1, mSubframe, mSeq;
    float mInterpFactor;
    double mNTNext;
    ViewerClone_cls *mpCParticleClone;
    ViewerClone_cls *mpCParticleCloneForMat;
    PositionAndDirection_cls mCSortPos;
    bool mbStoreValue;
	
    virtual wxThread::ExitCode Entry();
};

// mVpCAttribute ́AMaterialParticle_cls xn, ColorCurve_cls xn, Modifiers
// ̏ԂɂȂĂ邱ƂOƂēӏ̂ŁA
// Ԃۂ悤

class Particle_cls : public DataViewerBase_cls, public ThreadCommon_cls {
public:
    Particle_cls(ParentObj_cls *pCParentObj,
		  wxString strName = wxES);
    ~Particle_cls();

    ParticleSequence_cls *mpCParticleSequence;
    DrawParticle_cls         *mpCDrawParticle;
    DrawParticleLargeVBO_cls *mpCDrawParticleLargeVBO;
    ParticleFormat_cls *mpCParticleFormat;
        
    ParticleForRender_cls *mpCCurrent, *mpCNext;
    bool mbPreparingNextFinished;
    bool mbSkipDrawing; // 
    bool mbUsePrepareNext;
    bool mbExporting;

    FileSequence_cls* mpCExporterSequence;

    PositionAndDirection_cls mCCamPos, mCCamPosNext;

    ConfItemSTR_cls mCstrLink;
    ConfItemSTR_cls mCstrSortObject;
    ConfItemSTR_cls mCstrClassify;
    ConfItemSTR_cls mCstrPathExporter;
    ConfItemUINT_cls mCExportType;
    ConfItemUINT_cls mCExportDir;
    ConfItemUINT_cls mCClassifyType;
    ConfItemUINT_cls mCShaderDissolve;
    ConfItemUINT_cls mCTwoPass;
    ConfItemUINT_cls mCSortType;
    ConfItemFLOAT_cls mCSortFrequency;
    ConfItemUINT_cls mCInterpType; //Step Linear Hermite
    ConfItemUINT_cls mCInterpolateBy; //by index or ID;
    ConfItemUINT_cls mCVanishSizeType;
    ConfItemUINT_cls mCExtrapolateType;
    ConfItemBOOL_cls mCbDepthMask;
    ConfItemSTR_cls mCstrTexturePath[3];
    ConfItemUINT_cls mCDependDistance;
    ConfItemFLOAT_cls mCPointSizeFactor;
    ConfItemFLOAT_cls mCAlphaCrit;
    ConfItemFLOAT_cls mCDistanceBase;
    ConfItemINT_cls mCSphereDepth;
    ConfItemINT_cls mCTextureNum;
    ConfItemINT_cls mCInfoIndex, mCInfoID;
    ConfItemBOOL_cls mCbCastShadow;
    ConfItemBOOL_cls mCbTwistRandom;
    
    //wxString mstrPathChecked;

    int mIndexPathExporter, mIndexBtnExporter, mIndexBtnExportFormat;
    int mIndexParticleTexturePath[3];
    int mIndexSortFreq, mIndexSortObject;
    int mIndexPointSizeDepend;
    int mIndexDistanceBase;
    int mIndexPointSize;
    int mIndexAlphaCrit;
    int mIndexSphereDepth;

    void SyncConfListTagParticle();
    //void Clone(ViewerClone_cls &CClone);

    int  GetCurrentFrame();
    ParticleSnap_cls *GetPCCurrentSnap();
    wxString GetStrInfo();
    wxString GetStrPathCandid();
    long long SearchID();
    bool IsDataValid();
    bool IsExportValid();
    bool DoesUseIDLongLong();
    bool DoesStoreValue();
    int  GetNumMaterialLink(); 
    MaterialParticle_cls* GetPCMaterialLink(int i);
    bool IsPointAll();
    bool IsBillboardAll();
    bool IsSphereAll();
    bool DoesMatereialBaseExist(int type);
    void InitializeStatusForDrawingExe();
    void CheckStatusForDrawingExe();
    void CheckFileSequence();
    bool CheckFormat(int dataType);
    void ExportSnap(ParticleSnap_cls *pCSnap);
    void GLDrawBox(int status);
    void PrepareFilename(ParticleSnap_cls *pCSnap, int frame);
    bool PrepareDataNext(ViewerClone_cls *pCParticleClone,
			 ViewerClone_cls *pCParticleCloneForMat,
			 int composit, double NT, 
			 PositionAndDirection_cls CSortPos, bool bStoreValue);
    void GLDrawPointAll(int packVBO, int numParticle, bool bFullUpdateVBO,
			int lightNum, int ensemble);
    void GLDrawBillboardAll(int packVBO, int numParticle, bool bFullUpdateVBO,
			    int lightNum, int ensemble,
			    float baseMat16[16], float baseMat16Inv[16],
			    float viewMat16[16], float viewMat16Inv[16]);
    double GetFrameInfo(int &frame0, int &frame1, int &frame2, int &frame3, 
			int &subframe, double NT);
    std::vector < Particle_cls* > GetVpCDependency();
    void PrepareDraw(int ensemble, int composit, bool bPrepareNext = TRUE);
    void GLDraw(bool bDrawData, bool bDrawGuideObject, 
		int lightNum, int ensemble, int composit, int status, 
		float baseMat16[16], float baseMat16Inv[16],
		float viewMat16[16], float viewMat16Inv[16],
		bool bHittest = FALSE);
    void DrawTL(wxDC& dc, TLPanelGeom_cls* pCGeom,
		wxBitmap &CBitmapBuffer,
		int sashX, int posY, int panelWidth, int height,
		double normalizedWAMin, double normalizedWAMax);
    int GetUsedMemoryMB();
    void PrefetchData();
    void ReleaseMemoryData();

    void SetPathGUI(MultiInputPanel_cls *pCMNum, wxString strPath);
    void SetPathGUIExporter(MultiInputPanel_cls *pCMNum, wxString strPath);
    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);
    MultiInputPanel_cls *GetPCNewPanelExporter(wxWindow *pCWindow);
    
    MultiInputPanel_cls *GetPCNewPanelCommon(wxWindow *pCWindow);
    MultiInputPanel_cls *GetPCNewPanelMaterial(wxWindow *pCWindow, int indexMat);
    MultiInputPanel_cls *GetPCNewPanelColorCurve(wxWindow *pCWindow);
    MultiInputPanel_cls *GetPCNewPanelInfo(wxWindow *pCWindow);

    MultiInputPanel_cls *GetPCNewPanelFormatMain(wxWindow *pCWindow);
    MultiInputPanel_cls *GetPCNewPanelFormatHeader(wxWindow *pCWindow);
    MultiInputPanel_cls *GetPCNewPanelFormatBody(wxWindow *pCWindow);

    void Reload();
    void Export();
    void ExportFormat();
    void Expression();
    
    int  GetIndexColorCurveInit();
    void AddTextureCommand();
    void DeleteTextureCommand();
    void AddMaterialCommand();
    void DeleteHeaderCommand(int index);
    void AddHeaderCommand(int index);
    void UpDownHeaderCommand(int index, int direction);
    void UpdateHeaderCommand();
    void DeleteBodyCommand(int index);
    void AddBodyCommand(int index);
    void UpDownBodyCommand(int index, int direction);
    void UpdateBodyCommand();
    bool ProcNewMaterial(wxString strName);
    bool ProcNewColorCurve(wxString strName);
    void ProcDeleteMaterial(int index);

    void SyncMaterialParticle();
    bool HideAndShowMaterialCommon(MNumPainBase_cls* pCPain);
    bool HideAndShow(MNumPainBase_cls* pCPain);
    void UpdateButtonColorExporter(MNumPainBase_cls *pCPain);
    void UpdatePathColorExporter(MNumPainBase_cls *pCPain);
    void UpdateButtonColorMaterial(MNumPainBase_cls *pCPain);
    void UpdateFormatPanel(MNumPainBase_cls* pCPain);
    void UpdateHeaderPanel(MNumPainBase_cls* pCPain);
    void UpdateBodyPanel(MNumPainBase_cls* pCPain);
    void SetMaterialInfo(MNumPainBase_cls *pCPain);

    bool ReadStrLineMaterial(std::wistream &istream, wxString strFirstItem, wxString strLine);
    bool ReadStrLineFormat(std::wistream &istream, wxString strFirstItem, wxString strLine);
    void SerializeMaterial(wxString& strOut);
    void SerializeFormat(wxString& strOut);
};

#endif
