// (setq-c-offset 4)
// "clsStreamline.cpp"

#ifndef _STREAMLINE_H
#define _STREAMLINE_H

#include "clsDataViewerBase.h"

//#include "../../COMMON/clsThreadCommon.h"
#include "../../GLOBJ/clsVBOBaseObject.h"
#include "../../GLOBJ/clsVBOCommon.h"

class DrawStreamline_cls;
class MaterialStreamline_cls;
class MultiInputPanel_cls;
class MNumPainBase_cls;
class StreamlineForRender_cls;
class StreamlineFormat_cls;
class StreamlineProp_cls;
class StreamlineSequence_cls;
class StreamlineSnap_cls;
class ViewerClone_cls;

// mVpCAttribute ́AMaterialStreamline_cls xn, ColorCurve_cls xn, Modifiers
// ̏ԂɂȂĂ邱ƂOƂēӏ̂ŁA
// Ԃۂ悤

class Streamline_cls : public DataViewerBase_cls, public VBOCommon_cls {
public:
    Streamline_cls(ParentObj_cls *pCParentObj,
		   wxString strName = wxES);
    ~Streamline_cls();

    StreamlineProp_cls *mpCStreamlineProp;

    StreamlineSequence_cls *mpCStreamlineSequence;
    DrawStreamline_cls *mpCDrawStreamline;
    StreamlineFormat_cls *mpCStreamlineFormat;
    StreamlineForRender_cls *mpCCurrent, *mpCNext;

    ConfItemUINT_cls mCShaderDissolve;
    ConfItemBOOL_cls mCbXRay;
    ConfItemBOOL_cls mCbUseClrCurve;
    ConfItemBOOL_cls mCbRepeatCC;
    ConfItemUINT_cls mCStreamlineShader;

    // material͕邪A1̂݉肵ăo֐
    // mVpCAttribute ŊǗĂ̂ delete ͕sv
    // MaterialStreamline_cls *mpCMaterial;

    int mIndexMappingType;
    
    wxString GetStrInfo();
    wxString GetStrPathCandid();
    bool IsDataValid();

    void SyncConfListTagStreamline();
    void Clone(ViewerClone_cls &CClone);

    void CheckFileSequence();
    void ProcTrimming(double clipBoxMin[3], double clipBoxMax[3],
		      double matrix16[16], double NT,
		      float &smoothWidth, float &thinningFactor);
    void GLDrawBox(int status);
    void PrepareFilename(StreamlineSnap_cls *pCSnap, int frame);
    bool PrepareDataNext(ViewerClone_cls *pCStreamlineClone,
			 int composit, double NT);
    
    void PrepareDraw(int ensemble, int composit);
    void GLDraw(bool bDrawGuideObject, 
		int lightNum, int ensemble, int composit, int status, 
		bool bHittest = FALSE);
    void DrawTL(wxDC& dc, TLPanelGeom_cls* pCGeom,
		wxBitmap &CBitmapBuffer,
		int sashX, int posY, int panelWidth, int height,
		double normalizedWAMin, double normalizedWAMax);
    void PrefetchData();
    
    //int  GetNumAttribute(wxString strAttribName);
    void SetPathGUI(MultiInputPanel_cls *pCMNum, wxString strPath);
    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);
    MultiInputPanel_cls *GetPCNewPanelLineProp(wxWindow *pCWindow);
    MultiInputPanel_cls *GetPCNewPanelShader(wxWindow *pCWindow);
    MultiInputPanel_cls *GetPCNewPanelMaterial(wxWindow *pCWindow, int indexMat);

    MultiInputPanel_cls *GetPCNewPanelFormatMain(wxWindow *pCWindow);

    int  GetIndexColorCurveInit();
    void AddMaterialCommand();
    bool ProcNewMaterial(wxString strName);
    void ProcDeleteMaterial(int index);

    bool HideAndShowShader(MultiInputPanel_cls *pCMNumShader);
    bool HideAndShowTexture(MultiInputPanel_cls *pCMNumTex, int indexTexturePath);
    
    void SyncMaterialStreamline();
    void UpdateButtonColor(MNumPainBase_cls *pCPain);
    void SetMaterialInfo(MNumPainBase_cls *pCPain);

    void Reload();

    bool ReadStrLineMaterial(std::wistream &istream, wxString strFirstItem, wxString strLine);
    bool ReadStrLineFormat(std::wistream &istream, wxString strFirstItem, wxString strLine);
    void SerializeMaterial(wxString &strOut);
    void SerializeFormat(wxString &strOut);
};

#endif
