// (setq-c-offset 4)
// "clsVolumeBox.cpp"

#ifndef _VOLUME_BOX_H
#define _VOLUME_BOX_H

#include "clsDataViewerBase.h"
#include "../clsAttribute.h"
#include "../clsBox.h"

#include "../../COMMON/clsThreadCommon.h"
#include "../../GLOBJ/clsVBOBaseObject.h"

class DrawVolumeBox_cls;
class Material_cls;
class MultiInputPanel_cls;
class ShaderItem_cls;
class VolumeBoolean_cls;
class VolumeCoord_cls;
class VolumeMask_cls;
class VolumeFoRender_cls;
class VolumeSequence_cls;
class VolumeSnap_cls;
class ViewerClone_cls;

class ThreadVolumePrepareNext_cls : public ThreadInstance_cls {
 public:
    void SetParameters(VolumeFoRender_cls *pCNext,
		       VolumeSnap_cls *pCSnap1, VolumeSnap_cls *pCSnap2,
		       int frame1, float interpFactor, double NTNext,
		       ViewerClone_cls *pCVolumeBoxClone);
    VolumeFoRender_cls *mpCNext;
    VolumeSnap_cls *mpCSnap1, *mpCSnap2;
    int mFrame1;
    float mInterpFactor;
    double mNTNext;
    ViewerClone_cls *mpCVolumeBoxClone;
	
    virtual wxThread::ExitCode Entry();
};

class VolumeBox_cls : public DataViewerBase_cls, public Box_cls, public ThreadCommon_cls {
public:
    VolumeBox_cls(ParentObj_cls *pCParentObj,
		  wxString strName = wxES);
    ~VolumeBox_cls();

    VolumeSequence_cls *mpCVolumeSequence;
    DrawVolumeBox_cls *mpCDrawVolumeBox;

    VolumeFoRender_cls *mpCCurrent, *mpCNext;
    bool mbPreparingNextFinished;
    bool mbSkipDrawing;
    bool mbUsePrepareNext;

    ConfItemINT_cls mCSequenceOffsetZ;
    ConfItemINT_cls mCQuality, mCSubQuality;
    ConfItemFLOAT_cls mCTest;
    ConfItemINT_cls mCShaderQuality;
    ConfItemFLOAT_cls mCShaderFactor;
    ConfItemFLOAT_cls mCShaderDelta;
    ConfItemUINT_cls mCVolumeShader;//, mCTexFilter, mCTexWrap;
    ConfItemBOOL_cls mCbDiscard0Value;
    //ConfItemUINT_cls mCBlendType;
    ConfItemBOOL_cls mCbSelfShadow;
    ConfItemFLOAT_cls mCShadowFactor;
    ConfItemBOOL_cls mCbZStack;
    ConfItemBOOL_cls mCbRepeatCC;
    ConfItemINTARRAY_cls mCInfoIndex;

    bool mbZStackChecked;
    Material_cls *mpCMaterial;

    //int mIndexVolumePath;

    void SyncConfListTagVolumeBox();
    //void Clone(ViewerClone_cls &CClone, double NT);

    wxString GetStrInfo();
    wxString GetStrPathCandid();
    bool IsDataValid();
    //void ClearTexture();
    void InitializeStatusForDrawingExe();
    void CheckStatusForDrawingExe();
    void CheckFileSequence();
    void SetTexture3DParameter(Material_cls *pCMaterial);
    void ProcTrimming(double clipBoxMin[3], double clipBoxMax[3]);
    void PrepareFilename(VolumeSnap_cls *pCSnap, int frame, bool bZStack);
    void PrepareDataNext(int composit);
    
    //VolumeBoolean_cls* GetPCVolumeBoolean();
    VolumeCoord_cls* GetPCVolumeCoord();
    VolumeMask_cls* GetPCVolumeMask();

    ShaderItem_cls* GetPCShaderItem(int shaderType, bool bSelfShadow);
    void SetVolumeShader(int shaderType, Material_cls *pCMaterial,
			 int lightNum, 
			 double clipBoxMin[3], double clipBoxMax[3],
			 bool bSelfShadow, float alpha, float intervalGlobal);
    std::vector < VolumeBox_cls* > GetVpCDependency();
    void PrepareDraw(int ensemble, int composit, bool bPrepareNext = TRUE);
    void GLDraw(bool bDrawGuideObject, 
		int lightNum, int ensemble, int composit, int status, 
		bool bHittest = FALSE);
    void DrawTL(wxDC& dc, TLPanelGeom_cls* pCGeom,
		wxBitmap &CBitmapBuffer,
		int sashX, int posY, int panelWidth, int height,
		double normalizedWAMin, double normalizedWAMax);
    int GetUsedMemoryMB();
    void PrefetchData();
    void ReleaseMemoryData();

    void SetPathGUI(MultiInputPanel_cls *pCMNum, wxString strPath);
    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);
    MultiInputPanel_cls *GetPCNewPanelShader(wxWindow *pCWindow);
    MultiInputPanel_cls *GetPCNewPanelTexture(wxWindow *pCWindow);
    MultiInputPanel_cls *GetPCNewPanelOption(wxWindow *pCWindow);
    MultiInputPanel_cls *GetPCNewPanelInfo(wxWindow *pCWindow);
    
    void Rescale();
    void Reload();
    
    bool ReadStrLineMaterial(std::wistream &istream, wxString strFirstItem, wxString strLine);
    void SerializeMaterial(wxString& strOut);
};

#endif
