// (setq-c-offset 4)
// "clsCameraProp.h"

#include "clsCameraProp.h"
#include "clsStereoProp.h"

#include "../../PARAMETER/clsParameter.h"
#include "../../PARAMETER/clsParamGroup.h"

#include "../../COMMON/CommonDefinitions.h"

#define CLS CameraProp_cls

CLS::
CameraProp_cls(wxString strName, wxString strParentClassName) : Attribute_cls("CameraProp_cls", "CameraProp") {
    wxString strConfListLabel = "SceneObj::";  strConfListLabel << strName;
    strConfListLabel << wxT("::CameraProp");

    wxString strUpdate = "VIEW3D::PROPERTY_OBJECT";
    
    mCConfList.SetTag(strConfListLabel);
    mCConfList.Add(&mCbPassepartout, "Passepartout=", "1", strUpdate);
    mCConfList.Add(&mCbOverwriteGeometry, "OverwriteGeometry=", "0", strUpdate);
    mCConfList.Add(&mCWidthOverwrite, "Width=", "640", strUpdate);
    mCConfList.Add(&mCHeightOverwrite, "Height=", "480", strUpdate);
    mCConfList.Add(&mCAngleV, "AngleV=", "35", strUpdate);
    mCConfList.Add(&mCSizeOrthoV, "SizeOrthoV=", "5", strUpdate);
    mCConfList.Add(&mCTiltAngle, "TiltAngle=", "0", strUpdate);
    mCConfList.Add(&mCClipMin, "ClipMin=", "0.01", strUpdate);
    mCConfList.Add(&mCClipMax, "ClipMax=", "100", strUpdate);
    mCConfList.Add(&mC1stBufferSizeIndex, "1stBufSizeIdx=", "1", strUpdate);
    
    AddOneDimParam("AngleV", "V", 35);
    AddOneDimParam("SizeOthoV", "S", 5);
    AddOneDimParam("TiltAngle", "O", 0);
        
    ParamGroup_cls *pCParamGroupClip = GetPCNewParamGroup("Clip Min/Max", "Min", "Max");
    InitializeAndPushParam(pCParamGroupClip, 0.01, 100);
}

CLS::
~CameraProp_cls(){}

float CLS::
GetAspectRatioWonH(){
    return mCWidthOverwrite.GetBodyDOUBLE() / mCHeightOverwrite.GetBodyDOUBLE();
}

void CLS::
SyncronizeParam(wxString strObj){
    SyncronizeParamAndConf(strObj, "AngleV", mCAngleV);
    SyncronizeParamAndConf(strObj, "TiltAngle", mCTiltAngle);
    SyncronizeParamAndConf2(strObj, "Clip Min/Max", mCClipMin, mCClipMax);
}

void CLS::
SyncronizeConf(double time){
    SyncronizeConfAndParam(time, "AngleV", mCAngleV);
    SyncronizeConfAndParam(time, "TiltAngle", mCTiltAngle);
    SyncronizeConfAndParam2(time, "Clip Min/Max", mCClipMin, mCClipMax);
}
