// -*- c++ -*-
// (setq c-basic-offset 4)
// "clsFogProp.h"

#include "clsFogProp.h"

#include "../../PARAMETER/clsParamGroup.h"
#include "../../TIMELINE/clsTimeCtrl.h"

#define CLS FogProp_cls

CLS::
FogProp_cls() : Attribute_cls("FogProp_cls", "FogProp"){
    SetToDefaultParam();
}

void  CLS::
SetToDefaultParam(){
    mCConfList.Clear();

    wxString strUpdate = "VIEW3D::PROPERTY_OBJECT";

    mCConfList.SetTag("FogProp");
    mCConfList.Add(&mCFogType, "FogType=", "0", strUpdate);
    mCConfList.Add(&mCFogDensity, "FogDensity=", "0.01", strUpdate);
    mCConfList.Add(&mCFogStart, "FogStart=", "1", strUpdate);
    mCConfList.Add(&mCFogStart, "FogEnd=", "100", strUpdate);
    mCConfList.Add(&mCFogColor, "FogColor=", "1 1 1", strUpdate);
    mCConfList.Add(&mCbOverwriteBG, "FogOverwrite=", "0", strUpdate);

    double clr = 1;
    ParamGroup_cls *pCColor = GetPCNewParamGroup("FogColor", "R", "G", "B");
    InitializeAndPushParam(pCColor, clr, clr, clr);

    double density = 0.01;
    ParamGroup_cls *pCDensity = GetPCNewParamGroup("Density", "d");
    InitializeAndPushParam(pCDensity, density);

    double min = 1, max = 100;
    ParamGroup_cls *pCDistance = GetPCNewParamGroup("Distance", "st", "ed");
    InitializeAndPushParam(pCDistance, min, max);
}

void CLS::
SyncProp(wxString strObj){
    SyncronizeParamAndConf3(strObj, "FogColor", mCFogColor); 
    SyncronizeParamAndConf(strObj, "Density", mCFogDensity);
    SyncronizeParamAndConf2(strObj, "Distance", mCFogStart, mCFogEnd);
}

void CLS::
SetPropInfo(){
    double time = GetPCTimeCtrl()->GetCurrentNT();
    mCFogColor.SetBodyFromData
	(GetPCParamGroup("FogColor")->GetStrValues(time, FALSE));
    mCFogDensity.SetBodyFromData
	(GetPCParamGroup("Density")->GetStrValues(time, FALSE));

    std::vector < double > VDistance = GetPCParamGroup("Distance")->GetVInterpolatedValue(time, FALSE);
    mCFogStart.SetBodyFromData(VDistance[0]);
    mCFogEnd.SetBodyFromData(VDistance[1]);
}
