// (setq-c-offset 4)
// "clsTextProp.h"

#include "clsTextProp.h"

#include "../../PARAMETER/clsParameter.h"
#include "../../PARAMETER/clsParamGroup.h"

#include "../../COMMON/CommonDefinitions.h"

#define CLS TextProp_cls

CLS::
TextProp_cls(wxString strName, wxString strParentClassName) : Attribute_cls("TextProp_cls", "TextProp") {

    wxString strConfListLabel = "SceneObj::";  strConfListLabel << strName;
    strConfListLabel << wxT("::TextProp");

    wxString strUpdate = "VIEW3D::PROPERTY_OBJECT";

    mCConfList.SetTag(strConfListLabel);
#ifdef WIN32
    mCConfList.Add(&mCstrFontDesc, "TextFontDesc=", wxString::Format("%s 24 windows-932", _("Meiryo")), strUpdate);
#else
    mCConfList.Add(&mCstrFontDesc, "TextFontDesc=", "Arial 24", strUpdate);
#endif
    mCConfList.Add(&mCstrText, "TextText=", "Text", strUpdate);
    mCConfList.Add(&mCbExternal, "TextExternal=", "0", strUpdate);
    mCConfList.Add(&mCTextScale, "TextScale=", "0.2", strUpdate);
    
    ParamGroup_cls *pCParamGroupTextScale = GetPCNewParamGroup("Scale", "S");
    InitializeAndPushParam(pCParamGroupTextScale, 0.1);
}

CLS::
~TextProp_cls(){}

void CLS::
SyncronizeParam(wxString strObj){
    SyncronizeParamAndConf(strObj, "Scale", mCTextScale);
}

void CLS::
SyncronizeConf(double time){
    SyncronizeConfAndParam(time, "Scale", mCTextScale);
}
