// (setq-c-offset 4)
// "clsAttribute.cpp"

#ifndef _ATTRIBUTE_H
#define _ATTRIBUTE_H

#include "../COMMON/clsGetPC.h"

#include "../CONFITEM/clsConfItem.h"
#include "../CONFITEM/clsConfListContainer.h"
#include "../CONFITEM/clsStrName.h"

#include "../FILEIO/clsParser.h"

class ParamGroup_cls;
class SceneObj_cls;

class AttributeClone_cls : public StrName_cls, public ConfListContainer_cls {
 public:
    ~AttributeClone_cls();
    
    std::vector < ParamGroup_cls > mVCParamGroup;

    ConfItemSTR_cls mCstrAttributeName;
   
    //void CloneConfListFrom(Attribute_cls& CSrc);
    bool IsParamGroupTimeDepend();
    wxString GetStrProcCounter();
    wxString GetStrAttributeName();
    bool IsAttributeSameAs(wxString strAttribName);
    bool IsAttributeValidAndSameAs(wxString strAttribName);
    ParamGroup_cls* GetPCParamGroup(wxString strParamGroupName);
};

class Attribute_cls : virtual public ConfListContainer_cls, virtual public Parser_cls, virtual public GetPC_cls, virtual public StrName_cls {
public:
    Attribute_cls(wxString strAttribName, wxString strName);
    Attribute_cls(Attribute_cls &CSrc);

    ~Attribute_cls();
  
    ConfItemSTR_cls mCstrAttributeName;
    ConfItemBOOL_cls mCbShy;

    static void Delete(Attribute_cls *pCAttribute);
    static void DeleteBuffer(Attribute_cls *pCAttribute);
    void SyncBufferFromSrc();
    void SyncSrcFromBuffer(SceneObj_cls *pCObj);

    std::vector < ParamGroup_cls* > mVpCParamGroup;

    void SetConfListTagForSceneObjAttribute
	(wxString strName, wxString strObjName);

    void Clone(AttributeClone_cls &CClone);
    bool IsParamGroupTimeDepend();
    void GetVstrParamTag(wxString strParent, std::vector < wxString > &VstrTag);
    ParamGroup_cls* GetPCParamGroup(wxString strParamGroupName);
    wxString GetStrAttributeName();
    bool IsAttributeSameAs(wxString strAttributeName);
    bool IsAttributeValidAndSameAs(wxString strAttribName);
    
    SceneObj_cls* GetPCTargetSceneObj();
    ParamGroup_cls* GetPCNewParamGroup
	(wxString strParamGroupName, wxString str1, 
	 wxString str2 = wxEmptyString, wxString wx3 = wxEmptyString);
    void InitializeAndPushParam(ParamGroup_cls *pCParamGroup,
				double v0, double v1 = 0, double v2 = 0);
    void AddOneDimParam(wxString strParamGroupName, wxString strParamName, double ini);
    
    void SyncronizeParamForFilter
	(wxString strParamGroup,  std::vector < float > VValueNew);
    void SyncronizeParamForModifier
	(wxString strParamGroup, std::vector < float > VValueNew,
	 SceneObj_cls *pCObj);

    void DeselectKeyFrame(wxString strException);
    bool IsSelectedTLKeyExist();
    void DeleteSelectedTLKeyCommand(wxString strTag);
    void SetSelectedTLKeyTypeCommand(wxString strTag, int keyType, double ease);
    void MoveSelectedTLKeyCommand(wxString strTag, double dX, double dY);
    void RescaleParametersCommand(wxString strTag, double scale);

    void SyncronizeParamAndConf3(wxString strObj, wxString strParamGroup, ConfItemFLOATARRAY_cls &CConf);
    void SyncronizeParamAndConf2(wxString strObj, wxString strParamGroup, ConfItemFLOAT_cls &CConf0, ConfItemFLOAT_cls &CConf1);
    void SyncronizeParamAndConf(wxString strObj, wxString strParamGroup, ConfItemFLOAT_cls &CConf);
    void SyncronizeConfAndParam(double time, wxString strParamGroup, ConfItemFLOAT_cls &CConf);
    void SyncronizeConfAndParam2(double time, wxString strParamGroup, ConfItemFLOAT_cls &CConf0, ConfItemFLOAT_cls &CConf1);
    

    bool ReadStrLine(std::wistream &istream, wxString strFirstItem, wxString strLine);
    void Serialize(wxString& strOut);
};

#endif
