// (setq-c-offset 4)
// "clsCamera.cpp"

#ifndef _CAMERA_H
#define _CAMERA_H

#include "clsSceneObj.h"

#define _CAMERA_INVALID         9999

class CameraProp_cls;
class FocalBlurProp_cls;
class MultiInputPanel_cls;
class StereoProp_cls;

class Camera_cls : public SceneObj_cls {
public:
    Camera_cls(ParentObj_cls *pCParentObj, wxString strName = wxES);
    ~Camera_cls();

    ConfItemUINT_cls mCType;

    CameraProp_cls *mpCCameraProp;
    StereoProp_cls *mpCStereoProp;
    FocalBlurProp_cls *mpCFocalBlurProp;

    int mIndexAngleV, mIndexSizeOrtho, mIndexTilt;
    int mIndexClipMinMax, mIndex1stBuffer;
    int mIndexParallax, mIndexEyeType;
    int mIndexBlurType, mIndexBlurSize;
    int mIndexTarget;

    bool mbSkipDraw;

    wxSize GetSize();
    float GetAngleL();
    float GetSizeOrthoL();
    std::vector < double > GetVMinMax(double NT);
    float GetAspectRatioWonH();
    void GLDraw(bool bDrawLightCam, int status, bool bHittest = FALSE);
    void GLDrawPerspective();
    void GLDrawOrthogonal();
    void GLDrawFisheye();
    std::vector < float > GetVPasspartoutInfo();
    void GLDrawPassepartoutMain(float angleW, float angleH, float angleCanvas);
    void GLDrawPassepartout(double canvasAngle);
    void GLDrawPassepartoutOrtho(double canvasSizeOrtho);

    MultiInputPanel_cls *GetPCNewPanelCamera(wxWindow *pCWindow);
    MultiInputPanel_cls *GetPCNewPanelFocalBlur(wxWindow *pCWindow);
    MultiInputPanel_cls *GetPCNewPanelStereo(wxWindow *pCWindow);
    bool HideAndShowCamera(MultiInputPanel_cls *pC);
    bool HideAndShowStereo(MultiInputPanel_cls *pC);
    bool HideAndShowFocalBlur(MultiInputPanel_cls *pC);
};

#endif
