// (setq-c-offset 4)
// "clsPrimitive.cpp"

#ifndef _LIGHTSOURCE_H
#define _LIGHTSOURCE_H

#include "clsSceneObj.h"

#define _LIGHT_PARALLEL  0
#define _LIGHT_POINT     1
#define _LIGHT_SPOT 2
#define _LIGHT_INVALID  9999

#define _LIGHT_FADE_OFF 0
#define _LIGHT_FADE_1   1
#define _LIGHT_FADE_2   2

#define _LIGHT_MAX 3

class MaterialLight_cls;
class MultiInputPanel_cls;

class LightSource_cls : public SceneObj_cls {
public:
    LightSource_cls(ParentObj_cls *pCParentObj, 
		    wxString strType, wxString strName = wxES);
    ~LightSource_cls();

    ConfItemUINT_cls mCType;
    ConfItemBOOL_cls mCbValid, mCbXRay;
    ConfItemBOOL_cls mCbCastShadow;
    ConfItemUINT_cls mCFadeType;
    ConfItemFLOAT_cls mCFadeDistance;
    ConfItemFLOAT_cls mCSpotAngle;
    ConfItemFLOAT_cls mCSpotExponent;
    ConfItemFLOAT_cls mCSoftSize;
    
    MaterialLight_cls *mpCMaterial;

    int mIndexFadeDistance;
    int mIndexSpot;

    wxString GetStrInitName();    
    MaterialLight_cls* GetPCMaterial();
    static wxString msstrTypeName[_LIGHT_MAX];
    static wxString GetStrInitNameCandidate(int type);
    static int GetTypeFromStr(wxString strTypeName);

    void SyncConfListTagLightSource();

    void GLSetAttenuation(int &lightCurrent);
    void GLSetSpotEffect(int &lightCurrent);
    void SetGLLight(int &lightCurrent, int ensemble);
    void GLDrawMain(bool bDrawLightCam, int status, bool bHittest); 
    void GLDraw(bool bDrawLightCam, int &lightCurrent,
		int ensemble, int status,
		bool bHittest = FALSE);
    void GLDrawXray(bool bDrawLightCam, int status);

    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);
    bool HideAndShow(MultiInputPanel_cls *pC);
    
    bool ReadStrLineMaterial(std::wistream &istream, wxString strFirstItem, wxString strLine);
    void SerializeMaterial(wxString& strOut);
};

#endif
