// (setq-c-offset 4)
// "clsMaterial.cpp"

#ifndef _MATERIAL_H
#define _MATERIAL_H

//#include "clsMaterialBase.h"
#include "clsAttribute.h"
#include "clsMaterialOption.h"
#include "clsMaterialTexture.h"

#define _MATERIAL_SHADER_CLASSIC 0
#define _MATERIAL_SHADER_GOURAUD 1
#define _MATERIAL_SHADER_PHONG   2
#define _MATERIAL_SHADER_TOON    3
#define _MATERIAL_SHADER_NORMAL  4
#define _MATERIAL_SHADER_CUSTOM  5

class ImageSequence_cls;
class MultiInputPanel_cls;

class Material_cls : public Attribute_cls, public MaterialOption_cls, public MaterialTexture_cls{
public:
    Material_cls(wxString strObjName, wxString strParentClassName);
    ~Material_cls();

    wxString mstrParentClassName;

    ConfItemSTR_cls mCstrLink;
    ConfItemUINT_cls mCShaderType;
    ConfItemUINT_cls mCShaderDissolve;
    ConfItemBOOL_cls mCbShaderFlat, mCbVolumeTrim;
    ConfItemFLOAT_cls mCToonThreshold, mCToonBoldness;

   
    Material_cls* GetPCLinked(wxString strObjectClassName);

    void SyncConfListTag(wxString strName);

    int mReferenceCounter;
    bool DoesUseTexture();
    float GetAlpha();
    float GetShininess();
    std::vector < float > GetVColor(wxString strTag);
    void  GetColorInfo(float ambient[3], float diffuse[3], float specular[3], float &shininess);
    void  SetGLMaterialSetting();
    //void  SetGLLightSetting(int lightCurrent);
    
    void BeginShader(int lightNum, int ensemble, bool bForceUseTexture = false);
    void BeginLineShader(int ensemble);
    void EndShader();
    void EndLineShader();
    
    bool ReadStrLine(std::wistream &istream, wxString strFirstItem, wxString strLine);
    void Serialize(wxString& strOut);
};

#endif
