// (setq-c-offset 4)
// "clsMaterialOption.h"

#include "clsMaterialOption.h"

#include "../MYGL/clsGLExtention.h"
#include "../WIDGETCTRL/MULTIINPUT/clsMultiInputPanel.h"

#include "../COMMON/CommonDefinitionsGL.h"

#define CLS MaterialOption_cls

CLS::
MaterialOption_cls(){
    mbUseBlendType = FALSE;
}

void CLS::
AddItemToConfList(ConfItemList_cls &CConfList, wxString strUpdate){
    CConfList.Add(&mCbAdditive, "Additive=", "0", strUpdate);
    CConfList.Add(&mCbCullBack, "CullBack=", "1", strUpdate);
    CConfList.Add(&mCbDepthMask, "DepthMask=", "1", strUpdate);
    CConfList.Add(&mCbWireframe, "Wireframe=", "0", strUpdate);
    CConfList.Add(&mCBlendType, "BlendType=", "0", strUpdate);
}

MultiInputPanel_cls* CLS::
GetPCNewPanelOption(wxWindow *pCWindow, bool bLine1, bool bLine2){
    MultiInputPanel_cls *pC = 
	new MultiInputPanel_cls(pCWindow, "Option"/*, TRUE*/);
    
    pC->mTextWidth = 100;
    if (bLine1 == TRUE){
	pC->CombineSizer(2);
	pC->CombineConfItem(mCbCullBack, _("Cull Back"));
	pC->CombineConfItem(mCbAdditive, _("Additive"));
    }
    if (bLine2 == TRUE){
	pC->CombineSizer(2);
	pC->CombineConfItem(mCbDepthMask, _("Depth Mask"));
	pC->CombineConfItem(mCbWireframe, _("Wire Frame"));
    }
    
    pC->FinishSetting();
    return pC;
}

void CLS::
SetAlphaBlendFunc(){
    GetPCGLExtentions()->
	BlendFuncSeparate(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA,
			  GL_ONE, GL_ONE_MINUS_SRC_ALPHA);
}

void CLS::
SetBlendFunc(){
    if (mbUseBlendType == FALSE){
	if (mCbAdditive.GetBodyBOOL() == TRUE)
	    GetPCGLExtentions()->
		BlendFuncSeparate(GL_SRC_ALPHA, GL_ONE,
				  GL_ONE, GL_ONE_MINUS_SRC_ALPHA);
	else
	    GetPCGLExtentions()->
		BlendFuncSeparate(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA,
				  GL_ONE, GL_ONE_MINUS_SRC_ALPHA);
    }
    else
	GetPCGLExtentions()->
	    BlendFuncSeparate(GL_ONE, GL_ONE_MINUS_SRC_ALPHA,
			      GL_ONE, GL_ONE_MINUS_SRC_ALPHA);
}

void CLS::
SetDepthMask(){
    if (mCbDepthMask.GetBodyBOOL() == TRUE)
	glDepthMask(GL_TRUE);
    else
	glDepthMask(GL_FALSE);
}
