// (setq-c-offset 4)
// "clsMeshObj.cpp"

#ifndef _MESHOBJ_H
#define _MESHOBJ_H

#include "clsSceneObj.h"

#include "../COMMON/clsVectorMath.h"
#include "../GLOBJ/clsVBOBaseObject.h"
#include "../FILEIO/clsAsciiReader.h"
#include "../MESH/clsMeshBase2.h"
#include "../MESH/clsWavefrontMaterial.h"

class MultiInputPanel_cls;

class MeshObj_cls : public SceneObj_cls, public VectorMath_cls, public AsciiReader_cls {
 public:
    MeshObj_cls(ParentObj_cls *pCParentObj, 
		wxString strName = wxES);
    ~MeshObj_cls();

    ConfItemSTR_cls mCstrPath;
    ConfItemUINT_cls mCUseMaterial;
    ConfItemBOOL_cls mCbCastShadow;
    ConfItemBOOL_cls mCbXRay;

    ConfItemUINT_cls mCWavefrontCoord;
    ConfItemBOOL_cls mCbWavefrontUseEmit;
    
    wxString mstrLoaded, mstrVBOMade;
    wxString mstrLoadedObjectName;
    bool mbMaterialExist;
    int mCalledMaterialType;

    Material_cls *mpCMaterial;
    
    // -- Mesh2
    
    MeshBase2_cls mCMesh2;
    
    static wxString GetStrInitNameCandidate();

    wxString GetStrInfo();
    void CheckLoad();
    void CheckVBO();
    void CheckTree();
    
    void ClearMesh();
    void ReadMesh();
    void GLDrawSV();
    void GLDraw(int lightNum, int ensemble, int status);

    bool ReadStrLineMaterial(std::wistream &istream, wxString strFirstItem, wxString strLine);
    void SerializeMaterial(wxString& strOut);

    void SetPathGUI(MultiInputPanel_cls *pCMNum, wxString strPath);
    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);
    MultiInputPanel_cls *GetPCNewPanelFormatWavefrontObj(wxWindow *pCWindow);
    void Reload();
};

#endif
