// (setq-c-offset 4)
// "clsPrimitive.cpp"

#ifndef _PRIMITIVE_H
#define _PRIMITIVE_H

#include "clsSceneObj.h"

#include "../GLOBJ/clsVBOBaseObject.h"

#define _PRIMITIVE_EMPTY  0
#define _PRIMITIVE_BOX    1
#define _PRIMITIVE_SPHERE 2
#define _PRIMITIVE_PLANE  3
#define _PRIMITIVE_CONE   4
#define _PRIMITIVE_CYLINDER 5

#define _PRIMITIVE_INVALID 9999

#define _PRIMITIVE_MAX 6

class Material_cls;
class MultiInputPanel_cls;

class Primitive_cls : public SceneObj_cls {
public:
    Primitive_cls(ParentObj_cls *pCParentObj, 
		  wxString strType, wxString strName = wxES);
    ~Primitive_cls();

    ConfItemUINT_cls mCType;
    //ConfItemUINT_cls mCMapping;
    ConfItemINT_cls mCSphereDepth;
    ConfItemBOOL_cls mCbCastShadow;
    ConfItemBOOL_cls mCbXRay;

    Material_cls *mpCMaterial;

    int mIndexDepth;

    wxString GetStrInitName();
    static wxString msstrTypeName[_PRIMITIVE_MAX];
    static wxString GetStrInitNameCandidate(int type);
    static int GetTypeFromStr(wxString strTypeName);

    void SyncConfListTagPrimitive();

    bool IsInside(float fX, float fY, float fZ);

    VBOBaseObject_cls mCVBOObject;

    void GLDrawEachType(bool bDrawGuideObject, int mapping, 
			int objectState = _VBO_OBJECT);
    void GLDrawSV();
    void GLDrawBox();
    void GLDraw(bool bDrawGuideObject, 
		int lightNum, int ensemble, int composit, int status,
		bool bHitTest);

    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);
    bool HideAndShow(MultiInputPanel_cls *pC);
    bool HideAndShowTexture(MultiInputPanel_cls *pCMNumTex, int indexTexturePath);

    bool ReadStrLineMaterial(std::wistream &istream, wxString strFirstItem, wxString strLine);
    void SerializeMaterial(wxString& strOut);
};

#endif



