// (setq-c-offset 4)
// "clsSceneObj.cpp"

#ifndef _SCENE_OBJ_H
#define _SCENE_OBJ_H

#include "../CONFITEM/clsConfItem.h"
#include "../CONFITEM/clsConfListContainer.h"

#include "../COMMON/clsGetPC.h"
#include "../COMMON/clsTensorMath.h"
#include "../MYGL/clsPosition.h"
#include "../MYGL/clsGLExtention.h"
#include "../FILEIO/clsParser.h"

#include "../PARAMETER/clsParamGroup.h"

#include "../COMMON/CommonDefinitionsWX.h"

#include <wx/wx.h>

#include <list>
#include <vector>

#define _PARENTOBJ_ROOT 0
#define _PARENTOBJ_OBJ  1

#define _MODIFIER_FH 0
#define _MODIFIER_LH 1

class Attribute_cls;
class Material_cls;
class ModifierBase_cls;
class SceneObj_cls;
class SceneObjInstance_cls;

class ParentObj_cls : public GetPC_cls, public Parser_cls {
 public:
    ParentObj_cls(int type);
    ~ParentObj_cls();
    void Clear();

    void GetVPCList(std::vector < SceneObj_cls* > &VpCList);

    int mSortOrder;
    int mParentObjType;
    int mProcessedInInstanceLoop;
    
    // foOɖO邽߂ɁAꎞIɂɒuĂ
    //ConfItemSTR_cls mCstrName;

    wxString mstrClassName;
    std::list < SceneObj_cls* > mVpCObj;
    std::list < SceneObj_cls* >::iterator GetIterFromP(SceneObj_cls* pC);
    std::list < SceneObj_cls* >::iterator GetIterFromIndex(int index);
    SceneObj_cls* GetPCFromIndex(int index);
    int GetIndexFromPC(SceneObj_cls *pC);

    wxString GetStrNewCandidate(wxString strCandidate);
    void GetAllObjectsName(wxArrayString &CArrayStr);
    void GetDirectChildrensName(wxArrayString &CArrayStr);
    int  GetActiveLightNumRoot(bool bForShadow = FALSE);

    bool IsSameAs(wxString strClassName);
    bool IsObjExist(wxString strName, SceneObj_cls *pCException = NULL);
    bool IsAncestor(wxString strName);
    SceneObj_cls* GetPCFromName(const wxString& strName);
    SceneObj_cls* GetPCWorld();
    Attribute_cls* GetPCAttributeFromAddress(wxString strAddress);
    
    wxString GetStrName();
    
    void ClearProcessedMarkInInstanceLoop();
    void InitializeStatusForDrawing();
    void CheckStatusForDrawing();

    void InsertSceneObjNative(SceneObj_cls *pCObj, int pos);
    void ProcessSortSelection(std::vector < SceneObj_cls* > &VpCNewList,
			      std::vector < SceneObj_cls* > VpCSelectiedObject);
    
    void InheritChilds(SceneObj_cls *pCFrom);
    void RescaleParametersRoot(double scale);
    void GetTotalUsedMemoryMB(int& memoryMB);
    void Prefetch();
    void ReleaseMemory();
};

class SceneObj_cls : public ParentObj_cls, public ConfListContainer_cls, public TensorMath_cls, public GLCheckError_cls {
    friend class Camera_cls;
    friend class DataViewerBase_cls;
    friend class LightSource_cls;
    friend class MeshObj_cls;
    friend class ParentObj_cls;
    friend class Primitive_cls;
    friend class TextObj_cls;
    friend class SceneObjCtrl_cls;
    friend class World_cls;
private:
    SceneObj_cls(ParentObj_cls *pCParentObj);
    virtual ~SceneObj_cls();
public:
    ParentObj_cls* mpCParentObj;
    double mModifierMatrix[16];
    int    mGeneratedDepth;
    
    ConfItemSTR_cls  mCstrName;
    ConfItemBOOL_cls mCbVisible, mCbShy;
    std::vector < ParamGroup_cls* > mVpCParamGroup;
    std::list < Attribute_cls* > mVpCAttribute;
    std::list < Attribute_cls* > mVpCDataProc;

    void Initialize(wxString strName);
    void ProcRename(wxString strNewName);
    void SyncConfListTag();

    wxArrayString GetAstrAttribList();
    
    std::vector < SceneObjInstance_cls* > GetVNewPCInstance();
    
    //bool IsSameAs(wxString strClassName);
    int GetChildIndex();
    int GetActiveLightNum(bool bForShadow);
    void GetVstrParamTag(std::vector < wxString > &VstrTag);
    ParamGroup_cls* GetPCParamGroup(wxString strFirstItem, wxString strTag = wxES);
    ConfItem_cls* GetPCItemInAttrib(wxString strAttribName, wxString strTag);
    Material_cls* GetPCMaterial();
    void ClearModifierMatrix();
    std::vector < double > GetPositionGlobal(double NT, double *pPosOffset = NULL);
    void GetMatrix16(double matrix[16], double NT, double *pPosOffset = NULL);
    void ApplyTranslate(double matrix[16], double NT);
    void ApplyRotate(double matrix[16], double NT);
    void ProcTexSpaceModBegin();
    void ProcTexSpaceModEnd();
    void BasicGLMatrix();
    void GLDraw(bool bDrawGuideObject, bool bDrawLightCam, bool bDrawData, 
		int &lightCurrent, int ensemble, int composit, int status,
		float baseMat16[16], float baseMat16Inv[16],
		float viewMat16[16], float viewMat16Inv[16],
		bool bHitTest);
    void GLDrawXray(bool bDrawGuideObject, bool bDrawLightCam, bool bDrawData,
		    int &lightCurrent, int ensemble, int composit, int status,
		    float baseMat16[16], float baseMat16Inv[16],
		    float viewMat16[16], float viewMat16Inv[16],
		    bool bHitTest);
    
    std::list < Attribute_cls* >::iterator GetIterAttributeFromIndex(int index);
    std::list < Attribute_cls* >::iterator GetIterAttributeFromPC(Attribute_cls *pCAttrib);
    //Attribute_cls* GetPCAttributeFromName(wxString strName);
    Attribute_cls* GetPCAttributeFromAttribName(wxString strAttibName, int skip = 0);
    Attribute_cls* GetPCAttribute(wxString strName, int skip = 0);
    Attribute_cls* GetPCAttributeFromIndex(int index);
    ModifierBase_cls* GetPCValidModifier(wxString strName);

    std::list < Attribute_cls* >::iterator GetIterDataProcFromIndex(int index);
    ModifierBase_cls* GetPCDataProc(wxString strName, int skip = 0);
    ModifierBase_cls* GetPCDataProcFromIndex(int index);

    int GetIndexModifierInit();
    int GetIndexModifier(Attribute_cls* pCAttribute);
    int GetIndexDProc(Attribute_cls *pCAttribute);
    int GetNumAttribute(wxString strAttribName);
    bool IsAttributesTimeDepend();
    bool IsParamGroupTimeDepend();
    bool IsAttributeExist(wxString strName);
    bool IsDataProcExist(wxString strName);
    bool IsDataProcClsExist(wxString strName);
    wxString GetStrBaseName();
    wxString GetStrName();
    wxString GetStrTag();
    wxString GetStrTag(ParamGroup_cls *pCParamGroup);
    wxString GetStrParentName();
    wxString GetStrUniqueName(wxString strName);

    int GetUsedMemoryMB();
    void PrefetchData();
    void ReleaseMemoryData();

    void ProcModifier(wxString strType, void *pTgt, void *pParam/*, int type*/);
    
    void DeselectKeyFrame(wxString strException);

    void AddModifierCommand(wxString strClassName, wxString strNameCandid);
    void DeleteModifierCommand(wxString strName);
    void MoveModifierCommand(wxString strName, int indexTo);
    void SetModifierValidityCommand(wxString strName, bool bValidity);

    void AddDataProcCommand(wxString strClassName, wxString strNameCandid);
    void DeleteDataProcCommand(wxString strName);
    void MoveDataProcCommand(wxString strName, int indexTo);
    void SetDataProcValidityCommand(wxString strName, bool bValidity);

    void AddMaterialCommand();

    bool IsSelectedTLKeyExist();
    void DeleteSelectedTLKeyCommand();
    void SetSelectedTLKeyTypeCommand(int keyType, double ease);
    void MoveSelectedTLKeyCommand(double dNX, double dY);

    void SetParamD3Command(wxString strParamGroup, double dValue[3]);

    void SetParam3Command(wxString strParamGroup, double value[3]);

    bool ProcNewModifier(Attribute_cls *pCAttrib);
    bool ProcNewTracking(wxString strName);
    bool ProcNewArrayCopy(wxString strName);
    bool ProcNewModifyApparentSize(wxString strName);
    bool ProcNewModifyParticleSize(wxString strName);
    bool ProcNewNestedVolume(wxString strName);
    bool ProcNewParticleBoolean(wxString strName);
    bool ProcNewParticleFiltering(wxString strName);
    bool ProcNewParticleTweak(wxString strName);
    bool ProcNewTrimming(wxString strName);
    bool ProcNewTexSpaceMod(wxString strName);
    bool ProcNewSequenceRemapMod(wxString strName);
    bool ProcNewVolumeMask(wxString strName);
    bool ProcNewDProc(Attribute_cls *pCAttrib);
    bool ProcNewVolumeCoord(wxString strName);
    bool ProcNewVolumeBoolean(wxString strName);
    bool ProcNewVolumeDownsize(wxString strName);
    bool ProcNewParticleDownsize(wxString strName);
    bool ProcNewParticleExclude(wxString strName);
    bool ProcNewParticleMerge(wxString strName);
    bool ProcNewStreamFiltering(wxString strName);
    bool ProcNewStreamSetAlpha(wxString strName);
    bool ProcNewStreamTransform(wxString strName);
    bool ProcNewMaterial(wxString strName);
    bool ProcNewColorCurve(wxString strName);
    bool ProcNew(wxString strFirsttem, wxString strLine);
    bool ProcDelete(wxString strFirstItem, wxString strLine);
    bool ProcMove(wxString strFirstItem, wxString strLine);

    void RescaleParameters(double scale);

    bool ReadStrLine(std::wistream &istream, wxString strFirstItem, wxString strLine);

    void SerializePropertiesOnly(wxString& strOut);
    void Serialize(wxString& strOut);

    int mReferenceCounter;
    void Refer();
    void ReferRelease();

    friend bool operator<(const SceneObj_cls& a, const SceneObj_cls& b);
    friend bool operator>(const SceneObj_cls& a, const SceneObj_cls& b);
    static bool ComparePointer(const SceneObj_cls* a, const SceneObj_cls* b);
};

class SceneObjInstance_cls : public TensorMath_cls {
    friend class Camera_cls;
    friend class LightSource_cls;
    friend class ParentObj_cls;
    friend class Primitive_cls;
    friend class SceneObjCtrl_cls;
    friend class SceneObj_cls;
    friend class VolumeBox_cls;
    friend class Particle_cls;
    friend class HeightField_cls;
 public:
    
    SceneObjInstance_cls(SceneObj_cls *pCSceneObj);
    SceneObj_cls *mpCSceneObjLink;
  
    double mMatrix[16];
    double mDist2ForSort;
    int mStatus;
    int mModifierDepth;
    
    void GLDraw(bool bDrawGuideObject, bool bDrawLightCam, bool bDrawData,
		int &lightCurrent, int ensemble, int composit,
		float baseMat16[16], float baseMat16Inv[16],
		float viewMat16[16], float viewMat16Inv[16],
		bool bHitTest);
    void GLDrawXray(bool bDrawGuideObject, bool bDrawLightCam, bool bDrawData,
		    int &lightCurrent, int ensemble, int composit,
		    float baseMat16[16], float baseMat16Inv[16],
		    float viewMat16[16], float viewMat16Inv[16],
		    bool bHitTest);
    void SetDistance(Position_cls mCCamPos, double NT);

    friend bool operator<(const SceneObjInstance_cls& a, const SceneObjInstance_cls& b);
    friend bool operator>(const SceneObjInstance_cls& a, const SceneObjInstance_cls& b);
    static bool ComparePointer(const SceneObjInstance_cls* a, const SceneObjInstance_cls* b);
};

#endif

