// (setq c-basic-offset 4)
// "clsSceneObjCtrl.cpp"

#ifndef _SCENEOBJ_CTRL_H_
#define _SCENEOBJ_CTRL_H_

#include "clsSceneObj.h"

#include "../CONFITEM/clsConfItem.h"
#include "../CONFITEM/clsConfListContainer.h"
#include "../FILEIO/clsParser.h"
#include "../MYGL/clsGLExtention.h"

#include "../WIDGETCTRL/clsWidgetCommon.h"

#include <vector>

class Hittest_cls;

class SceneObjCtrl_cls : public WidgetCommon_cls, public GLCheckError_cls, public ParentObj_cls, public ConfListContainer_cls {
 public:
    SceneObjCtrl_cls();
    ~SceneObjCtrl_cls();

    SceneObj_cls* mpCActiveObject;
    std::vector <SceneObj_cls*> mVpCSelectedObject;

    ConfItemSTR_cls mCstrActiveItemName;

    void SetToDefault();
    void Clear();

    void GLDrawObjects(bool bDrawGuideObject, bool bDrawLightCam,
		       bool bDrawData,
		       int &lightCurrent, int ensemble, int composit,
		       PositionAndDirection_cls &CCamPos,
		       PositionAndDirection_cls &CCamPosNext,
		       float baseMat16[16], float baseMat16Inv[16],
		       float viewMat16[16], float viewMat16Inv[16],
		       Hittest_cls *pCHitTest, bool bHitTest);

    void ClearSelection();
    wxString GetStrSelf();
    wxString GetActiveObjectName();
    ConfItem_cls* GetPCConfItem(wxString strTag);
    ParamGroup_cls* GetPCParamGroup(wxString strTag);
    Parameter_cls* GetPCParameter(wxString strTag);
    int GetStatus(SceneObj_cls *pCObj);
    bool IsSelected(SceneObj_cls *pCObj);
        
    void RemoveSelectedObject(int index);
    void Detatch(SceneObj_cls *pCObj);
    void Select(wxString strObjName, bool bAdditional, bool bUpdateGUI = TRUE, bool bToggle = FALSE);
    void Deselect(wxString strObjName, bool bUpdateGUI = TRUE);
    void DeselectKeyFrame(wxString strException = wxES);
    void SelectActitiveObjectOnly();
    bool ChangeKeyTypeByModKey(wxString strTag, int keyIndex, 
			       bool bCtrl, bool bShift, bool bAlt);
    bool SelectKeyFrame(wxString strTag, int keyIndex, 
			bool bSelect, bool bAdditional,
			double resolution = _RES_DEFAULT);

    void RemoveTagHeader(wxString& strTag);
    wxString GetStrUniqueName(wxString strName);
    wxString GetStrCommandParamGroup(wxString strTag, 
				     ParamGroup_cls *pCParamGroup);
    void SortSelectionList();
    bool IsSelectedTLKeyExist();
    void DeleteSelectedTLKeyCommand();
    void SetSelectedTLKeyTypeCommand(int keyType, double ease);
    void MoveSelectedTLKeyCommand(double dNX, double dY);
    void SetVisibleMultipleCommand(bool bVisibleNew);
    void ToggleVisibleCommand(wxString strName);
    
    void SetValidMultipleCommand(bool bValidNew);
    void ToggleValidCommand(wxString strName);
    
    void MoveItemMultipleToCommand(wxString strNameTo, bool bAdditional);
    void MoveItemToCommand(wxString strNameTo, bool bAdditional);
    void MoveModifierCommand(wxString strTag, int indexTo);
    void SetMultipleToChildCommand(wxString strNameTo);
    void SetToChildCommand(wxString strNameTo);
    void RenameCommand(wxString strNameOld, wxString strNameNew);
    void AppendCommandBase
	(wxString strName, wxString strClassName, wxString strBaseName);
    wxString AppendPrimitiveCommand(int type, wxString strNewName = wxES);
    wxString AppendLightCommand(int type, wxString strNewName = wxES);
    wxString AppendSceneObjCommand(wxString strBaseName, wxString strNewName = wxES);
    void DuplicateObjectCommand();
    void DeleteItemsCommand();
    
    void MoveItemNative(SceneObj_cls *pCFrom, 
			wxString strToParentName, int index1);
    bool ProcMove(std::wistream &istream, 
		  wxString strFirstItem, wxString strLine);
    bool ProcSetToChild(std::wistream &istream, 
			wxString strFirstItem, wxString strLine);
    bool ProcRename(std::wistream &istream, 
		    wxString strFirstItem, wxString strLine);
    bool ProcNew(std::wistream &istream, 
		 wxString strFirstItem, wxString strLine);
    void DeleteSceneObj(SceneObj_cls *pCTgt);
    bool ProcDelete(std::wistream &istream, 
		    wxString strFirstItem, wxString strLine);
    bool ProcReadProperties(std::wistream &istream, 
			    wxString strFirstItem, wxString strLine);
    bool ProcReadObj(std::wistream &istream,
		     wxString strFirstItem, wxString strLine);

    bool ReadStrLine(std::wistream &istream,
		     wxString strFirstItem, wxString strLine);

    void Serialize(wxString &strOut);
};

#endif
