// (setq c-basic-offset 4)
// "clsSceneObjViewerBase.h"

#include "clsSceneObjViewerBase.h"

#include "../PREFERENCE/clsShortcut.h"
#include "../SCENEOBJ/clsSceneObj.h"
#include "../SCENEOBJ/clsSceneObjCtrl.h"
#include "../WIDGETCTRL/EX/wxPanelEX.h"
#include "../WIDGETCTRL/WX/clsFontProvider.h"

#include "../COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;

#define CLS SceneObjViewerBase_cls

SceneObjViewerBase_cls::
SceneObjViewerBase_cls(){
    mpCRenamer = NULL;
    mbKillRenamer = FALSE;
    mbRename = FALSE;
}

int CLS::
GetItemIndexByName(wxString strName){
    int num = mAstrDisplayedItem.GetCount();
    for (int i = 0; i < num; i++) 
	if (mAstrDisplayedItem[i].IsSameAs(strName)) return i;
    return -1;
}
 
void CLS::
ConstructRenameTextCtrl(wxWindow  *pCParent, int fontsize, wxPanelEX *pCPanelEX){
    SceneObjCtrl_cls *pCObjCtrl = GCClassProvider.GetPCSceneObjCtrl();
    SceneObj_cls *pCActiveObject = pCObjCtrl->mpCActiveObject;
    if (pCActiveObject == NULL) return;
    mbRename = TRUE;
    wxString strIni = pCActiveObject->mCstrName.mstrBody;
    int index = GetItemIndexByName(strIni);
    wxPoint pos = mADisplayedRect[index].GetPosition();
    wxSize size = mADisplayedRect[index].GetSize();
    int x = pos.x - 2, y = pos.y - 2;
    int width = size.GetWidth() + 16;
    int height = size.GetHeight();
    if (width < 120) width = 120;

    mpCRenamer = new wxTextCtrl(pCParent, wxID_ANY, strIni,
				wxPoint(x, y), wxSize(width, height),
				wxTE_PROCESS_ENTER);
    mpCRenamer->SetFont(FontProvider_cls::GetFont(fontsize));
    mpCRenamer->SetFocus();
    mpCRenamer->SelectAll();

    pCParent->Connect(mpCRenamer->GetId(), wxEVT_TEXT_ENTER, mFuncRenamer);
    mpCRenamer->Connect(wxEVT_KILL_FOCUS, mFuncRenamerFocus, NULL, pCParent);
    mpCRenamer->Connect(wxEVT_KEY_DOWN,	mFuncRenamerKey, NULL, pCParent);
    
    pCPanelEX->mbSkipKeyHook = TRUE;
    GCClassProvider.GetPCShortcut()->mbSkipShortcut = TRUE;
}

void CLS::
ProcessRename(){
    //if (mbKillRenamer == TRUE) return;

    mbKillRenamer = TRUE;
    wxString strNewName = mpCRenamer->GetValue();

    SceneObjCtrl_cls *pCObjCtrl = GCClassProvider.GetPCSceneObjCtrl();
    SceneObj_cls *pCActiveObject = pCObjCtrl->mpCActiveObject;
    if (pCActiveObject == NULL) return;

    pCObjCtrl->RenameCommand(pCActiveObject->GetStrName(), strNewName);
}

void CLS::
ProcRenamer(wxCommandEvent& event){
    ProcessRename();
    event.Skip();
}

void CLS::
ProcRenamerFocus(wxFocusEvent& event){
    ProcessRename();
    event.Skip();
}

void CLS::
ProcRenamerKey(wxKeyEvent& event){
    if (event.GetKeyCode() == WXK_ESCAPE) mbKillRenamer = TRUE;
    int shortcutEnum = 
      GCClassProvider.GetPCTextShortcut()->GetShortcutEnum(event, wxES);
    if (shortcutEnum != -1){
	int lineLength = mpCRenamer->GetLineLength(0);
	if (shortcutEnum == _SC_TEXT_BEGINNING_LINE)
	    mpCRenamer->SetInsertionPoint(0);
	if (shortcutEnum == _SC_TEXT_END_LINE)
	    mpCRenamer->SetInsertionPoint(lineLength);
	if (shortcutEnum == _SC_TEXT_KILL_LINE){
	    mpCRenamer->SetSelection(mpCRenamer->GetInsertionPoint(),lineLength);
	    mpCRenamer->Cut();
	}
	if (shortcutEnum == _SC_TEXT_SELECT_ALL)
	    mpCRenamer->SelectAll();
	return;
    }

    event.StopPropagation();
    event.Skip();
}

void SceneObjViewerBase_cls::
ProcIdle(wxWindow *pCParent, wxPanelEX *pCPanelEX){
    if (mbKillRenamer == TRUE){
	mbRename = FALSE;
	mbKillRenamer = FALSE;
	if (mpCRenamer != NULL){
	    mpCRenamer->Destroy();
	    pCPanelEX->mbSkipKeyHook = FALSE;
	    GCClassProvider.GetPCShortcut()->mbSkipShortcut = FALSE;
	}
	mpCRenamer = NULL;
	pCParent->Refresh();

    }
}
