// (setq-c-offset 4)
// "clsStereoProp.h"

#include "clsStereoProp.h"

#include "../MYGL/clsPosition.h"
#include "../PARAMETER/clsParameter.h"
#include "../PARAMETER/clsParamGroup.h"
#include "../TIMELINE/clsTimeCtrl.h"

#include "../COMMON/CommonDefinitions.h"

#define CLS StereoProp_cls

CLS::
StereoProp_cls(wxString strName, wxString strParentClassName) : Attribute_cls("StereoProp_cls", "StereoProp") {
    
    wxString strConfListLabel = "SceneObj::";  strConfListLabel << strName;
    strConfListLabel << wxT("::StereoProp");

    mCConfList.SetTag(strConfListLabel);

    mCConfList.Add(&mCStereoType, "StereoType=", "0", "VIEW3D::PROPERTY_OBJECT");
    mCConfList.Add(&mCEyeType, "EyeType=", "0", "VIEW3D");
    mCConfList.Add(&mCParallax, "Parallax=", "0.05", "VIEW3D");
    mCConfList.Add(&mCToeInAngle, "ToeAngle=", "0.5", "VIEW3D");

    AddOneDimParam("Parallax", "D", 0.05);
};

void CLS::
StereoRotate(PositionAndDirection_cls &CCam, int stereo){
    if (mCEyeType.GetBodyINT() == _STEREO_LFT) stereo = 0;
    if (mCEyeType.GetBodyINT() == _STEREO_RGT) stereo = 1;

    double nt = GetPCTimeCtrl()->GetCurrentNT();
    double parallax = GetPCParamGroup("Parallax")->GetVInterpolatedValue(nt)[0];
    
    switch(stereo){
    case 0:
	CCam.TranslateInWC(-parallax, 0); break;
    case 1:
	CCam.TranslateInWC(parallax, 0); break;
    }
    
    if (mCStereoType.GetBodyINT() == _STEREO_TOEIN);
    switch(stereo){
    case 0:
	CCam.RotateYaw(mCToeInAngle.GetBodyDOUBLE()); break;
    case 1:
	CCam.RotateYaw(-mCToeInAngle.GetBodyDOUBLE()); break;
    }
}

int CLS::
GetStereoNum(){
    if (mCStereoType.GetBodyINT() == _STEREO_NONE) return 1;
    switch(mCEyeType.GetBodyINT()){
    case _STEREO_NONE: return 1;
    case _STEREO_LFT: case _STEREO_RGT: return 1;
    case _STEREO_SCANLINE: case _STEREO_SIDEBYSIDE: return 2;
    case _STEREO_RED_CYAN: case _STEREO_YELLOW_BLUE: return 2;
    case _STEREO_QUADBUFFER: return 2;
    }
    return 1;
}

int CLS::
GetEyeType(){
    int eyeType = mCEyeType.GetBodyINT();
    if (mCStereoType.GetBodyINT() == 0) eyeType = 0;
    return eyeType;
}
