// (setq-c-offset 4)
// "clsTextObj.cpp"

#ifndef _TEXTOBJ_H
#define _TEXTOBJ_H

#include "clsSceneObj.h"

#include "../MYGL/clsGLTexture.h"

#include <vector>

class TextProp_cls;
class MultiInputPanel_cls;

class TextItem_cls{
public:
    TextItem_cls(wxString strText = wxEmptyString);

    wxString mstrText;
    float mOffset[3];
    float mScale[3];
    int   mWidth, mHeight;
    float mDescend;

    float GetAspectRatio();
    
};

class TextObj_cls : public SceneObj_cls {
 public:
    TextObj_cls(ParentObj_cls *pCParentObj, 
		wxString strName = wxES);
    ~TextObj_cls();
    
    ConfItemBOOL_cls mCbXRay;
    ConfItemBOOL_cls mCbDepthTest;

    wxString mstrTextMade;
    wxString mstrFontMade;

    int mIndexExternal, mIndexScale;
    
    TextProp_cls *mpCTextProp;
    Material_cls *mpCMaterial;

    std::vector < GLTexture_cls > mACGLTexture;
    std::vector < TextItem_cls > mATextMade;

    void SyncConfListTagTextObj();

    void ReadString(wxString strIn);
    void CheckAndPrepare();
    void MakeTextTexture();
    void GLDraw(int lightNum, int ensemble, int status);

    MultiInputPanel_cls *GetPCNewPanel(wxWindow *pCWindow);

    bool ReadStrLineMaterial(std::wistream &istream, wxString strFirstItem, wxString strLine);
    void SerializeMaterial(wxString& strOut);
};

#endif
