// (setq-c-offset 4)
// "clsParticleForRenderInterpThread.h"

#include "clsParticleForRenderInterpThread.h"

#include "../clsParticleForRender.h"
#include "../clsParticleSnap.h"

#include "../../LUA/clsLuaBase.h"
#include "../../SCENEOBJ/DATAVIEWER/clsMaterialParticle.h"
#include "../../SCENEOBJ/DATAVIEWER/clsParticle.h"

#include "../../COMMON/CommonDefinitions.h"

#define CLS ThreadInterpStep_cls

void CLS::
SetParameters(ParticleSnap_cls *pCSnap1, ParticleSnap_cls *pCSnap2,
	      ParticleSnap_cls *pCSnap0, ParticleSnap_cls *pCSnap3,
	      int classifyType, wxString strClassify, 
	      LuaBase_cls *pCLuaForClassify,
	      int interpType,int vanishSizeType, int extrapolateType,
	      double factor, bool bUseID,
	      int numMat, float alphaCrit, float *sizeFactor, int *sizeType, 
	      int *sizeAlphaType, float *sizeAlphaBase, float *sizeAlphaMax, 
	      int *clrCurveType, int *clrCurveDepend,
	      float (*clrEmit)[3], unsigned char *paramBit, 
	      ParamGroup_cls** ppCClr,
	      std::vector < double > *VRange,
	      float (*pX)[3], unsigned char *pType, float *pFilterAlpha,
	      float *pSize, float *pSizeAlpha, 
	      float *pClrCurveS, float *pClrCurveT,
	      float *pValue0, float *pValue1, float *pValue2,
	      unsigned char *pParamBit, int *pID, long long *pIDLongLong, 
	      ArrayAndIndex_cls *pIndexAndZ){
    mpCSnap1 = pCSnap1; mpCSnap2 = pCSnap2;
    mpCSnap0 = pCSnap0; mpCSnap3 = pCSnap3;
    //mNT = NT;
    mNumMat = numMat;
    mClassifyType = classifyType;
    mstrClassify = strClassify;
    mpCLuaForClassify = pCLuaForClassify;
    mInterpType = interpType;
    mVanishSizeTpe = vanishSizeType;
    mExtrapolateType = extrapolateType;
    mFactor = factor;
    mbUseID = bUseID;
    mAlphaCrit = alphaCrit;
    mSizeFactor = sizeFactor;
    mSizeType = sizeType;
    mSizeAlphaType = sizeAlphaType;
    mSizeAlphaBase = sizeAlphaBase;
    mSizeAlphaMax = sizeAlphaMax;
    mClrCurveType = clrCurveType;
    mClrCurveDepend = clrCurveDepend;
    mClrEmit = clrEmit;
    mParamBit = paramBit;
    mppCClr = ppCClr;
    mVRange = VRange;
    mpX = pX;
    mpType = pType;
    mpSize = pSize;
    mpFilterAlpha = pFilterAlpha;
    mpSizeAlpha = pSizeAlpha;
    mpClrCurveS = pClrCurveS; mpClrCurveT = pClrCurveT;
    mpParamBit = pParamBit;
    mpID = pID;
    mpIDLongLong = pIDLongLong;
    mpValue0 = pValue0; mpValue1 = pValue1; mpValue2 = pValue2;
    mpIndexAndZ = pIndexAndZ;

    mbSearchNextIndexOnly = FALSE;
}

void CLS::
SetParametersTime(double NT, int frame, int subFrame, int seq){
    mNT = NT;
    mFrame = frame;
    mSubFrame = subFrame;
    mSeq = seq;
}

void CLS::
SetParametersDownsize(int tgtIni, int downsize, int downsizeType){
    mTgtIni = tgtIni;
    mDownsize = downsize;
    mDownsizeType = downsizeType;

    if (mpCSnap1->mbUseID == FALSE && mpCSnap1->mbUseIDLongLong == FALSE)
	mDownsizeType = _DOWNSIZE_BY_INDEX;
    if (mDownsizeType == _DOWNSIZE_BY_ID && mpCSnap1->mbUseID == FALSE)
	mDownsizeType = _DOWNSIZE_BY_ID_LONGLONG;
}

void CLS::
ClassifyByExpression(unsigned char * const pType,
		     const int *pCSnap1ID,
		     const long long *pCSnap1IDLongLong,
		     const int PIni, const int PFin){
    wxString strFunction;

    float (* const pX)[3] = mpX;

    if (pCSnap1IDLongLong != NULL || pCSnap1ID != NULL)
	strFunction << "function script(index, x, y, z, type, id)" << ENDL;
    else
	strFunction << "function script(index, x, y, z, type)" << ENDL;
    strFunction << mstrClassify << ENDL;
    strFunction << "end" << ENDL;
    
    wxArrayString CAstrDummy;
    mpCLuaForClassify->OpenLuaBase(strFunction, 0, CAstrDummy, NULL);
    mpCLuaForClassify->SetVariable(mNT, "nt");
    mpCLuaForClassify->SetVariable(mFrame, "frame");
    mpCLuaForClassify->SetVariable(mSubFrame, "subframe");
    mpCLuaForClassify->SetVariable(mSeq, "seq");
    
    if (pCSnap1IDLongLong != NULL){
	for (int i = PIni; i < PFin; i++){
	    lua_State *pLua = mpCLuaForClassify->mpLua;
	    lua_getglobal(pLua, "script");
	    lua_pushnumber(pLua, i);
	    lua_pushnumber(pLua, pX[i][X]);
	    lua_pushnumber(pLua, pX[i][Y]);
	    lua_pushnumber(pLua, pX[i][Z]);
	    lua_pushnumber(pLua, pType[i]);
	    lua_pushnumber(pLua, pCSnap1IDLongLong[i]);
	    
	    lua_pcall(pLua, 6, 1, 0);
	    int type = lua_tonumber(pLua, -1);
	    pType[i] = type;
	    lua_pop(pLua, 1);
	}
    }
    else if (pCSnap1ID != NULL){
	for (int i = PIni; i < PFin; i++){
	    lua_State *pLua = mpCLuaForClassify->mpLua;
	    lua_getglobal(pLua, "script");
	    lua_pushnumber(pLua, i);
	    lua_pushnumber(pLua, pX[i][X]);
	    lua_pushnumber(pLua, pX[i][Y]);
	    lua_pushnumber(pLua, pX[i][Z]);
	    lua_pushnumber(pLua, pType[i]);
	    lua_pushnumber(pLua, pCSnap1ID[i]);
	    
	    lua_pcall(pLua, 6, 1, 0);
	    int type = lua_tonumber(pLua, -1);
	    pType[i] = type;
	    lua_pop(pLua, 1);
	}
    }
    else{
	for (int i = PIni; i < PFin; i++){
	    lua_State *pLua = mpCLuaForClassify->mpLua;
	    lua_getglobal(pLua, "script");
	    lua_pushnumber(pLua, i);
	    lua_pushnumber(pLua, pX[i][X]);
	    lua_pushnumber(pLua, pX[i][Y]);
	    lua_pushnumber(pLua, pX[i][Z]);
	    lua_pushnumber(pLua, pType[i]);
	    
	    lua_pcall(pLua, 5, 1, 0);
	    int type = lua_tonumber(pLua, -1);
	    pType[i] = type;
	    lua_pop(pLua, 1);
	}
    }

    mpCLuaForClassify->CloseLuaBase();
}

double CLS::
GetRemapX(std::vector < double > &VRange, double x0){//, double NT){
    double width = VRange[1] - VRange[0];
    if (width == 0) return 1;
    return (x0 - VRange[0])/width;
}

int CLS::
SearchIDFull(const int * const pID2, int num2, int index, int id){
    // ID\[gĂ邱ƂOƂB
    for (int i = 0; i < num2; i++){
	if (i < num2 - 1000)
	    if (pID2[i+1000] < id) i += 1000;
	if (pID2[i] == id) return i;
	if (pID2[i] > id) return -1;
    }
    return -1;
}

int CLS::
SearchIDNear10(const int * const pID2, int num2, int index, int id){
    int range = 10;
    int ini = index - range; 
    if (ini < 0) ini = 0;
    int fin = index + range;
    if (fin > num2) fin = num2;
    for (int i = ini; i < fin; i++){
	if (pID2[i] == id) return i;
	if (pID2[i] > id) return -1;
    }
    return -1;
}

int CLS::
SearchIDNear(const int * const pID2, int num2, int index, int id, int range){
    int ini = index - range; 
    if (ini < 0) ini = 0;
    int fin = index + range;
    if (fin > num2) fin = num2;
    int step = range / 10;
    for (int i = ini; i < fin; i++){
	if (i < fin - step)
	    if (pID2[i + step] < id) i += step;
	if (pID2[i] == id) return i;
	if (pID2[i] > id) return -1;
    }
    return -1;
}

int CLS::
SearchIDFrom(const int * const pID2, int num2, int index, int id){
    int iNext = SearchIDNear10(pID2, num2, index, id);
    if (iNext == -1)
	iNext = SearchIDNear(pID2, num2, index, id, 100);
    if (iNext == -1)
	iNext = SearchIDNear(pID2, num2, index, id, 1000);
    if (iNext == -1)
	iNext = SearchIDNear(pID2, num2, index, id, 10000);
    if (iNext == -1)
	iNext = SearchIDFull(pID2, num2, index, id);
    return iNext;
}

int CLS::
SearchIDLongFull(const long long * const pID2, int num2, int index, long long id){
    // ID\[gĂ邱ƂOƂB
    for (int i = 0; i < num2; i++){
	if (i < num2 - 1000)
	    if (pID2[i+1000] < id) i += 1000;
	if (pID2[i] == id) return i;
	if (pID2[i] > id) return -1;
    }
    return -1;
}

int CLS::
SearchIDLongNear10(const long long * const pID2, int num2, int index, long long id){
    int range = 10;
    int ini = index - range; 
    if (ini < 0) ini = 0;
    int fin = index + range;
    if (fin > num2) fin = num2;
    for (int i = ini; i < fin; i++){
	if (pID2[i] == id) return i;
	if (pID2[i] > id) return -1;
    }
    return -1;
}

int CLS::
SearchIDLongNear(const long long * const pID2, int num2, int index, long long id, int range){
    int ini = index - range; 
    if (ini < 0) ini = 0;
    int fin = index + range;
    if (fin > num2) fin = num2;
    int step = range / 10;
    for (int i = ini; i < fin; i++){
	if (i < fin - step)
	    if (pID2[i + step] < id) i += step;
	if (pID2[i] == id) return i;
	if (pID2[i] > id) return -1;
    }
    return -1;
}

int CLS::
SearchIDLongFrom(const long long * const pID2, int num2, int index, long long id){
    int iNext = SearchIDLongNear10(pID2, num2, index, id);
    if (iNext == -1)
	iNext = SearchIDLongNear(pID2, num2, index, id, 100);
    if (iNext == -1)
	iNext = SearchIDLongNear(pID2, num2, index, id, 1000);
    if (iNext == -1)
	iNext = SearchIDLongNear(pID2, num2, index, id, 10000);
    if (iNext == -1)
	iNext = SearchIDLongFull(pID2, num2, index, id);
    return iNext;
}

void CLS::
SearchNextIndexByID(){

    // mutexȂ̂ŕsN\͂
    mpCSnap1->mbNextIndexCalcStarted = TRUE;
    mpCSnap1->mbNextIndexCalcedThread = TRUE;
        
    const int PIni = mPIni;
    const int PFin = mPFin;

    ParticleSnap_cls * const pCSnap1 = mpCSnap1;
    ParticleSnap_cls * const pCSnap2 = mpCSnap2;

    int * const pNextIndex = pCSnap1->mpNextIndex;
    int * const pSnap2PrevIndex = pCSnap2->mpPrevIndex;
    const int * const pID1 = pCSnap1->mpID;
    const int * const pID2 = pCSnap2->mpID;
    const long long * const pIDLong1 = pCSnap1->mpIDLongLong;
    const long long * const pIDLong2 = pCSnap2->mpIDLongLong;
    const unsigned char * const pCSnap1Type = pCSnap1->mpType;
    const unsigned char * const pCSnap2Type = pCSnap2->mpType;

    wxStopWatch CSW;
    CSW.Start();
    
    bool bValid = FALSE;
    ASSERT(pNextIndex != NULL);
    if (pID1 == NULL){
	if ((pIDLong1 != NULL) && (pIDLong2 != NULL)){
	    bValid = TRUE;
	    
	    int num2 = pCSnap2->mPNum;
	    pNextIndex[PIni] = SearchIDLongFrom(pIDLong2, num2, PIni, pIDLong1[PIni]);
	    for (int i = PIni+1; i < PFin; i++){
		int candidate = pNextIndex[i-1] + 1;
		if (candidate == 0){
		candidate = i;
		if (candidate >= num2) candidate = num2-1;
		}
		pNextIndex[i] = SearchIDLongFrom(pIDLong2, num2, candidate, pIDLong1[i]);
	    }
	}
	
    }
    else{
	if ((pID1 != NULL) && (pID2 != NULL)){
	    bValid = TRUE;

	    int num2 = pCSnap2->mPNum;
	    pNextIndex[PIni] = SearchIDFrom(pID2, num2, PIni, pID1[PIni]);
	    for (int i = PIni+1; i < PFin; i++){
		int candidate = pNextIndex[i-1] + 1;
		if (candidate == 0) candidate = i;
		pNextIndex[i] = SearchIDFrom(pID2, num2, candidate, pID1[i]);
	    }
	}
    }

    if (bValid == FALSE){
	for (int i = PIni; i < PFin; i++)
	    pNextIndex[i] = -1;
    }
    else{
	// ^CvقȂΕԂȂ
	if (pCSnap1Type != NULL)
	    for (int i = PIni; i < PFin; i++){
		if (pNextIndex[i] != -1)
		    if (pCSnap1Type[i] != pCSnap2Type[pNextIndex[i]])
			pNextIndex[i] = -1;
	    }
	for (int i = PIni; i < PFin; i++){
	    int nextIndex = pNextIndex[i];
	    if (nextIndex == -1) continue;
	    pSnap2PrevIndex[nextIndex] = i;
	}
    }
    
    //wxString strLog;
    //strLog << "Search ID " << PIni << "-" << PFin << "::" << CSW.Time() << "ms" << ENDL;
    //wxLogMessage(strLog);
}

void CLS::
InterpolateXYZLinearByID(){

    if (mpCSnap2->mpX == NULL)
	return InterpolateXYZStep();
    
    const int PIni = mPIni;
    const int PFin = mPFin;
    const ParticleSnap_cls * const pCSnap1 = mpCSnap1;
    const ParticleSnap_cls * const pCSnap2 = mpCSnap2;
    const ParticleSnap_cls * const pCSnap0 = mpCSnap0;
    const int * const pCSnap1ID               = pCSnap1->mpID;
    const long long * const pCSnap1IDLongLong = pCSnap1->mpIDLongLong;
    const float (* const pCSnap1X)[3] = pCSnap1->mpX;
    const float (* const pCSnap2X)[3] = pCSnap2->mpX;
    const float (* const pCSnap0X)[3] = pCSnap0->mpX;
    const double factor = mFactor;
    const double factorInv = 1.0 - factor;
    float (* const pX)[3] = mpX;
    const int * const pNextIndex = pCSnap1->mpNextIndex;
    const int * const pPrevIndex = pCSnap1->mpPrevIndex;
    const int downsizeType = mDownsizeType;
    const int exterpolateType = mExtrapolateType;

    ASSERT(pNextIndex != NULL);
    
    int tgt = mTgtIni;
    switch(downsizeType){
    case _DOWNSIZE_BY_INDEX: {
	for (int i = PIni; i < PFin; i++){
	    if (i % mDownsize != 0) continue;
	    int i2 = pNextIndex[i];
	    if (i2 == -1){
		int i0 = pPrevIndex[i]; 
		if (exterpolateType == 0 || i0 == -1){
		    pX[tgt][X] = pCSnap1X[i][X];
		    pX[tgt][Y] = pCSnap1X[i][Y];
		    pX[tgt][Z] = pCSnap1X[i][Z];
		}
		else{
		    pX[tgt][X] = pCSnap1X[i][X] + (pCSnap1X[i][X] - pCSnap0X[i0][X]) * factor;
		    pX[tgt][Y] = pCSnap1X[i][Y] + (pCSnap1X[i][Y] - pCSnap0X[i0][Y]) * factor;
		    pX[tgt][Z] = pCSnap1X[i][Z] + (pCSnap1X[i][Z] - pCSnap0X[i0][Z]) * factor;
		}
	    }
	    else{
		pX[tgt][X] = 
		    pCSnap1X[i][X] * factorInv + pCSnap2X[i2][X] * factor;
		pX[tgt][Y] = 
		    pCSnap1X[i][Y] * factorInv + pCSnap2X[i2][Y] * factor;
		pX[tgt][Z] = 
		    pCSnap1X[i][Z] * factorInv + pCSnap2X[i2][Z] * factor;
	    }
	    tgt++;
	}
	break; }
    case _DOWNSIZE_BY_ID: {
	for (int i = PIni; i < PFin; i++){
	    if (pCSnap1ID[i] % mDownsize != 0) continue;
	    int i2 = pNextIndex[i];
	    if (i2 == -1){
		int i0 = pPrevIndex[i]; i0 = -1;
		if (exterpolateType == 0 || i0 == -1){
		    pX[tgt][X] = pCSnap1X[i][X];
		    pX[tgt][Y] = pCSnap1X[i][Y];
		    pX[tgt][Z] = pCSnap1X[i][Z]; }
		else{
		    pX[tgt][X] = pCSnap1X[i][X] + (pCSnap1X[i][X] - pCSnap0X[i0][X]) * factor;
		    pX[tgt][Y] = pCSnap1X[i][Y] + (pCSnap1X[i][Y] - pCSnap0X[i0][Y]) * factor;
		    pX[tgt][Z] = pCSnap1X[i][Z] + (pCSnap1X[i][Z] - pCSnap0X[i0][Z]) * factor; 
		}
	    }
	    else{
		pX[tgt][X] = 
		    pCSnap1X[i][X] * factorInv + pCSnap2X[i2][X] * factor;
		pX[tgt][Y] = 
		    pCSnap1X[i][Y] * factorInv + pCSnap2X[i2][Y] * factor;
		pX[tgt][Z] = 
		    pCSnap1X[i][Z] * factorInv + pCSnap2X[i2][Z] * factor;
	    }
	    tgt++;
	}
	break; }
    case _DOWNSIZE_BY_ID_LONGLONG: {
	for (int i = PIni; i < PFin; i++){
	    if (pCSnap1IDLongLong[i] % mDownsize != 0) continue;
	    int i2 = pNextIndex[i];
	    if (i2 == -1){
		int i0 = pPrevIndex[i];
		if (exterpolateType == 0 || i0 == -1){
		    pX[tgt][X] = pCSnap1X[i][X];
		    pX[tgt][Y] = pCSnap1X[i][Y];
		    pX[tgt][Z] = pCSnap1X[i][Z]; }
		else{
		    pX[tgt][X] = pCSnap1X[i][X] + (pCSnap1X[i][X] - pCSnap0X[i0][X]) * factor;
		    pX[tgt][Y] = pCSnap1X[i][Y] + (pCSnap1X[i][Y] - pCSnap0X[i0][Y]) * factor;
		    pX[tgt][Z] = pCSnap1X[i][Z] + (pCSnap1X[i][Z] - pCSnap0X[i0][Z]) * factor;
		}
	    }
	    else{
		pX[tgt][X] = 
		    pCSnap1X[i][X] * factorInv + pCSnap2X[i2][X] * factor;
		pX[tgt][Y] = 
		    pCSnap1X[i][Y] * factorInv + pCSnap2X[i2][Y] * factor;
		pX[tgt][Z] = 
		    pCSnap1X[i][Z] * factorInv + pCSnap2X[i2][Z] * factor;
	    }
	    tgt++;
	}
	break; }
    }
}

void CLS::
InterpolateXYZHermiteByID(){
    const int PIni = mPIni;
    const int PFin = mPFin;
    const ParticleSnap_cls * const pCSnap1 = mpCSnap1;
    const ParticleSnap_cls * const pCSnap2 = mpCSnap2;
    const ParticleSnap_cls * const pCSnap0 = mpCSnap0;
    const int * const pCSnap1ID               = pCSnap1->mpID;
    const long long * const pCSnap1IDLongLong = pCSnap1->mpIDLongLong;
    const float (* const pCSnap1X)[3] = pCSnap1->mpX;
    const float (* const pCSnap2X)[3] = pCSnap2->mpX;
    const float (* const pCSnap1V)[3] = pCSnap1->mpV;
    const float (* const pCSnap2V)[3] = pCSnap2->mpV;
    const float (* const pCSnap0X)[3] = pCSnap0->mpX;
    const double factor = mFactor;
    const double factorInv = 1.0 - factor;
    float (* const pX)[3] = mpX;
    const int * const pNextIndex = pCSnap1->mpNextIndex;
    const int * const pPrevIndex = pCSnap1->mpPrevIndex;
    const int downsizeType = mDownsizeType;
    const int exterpolateType = mExtrapolateType;
    const double DT = pCSnap2->mSnapTime - pCSnap1->mSnapTime;

    ASSERT(pNextIndex != NULL);
    
    int tgt = mTgtIni;
    switch(downsizeType){
    case _DOWNSIZE_BY_INDEX: {
	for (int i = PIni; i < PFin; i++){
	    if (i % mDownsize != 0) continue;
	    int i2 = pNextIndex[i];
	    if (i2 == -1){
		int i0 = pPrevIndex[i]; 
		if (exterpolateType == 0 || i0 == -1){
		    pX[tgt][X] = pCSnap1X[i][X];
		    pX[tgt][Y] = pCSnap1X[i][Y];
		    pX[tgt][Z] = pCSnap1X[i][Z];
		}
		else{
		    float VX1 = pCSnap1V[i][X]*DT;
		    float VY1 = pCSnap1V[i][Y]*DT;
		    float VZ1 = pCSnap1V[i][Z]*DT;
		    pX[tgt][X] = pCSnap1X[i][X] + VX1*factor;
		    pX[tgt][Y] = pCSnap1X[i][Y] + VY1*factor;
		    pX[tgt][Z] = pCSnap1X[i][Z] + VZ1*factor;
		}
	    }
	    else{
		float X1 = pCSnap1X[i][X], X2 = pCSnap2X[i2][X];
		float Y1 = pCSnap1X[i][Y], Y2 = pCSnap2X[i2][Y];
		float Z1 = pCSnap1X[i][Z], Z2 = pCSnap2X[i2][Z];
		float VX1 = pCSnap1V[i][X]*DT, VX2 = pCSnap2V[i2][X]*DT;
		float VY1 = pCSnap1V[i][Y]*DT, VY2 = pCSnap2V[i2][Y]*DT;
		float VZ1 = pCSnap1V[i][Z]*DT, VZ2 = pCSnap2V[i2][Z]*DT;
		pX[tgt][X] = X1 + factor*(VX1 + factor*(-3*X1-2*VX1+3*X2-VX2 + factor*(2*X1+VX1-2*X2+VX2)));
	    pX[tgt][Y] = Y1 + factor*(VY1 + factor*(-3*Y1-2*VY1+3*Y2-VY2 + factor*(2*Y1+VY1-2*Y2+VY2)));
	    pX[tgt][Z] = Z1 + factor*(VZ1 + factor*(-3*Z1-2*VZ1+3*Z2-VZ2 + factor*(2*Z1+VZ1-2*Z2+VZ2)));
	    }
	    tgt++;
	}
	break; }
    case _DOWNSIZE_BY_ID: {
	for (int i = PIni; i < PFin; i++){
	    if (pCSnap1ID[i] % mDownsize != 0) continue;
	    int i2 = pNextIndex[i];
	    if (i2 == -1){
		int i0 = pPrevIndex[i]; i0 = -1;
		if (exterpolateType == 0 || i0 == -1){
		    pX[tgt][X] = pCSnap1X[i][X];
		    pX[tgt][Y] = pCSnap1X[i][Y];
		    pX[tgt][Z] = pCSnap1X[i][Z]; }
		else{
		    float VX1 = pCSnap1V[i][X]*DT;
		    float VY1 = pCSnap1V[i][Y]*DT;
		    float VZ1 = pCSnap1V[i][Z]*DT;
		    pX[tgt][X] = pCSnap1X[i][X] + VX1*factor;
		    pX[tgt][Y] = pCSnap1X[i][Y] + VY1*factor;
		    pX[tgt][Z] = pCSnap1X[i][Z] + VZ1*factor;
		}
	    }
	    else{
		float X1 = pCSnap1X[i][X], X2 = pCSnap2X[i2][X];
		float Y1 = pCSnap1X[i][Y], Y2 = pCSnap2X[i2][Y];
		float Z1 = pCSnap1X[i][Z], Z2 = pCSnap2X[i2][Z];
		float VX1 = pCSnap1V[i][X]*DT, VX2 = pCSnap2V[i2][X]*DT;
		float VY1 = pCSnap1V[i][Y]*DT, VY2 = pCSnap2V[i2][Y]*DT;
		float VZ1 = pCSnap1V[i][Z]*DT, VZ2 = pCSnap2V[i2][Z]*DT;
		pX[tgt][X] = X1 + factor*(VX1 + factor*(-3*X1-2*VX1+3*X2-VX2 + factor*(2*X1+VX1-2*X2+VX2)));
	    pX[tgt][Y] = Y1 + factor*(VY1 + factor*(-3*Y1-2*VY1+3*Y2-VY2 + factor*(2*Y1+VY1-2*Y2+VY2)));
	    pX[tgt][Z] = Z1 + factor*(VZ1 + factor*(-3*Z1-2*VZ1+3*Z2-VZ2 + factor*(2*Z1+VZ1-2*Z2+VZ2)));
	    }
	    tgt++;
	}
	break; }
    case _DOWNSIZE_BY_ID_LONGLONG: {
	for (int i = PIni; i < PFin; i++){
	    if (pCSnap1IDLongLong[i] % mDownsize != 0) continue;
	    int i2 = pNextIndex[i];
	    if (i2 == -1){
		int i0 = pPrevIndex[i];
		if (exterpolateType == 0 || i0 == -1){
		    pX[tgt][X] = pCSnap1X[i][X];
		    pX[tgt][Y] = pCSnap1X[i][Y];
		    pX[tgt][Z] = pCSnap1X[i][Z]; }
		else{
		    float VX1 = pCSnap1V[i][X]*DT;
		    float VY1 = pCSnap1V[i][Y]*DT;
		    float VZ1 = pCSnap1V[i][Z]*DT;
		    pX[tgt][X] = pCSnap1X[i][X] + VX1*factor;
		    pX[tgt][Y] = pCSnap1X[i][Y] + VY1*factor;
		    pX[tgt][Z] = pCSnap1X[i][Z] + VZ1*factor;
		}
	    }
	    else{
		float X1 = pCSnap1X[i][X], X2 = pCSnap2X[i2][X];
		float Y1 = pCSnap1X[i][Y], Y2 = pCSnap2X[i2][Y];
		float Z1 = pCSnap1X[i][Z], Z2 = pCSnap2X[i2][Z];
		float VX1 = pCSnap1V[i][X]*DT, VX2 = pCSnap2V[i2][X]*DT;
		float VY1 = pCSnap1V[i][Y]*DT, VY2 = pCSnap2V[i2][Y]*DT;
		float VZ1 = pCSnap1V[i][Z]*DT, VZ2 = pCSnap2V[i2][Z]*DT;
		pX[tgt][X] = X1 + factor*(VX1 + factor*(-3*X1-2*VX1+3*X2-VX2 + factor*(2*X1+VX1-2*X2+VX2)));
	    pX[tgt][Y] = Y1 + factor*(VY1 + factor*(-3*Y1-2*VY1+3*Y2-VY2 + factor*(2*Y1+VY1-2*Y2+VY2)));
	    pX[tgt][Z] = Z1 + factor*(VZ1 + factor*(-3*Z1-2*VZ1+3*Z2-VZ2 + factor*(2*Z1+VZ1-2*Z2+VZ2)));
	    }
	    tgt++;
	}
	break; }
    }
}

void CLS::
InterpolateXYZBezierByID(int bezierType){
    const int PIni = mPIni;
    const int PFin = mPFin;
    const ParticleSnap_cls * const pCSnap1 = mpCSnap1;
    const ParticleSnap_cls * const pCSnap2 = mpCSnap2;
    const ParticleSnap_cls * const pCSnap0 = mpCSnap0;
    const ParticleSnap_cls * const pCSnap3 = mpCSnap3;
    const int * const pCSnap1ID               = pCSnap1->mpID;
    const long long * const pCSnap1IDLongLong = pCSnap1->mpIDLongLong;
    const float (* const pCSnap1X)[3] = pCSnap1->mpX;
    const float (* const pCSnap2X)[3] = pCSnap2->mpX;
    const float (* const pCSnap0X)[3] = pCSnap0->mpX;
    const float (* const pCSnap3X)[3] = pCSnap3->mpX;
    const double factor = mFactor;
    const double factorInv = 1.0 - factor;
    float (* const pX)[3] = mpX;
    const int * const pNextIndex = pCSnap1->mpNextIndex;
    const int * const pPrevIndex = pCSnap1->mpPrevIndex;
    const int * const pNextNextIndex = pCSnap2->mpNextIndex;
    const int downsizeType = mDownsizeType;
    const int exterpolateType = mExtrapolateType;

    ASSERT(pNextIndex != NULL);
    ASSERT(pNextNextIndex != NULL);

    int tgt = mTgtIni;
    if (bezierType == 1){
	switch(downsizeType){
	case _DOWNSIZE_BY_INDEX: {
	    for (int i = PIni; i < PFin; i++){
		if (i % mDownsize != 0) continue;
		int i2 = pNextIndex[i];
		if (i2 == -1){
		    int i0 = pPrevIndex[i]; 
		    if (exterpolateType == 0 || i0 == -1){
			pX[tgt][X] = pCSnap1X[i][X];
			pX[tgt][Y] = pCSnap1X[i][Y];
			pX[tgt][Z] = pCSnap1X[i][Z];
		    }
		    else{
			pX[tgt][X] = pCSnap1X[i][X] + (pCSnap1X[i][X] - pCSnap0X[i0][X]) * factor;
			pX[tgt][Y] = pCSnap1X[i][Y] + (pCSnap1X[i][Y] - pCSnap0X[i0][Y]) * factor;
			pX[tgt][Z] = pCSnap1X[i][Z] + (pCSnap1X[i][Z] - pCSnap0X[i0][Z]) * factor;
		    }
		}
		else{
		    int i0 = pPrevIndex[i];
		    int i3 = pNextNextIndex[i2];
		    if (i0 == -1 || i3 == -1){
			pX[tgt][X] = 
			    pCSnap1X[i][X]*factorInv + pCSnap2X[i2][X]*factor;
			pX[tgt][Y] = 
			    pCSnap1X[i][Y]*factorInv + pCSnap2X[i2][Y]*factor;
			pX[tgt][Z] = 
			    pCSnap1X[i][Z]*factorInv + pCSnap2X[i2][Z]*factor;
		    }
		    else{
			ExecBezier(pX[tgt], pCSnap0X[i0], pCSnap1X[i], pCSnap2X[i2], pCSnap3X[i3], factor);
		    }
		}
		tgt++;
	    }
	    break; }
	case _DOWNSIZE_BY_ID: {
	    for (int i = PIni; i < PFin; i++){
		if (pCSnap1ID[i] % mDownsize != 0) continue;
		int i2 = pNextIndex[i];
		if (i2 == -1){
		    int i0 = pPrevIndex[i]; i0 = -1;
		    if (exterpolateType == 0 || i0 == -1){
			pX[tgt][X] = pCSnap1X[i][X];
			pX[tgt][Y] = pCSnap1X[i][Y];
			pX[tgt][Z] = pCSnap1X[i][Z]; }
		    else{
			pX[tgt][X] = pCSnap1X[i][X] + (pCSnap1X[i][X] - pCSnap0X[i0][X]) * factor;
			pX[tgt][Y] = pCSnap1X[i][Y] + (pCSnap1X[i][Y] - pCSnap0X[i0][Y]) * factor;
			pX[tgt][Z] = pCSnap1X[i][Z] + (pCSnap1X[i][Z] - pCSnap0X[i0][Z]) * factor; 
		    }
		}
		else{
		    int i0 = pPrevIndex[i];
		    int i3 = pNextNextIndex[i2];
		    if (i0 == -1 || i3 == -1){
			pX[tgt][X] = 
			    pCSnap1X[i][X]*factorInv + pCSnap2X[i2][X]*factor;
			pX[tgt][Y] = 
			    pCSnap1X[i][Y]*factorInv + pCSnap2X[i2][Y]*factor;
			pX[tgt][Z] = 
			    pCSnap1X[i][Z]*factorInv + pCSnap2X[i2][Z]*factor;
		    }
		    else{
			ExecBezier(pX[tgt], pCSnap0X[i0], pCSnap1X[i], pCSnap2X[i2], pCSnap3X[i3], factor);
		    }
		}
		tgt++;
	    }
	    break; }
	case _DOWNSIZE_BY_ID_LONGLONG: {
	    for (int i = PIni; i < PFin; i++){
		if (pCSnap1IDLongLong[i] % mDownsize != 0) continue;
		int i2 = pNextIndex[i];
		if (i2 == -1){
		    int i0 = pPrevIndex[i];
		    if (exterpolateType == 0 || i0 == -1){
			pX[tgt][X] = pCSnap1X[i][X];
			pX[tgt][Y] = pCSnap1X[i][Y];
			pX[tgt][Z] = pCSnap1X[i][Z]; }
		    else{
			pX[tgt][X] = pCSnap1X[i][X] + (pCSnap1X[i][X] - pCSnap0X[i0][X]) * factor;
			pX[tgt][Y] = pCSnap1X[i][Y] + (pCSnap1X[i][Y] - pCSnap0X[i0][Y]) * factor;
			pX[tgt][Z] = pCSnap1X[i][Z] + (pCSnap1X[i][Z] - pCSnap0X[i0][Z]) * factor;
		    }
		}
		else{
		    int i0 = pPrevIndex[i];
		    int i3 = pNextNextIndex[i2];
		    if (i0 == -1 || i3 == -1){
			pX[tgt][X] = 
			    pCSnap1X[i][X]*factorInv + pCSnap2X[i2][X]*factor;
			pX[tgt][Y] = 
			    pCSnap1X[i][Y]*factorInv + pCSnap2X[i2][Y]*factor;
			pX[tgt][Z] = 
			    pCSnap1X[i][Z]*factorInv + pCSnap2X[i2][Z]*factor;
		    }
		    else{
			ExecBezier(pX[tgt], pCSnap0X[i0], pCSnap1X[i], pCSnap2X[i2], pCSnap3X[i3], factor);
		    }
		}
		tgt++;
	    }
	    break; }
	}
    }
    
    if (bezierType == 2){
	switch(downsizeType){
	case _DOWNSIZE_BY_INDEX: {
	    for (int i = PIni; i < PFin; i++){
		if (i % mDownsize != 0) continue;
		int i2 = pNextIndex[i];
		if (i2 == -1){
		    int i0 = pPrevIndex[i]; 
		    if (exterpolateType == 0 || i0 == -1){
			pX[tgt][X] = pCSnap1X[i][X];
			pX[tgt][Y] = pCSnap1X[i][Y];
			pX[tgt][Z] = pCSnap1X[i][Z];
		    }
		    else{
			pX[tgt][X] = pCSnap1X[i][X] + (pCSnap1X[i][X] - pCSnap0X[i0][X]) * factor;
			pX[tgt][Y] = pCSnap1X[i][Y] + (pCSnap1X[i][Y] - pCSnap0X[i0][Y]) * factor;
			pX[tgt][Z] = pCSnap1X[i][Z] + (pCSnap1X[i][Z] - pCSnap0X[i0][Z]) * factor;
		    }
		}
		else{
		    int i0 = pPrevIndex[i];
		    int i3 = pNextNextIndex[i2];
		    if (i0 == -1 || i3 == -1){
			pX[tgt][X] = 
			    pCSnap1X[i][X]*factorInv + pCSnap2X[i2][X]*factor;
			pX[tgt][Y] = 
			    pCSnap1X[i][Y]*factorInv + pCSnap2X[i2][Y]*factor;
			pX[tgt][Z] = 
			    pCSnap1X[i][Z]*factorInv + pCSnap2X[i2][Z]*factor;
		    }
		    else{
			ExecBezier2(pX[tgt], pCSnap0X[i0], pCSnap1X[i], pCSnap2X[i2], pCSnap3X[i3], factor);
		    }
		}
		tgt++;
	    }
	    break; }
	case _DOWNSIZE_BY_ID: {
	    for (int i = PIni; i < PFin; i++){
		if (pCSnap1ID[i] % mDownsize != 0) continue;
		int i2 = pNextIndex[i];
		if (i2 == -1){
		    int i0 = pPrevIndex[i]; i0 = -1;
		    if (exterpolateType == 0 || i0 == -1){
			pX[tgt][X] = pCSnap1X[i][X];
			pX[tgt][Y] = pCSnap1X[i][Y];
			pX[tgt][Z] = pCSnap1X[i][Z]; }
		    else{
			pX[tgt][X] = pCSnap1X[i][X] + (pCSnap1X[i][X] - pCSnap0X[i0][X]) * factor;
			pX[tgt][Y] = pCSnap1X[i][Y] + (pCSnap1X[i][Y] - pCSnap0X[i0][Y]) * factor;
			pX[tgt][Z] = pCSnap1X[i][Z] + (pCSnap1X[i][Z] - pCSnap0X[i0][Z]) * factor; 
		    }
		}
		else{
		    int i0 = pPrevIndex[i];
		    int i3 = pNextNextIndex[i2];
		    if (i0 == -1 || i3 == -1){
			pX[tgt][X] = 
			    pCSnap1X[i][X]*factorInv + pCSnap2X[i2][X]*factor;
			pX[tgt][Y] = 
			    pCSnap1X[i][Y]*factorInv + pCSnap2X[i2][Y]*factor;
			pX[tgt][Z] = 
			    pCSnap1X[i][Z]*factorInv + pCSnap2X[i2][Z]*factor;
		    }
		    else{
			ExecBezier2(pX[tgt], pCSnap0X[i0], pCSnap1X[i], pCSnap2X[i2], pCSnap3X[i3], factor);
		    }
		}
		tgt++;
	    }
	    break; }
	case _DOWNSIZE_BY_ID_LONGLONG: {
	    for (int i = PIni; i < PFin; i++){
		if (pCSnap1IDLongLong[i] % mDownsize != 0) continue;
		int i2 = pNextIndex[i];
		if (i2 == -1){
		    int i0 = pPrevIndex[i];
		    if (exterpolateType == 0 || i0 == -1){
			pX[tgt][X] = pCSnap1X[i][X];
			pX[tgt][Y] = pCSnap1X[i][Y];
			pX[tgt][Z] = pCSnap1X[i][Z]; }
		    else{
			pX[tgt][X] = pCSnap1X[i][X] + (pCSnap1X[i][X] - pCSnap0X[i0][X]) * factor;
			pX[tgt][Y] = pCSnap1X[i][Y] + (pCSnap1X[i][Y] - pCSnap0X[i0][Y]) * factor;
			pX[tgt][Z] = pCSnap1X[i][Z] + (pCSnap1X[i][Z] - pCSnap0X[i0][Z]) * factor;
		    }
		}
		else{
		    int i0 = pPrevIndex[i];
		    int i3 = pNextNextIndex[i2];
		    if (i0 == -1 || i3 == -1){
			pX[tgt][X] = 
			    pCSnap1X[i][X]*factorInv + pCSnap2X[i2][X]*factor;
			pX[tgt][Y] = 
			    pCSnap1X[i][Y]*factorInv + pCSnap2X[i2][Y]*factor;
			pX[tgt][Z] = 
			    pCSnap1X[i][Z]*factorInv + pCSnap2X[i2][Z]*factor;
		    }
		    else{
			ExecBezier2(pX[tgt], pCSnap0X[i0], pCSnap1X[i], pCSnap2X[i2], pCSnap3X[i3], factor);
		    }
		}
		tgt++;
	    }
	    break; }
	}
    }
    
}

void CLS::
InterpolateXYZHermite(){
    const int PIni = mPIni;
    const int PFin = mPFin;
    const ParticleSnap_cls *pCSnap1 = mpCSnap1;
    const ParticleSnap_cls *pCSnap2 = mpCSnap2;
    const int * const pCSnap1ID               = pCSnap1->mpID;
    const long long * const pCSnap1IDLongLong = pCSnap1->mpIDLongLong;
    const float (* const pCSnap1X)[3] = pCSnap1->mpX;
    const float (* const pCSnap2X)[3] = pCSnap2->mpX;
    const float (* const pCSnap1V)[3] = pCSnap1->mpV;
    const float (* const pCSnap2V)[3] = pCSnap2->mpV;
    const double factor = mFactor;
    const double factorInv = 1.0 - factor;
    float (* const pX)[3] = mpX;
    const int downsizeType = mDownsizeType;
    const double DT = pCSnap2->mSnapTime - pCSnap1->mSnapTime;

    int tgt = mTgtIni;
    switch(downsizeType){
    case _DOWNSIZE_BY_INDEX: { 
	for (int i = PIni; i < PFin; i++){
	    if (i % mDownsize != 0) continue;
	    float X1 = pCSnap1X[i][X], X2 = pCSnap2X[i][X];
	    float Y1 = pCSnap1X[i][Y], Y2 = pCSnap2X[i][Y];
	    float Z1 = pCSnap1X[i][Z], Z2 = pCSnap2X[i][Z];
	    float VX1 = pCSnap1V[i][X]*DT, VX2 = pCSnap2V[i][X]*DT;
	    float VY1 = pCSnap1V[i][Y]*DT, VY2 = pCSnap2V[i][Y]*DT;
	    float VZ1 = pCSnap1V[i][Z]*DT, VZ2 = pCSnap2V[i][Z]*DT;
	    pX[tgt][X] = X1 + factor*(VX1 + factor*(-3*X1-2*VX1+3*X2-VX2 + factor*(2*X1+VX1-2*X2+VX2)));
	    pX[tgt][Y] = Y1 + factor*(VY1 + factor*(-3*Y1-2*VY1+3*Y2-VY2 + factor*(2*Y1+VY1-2*Y2+VY2)));
	    pX[tgt][Z] = Z1 + factor*(VZ1 + factor*(-3*Z1-2*VZ1+3*Z2-VZ2 + factor*(2*Z1+VZ1-2*Z2+VZ2)));
	    tgt++;
	}
	break; }
    case _DOWNSIZE_BY_ID: {
	for (int i = PIni; i < PFin; i++){
	    if (pCSnap1ID[i] % mDownsize != 0) continue;
	    float X1 = pCSnap1X[i][X], X2 = pCSnap2X[i][X];
	    float Y1 = pCSnap1X[i][Y], Y2 = pCSnap2X[i][Y];
	    float Z1 = pCSnap1X[i][Z], Z2 = pCSnap2X[i][Z];
	    float VX1 = pCSnap1V[i][X]*DT, VX2 = pCSnap2V[i][X]*DT;
	    float VY1 = pCSnap1V[i][Y]*DT, VY2 = pCSnap2V[i][Y]*DT;
	    float VZ1 = pCSnap1V[i][Z]*DT, VZ2 = pCSnap2V[i][Z]*DT;
	    pX[tgt][X] = X1 + factor*(VX1 + factor*(-3*X1-2*VX1+3*X2-VX2 + factor*(2*X1+VX1-2*X2+VX2)));
	    pX[tgt][Y] = Y1 + factor*(VY1 + factor*(-3*Y1-2*VY1+3*Y2-VY2 + factor*(2*Y1+VY1-2*Y2+VY2)));
	    pX[tgt][Z] = Z1 + factor*(VZ1 + factor*(-3*Z1-2*VZ1+3*Z2-VZ2 + factor*(2*Z1+VZ1-2*Z2+VZ2)));
	    tgt++;
	}
	break; }
    case _DOWNSIZE_BY_ID_LONGLONG: {
	for (int i = PIni; i < PFin; i++){
	    if (pCSnap1IDLongLong[i] % mDownsize != 0) continue;
	    float X1 = pCSnap1X[i][X], X2 = pCSnap2X[i][X];
	    float Y1 = pCSnap1X[i][Y], Y2 = pCSnap2X[i][Y];
	    float Z1 = pCSnap1X[i][Z], Z2 = pCSnap2X[i][Z];
	    float VX1 = pCSnap1V[i][X]*DT, VX2 = pCSnap2V[i][X]*DT;
	    float VY1 = pCSnap1V[i][Y]*DT, VY2 = pCSnap2V[i][Y]*DT;
	    float VZ1 = pCSnap1V[i][Z]*DT, VZ2 = pCSnap2V[i][Z]*DT;
	    pX[tgt][X] = X1 + factor*(VX1 + factor*(-3*X1-2*VX1+3*X2-VX2 + factor*(2*X1+VX1-2*X2+VX2)));
	    pX[tgt][Y] = Y1 + factor*(VY1 + factor*(-3*Y1-2*VY1+3*Y2-VY2 + factor*(2*Y1+VY1-2*Y2+VY2)));
	    pX[tgt][Z] = Z1 + factor*(VZ1 + factor*(-3*Z1-2*VZ1+3*Z2-VZ2 + factor*(2*Z1+VZ1-2*Z2+VZ2)));
	    tgt++;
	}
	break; }
    }
}

void CLS::
InterpolateXYZLinear(){

    if (mpCSnap2->mpX == NULL)
	return InterpolateXYZStep();

    const int PIni = mPIni;
    const int PFin = mPFin;
    const ParticleSnap_cls *pCSnap1 = mpCSnap1;
    const ParticleSnap_cls *pCSnap2 = mpCSnap2;
    const int * const pCSnap1ID               = pCSnap1->mpID;
    const long long * const pCSnap1IDLongLong = pCSnap1->mpIDLongLong;
    const float (* const pCSnap1X)[3] = pCSnap1->mpX;
    const float (* const pCSnap2X)[3] = pCSnap2->mpX;
    const double factor = mFactor;
    const double factorInv = 1.0 - factor;
    float (* const pX)[3] = mpX;
    const int downsizeType = mDownsizeType;

    int tgt = mTgtIni;
    switch(downsizeType){
    case _DOWNSIZE_BY_INDEX: { 
	for (int i = PIni; i < PFin; i++){
	    if (i % mDownsize != 0) continue;
	    pX[tgt][X] = 
		pCSnap1X[i][X] * factorInv + pCSnap2X[i][X] * factor;
	    pX[tgt][Y] = 
		pCSnap1X[i][Y] * factorInv + pCSnap2X[i][Y] * factor;
	    pX[tgt][Z] = 
		pCSnap1X[i][Z] * factorInv + pCSnap2X[i][Z] * factor;
	    tgt++;
	}
	break; }
    case _DOWNSIZE_BY_ID: {
	for (int i = PIni; i < PFin; i++){
	    if (pCSnap1ID[i] % mDownsize != 0) continue;
	    pX[tgt][X] = 
		pCSnap1X[i][X] * factorInv + pCSnap2X[i][X] * factor;
	    pX[tgt][Y] = 
		pCSnap1X[i][Y] * factorInv + pCSnap2X[i][Y] * factor;
	    pX[tgt][Z] = 
		pCSnap1X[i][Z] * factorInv + pCSnap2X[i][Z] * factor;
	    tgt++;
	}
	break; }
    case _DOWNSIZE_BY_ID_LONGLONG: {
	for (int i = PIni; i < PFin; i++){
	    if (pCSnap1IDLongLong[i] % mDownsize != 0) continue;
	    pX[tgt][X] = 
		pCSnap1X[i][X] * factorInv + pCSnap2X[i][X] * factor;
	    pX[tgt][Y] = 
		pCSnap1X[i][Y] * factorInv + pCSnap2X[i][Y] * factor;
	    pX[tgt][Z] = 
		pCSnap1X[i][Z] * factorInv + pCSnap2X[i][Z] * factor;
	    tgt++;
	}
	break; }
    }
}

void CLS::
ExecBezier(float *tgt, const float* x0, const float* x1, const float* x2, const float* x3, float t){
    tgt[X] = x1[X] + 0.5*t*(x2[X] - x0[X] + t*(-x3[X] + 4*x2[X] - 5*x1[X] + 2*x0[X] + t*(x3[X] - 3*x2[X] + 3*x1[X] - x0[X])));
    tgt[Y] = x1[Y] + 0.5*t*(x2[Y] - x0[Y] + t*(-x3[Y] + 4*x2[Y] - 5*x1[Y] + 2*x0[Y] + t*(x3[Y] - 3*x2[Y] + 3*x1[Y] - x0[Y])));
    tgt[Z] = x1[Z] + 0.5*t*(x2[Z] - x0[Z] + t*(-x3[Z] + 4*x2[Z] - 5*x1[Z] + 2*x0[Z] + t*(x3[Z] - 3*x2[Z] + 3*x1[Z] - x0[Z])));
}

void CLS::
ExecBezier2(float *tgt, const float* x0, const float* x1, const float* x2, const float* x3, float t){
    float dx0[3] = {x1[X]-x0[X] - 0*(x3[X]-x0[X]),
		    x1[Y]-x0[Y] - 0*(x3[X]-x0[Y]),
		    x1[Z]-x0[Z] - 0*(x3[X]-x0[Z])};
    float dx1[3] = {x2[X]-x1[X] - 0*(x3[X]-x0[X]),
		    x2[Y]-x1[Y] - 0*(x3[Y]-x0[Y]),
		    x2[Z]-x1[Z] - 0*(x3[Z]-x0[Z])};
    float norm0 = sqrt(dx0[X]*dx0[X] + dx0[Y]*dx0[Y] + dx0[Z]*dx0[Z]);
    float norm1 = sqrt(dx1[X]*dx1[X] + dx1[Y]*dx1[Y] + dx1[Z]*dx1[Z]);

    float angleFactor = 1;
    if (norm0 != 0 && norm1 != 0){
	angleFactor = (dx0[X]*dx1[X] + dx0[Y]*dx1[Y] + dx0[Z]*dx1[Z]) / norm0 / norm1;
    }
    float h = 1.0/4.0 - 1.0/12.0*angleFactor;
    float tinv = 1.0-t;
    
    float P1[3] = {x1[X] + (x2[X]-x0[X])*h*t,
		   x1[Y] + (x2[Y]-x0[Y])*h*t,
		   x1[Z] + (x2[Z]-x0[Z])*h*t};
    float P2[3] = {(x1[X]+(x2[X]-x0[X])*h)*tinv + (x2[X]+(x1[X]-x3[X])*h)*t,
		   (x1[Y]+(x2[Y]-x0[Y])*h)*tinv + (x2[Y]+(x1[Y]-x3[Y])*h)*t,
		   (x1[Z]+(x2[Z]-x0[Z])*h)*tinv + (x2[Z]+(x1[Z]-x3[Z])*h)*t};
    float P3[3] = {x2[X] + (x1[X]-x3[X])*h*tinv,
		   x2[Y] + (x1[Y]-x3[Y])*h*tinv,
		   x2[Z] + (x1[Z]-x3[Z])*h*tinv};
    float Q1[3] = {P1[X]*tinv + P2[X]*t,
		   P1[Y]*tinv + P2[Y]*t,
		   P1[Z]*tinv + P2[Z]*t};
    float Q2[3] = {P2[X]*tinv + P3[X]*t,
		   P2[Y]*tinv + P3[Y]*t,
		   P2[Z]*tinv + P3[Z]*t};
    tgt[X] = Q1[X]*tinv + Q2[X]*t;
    tgt[Y] = Q1[Y]*tinv + Q2[Y]*t;
    tgt[Z] = Q1[Z]*tinv + Q2[Z]*t;

    /*
    wxString strLog;
    strLog << "angle Factor = " << angleFactor << ENDL;
    strLog << x0[X] << ":" << x1[X] << ":" << x2[X] << ":" << x3[X] << ENDL;
    strLog << P1[X] << ":" << P2[X] << ":" << P3[X] << ENDL;
    wxLogMessage(strLog);
    */
}

void CLS::
InterpolateXYZBezier(int bezierType){
    const int PIni = mPIni, PFin = mPFin;
    const ParticleSnap_cls *pCSnap1 = mpCSnap1;
    const ParticleSnap_cls *pCSnap2 = mpCSnap2;
    const ParticleSnap_cls *pCSnap0 = mpCSnap0;
    const ParticleSnap_cls *pCSnap3 = mpCSnap3;
    const int * const pCSnap1ID               = pCSnap1->mpID;
    const long long * const pCSnap1IDLongLong = pCSnap1->mpIDLongLong;
    const float (* const pCSnap1X)[3] = pCSnap1->mpX;
    const float (* const pCSnap2X)[3] = pCSnap2->mpX;
    const float (* const pCSnap0X)[3] = pCSnap0->mpX;
    const float (* const pCSnap3X)[3] = pCSnap3->mpX;
    const double factor = mFactor;
    const double factorInv = 1.0 - factor;
    float (* const pX)[3] = mpX;
    const int downsizeType = mDownsizeType;

    /*
    wxString strLog;
    strLog << mpCSnap0->mstrLoadedFileBody << ":" << mpCSnap1->mstrLoadedFileBody << ":" << mpCSnap2->mstrLoadedFileBody << ":" << mpCSnap3->mstrLoadedFileBody << ENDL;
    strLog << pCSnap0X[0][X] << ":" << pCSnap1X[0][X] << ":" << pCSnap2X[0][X] << ":" << pCSnap3X[0][X] << ENDL;
    strLog << mpCSnap3->mpX[0][X] << ENDL;
    wxLogMessage(strLog);
    */

    int tgt = mTgtIni;
    if (bezierType == 1){
	switch(downsizeType){
	case _DOWNSIZE_BY_INDEX: { 
	    for (int i = PIni; i < PFin; i++){
		if (i % mDownsize != 0) continue;
		ExecBezier(pX[tgt], pCSnap0X[i], pCSnap1X[i], pCSnap2X[i], pCSnap3X[i], factor); 
		tgt++; }
	    break; }
	case _DOWNSIZE_BY_ID: {
	    for (int i = PIni; i < PFin; i++){
		if (pCSnap1ID[i] % mDownsize != 0) continue;
		ExecBezier(pX[tgt], pCSnap0X[i], pCSnap1X[i], pCSnap2X[i], pCSnap3X[i], factor);
		tgt++; }
	    break; }
	case _DOWNSIZE_BY_ID_LONGLONG: {
	    for (int i = PIni; i < PFin; i++){
		if (pCSnap1IDLongLong[i] % mDownsize != 0) continue;
		ExecBezier(pX[tgt], pCSnap0X[i], pCSnap1X[i], pCSnap2X[i], pCSnap3X[i], factor);
		tgt++; }
	    break; }
	}
    }
    if (bezierType == 2){
	switch(downsizeType){
	case _DOWNSIZE_BY_INDEX: { 
	    for (int i = PIni; i < PFin; i++){
		if (i % mDownsize != 0) continue;
		ExecBezier2(pX[tgt], pCSnap0X[i], pCSnap1X[i], pCSnap2X[i], pCSnap3X[i], factor);
		tgt++; }
	    break; }
	case _DOWNSIZE_BY_ID: {
	    for (int i = PIni; i < PFin; i++){
		if (pCSnap1ID[i] % mDownsize != 0) continue;
		ExecBezier2(pX[tgt], pCSnap0X[i], pCSnap1X[i], pCSnap2X[i], pCSnap3X[i], factor);
		tgt++; }
	    break; }
	case _DOWNSIZE_BY_ID_LONGLONG: {
	    for (int i = PIni; i < PFin; i++){
		if (pCSnap1IDLongLong[i] % mDownsize != 0) continue;
		ExecBezier2(pX[tgt], pCSnap0X[i], pCSnap1X[i], pCSnap2X[i], pCSnap3X[i], factor);
		tgt++; }
	    break; }
	}
    }
}

void CLS::
InterpolateXYZStep(){
    const int PIni = mPIni, PFin = mPFin;
    const ParticleSnap_cls *pCSnap1 = mpCSnap1;
    float (* const pX)[3] = mpX;
    const int downsizeType = mDownsizeType;

    int tgt = mTgtIni;
    for (int i = PIni; i < PFin; i++){
	long long id = i;
	switch(downsizeType){
	case _DOWNSIZE_BY_ID:
	    id = mpCSnap1->mpID[i]; break;
	case _DOWNSIZE_BY_ID_LONGLONG:
	    id = mpCSnap1->mpIDLongLong[i]; break;
	}
	if (id % mDownsize != 0) continue;
	memcpy(pX[tgt], pCSnap1->mpX[i], sizeof(float)*3);
	tgt++; }
}

void CLS::
InterpolateSizeLinearByID(){
    const int PIni = mPIni, PFin = mPFin;
    const ParticleSnap_cls *pCSnap1 = mpCSnap1;
    const ParticleSnap_cls *pCSnap2 = mpCSnap2;
    const int * const pCSnap1ID               = pCSnap1->mpID;
    const long long * const pCSnap1IDLongLong = pCSnap1->mpIDLongLong;
    const double factor = mFactor;
    const double factorInv = 1.0 - factor;
    const int vanishSizeType = mVanishSizeTpe;
    
    unsigned char * const pType = mpType;
    const float * const sizeFactor = mSizeFactor;
    const int * const sizeType = mSizeType;

    float * const pSize = mpSize;
    const float * const pSize1 = pCSnap1->mpSize;
    const float * const pSize2 = pCSnap2->mpSize;
    int * const pNextIndex = pCSnap1->mpNextIndex;
    ASSERT(pNextIndex != NULL);
    
    const int downsizeType = mDownsizeType;
    if (pCSnap1->mpSize != NULL){
	int tgt = mTgtIni;
	switch(downsizeType){
	case _DOWNSIZE_BY_INDEX: {
	    for (int i = PIni; i < PFin; i++){
		if (i % mDownsize != 0) continue;
		if (sizeType[pType[tgt]] == 1)
		    pSize[tgt] = 1 * sizeFactor[pType[tgt]];
		else{
		    int i2 = pNextIndex[i];
		    if (i2 == -1){
			switch(vanishSizeType){
			case 0:
			    pSize[tgt] = pSize1[i] * sizeFactor[pType[tgt]];
			    break;
			case 1:
			    pSize[tgt] = pSize1[i] * sizeFactor[pType[tgt]] * factorInv;
			    break;
			case 2:
			    pSize[tgt] = 0; break;
			case 3:
			    if ((i % 10) < (10 * factorInv))
				pSize[tgt] = pSize1[i] * sizeFactor[pType[tgt]];
			    else
				pSize[tgt] = 0;
			    break;
			}
		    }
		    else
			pSize[tgt] = (pSize1[i ] * factorInv +
				      pSize2[i2] * factor) * sizeFactor[pType[tgt]];
		}
		tgt++; }
	    break; }
	case _DOWNSIZE_BY_ID: {
	    for (int i = PIni; i < PFin; i++){
		if (pCSnap1ID[i] % mDownsize != 0) continue;
		if (sizeType[pType[tgt]] == 1)
		    pSize[tgt] = 1 * sizeFactor[pType[tgt]];
		else{
		    int i2 = pNextIndex[i];
		    if (i2 == -1){
			switch(vanishSizeType){
			case 0:
			    pSize[tgt] = pSize1[i] * sizeFactor[pType[tgt]];
			    break; 
			case 1:
			    pSize[tgt] = pSize1[i] * sizeFactor[pType[tgt]] * factorInv;
			    break;
			case 2:
			    pSize[tgt] = 0; break;
			case 3:
			    if ((i % 10) < (10 * factorInv))
				pSize[tgt] = pSize1[i] * sizeFactor[pType[tgt]];
			    else
				pSize[tgt] = 0;
			    break;
			}
		    }
		    else
			pSize[tgt] = (pSize1[i ] * factorInv +
				      pSize2[i2] * factor) * sizeFactor[pType[tgt]]; break;
		}
		tgt++; }
	    break; }
	case _DOWNSIZE_BY_ID_LONGLONG: {
	    for (int i = PIni; i < PFin; i++){
		if (pCSnap1IDLongLong[i] % mDownsize != 0) continue;
		if (sizeType[pType[tgt]] == 1)
		    pSize[tgt] = 1 * sizeFactor[pType[tgt]];
		else{
		    int i2 = pNextIndex[i];
		    if (i2 == -1){
			switch(vanishSizeType){
			case 0:
			    pSize[tgt] = pSize1[i] * sizeFactor[pType[tgt]];
			    break; 
			case 1:
			    pSize[tgt] = pSize1[i] * sizeFactor[pType[tgt]] * factorInv;
			    break;
			case 2:
			    pSize[tgt] = 0; break;
			case 3:
			    if ((i % 10) < (10 * factorInv))
				pSize[tgt] = pSize1[i] * sizeFactor[pType[tgt]];
			    else
				pSize[tgt] = 0;
			    break;
			}
		    }
		    else
			pSize[tgt] = (pSize1[i ] * factorInv +
				      pSize2[i2] * factor) * sizeFactor[pType[tgt]];
		}
		tgt++; }
	    break; }
	}
    }
    else{
	int tgt = mTgtIni;
	for (int i = PIni; i < PFin; i++){
	    long long id = i;
	    switch(downsizeType){
	    case _DOWNSIZE_BY_ID:
		id = pCSnap1ID[i]; break;
	    case _DOWNSIZE_BY_ID_LONGLONG:
		id = pCSnap1IDLongLong[i]; break;
	    }
	    if (id % mDownsize != 0) continue;
	    pSize[tgt] = 1 * sizeFactor[pType[tgt]];
	    tgt++;
	}
    }
}

void CLS::
InterpolateSizeLinear(){
    const int PIni = mPIni, PFin = mPFin;
    const ParticleSnap_cls *pCSnap1 = mpCSnap1;
    const ParticleSnap_cls *pCSnap2 = mpCSnap2;
    const double factor = mFactor;
    const double factorInv = 1.0 - factor;
    
    unsigned char * const pType = mpType;
    const float * const sizeFactor = mSizeFactor;
    const int * const sizeType = mSizeType;
    float * const pSize = mpSize;
    const float * const pSize1 = pCSnap1->mpSize;
    const float * const pSize2 = pCSnap2->mpSize;

    const int downsizeType = mDownsizeType;
    if (pCSnap1->mpSize != NULL){
	int tgt = mTgtIni;
	for (int i = PIni; i < PFin; i++){
	    long long id = i;
	    switch(downsizeType){
	    case _DOWNSIZE_BY_ID:
		id = mpCSnap1->mpID[i]; break;
	    case _DOWNSIZE_BY_ID_LONGLONG:
		id = mpCSnap1->mpIDLongLong[i]; break;
	    }
	    if (id % mDownsize != 0) continue;
	    if (sizeType[pType[tgt]] == 0)
		pSize[tgt] = (pSize1[i] * factorInv +
			      pSize2[i] * factor) * sizeFactor[pType[tgt]];
	    else
		pSize[tgt] = 1 * sizeFactor[pType[tgt]];
	    tgt++; }
    }
    else{
	int tgt = mTgtIni;
	for (int i = PIni; i < PFin; i++){
	    long long id = i;
	    switch(downsizeType){
	    case _DOWNSIZE_BY_ID:
		id = mpCSnap1->mpID[i]; break;
	    case _DOWNSIZE_BY_ID_LONGLONG:
		id = mpCSnap1->mpIDLongLong[i]; break;
	    }
	    if (id % mDownsize != 0) continue;
	    pSize[tgt] = 1 * sizeFactor[pType[tgt]];
	    tgt++; }
    }
}

void CLS::
InterpolateSizeStep(){
    const int PIni = mPIni, PFin = mPFin;
    const ParticleSnap_cls *pCSnap1 = mpCSnap1;
    unsigned char * const pType = mpType;
    const float * const sizeFactor = mSizeFactor;
    const int * const sizeType = mSizeType;
    float * const pSize = mpSize;
    const float * const pSize1 = pCSnap1->mpSize;
    const int downsizeType = mDownsizeType;
    
    if (pSize1 != NULL){
	int tgt = mTgtIni;
	for (int i = PIni; i < PFin; i++){
	    long long id = i;
	    switch(downsizeType){
	    case _DOWNSIZE_BY_ID:
		id = mpCSnap1->mpID[i]; break;
	    case _DOWNSIZE_BY_ID_LONGLONG:
		id = mpCSnap1->mpIDLongLong[i]; break;
	    }
	    if (id % mDownsize != 0) continue;
	    if (sizeType[pType[tgt]] == 0)
		pSize[tgt] = pSize1[i] * sizeFactor[pType[tgt]];
	    else
		pSize[tgt] = 1 * sizeFactor[pType[tgt]];
	    tgt++; }
    }
    else{
	int tgt = mTgtIni;
	for (int i = PIni; i < PFin; i++){
	    long long id = i;
	    switch(downsizeType){
	    case _DOWNSIZE_BY_ID:
		id = mpCSnap1->mpID[i]; break;
	    case _DOWNSIZE_BY_ID_LONGLONG:
		id = mpCSnap1->mpIDLongLong[i]; break;
	    }
	    if (id % mDownsize != 0) continue;
	    pSize[tgt] = 1 * sizeFactor[pType[tgt]];
	    tgt++; }
    }
}

void CLS::
InterpolateValueLinearByID(float *pValue, int valueIndex){
    const int PIni = mPIni, PFin = mPFin;

    const ParticleSnap_cls *pCSnap1 = mpCSnap1;
    const ParticleSnap_cls *pCSnap2 = mpCSnap2;
    const int * const pCSnap1ID               = pCSnap1->mpID;
    const long long * const pCSnap1IDLongLong = pCSnap1->mpIDLongLong;
    const double factor = mFactor; //!!//
    const double factorInv = 1.0 - factor;
    //const int vanishSizeType = mVanishSizeTpe;
    const float * const pValue1 = pCSnap1->mpValue[valueIndex];
    const float * const pValue2 = pCSnap2->mpValue[valueIndex];
    ASSERT(pValue1 != NULL);
    ASSERT(pValue2 != NULL);
    int * const pNextIndex = pCSnap1->mpNextIndex;
    ASSERT(pNextIndex != NULL);

    const int downsizeType = mDownsizeType;    
    int tgt = mTgtIni;
    switch(downsizeType){
    case _DOWNSIZE_BY_INDEX: {
	for (int i = PIni; i < PFin; i++){
	    if (i % mDownsize != 0) continue;
	    int i2 = pNextIndex[i];
	    if (i2 == -1) pValue[tgt] = pValue1[i];
	    else	  pValue[tgt] = pValue1[i]*factorInv + pValue2[i2]*factor;
	    tgt++; }
	break; }
    case _DOWNSIZE_BY_ID: {
	for (int i = PIni; i < PFin; i++){
	    if (pCSnap1ID[i] % mDownsize != 0) continue;
	    int i2 = pNextIndex[i];
	    if (i2 == -1) pValue[tgt] = pValue1[i];
	    else          pValue[tgt] = pValue1[i]*factorInv + pValue2[i2]*factor;
	    tgt++; } 
	break; }
    case _DOWNSIZE_BY_ID_LONGLONG: {
	for (int i = PIni; i < PFin; i++){
	    if (pCSnap1IDLongLong[i] % mDownsize != 0) continue;
	    int i2 = pNextIndex[i];
	    if (i2 == -1) pValue[tgt] = pValue1[i];
	    else          pValue[tgt] = pValue1[i]*factorInv + pValue2[i2]*factor;
	    tgt++; }
	break; }
    }
}

void CLS::
InterpolateValueLinear(float *pValue, int valueIndex){
    const int PIni = mPIni, PFin = mPFin;
    const ParticleSnap_cls *pCSnap1 = mpCSnap1;
    const ParticleSnap_cls *pCSnap2 = mpCSnap2;
    const double factor = mFactor;
    const double factorInv = 1.0 - factor;
    const float * const pValue1 = pCSnap1->mpValue[valueIndex];
    const float * const pValue2 = pCSnap2->mpValue[valueIndex];
    ASSERT(pValue1 != NULL);
    ASSERT(pValue2 != NULL);

    const int downsizeType = mDownsizeType;
    int tgt = mTgtIni;
    for (int i = PIni; i < PFin; i++){
	long long id = i;
	switch(downsizeType){
	case _DOWNSIZE_BY_ID: 
	    id = mpCSnap1->mpID[i]; break;
	case _DOWNSIZE_BY_ID_LONGLONG:
	    id = mpCSnap1->mpIDLongLong[i]; break;
	}
	if (id % mDownsize != 0) continue;
	pValue[tgt] = pValue1[i]*factorInv + pValue2[i]*factor;
	tgt++; }
}

void CLS::
InterpolateValueStep(float *pValue, int valueIndex){
    const int PIni = mPIni, PFin = mPFin;
    const ParticleSnap_cls *pCSnap1 = mpCSnap1;
    const float * const pValue1 = pCSnap1->mpValue[valueIndex];
    ASSERT(pValue1 != NULL);

    const int downsizeType = mDownsizeType;
    int tgt = mTgtIni;
    for (int i = PIni; i < PFin; i++){
	long long id = i;
	switch(downsizeType){
	case _DOWNSIZE_BY_ID:
	    id = mpCSnap1->mpID[i]; break;
	case _DOWNSIZE_BY_ID_LONGLONG:
	    id = mpCSnap1->mpIDLongLong[i]; break;
	}
	if (id % mDownsize != 0) continue;
	pValue[tgt] = pValue1[i];
	tgt++; }
}

wxThread::ExitCode CLS::
Entry(){
    const int PIni = mPIni, PFin = mPFin;
    int interpType = mInterpType;
    const ParticleSnap_cls *pCSnap1 = mpCSnap1;
    const ParticleSnap_cls *pCSnap2 = mpCSnap2;
    const int *pCSnap1ID         = pCSnap1->mpID;
    const long long *pCSnap1IDLongLong = pCSnap1->mpIDLongLong;
    const float *pCSnap1Value0 = pCSnap1->mpValue[0];
    const float *pCSnap1Value1 = pCSnap1->mpValue[1];
    const float *pCSnap1Value2 = pCSnap1->mpValue[2];
    const float *pCSnap2Value0 = (pCSnap2 != NULL) ? pCSnap2->mpValue[0]: NULL;
    const float *pCSnap2Value1 = (pCSnap2 != NULL) ? pCSnap2->mpValue[1]: NULL;
    const float *pCSnap2Value2 = (pCSnap2 != NULL) ? pCSnap2->mpValue[2]: NULL;
    const unsigned char * const pCSnap1Type = pCSnap1->mpType;
    const double NT = mNT;
    const int sortType = mSortType;
    const int numMat = mNumMat;
    //const float * const sizeFactor = mSiFactor;
    //const int * const sizeType = mSizeType;
    const int * const sizeAlphaType = mSizeAlphaType;
    const float * const sizeAlphaBase = mSizeAlphaBase;
    const float * const sizeAlphaMax = mSizeAlphaMax;
    const int * const clrCurveType = mClrCurveType;
    const int * const clrCurveDepend = mClrCurveDepend;
    float (* const clrEmit)[3] = mClrEmit;
    const unsigned char * const paramBit = mParamBit;
    ParamGroup_cls * const *ppCClr = mppCClr;
    std::vector < double > * const VRange = mVRange;
    float (* const pX)[3] = mpX;
    unsigned char * const pType = mpType;
    int * const pID = mpID;
    long long * const pIDLongLong = mpIDLongLong;
    float * const pFilterAlpha = mpFilterAlpha;
    float * const pSize = mpSize;
    float * const pSizeAlpha = mpSizeAlpha;
    float * const pClrCurveS = mpClrCurveS;
    float * const pClrCurveT = mpClrCurveT;
    float * const pValue0 = mpValue0;
    float * const pValue1 = mpValue1;
    float * const pValue2 = mpValue2;
    unsigned char * const pParamBit = mpParamBit;
    ArrayAndIndex_cls * const pIndexAndZ = mpIndexAndZ;
    const double factor = mFactor;
    const double factorInv = 1.0 - factor;
    const int downsizeType = mDownsizeType;

    bool bUseID = mbUseID;
    if (interpType == 0) bUseID = FALSE;
    if (pCSnap1ID == NULL && pCSnap1IDLongLong == NULL) bUseID = FALSE;

    if (mbSearchNextIndexOnly == TRUE){
	if (bUseID == TRUE) SearchNextIndexByID();
	*mpbFinishedFlagLink = TRUE;
	return 0;
    }

    if (mpCSnap2 == NULL) interpType = 0;
    if ((mpCSnap3 == mpCSnap2) || (mpCSnap0 == mpCSnap1))
	if (interpType >= 3) interpType = 1;
    
    if (bUseID == FALSE && interpType != 0)
	if (mpCSnap1->mPNum != mpCSnap2->mPNum) interpType = 0;
    
    switch(interpType){
    case _INTERP_STEP:
	InterpolateXYZStep(); break;
    case _INTERP_LINEAR:
	if (bUseID == TRUE){
	    if (pCSnap1->mbNextIndexCalced == FALSE) SearchNextIndexByID();
	    InterpolateXYZLinearByID(); break; }
	InterpolateXYZLinear(); break;
    case _INTERP_HERMITE:
	if (bUseID == TRUE){
	    if (pCSnap1->mbNextIndexCalced == FALSE) SearchNextIndexByID();
	    InterpolateXYZHermiteByID(); break; } 
	InterpolateXYZHermite(); break;
    case _INTERP_BEZIER:
	if (bUseID == TRUE){
	    if (pCSnap1->mbNextIndexCalced == FALSE) SearchNextIndexByID();
	    if (pCSnap2->mbNextIndexCalced == TRUE)
		InterpolateXYZBezierByID(1); 
	    else
		InterpolateXYZLinearByID();
	    break; 
	}
	InterpolateXYZBezier(1); break;
    case _INTERP_BEZIERB:
	if (bUseID == TRUE){
	    if (pCSnap1->mbNextIndexCalced == FALSE) SearchNextIndexByID();
	    if (pCSnap2->mbNextIndexCalced == TRUE)
		InterpolateXYZBezierByID(2); 
	    else
		InterpolateXYZLinearByID();
	    break; }
	InterpolateXYZBezier(2); break;
    }
    

    if (mClassifyType == 1){
	ClassifyByExpression(pType, pCSnap1ID, pCSnap1IDLongLong,
			     PIni, PFin);
    }
    else{
	if (pCSnap1Type != NULL){
	    int tgt = mTgtIni;
	    for (int i = PIni; i < PFin; i++){
		long long id = i;
		switch(downsizeType){
		case _DOWNSIZE_BY_ID:
		    id = pCSnap1ID[i]; break;
		case _DOWNSIZE_BY_ID_LONGLONG:
		    id = pCSnap1IDLongLong[i]; break;
		}
		if (id % mDownsize != 0) continue;
		pType[tgt] = pCSnap1Type[i];
		tgt++;
	    }
	}
	else{
	    int tgt = mTgtIni;
	    for (int i = PIni; i < PFin; i++){
		long long id = i;
		switch(downsizeType){
		case _DOWNSIZE_BY_ID:
		    id = pCSnap1ID[i]; break;
		case _DOWNSIZE_BY_ID_LONGLONG:
		    id = pCSnap1IDLongLong[i]; break;
		}
		if (id % mDownsize != 0) continue;
		pType[tgt] = 0;
		tgt++;
	    }
	}
    }
    
    {// }eAŃ^Cv𐧌
     // _ETCYŕ\Ȃq pFilterAlpha0
	int tgt = mTgtIni;
	for (int i = PIni; i < PFin; i++){
	    long long id = i;
	    switch(downsizeType){
	    case _DOWNSIZE_BY_ID:
		id = pCSnap1ID[i]; break;
	    case _DOWNSIZE_BY_ID_LONGLONG:
		id = pCSnap1IDLongLong[i]; break;
	    }
	    if (id % mDownsize != 0) continue;
	    if (pType[tgt] >= numMat) pType[tgt] = numMat - 1;
	    tgt++;
	}
	if (downsizeType != _DOWNSIZE_BY_INDEX)
	    for (int i = tgt; i < PFin; i++)
		pFilterAlpha[i] = 0;
    }
    
    switch(interpType){
    case _INTERP_STEP:
	InterpolateSizeStep(); break;
    case _INTERP_LINEAR: case _INTERP_HERMITE:
    case _INTERP_BEZIER: case _INTERP_BEZIERB:
	if (bUseID == TRUE) InterpolateSizeLinearByID(); 
	else                InterpolateSizeLinear(); 
	break;
    }
    
    int clrDependMod[10];
    for (int type = 0; type < 10; type++){
	clrDependMod[type] = clrCurveDepend[type];
	if (clrDependMod[type] == _COLOR_CURVE_DEPEND_TYPE_VALUE0){
	    if (interpType != 0 && pCSnap1Value0 != NULL && pCSnap2Value0 != NULL)
		clrDependMod[type] = _COLOR_CURVE_DEPEND_TYPE_VALUE0_LINEAR;
	    else if (pCSnap1Value0 != NULL)
		clrDependMod[type] = _COLOR_CURVE_DEPEND_TYPE_VALUE0_STEP;
	    else
		clrDependMod[type] = _COLOR_CURVE_DEPEND_TYPE_INVALID;
	}
	if (clrDependMod[type] == _COLOR_CURVE_DEPEND_TYPE_VALUE1){
	    if (interpType != 0 && pCSnap1Value1 != NULL && pCSnap2Value1 != NULL)
		clrDependMod[type] = _COLOR_CURVE_DEPEND_TYPE_VALUE1_LINEAR;
	    else if (pCSnap1Value1 != NULL)
		clrDependMod[type] = _COLOR_CURVE_DEPEND_TYPE_VALUE1_STEP;
	    else
		clrDependMod[type] = _COLOR_CURVE_DEPEND_TYPE_INVALID;
	}
	if (clrDependMod[type] == _COLOR_CURVE_DEPEND_TYPE_VALUE2){
	    if (interpType != 0 && pCSnap1Value2 != NULL && pCSnap2Value2 != NULL)
		clrDependMod[type] = _COLOR_CURVE_DEPEND_TYPE_VALUE2_LINEAR;
	    else if (pCSnap1Value2 != NULL)
		clrDependMod[type] = _COLOR_CURVE_DEPEND_TYPE_VALUE2_STEP;
	    else
		clrDependMod[type] = _COLOR_CURVE_DEPEND_TYPE_INVALID;
	}
    }

    const int * const pNextIndex = pCSnap1->mpNextIndex;
    if (bUseID == TRUE)
	ASSERT(pNextIndex != NULL);
    
    {
	int tgt = mTgtIni;
	switch(downsizeType){
	case _DOWNSIZE_BY_INDEX: {
	    for (int i = PIni; i < PFin; i++){
		if (i % mDownsize != 0) continue;

		int type = pType[tgt];
		if (clrCurveType[type] == 1){
		    double value = 0, x0;
		    std::vector < double > VClr;
		    switch(clrDependMod[type]){
		    case _COLOR_CURVE_DEPEND_TYPE_INDEX:
			value = i; break;
		    case _COLOR_CURVE_DEPEND_TYPE_SIZE:
			value = pSize[tgt]; break;
		    case _COLOR_CURVE_DEPEND_TYPE_ID:
			if (pCSnap1IDLongLong != NULL)
			    value = pCSnap1IDLongLong[i];
			else if (pCSnap1ID != NULL)
			    value = pCSnap1ID[i];
			else value = 0;
			break;
		    case _COLOR_CURVE_DEPEND_TYPE_VALUE0_STEP:
			value = pCSnap1Value0[i]; break;
		    case _COLOR_CURVE_DEPEND_TYPE_VALUE0_LINEAR: {
			int i2 = i;
			if (bUseID == TRUE) i2 = pNextIndex[i];
			value = pCSnap1Value0[i] * factorInv + 
			    pCSnap2Value0[i2] * factor; 
			break;
		    }
		    case _COLOR_CURVE_DEPEND_TYPE_VALUE1_STEP:
			value = pCSnap1Value1[i]; break;
		    case _COLOR_CURVE_DEPEND_TYPE_VALUE1_LINEAR: {
			int i2 = i;
			if (bUseID == TRUE) i2 = pNextIndex[i];
			value = pCSnap1Value1[i] * factorInv + 
			    pCSnap2Value1[i2] * factor; 
			break; }
		    case _COLOR_CURVE_DEPEND_TYPE_VALUE2_STEP:
			value = pCSnap1Value2[i]; break;
		    case _COLOR_CURVE_DEPEND_TYPE_VALUE2_LINEAR: {
			int i2 = i;
			if (bUseID == TRUE) i2 = pNextIndex[i];
			value = pCSnap1Value2[i] * factorInv + 
			    pCSnap2Value2[i2] * factor; 
			break; }
		    case _COLOR_CURVE_DEPEND_TYPE_INVALID:
			value = 0; break;
			
		    case _COLOR_CURVE_DEPEND_TYPE_X:
			value = pX[tgt][0]; break;
		    case _COLOR_CURVE_DEPEND_TYPE_Y:
			value = pX[tgt][1]; break;
		    case _COLOR_CURVE_DEPEND_TYPE_Z:
			value = pX[tgt][2]; break;
		    }

		    x0 = GetRemapX(VRange[type], value/*, NT*/);
	    
		    pClrCurveS[tgt] = x0;
		    pClrCurveT[tgt] = ((float)type + 0.5) / numMat / 3;
		}
		else{
		    pClrCurveS[tgt] = 0;
		    pClrCurveT[tgt] = ((float)type + 0.5) / numMat / 3;
		}

		pParamBit[tgt] = paramBit[type];
		tgt++;
	    }
	    break; }
	case _DOWNSIZE_BY_ID: {
	    for (int i = PIni; i < PFin; i++){
		if (pCSnap1ID[i] % mDownsize != 0) continue;

		int type = pType[tgt];
		if (clrCurveType[type] == 1){
		
		    double value = 0, x0;
		    std::vector < double > VClr;
		    switch(clrDependMod[type]){
		    case _COLOR_CURVE_DEPEND_TYPE_INDEX:
			value = i; break;
		    case _COLOR_CURVE_DEPEND_TYPE_SIZE:
			value = pSize[tgt]; break;
		    case _COLOR_CURVE_DEPEND_TYPE_ID:
			if (pCSnap1IDLongLong != NULL)
			    value = pCSnap1IDLongLong[i];
			else if (pCSnap1ID != NULL)
			    value = pCSnap1ID[i];
			else value = 0;
			break;
		    case _COLOR_CURVE_DEPEND_TYPE_VALUE0_STEP:
			value = pCSnap1Value0[i]; break;
		    case _COLOR_CURVE_DEPEND_TYPE_VALUE0_LINEAR: {
			int i2 = i;
			if (bUseID == TRUE) i2 = pNextIndex[i];
			value = pCSnap1Value0[i] * factorInv + 
			    pCSnap2Value0[i2] * factor; 
			break;
		    }
		    case _COLOR_CURVE_DEPEND_TYPE_VALUE1_STEP:
			value = pCSnap1Value1[i]; break;
		    case _COLOR_CURVE_DEPEND_TYPE_VALUE1_LINEAR: {
			int i2 = i;
			if (bUseID == TRUE) i2 = pNextIndex[i];
			value = pCSnap1Value1[i] * factorInv + 
			    pCSnap2Value1[i2] * factor; 
			break; }
		    case _COLOR_CURVE_DEPEND_TYPE_VALUE2_STEP:
			value = pCSnap2Value1[i]; break;
		    case _COLOR_CURVE_DEPEND_TYPE_VALUE2_LINEAR: {
			int i2 = i;
			if (bUseID == TRUE) i2 = pNextIndex[i];
			value = pCSnap1Value2[i] * factorInv + 
			    pCSnap2Value2[i2] * factor; 
			break; }
		    case _COLOR_CURVE_DEPEND_TYPE_INVALID:
			value = 0; break;
		
		    case _COLOR_CURVE_DEPEND_TYPE_X:
			value = pX[tgt][0]; break;
		    case _COLOR_CURVE_DEPEND_TYPE_Y:
			value = pX[tgt][1]; break;
		    case _COLOR_CURVE_DEPEND_TYPE_Z:
			value = pX[tgt][2]; break;
		    }

		    x0 = GetRemapX(VRange[type], value/*, NT*/);
	    
		    pClrCurveS[tgt] = x0;
		    pClrCurveT[tgt] = ((float)type + 0.5) / numMat / 3;
		}
		else{
		    pClrCurveS[tgt] = 0;
		    pClrCurveT[tgt] = ((float)type + 0.5) / numMat / 3;
		}

		pParamBit[tgt] = paramBit[type];
		tgt++;
	    }
	    break; }
	case _DOWNSIZE_BY_ID_LONGLONG: {
	    for (int i = PIni; i < PFin; i++){
		if (pCSnap1IDLongLong[i] % mDownsize != 0) continue;
		
		int type = pType[tgt];
		if (clrCurveType[type] == 1){
		
		    double value = 0, x0;
		    std::vector < double > VClr;
		    switch(clrDependMod[type]){
		    case _COLOR_CURVE_DEPEND_TYPE_INDEX:
			value = i; break;
		    case _COLOR_CURVE_DEPEND_TYPE_SIZE:
			value = pSize[tgt]; break;
		    case _COLOR_CURVE_DEPEND_TYPE_ID:
			if (pCSnap1IDLongLong != NULL)
			    value = pCSnap1IDLongLong[i];
			else if (pCSnap1ID != NULL)
			    value = pCSnap1ID[i];
			else value = 0;
			break;
		    case _COLOR_CURVE_DEPEND_TYPE_VALUE0_STEP:
			value = pCSnap1Value0[i]; break;
		    case _COLOR_CURVE_DEPEND_TYPE_VALUE0_LINEAR: {
			int i2 = i;
			if (bUseID == TRUE) i2 = pNextIndex[i];
			value = pCSnap1Value0[i] * factorInv + 
			    pCSnap2Value0[i2] * factor; 
			break;
		    }
		    case _COLOR_CURVE_DEPEND_TYPE_VALUE1_STEP:
			value = pCSnap1Value1[i]; break;
		    case _COLOR_CURVE_DEPEND_TYPE_VALUE1_LINEAR: {
			int i2 = i;
			if (bUseID == TRUE) i2 = pNextIndex[i];
			value = pCSnap1Value1[i] * factorInv + 
			    pCSnap2Value1[i2] * factor; 
			break; }
		    case _COLOR_CURVE_DEPEND_TYPE_VALUE2_STEP:
			value = pCSnap2Value1[i]; break;
		    case _COLOR_CURVE_DEPEND_TYPE_VALUE2_LINEAR: {
			int i2 = i;
			if (bUseID == TRUE) i2 = pNextIndex[i];
			value = pCSnap1Value2[i] * factorInv + 
			    pCSnap2Value2[i2] * factor; 
			break; }
		    case _COLOR_CURVE_DEPEND_TYPE_INVALID:
			value = 0; break;
		
		    case _COLOR_CURVE_DEPEND_TYPE_X:
			value = pX[tgt][0]; break;
		    case _COLOR_CURVE_DEPEND_TYPE_Y:
			value = pX[tgt][1]; break;
		    case _COLOR_CURVE_DEPEND_TYPE_Z:
			value = pX[tgt][2]; break;
		    }

		    x0 = GetRemapX(VRange[type], value/*, NT*/);
	    
		    pClrCurveS[tgt] = x0;
		    pClrCurveT[tgt] = ((float)type + 0.5) / numMat / 3;
		}
		else{
		    pClrCurveS[tgt] = 0;
		    pClrCurveT[tgt] = ((float)type + 0.5) / numMat / 3;
		}

		pParamBit[tgt] = paramBit[type];
		tgt++;
	    }
	    break; }
	}
    }
    
    if (pSizeAlpha != NULL){
	int tgt = mTgtIni;
	for (int i = PIni; i < PFin; i++){
	    long long id = i;
	    switch(downsizeType){
	    case _DOWNSIZE_BY_ID:
		id = pCSnap1ID[i]; break;
	    case _DOWNSIZE_BY_ID_LONGLONG:
		id = pCSnap1IDLongLong[i]; break;
	    }
	    if (id % mDownsize != 0) continue;
	    int type = pType[tgt];
	    if (sizeAlphaType[type] == 1){
		const float size = pSize[tgt];
		const float l_sizeAlphaBase = sizeAlphaBase[type];
		const float l_sizeAlphaMax = sizeAlphaMax[type];
		pSizeAlpha[tgt] = 1.0f / size / size * l_sizeAlphaBase * l_sizeAlphaBase;
		if (pSizeAlpha[tgt] > l_sizeAlphaMax)
		    pSizeAlpha[tgt] = l_sizeAlphaMax;
		if (pSizeAlpha[tgt] < mAlphaCrit)
		    pSizeAlpha[tgt] = 0; // ؎̂
	    }
	    else
		pSizeAlpha[tgt] = 1.0f;
	    tgt++;
	}
    }

    if (pID != NULL){
	// Downsize ȂꍇłIDD
	int idType = _DOWNSIZE_BY_INDEX;
	if (pCSnap1ID != NULL) idType = _DOWNSIZE_BY_ID;
	if (pCSnap1IDLongLong != NULL) idType = _DOWNSIZE_BY_ID_LONGLONG;
	int tgt = mTgtIni;
	for (int i = PIni; i < PFin; i++){
	    long long id = i;
	    switch(idType){
	    case _DOWNSIZE_BY_ID:
		id = pCSnap1ID[i]; break;
	    case _DOWNSIZE_BY_ID_LONGLONG:
		id = pCSnap1IDLongLong[i]; break;
	    }
	    if (id % mDownsize != 0) continue;
	    
	    pID[tgt] = id;
	    
	    tgt++;
	}
    }

    if (pIDLongLong != NULL){
	// Downsize ȂꍇłIDD
	int idType = _DOWNSIZE_BY_INDEX;
	if (pCSnap1ID != NULL) idType = _DOWNSIZE_BY_ID;
	if (pCSnap1IDLongLong != NULL) idType = _DOWNSIZE_BY_ID_LONGLONG;
	int tgt = mTgtIni;
	for (int i = PIni; i < PFin; i++){
	    long long id = i;
	    switch(idType){
	    case _DOWNSIZE_BY_ID:
		id = pCSnap1ID[i]; break;
	    case _DOWNSIZE_BY_ID_LONGLONG:
		id = pCSnap1IDLongLong[i]; break;
	    }
	    if (id % mDownsize != 0) continue;
	    
	    pIDLongLong[tgt] = id;
	    
	    tgt++;
	}
    }

    if (pValue0 != NULL){
	switch(interpType){
	case _INTERP_STEP:
	    InterpolateValueStep(pValue0, 0); break;
	case _INTERP_LINEAR: case _INTERP_HERMITE:
	case _INTERP_BEZIER: case _INTERP_BEZIERB:
	    if (bUseID == TRUE) InterpolateValueLinearByID(pValue0, 0); 
	    else 		InterpolateValueLinear(pValue0, 0); 
	    break; }
    }

    if (pValue1 != NULL){
	switch(interpType){
	case _INTERP_STEP:
	    InterpolateValueStep(pValue1, 1); break;
	case _INTERP_LINEAR: case _INTERP_HERMITE:
	case _INTERP_BEZIER: case _INTERP_BEZIERB:
	    if (bUseID == TRUE) InterpolateValueLinearByID(pValue1, 1);
	    else 		InterpolateValueLinear(pValue1, 1); 
	    break; }
    }

    if (pValue2 != NULL){
	switch(interpType){
	case _INTERP_STEP:
	    InterpolateValueStep(pValue2, 2); break;
	case _INTERP_LINEAR: case _INTERP_HERMITE:
	case _INTERP_BEZIER: case _INTERP_BEZIERB:
	    if (bUseID == TRUE) InterpolateValueLinearByID(pValue2, 2);
	    else 		InterpolateValueLinear(pValue2, 2);
	    break; }
    }

    *mpbFinishedFlagLink = TRUE;
    return 0;
}

// ----

#define CLS ThreadSetArrayZ_cls

void CLS::
SetParameters(float (*pX)[3], unsigned char *pType, float *pFilterAlpha,
	      float *pSizeAlpha, unsigned char *pParamBit,
	      ArrayAndIndex_cls *pIndexAndZ,
	      PositionAndDirection_cls CSortPos, int sortType){
    mpX = pX;
    mpType = pType;
    mpFilterAlpha = pFilterAlpha;
    mpSizeAlpha = pSizeAlpha;
    mpParamBit = pParamBit;
    mpIndexAndZ = pIndexAndZ;
    mCSortPos = CSortPos;
    mSortType = sortType;
}

wxThread::ExitCode CLS::
Entry(){
    const int PIni = mPIni;
    const int PFin = mPFin;
    float (* const pX)[3] = mpX;
    unsigned char * const pType = mpType;
    float * const pFilterAlpha = mpFilterAlpha;
    float * const pSizeAlpha = mpSizeAlpha;
    unsigned char * const pParamBit = mpParamBit;
    ArrayAndIndex_cls * const pIndexAndZ = mpIndexAndZ;
    const PositionAndDirection_cls CSortPos = mCSortPos;
    const int sortType = mSortType;

    if (sortType == _SORT_NONE){
	for (int i = PIni; i < PFin; i++){
	    pIndexAndZ[i].mIndex = i;
	    pIndexAndZ[i].mZ = 0;
	}
    }
    
    if (sortType == _SORT_Z ||
	sortType == _SORT_OBJECT){
	const float sortPosX = CSortPos.mPos[0];
	const float sortPosY = CSortPos.mPos[1];
	const float sortPosZ = CSortPos.mPos[2];
	const float camTgtX = CSortPos.mTgt[0];
	const float camTgtY = CSortPos.mTgt[1];
	const float camTgtZ = CSortPos.mTgt[2];
	for (int i = PIni; i < PFin; i++){
	    pIndexAndZ[i].mIndex = i;
	    pIndexAndZ[i].mZ = -((pX[i][X] - sortPosX)*camTgtX +
				 (pX[i][Y] - sortPosY)*camTgtY +
				 (pX[i][Z] - sortPosZ)*camTgtZ);
	}
    }
    if (sortType == _SORT_Z_INV){
	const float sortPosX = CSortPos.mPos[0];
	const float sortPosY = CSortPos.mPos[1];
	const float sortPosZ = CSortPos.mPos[2];
	const float camTgtX = CSortPos.mTgt[0];
	const float camTgtY = CSortPos.mTgt[1];
	const float camTgtZ = CSortPos.mTgt[2];
	for (int i = PIni; i < PFin; i++){
	    pIndexAndZ[i].mIndex = i;
	    pIndexAndZ[i].mZ = ((pX[i][X] - sortPosX)*camTgtX +
				(pX[i][Y] - sortPosY)*camTgtY +
				(pX[i][Z] - sortPosZ)*camTgtZ);
	}
    }
    if (sortType == _SORT_DISTANCE || sortType == _SORT_DISTANCE_ONLY){	
	const float sortPosX = CSortPos.mPos[0];
	const float sortPosY = CSortPos.mPos[1];
	const float sortPosZ = CSortPos.mPos[2];
	for (int i = PIni; i < PFin; i++){
	    pIndexAndZ[i].mIndex = i;
	    pIndexAndZ[i].mZ = -sqrt((pX[i][X]-sortPosX)*(pX[i][X]-sortPosX) +
				     (pX[i][Y]-sortPosY)*(pX[i][Y]-sortPosY) +
				     (pX[i][Z]-sortPosZ)*(pX[i][Z]-sortPosZ));
	}
    }
    if (sortType == _SORT_DISTANCE_INV){	
	const float sortPosX = CSortPos.mPos[0];
	const float sortPosY = CSortPos.mPos[1];
	const float sortPosZ = CSortPos.mPos[2];
	for (int i = PIni; i < PFin; i++){
	    pIndexAndZ[i].mIndex = i;
	    pIndexAndZ[i].mZ = sqrt((pX[i][X]-sortPosX)*(pX[i][X]-sortPosX) +
				    (pX[i][Y]-sortPosY)*(pX[i][Y]-sortPosY) +
				    (pX[i][Z]-sortPosZ)*(pX[i][Z]-sortPosZ));
	}
    }
    if (sortType == _SORT_TYPE){
	for (int i = PIni; i < PFin; i++)
	    pIndexAndZ[i].mZ = -pType[i];
    }

    if (mpSizeAlpha != NULL)
	for (int i = PIni; i < PFin; i++)
	    pFilterAlpha[i] *= pSizeAlpha[i];
	
    for (int i = PIni; i < PFin; i++)
	if ((pParamBit[i] / _PARAMBIT_HIDE) % 2 == 1)
	    pFilterAlpha[i] *= 0;
        
    *mpbFinishedFlagLink = TRUE;
    return 0;
}
