// (setq-c-offset 4)
// "clsStreamlineForRenderInterpThread.h"

#include "clsStreamlineForRenderInterpThread.h"

#include "../clsStreamlineForRender.h"
#include "../clsStreamlineSnap.h"

#include "../../SCENEOBJ/DATAVIEWER/clsStreamline.h"

#include "../../COMMON/CommonDefinitions.h"

#define CLS ThreadStreamlineInterp_cls

void CLS::
SetParameters(StreamlineSnap_cls *pCSnap1, StreamlineSnap_cls *pCSnap2,
	      double factor,
	      float (*pPos)[3], float *pU, float *pValue, int *pLineIndex){
    mpCSnap1 = pCSnap1; mpCSnap2 = pCSnap2;
    mFactor = factor;
    mpPos = pPos;
    mpU = pU;
    mpValue = pValue;
    mpLineIndex = pLineIndex;
}

/*
void CLS::
SetParametersTime(double NT, int frame, int subFrame, int seq){
    mNT = NT;
    mFrame = frame;
    mSubFrame = subFrame;
    mSeq = seq;
}
*/

wxThread::ExitCode CLS::
Entry(){
    const int SIni = mPIni;
    const int SFin = mPFin;

    const StreamlineSnap_cls *pCSnap1 = mpCSnap1;
    const StreamlineSnap_cls *pCSnap2 = mpCSnap2;

    const double factor = mFactor;
    const double factorInv = 1.0 - factor;

    float (* const pPos)[3] = mpPos;
    float * const pU = mpU;
    float * const pValue = mpValue;
    int   * const pLineIndex = mpLineIndex;

    int interpType = 0; // Step;
    if (mpCSnap2 == NULL) interpType = 0;
    else{
	if (mpCSnap1->mSNum != mpCSnap2->mSNum) interpType = 0;
	else interpType = 1;
    }	

    switch(interpType){
    case 0:
	for (int i = SIni; i < SFin; i++){
	    mpPos[i][0] = pCSnap1->mpPos[i][0];
	    mpPos[i][1] = pCSnap1->mpPos[i][1];
	    mpPos[i][2] = pCSnap1->mpPos[i][2];
	    mpU[i] = pCSnap1->mpU[i];
	    mpValue[i] = pCSnap1->mpValue[i];
	    mpLineIndex[i] = pCSnap1->mpLineIndex[i];
	}
	break; 
    case 1:
	for (int i = SIni; i < SFin; i++){
	    mpPos[i][0] = pCSnap1->mpPos[i][0] * factorInv + pCSnap2->mpPos[i][0] * factor;
	    mpPos[i][1] = pCSnap1->mpPos[i][1] * factorInv + pCSnap2->mpPos[i][1] * factor;
	    mpPos[i][2] = pCSnap1->mpPos[i][2] * factorInv + pCSnap2->mpPos[i][2] * factor;
	    mpU[i] = pCSnap1->mpU[i] * factorInv + pCSnap2->mpU[i] * factor;
	    mpValue[i] = pCSnap1->mpValue[i] * factorInv + pCSnap2->mpValue[i] * factor;
	    mpLineIndex[i] = pCSnap1->mpLineIndex[i];
	}
    }

    *mpbFinishedFlagLink = TRUE;
    return 0;
}
