// -*- c -*- 
// "clsDF3Read.h"

#include "clsDF3Read.h"

#include "../clsVolumeSnap.h"
#include "../clsVolumeSequence.h"

#include "../../../clsFrameMain.h"

#include <stdio.h>
#include "../../COMMON/CommonDefinitions.h"
#include "../../COMMON/MyEndian.h"

#define CLS ThreadDF3Read

void CLS::
SetParameters(bool *pbFinishedFlagLink, VolumeSnap_cls *pCSnap){

    SetBaseParam(pbFinishedFlagLink, pCSnap);
    mstrFile = pCSnap->mstrFile.Clone();
    mbUseUShort = pCSnap->mbUseUShort;
    mbUseFloat = pCSnap->mbUseFloat;

    if (Create() != wxTHREAD_NO_ERROR) return;
}

void CLS::
ReadDF3(){
    FILE *pFile = fopen(mstrFile.char_str(), "rb");
    if (pFile != NULL){
	int size = mSize[X] * mSize[Y] * mSize[Z];
	fseek(pFile, 6, SEEK_SET);
	if (mbUseFloat == TRUE){
	    float *pData_float = new float[size];
	    int size8 = size / 8;
	    for (int i = 0; i < size; i+=8)
		MyEndian::SwapByte4x8((void*)&pData_float[i]);
	    for (int i = 8*size8; i < size; i++)
		MyEndian::SwapByte((void*)&pData_float[i], 4);
	    for (int i = 0; i < size; i++){
		float scale = 1;
		mpData_ushortLink[i] = pData_float[i]/scale * 65535;
	    }
	    delete [] pData_float;
	}
	else if (mbUseUShort == TRUE){
	    fread(mpData_ushortLink, sizeof(unsigned short), size, pFile);
	    
	    int size8 = size / 8;
	    for (int i = 0; i < size; i+=8)
		MyEndian::SwapByte2x8((void*)&mpData_ushortLink[i]);

	    for (int i = 8*size8; i < size; i++)
		MyEndian::SwapByte((void*)&mpData_ushortLink[i], 2);
	}
	else
	    fread(mpData_ucharLink, sizeof(uchar), size, pFile);
	fclose(pFile);
    }
    else{
	for (int z = 0; z < mSize[Z]; z++){
	    int indexz = z * mSize[X] * mSize[Y];
	    for (int y = 0; y < mSize[Y]; y++){
		int indexy = indexz + y * mSize[X];
		for (int x = 0; x < mSize[X]; x++){
		    int index = indexy + x;
		    if (z > 64)
			mpData_ucharLink[index] = 0;
		    else
			mpData_ucharLink[index] = 128;
		}
	    }
	}
    }
}

wxThread::ExitCode CLS::
Entry(){
    mpCDataSequenceLink->PushLock();
    DummyEntry();
    *mpbFinishedFlagLink = TRUE;
    mpCDataSequenceLink->PopLock();

    SendMenuEvent(GetPCFrameMain(0), menuFromSubThread);
    
    return 0;
}

void CLS::
DummyEntry(){
    ReadDF3();
}
