// -*- c -*- 
// "clsImgSeqRead.h"

#include "clsImgSeqRead.h"

#include "../clsVolumeSnap.h"
#include "../clsVolumeSequence.h"

#include "../../COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;
#include "../../GRAPHIC/clsReadPNG.h"

#include "../../../clsFrameMain.h"

#include <stdio.h>
#include "../../COMMON/CommonDefinitions.h"

#define CLS ThreadImgSeqRead

void CLS::
SetParameters(bool *pbFinishedFlagLink, VolumeSnap_cls *pCVolume){

    SetBaseParam(pbFinishedFlagLink, pCVolume);
    mCFSDual = pCVolume->mCFileSequenceDual;
    mFrame = pCVolume->mFrame;
    
    if (Create() != wxTHREAD_NO_ERROR) return;
}

void CLS::
ReadImgSeq(){
    mCFSDual.CalcMaxOffsetZ(mFrame);
    for  (int z = 0; z < mSize[Z]; z++){
	wxString strFile = mCFSDual.GetModifiedStrDual(mFrame, z);

	FILE *fp = fopen(strFile.char_str(), "rb");
	wxImage CImage;
	wxImage CImageDW;
	if (fp != NULL){
	    if (GCClassProvider.GetPCReadPNG()->ReadPNG(fp, strFile, CImage, CImageDW) == FALSE)
		CImage.LoadFile(strFile);
	    if (fp != NULL) fclose(fp);
	}
	
	//wxImage CImage(strFile);
	if (CImage.IsOk() == FALSE)
	    return;
	if (mSize[X] != CImage.GetWidth() ||
	    mSize[Y] != CImage.GetHeight()) return;

	if (CImageDW.IsOk() == TRUE){
	    int indexz = z * mSize[X] * mSize[Y];
	    for (int y = 0; y < mSize[Y]; y++){
		int indexy = indexz + (mSize[Y] - y - 1) * mSize[X];
		for (int x = 0; x < mSize[X]; x++){
		    int index = indexy + x;
		    mpData_ushortLink[index] = CImage.GetRed(x, y) *256 + CImageDW.GetRed(x,y);
		}
	    }
	}
	else{
	    int indexz = z * mSize[X] * mSize[Y];
	    for (int y = 0; y < mSize[Y]; y++){
		int indexy = indexz + (mSize[Y] - y - 1) * mSize[X];
		for (int x = 0; x < mSize[X]; x++){
		    int index = indexy + x;
		    mpData_ucharLink[index] = CImage.GetRed(x, y);
		}
	    }
	}
    }
}

wxThread::ExitCode CLS::
Entry(){
    mpCDataSequenceLink->PushLock();
    DummyEntry();
    *mpbFinishedFlagLink = TRUE;
    mpCDataSequenceLink->PopLock();

    SendMenuEvent(GetPCFrameMain(0), menuFromSubThread);
    
    return 0;
}

void CLS::
DummyEntry(){
    ReadImgSeq();
}
