// -*- c -*- 
// "clsDataSequence.cpp"

#ifndef _DATA_SEQUENCE_H
#define _DATA_SEQUENCE_H

#include "../COMMON/clsFileSequence.h"
#include "../COMMON/clsFileSequenceDual.h"
#include "../COMMON/clsGetPC.h"
#include "../PARAMETER/clsParamDrawTLBase.h"
#include "../PARAMETER/clsParameter.h"

class DataSnap_cls;
class Parameter_cls;
class ParamGroup_cls;

class DataSequence_cls : public FileSequence_cls, public FileSequenceDual_cls, public ParamDrawTLBase_cls, public GetPC_cls {
 public:
    DataSequence_cls(int type);
    ~DataSequence_cls();
    void ClearSequence();

    int mDataType;
    int mReadingLock;
    int mDrawCounter;
    int mTotalUsedMemoryMB; //Idle ɎWꂽ̕ێ

    DataSnap_cls **mApCSnap;
    bool mbTimeDepend;
    
    void MarkPriority(ParamGroup_cls *pCRemapParamGroup, bool bRepeat);
    int GetOldestDrawnIndex();
    virtual int GetTotalUsedMemoryMB() = 0;
    bool IsDataValid();

    int GetRemappedIndex(int index, ParamGroup_cls *pCRemapParamGroup, double NT,
			 bool bRepeat);
    void DrawTL(wxDC& dc, TLPanelGeom_cls* pCGeom,
		wxBitmap &CBitmapBuffer,
		int sashX, int posY, int panelWidth, int height,
		double normalizedWAMin, double normalizedWAMax,
		ParamGroup_cls *pCRemapParamGroup, bool bRepeat = FALSE);
    void CalcMaxOffset(bool bSequence = TRUE);
    void CalcMaxOffsetDual();
    void PushLock();
    void PopLock();
    
    wxString GetStrInfo(bool bZStack);
};

#endif
