// -*- c -*- 
// "clsImageSequence.h"

#include "clsImageSequence.h"

#include "clsDataSnap.h"
#include "clsImageSnap.h"

#define CLS ImageSequence_cls

CLS::
ImageSequence_cls() : DataSequence_cls(_DATA_IMAGE){
    mbTimeDepend = FALSE;
}

CLS::
~ImageSequence_cls(){
    if (mApCSnap != NULL){
	for (int i = 0; i < mSeqLen; i++){
	    if (mApCSnap[i] != NULL){
		delete (ImageSnap_cls*)mApCSnap[i];
		mApCSnap[i] = NULL;
	    }
	}
	delete mApCSnap;
	mApCSnap = NULL;
    }
}

int CLS:: 
GetTotalUsedMemoryMB(){
    mTotalUsedMemoryMB = 0;
    return mTotalUsedMemoryMB;
}

ImageSnap_cls* CLS::
GenerateIfNot(int index){

    int seqLen = mSeqLen;
    if (mSeqLenT >= 0) seqLen = mSeqLenT;

    if (index >= seqLen) index = seqLen - 1;
    if (index < 0) index = 0;
    if (mbTimeDepend == FALSE) index = 0;
    
    if (mApCSnap == NULL) return NULL;

    if (mApCSnap[index] == NULL){
	mApCSnap[index] = new ImageSnap_cls(this, index);
    }

    return (ImageSnap_cls*)mApCSnap[index];
}

ImageSnap_cls* CLS::
GetPCSnap(int index){
    if (mApCSnap == NULL) return NULL;
    
    if (index >= mSeqLen) index = mSeqLen - 1;
    if (index < 0) index = 0;
    if (mbTimeDepend == FALSE) index = 0;

    return (ImageSnap_cls*)mApCSnap[index];
}
