// -*- c -*- 
// "clsParticleSnap.cpp"

#ifndef _PARTICLE_SNAP_H
#define _PARTICLE_SNAP_H

#include "clsDataSnap.h"

//#include "../COMMON/clsGetPC.h"
#include "../WIDGETCTRL/clsWidgetCommon.h"

#include "../COMMON/CommonDefinitionsForH.h"

#include "../../wxWidgetEnumMenu.h"

#include <wx/wx.h>

class ParticleFormat_cls;
class ParticleFormatClone_cls;
class ParticleSequence_cls;

class ThreadReadBuffer_cls : public wxThread {
 public:
    ThreadReadBuffer_cls();
    void SetParameters(bool *pbFinishedFlagLink,
		       std::istream *pifstream, char *pBuf, int size);

    bool *mpbFinishedFlagLink;
    std::istream *mpifstream;
    char *mpBuf;
    int  mSize;

    virtual ExitCode Entry();
};

class ParticleSnap_cls : public DataSnap_cls {
 public:
    ParticleSnap_cls(ParticleSequence_cls *pCParent, int index);
    ~ParticleSnap_cls();
    void Clear();

    bool mValidData;
    // XbhłmbNextIndexCalcedThread  iĂłɁjTRUE
    // SImbNextIndexCalced TRUE ɂB
    bool mbNextIndexCalcStarted;
    bool mbNextIndexCalced, mbNextIndexCalcedThread;
    bool mbPrevIndexCalced;
    int mFrame;

    bool mbAllocated;
    bool mbUseVelocity, mbUseType, mbUseID, mbUseIDLongLong;
    bool mbInterpolateByID;
    bool mbUseSize, mbUseValue[_MAX_PVALUE];
    int mPNum;
    double mSnapTime;
    float (*mpX)[3];
    float (*mpV)[3];
    int *mpID;
    long long *mpIDLongLong;
    int *mpNextIndex, *mpPrevIndex;
    unsigned char *mpType;
    float *mpSize;
    float *mpValue[_MAX_PVALUE];
    
    wxString mstrFile;
    wxString mstrLoadedFileHeader, mstrLoadedFileBody;
    int mDataType;

    wxString GetStrInfo(int infoIndex);
    int GetUsedMemoryByte();

    void AllocateIfNot(int PNum);
    void CheckAllocateNextIndex(bool bInterpolateById);
    void SetStrFile(wxString strFile);
    void SetFrame(int frame);

    void ReadHeaderBinarySTREAM(ParticleFormatClone_cls *pCFormatClone,
			       std::istream &istream,
			       int &PNum, double &snapTime);
    void ReadHeaderBinary(ParticleFormatClone_cls *pCFormatClone,
			  int &PNum, double &snapTime);
    void ReadHeaderAsciiSTREAM(ParticleFormatClone_cls *pCFormatClone,
			      std::istream &istream,
			      int &PNum, double &snapTime);
    void ReadHeaderAscii(ParticleFormatClone_cls *pCFormatClone,
			 int &PNum, double &snapTime);
    
    bool ReadHeader(ParticleFormatClone_cls *pCFormatClone);
    bool DefaultData();
    bool ReadData(ParticleFormatClone_cls *pCFormatClone,
		  bool bParallel = FALSE);
    
    bool PrefetchData(ParticleFormatClone_cls *pCFormatClone);

    void ExportSnap(wxString strFile, int direction);
    wxString GetStrExportFormat(int direction);
};

#endif

