// (setq-c-offset 4)
// "clsStreamlineForRender.cpp"

#ifndef _STREAMLINE_FOR_RENDER_H
#define _STREAMLINE_FOR_RENDER_H

class StreamlineSnap_cls;
class ViewerClone_cls;

#include "../COMMON/clsThreadCommon.h"

class StreamlineForRender_cls : public ThreadCommon_cls {
public:
    StreamlineForRender_cls();
    ~StreamlineForRender_cls();

    int mSNum;
    float (*mpPos)[3];
    float *mpU;
    float *mpValue;
    int   *mpLineIndex;
    float *mpFilterAlpha;

    int mFrame;
    float mFactor;

    wxString mstrStatusLog;

    int mDrawCounter;
    
    void Clear();

    bool CheckUpdate(int frame, float factor, wxString strStatusLog);

    void PrepareCommonRenderParameter(ViewerClone_cls *pCParticleClone);

    void Allocate(long long SNum, bool bUseFilterAlpha);
    void PrepareData(StreamlineSnap_cls *pCSnap1, StreamlineSnap_cls *pCSnap2,
		     int frame, int subFrame, int seq, double factor, 
		     ViewerClone_cls *pCStreamlineClone,
		     double NT);
    void ProcFiltering(double NT, ViewerClone_cls *pCStreamlineClone);
    void ProcSetAlpha (double NT, ViewerClone_cls *pCStreamlineClone);
    void ProcTransform(double NT, ViewerClone_cls *pCStreamlineClone);
};

#endif
