// (setq-c-offset 4)
// "clsVolumeForRender.cpp"

#ifndef _VOLUME_FOR_RENDER_H
#define _VOLUME_FOR_RENDER_H

#include "../COMMON/clsTensorMath.h"
#include "../COMMON/clsThreadCommon.h"
#include "../COMMON/clsGetPC.h"

class VolumeSnap_cls;
class VolumeBox_cls;
class ViewerClone_cls;

#include <wx/wx.h>

class ThreadCallBoolean_cls : public ThreadInstance_cls{
 public:
    void SetParameters(ViewerClone_cls *pCVolumeBoxClone, char *pMask,
		       int sizeX, int sizeY, int sizeZ,
		       double NT);
    bool CreateThread(bool *pbFinishedFlag);
    
    ViewerClone_cls *mpCVolumeBoxClone;
    char *mpMask;
    int mSizeX, mSizeY, mSizeZ;
    double mNT;

    virtual ExitCode Entry();
};

class VolumeFoRender_cls : public GetPC_cls, public ThreadCommon_cls, public TensorMath_cls {
 public:
    VolumeFoRender_cls();
    ~VolumeFoRender_cls();

    int mSize[3];
    
    char *mpMask;
    unsigned char *mpData_uchar;
    unsigned short *mpData_ushort;
    
    int mSizeAllocatedData, mSizeAllocatedMask;
    int mFrame;
    float mFactor;
    wxString mstrProcCounterForProcess;
    bool mbFinishedFlagBoolean;
    wxString mstrSnap1LoadedBody, mstrSnap2LoadedBody;

    double mNT; //mFrame mFactor ƈ DataProc ]p̎
    bool mbDataBakedToTexture;
    unsigned int mTexture3D;

    //int mDrawCounter;
    int mPrepareCounter;
    
    void Clear();
    void ClearData();
    void ClearMask();
    void ClearTexture();

    bool IsSameStep(int frame, double factor);
    void CopyDataFromSnap_EqualSize(VolumeSnap_cls *pCSnap1, VolumeSnap_cls *pCSnap2,
				    double factor, int size);
    void CopyDataFromSnap_Resized(VolumeSnap_cls *pCSnap1, VolumeSnap_cls *pCSnap2,
				  double factor, int size);
    void PrepareData(VolumeSnap_cls *pCSnap1, VolumeSnap_cls *pCSnap2,
		     int frame, double factor, 
		     ViewerClone_cls *pCVolumeBoxClone,
		     bool bForce, double NT);
    void ProcDownSize(int currentSize[3], ViewerClone_cls*pCVolumeBoxClone);
    void ProcDataModifierFirst(ViewerClone_cls*pCVolumeBoxClone);
    void ProcDataModifierLast(ViewerClone_cls *pCVolumeBoxClone);
    wxString GetStrProcCounterForProcess(VolumeBox_cls *pCVolumeBox, double NT);
    wxString GetStrProcCounterForProcessClone(ViewerClone_cls *pCVolumeBoxClone, double NT);
    void ProcDataBooleanFirst(ViewerClone_cls *pCVolumeBoxClone);
    void ProcDataBooleanLast(ViewerClone_cls *pCVolumeBoxClone);
    void PrepareTexture();
    void BindTexture();
};

#endif
