// -*- c -*- 
// "clsVolumeSnap.cpp"

#ifndef _VOLUME_SNAP_H
#define _VOLUME_SNAP_H

#define _VOLUME_UCHAR 0
#define _VOLUME_USHORT 1

#include "clsDataSnap.h"

#include "../COMMON/clsGetPC.h"
#include "../COMMON/clsFileSequenceDual.h"
#include "../WIDGETCTRL/clsWidgetCommon.h"

#include "../../wxWidgetEnumMenu.h"

#include <wx/wx.h>

class VolumeSequence_cls;

class VolumeSnap_cls : public DataSnap_cls {
 public:
    VolumeSnap_cls(VolumeSequence_cls *pCParent, int index);
    ~VolumeSnap_cls();
    void Clear();
    void ClearUChar();
    void ClearUShort();

    int mFrame;
    FileSequenceDual_cls mCFileSequenceDual;
    wxString mstrFile;
    wxString mstrLoadedFileHeader, mstrLoadedFileBody;
    //int mDataFormat;
    bool mbZStack;
    bool mbUseUShort;
    bool mbUseFloat;

    int mSize[3];
    int mAllocatedSize[3];
    unsigned char *mpData_uchar;
    unsigned short *mpData_ushort;

    bool IsSizeSame(VolumeSnap_cls* pCTgt);
    wxString GetStrInfo(int x, int y, int z);
    int GetUsedMemoryByte();

    void AllocateIfNot();
    void GetScaleCandid(double scaleCandid[3]);
    void SetStrFile(wxString strFile);
    void SetFileSequenceDual(FileSequenceDual_cls *pCFSDual, int frame);
    bool ReadHeaderZStack();
    bool ReadHeader(bool bZStack);
    bool DefaultData();
    bool ReadData(bool bParallel = FALSE);

    bool PrefetchData(bool bZStack);
};

#endif
