// -*- c++ -*-
// "clsAACtrl.h"

#include "clsAACtrl.h"
#include "clsTimeCtrl.h"

#include "../SCENEOBJ/DATAVIEWER/clsColorCurve.h"
#include "../MISC/clsMisc.h"

#define CLS AACtrl_cls

double CLS::
GetTimeNormalized(){
    if (mDraggingItem == _TL_SEL_TIME) return mDraggingNormalTime;
    return GetPCTimeCtrl()->GetCurrentNT();
}

void CLS::
SetRegion(int type){
    if (type == _TL_AA){
	int mid = (mCAAMin.GetBodyINT() + mCAAMax.GetBodyINT()) / 2;
	mRegionLforDrag = mid - mCAAMin.GetBodyINT();
	mRegionRforDrag = mCAAMax.GetBodyINT() - mid;
    }
    if (type == _TL_WA){
	int mid = (GetPCTimeCtrl()->mCWAMin.GetBodyINT() + GetPCTimeCtrl()->mCWAMax.GetBodyINT()) / 2;
	mRegionLforDrag = mid - GetPCTimeCtrl()->mCWAMin.GetBodyINT();
	mRegionRforDrag = GetPCTimeCtrl()->mCWAMax.GetBodyINT() - mid;
    }
}

void CLS::
ExpandAA(bool bExpand){
    int minAtClick = mCAAMin.GetBodyINT();
    int maxAtClick = mCAAMax.GetBodyINT();
    int current = GetPCTimeCtrl()->mCFrameCurrent.GetBodyINT();
    int depthMin = (current -  minAtClick);
    int depthMax = (maxAtClick - current);
    int newMin, newMax;
    
    if (bExpand == FALSE){
	newMin = current - depthMin * 2; 
	newMax = current + depthMax * 2;
    }
    else{
	newMin = current - depthMin / 2; 
	newMax = current + depthMax / 2;
    }
    
    if (newMin < 0) newMin = 0;
    if (newMin > current) newMin = current;

    int frameMax = GetPCTimeCtrl()->mCFrameMax.GetBodyINT();
    if (newMax > frameMax) newMax = frameMax;
    if (newMax < current) newMax = current;

    if (newMax < newMin + 2) return;

    mCAAMin.SetBodyFromData((long long)newMin);
    mCAAMax.SetBodyFromData((long long)newMax);
}

void CLS::
ExpandAAForColor(bool bExpand, int current){
    int minAtClick = mCAAMin.GetBodyINT();
    int maxAtClick = mCAAMax.GetBodyINT();
    int depthMin = (current -  minAtClick);
    int depthMax = (maxAtClick - current);
    int newMin, newMax;
    
    if (bExpand == FALSE){
	newMin = current - depthMin * 2; 
	newMax = current + depthMax * 2;
    }
    else{
	newMin = current - depthMin / 2; 
	newMax = current + depthMax / 2;
    }
    
    if (newMin < 0) newMin = 0;
    if (newMin > current) newMin = current;

    int frameMax = _COLOR_CURVE_RESOLUTION;
    if (newMax > frameMax) newMax = frameMax;
    if (newMax < current) newMax = current;

    if (newMax < newMin + 2) return;

    mCAAMin.SetBodyFromData((long long)newMin);
    mCAAMax.SetBodyFromData((long long)newMax);
}

double CLS::
GetWAMinNormalized(){
    if (mDraggingItem == _TL_SEL_WA_MIN) return mDraggingNormalTime;
    if (mDraggingItem == _TL_SEL_WA_REGION){
	int frameMax = GetPCTimeCtrl()->mCFrameMax.GetBodyINT();
	return mDraggingNormalTime - (double)mRegionLforDrag / frameMax; 
    }
    return GetPCTimeCtrl()->GetNormalizedWAMin();
}

double CLS::
GetWAMaxNormalized(){
    if (mDraggingItem == _TL_SEL_WA_MAX) return mDraggingNormalTime;
    if (mDraggingItem == _TL_SEL_WA_REGION){
	int frameMax = GetPCTimeCtrl()->mCFrameMax.GetBodyINT();
	return mDraggingNormalTime + (double)mRegionRforDrag / frameMax; 
    }
    return GetPCTimeCtrl()->GetNormalizedWAMax();
}

double CLS::
GetWARegionNormalizedQ(){
    if (mDraggingItem == _TL_SEL_WA_MIN)
	return GetPCTimeCtrl()->GetQuantized((mDraggingNormalTime + GetPCTimeCtrl()->GetNormalizedWAMax())/2, _MISC_ROUND_DOWN);
    if (mDraggingItem == _TL_SEL_WA_MAX)
	return GetPCTimeCtrl()->GetQuantized((mDraggingNormalTime + GetPCTimeCtrl()->GetNormalizedWAMin())/2, _MISC_ROUND_DOWN);
    if (mDraggingItem == _TL_SEL_WA_REGION)
	return mDraggingNormalTime;
    return GetPCTimeCtrl()->GetQuantized(GetPCTimeCtrl()->GetNormalizedWARegion(), _MISC_ROUND_DOWN);
}
