// -*- c++ -*-/
// "clsDefaultKey.h"

#include "clsDefaultKey.h"
#include "clsTimeCtrl.h"

#include "../COMMON/clsClassProvider.h"

extern ClassProvider_cls GCClassProvider;

#include "../UNDO/clsUndoManager.h"

#include "../WIDGETCTRL/clsBitmapPanel.h"
#include "../WIDGETCTRL/INPUTITEM/clsVCenter.h"

#include "../WIDGETCTRL/WX/myArtProv.h"
#include "../WIDGETCTRL/WX/clsStringProvider.h"

#include "../../clsMain.h"

#include "../../wxWidgetEnum.h"

#include <wx/bmpcbox.h>

#define CLS DefaultKey_cls

VCenter_cls* CLS::
SetDefaultKey(wxWindow *pCThis){
    int defaultKey = GCClassProvider.GetPCTimeCtrl()->mCDefaultKey.GetBodyINT();
    wxString *AstrKey = GCClassProvider.GetPCStringProvider()->GetAstr("DefaultKey");
    mpCDefaultKey = 
	new wxBitmapComboBox(pCThis, cmbDefaultKey, AstrKey[defaultKey], wxDPS, 5, AstrKey);

    mpCDefaultKey->SetItemBitmap(0, ART("wxART_TLICON_LINEAR_N"));
    mpCDefaultKey->SetItemBitmap(1, ART("wxART_TLICON_HERMITE_AUTO_N"));
    mpCDefaultKey->SetItemBitmap(2, ART("wxART_TLICON_HERMITE_EASE_N"));
    mpCDefaultKey->SetItemBitmap(3, ART("wxART_TLICON_STEP_N"));
    mpCDefaultKey->SetItemBitmap(4, ART("wxART_TLICON_AUTO"));

    mpCBitmapKeyType = 
	new BitmapPanel_cls(pCThis, btnCtrlDefaultKey, wxDP, wxSize(15, 15));
    mpCBitmapKeyType->SetBorder(3, 3);
    mpCBitmapKeyType->AddBitmapStr("wxART_TLICON_LINEAR_N", "wxART_TLICON_LINEAR_P");
    mpCBitmapKeyType->mbButton = TRUE;
    VCenter_cls *pCDefaultKeyIcon = new VCenter_cls(mpCBitmapKeyType);

    return pCDefaultKeyIcon;
}

void CLS::
ProcDefaultKey(wxComEvt& event){
    wxString strNewType = event.GetString();
    long long newValue = 0;
    newValue = GCClassProvider.GetPCStringProvider()->GetIndexFromStr("DefaultKey", strNewType);
    //if (strNewType.IsSameAs("Ease")) newValue = 1;
    
    wxString strFrom, strTo;
    GCClassProvider.GetPCTimeCtrl()->mCDefaultKey.SerializeSingleItem(strFrom);
    GCClassProvider.GetPCTimeCtrl()->mCDefaultKey.SetBodyFromData(newValue);
    GCClassProvider.GetPCTimeCtrl()->mCDefaultKey.SerializeSingleItem(strTo);
    if (strFrom.IsSameAs(strTo) == FALSE){
	GCClassProvider.GetPCUndo()->PushCommandPair(strFrom, strTo);
	GCClassProvider.GetPCUndo()->Skip(); //łɕύXĂ̂SkipB
	GCClassProvider.GetPCMain()->UpdatePanels("CONSOLE::TIMELINE::GRAPH::COLOR_CURVE");
    }
}

void CLS::
ProcButtonDefaultKey(){
    int keyType;
    double ease;
    GCClassProvider.GetPCTimeCtrl()->GetDefaultKeyTypeAndEase(&keyType, &ease);
    if (keyType == -1) return;
    
    GCClassProvider.GetPCMain()->SetSelectedTLKeyTypeCommand(keyType, ease);
}

void CLS::
UpdateDefaultKeyIcon(){
    int defaultKey = GCClassProvider.GetPCTimeCtrl()->mCDefaultKey.GetBodyINT();
    wxString *AstrKey = GCClassProvider.GetPCStringProvider()->GetAstr("DefaultKey");
    mpCDefaultKey->SetValue(AstrKey[defaultKey]);

    switch(defaultKey){
    case 0:
	mpCBitmapKeyType->SetBitmapStr(0, "wxART_TLICON_LINEAR_N", "wxART_TLICON_LINEAR_P"); 
	break;
    case 1:
	mpCBitmapKeyType->SetBitmapStr(0, "wxART_TLICON_HERMITE_AUTO_N", "wxART_TLICON_HERMITE_AUTO_P");
	break;
    case 2:
	mpCBitmapKeyType->SetBitmapStr(0, "wxART_TLICON_HERMITE_EASE_N", "wxART_TLICON_HERMITE_EASE_P");
	break;
    case 3:
	mpCBitmapKeyType->SetBitmapStr(0, "wxART_TLICON_STEP_N", "wxART_TLICON_STEP_P");
	break;
    case 4:
	mpCBitmapKeyType->SetBitmapStr(0, "wxART_TLICON_AUTO"); break;
    }
}
