// -*- c++ -*-
// (setq c-basic-offset 4)
// "clsEnsembleCtrl.cpp"

#ifndef _ENSEMBLE_CTRL_H
#define _ENSEMBLE_CTRL_H

#include "../COMMON/clsGetPC.h"
#include "../CONFITEM/clsConfItem.h"
#include "../CONFITEM/clsConfListContainer.h"

class FBO_cls;

class EnsembleCtrl_cls : public ConfListContainer_cls, public GetPC_cls {
 public:
    EnsembleCtrl_cls();
    ~EnsembleCtrl_cls();

    void SetToDefaultParam();

    ConfItemBOOL_cls mCbUseEnsemble;
    ConfItemINT_cls mCEnsembleSambleNum;
    ConfItemBOOL_cls mCbUseGammaForEnsemble;
    //ConfItemBOOL_cls mCbTransparentShadowForEnsemble;v

    int mEnsembleStep;
    FBO_cls *mpCFBOBuffer;

    void ClearFBOBuffer();
    void SetEnsembleStep(int ensembleStep);
    int GetEnsembleSampleNum();

    void PrepareBuffer(FBO_cls *pCFBOSrc);
    void DrawOnBuffer(FBO_cls *pCFBOSrc, int sampleNum);
    void DrawFromBuffer(FBO_cls *pCFBOTgt);
};

#endif
