// -*- c++ -*-
// (setq c-basic-offset 4)
// "clsMotionBlurCtrl.cpp"

#ifndef _MOTION_BLUR_CTRL_H
#define _MOTION_BLUR_CTRL_H

#include "../COMMON/clsGetPC.h"
#include "../CONFITEM/clsConfItem.h"
#include "../CONFITEM/clsConfListContainer.h"

class FBO_cls;

class MotionBlurCtrl_cls : public ConfListContainer_cls, public GetPC_cls {
 public:
    MotionBlurCtrl_cls();
    ~MotionBlurCtrl_cls();

    void SetToDefaultParam();
    
    ConfItemBOOL_cls mCbUseMotionBlur;
    ConfItemBOOL_cls mCbUseGammaForBlur;
    ConfItemINT_cls mCBlurQuality;
    ConfItemFLOAT_cls mCBlurLength;

    int mBlurStep;
    FBO_cls *mpCFBOBuffer;

    void ClearFBOBuffer();
    void SetBlurStep(int blurStep);
    int GetBlurSampleNum();
    void PrepareBuffer(FBO_cls *pCFBOSrc);
    void DrawOnBuffer(FBO_cls *pCFBOSrc, int sampleNum);
    void DrawFromBuffer(FBO_cls *pCFBOTgt);
};

#endif
