// -*- c++ -*-/
// "clsPlayCtrlGUI.h"

#include "clsPlayCtrl.h"
#include "clsTimeCtrl.h"

#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"

#include "../SCENEOBJ/clsSceneObjCtrl.h"
#include "../UNDO/clsUndoManager.h"

#include "../WIDGETCTRL/clsBitmapPanel.h"
#include "../WIDGETCTRL/WX/myArtProv.h"
#include "../WIDGETCTRL/WX/clsColorProvider.h"
#include "../WIDGETCTRL/WX/clsFontProvider.h"
#include "../WIDGETCTRL/WX/clsStringProvider.h"
#include "../WIDGETCTRL/INPUTITEM/clsVCenter.h"

#include "../../clsMain.h"

#include <wx/tglbtn.h>
#include <wx/artprov.h>
#include <wx/bmpcbox.h>

#define CLS PlayCtrl_cls

BEGIN_EVENT_TABLE(CLS, wxPanel)
EVT_BUTTON(btnCtrlStepBCK2,  CLS::OnButtonStepBCK2)
EVT_BUTTON(btnCtrlPlayBCK1,  CLS::OnButtonPlayBCK1)
EVT_BUTTON(btnCtrlStepBCK1,  CLS::OnButtonStepBCK1)
EVT_BUTTON(btnCtrlStepFWD1,  CLS::OnButtonStepFWD1)
EVT_BUTTON(btnCtrlPlayFWD1,  CLS::OnButtonPlayFWD1)
EVT_BUTTON(btnCtrlStepFWD2,  CLS::OnButtonStepFWD2)
EVT_BUTTON(btnCtrlDefaultKey, CLS::OnButtonDefaultKey)
EVT_BUTTON(btnRepeat,    CLS::OnToggleRepeat)
EVT_TOGGLEBUTTON(btnAutoAbort, CLS::OnToggleAutoAbort)
EVT_SPINCTRL(spnAnimStep,   CLS::OnSpinAnimStep)
EVT_SPINCTRL(spnAnimInterp, CLS::OnSpinAnimInterp)
EVT_COMBOBOX(cmbInterpType, CLS::OnCmbInterpType)
EVT_COMBOBOX(cmbDefaultKey, CLS::OnCmbDefaultKey)
EVT_KEY_DOWN(CLS::OnKeyDown)
END_EVENT_TABLE()

CLS::
PlayCtrl_cls(wxWindow *pCParent):
wxPanel(pCParent)
{
    SetBackgroundColour(wxColour(216, 216, 216));
    SetFont(FontProvider_cls::GetFont(1));

    //i
    wxBoxSizer *pBoxSizerButtons2 = new wxBoxSizer(wxHORIZONTAL);

    //SetStaticText(pBoxSizerButtons2, _("Set Key"));
    wxSize CSizeC = wxSize(40, FontProvider_cls::GetButtonHeight());

    mpCButtonStepBCK2 = new wxBitmapButton
	(this, btnCtrlStepBCK2, ARTWX("wxART_STARTPOINT"), wxDP, CSizeC);
    mpCButtonPlayBCK1 = new wxBitmapButton
	(this, btnCtrlPlayBCK1, ARTWX("wxART_PLAY_BACK"), wxDP, CSizeC);
    mpCButtonStepBCK1 =	new wxBitmapButton
	(this, btnCtrlStepBCK1, ARTWX("wxART_STEP_BACKWARD"), wxDP, CSizeC);
    mpCButtonStepFWD1 =	new wxBitmapButton
	(this, btnCtrlStepFWD1, ARTWX("wxART_STEP_FORWARD"), wxDP, CSizeC);
    mpCButtonPlayFWD1 =	new wxBitmapButton
	(this, btnCtrlPlayFWD1, ARTWX("wxART_PLAY"), wxDP, CSizeC);
    mpCButtonStepFWD2 =	new wxBitmapButton
	(this, btnCtrlStepFWD2, ARTWX("wxART_ENDPOINT"), wxDP, CSizeC);

    /*
    mpCButtonSetKeyPos   ->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    mpCButtonSetKeyPosRot->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    mpCButtonSetKeyAnc   ->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    */

    int spinWidth = 100;
#ifdef WIN32
    spinWidth = 50;
#endif

    wxSize CSizeSpin = wxSize(spinWidth, FontProvider_cls::GetButtonHeight());
    mpCSpinAnimStep = 
	new wxSpinCtrl(this, spnAnimStep, wxES, wxDP, CSizeSpin);
    mpCSpinAnimStep->SetRange(1, 99);

    mpCSpinAnimInterp = 
	new wxSpinCtrl(this, spnAnimInterp, wxES, wxDP, CSizeSpin);
    mpCSpinAnimInterp->SetRange(1, 99);

    VCenter_cls *pCDefaultKeyIcon = SetDefaultKey(this);

    /*
    int defaultKey = GetPCTimeCtrl()->mCDefaultKey.GetBodyINT();
    wxString *AstrKey = GetPCStringProvider()->GetAstr("DefaultKey");
    mpCDefaultKey = 
	new wxBitmapComboBox(this, cmbDefaultKey, AstrKey[defaultKey], wxDPS, 5, AstrKey);
    mpCDefaultKey->SetItemBitmap(0, ART("wxART_TLICON_LINEAR_N"));
    mpCDefaultKey->SetItemBitmap(1, ART("wxART_TLICON_HERMITE_AUTO_N"));
    mpCDefaultKey->SetItemBitmap(2, ART("wxART_TLICON_HERMITE_EASE_N"));
    mpCDefaultKey->SetItemBitmap(3, ART("wxART_TLICON_STEP_N"));
    mpCDefaultKey->SetItemBitmap(4, ART("wxART_TLICON_AUTO"));
    
    mpCBitmapKeyType = 
	new BitmapPanel_cls(this, btnCtrlDefaultKey, wxDP, wxSize(15, 15));
    mpCBitmapKeyType->SetBorder(3, 3);
    mpCBitmapKeyType->AddBitmapStr("wxART_TLICON_LINEAR_N", "wxART_TLICON_LINEAR_P");
    mpCBitmapKeyType->mbButton = TRUE;
    VCenter_cls *pCDefaultKeyIcon = new VCenter_cls(mpCBitmapKeyType);
    */
    
    int interpType = GetPCTimeCtrl()->mCInterpolateComposite.GetBodyINT();
    wxString strComp[2] = {"Data", "Image"};
    mpCInterpType = 
	new wxComboBox(this, cmbInterpType, strComp[interpType], wxDPS, 2, strComp);
    
    mpCButtonRepeat    = new wxBitmapButton
	(this, btnRepeat,
	 wxArtProvider::GetBitmap(wxT("wxART_REPEAT"), wxART_TOOLBAR),
	 wxDP, wxSize(60, FontProvider_cls::GetButtonHeight()));
	 
    int flags = wxEXPAND/* | wxALIGN_CENTER_VERTICAL*/;
    
/*
    pBoxSizerButtons2->Add(mpCButtonSetKeyAnc,     0, flags);
    pBoxSizerButtons2->Add(mpCButtonSetKeyPos,     0, flags);
    pBoxSizerButtons2->Add(mpCButtonSetKeyPosRot,  0, flags);
*/
    pBoxSizerButtons2->AddStretchSpacer(1);
    pBoxSizerButtons2->Add(mpCButtonRepeat,     0, flags);
    pBoxSizerButtons2->Add(10, -1);
    pBoxSizerButtons2->Add(mpCButtonStepBCK2,   0, flags);
    pBoxSizerButtons2->Add(mpCButtonPlayBCK1,   0, flags);
    pBoxSizerButtons2->Add(mpCButtonStepBCK1,   0, flags);
    pBoxSizerButtons2->Add(mpCButtonStepFWD1,   0, flags);
    pBoxSizerButtons2->Add(mpCButtonPlayFWD1,   0, flags);
    pBoxSizerButtons2->Add(mpCButtonStepFWD2,   0, flags);
    pBoxSizerButtons2->Add(10, -1);

    pBoxSizerButtons2->Add(pCDefaultKeyIcon,     0, flags);
    pBoxSizerButtons2->Add(mpCDefaultKey,     0, flags);
    pBoxSizerButtons2->Add(10, -1);
    
    SetStaticText(pBoxSizerButtons2, _("Stepping"));
    pBoxSizerButtons2->Add(mpCSpinAnimStep,     0, flags);

    SetStaticText(pBoxSizerButtons2, _("Interval"));
    pBoxSizerButtons2->Add(mpCSpinAnimInterp,   0, flags);
    pBoxSizerButtons2->Add(10, -1);
    pBoxSizerButtons2->Add(mpCInterpType, 0, flags);
    pBoxSizerButtons2->Add(10, -1);

    /*
    SetStaticText(pBoxSizerButtons2, _("Prefetch"));
    pBoxSizerButtons2->Add(mpCSpinPrefetch  ,   0, flags);
    */

    /*
    mpCAutoAbort    =
	new wxToggleButton(this, btnAutoAbort, _("Auto Abort"),
			   wxDP, wxSize(120, FontProvider_cls::GetButtonHeight()));
    mpCAutoAbort->SetToolTip(_("Abort drawing process if it takes too much time.")); 
    */
    
    pBoxSizerButtons2->AddStretchSpacer(1);
    //pBoxSizerButtons2->Add(mpCAutoAbort, 0, flags);
        
    this->SetSizer(pBoxSizerButtons2);
}

void CLS::
SetStaticText(wxBoxSizer *pBoxSizerSrc, wxString strTag){
    wxStaticText *pCTag = new wxStaticText(this, wxID_ANY, strTag);
    VCenter_cls *pCVCenter = new VCenter_cls(pCTag);
    pBoxSizerSrc->Add(pCVCenter, 0, wxEXPAND);
}

void CLS::
OnButtonSetKeyPos(wxComEvt &event){
    //SendMenuEventToTop(this, menuSetKeyPos);
}

void CLS::
OnButtonSetKeyPosRot(wxComEvt &event){
    //SendMenuEventToTop(this, menuSetKeyPosRot);
}

void CLS::
OnButtonSetKeyAnc(wxComEvt &event){
    //SendMenuEventToTop(this, menuSetKeyAnc);
}

void CLS::
OnButtonStepBCK2(wxComEvt& event){
    GetPCTimeCtrl()->SetCurrentFrameToEndCommand(-1);
}

void CLS::
OnButtonPlayBCK1(wxComEvt& event){
    GetPCTimeCtrl()->StartPlayCommand(-1);
    GetPCMain()->UpdatePanels("TIMELINE");
}

void CLS::
OnButtonStepBCK1(wxComEvt& event){
    GetPCTimeCtrl()->SetCurrentFrameToNextCommand(-1);
}

void CLS::
OnButtonStepFWD1(wxComEvt& event){
    GetPCTimeCtrl()->SetCurrentFrameToNextCommand(+1);
}

void CLS::
OnButtonPlayFWD1(wxComEvt& event){
    GetPCTimeCtrl()->StartPlayCommand(+1);
    GetPCMain()->UpdatePanels("TIMELINE");
}

void CLS::
OnButtonStepFWD2(wxComEvt& event){
    GetPCTimeCtrl()->SetCurrentFrameToEndCommand(+1);
}

void CLS::
OnButtonDefaultKey(wxComEvt& event){
    ProcButtonDefaultKey();
}

void CLS::
OnToggleRepeat(wxComEvt& event){
    bool oldValue = GetPCTimeCtrl()->mCbRepeat.GetBodyBOOL();
    bool newValue = ! oldValue;
    if (newValue != oldValue) 
	GetPCTimeCtrl()->SetRepeatCommand(newValue);
    UpdateButtonColor();
}

void CLS::
OnToggleAutoAbort(wxComEvt& event){
    //GLDrawData_cls::msbUseAbortion = mpCAutoAbort->GetValue();
}

void CLS::
OnSpinAnimStep(wxSpinEvent& event){
    long long newValue = mpCSpinAnimStep->GetValue();
    
    wxString strFrom, strTo;
    GetPCTimeCtrl()->mCSubFrameStepping.SerializeSingleItem(strFrom);
    GetPCTimeCtrl()->mCSubFrameStepping.SetBodyFromData(newValue);
    GetPCTimeCtrl()->mCSubFrameStepping.SerializeSingleItem(strTo);

    if (strFrom.IsSameAs(strTo) == FALSE){
	GetPCUndo()->PushCommandPair(strFrom, strTo);
	GetPCUndo()->Skip(); //łɕύXĂ̂SkipB
	//mpCTimeLink->SetAnimInterpCommand(newValue, oldValue);
	GetPCMain()->UpdatePanels("CONSOLE::TIMELINE");
    }
}

void CLS::
OnSpinAnimInterp(wxSpinEvent& event){
    long long newValue = mpCSpinAnimInterp->GetValue();
    
    wxString strFrom, strTo;
    GetPCTimeCtrl()->mCSubFrameMax.SerializeSingleItem(strFrom);
    GetPCTimeCtrl()->mCSubFrameMax.SetBodyFromData(newValue);
    GetPCTimeCtrl()->mCSubFrameMax.SerializeSingleItem(strTo);
    
    if (strFrom.IsSameAs(strTo) == FALSE){
	GetPCUndo()->PushCommandPair(strFrom, strTo);
	GetPCUndo()->Skip(); //łɕύXĂ̂SkipB
	GetPCMain()->UpdatePanels("CONSOLE::TIMELINE");
    }
}

void CLS::
OnCmbInterpType(wxComEvt& event){
    wxString strNewType = event.GetString();
    long long newValue = 0;
    if (strNewType.IsSameAs("Image")) newValue = 1;
    
    wxString strFrom, strTo;
    GetPCTimeCtrl()->mCInterpolateComposite.SerializeSingleItem(strFrom);
    GetPCTimeCtrl()->mCInterpolateComposite.SetBodyFromData(newValue);
    GetPCTimeCtrl()->mCInterpolateComposite.SerializeSingleItem(strTo);
    if (strFrom.IsSameAs(strTo) == FALSE){
	GetPCUndo()->PushCommandPair(strFrom, strTo);
	GetPCUndo()->Skip(); //łɕύXĂ̂SkipB
	GetPCMain()->UpdatePanels("CONSOLE::TIMELINE");
    }
}

void CLS::
OnCmbDefaultKey(wxComEvt& event){
    ProcDefaultKey(event);
}

void CLS::
OnKeyDown(wxKeyEvent& event){
    event.SetId(GetParent()->GetId());
    GetParent()->GetEventHandler()->AddPendingEvent(event);
}

void CLS::
UpdateDisplayedValues(){
    mpCSpinAnimStep->SetValue(GetPCTimeCtrl()->mCSubFrameStepping.GetBodyINT());
    mpCSpinAnimInterp->SetValue(GetPCTimeCtrl()->mCSubFrameMax.GetBodyINT());
    int interpType = GetPCTimeCtrl()->mCInterpolateComposite.GetBodyINT();
    wxString strComp[2] = {"Data", "Image"};
    mpCInterpType->SetValue(strComp[interpType]);

    UpdateDefaultKeyIcon();
}

void CLS::
UpdateButtonColor(){
    if (GetPCTimeCtrl()->mPlayDirection == 1)
	ColorProvider_cls::SetBGColor(mpCButtonPlayFWD1, "Active");
    else
	ColorProvider_cls::SetBGColor(mpCButtonPlayFWD1, "Null");
    if (GetPCTimeCtrl()->mPlayDirection == -1)
	ColorProvider_cls::SetBGColor(mpCButtonPlayBCK1, "Active");
    else
	ColorProvider_cls::SetBGColor(mpCButtonPlayBCK1, "Null");
    /*
    if (mpCTimeLink->mbPlaying == TRUE){
	if (mpCTimeLink->mPlayDirection == +1){
	    mpCButtonPlayFWD1->SetBackgroundColour(wxT("LIGHT BLUE"));
	    mpCButtonPlayBCK1->SetBackgroundColour(wxNullColour); 
	}
	else if (mpCTimeLink->mPlayDirection == -1){
	    mpCButtonPlayBCK1->SetBackgroundColour(wxT("LIGHT BLUE"));
	    mpCButtonPlayFWD1->SetBackgroundColour(wxNullColour); 
	}
    }
    else{
	mpCButtonPlayFWD1->SetBackgroundColour(wxNullColour);
	mpCButtonPlayBCK1->SetBackgroundColour(wxNullColour);
    }
    */
    
    if (GetPCTimeCtrl()->mCbRepeat.GetBodyBOOL() == TRUE)
	ColorProvider_cls::SetBGColor(mpCButtonRepeat, "Active");
    else
	ColorProvider_cls::SetBGColor(mpCButtonRepeat, "Null");
}

void CLS::
UpdatePanels(){
    UpdateDisplayedValues();
    UpdateButtonColor();
}

