// -*- c++ -*-
// "clsPlayCtrlGUI.cpp"

#ifndef _PLAY_CTRL_GUI_H
#define _PLAY_CTRL_GUI_H

#include "clsDefaultKey.h"

#include "../COMMON/clsGetPC.h"
#include "../WIDGETCTRL/clsWidgetCommon.h"

#include "../COMMON/CommonDefinitionsWX.h"

#include <wx/spinctrl.h>

class BitmapPanel_cls;
class TimeCtrl_cls;
class wxCheckBox;
class wxButton;
class wxBitmapComboBox;
class wxBitmapButton;
class wxToggleButton; 

class PlayCtrl_cls : public wxPanel, public DefaultKey_cls, public WidgetCommon_cls, public GetPC_cls {
 public:
    PlayCtrl_cls(wxWindow *pCParent);
    //~PlayCtrlGUI_cls();

    wxBitmapButton   *mpCButtonStepBCK2;
    wxBitmapButton   *mpCButtonPlayBCK1;
    wxBitmapButton   *mpCButtonStepBCK1;
    wxBitmapButton   *mpCButtonStepFWD1;
    wxBitmapButton   *mpCButtonPlayFWD1;
    wxBitmapButton   *mpCButtonStepFWD2;
    wxBitmapButton   *mpCButtonRepeat;
    wxBitmapButton   *mpCButtonAbort;

    wxComboBox       *mpCInterpType;
    //wxBitmapComboBox *mpCDefaultKey;
    //BitmapPanel_cls  *mpCBitmapKeyType;

    wxSpinCtrl   *mpCSpinAnimStep;
    wxSpinCtrl   *mpCSpinAnimInterp;
    
    void SetStaticText(wxBoxSizer *pBoxSizerSrc, wxString strTag);
    void CheckAbortClicked(const wxPoint& mousePos);

    void OnButtonSetKeyPos   (wxComEvt &event);
    void OnButtonSetKeyPosRot(wxComEvt &event);
    void OnButtonSetKeyAnc   (wxComEvt &event);
    void OnButtonStepBCK2    (wxComEvt &event);
    void OnButtonPlayBCK1    (wxComEvt &event);
    void OnButtonStepBCK1    (wxComEvt &event);
    void OnButtonStepFWD1    (wxComEvt &event);
    void OnButtonPlayFWD1    (wxComEvt &event);
    void OnButtonStepFWD2    (wxComEvt &event);
    void OnButtonAbort       (wxComEvt &event);
    void OnButtonDefaultKey  (wxComEvt &event);
    void OnToggleRepeat      (wxComEvt &event);
    void OnToggleAutoAbort   (wxComEvt &event);
    void OnSpinAnimStep  (wxSpinEvent &event);
    void OnSpinAnimInterp(wxSpinEvent &event);
    void OnCmbInterpType     (wxComEvt &event);
    void OnCmbDefaultKey     (wxComEvt &event); 
    void OnKeyDown(wxKeyEvent& event);

    void UpdateDisplayedValues();
    void UpdateButtonColor();
    void UpdatePanels();
    
 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

#endif
