// -*- c++ -*-
// (setq c-basic-offset 4)
// "clsTimeCtrl.h"

#ifndef _TIME_CTRL_H
#define _TIME_CTRL_H

#include "clsMotionBlurCtrl.h"

#include "../COMMON/CommonDefinitionsForH.h"
#include "../COMMON/clsExpectTime.h"
#include "../COMMON/clsGetPC.h"
#include "../CONFITEM/clsConfItem.h"
#include "../CONFITEM/clsConfListContainer.h"

#include "../FILEIO/clsParser.h"

#include "../WIDGETCTRL/clsWidgetCommon.h"

class TimeCtrl_cls : public WidgetCommon_cls, public Parser_cls, public ConfListContainer_cls, public GetPC_cls, public ExpectTime_cls {
 public:
    TimeCtrl_cls();
    ~TimeCtrl_cls();

    static bool msbForceAbort;

    void SetToDefaultParam();
    int mPlayDirection;
    bool mbRecordRender;
    bool mbRecordSnap;
    bool mbExport;
    // ۑOɐɐił܂̂}
    bool mbRecordConfirmed, mbExportConfirmed; 
    
    // 摜p̈ꎞϐێ
    // @1̕ϐgȂ̂ŁARemapf[^CompositłȂ
    double mInterpFactorForComposit;

    // mCFrameCurrent :: XibvVbg̃CfbNX
    // mCSubFrame :: ݂̕Ԃ̃t[
    // Step
    ConfItemINT_cls mCFrameMax; // Ō̃t[܂
    ConfItemINT_cls mCFrameCurrent;
    ConfItemINT_cls mCWAMin, mCWAMax; // Ō̃t[܂
    ConfItemINT_cls mCWASubMin, mCWASubMax; // Ō̃Tut[܂܂Ȃ
    
    ConfItemINT_cls mCSubFrameStepping;
    ConfItemINT_cls mCSubFrameMax;
    ConfItemINT_cls mCSubFrameCurrent;

    ConfItemUINT_cls mCInterpolateComposite;
    ConfItemUINT_cls mCDefaultKey;

    ConfItemBOOL_cls mCbRepeat;

    wxString GetStrSelf();
    //wxStopWatch mCStopWatch;

    wxString GetStrRecordInfo(double percentage);
    double GetOutputPercent();

    int GetStep(int frame, int subFrame);
    int GetCurrentStep();
    int GetImageCompositeNum();

    //int GetEnsembleSampleNum();
    void GetDefaultKeyTypeAndEase(int *pKeyType, double *pEaseFactor);
    double GetDefaultResolution();
    double GetQuantized(double normed, int type);
    double GetQuantizedForColor(double normed, int type);
    double GetFrameFromNT(double normed, int &frame, int &subframe);
    double GetNormalizedValue(int frame, int subFrame, int blurStep = 0);
    double GetCurrentNT(bool bForData = FALSE);
    double GetNextNT(bool bForData = FALSE);
    double GetDNT(); // 1 Scene frame NT
    void AdjustFrameForComposer(int *pFrame1, int *pFrame2, 
				double *pInterpFactor, int composit,
				bool bForNext = FALSE);
    void StoreInterpFactorForComposit(double interpFactor);
    
    double GetNormalizedWAMin();
    double GetNormalizedWAMax();
    double GetNormalizedWARegion();
    
    void GetNextTimeInfo(int &frame, int &subFrame, int direction);
    bool ProcPlay();
    void SendUpdate();

    void PrepareBlurBuffer(FBO_cls *pCFBOSrc);
    void SetBlurStep(int blurStep);
    void SetWAMinCommand(int min);
    void SetWAMaxCommand(int max);
    void SetWARegionCommand(int region, int regionL, int regionR);
    void SetCurrentFrameToEndCommand(int direction);
    void SetCurrentFrameToNextCommand(int direction);
    void SetCurrentFrameCommand(int currentFrame);
    void SetCurrentSubFrameCommand(int currentSubFrame);
    void SetCurrentNTCommand(double newNT);
    void SetFrameMaxCommand(int frameMax);
    void SetRepeatCommand(bool bRepeat);

    void AnimCommand(bool bSnap = FALSE);
    void ExportCommand();
    void StartPlayCommand(int direction);
    void StopPlayCommand();

    bool ProcSetWAMin(wxString strFirstItem);
    bool ProcSetWAMax(wxString strFirstItem);
    bool ProcSetFrameMax(wxString strFirstItem);
    bool ProcSetFrameCurrent(wxString strFirstItem);
    bool ProcSetSubFrameCurrent(wxString strFirstItem);
    bool ProcSetRepeat(wxString strFirstItem);

    bool ReadStrLine(std::wistream &istream, wxString strFirstItem, wxString strLine);
};

#endif
