// (setq c-basic-offset 4)
// "clsTimeline.cpp"

#ifndef _TIMELINE_H_
#define _TIMELINE_H_

#include "clsAACtrl.h"

#include "../CONFITEM/clsConfListContainer.h"
#include "../WIDGETCTRL/EX/wxPanelEX.h"

#include "../COMMON/CommonDefinitionsWX.h"

#include <wx/dcmemory.h>

class AtoSTextCtrl_cls;
class BitmapPanel_cls;
class PlayCtrl_cls;
class TextButton_cls;
class TimelineTics_cls;
class TimelineAA_cls;
class TimelineWA_cls;
class TimelineParam_cls;

#define _TL_SASH_MIN 180

class Timeline_cls : public wxPanelEX, public ConfListContainer_cls, public AACtrl_cls {
 public:
    Timeline_cls(wxWindow *pCParent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDP, const wxSize &size=wxDS, long style=wxTAB_TRAVERSAL);

    wxBitmap mCBitmapBuffer;
    wxMemoryDC mCMemoryDCWorkSpace;

    wxBoxSizer *mpBoxSizerTics, *mpBoxSizerAA, *mpBoxSizerWA;
    wxSizerItem *mpCTicsSpacer, *mpCAASpacer, *mpCWASpacer;

    BitmapPanel_cls *mpCBtnKilroy, *mpCBtnTimeDepend, *mpCBtnSelectOnly;
    TimelineTics_cls *mpCTimelineTics;
    wxStaticText *mpCTicsMode;
    TimelineAA_cls *mpCTimelineAA;
    TimelineWA_cls *mpCTimelineWA;
    TimelineParam_cls *mpCTimelineParam;
    PlayCtrl_cls *mpCPlayCtrl;
    AtoSTextCtrl_cls *mpCTextCtrlFrame, *mpCTextCtrlSubFrame;

    TextButton_cls *mpCTextMenuView, *mpCTextMenuSelect, *mpCTextMenuChannel;
    TextButton_cls *mpCTextMenuTimeline, *mpCTextMenuKey;
        
    ConfItemINT_cls mCSashX;
    ConfItemINT_cls mCFontSize;
    ConfItemBOOL_cls mCbKilroy;
    ConfItemBOOL_cls mCbTimeDepend;
    ConfItemBOOL_cls mCbSelectOnly;
    
    int mPrevSash;
    //int mRegionLforDrag, mRegionRforDrag;
    
    void SetToDefaultParam();
    void SetRegion(int mType);
    int GetLineHeight();
    void Zoom(int direction);
    
    void ProcAfterMath(const wxString& strCommand, const wxString& strItem);
    //void CheckAbortClicked(const wxPoint& mousePos);

    void OnMenuView       (wxComEvt& event);
    void OnMenuSelect     (wxComEvt& event);
    void OnMenuTimeline   (wxComEvt& event);
    void OnDeselect       (wxComEvt& event);
    void OnMenuChannel    (wxComEvt& event);
    void OnMenuKey        (wxComEvt& event);
    void OnMenuExtrapolate(wxComEvt& event);
    void OnMenuZoom       (wxComEvt& event);
    void OnMenuTimeDepend (wxComEvt& event);
    void OnMenuShy        (wxComEvt& event);
    void OnMenuTLIn       (wxComEvt& event);
    void OnMenuTLOut      (wxComEvt& event);
    void OnMenuDelete     (wxComEvt& event);
    void OnFrame          (wxComEvt& event);
    void OnSelectOnly     (wxComEvt& event);
    void OnTimeDepend     (wxComEvt& event);
    void OnKilroy         (wxComEvt& event);
    void OnTicsMode       (wxComEvt& event);
    void OnSize(wxSizeEvent& event);
    //void OnKeyDown(wxKeyEvent& event);

    void UpdateStatusButtons();
    void UpdateTextCtrls();
    void UpdatePanels(const wxString& strPanelTag, bool bUpdateBar = FALSE);

    void Serialize(wxString& strOut);
    void ReadStrLine(std::wistream &istream, wxString strFirstItem, wxString strLine);

private:
    DECLARE_EVENT_TABLE()
};

#endif
