// (setq c-basic-offset 4)
// "clsTimelineAA.cpp"

#ifndef _TIMELINE_BASE_H_
#define _TIMELINE_BASE_H_

#include "../COMMON/clsGetPC.h"
#include "../COMMON/CommonDefinitionsWX.h"

#include <wx/wx.h>
#include <wx/dcbuffer.h>

class Timeline_cls;

class TLPanelGeom_cls {
public:
    TLPanelGeom_cls();

    int mBorderXL, mBorderXR;
    int mPanelWidth, mPanelHeight;
    float mNormalizedWAMin, mNormalizedWAMax, mNormalizedWARegion;
    double mTLRegionMin, mTLRegionMax;

    bool IsWithinRange(int devX, int margin);
    void SetTLRegion(double regionMin, double regionMax);
    int GetDevCoordFromN(double normedValue, int offsetX/* = -1*/);
    double GetNFromDevCoord(int devX, int offsetX/* = -1*/);
};

#define _TL_SEL_MIN 1
#define _TL_SEL_MAX 2
#define _TL_SEL_REGION 3
#define _TL_SEL_SLIDER 4

class AACtrl_cls;
class GraphEditor_cls;
class wxPanelEX;

class TimelineBase_cls : public wxPanel, public TLPanelGeom_cls, public GetPC_cls {
 public: 
    TimelineBase_cls(Timeline_cls *pCParent, int type, wxSize size = wxDS);
    TimelineBase_cls(GraphEditor_cls *pCParent, int type, wxSize size = wxDS); 
    void ConstructorBase(int type);

    AACtrl_cls *mpCAALink;
    wxPanelEX *mpCParent;
    
    bool mbForColorCurve;
    int mType;
    int mSelected;
    int mMousePosCurrentX, mMousePosCurrentY;
    wxRect mRectSlider, mRectMin, mRectMax, mRectRegion;
    
    int mFrameCurrent, mSubFrameCurrent;
    int mFrameMax;
    double mTimeNormalized, mAAMinNormalized, mAAMaxNormalized;
    double mAARegionNormalized;
    
    int mFrameDragging;
    double mQuantizedTimeDragging;

    void UpdateStateForCC();
    void UpdateState();
    double GetQuantized(double posNormed, int type);
    void CalcFrameDraggingFromPosition(int offsetX);
    
    void DrawWorkingArea(wxAutoBufferedPaintDC &dc, int offsetX); 
    void DrawCurrentTime(wxDC &dc, int offsetX);

    bool SelectItem(int offsetX = -1);
    virtual void LimitDragging();
    void ProcMouseEventBase(wxMouseEvent& event, int offsetX);
    void ProcMouseReleaseBase();
    void MoveTimeSlider();
    void MoveWAMin();
    void MoveWAMax();
    void MoveWARegion();
    void MoveAAMin();
    void MoveAAMax();
    void MoveAARegion();
    
    void OnSize(wxSizeEvent& event);
private:
    DECLARE_EVENT_TABLE()
};

#endif
