// (setq c-basic-offset 4)
// "clsTimelineParam.cpp"

#ifndef _TIMELINE_PARAM_H_
#define _TIMELINE_PARAM_H_

#include "clsTimelineBase.h"
#include "../FILEIO/clsParser.h"
#include "../SCENEOBJ/clsSceneObjViewerBase.h"
#include "../WIDGETCTRL/clsWidgetCommon.h"
#include "../WIDGETCTRL/SCROLL/clsIconButtonCtrl.h"
#include "../WIDGETCTRL/SCROLL/clsScrollPanel.h"
#include "../WIDGETCTRL/WX/clsFontProvider.h"

class Attribute_cls;
class ParamGroup_cls;
class ParentObj_cls;
class SceneObj_cls;
class TextCtrlWithDrag_cls;
class Timeline_cls;

#include <list>

#define _CURSOR_NORMAL 0
#define _CURSOR_SIZE_WE 1

class TimelineParam_cls : public ScrollPanel_cls, public Parser_cls, public TimelineBase_cls, public SceneObjViewerBase_cls, public WidgetCommon_cls {
public:
    TimelineParam_cls(Timeline_cls *pCParent);
    ~TimelineParam_cls();

    Timeline_cls *mpCParent;
    wxMenu *mpCPopupMenuInsertKey;
    
    wxIcon *mpCIconOpen[_FONT_MAX], *mpCIconClose[_FONT_MAX];
    wxIcon *mpCIconUnlink[_FONT_MAX], *mpCIconLink[_FONT_MAX];
    wxIcon *mpCIconTimeP[_FONT_MAX], *mpCIconTimeN[_FONT_MAX];
    wxIcon *mpCIconLeftP[_FONT_MAX], *mpCIconRightP[_FONT_MAX];
    wxIcon *mpCIconLeftN[_FONT_MAX], *mpCIconRightN[_FONT_MAX];
    wxIcon *mpCIconCheck[_FONT_MAX], *mpCIconUncheck[_FONT_MAX];
    wxIcon *mpCIconKilroyP[_FONT_MAX], *mpCIconKilroyN[_FONT_MAX];
    wxIcon *mpCIconExprP[_FONT_MAX], *mpCIconExprN[_FONT_MAX];
    wxIcon *mpCIconExprE[_FONT_MAX];
    wxIcon *mpCIconTextP[_FONT_MAX], *mpCIconTextN[_FONT_MAX];

    std::vector < wxRect > mAIconRectOpenClose;
    std::vector < wxRect > mAIconRectLink;
    std::vector < wxRect > mAIconRectKilroy;
    std::vector < wxRect > mAIconRectExpr;
    std::vector < wxRect > mAIconRectText;
    std::vector < wxRect > mAIconRectTimeDepend;
    std::vector < wxRect > mAIconRectKeyLeft;
    std::vector < wxRect > mAIconRectKeyRight;
    std::vector < wxRect > mAIconRectKeyCheck;

    StringButtonCtrl_cls mCDisplayItem, mCDisplayValue;
    IconButtonCtrl_cls mCOpenClose, mCLink, mCTimeDepend;
    IconButtonCtrl_cls mCKeyLeft, mCKeyRight, mCKeyCheck;
    IconButtonCtrl_cls mCKilroy, mCExpr, mCTextBtn;

    std::vector < wxRect > mAValueRect;
    std::vector < std::vector < wxRect > > mAAKeyFrameRect;
    std::vector < std::vector < int > > mAAKeyFrameIndex;
    wxArrayString mAstrOpenedItem;
    wxString mstrPushedItem;

    static std::vector < wxRect > msAEmptyRect;
    static std::vector < int > msAEmptyIndex;

    //wxRect mCRectSelectRegion;
    wxBitmap mCBitmapPaintBuffer;
        
    bool mbValueInput, mbKillValueInput;
    int mQueOpenNextValueInput;
    //wxTextCtrl *mpCValueInput;
    TextCtrlWithDrag_cls *mpCValueInput;
    bool mbSashSelecting, mbKeySelecting;
    
    int mLastSelectIndex;
    int mCursorCurrent;
    void ClearDisplayedItems();
    wxRect GetTimelineRect(int Xexpand);
    int GetYPos(int line);
    double GetMouseDNT();
    
    int GetOffsetX();
    void DrawParameter(wxDC& dc, wxString strItem, 
		       ParamGroup_cls* pCParamGroup, int& itemCount);
    void DrawParamGroup(wxDC& dc, wxString strItem,
			std::vector < ParamGroup_cls* > &VpCParamGroup, 
			int& itemCount, int indentPos);
    void DrawAttribute(wxDC& dc, wxString strItem,
		       std::list < Attribute_cls* > &VpCAttribute,
		       int& itemCount, int indentPos);
    void DrawItem(wxDC& dc, ParentObj_cls* pCParent, 
		  int& itemCount, SceneObj_cls *pCActiveObject, int depth);
    void DrawFilter(wxDC& dc, int& itemCount, int depth);
    int  GetFontSize();
    wxString GetParamGroupTagLong(wxString strTag);
    void SelectIfObject(wxString strTag, bool bMultiLine);
    void SelectParameter(wxString strTag);
    bool SelectItemByMouse(bool bAdditional, bool bMultiLine);
    void SelectItemByRegion();

    void ConstructValueTextCtrl(int index);
    
    void ToggleOpenClose(wxString strItem);
    void ToggleLink(wxString strItem);
    void ToggleKilroy(wxString strItem);
    void ToggleExpr(wxString strItem);
    void PushText(wxString strItem);
    void ToggleTimeDepend(wxString strItem);
    void ToggleKey(wxString strItem);
    void MoveKey(int direction, wxString strItem);
    //void ProcRename(const wxString& strNameOld, const wxString& strNameNew);
    void ProcAfterMath(const wxString& strCommand, wxString strItem);
    //void ProcDelete(const wxString& strTag);
    void MotionSash(wxMouseEvent &event);
    //void DrawDraggingRegion(wxDC &dc);
    void SendUpdate();
    void UpdateDisplay(wxDC& dc);
    void OnPaint(wxPaintEvent& event);

    void OnLeftUp(wxMouseEvent& event);
    void OnLeftDown(wxMouseEvent& event);
    bool ProcKeyDialogCheck(int index, wxPoint CAtDown);
    void OnRightDown(wxMouseEvent& event);
    void OnMouseWheel(wxMouseEvent& event);
    void OnMouseMotion(wxMouseEvent& event);
    void OnDoubleClick(wxMouseEvent& event);
    void OnMouseLeave(wxMouseEvent& event);
    void OnKeyDown(wxKeyEvent& event);
    void OnRenamer(wxCommandEvent& event);
    void OnRenamerFocus(wxFocusEvent& event);
    void OnRenamerKey(wxKeyEvent& event);
    void OnRename(wxCommandEvent& event);
    void OnInsertKey(wxCommandEvent& event);
    void ProcessInput(wxString strItem, bool bOpenNext);
    void OnValueInput(wxCommandEvent& event);
    void OnValueInputKey(wxKeyEvent& event);
    void OnValueInputFocus(wxFocusEvent& event);

    void OnIdle(wxIdleEvent& event);
private:
    DECLARE_EVENT_TABLE()
};

#endif
