// (setq c-basic-offset 4)
// "clsTimelineTics.h"

#include "clsTimelineTics.h"

#include "clsTimeCtrl.h"
#include "clsTimeline.h"

#include "../COMMON/CommonDefinitions.h"
#include "../COMMON/CommonDefinitionsWX.h"

#define CLS TimelineTics_cls

BEGIN_EVENT_TABLE(CLS, TimelineBase_cls)
EVT_PAINT       (CLS::OnPaint)
END_EVENT_TABLE()

TimelineTics_cls::
TimelineTics_cls(Timeline_cls* pCParent) : TimelineBase_cls (pCParent, _TL_TICS, wxSize(-1, 16)) {
    mBorderXR = 18;
    mpCParent = pCParent;
    SetBackgroundStyle(wxBG_STYLE_CUSTOM);
}

void TimelineTics_cls::
UpdateDisplay(wxAutoBufferedPaintDC& dc){
    UpdateState();
    SetTLRegion(mAAMinNormalized, mAAMaxNormalized);

    switch(mpCAALink->mCTicsMode.GetBodyINT()){
    case 0:
	SetParameter(GetClientSize(), 
		     mpCAALink->mCAAMin.GetBodyINT(),
		     mpCAALink->mCAAMax.GetBodyINT());
	break;
    case 1: {
	int factor = GetPCTimeCtrl()->mCSubFrameMax.GetBodyINT();
	SetParameter(GetClientSize(), 
		     mpCAALink->mCAAMin.GetBodyINT() * factor,
		     mpCAALink->mCAAMax.GetBodyINT() * factor);
	break; }
    case 2: 
	SetParameter(GetClientSize(), mAAMinNormalized, mAAMaxNormalized);
	break; 
    }

    SetBorderX(6, 6+12);
    
    DrawTics(dc, TRUE);

    if (mbForColorCurve == FALSE) DrawCurrentTime(dc, 0);
}

void TimelineTics_cls::
OnPaint(wxPaintEvent& event){
    wxAutoBufferedPaintDC dc(this);
    UpdateDisplay(dc);
}
