// -*- c -*- 
// "clsUndoManager.cpp"

#ifndef _UNDO_MANAGER_H
#define _UNDO_MANAGER_H

#include <wx/wx.h>
#include <vector>

#include "../COMMON/clsGetPC.h"
#include "../FILEIO/clsParser.h"

#include "../COMMON/CommonDefinitionsWX.h"


class UndoManager_cls : public Parser_cls, public GetPC_cls {
 public:
    UndoManager_cls();

    std::vector < wxString > mVCRedoCommand;
    std::vector < wxString > mVCUndoCommand;

    int mCurrent, mBlockDepth;
    wxString GetStrRedoAll(int lineNum = 999999);
    wxString GetStrUndoAll(int lineNum = 999999);

    void Clear();
    void PushCommandPair(wxString strUndo, wxString strRedo);
    void PushCommandPairAndDo(wxString strUndo, wxString strRedo);
    void PopCommandPair();
    void Execute(int direction = 1);
    void Undo();
    void Redo();
    void Skip();

    void OpenBlock(wxString strTag = wxES);
    void CloseBlock(wxString strTag = wxES);
};

#endif
