// -*- c -*- 
// "clsFileDialogEX.h"

#include "clsFileDialogEX.h"

#include "../../GLCANVAS/clsGLCanvas.h"

#include "../../COMMON/CommonDefinitions.h"

#include <wx/filename.h>

wxFileDialogEX*   GpCFileDialog = NULL;

wxFileDialogEX::
wxFileDialogEX(/*wxWindow* parent*/){
    //mpCDialog = new wxFileDialog(parent, wxT("FileDialogEX"));
    mpCDialog = NULL;
    mbLock = FALSE;
};

wxFileDialogEX::
~wxFileDialogEX(){
    if (mpCDialog != NULL)
	mpCDialog->Destroy();
}

void wxFileDialogEX::
MakeDialog(wxWindow *pCParent, int style){
    if (mpCDialog != NULL)
	mpCDialog->Destroy();
    
    mpCDialog = new wxFileDialog(pCParent, wxT("FileDialogEX"), wxES, wxES, wxES, style);
    //mpCDialog->SetWindowStyle(wxFD_DEFAULT_STYLE);
}

void wxFileDialogEX::
DestroyDialog(){
    mpCDialog->Destroy();
    mpCDialog = NULL;
}

void wxFileDialogEX::
SetMessage(wxString strMes){
    mpCDialog->SetMessage(strMes);
}

void wxFileDialogEX::
SetInitPathFull(wxString strPath){
    if (strPath == wxT("None")) return;
    wxFileName CFile(strPath);
    mpCDialog->SetDirectory(CFile.GetPath());
    mpCDialog->SetFilename(CFile.GetFullName());
}

void wxFileDialogEX::
SetInitPath(wxString strDir, wxString strFileName){
    if (strDir != wxT(""))
	mpCDialog->SetDirectory(strDir);
    if (strFileName != wxT(""))
	mpCDialog->SetFilename(strFileName);
}

void wxFileDialogEX::
SetWildcard(wxString strWildCard){
    if (strWildCard.IsSameAs(wxT("IMAGE")) ||
	strWildCard.IsSameAs(wxT("IMAGE|EXR"))){
	wxString strAll = wxT("*.png, *.jpg, *.tiff, *.tga, *.bmp");
	wxString strWildAll = wxT(")|*.png;*.PNG;*.jpg;*.JPG;*.jpeg;*.JPEG;*.tif;*.TIF;*.tga;*.TGA;*.bmp;*.BMP;");
	if (strWildCard.IsSameAs(wxT("IMAGE|EXR"))){
	    strAll << wxT(", *.exr");
	    strWildAll << wxT("*.exr;*.EXR;");
	}
	    
	wxString strWildCardImg = wxT("image (");
	strWildCardImg << strAll;
	strWildCardImg << strWildAll;
	strWildCardImg << wxT("|png (*.png)|*.png;*.PNG|jpg (*.jpg)|*.jpg;*.JPG;*.jpeg;*.JPEG|tiff (*.tiff)|*.tif;*.TIF;*.tiff;*.FIFF|tga (*.tga)|*.tga;*.TGA|bmp (*.bmp)|*.bmp:*.BMP");
	if (strWildCard.IsSameAs(wxT("IMAGE|EXR")))
	    strWildCardImg << wxT("|exr (*.exr)|*.exr;*.EXR");
	strWildCardImg << wxT("|all|*");
	mpCDialog->SetWildcard(strWildCardImg);
	return;
    }
    mpCDialog->SetWildcard(strWildCard);
}

int wxFileDialogEX::
ShowModal(){
    if (mbLock == TRUE) return FALSE;
    mbLock = TRUE;
    int retVal = mpCDialog->ShowModal();
    GLCanvas_cls::msbLockDragging = TRUE;
    mbLock = FALSE;
    //SetWildcard(wxT("*"));
    //
    return retVal;
}

void wxFileDialogEX::
UnLock(){
    mbLock = FALSE;
}

/*
void wxFileDialogEX::
SetStyle(long style){
    mpCDialog->SetWindowStyle(style);
}
*/

wxString wxFileDialogEX::
GetDirectory(){
    return mpCDialog->GetDirectory();
}

wxString wxFileDialogEX::
GetFileName(){
    return mpCDialog->GetFilename();
}

wxString wxFileDialogEX::
GetPath(){
    return mpCDialog->GetPath();
}


