// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsPanelBar.cpp"

#include "clsPanelBar.h"

#include "../../WIDGETCTRL/clsBitmapPanel.h"
#include "../../WIDGETCTRL/WX/clsColorProvider.h"
#include "../../WIDGETCTRL/WX/myArtProv.h"

#include <wx/bmpcbox.h>

#include "../../COMMON/CommonDefinitions.h"

#include "../../../wxWidgetEnum.h"

#define CLS PanelBar_cls

CLS::
PanelBar_cls (wxWindow *parent, wxWindowID id, const wxPoint &pos, const wxSize &size, long style) : wxPanelEX(parent, id, pos, size, style) {
    ColorProvider_cls::SetBGColor(this, "BarPanel");
    mbShowItem = TRUE;
}

void CLS::
ConstructBarItemHideShow(wxBoxSizer *pBoxSizerBar){
    
    wxSize CSize = wxSize(20, 20);

    BitmapPanel_cls *pCBtnHide = new BitmapPanel_cls(this, btnHidePanel, wxDP, CSize);
    pCBtnHide->AddBitmapStr("wxART_HIDE", "wxART_HIDE_P");
    pCBtnHide->mbButton = TRUE;
    pCBtnHide->SetBorder(1,1);

    BitmapPanel_cls *pCBtnShow = new BitmapPanel_cls(this, btnShowPanel, wxDP, CSize);
    pCBtnShow->AddBitmapStr("wxART_SHOW", "wxART_SHOW_P");
    pCBtnShow->mbButton = TRUE;
    pCBtnShow->SetBorder(1,1);
    pCBtnShow->Hide();    

    pBoxSizerBar->AddSpacer(4);
    pBoxSizerBar->Add(pCBtnHide, 0, 0);
    pBoxSizerBar->Add(pCBtnShow, 0, 0);
}

void CLS::
ConstructBarItemZoom(wxBoxSizer *pBoxSizerBar){
    
    wxSize CSize = wxSize(20, 20);

    BitmapPanel_cls *pCBtnZoomP = new BitmapPanel_cls(this, btnZoomPanelP, wxDP, CSize);
    pCBtnZoomP->AddBitmapStr("wxART_ZOOM_P", "wxART_ZOOM_P_P");
    pCBtnZoomP->mbButton = TRUE;
    pCBtnZoomP->SetBorder(1,1);

    BitmapPanel_cls *pCBtnZoomM = new BitmapPanel_cls(this, btnZoomPanelM, wxDP, CSize);
    pCBtnZoomM->AddBitmapStr("wxART_ZOOM_M", "wxART_ZOOM_M_P");
    pCBtnZoomM->mbButton = TRUE;
    pCBtnZoomM->SetBorder(1,1);

    pBoxSizerBar->Add(pCBtnZoomP, 0, 0);
    pBoxSizerBar->Add(pCBtnZoomM, 0, 0);
    pBoxSizerBar->AddSpacer(8);
}

void CLS::
ConstructBarItemDefault(wxBoxSizer *pBoxSizerBar){

    wxSize CSize = wxSize(20, 20);

    BitmapPanel_cls *pCBtnH = new BitmapPanel_cls(this, btnSeparatePanelH, wxDP, CSize);
    pCBtnH->AddBitmapStr("wxART_SPLITTER_H", "wxART_SPLITTER_H_P");
    pCBtnH->mbButton = TRUE;
    pCBtnH->SetBorder(1,1);

    BitmapPanel_cls *pCBtnV = new BitmapPanel_cls(this, btnSeparatePanelV, wxDP, CSize);
    pCBtnV->AddBitmapStr("wxART_SPLITTER_V", "wxART_SPLITTER_V_P");
    pCBtnV->mbButton = TRUE;
    pCBtnV->SetBorder(1,1);

    BitmapPanel_cls *pCBtnD = new BitmapPanel_cls(this, btnDestroyPanel, wxDP, CSize);
    pCBtnD->AddBitmapStr("wxART_SPLITTER_D", "wxART_SPLITTER_D_P");
    pCBtnD->mbButton = TRUE;
    pCBtnD->SetBorder(1,1);
    
    pBoxSizerBar->Add(pCBtnH, 0, 0);
    pBoxSizerBar->Add(pCBtnV, 0, 0);
    pBoxSizerBar->AddSpacer(8);
    pBoxSizerBar->Add(pCBtnD, 0, 0);
}

void CLS::
HideItem(){
    Freeze();
    uint num = GetSizer()->GetItemCount();
    for (uint i = 0; i < num; i++){
	wxSizerItem *pCItem = GetSizer()->GetItem(i);
	if (pCItem->IsSpacer() == TRUE){
	    if (pCItem->GetSpacer().GetWidth() == 8){
		GetSizer()->Remove(i);
		GetSizer()->InsertSpacer(i, 0);
	    }
	}
	wxWindow* pCWindow = pCItem->GetWindow();
	if (pCWindow == NULL) continue;
	int id = pCWindow->GetId();
	for (int j = 0; j < _PANEL_BAR_HIDE_ITEM_MAX; j++)
	    if (id == msAIDHide[j]) pCWindow->Hide();
	if (id == btnShowPanel) pCWindow->Show();
    }
    Layout();
    Thaw();
    mbShowItem = FALSE;
}

void CLS::
ShowItem(){
    Freeze();
    uint num = GetSizer()->GetItemCount();
    for (uint i = 0; i < num; i++){
	wxSizerItem *pCItem = GetSizer()->GetItem(i);
	if (pCItem->IsSpacer() == TRUE){
	    if (pCItem->GetSpacer().GetWidth() == 0){
		GetSizer()->Remove(i);
		GetSizer()->InsertSpacer(i, 8);
	    }
	}
	wxWindow* pCWindow = pCItem->GetWindow();
	if (pCWindow == NULL) continue;
	int id = pCWindow->GetId();
	for (int j = 0; j < _PANEL_BAR_HIDE_ITEM_MAX; j++)
	    if (id == msAIDHide[j]) pCWindow->Show();
	if (id == btnShowPanel) pCWindow->Hide();
    }
    Layout();
    Thaw();
    mbShowItem = TRUE;
}

void CLS::
ToggleItem(){
    if (mbShowItem == TRUE) HideItem();
    else ShowItem();
}

int PanelBar_cls::msAIDHide[_PANEL_BAR_HIDE_ITEM_MAX] = {
    btnZoomPanelP, btnZoomPanelM,
    btnSeparatePanelH, btnSeparatePanelV, btnDestroyPanel,
    btnHidePanel
};
