// -*- c++ -*- 
// "clsPopupMenuEX.h"
// (setq c-basic-offset 4)

#include "clsPopupMenuEX.h"

#define CLS PopupMenuEX_cls

BEGIN_EVENT_TABLE(CLS, wxMenu)
    EVT_MENU_OPEN(CLS::OnOpen)
    EVT_MENU_CLOSE(CLS::OnClose)
    EVT_MENU_HIGHLIGHT(wxID_ANY, CLS::OnShowMenuHelp)
END_EVENT_TABLE()

CLS::
PopupMenuEX_cls(wxFrame *pCParent){
    mPushed = FALSE;
    mpCParentLink = pCParent;
}

void CLS::OnOpen(wxMenuEvent &evt) {
    if (!mPushed) {
        // Clear it
        mpCParentLink->GetStatusBar()->PushStatusText(wxString(), 0);
        mPushed = true;
    }

    //evt.Skip();
}

void CLS::OnClose(wxMenuEvent &evt) {
    if (mPushed) {
        mpCParentLink->GetStatusBar()->PopStatusText(0);
        mPushed = false;
    }

    //evt.Skip();
}

void CLS::OnShowMenuHelp(wxMenuEvent &evt) {
    int id = evt.GetMenuId();
    if (id < 0)
	return;
    
    wxString strHelp = GetHelpString(id);
    if (strHelp.IsEmpty() == FALSE){
	if (mPushed) {
	    mpCParentLink->GetStatusBar()->PopStatusText(0);
	    mpCParentLink->GetStatusBar()->PushStatusText(strHelp, 0);
	} else {
	    mpCParentLink->GetStatusBar()->PushStatusText(strHelp, 0);
	    mPushed = true;
	}
    }

    //evt.Skip();
}
