// -*- c++ -*- 
// (setq c-basic-offset 4)
// "wxPanelEX.cpp"

#ifndef _WXPANEL_EX_H
#define _WXPANEL_EX_H

#include <wx/wx.h>
#include <wx/scrolwin.h>

#include "../../COMMON/CommonDefinitionsWX.h"
#include "../clsWidgetCommon.h"

#define _PANEL_UNDEFINED  -1
#define _PANEL_TIMELINE    0
#define _PANEL_OUTLINER    1
#define _PANEL_PROPERTY    2
#define _PANEL_VIEW3D      3
#define _PANEL_GRAPH       4
#define _PANEL_COLOR_CURVE 5
#define _PANEL_TEXT_EDITOR 6
#define _PANEL_CONSOLE     7
#define _PANEL_BASIC_MAX   8

#define _PANEL_PROPERTY_RENDER 8
#define _PANEL_PROPERTY_SCENE  9
#define _PANEL_PROPERTY_OBJECT 10
#define _PANEL_PROPERTY_MATERIAL 11
#define _PANEL_PROPERTY_MODIFIER 12
#define _PANEL_PROPERTY_DATAPROC 13
#define _PANEL_PROPERTY_FORMAT 14
#define _PANEL_PROPERTY_INFO 15
#define _PANEL_CHILD       16 //ʏ̃pl̎q Bar 
#define _PANEL_DUMMY       17
#define _PANEL_TYPE_MAX    18

// !! pl̃^Cv́AwxPanelEX::msVstrPanelNameƘAĂȂƂȂ
// !! ύX͂Abvf[g邱

class MouseCtrl_cls;
class SplittableWindow_cls;
class PanelBar_cls;

class wxPanelEX : public wxScrolled < wxPanel >, public WidgetCommon_cls {
public:
    wxPanelEX (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDP, const wxSize &size=wxDS, long style=wxTAB_TRAVERSAL);
    ~wxPanelEX();
	
    static wxString msVstrPanelName[_PANEL_TYPE_MAX];
    static wxString msVstrPanelNameLocale[_PANEL_TYPE_MAX];
    static wxString msVstrPanelIconTag[_PANEL_TYPE_MAX];
    static void InitializeStatic();
    static int GetPanelTypeFromStr(wxString strPanelType);
    static int GetPanelTypeFromStrLocale(wxString strPanelType);

    int mPanelType, mParentPanelType;
    void SetPanelType(int panelType, int parentPanelType = _PANEL_UNDEFINED);
    void ConstructSelfIcon(wxBoxSizer *pBoxSizerBar);
    void ConstructTypeSelector(wxBoxSizer *pBoxSizerBar);

    /*
      void ConstructBarItemHideShow(wxBoxSizer *pBoxSizerBar);    
      void ConstructBarItemZoom(wxBoxSizer *pBoxSizerBar);
      void ConstructBarItemDefault(wxBoxSizer *pBoxSizerBar);
    */

    bool mbSkipKeyHook;
    MouseCtrl_cls *mpCMouseCtrl;
    PanelBar_cls  *mpCPanelBar;
    SplittableWindow_cls *mpCParentSWindow;

    void OnMouse(wxMouseEvent& event);
    void OnKeyDown(wxKeyEvent& event);

    void OnMenuChangePanelType(wxCommandEvent& event);
    void OnMenuDestroyPanel(wxCommandEvent& event);
    void OnMenuSeparationDirection(wxCommandEvent& event);
    void OnMenuSeparationSwap(wxCommandEvent& event);
    void OnShowPanelManage(wxCommandEvent& event);
    void OnBtnSeparatePanel(wxCommandEvent& event);
    void OnBtnDestroyPanel(wxCommandEvent& event);
    void OnBtnHideBarItem(wxCommandEvent& event);
    void OnBtnShowBarItem(wxCommandEvent& event);
    void OnTypeSelector(wxCommandEvent& event);
    void OnLeftDown(wxMouseEvent& event);

    void OnBtnZoomP(wxCommandEvent& event);
    void OnBtnZoomM(wxCommandEvent& event);

    bool IsInnertiaExist();
    void UpdatePanels(const wxString& strPanelTag, bool bUpdateBar = FALSE);
    //void ProcRename(const wxString& strNameOld, const wxString& strNameNew);
    void ProcAfterMath(const wxString& strCommand, const wxString& strItem);
    void CheckAbortClicked(const wxPoint& mousePos);
    
    void ReadStrLine(std::wistream &istream, wxString strFirstItem, wxString strLine);
    void Serialize(wxString &strOut);

 private:
    DECLARE_EVENT_TABLE()
};

#endif
