// -*- c -*- 
// (setq c-basic-offset 4)
// "clsAtoSTextCtrl.h"

#include "clsAtoSTextCtrl.h"

#include "../../INPUTMETHOD/clsMouseCtrl.h"

#define CLS AtoSTextCtrl_cls

CLS::
AtoSTextCtrl_cls(wxWindow *parent, wxWindowID id, wxString strInit,
		 wxPoint pos, wxSize size, long style) 
: wxTextCtrl(parent, id, strInit, pos, size, style)
{
    ConstructMain();
    mpCMouseCtrl  = new MouseCtrl_cls;
    mDragScale = 0;
    mbInteger = FALSE;
    mbLimit = FALSE;
    mMin = mMax = 0;
    mbDragging = FALSE;
}

CLS::
~AtoSTextCtrl_cls(){
    delete mpCMouseCtrl;
}

void CLS::
ConstructMain(){
    SetWindowStyle(GetWindowStyle() | wxWANTS_CHARS);

    Connect(GetId(), wxEVT_CHAR_HOOK,
	    wxKeyEventHandler(CLS::OnCharHook));
    Connect(GetId(), wxEVT_CHAR,
	    wxKeyEventHandler(CLS::OnChar));
    
    Connect(GetId(), wxEVT_MOTION,
	    wxMouseEventHandler(CLS::OnMouseMotion));
    Connect(GetId(), wxEVT_LEFT_DOWN,
	    wxMouseEventHandler(CLS::OnMouse));
    Connect(GetId(), wxEVT_LEFT_UP,
	    wxMouseEventHandler(CLS::OnMouse));

    /*
    Connect(GetId(), wxEVT_MIDDLE_DOWN,
	    wxMouseEventHandler(CLS::OnMouse));
    Connect(GetId(), wxEVT_RIGHT_DOWN,
	    wxMouseEventHandler(CLS::OnMouse));
    */

    Connect(GetId(), wxEVT_SIZE,
	    wxSizeEventHandler(CLS::OnSize));
	    
}

bool CLS::
ProcDragging(){
    MouseNormalized_cls CMP(mpCMouseCtrl, mClientSize);

    double dX = CMP.GetDX();

    if (mDragScale != 0){
	//wxString strValue = GetValue();
	//double value; strValue.ToDouble(&value);

	//	value += dX * mDragScale;
	float dragScale = mDragScale;
	if (mpCMouseCtrl->mbAModifier[0] == TRUE){
	    dragScale *= 0.1;
	    printf("!!\n");
	}
	if (mpCMouseCtrl->mbAModifier[2] == TRUE){
	    dragScale *= 10;
	    printf("!!!\n");
	}
	
	mCachedValue += dX * dragScale;

	if (mbLimit == TRUE){
	    if (mCachedValue < mMin) mCachedValue = mMin;
	    if (mCachedValue > mMax) mCachedValue = mMax;
	}

	wxString strValue;
	if (mbInteger == TRUE)
	    strValue << floor(mCachedValue+0.5);
	else
	    strValue << mCachedValue;
	SetValue(strValue);
	mbDragging = TRUE;
	return TRUE;
    }
    return FALSE;
}

bool CLS::
ProcessMouseEvent(wxMouseEvent& event){
    bool bRetValue = FALSE;
    mpCMouseCtrl->SetMouseInformation(event);

    if (mpCMouseCtrl->IsButtonDown()){
	wxString strValue = GetValue();
	strValue.ToDouble(&mCachedValue);
    }

    if (mpCMouseCtrl->IsMouseDragging() == TRUE &&
	(mpCMouseCtrl->mbAModifier[1] == TRUE ||
	 mpCMouseCtrl->mbAModifier[2] == TRUE)){
	wxMouseState mouseState = ::wxGetMouseState();
	bool isLeftDown = mouseState.LeftIsDown();
	
	if (isLeftDown == TRUE)
	    bRetValue = ProcDragging();
    }

    if (mpCMouseCtrl->IsButtonUp() == TRUE){
	if (mbDragging == TRUE){
	    wxCommandEvent com(wxEVT_COMMAND_TEXT_ENTER, 0);
	    com.SetId(GetId());
	    GetParent()->GetEventHandler()->AddPendingEvent(com);
	}
	mbDragging = FALSE;
    }

    mpCMouseCtrl->SetPreviousPosition();
    return bRetValue;
}

/*
void CLS::
UpdateValueFromText(bool assign){
    wxString value = GetLineText(0);
    
    if (assign == TRUE && (value != mPrevValue)){
	wxKeyEvent dummy(wxEVT_CHAR);
	dummy.m_keyCode = WXK_RETURN;
	dummy.SetId(GetId());
	GetParent()->GetEventHandler()->AddPendingEvent(dummy);
    }

    mPrevValue = value;
}
*/

void CLS::
OnCharHook(wxKeyEvent& event){
    // Skipしないことにより、Hookで上の階層がキー入力の処理をするのを防ぐ
    // DoAllowNextEvent() によって、通常のキーイベントが発生する
  //printf("TextHook!!¥n"); fflush(stdout);
#ifdef WIN32
    event.DoAllowNextEvent();
#else
    OnChar(event);
#endif

    // Ctrl-Z を使いたい。Ctrl 押しのイベントは上の階層へ
    if (event.GetModifiers() == wxMOD_CONTROL) event.Skip();
}

void CLS::
OnChar(wxKeyEvent& event){
    int keyCode = event.GetKeyCode();
    //printf("OnChar!!¥n"); fflush(stdout);
    if (keyCode == WXK_TAB/* || keyCode == WXK_RETURN*/){
	wxCommandEvent com(wxEVT_COMMAND_TEXT_ENTER, 0);
	com.SetId(GetId());
	GetParent()->GetEventHandler()->AddPendingEvent(com);
    }
    event.Skip();
}

void CLS::
OnMouse(wxMouseEvent& event){
    ProcessMouseEvent(event);
    event.Skip();
}

void CLS::
OnMouseMotion(wxMouseEvent& event){
    if (ProcessMouseEvent(event) == FALSE)
	event.Skip();
}

void CLS::
OnSize(wxSizeEvent& event){
    mClientSize = event.GetSize();
    event.Skip();
}

/*
void CLS::
UpdateDisplay(){
    SetValue(wxString::FromAscii(msValue.c_str()));
}
*/

/*
void CLS::
SetValueStr(wxString strValue){
    SetValue(strValue);
}
*/
