// -*- c -*- 
// "clsTextButton.h"

#include "clsTextButton.h"
#include "../WX/clsColorProvider.h"

#define CLS TextButton_cls

BEGIN_EVENT_TABLE(CLS, wxStaticText)
EVT_LEFT_DOWN(CLS::OnLeftDown)
EVT_RIGHT_DOWN(CLS::OnRightDown)
EVT_ENTER_WINDOW(CLS::OnEnter)
EVT_LEAVE_WINDOW(CLS::OnLeave)
END_EVENT_TABLE()

TextButton_cls::
TextButton_cls(wxWindow *pCParent, wxWindowID id, wxString initStr) :
wxStaticText(pCParent, id, initStr){
    mpCEventTarget = NULL;
    mbPushed = FALSE;
}

void CLS::
SetEventTarget(wxWindow *pCEventTarget){
    mpCEventTarget = pCEventTarget;
}

void CLS::
Push(){
    SetBackgroundColour(ColorProvider_cls::GetColor("TextSelected"));
    Refresh();
    Update();
    mbPushed = TRUE;
}

void CLS::
Pull(){
    SetBackgroundColour(wxNullColour);
    Refresh();
    mbPushed = FALSE;
}

void CLS::
PopMenu(wxWindow *pCSrc, wxMenu* pCMenu){
    wxPoint CPos = GetRect().GetBottomLeft();
    Push();
    pCSrc->PopupMenu(pCMenu, CPos);
    Pull();
}

void CLS::
OnLeftDown(wxMouseEvent& event){
    wxCommandEvent com(wxEVT_BUTTON);
    com.SetId(GetId());
    if (mpCEventTarget == NULL)
	return GetParent()->GetEventHandler()->AddPendingEvent(com);
    
    mpCEventTarget->GetEventHandler()->AddPendingEvent(com);
}

void CLS::
OnRightDown(wxMouseEvent& event){
    event.SetId(GetParent()->GetId());
    GetParent()->GetEventHandler()->AddPendingEvent(event);
}

void CLS::
OnEnter(wxMouseEvent& event){
    SetBackgroundColour(ColorProvider_cls::GetColor("TextActive"));
    Refresh();
}

void CLS::
OnLeave(wxMouseEvent& event){
    if (mbPushed == TRUE) return;
    SetBackgroundColour(wxNullColour);
    Refresh();
}
