// -*- c -*- 
// (setq c-basic-offset 4)
// "clsTextCtrlWithDrag.h"

#include "clsTextCtrlWithDrag.h"

#include "../../INPUTMETHOD/clsMouseCtrl.h"

#define CLS TextCtrlWithDrag_cls

BEGIN_EVENT_TABLE(CLS, wxTextCtrl)
EVT_MOUSE_CAPTURE_LOST(CLS::OnCaptureLost ) 
END_EVENT_TABLE()

CLS::
TextCtrlWithDrag_cls(wxWindow *parent, wxWindowID id, wxString strInit,
		     wxPoint pos, wxSize size, long style) 
: wxTextCtrl(parent, id, strInit, pos, size, style)
{
    ConstructMain();
    mpCMouseCtrl  = new MouseCtrl_cls;
    mDragScale = 0;
    mbInteger = FALSE;
    mbDragging = FALSE;
    strInit.ToDouble(&mCachedValue);
    mClientSize = size;
}

CLS::
~TextCtrlWithDrag_cls(){
    if (HasCapture() == TRUE)
	ReleaseMouse();
    delete mpCMouseCtrl;
}

void CLS::
ConstructMain(){
    Connect(GetId(), wxEVT_MOTION,
	    wxMouseEventHandler(CLS::OnMouseMotion));
    Connect(GetId(), wxEVT_LEFT_DOWN,
	    wxMouseEventHandler(CLS::OnMouse));
    Connect(GetId(), wxEVT_LEFT_UP,
	    wxMouseEventHandler(CLS::OnMouse));
    /*
    Connect(GetId(), wxEVT_MOUSE_CAPTURE_LOST,
	    wxMouseCaptureLostEventHandler(CLS::OnCaptureLost));
    */
}

bool CLS::
ProcDragging(){
    MouseNormalized_cls CMP(mpCMouseCtrl, mClientSize);

    double dX = CMP.GetDX();

#ifdef WIN32
    if (HasCapture() == FALSE)
	CaptureMouse();
#endif

    if (mDragScale != 0){
	
	// Skip first one drag;
	if (mbDragging == TRUE){
	    float dragScale = mDragScale;
	    if (mpCMouseCtrl->mbAModifier[0] == TRUE){
		dragScale *= 0.1;
	    }
	    if (mpCMouseCtrl->mbAModifier[2] == TRUE){
		dragScale *= 10;
	    }
	    
	    mCachedValue += dX * dragScale;
	}

	wxString strValue;
	if (mbInteger == TRUE)
	    strValue << floor(mCachedValue+0.5);
	else
	    strValue << mCachedValue;
	SetValue(strValue);
	mbDragging = TRUE;
	return TRUE;
    }
    return FALSE;
}

bool CLS::
ProcessMouseEvent(wxMouseEvent& event){
    bool bRetValue = FALSE;
    mpCMouseCtrl->SetMouseInformation(event, FALSE);

    wxMouseState mouseState = ::wxGetMouseState();
    bool isLeftDown = mouseState.LeftIsDown();

    if (mpCMouseCtrl->IsButtonDown()){
	wxString strValue = GetValue();
	strValue.ToDouble(&mCachedValue);
	
	if (isLeftDown == TRUE) mbDragging = TRUE;
    }

    if (mpCMouseCtrl->IsMouseDragging() == TRUE &&
	(mpCMouseCtrl->mbAModifier[1] == TRUE ||
	 mpCMouseCtrl->mbAModifier[2] == TRUE)){

#ifndef WIN32
	if (mbDragging == TRUE)
#endif
	    if (isLeftDown == TRUE)
		bRetValue = ProcDragging();
    }

    if (mpCMouseCtrl->IsButtonUp() == TRUE){
	if (mbDragging == TRUE){
	    wxCommandEvent com(wxEVT_COMMAND_TEXT_ENTER, 0);
	    com.SetId(GetId());
	    GetParent()->GetEventHandler()->AddPendingEvent(com);
	    mbDragging = FALSE;
	    printf("mbDragging FALSE\n");
	}
	
    }

    mpCMouseCtrl->SetPreviousPosition();
    return bRetValue;
}

void CLS::
OnMouse(wxMouseEvent& event){
    ProcessMouseEvent(event);
    if (mbDragging == FALSE) event.Skip();
}

void CLS::
OnMouseMotion(wxMouseEvent& event){
    ProcessMouseEvent(event);
    if (mbDragging == FALSE) event.Skip();
    /*
    if (ProcessMouseEvent(event) == FALSE)
	event.Skip();
    */
}

void CLS::
OnCaptureLost(wxMouseCaptureLostEvent& event){
    printf("Capture LOST");
    event.Skip();
}
