// (setq c-basic-offset 4)
// "clsHideAndShowButton.h"

#include "clsHideAndShowButton.h"

#include "../../CONFITEM/clsConfItem.h"
#include "../../MISC/clsMisc.h"
#include "../../WIDGETCTRL/clsBitmapPanel.h"
#include "../../WIDGETCTRL/WX/myArtProv.h"

#include "../../COMMON/CommonDefinitionsWX.h"

#define CLS HideAndShowButton_cls

CLS::
HideAndShowButton_cls(wxArrayString* pAstrColosedItem, wxWindow *pCPanelLink, wxString strTag) 
{
    // PanelLinkƓ̃plɂ邱ƑO
    wxWindow *pCParent = pCPanelLink->GetParent();
    mpCBitmapPanel = new BitmapPanel_cls(pCParent, wxID_ANY, wxDP, wxSize(20, 20));
    mpCBitmapPanel->AddBitmapStr("wxART_CLOSE");
    mpCBitmapPanel->AddBitmapStr("wxART_OPEN");
    mpCBitmapPanel->mbButton = TRUE;
    mpCBitmapPanel->SetBorder(4, 4);
    mpCBitmapPanel->mState = 1;
    pCParent->Connect(mpCBitmapPanel->GetId(), wxEVT_COMMAND_BUTTON_CLICKED, wxComEH(CLS::OnButton), NULL, this);
    
    mstrTag = strTag;
    mpCLabel = new wxStaticText(pCParent, wxID_ANY, strTag);
    //mpCConfBoolLink = pCConfBoolLink;
    mpAstrClosedItem = pAstrColosedItem;
    mpCPanelLink = pCPanelLink;
    mbForceResize = FALSE;

    SyncStateToData();
}

void CLS::
SetToSizer(wxBoxSizer *pBoxSizer){
    wxBoxSizer *pBoxSizerH = new wxBoxSizer(wxHORIZONTAL);
    pBoxSizerH->Add(mpCBitmapPanel, 0, wxEXPAND);
    pBoxSizerH->Add(mpCLabel, 1, wxEXPAND);
    pBoxSizer->Add(pBoxSizerH, 0, wxEXPAND);
}

void CLS::
SyncStateToData(){
    if (Misc_cls::DoesExistInArray(*mpAstrClosedItem, mstrTag) == TRUE)
	mpCBitmapPanel->mState = 0;
    else
	mpCBitmapPanel->mState = 1;
}

void CLS::
HideAndShow(){
    if (Misc_cls::DoesExistInArray(*mpAstrClosedItem, mstrTag) == FALSE &&
	mpCPanelLink->IsShown() == FALSE)
	mpCPanelLink->Show();
    if (Misc_cls::DoesExistInArray(*mpAstrClosedItem, mstrTag) == TRUE && 
	mpCPanelLink->IsShown() == TRUE)
	mpCPanelLink->Hide();
}

void CLS::
OnButton(wxCommandEvent& event){
    /*
    mpCConfBoolLink->SetBodyFromData((long long)mpCBitmapPanel->mState);
    */
    if (Misc_cls::DoesExistInArray(*mpAstrClosedItem, mstrTag) == FALSE &&
	mpCBitmapPanel->mState == 0)
	mpAstrClosedItem->push_back(mstrTag);
    if (Misc_cls::DoesExistInArray(*mpAstrClosedItem, mstrTag) == TRUE &&
	mpCBitmapPanel->mState == 1)
	mpAstrClosedItem->Remove(mstrTag);

    HideAndShow();
    
    wxWindow *pCParent = mpCBitmapPanel->GetParent();

    if (mbForceResize == TRUE){
	// PropertyModifier ł́A
	// XN[o[̒ǐ̂߂ԂɏKv
	pCParent->GetParent()->GetParent()->Freeze();
	wxSize CBestSize = pCParent->GetParent()->GetBestSize();
	pCParent->GetParent()->SetSize(wxSize(-1, CBestSize.GetHeight()));

	//pCParent->GetParent()->Layout();
    
	pCParent->GetParent()->GetParent()->Layout();
	pCParent->GetParent()->GetParent()->PostSizeEvent();	
	pCParent->GetParent()->GetParent()->Thaw();
    }
    else{
	pCParent->Layout();
	pCParent->GetParent()->Layout();
    }
	
    // ȂȂƁAScroll  ON/OFF TCYύXǐȂ
    //mpCPanelLink->GetParent()->GetParent()->SetVirtualSize(wxDS);
}
