// -*- c -*- 
// "clsInputItem.cpp"

#ifndef _INPUT_ITEM_H_
#define _INPUT_ITEM_H_

#include <wx/wx.h>
#include <vector>

#include "../../COMMON/clsGetPC.h"
#include "../../CONFITEM/clsConfItem.h"

#define _ITEM_BOXSIZER 0
#define _ITEM_CONFITEM 1
#define _ITEM_BUTTON   2
#define _ITEM_BITMAPPANEL 3

#define _BITMAP_BTN_DROPDOWN 0

#define _ITEM_MENU_COLOR 0
#define _ITEM_MENU_COLOR_CURVE 1

class wxStaticText;

class InputItem_cls : public GetPC_cls {
 public:
    InputItem_cls(int type, wxString strLabel, bool bEnable, bool bVolatile, int size);
    wxWindow *mpCWindowLink;
    std::vector < wxWindow* > mVpCWindowLinkArray;
    int mInputType, mSize, mTextWidth, mButtonWidth;
    int mButtonId;
    wxString mstrLabel;
    bool mbEnable;
    
    int mContextMenuType;
    bool mbVolatile; 
    bool mbLimit;
    double mMin, mMax;
    double mDragScale;

    // ComboBox
    std::vector < wxString > mVstrChoice;

    // BOXSIZER
    int mItemNum;
    wxBoxSizer *mpBoxSizerLink;

    // BITMAPPANLEL
    int mBitmapTemplate;
    bool mbUseVCenter;
    wxString mstrCommandStr;

    // CONFITEM
    ConfItemBase_cls* mpCConfItemLink;
    wxStaticText *mpCTextLabelLink;

    bool IsItemIdMatch(int id);
    std::vector < wxString > GetVstrLabel();
    void CombineChoiceList(std::vector < wxString > mVstrChoiceList);
    void RecombineConfItem(ConfItem_cls& CConfItem, wxString strPanelNamem, bool bForceShow = FALSE);
    void ConnectConfItem(wxBoxSizer* pBoxSizerCurrent, wxWindow *pCParent);
    void ConnectButton(wxBoxSizer* pBoxSizerCurrent, wxWindow *pCParent);
    void ConnectBitmapPanel(wxBoxSizer* pBoxSizerCurrent, wxWindow *pCParent);
    void ConnectSizer(wxBoxSizer* pBoxSizerCurrent);
    void OnChanged(bool bVolatile);

    bool Show(bool bShow = TRUE);
    bool Hide();
    void Enable(bool bEnable = TRUE);
    void SetBackgroundColour(std::vector < wxColor > Vclr);
    void SetBackgroundColour(wxColor clr);
    
    void UpdateLabel();
    void UpdateDisplay();
};

/*
#define _ITEM_NOT_DEFINED    0
#define _ITEM_INTEGER        1
#define _ITEM_INTEGER_SPIN   2
#define _ITEM_INTEGER_SLIDER 3
#define _ITEM_FLOAT          4
#define _ITEM_FLOAT_SLIDER   5
#define _ITEM_DOUBLE         6
#define _ITEM_DOUBLE_SLIDER  7
#define _ITEM_BOOL           8
#define _ITEM_UINT           9
#define _ITEM_UINT_LIST     10
#define _ITEM_UINT_SPIN     11
#define _ITEM_STRING        12
#define _ITEM_DUALSLIDER    13
#define _ITEM_UINT_ICON     14

#define _ITEM_WXPANEL       15
#define _ITEM_STATIC_TEXT   16
#define _ITEM_BUTTON        40

#define _ITEM_BUTTON_HIDE_PANEL 50
#define _ITEM_BOXSIZERHORIZONTAL 60

#define _ITEM_CONF        70
#define _ITEM_CONF_SLIDER 71

#define _ITEM_ALIGN_LEFT  0
#define _ITEM_ALIGN_RIGHT 1

#define _MN_UNDO_MANUAL        0
#define _MN_UNDO_AUTO_POINTER  1
#define _MN_UNDO_SCENEOBJ_CONFITEM 2

#include <wx/wx.h>
#include <vector>

class wxStaticTextEX;
//class FilterCtrl_cls;
class SceneObjCtrl_cls;

class InputItem_cls{
 public:
    InputItem_cls();

    wxString mstrLabel;
    wxString mstrSceneObjName;
    wxString mstrModifierName;
    wxStaticTextEX* mpCTextLabel;

    int  mType, mId, mUpdateBit;
    int  mUndoType;

    SceneObjCtrl_cls *mpCTgtSceneObjCtrl;
    int  mTextWidth, mItemWidth;
    void *mpValue, *mpCCtrl;
    float*   mpColorFloat;
    bool     mbEnable;
    double   mMin, mMax;
    int      mScale;

    unsigned int  mListMax;
    std::vector < wxString > mVstrChoiceList;
    std::vector < wxIcon >   *mpVIcon; // 
    
    bool mbConnectSizer;
    int  mSizerIndex;

    int          GetType();
    wxSizerFlags GetSizerFlagLabel();
    wxSizerFlags GetSizerFlagH(int borderWidth = 2);
    int      mAlign, mStyle;
    
    wxSizerFlags GetSizerFlagV();

    bool   IsButton();
    bool   IsShown();
    void   Show(bool bShow = TRUE);
    void   Hide();
    void   Enable(bool bEnable = TRUE);

    void SetParameter
	(int sizerCounter, 
	 int textWidth, int checkboxWidth, int comboWidth, int itemWidth);
    void CombinePointerButton
	(int id, wxString strLabel, int type,  bool bEnable);
    void CombinePointer
	(int type, void *pValue, 
	 wxString strLabel = wxT(""), bool bEnable = TRUE);
    void CombineList
	(unsigned int listMax, wxString *pChoiceList);
    
    void   SetRange(double min, double max, int scale);
    void   ApplyRange();
    void   SetRealTime();
    
    bool   *GetPValueBool();
    bool   GetValueBool();
    float  *GetPValueFloat();
    float  GetValueFloat();
    double *GetPValueDouble(int index = 0);
    double GetValueDouble(int index = 0);
    int    *GetPValueInt();
    int    GetValueInt();
    wxString *GetPValueStr();
    wxString GetValueStr();
    
    bool   Assign();

    void   UpdateDisplay();
    
    int  ConnectBoxSizer(wxBoxSizer* pBoxSizer, wxWindow* pWindow);

    wxBoxSizer* GetPNewSizer(wxWindow* pWindow);
    wxWindow*   GetPCwxWindow();
    
    void ItemConnect(wxBoxSizer* pBoxSizer);
    void ItemConnect_Int(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_IntSpin(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_IntSlider(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_Float(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_FloatSlider(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_Double(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_DoubleSlider(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_Bool(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_List(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_Icon(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_String(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_DualSlider(wxBoxSizer* pBoxSizer, wxWindow *pWindow);
    void ItemConnect_WXPanel(wxBoxSizer* pBoxSizer);
    void ItemConnect_StaticText(wxBoxSizer *pBoxSizer, wxWindow *pWindow);
    void ItemConnect_Button(wxBoxSizer* pBoxSizer, wxWindow* pWindow, bool bExpand = FALSE);
};
*/

#endif
