// (setq c-basic-offset 4)
// "clsMNumPainBase.h"

#include "clsMNumPainBase.h"
#include "clsHideAndShowButton.h"
#include "clsMultiInputPanel.h"

#include "../clsBitmapPanel.h"
#include "../../COMMON/CommonDefinitions.h"
#include "../../FILTER/clsFilterCtrl.h"
#include "../../SCENEOBJ/clsSceneObjCtrl.h"
#include "../../WIDGETCTRL/INPUTITEM/clsVCenter.h"
#include "../../WIDGETCTRL/WX/clsColorProvider.h"

#include "../../../wxWidgetEnum.h"

#include <wx/cursor.h>

#define CLS PanelDropSouece_cls

CLS::
PanelDropSouece_cls(DragButton_cls *pCParent) : wxDropSource (pCParent) {
    mpCParent = pCParent;
}

bool CLS::
GiveFeedback(wxDragResult effect){
    mpCParent->OnFeedBack();
    return FALSE;
}

#define CLS DragButton_cls

BEGIN_EVENT_TABLE(CLS, BitmapPanel_cls)
EVT_LEFT_DOWN(CLS::OnLeftDown)
END_EVENT_TABLE()

CLS::
DragButton_cls(MNumPainBase_cls *pCParent, wxString strTag) : BitmapPanel_cls(pCParent, wxID_ANY, wxDP, wxSize(36, 18)){

    mpCParent = pCParent;
    mstrTag = strTag;
    mbDealPushed = FALSE;
    AddBitmapStr("wxART_HANDLE", "wxART_HANDLE_P");
    SetBorder(1, 1);
}

void CLS::
OnFeedBack(){ mpCParent->CheckHover(); }

void CLS::
OnLeftDown(wxMouseEvent& event){
    mbPushed = TRUE;
    Refresh();
    Update();
    wxString strTag = "DraggingPanel::";
    strTag << mpCParent->mstrTag << "::" << mstrTag;
    wxTextDataObject dragData(strTag);
    PanelDropSouece_cls dragSource (this);
    dragSource.SetData (dragData);
    dragSource.SetCursor(wxDragNone, wxCursor(wxCURSOR_HAND));
    dragSource.SetCursor(wxDragError, wxCursor(wxCURSOR_HAND));
    wxDragResult result = dragSource.DoDragDrop(true);
    mbPushed = FALSE;
    Refresh();
    mpCParent->ClearHover();
}

#define CLS AcceptDropPanel_cls

CLS::
AcceptDropPanel_cls(InsertTarget_cls *pCParent){
    mpCParent = pCParent;
}

bool CLS::
OnDropText(wxCoord x, wxCoord y, const wxString& strData){
    mpCParent->ProcDrop(strData);
    return true;
}

#define CLS InsertTarget_cls

CLS::
InsertTarget_cls(MNumPainBase_cls *pCParent, int selfIndex) : wxPanel(pCParent, wxID_ANY, wxDP, wxSize(-1, 5)){
    mpCParent = pCParent;
    mSelfIndex = selfIndex;
    mbHovered = FALSE;

    SetDropTarget(new AcceptDropPanel_cls(this));
}

void CLS::
ProcDrop(wxString strData){ mpCParent->ProcDrop(strData, mSelfIndex); }

void CLS::
ClearHover(){
    SetBackgroundColour(wxNullColour);
    Refresh();
    mbHovered = FALSE;
}

void CLS::
CheckHover(wxPoint mousePos){
    wxRect CRect = GetScreenRect();
    if (CRect.Contains(mousePos) == TRUE && mbHovered == FALSE){
	SetBackgroundColour(wxColor(0, 0, 0));
	Refresh();
	mbHovered = TRUE;
    }
    if (CRect.Contains(mousePos) == FALSE && mbHovered == TRUE){
	SetBackgroundColour(wxNullColour);
	Refresh();
	mbHovered = FALSE;
    }
}


#define CLS MNumPainBase_cls

CLS::
MNumPainBase_cls(wxWindow *pCParent, wxSize& size, bool bScroll) : 
    wxScrolled  < wxPanel > (pCParent, wxID_ANY, wxDP, size, wxVSCROLL){

    SetBackgroundColour(ColorProvider_cls::GetColor("EditPanel"));
    mbHideButton = TRUE;
    mbDeleteButton = FALSE;
    mbInsertTarget = FALSE;
    mbDraggingItem = FALSE;
    
    SetSize(wxDefaultSize);
    SetVirtualSize(size);
        if (bScroll == FALSE) return;
    ShowScrollbars(wxSHOW_SB_NEVER, wxSHOW_SB_DEFAULT/*ALWAYS*/);
    EnableScrolling(FALSE, TRUE);
    SetScrollbars(10, 10, 50, 50);
}

CLS::
~MNumPainBase_cls(){
    uint numButton = mVpCHSButton.size();
    for (uint i = 0; i < numButton; i++) delete mVpCHSButton[i];

    uint numInsertTarget = mVpCInsertTarget.size();
    for (uint i = 0; i < numInsertTarget; i++)
	if (mVpCInsertTarget[i] != NULL) delete mVpCInsertTarget[i];
}

MultiInputPanel_cls* CLS::
GetPCMNum(wxString strName){
    uint numPanel = mVpCMNumPanelLink.size();
    for (uint i = 0; i < numPanel; i++){
	if (strName.IsSameAs(mVpCMNumPanelLink[i]->GetName()) == TRUE)
	    return mVpCMNumPanelLink[i];
    }
    return NULL;
}

void CLS::
SetMNum(MultiInputPanel_cls *pCMNum, wxArrayString &AstrColsedItem, 
	wxString strTag, bool bValidity, bool bForceResize){
    mVpCMNumPanelLink.push_back(pCMNum);
    
    HideAndShowButton_cls *pCBtn = 
	new HideAndShowButton_cls(&AstrColsedItem, pCMNum, strTag);
    pCBtn->mbForceResize = bForceResize;
    mVpCHSButton.push_back(pCBtn);

    if (mbInsertTarget == TRUE){
	InsertTarget_cls *pCInsertTarget = new InsertTarget_cls(this, mVpCInsertTarget.size());
	mVpCInsertTarget.push_back(pCInsertTarget);
    }
    else
	mVpCInsertTarget.push_back(NULL);
    mVbValidity.push_back(bValidity);
}

void CLS::
InitLayoutNumPanels(wxBoxSizer *pCBoxSizer){
    ASSERT(mVpCMNumPanelLink.size() == mVpCHSButton.size());

    if (mbInsertTarget == TRUE){
	InsertTarget_cls *pCInsertTarget = new InsertTarget_cls(this, mVpCInsertTarget.size());
	mVpCInsertTarget.push_back(pCInsertTarget);
    }
    else
	mVpCInsertTarget.push_back(NULL);

    ASSERT(mVpCInsertTarget.size() == mVpCMNumPanelLink.size() + 1);
    
    uint num = mVpCMNumPanelLink.size();
    for (uint i = 0; i < num; i++){
	if (mVpCInsertTarget[i] != NULL)
	    pCBoxSizer->Add(mVpCInsertTarget[i], 0, wxEXPAND);
	
	if (mbHideButton == TRUE && i == 0){
	    wxBoxSizer *pCBoxSizerIni = new wxBoxSizer(wxHORIZONTAL);
	    wxSize CSize = wxSize(20, 20);
	    BitmapPanel_cls *pBtnHide = new BitmapPanel_cls(this, btnNumPanelHide, wxDP, CSize);
	    pBtnHide->AddBitmapStr("wxART_HIDE", "wxART_HIDE_P");
	    pBtnHide->mbButton = TRUE;
	    pBtnHide->SetBorder(1,1);
	    mVpCHSButton[i]->SetToSizer(pCBoxSizerIni);

	    if (mbInsertTarget == TRUE){
		DragButton_cls *pCDragButton = new DragButton_cls(this, mVpCHSButton[i]->mpCLabel->GetLabel());
		pCBoxSizerIni->Add(pCDragButton, 0, wxEXPAND);
	    }
	    pCBoxSizerIni->AddStretchSpacer(1);
	    pCBoxSizerIni->Add(pBtnHide, 0, wxEXPAND);
	    
	    pCBoxSizer->Add(pCBoxSizerIni, 0, wxEXPAND);
	}
	else if (mbDeleteButton == TRUE){
	    wxBoxSizer *pCBoxSizerIni = new wxBoxSizer(wxHORIZONTAL);
	    wxSize CSize = wxSize(20, 20);
	    BitmapPanel_cls *pBtnDelete = new BitmapPanel_cls(this, btnNumPanelDelete, wxDP, CSize);
	    pBtnDelete->AddBitmapStr("wxART_CLOSE_PANEL", "wxART_CLOSE_PANEL_P");
	    pBtnDelete->mbButton = TRUE;
	    pBtnDelete->SetBorder(1,1);
	    pBtnDelete->mstrCommandStr = mVpCMNumPanelLink[i]->GetName();
	    
	    BitmapPanel_cls *pBtnValidity = new BitmapPanel_cls(this, btnNumPanelValidity, wxDP, wxSize(14, 14));
	    pBtnValidity->AddBitmapStr("wxART_EYE_S_N");
	    pBtnValidity->AddBitmapStr("wxART_EYE_S_P");
	    pBtnValidity->mbButton = TRUE;
	    pBtnValidity->mState = mVbValidity[i];
	    pBtnValidity->mstrCommandStr = mVpCMNumPanelLink[i]->GetName();
	    VCenter_cls *pCValidity = new VCenter_cls(pBtnValidity);

	    mVpCButtonValidity.push_back(pBtnValidity);
	    
	    mVpCHSButton[i]->SetToSizer(pCBoxSizerIni);
	    pCBoxSizerIni->AddSpacer(6);
	    pCBoxSizerIni->Add(pCValidity, 0, wxEXPAND);
	    pCBoxSizerIni->AddStretchSpacer(1);
	    if (mbInsertTarget == TRUE){
		DragButton_cls *pCDragButton = new DragButton_cls(this, mVpCHSButton[i]->mpCLabel->GetLabel());
		pCBoxSizerIni->Add(pCDragButton, 0, wxEXPAND);
	    }
	    pCBoxSizerIni->Add(pBtnDelete, 0, wxEXPAND);
	    pCBoxSizer->Add(pCBoxSizerIni, 0, wxEXPAND);
	}
	else {
	    if (mVpCMNumPanelLink[i]->mbUseStatus == TRUE){
		wxBoxSizer *pCBoxSizerIni = new wxBoxSizer(wxHORIZONTAL);
		mVpCHSButton[i]->SetToSizer(pCBoxSizerIni);
		BitmapPanel_cls *pBtnStatus = new BitmapPanel_cls(this, wxID_ANY, wxDP, wxSize(18, 18));
		pBtnStatus->AddBitmapStr("wxART_WARNING");
		VCenter_cls *pCWarning = new VCenter_cls(pBtnStatus);
		pCBoxSizerIni->AddStretchSpacer(1);
		pCBoxSizerIni->Add(pCWarning, 0, wxEXPAND);
		pCBoxSizer->Add(pCBoxSizerIni, 0, wxEXPAND);
		mVpCMNumPanelLink[i]->mpCStatusLink = pBtnStatus;
	    }
	    else{
		mVpCHSButton[i]->SetToSizer(pCBoxSizer);
	    }
	}
	
	pCBoxSizer->Add(mVpCMNumPanelLink[i], 0, wxEXPAND);
    }

    uint i = mVpCInsertTarget.size() - 1;
    if (mVpCInsertTarget[i] != NULL)
	pCBoxSizer->Add(mVpCInsertTarget[i], 0, wxEXPAND);
}

void CLS::
ClearHover(){
    uint num = mVpCInsertTarget.size();
    for (uint i = 0; i < num; i++)
	if (mVpCInsertTarget[i] != NULL) mVpCInsertTarget[i]->ClearHover();
}

void CLS::
CheckHover(){
    wxPoint mousePos = ::wxGetMousePosition();
    uint num = mVpCInsertTarget.size();	
    for (uint i = 0; i < num; i++)
	if (mVpCInsertTarget[i] != NULL)
	    mVpCInsertTarget[i]->CheckHover(mousePos);
}

void CLS::
ProcDrop(wxString strData, int index){
    wxString strCommand = PopStrItemFromStrLine(strData, "::");
    ASSERT(strCommand.IsSameAs("DraggingPanel"));
    wxString strController = PopStrItemFromStrLine(strData, "::");
    if (strController.IsSameAs("FilterCtrl")){
	PopStrItemFromStrLine(strData, "::");
	GetPCFilterCtrl()->MoveFilterCommand(strData, index);
    }
    if (strController.IsSameAs("SceneObjCtrl")){
	PopStrItemFromStrLine(strData, "::");
	GetPCSceneObjCtrl()->MoveModifierCommand(strData, index);
    }
}

void CLS::
LayoutNumPanels(bool bLayout){
    uint num = mVpCMNumPanelLink.size();
    for (uint i = 0; i < num; i++)
	mVpCHSButton[i]->HideAndShow();
    if (bLayout == TRUE){
	Layout();
	GetParent()->Layout();
    }

    // ȂȂƁAScroll  ON/OFF TCYύXǐȂ
    //GetParent()->SetVirtualSize(wxDS);
}

void CLS::
SyncStateToData(){
    uint num = mVpCHSButton.size();
    for (uint i = 0; i < num; i++)
	mVpCHSButton[i]->SyncStateToData();
}

void CLS::
SyncValidityToData(std::vector < bool > VbValidity){
    uint num = mVpCButtonValidity.size();
    ASSERT(num == VbValidity.size());

    for (uint i = 0; i < num; i++)
	mVpCButtonValidity[i]->SetStatus(VbValidity[i]);
}

void CLS::
UpdateValues(){
	    uint num = mVpCMNumPanelLink.size();
    for (uint i = 0; i < num; i++)
	mVpCMNumPanelLink[i]->UpdateValues(_MN_ALLITEM);
}
