// (setq c-basic-offset 4)
// "clsMNumPainBase.cpp"

#ifndef _MNUM_PAIN_BASE_H_
#define _MNUM_PAIN_BASE_H_

class MultiInputPanel_cls;
class HideAndShowButton_cls;

#include "../clsBitmapPanel.h"

#include "../../COMMON/clsGetPC.h"
#include "../../FILEIO/clsParser.h"

#include <vector>
#include <wx/wx.h>
#include <wx/dnd.h>
#include <wx/scrolwin.h>

class MultiInputPanel_cls;
class HideAndShowButton_cls;
class ConfItemBOOL_cls;

class InsertTarget_cls;
class MNumPainBase_cls;
class DragButton_cls;

class PanelDropSouece_cls : public wxDropSource {
public:
    PanelDropSouece_cls(DragButton_cls *pCParent);
    DragButton_cls *mpCParent;

    bool GiveFeedback(wxDragResult effect);
};

class DragButton_cls : public BitmapPanel_cls {
public:
    DragButton_cls(MNumPainBase_cls *pCParent, wxString strTag);

    MNumPainBase_cls* mpCParent;
    wxString mstrTag;

    void OnFeedBack();
    void OnLeftDown(wxMouseEvent &event);

    DECLARE_EVENT_TABLE()
};

class AcceptDropPanel_cls : public wxTextDropTarget {
public:
    AcceptDropPanel_cls(InsertTarget_cls *pCParent);
    
    InsertTarget_cls* mpCParent;
    
    bool OnDropText(wxCoord x, wxCoord y, const wxString& strData);
};

class InsertTarget_cls : public wxPanel {
public:
    InsertTarget_cls(MNumPainBase_cls *pCParent, int selfIndex);

    MNumPainBase_cls* mpCParent;
    int mSelfIndex;
    bool mbHovered;
    
    void ProcDrop(wxString strData);
    void ClearHover();
    void CheckHover(wxPoint mousePos);
};

class MNumPainBase_cls : public wxScrolled < wxPanel >, public Parser_cls, public GetPC_cls{
public:
    MNumPainBase_cls(wxWindow *pCParent, wxSize& size, bool bScroll = TRUE);
    ~MNumPainBase_cls();

    bool mbHideButton;
    bool mbInsertTarget;
    bool mbDeleteButton;
    bool mbDraggingItem;

    wxString mstrTag;

    std::vector < MultiInputPanel_cls* > mVpCMNumPanelLink;
    std::vector < HideAndShowButton_cls* > mVpCHSButton;
    std::vector < InsertTarget_cls* > mVpCInsertTarget;
    std::vector < bool > mVbValidity;
    std::vector < BitmapPanel_cls* > mVpCButtonValidity;
    
    MultiInputPanel_cls *GetPCMNum(wxString strName);
    void SetMNum(MultiInputPanel_cls* pCMNum, 
		 wxArrayString &AstrColsedItem,
		 wxString strTag, bool bValidity = TRUE, bool bForceResize = FALSE);
    void InitLayoutNumPanels(wxBoxSizer *pCBoxSizer);
    void LayoutNumPanels(bool bLayout = true);
    void ClearHover();
    void CheckHover();
    void ProcDrop(wxString strData, int index);

    void SyncStateToData();
    void SyncValidityToData(std::vector < bool > VbValidity);
    void UpdateValues();
};

#endif
