// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsMultiInputPanel.h"

#include "clsMultiInputPanel.h"
#include "clsInputItem.h"
#include "clsHookCtrl.h"

#include "../INPUTITEM/clsAtoSTextCtrl.h"

#include "../../COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;
#include "../../CONFITEM/clsConfItem.h"

#include "../clsWidgetCommon.h"
#include "../WX/clsColorProvider.h"
//#include "../WX/clsFontProvider.h"

#include "../../COMMON/CommonDefinitions.h"

#include "../../../wxWidgetEnum.h"
#include "../../../wxWidgetEnumMenu.h"

#define CLS MultiInputPanel_cls

BEGIN_EVENT_TABLE(CLS, wxPanel)
EVT_MENU_RANGE(menuCopyColor, menuPasteColor, CLS::OnMenuCommand)
EVT_MENU_RANGE(menuCopyColorCurve, menuPasteColorCurve, CLS::OnMenuCommand)
END_EVENT_TABLE()

CLS::
MultiInputPanel_cls(wxWindow *parent, wxString strPanelName, bool bVolatile) :
    wxScrolled < wxPanel > (parent, wxID_ANY, wxDPS, 0/*style*/, strPanelName)
{
    SetBackgroundColour(parent->GetBackgroundColour());
    mpCBoxSizerSrc = NULL;
    mpCPadding = NULL;
    mpCHookCtrl = new HookCtrl_cls;
    mItemSize = 1;
    mMinWidth = 250;
    mTextWidth = 120;
    mbVolatile = bVolatile;
    mbUseStatus = FALSE;
    mpCStatusLink = NULL;
    ClearItemProperty();
    
    //mstrInputPanelTag = strInputPanelTag;
}

CLS::
~MultiInputPanel_cls(){
    delete mpCHookCtrl;
    if (mbVolatile == TRUE) return;

    /*
    for (unsigned int i = 0; i < mVCItem.size(); i++)
	if (mVCItem[i].mInputType == _ITEM_CONFITEM)
	    mVCItem[i].mpCConfItemLink->DetachInputPanelName(GetName());
    */
}

MultiInputPanel_cls* CLS::
Initialize(MultiInputPanel_cls **ppMNum, wxWindow *pCParent, 
	   wxString strInputPanelTag, bool bVolatile){
    *ppMNum = new MultiInputPanel_cls(pCParent, strInputPanelTag, bVolatile);
    return *ppMNum;
}

int CLS::
GetItemId(int index){
    wxWindow *pCWindow = mVCItem[index].mpCWindowLink;
    if (pCWindow == NULL) return -1;
    return pCWindow->GetId();
}
	
InputItem_cls& CLS::
GetRefCItem(int id){
    for (unsigned int i = 0; i < mVCItem.size(); i++)
	if (mVCItem[i].IsItemIdMatch(id) == TRUE) return mVCItem[i];

    InputItem_cls CDummy(_ITEM_BOXSIZER, "dummy", TRUE, FALSE, mItemSize);
    return CDummy;
}

void CLS::
SetColorForXYZMinMax(uint indexX, uint indexY, uint indexZ){
    ColorProvider_cls *pCClr = GCClassProvider.GetPCColorProvider();
    if (mVCItem[indexX].mVpCWindowLinkArray.size() == 0){
	mVCItem[indexX+1].SetBackgroundColour(pCClr->GetColor("ClrX"));
	mVCItem[indexX+2].SetBackgroundColour(pCClr->GetColor("ClrX"));
	mVCItem[indexY+1].SetBackgroundColour(pCClr->GetColor("ClrY"));
	mVCItem[indexY+2].SetBackgroundColour(pCClr->GetColor("ClrY"));
	mVCItem[indexZ+1].SetBackgroundColour(pCClr->GetColor("ClrZ"));
	mVCItem[indexZ+2].SetBackgroundColour(pCClr->GetColor("ClrZ"));
    }
    else{
	std::vector < wxColor > VclrX, VclrY, VclrZ;
	VclrX.push_back(pCClr->GetColor("ClrX"));
	VclrX.push_back(pCClr->GetColor("ClrX"));
	VclrY.push_back(pCClr->GetColor("ClrY"));
	VclrY.push_back(pCClr->GetColor("ClrY"));
	VclrZ.push_back(pCClr->GetColor("ClrZ"));
	VclrZ.push_back(pCClr->GetColor("ClrZ"));
	mVCItem[indexX].SetBackgroundColour(VclrX);
	mVCItem[indexY].SetBackgroundColour(VclrY);
	mVCItem[indexZ].SetBackgroundColour(VclrZ);
    }
}

void CLS::
SetColorForXYZ(uint index){
    if (mVCItem[index].mVpCWindowLinkArray.size() != 0){
	ColorProvider_cls *pCClr = GCClassProvider.GetPCColorProvider();
	std::vector < wxColour > VClr;
	VClr.push_back(pCClr->GetColor("ClrX"));
	VClr.push_back(pCClr->GetColor("ClrY"));
	VClr.push_back(pCClr->GetColor("ClrZ"));
	mVCItem[index].SetBackgroundColour(VClr);
    }
    //mVCItem[index+0].SetBackgroundColour(wxColour(255, 244, 244));
    //mVCItem[index+1].SetBackgroundColour(wxColour(244, 255, 244));
    //mVCItem[index+2].SetBackgroundColour(wxColour(244, 244, 255));
}

InputItem_cls* CLS::
GetPCInputItem(ConfItem_cls *pCConf){
    for (unsigned int i = 0; i < mVCItem.size(); i++)
	if (mVCItem[i].mpCConfItemLink == pCConf) return &mVCItem[i];
    return NULL;
}

int CLS::
CombineSizer(int itemNum, wxString strLabel, bool bEnable){
    InputItem_cls CItem(_ITEM_BOXSIZER, strLabel, bEnable, 0, FALSE);
    CItem.mItemNum = itemNum;
    CItem.mTextWidth = mTextWidth;
    mVCItem.push_back(CItem);
    return mVCItem.size() - 1;
}

void CLS::
SetLimit(double min, double max){
    mbLimit = TRUE;
    mMin = min;
    mMax = max;
}

void CLS::
SetChoiceList(unsigned int listMax, wxString *pstrChoice){
    for (unsigned int i = 0; i < listMax; i++)
	mVstrChoiceList.push_back(pstrChoice[i]);
}


void CLS::
ClearItemProperty(){
    mbLimit = FALSE;
    mMin = -1;
    mMax = -1;
    mContextMenuType = -1;
    mDragScale = 0;
    mbItemVolatile = FALSE;
}

int CLS::
CombineConfItem(ConfItem_cls& CConfItem, wxString strLabel, bool bEnable){
    //CConfItem.AppendInputPanelName(GetName());
    InputItem_cls CItem(_ITEM_CONFITEM, strLabel, bEnable, mbItemVolatile, mItemSize);
    CItem.mbLimit = mbLimit;
    CItem.mMin = mMin;
    CItem.mMax = mMax;
    if (mDragScale != 0)
	CItem.mDragScale = mDragScale;
    CItem.mTextWidth = mTextWidth;
    CItem.mpCConfItemLink = &CConfItem;
    if (mVstrChoiceList.size() != 0){
	CItem.CombineChoiceList(mVstrChoiceList);
	mVstrChoiceList.clear();
    }
    ClearItemProperty();
    mVCItem.push_back(CItem);
    return mVCItem.size() - 1;
}


int CLS::
CombineButton(int id, wxString strLabel, 
	      int width, bool bEnable){
    InputItem_cls CItem(_ITEM_BUTTON, strLabel, bEnable, FALSE, mItemSize);
    CItem.mButtonId = id;
    CItem.mButtonWidth = width;
    CItem.mContextMenuType = mContextMenuType;
    ClearItemProperty();
    mVCItem.push_back(CItem);
    return mVCItem.size() - 1;
}

int CLS::
CombineBitmapPanel(int id, wxString strLabel,
		   int width, bool bEnable){
    InputItem_cls CItem(_ITEM_BITMAPPANEL, strLabel, bEnable, FALSE, mItemSize);
    CItem.mButtonId = id;
    CItem.mButtonWidth = width;
    CItem.mContextMenuType = mContextMenuType;
    ClearItemProperty();
    mVCItem.push_back(CItem);
    return mVCItem.size() - 1;
}

void CLS::
CombineToDummy(int index, ConfItem_cls& CConfItem){
    mVCItem[index].mpCConfItemLink = &CConfItem;
    mVCItem[index].Hide();
}

void CLS::
SetHook(HookItem_cls *pCInstance,
	void (HookItem_cls::*pFunc)(wxCommandEvent& event), 
	int type, int index, wxString strCommand){
    int id = wxID_ANY;
    if (index != -1) id = GetItemId(index);
    mpCHookCtrl->SetHookItem(pCInstance, pFunc, type, id, strCommand);
}

void CLS::
SetItemSTR(int index, wxString strValue){
    ((AtoSTextCtrl_cls*)(mVCItem[index].mpCWindowLink))->SetValue(strValue);
    mVCItem[index].OnChanged(FALSE);
}

void CLS::
SyncFromGUI(){
    for (uint i = 0; i < mVCItem.size(); i++)
	mVCItem[i].OnChanged(mbVolatile);
}

void CLS::
OnItemChange(wxCommandEvent& event){
    GetRefCItem(event.GetId()).OnChanged(mbVolatile);
    mpCHookCtrl->CheckHook(event); 
}

void CLS::
OnBtnRight(wxMouseEvent& event){
    int id = event.GetId();

    InputItem_cls &CItem = GetRefCItem(id);
    if (CItem.mstrLabel.IsSameAs("dummy")) return;

    if (CItem.mContextMenuType == -1) return;

    mActiveButtonIDForMenu = id;
    wxMenu CMenu;
    switch(CItem.mContextMenuType){
    case _ITEM_MENU_COLOR:
	CMenu.Append(menuCopyColor, _("Copy Color"));
	CMenu.Append(menuPasteColor, _("Paste Color"));
	break;
    case _ITEM_MENU_COLOR_CURVE:
	CMenu.Append(menuCopyColorCurve, _("Copy Color Curve"));
	CMenu.Append(menuPasteColorCurve, _("Paste Color Curve"));
	break;
    }
    PopupMenu(&CMenu);
}

wxBoxSizer* CLS::
GetPNewSizer(wxBoxSizer *pBoxSizerSrc, InputItem_cls &CItem){

    wxBoxSizer *pCBoxSizerH = new wxBoxSizer(wxHORIZONTAL);
    wxSizerFlags sflagH(0);
    sflagH.Border(wxLEFT, 2).Expand().Align(wxLEFT);
    pBoxSizerSrc->Add(pCBoxSizerH, sflagH);
    
    if (CItem.mstrLabel.IsEmpty() != TRUE){
	wxBoxSizer* pCBoxSizerV = new wxBoxSizer(wxVERTICAL);
	wxStaticText *pCText = new wxStaticText(this, wxID_ANY, CItem.mstrLabel, wxPoint(10, 10), wxSize(CItem.mTextWidth, -1));
	wxSizerFlags sflagV(0);
	sflagV.Expand().Align(wxLEFT);
	pCBoxSizerV->AddStretchSpacer(1);
	pCBoxSizerV->Add(pCText, sflagV);
	pCBoxSizerV->AddStretchSpacer(1);
	pCBoxSizerH->Add(pCBoxSizerV, 0, wxEXPAND);
	CItem.mpCTextLabelLink = pCText;
    }

    return pCBoxSizerH;
}

void CLS::
MakeGeometry(){
    if (mpCBoxSizerSrc == NULL)
	mpCBoxSizerSrc = new wxBoxSizer(wxVERTICAL);

    wxBoxSizer *pBoxSizerCurrent = mpCBoxSizerSrc;
    int horizontalCount = 0;

    for (unsigned int i = 0; i < mVCItem.size(); i++){
	InputItem_cls& CItem = mVCItem[i];

	// ʂ̉̃TCU[pӂB
	if (CItem.mInputType == _ITEM_BOXSIZER){
	    pBoxSizerCurrent = GetPNewSizer(mpCBoxSizerSrc, CItem);
	    horizontalCount = CItem.mItemNum;
	    CItem.ConnectSizer(pBoxSizerCurrent);
	    continue;
	}

	if (CItem.mInputType == _ITEM_CONFITEM){
	    if (pBoxSizerCurrent == mpCBoxSizerSrc){
		pBoxSizerCurrent = GetPNewSizer(mpCBoxSizerSrc, CItem);
		horizontalCount = 1;
	    }
	    CItem.ConnectConfItem(pBoxSizerCurrent, this);
	    if (horizontalCount > 0){
		horizontalCount--;
		if (horizontalCount == 0) pBoxSizerCurrent = mpCBoxSizerSrc;
	    }
	}

	if (CItem.mInputType == _ITEM_BUTTON){
	    if (pBoxSizerCurrent == mpCBoxSizerSrc){
		pBoxSizerCurrent = GetPNewSizer(mpCBoxSizerSrc, CItem);
		horizontalCount = 1;
		printf("SetNewSizer %p %p\n", pBoxSizerCurrent, mpCBoxSizerSrc);
	    }
	    CItem.ConnectButton(pBoxSizerCurrent, this);
	    if (horizontalCount > 0){
		horizontalCount--;
		if (horizontalCount == 0) pBoxSizerCurrent = mpCBoxSizerSrc;
	    }
	    
	    CItem.mpCWindowLink->Connect(wxEVT_RIGHT_DOWN, wxMouseEventHandler(MultiInputPanel_cls::OnBtnRight), NULL, this);
	}

	if (CItem.mInputType == _ITEM_BITMAPPANEL){
	    if (pBoxSizerCurrent == mpCBoxSizerSrc){
		pBoxSizerCurrent = GetPNewSizer(mpCBoxSizerSrc, CItem);
		horizontalCount = 1;
		printf("SetNewSizer %p %p\n", pBoxSizerCurrent, mpCBoxSizerSrc);
	    }
	    CItem.ConnectBitmapPanel(pBoxSizerCurrent, this);
	    if (horizontalCount > 0){
		horizontalCount--;
		if (horizontalCount == 0) pBoxSizerCurrent = mpCBoxSizerSrc;
	    }

	    CItem.mpCWindowLink->Connect(wxEVT_RIGHT_DOWN, wxMouseEventHandler(MultiInputPanel_cls::OnBtnRight), NULL, this);
	}

    }

    mpCPadding = mpCBoxSizerSrc->Add(mMinWidth, -1, 0, 0);
    
    SetSizer(mpCBoxSizerSrc);
}

void CLS::
FinishSetting(){
    Hide();
    Freeze();
    MakeGeometry();
    Thaw();
    Show();
}

void CLS::
UpdateValues(int index){
    for (int i = 0; i < (int)mVCItem.size(); i++){
	if (index != _MN_ALLITEM) i = index;
	mVCItem[i].UpdateDisplay();
	if (index != _MN_ALLITEM) return;
    }
}

void CLS::
OnMenuCommand(wxCommandEvent &event){
    event.SetInt(mActiveButtonIDForMenu);
    GetParent()->GetEventHandler()->AddPendingEvent(event);
}
