// -*- c++ -*- 
// "clsScrollPanel.h"
// (setq c-basic-offset 4)

#include "clsScrollPanel.h"
#include "../../COMMON/CommonDefinitions.h"

#include <wx/dcbuffer.h>

ScrollPanel_cls::
ScrollPanel_cls()
{
    mOffsetY = 0;
    mbBarFloating = FALSE;
    mpCTgtPanel = NULL;
}

void ScrollPanel_cls::
SetTgtPanel(wxPanel *pCTgtPanel){
    mpCTgtPanel = pCTgtPanel;
}

int ScrollPanel_cls::
GetIndex(int lineHeight){
    int index = (mMouseYCurrent-mOffsetY) / lineHeight;
    if (index < 0) index = 0;
    return index;
}

int ScrollPanel_cls::
GetDragDistance(){
    return (int)sqrt((mMouseXCurrent-mMouseXAtDown)*(mMouseXCurrent-mMouseXAtDown) + (mMouseYCurrent-mMouseYAtDown)*(mMouseYCurrent-mMouseYAtDown));
}

void ScrollPanel_cls::
CheckOffsetBase(){
    
    if (mOffsetY + mVirtualHeight < mTgtPanelHeight)
	mOffsetY = mTgtPanelHeight - mVirtualHeight;
    if (mOffsetY > 0) mOffsetY = 0;
}

void ScrollPanel_cls::
LeftUpBase(wxMouseEvent& event){
    if (mpCTgtPanel->HasCapture() == TRUE) mpCTgtPanel->ReleaseMouse();
}

void ScrollPanel_cls::
MotionBase(wxMouseEvent& event, bool bDragPanel, bool bDragBar){
    if (mpCTgtPanel->HasCapture() == FALSE){
	mMouseYAtDown = event.GetY();
	mMouseYPrev = mMouseYAtDown;
	mpCTgtPanel->CaptureMouse();
    }
    
    int newy = event.GetY();
    int dy = newy - mMouseYPrev;
    if (bDragBar == TRUE){
	if (mVirtualHeight > mTgtPanelHeight)
	    mOffsetY -= (float)mVirtualHeight * dy / mTgtPanelHeight;
    }
    else if (bDragPanel == TRUE)
	mOffsetY += dy;
    CheckOffsetBase();
    mMouseYPrev = newy;
}

void ScrollPanel_cls::
LeaveBase(wxMouseEvent& event){
    mbBarFloating = FALSE;
    mpCTgtPanel->Refresh();
}

bool ScrollPanel_cls::
WheelBase(wxMouseEvent& event){
    if (event.GetWheelAxis() != wxMOUSE_WHEEL_VERTICAL) return FALSE;

    int wheelRotaion = event.GetWheelRotation();
    int wheelDelta = event.GetWheelDelta();

    int dy = 0;
    if (wheelRotaion == wheelDelta) dy = 12;
    if (wheelRotaion == -wheelDelta) dy = -12;
    if (mVirtualHeight > mTgtPanelHeight)
	mOffsetY += (float)mVirtualHeight * dy / mTgtPanelHeight;
    
    CheckOffsetBase();
    return TRUE;
}

void ScrollPanel_cls::
DrawScrollBar(wxDC& dc, bool mbDragging){
    dc.SetPen(*wxTRANSPARENT_PEN);
    if (mVirtualHeight < mTgtPanelHeight) return;

    if (mbBarSelecting == TRUE || (mbBarFloating == TRUE && mbDragging == FALSE))
	dc.SetBrush(wxColour(240, 240, 240));
    else
	dc.SetBrush(wxColour(96, 96, 96));
    int y0 = (-mOffsetY) * mTgtPanelHeight / mVirtualHeight;
    double heightRate = (double)(-mOffsetY+mTgtPanelHeight) / mVirtualHeight;
    int y1 = heightRate * mTgtPanelHeight;
    dc.DrawRectangle(mTgtPanelWidth-10, y0, 4, y1-y0);
}
