// (setq c-basic-offset 4)
// "clsAutoComplete.h"

#include "clsAutoComplete.h"

#include "../../COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;

#include "../../SCENEOBJ/clsSceneObjCtrl.h"

#include "../../COMMON/CommonDefinitionsWX.h"

DictionaryItem_cls::
DictionaryItem_cls(wxString strTag, Dictionary_cls* pCChild){
    mstrTag = strTag;
    mpCChild = pCChild;
}

DictionaryItem_cls::
~DictionaryItem_cls(){
    if (mpCChild != NULL) delete mpCChild;
}

Dictionary_cls::
~Dictionary_cls(){
    Clear();
}

void Dictionary_cls::
Clear(){
    int num = mVpCItem.size();
    for (int i = 0; i < num; i++) delete mVpCItem[i];
    mVpCItem.clear();
}


void Dictionary_cls::
PushItem(wxString strTag, Dictionary_cls* pCChild){
    mVpCItem.push_back(new DictionaryItem_cls(strTag, pCChild));
}

bool Dictionary_cls::
CompareTagAndInput(wxString strTag, wxString strInput){
    wxString strLast = strTag.Right(1);
    if (strInput.IsSameAs(strTag)) return TRUE;

    if (strInput.Find(strTag) == 0){
	if (strTag.Right(1).IsSameAs("(") &&
	    strInput.Right(1).IsSameAs(")"))
	    return TRUE;
    }

    return FALSE;
}


wxArrayString Dictionary_cls::
FindCadidates(wxArrayString AstrInput, int depth, int &pos){
    if (depth >= AstrInput.GetCount()){
	wxArrayString AstrCandidate;
	int num = mVpCItem.size();
	for (int i = 0; i < num; i++) AstrCandidate.Add(mVpCItem[i]->mstrTag);
	pos = 0;
	return AstrCandidate;
    }
    wxString strInput = AstrInput[depth];
    wxArrayString AstrCandidate;
    int num = mVpCItem.size();
    for (int i = 0; i < num; i++){
	wxString strTag = mVpCItem[i]->mstrTag;
	wxString strLast = strTag.Right(1);
	if (CompareTagAndInput(strTag, strInput) == TRUE/*strTag.IsSameAs(strInput)*/){
	    if (mVpCItem[i]->mpCChild == NULL)
		AstrCandidate.Add(mVpCItem[i]->mstrTag);
	    else
		return mVpCItem[i]->mpCChild->FindCadidates(AstrInput, depth+1, pos);
	}
	else if (strTag.Find(strInput) == 0){
	    wxString strCandidate = mVpCItem[i]->mstrTag;
	    if (mVpCItem[i]->mpCChild != NULL && strLast.IsSameAs("(") == FALSE){
		strCandidate << wxT(".");
	    }
	    AstrCandidate.Add(strCandidate);
	}
    }

    int candid = AstrCandidate.GetCount();
    if (candid == 0) { pos = 0; return AstrCandidate; }
    if (candid == 1) { pos = AstrCandidate[0].Length(); return AstrCandidate; }
    
    bool breaker = FALSE;
    pos = 0;
    int length0 = AstrCandidate[0].Length();
    while(pos < length0){
	wxString strBase = AstrCandidate[0].Mid(pos, 1);
	for (int i = 1; i < candid; i++){
	    if (AstrCandidate[i].Mid(pos, 1).IsSameAs(strBase) == FALSE){
		breaker = TRUE; break;
	    }
	}
	if (breaker == TRUE) break;
	pos++;
    }

    return AstrCandidate;
}

// ----

#define CLS AutoComplete_cls 

CLS::
AutoComplete_cls(int type){
    if (type == _AUTO_COMPLETE_LUA)
	InitializeLua();
    if (type == _AUTO_COMPLETE_GLSL)
	InitializeGLSL();
}

void CLS::
UpdateDirectoryObject(){
    wxArrayString CAObjectName;
    GCClassProvider.GetPCSceneObjCtrl()->GetAllObjectsName(CAObjectName);
    mCDictionaryObject.Clear();
    int num = CAObjectName.Count();
    for (int i = 0; i < num; i++)
	mCDictionaryObject.PushItem(CAObjectName[i]);
    mCDictionaryObject.PushItem("Position");
    mCDictionaryObject.PushItem("Rotation");
    mCDictionaryObject.PushItem("Scale");
}

int CLS::
GetStrCount(wxString strLine, wxString strItem){
    int count = 0;
    while (TRUE){
	int pos = strLine.Find(strItem);
	if (pos == wxNOT_FOUND) return count;
	count++;
	strLine = strLine.Mid(pos+1);
    }
}

int CLS::
FindUnclosed(wxString strLine, wxString strOpen, wxString strClose){
    if (strOpen.IsSameAs(strClose)){
	int openCount = GetStrCount(strLine, strOpen);
	if (openCount == 1) return strLine.Find(strOpen);
	if (openCount % 2 == 1){
	    int pos = strLine.Find(strOpen);
	    return pos+1 + strLine.Mid(pos+1).Find(strOpen);
	}
	return wxNOT_FOUND;
    }
    int openCount = GetStrCount(strLine, strOpen);
    int closeCount = GetStrCount(strLine, strClose);
    if (openCount > closeCount) return strLine.Find(strOpen);
    return wxNOT_FOUND;
}

int CLS::
FindUnquoted(wxString strLine, wxString strItem){
    int findPos = strLine.Find(strItem);
    if (findPos != wxNOT_FOUND){
	wxString strMid = strLine.Mid(0, findPos);
	int count = GetStrCount(strMid, "\"");
	if (count % 2 == 1) return wxNOT_FOUND;
	int openCount = GetStrCount(strMid, "(");
	int closeCount = GetStrCount(strMid, ")");
	if (openCount > closeCount) return wxNOT_FOUND;
    }
    return findPos;
}

int CLS::
FindLuaDelimiters(wxString strLine, int wordHead){
    wxString strMid = strLine.Mid(wordHead);
    int findPos = wxNOT_FOUND;
    if (findPos == wxNOT_FOUND) findPos = strMid.Find(wxT("\t"));
    //if (findPos == wxNOT_FOUND)	findPos = strMid.Find(wxT("("));
    //if (findPos == wxNOT_FOUND)	findPos = strMid.Find(wxT(")"));
    if (findPos == wxNOT_FOUND)	findPos = strMid.Find(wxT("{"));
    if (findPos == wxNOT_FOUND)	findPos = strMid.Find(wxT("}"));
    //if (findPos == wxNOT_FOUND)	findPos = strMid.Find(wxT(","));
    if (findPos == wxNOT_FOUND)	findPos = strMid.Find(wxT("="));
    if (findPos == wxNOT_FOUND)	findPos = strMid.Find(wxT(";"));
    if (findPos == wxNOT_FOUND) findPos = FindUnclosed(strMid, "\"", "\"");
    if (findPos == wxNOT_FOUND) findPos = FindUnquoted(strMid, " ");
    return findPos;
}

int CLS::
GetWordHead(wxString strLine, int cursorPos){
    int wordHead = 0;
    wxString strUptoCursor = strLine.Mid(0, cursorPos);
    while (TRUE){
	int findPos = FindLuaDelimiters(strUptoCursor, wordHead);

	if (findPos == wxNOT_FOUND) break;
	else wordHead += findPos + 1;
    }
    return wordHead;
}

void CLS::
InitializeLua(){
    Dictionary_cls *pCOpsActiveObj = new Dictionary_cls;
    pCOpsActiveObj->PushItem("Delete()");
    pCOpsActiveObj->PushItem("Rename(");
    pCOpsActiveObj->PushItem("GetVisibility()");
    pCOpsActiveObj->PushItem("GetValid()");
    pCOpsActiveObj->PushItem("GetShy()");
    pCOpsActiveObj->PushItem("SetVisibility(");
    pCOpsActiveObj->PushItem("SetValidity(");
    pCOpsActiveObj->PushItem("SetShy(");
    pCOpsActiveObj->PushItem("GetParameterLink(\"");
    pCOpsActiveObj->PushItem("SetParameterLink(\"");
    
    Dictionary_cls *pCOpsSelectedObj = new Dictionary_cls;
    pCOpsSelectedObj->PushItem("Delete()");
    pCOpsSelectedObj->PushItem("MoveTo(");
    pCOpsSelectedObj->PushItem("SetChildTo(");
    pCOpsSelectedObj->PushItem("SetVisibility(");
    pCOpsSelectedObj->PushItem("SetValidity(");
    
    Dictionary_cls *pCOps = new Dictionary_cls;
    pCOps->PushItem("ActiveObj", pCOpsActiveObj);
    pCOps->PushItem("AddPrimitive(");
    pCOps->PushItem("AddCamera(");
    pCOps->PushItem("AddLight(");
    pCOps->PushItem("AddMesh(");
    pCOps->PushItem("AddEmpty(");
    pCOps->PushItem("AddWorld(");
    pCOps->PushItem("AddVolumeBox(");
    pCOps->PushItem("AddParticle(");
    pCOps->PushItem("AddStreamline(");
    pCOps->PushItem("AddHeightField(");
    pCOps->PushItem("DeleteObject(");
    pCOps->PushItem("SelectObject(");
    pCOps->PushItem("DeselectObject(");
    pCOps->PushItem("SetVisibility(");
    pCOps->PushItem("SetValidity(");
    pCOps->PushItem("SelectedObject", pCOpsSelectedObj);
    
    Dictionary_cls *pCParamGroup = new Dictionary_cls;
    pCParamGroup->PushItem("GetDimension()");
    pCParamGroup->PushItem("GetValueAt");
    pCParamGroup->PushItem("SetValueAt");
    pCParamGroup->PushItem("GetLink");
    pCParamGroup->PushItem("SetLink");
    pCParamGroup->PushItem("GetShy");
    pCParamGroup->PushItem("SetShy");
    pCParamGroup->PushItem("GetUseExpression");
    pCParamGroup->PushItem("SetUseExpression");
    pCParamGroup->PushItem("GetExpression");
    pCParamGroup->PushItem("SetExpression");
    pCParamGroup->PushItem("GetTimeDependency");
    pCParamGroup->PushItem("SetTimeDependency");

    Dictionary_cls *pCObjectAttrib = new Dictionary_cls;
    pCObjectAttrib->PushItem("GetConfList()");
    pCObjectAttrib->PushItem("GetConfItem(");

    Dictionary_cls *pCObject = new Dictionary_cls;
    pCObject->PushItem("GetShy()");
    pCObject->PushItem("SetShy(");
    pCObject->PushItem("GetVisibility()");
    pCObject->PushItem("SetVisibility(");
    pCObject->PushItem("GetValidity()");
    pCObject->PushItem("SetValidity(");
    pCObject->PushItem("GetConfList()");
    pCObject->PushItem("GetConfItem(");
    pCObject->PushItem("GetAttribList()");
    pCObject->PushItem("GetAttrib(", pCObjectAttrib);
    
    Dictionary_cls *pCData = new Dictionary_cls;
    pCData->PushItem("GetName(");
    pCData->PushItem("GetActiveObject(");
    pCData->PushItem("GetParent(");
    pCData->PushItem("GetChild(");
    pCData->PushItem("GetChildList(");
    pCData->PushItem("GetPosition(");
    pCData->PushItem("GetRotationEuler(");
    pCData->PushItem("GetScale(");
    pCData->PushItem("Object(", pCObject);
    pCData->PushItem("ParamGroup(", pCParamGroup);
    
    Dictionary_cls *pCThis = new Dictionary_cls;
    pCThis->PushItem("GetValueAt");
    pCThis->PushItem("GetKeyNum");
    
    Dictionary_cls *pCString = new Dictionary_cls;
    pCString->PushItem("byte");
    pCString->PushItem("char");
    pCString->PushItem("dump");
    pCString->PushItem("find");
    pCString->PushItem("format");
    pCString->PushItem("gmatch");
    pCString->PushItem("gsub");
    pCString->PushItem("len");
    pCString->PushItem("lower");
    pCString->PushItem("match");
    pCString->PushItem("rep");
    pCString->PushItem("reverse");
    pCString->PushItem("sub");
    pCString->PushItem("upper");

    Dictionary_cls *pCMath = new Dictionary_cls;
    pCMath->PushItem("abs");
    pCMath->PushItem("acos");
    pCMath->PushItem("asin");
    pCMath->PushItem("atan");
    pCMath->PushItem("ceil");
    pCMath->PushItem("cos");
    pCMath->PushItem("deg");
    pCMath->PushItem("exp");
    pCMath->PushItem("floor");
    pCMath->PushItem("fmod");
    pCMath->PushItem("huge");
    pCMath->PushItem("log");
    pCMath->PushItem("max");
    pCMath->PushItem("maxinteger");
    pCMath->PushItem("min");
    pCMath->PushItem("mininterger");
    pCMath->PushItem("modf");
    pCMath->PushItem("pi");
    pCMath->PushItem("rad");
    pCMath->PushItem("random");
    pCMath->PushItem("randomseed");
    pCMath->PushItem("sin");
    pCMath->PushItem("sqrt");
    pCMath->PushItem("tan");
    pCMath->PushItem("tointeger");
    pCMath->PushItem("type");
    pCMath->PushItem("ult");

    Dictionary_cls *pCTable = new Dictionary_cls;
    pCTable->PushItem("concat");
    pCTable->PushItem("insert");
    pCTable->PushItem("pack");
    pCTable->PushItem("remove");
    pCTable->PushItem("sort");
    pCTable->PushItem("unpack");
    
    mCDictionaryRoot.PushItem("Ops", pCOps);
    mCDictionaryRoot.PushItem("Data", pCData);
    mCDictionaryRoot.PushItem("This", pCThis);
    mCDictionaryRoot.PushItem("assert");
    mCDictionaryRoot.PushItem("break");
    mCDictionaryRoot.PushItem("collectgarbage");
    mCDictionaryRoot.PushItem("do");
    mCDictionaryRoot.PushItem("else");
    mCDictionaryRoot.PushItem("elseif");
    mCDictionaryRoot.PushItem("end");
    mCDictionaryRoot.PushItem("error");
    mCDictionaryRoot.PushItem("for");
    mCDictionaryRoot.PushItem("function");
    mCDictionaryRoot.PushItem("if");
    mCDictionaryRoot.PushItem("ipairs");
    mCDictionaryRoot.PushItem("local");
    mCDictionaryRoot.PushItem("load");
    mCDictionaryRoot.PushItem("loadfile");
    mCDictionaryRoot.PushItem("math", pCMath);
    mCDictionaryRoot.PushItem("next");
    mCDictionaryRoot.PushItem("pairs");
    mCDictionaryRoot.PushItem("print");
    mCDictionaryRoot.PushItem("repeat");
    mCDictionaryRoot.PushItem("return");
    mCDictionaryRoot.PushItem("rawequal");
    mCDictionaryRoot.PushItem("rawget");
    mCDictionaryRoot.PushItem("rawlen");
    mCDictionaryRoot.PushItem("rawset");
    mCDictionaryRoot.PushItem("select");
    mCDictionaryRoot.PushItem("string", pCString);
    mCDictionaryRoot.PushItem("table", pCTable);
    mCDictionaryRoot.PushItem("then");
    mCDictionaryRoot.PushItem("tonumber");
    mCDictionaryRoot.PushItem("tostring");
    mCDictionaryRoot.PushItem("type");
    mCDictionaryRoot.PushItem("until");
    mCDictionaryRoot.PushItem("while");
}

void CLS::
InitializeGLSL(){
    Dictionary_cls *pCFog = new Dictionary_cls;
    pCFog->PushItem("color");
    pCFog->PushItem("density");
    pCFog->PushItem("end");
    pCFog->PushItem("start");

    Dictionary_cls *pCFrontMaterial = new Dictionary_cls;
    pCFrontMaterial->PushItem("shininess");
    
    mCDictionaryRoot.PushItem("ambient"); //
    mCDictionaryRoot.PushItem("auto");
    mCDictionaryRoot.PushItem("break");
    mCDictionaryRoot.PushItem("case");
    mCDictionaryRoot.PushItem("char");
    mCDictionaryRoot.PushItem("clamp"); // 
    mCDictionaryRoot.PushItem("const");
    mCDictionaryRoot.PushItem("constantAttenuation"); //
    mCDictionaryRoot.PushItem("continue");
    mCDictionaryRoot.PushItem("default");
    mCDictionaryRoot.PushItem("diffuse"); //
    mCDictionaryRoot.PushItem("do");
    mCDictionaryRoot.PushItem("dot"); //
    mCDictionaryRoot.PushItem("double");
    mCDictionaryRoot.PushItem("else");
    mCDictionaryRoot.PushItem("enum");
    mCDictionaryRoot.PushItem("extern");
    mCDictionaryRoot.PushItem("float");
    mCDictionaryRoot.PushItem("for");
    mCDictionaryRoot.PushItem("gl_FragCoord"); //
    mCDictionaryRoot.PushItem("gl_FragColor"); //
    mCDictionaryRoot.PushItem("gl_FrontLightProduct"); //
    mCDictionaryRoot.PushItem("gl_FrontMaterial", pCFrontMaterial); //
    mCDictionaryRoot.PushItem("gl_LightSource"); //
    mCDictionaryRoot.PushItem("gl_Fog", pCFog); //
    
    mCDictionaryRoot.PushItem("if");
    mCDictionaryRoot.PushItem("int");
    mCDictionaryRoot.PushItem("linearAttenuation"); //
    mCDictionaryRoot.PushItem("length"); //
    mCDictionaryRoot.PushItem("long");
    mCDictionaryRoot.PushItem("mix"); //
    mCDictionaryRoot.PushItem("normalize"); //
    mCDictionaryRoot.PushItem("position"); //
    mCDictionaryRoot.PushItem("quadraticAttenuation"); //
    mCDictionaryRoot.PushItem("register");
    mCDictionaryRoot.PushItem("return");
    mCDictionaryRoot.PushItem("short");
    mCDictionaryRoot.PushItem("signed");
    mCDictionaryRoot.PushItem("sizeof");
    mCDictionaryRoot.PushItem("specluar"); //
    mCDictionaryRoot.PushItem("spotDirection"); //
    mCDictionaryRoot.PushItem("static");
    mCDictionaryRoot.PushItem("struct");
    mCDictionaryRoot.PushItem("switch");
    mCDictionaryRoot.PushItem("texture2D"); //
    mCDictionaryRoot.PushItem("typedef");
    mCDictionaryRoot.PushItem("union");
    mCDictionaryRoot.PushItem("uniform"); //
    mCDictionaryRoot.PushItem("unsigned");
    mCDictionaryRoot.PushItem("varying"); //
    mCDictionaryRoot.PushItem("vec3"); //
    mCDictionaryRoot.PushItem("vec4"); //
    mCDictionaryRoot.PushItem("void");
    mCDictionaryRoot.PushItem("volatile");
    mCDictionaryRoot.PushItem("while");
}

wxString CLS::
AutoComplete(wxString strLine, int cursorPos, 
	     wxArrayString &AstrCandidatesShort,
	     wxArrayString &AstrCandidatesLong,
	     wxString &strInitWord){

    int headPos = GetWordHead(strLine, cursorPos);

    wxString strDelimiter = wxES;
    if (headPos > 0)
	strDelimiter = strLine.Mid(headPos-1, 1);

    if (headPos != wxNOT_FOUND)
	strInitWord = strLine.Mid(headPos, cursorPos-headPos);
    else
	strInitWord = strLine;
    wxString strInitWordCpy = strInitWord;

    bool bObjectName = FALSE;
    Dictionary_cls *pCDictionary = &mCDictionaryRoot;
    if (strDelimiter.IsSameAs(wxT("\""))){
	pCDictionary = &mCDictionaryObject;
	UpdateDirectoryObject();
	bObjectName = TRUE;
    }

    wxArrayString CAString;
    if (bObjectName == TRUE){
	// IuWFNg̃Xg̎.Ƃ֌WȂ̂ł̂܂܋Lq
	CAString.Add(strInitWordCpy);
    }
    else
	while (strInitWordCpy.IsEmpty() == FALSE)
	    CAString.Add(PopStrItemFromStrLine(strInitWordCpy, wxT(".")));
    
    int pos;
    AstrCandidatesShort = pCDictionary->FindCadidates(CAString, 0, pos);
    AstrCandidatesLong = AstrCandidatesShort;
    
    if (AstrCandidatesShort.GetCount() == 0) return wxES;
    
    wxString strCandit = AstrCandidatesShort[0].Mid(0, pos);
    
    // IuWFNg̃Xg̎.Ƃ֌WȂ̂ł̂܂ܕԂB
    if (bObjectName == TRUE) return strCandit;
    
    // math.sin Ȃǂ̏ꍇ͍Ō . ܂ł̏ċA
    wxString strCompleted;
    int num = CAString.GetCount();
    if (num > 0 && CAString[num-1].IsSameAs(strCandit) == FALSE &&
	strInitWord.Mid(strInitWord.Length()-1, 1).IsSameAs(wxT(".")) == TRUE) num++;
    
    int canditNum = AstrCandidatesLong.GetCount();
    for (int j = 0; j < canditNum; j++){
	AstrCandidatesLong[j].Clear();
	for (int i = 0; i < num - 1; i++)
	    AstrCandidatesLong[j] << CAString[i] << wxT(".");
	AstrCandidatesLong[j] << AstrCandidatesShort[j];
    }
    for (int i = 0; i < num - 1; i++) strCompleted << CAString[i] << wxT(".");
    strCompleted << strCandit;

    return strCompleted;
}

AutoComplete_cls *GpCAutoCompleteLua = NULL;
AutoComplete_cls *GpCAutoCompleteGLSL = NULL;
