// (setq c-basic-offset 4)
// "clsAutoComplete.cpp"

#ifndef _AUTO_COMPLETE_H_
#define _AUTO_COMPLETE_H_

#include "../../FILEIO/clsParser.h"

#include <vector>

#define _AUTO_COMPLETE_LUA 0
#define _AUTO_COMPLETE_GLSL 1

class Dictionary_cls;

class DictionaryItem_cls{
 public:
    DictionaryItem_cls(wxString strTag, Dictionary_cls* pCChild);
    ~DictionaryItem_cls();

    wxString mstrTag;
    Dictionary_cls *mpCChild;
};

class Dictionary_cls{
 public:
    ~Dictionary_cls();
    std::vector < DictionaryItem_cls* > mVpCItem;

    void Clear();
    void PushItem(wxString strTag, Dictionary_cls* pCChild = NULL);

    bool CompareTagAndInput(wxString strTag, wxString strInput);
    wxArrayString FindCadidates(wxArrayString AstrInput, int depth, int &pos);
};

class AutoComplete_cls : public Parser_cls {
 public:
    AutoComplete_cls(int type);
    
    void InitializeLua();
    void InitializeGLSL();

    Dictionary_cls mCDictionaryRoot;
    Dictionary_cls mCDictionaryObject;

    void UpdateDirectoryObject();
    int GetStrCount(wxString strLine, wxString strItem);
    int FindUnclosed(wxString strLine, wxString strOpen, wxString strClose);
    int FindUnquoted(wxString strLine, wxString strItem);
    int FindLuaDelimiters(wxString strLine, int wordHead);
    int GetWordHead(wxString strLine, int cursorPos);
    wxString AutoComplete(wxString strLine, int cursorPos, 
			  wxArrayString &AstrCandidatesShort, 
			  wxArrayString &AstrCandidatesLong,
			  wxString &strInitWord);

    
};

#endif
