// (setq c-basic-offset 4)
// "clsConsoleCtrl.cpp"

#ifndef _CONSOLE_CTRL_H_
#define _CONSOLE_CTRL_H_

#define _CONSOLE_LUA_CONSOLE 0
#define _CONSOLE_UNDO 1
#define _CONSOLE_REDO 2
#define _CONSOLE_WINDOWS 3
#define _CONSOLE_WXLOG 4

#include "clsTextEntryBase.h"
#include "clsTextEntryMarkup.h"
#include "clsTextEntryPopup.h"

#include "../../COMMON/clsGetPC.h"

#include "../EX/wxPanelEX.h"

#include <vector>

class wxRichTextCtrl;
class LuaBase_cls;
struct lua_State;
class TextButton_cls;

class ConsoleCtrl_cls : public wxPanelEX, public TextEntryBase_cls, public TextEntryMarkup_cls, public GetPC_cls {
 public:
    ConsoleCtrl_cls(wxWindow *pCParent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxTAB_TRAVERSAL);
    ~ConsoleCtrl_cls();

    wxComboBox *mpCComboSelector;
    TextButton_cls *mpCTextMenuLog;

    LuaBase_cls *mpCLua;
    
    wxString mAstrSelctor[5];

    int mMode;
    wxString mstrOneLiner;
    std::vector < wxString > mVstrHistory;
    int mHistory;
    
    void CallHistory(int direction);
    void ProcessCompletion(wxString strComplete = wxES);
    void ProcessOneLiner();
    void ProcessEnter();

    void OnKey(wxKeyEvent& event);
    //void ShowUndo(wxCommandEvent& event);
    void ShowLua(wxCommandEvent& event);

    void UpdatePanels(const wxString& strPanelTag);

    void OnComboBox(wxCommandEvent& event);
    void OnMenuLog(wxCommandEvent& event);
    void OnMenuLogClear(wxCommandEvent& event);
    void OnMenuLogUpdate(wxCommandEvent& event);
    void OnCharHook(wxKeyEvent& event);
    void OnChar(wxKeyEvent& event);
    void OnPopMenu(wxCommandEvent& event);
    void OnTimer(wxTimerEvent& event);
    void OnIdle(wxIdleEvent& event);

    DECLARE_EVENT_TABLE();
};

#endif
