// (setq c-basic-offset 4)
// "clsTextEntryBase.cpp"

#include "clsTextEntryBase.h"
#include "clsAutoComplete.h"

#include "../../COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;
#include "../../WIDGETCTRL/WX/clsColorProvider.h"

#define CLS TextEntryBase_cls

CLS::
TextEntryBase_cls(wxWindow *pCParent){
    mpCTempTextCtrl = new wxTextCtrl
	(pCParent, wxID_ANY, wxES, wxDP, wxSize(0, 0));
    mpCTextCtrl = new wxRichTextCtrl
	(pCParent, wxID_ANY, wxES, wxDPS, 
	 wxTE_MULTILINE | wxTE_PROCESS_TAB | wxWANTS_CHARS);
    ColorProvider_cls::SetBGColor(mpCTextCtrl, "TextPanel");
}

CLS::
TextEntryBase_cls(){
}

void CLS::
SetToDefaultAttr(){
    wxTextPos last = mpCTextCtrl->GetLastPosition();
    last++;
    mpCTextCtrl->SetStyleEx(wxRichTextRange(0, last), mCTextAttrDefault);
}

int CLS::
GetInsertionPointXY(long *posX, long *posY){
    int pos = mpCTextCtrl->GetInsertionPoint();
    mpCTextCtrl->PositionToXY(pos, posX, posY);
    return mpCTextCtrl->GetLineLength(*posY);
}

void CLS::
ReplaceLine(wxString strNewLine){
    int pos = mpCTextCtrl->GetInsertionPoint();
    long posX, posY;
    int lineLength = GetInsertionPointXY(&posX, &posY);
    int pos0 = mpCTextCtrl->XYToPosition(0, posY);
    int pos1 = mpCTextCtrl->XYToPosition(lineLength, posY);

    mpCTextCtrl->Replace(pos0, pos1, strNewLine/*.Mid(lineLength)*/);
}

void CLS::
ProcessCompletion(AutoComplete_cls *pCAutoComplete, wxString strComplete){
    
    int pos = mpCTextCtrl->GetInsertionPoint();
    long posX, posY;
    GetInsertionPointXY(&posX, &posY);
    wxString line = mpCTextCtrl->GetLineText(posY);
    
    wxArrayString AstrCandidatesShort, AstrCandidatesLong;
    wxString strInitWord;
    if (strComplete.IsEmpty() == TRUE){
	strComplete = pCAutoComplete->AutoComplete(line, posX, AstrCandidatesShort, AstrCandidatesLong, strInitWord);
	
	if (strComplete.IsSameAs(strInitWord) == TRUE){
	    if (AstrCandidatesShort.GetCount() > 1)
		mCPopup.Popup(AstrCandidatesShort, AstrCandidatesLong,
			      mpCTextCtrl);
	    else
		mpCTextCtrl->WriteText(" ");
	    return; 
	}
    }
    
    if (strComplete.IsEmpty() == TRUE){
	mpCTextCtrl->WriteText(" ");
	return;
    }
    
    int wordHead = pCAutoComplete->GetWordHead(line, posX);
    wxString strNewLine = line.Mid(0, wordHead) + strComplete + line.Mid(posX);
    int newPosX = posX + strComplete.Length() - (posX - wordHead);
    
    ReplaceLine(strNewLine);
    int newPos = mpCTextCtrl->XYToPosition(newPosX, posY);
    mpCTextCtrl->SetInsertionPoint(newPos);
}

void CLS::
ProcessCompletionLua(wxString strComplete){
    ProcessCompletion(GCClassProvider.GetPCAutoCompleteLua(), strComplete);
}

void CLS::
ProcessCompletionGLSL(wxString strComplete){
    ProcessCompletion(GCClassProvider.GetPCAutoCompleteGLSL(), strComplete);
}
