// (setq c-basic-offset 4)
// "clsTextEntryCtrl.cpp"

#ifndef _TEXT_ENTRY_CTRL_H_
#define _TEXT_ENTRY_CTRL_H_

#define _TEXT_LUA_SCRIPT 0
#define _TEXT_GLSL 1
#define _TEXT_TEXT 2

#include "../../COMMON/clsClassProvider.h"
#include "../../CONFITEM/clsConfListContainer.h"
#include "../../FILEIO/clsParser.h"
#include "../../INPUTMETHOD/clsSelectorPopup.h"
#include "clsTextEntryBase.h"
#include "clsTextEntryMarkup.h"

#include "../EX/wxPanelEX.h"

class wxRichTextCtrl;
class LuaBase_cls;
struct lua_State;

class wxSplitterWindow;

class TextEntryCtrl_cls : public wxPanelEX, public GetPC_cls, public ConfListContainer_cls, public Parser_cls, public TextEntryBase_cls, public TextEntryMarkup_cls {
 public:
    TextEntryCtrl_cls(wxWindow *pCParent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxTAB_TRAVERSAL);
    ~TextEntryCtrl_cls();

    wxComboBox *mpCComboSelector;
    wxTextAttr mCTextAttrDefault, mCTextAttrMarkup;
    wxStaticText *mpCLinkedParamGroup;

    wxSplitterWindow *mpCSplitterWindow;
    
    wxStaticText *mpCMessage;
    
    ConfItemSTR_cls mCstrLinkedItem; //Paramgroup or ConfItemSTR
    ConfItemBOOL_cls mCbPinned;

    LuaBase_cls *mpCLua;

    wxString mAstrSelctor[3];
    int mMode;
    
    void SetToDefaultParam();

    SelectorPopup_cls mCSelector;

    void CallHistory(int direction);
    void ProcessCompletion(wxString strComplete = wxES);

    void OnKey(wxKeyEvent& event);
    void OnPinMode(wxCommandEvent& event);
    void OnDropDown(wxCommandEvent& event);
    void OnTextClear(wxCommandEvent& event);
    void OnTextUndo(wxCommandEvent& event);
    void OnTextRedo(wxCommandEvent& event);
    void OnTextCopy(wxCommandEvent& event);
    void OnTextCut(wxCommandEvent& event);
    void OnTextPaste(wxCommandEvent& event);
    void OnTextOpen(wxCommandEvent& event);
    void OnTextSave(wxCommandEvent& event);
    void OnTextApply(wxCommandEvent& event);
    void ShowUndo(wxCommandEvent& event);
    void ShowLua(wxCommandEvent& event);

    void Reconnect();
    void ProcAfterMath(const wxString& strCommand, wxString strItem, bool bForce = FALSE);
    void UpdatePanels(const wxString& strPanelTag);

    void OnComboBox(wxCommandEvent& event);
    void OnCharHook(wxKeyEvent& event);
    void OnChar(wxKeyEvent& event);
    void OnPopMenuText(wxCommandEvent& event);
    void OnPopMenu(wxCommandEvent& event);
    void OnTimer(wxTimerEvent& event);
    void OnIdle(wxIdleEvent& event);

    void Serialize(wxString& strOut);
    void ReadStrLine(std::wistream &istream, wxString strFirstItem, wxString strLine);

    DECLARE_EVENT_TABLE();
};

#endif
