// (setq c-basic-offset 4)
// "clsTextEntryMarkup.h"

#include "clsTextEntryMarkup.h"

#include <wx/richtext/richtextctrl.h>

#define CLS TextEntryMarkup_cls 

CLS::
TextEntryMarkup_cls(){
    mbMarkParenthesis = FALSE;
    mMarked = -1;
    mpCTextCtrlLink = NULL;
    mCTextAttrMarkup.SetBackgroundColour(wxColour(128, 128, 128));
}

void CLS::
SetPMarkupRichTextCtrl(wxRichTextCtrl *pCTextCtrl){
    mpCTextCtrlLink = pCTextCtrl;
}

void CLS::
ProcessParensesis(){
    int pos = mpCTextCtrlLink->GetInsertionPoint();
    if (pos < 1) return;
    wxString strLast = mpCTextCtrlLink->GetRange(pos-1, pos);
    if (strLast.IsSameAs(")") || strLast.IsSameAs("]") || strLast.IsSameAs("}")){
	int posSearch = pos-1;
	wxArrayString AstrStack;
	while ( posSearch >= 0){
	    wxString strSearch = mpCTextCtrlLink->GetRange(posSearch, posSearch+1);
	    if (strSearch.IsSameAs(")")) AstrStack.Add(wxT(")"));
	    if (strSearch.IsSameAs("]")) AstrStack.Add(wxT("]"));
	    if (strSearch.IsSameAs("}")) AstrStack.Add(wxT("}"));
	    if (strSearch.IsSameAs("(")){
		if (AstrStack.Last().IsSameAs(")")) AstrStack.pop_back();
	    }
	    if (strSearch.IsSameAs("[")){
		if (AstrStack.Last().IsSameAs("]")) AstrStack.pop_back();
	    }
	    if (strSearch.IsSameAs("{")){
		if (AstrStack.Last().IsSameAs("}")) AstrStack.pop_back();
	    }
	    if (AstrStack.GetCount() == 0) break;
	    posSearch--;
	}
	if (posSearch != -1){
	    wxRichTextRange CRange(posSearch, posSearch+1);
	    mpCTextCtrlLink->GetStyle(posSearch, mCTextAttrMarkupBefore);
	    if (mCTextAttrMarkupBefore.GetBackgroundColour() == wxNullColour)
		mCTextAttrMarkupBefore.SetBackgroundColour(mpCTextCtrlLink->GetBackgroundColour());
	    
	    mpCTextCtrlLink->SetStyleEx(CRange, mCTextAttrMarkup);
	    mMarked = posSearch;
	    mCTimerMarkup.StartOnce(500);
	}
    }
}

void CLS::
ClearMark(){
    wxRichTextRange CRange(mMarked, mMarked+1);
    mpCTextCtrlLink->SetStyleEx(CRange, mCTextAttrMarkupBefore);
    mMarked = -1;
}

void CLS::
ProcMarkupCharHook(){
    if (mMarked != -1) ClearMark();
}

void CLS::
ProcMarkupChar(wxKeyEvent &event){
    int keyCode = event.GetKeyCode();
    if (keyCode == ')' || keyCode == ']' || keyCode == '}' )
	mbMarkParenthesis = TRUE;
}

void CLS::
ProcMarkupTimer(){
    if (mMarked != -1) ClearMark();
}

void CLS::
ProcMarkupIdle(){
    if (mbMarkParenthesis == TRUE){
	ProcessParensesis();
	mbMarkParenthesis = FALSE;
    }
}
