// (setq c-basic-offset 4)
// "clsColorCurveProvider.cpp"

#include "clsColorCurveProvider.h"
#include "../../SCENEOBJ/DATAVIEWER/clsColorCurve.h"

#define CLS ColorCurveProvider_cls

CLS::
ColorCurveProvider_cls(){
    SetToDefault();
}

void CLS::
SetToDefault(){
    wxArrayString mAstrItem;
    mAstrItem.push_back("R");
    mAstrItem.push_back("G");
    mAstrItem.push_back("B");
    mAstrItem.push_back("A");
    mpCColorCurve[0] = new ColorCurve_cls("Red Yellow", mAstrItem);
    double clrInit0[2][5] = {{0, 1, 0, 0, 0},
			     {1, 1, 1, 0, 1}};
    mpCColorCurve[0]->SetInitKeyframes(2, clrInit0);

    mpCColorCurve[1] = new ColorCurve_cls("Green Red", mAstrItem);
    double clrInit1[2][5] = {{0, 0, 1, 0, 0},
			     {1, 1, 0, 0, 1}};
    mpCColorCurve[1]->SetInitKeyframes(2, clrInit1);

    mpCColorCurve[2] = new ColorCurve_cls("Black White", mAstrItem);
    double clrInit2[2][5] = {{0, 0, 0, 0, 0},
			     {1, 1, 1, 1, 1}};
    mpCColorCurve[2]->SetInitKeyframes(2, clrInit2);

    mpCColorCurve[3] = new ColorCurve_cls("Cold Color", mAstrItem);
    double clrInit3[2][5] = {{0, 0, 0, 1, 0},
			     {1, 0, 1, 1, 1}};
    mpCColorCurve[3]->SetInitKeyframes(2, clrInit3);

    mpCColorCurve[4] = new ColorCurve_cls("ModerateGray Color", mAstrItem);
    double clrInit4[2][5] = {{0, 0.50, 0.50, 0.50, 0},
			     {1, 0.75, 0.75, 0.75, 1}};
    mpCColorCurve[4]->SetInitKeyframes(2, clrInit4);

    mpCColorCurve[5] = new ColorCurve_cls("Spectrum", mAstrItem);
    double clrInit5[7][5] = {{0.000, 0.03, 0.00, 0.07, 0.000},
			     {0.167, 0.32, 0.00, 0.77, 0.167},
			     {0.333, 0.00, 0.31, 0.59, 0.333},
			     {0.500, 0.00, 0.78, 0.00, 0.500},
			     {0.666, 0.82, 0.56, 0.00, 0.666},
			     {0.833, 0.84, 0.00, 0.00, 0.833},
			     {1.000, 0.26, 0.00, 0.00, 1.000}};
    mpCColorCurve[5]->SetInitKeyframes(7, clrInit5);

    mpCColorCurve[6] = new ColorCurve_cls("SpectrumRGB", mAstrItem);
    double clrInit6[5][5] = {{0.00, 1.00, 0.00, 0.00, 0.00},
			     {0.25, 0.50, 0.00, 0.50, 0.25},
			     {0.50, 0.00, 0.00, 1.00, 0.50},
			     {0.75, 0.00, 0.50, 0.50, 0.75},
			     {1.00, 0.00, 1.00, 0.00, 1.00}};
    mpCColorCurve[6]->SetInitKeyframes(5, clrInit6);

    mpCColorCurve[7] = new ColorCurve_cls("Incandescent", mAstrItem);
    double clrInit7[5][5] = {{0.000, 0.00, 0.00, 0.00, 0.000},
			     {0.594, 0.73, 0.00, 0.00, 0.594},
			     {0.809, 1.00, 0.55, 0.20, 0.809},
			     {0.900, 0.97, 0.94, 0.07, 0.900},
			     {1.000, 0.97, 0.97, 0.83, 1.000}};
    mpCColorCurve[7]->SetInitKeyframes(5, clrInit7);

    mpCColorCurve[8] = new ColorCurve_cls("ColdSteel", mAstrItem);
    double clrInit8[3][5] = {{0.000, 1.00, 1.00, 1.00, 0.000},
			     {0.645, 0.05, 0.02, 0.14, 0.645},
			     {1.000, 0.36, 0.73, 0.76, 1.000}};
    mpCColorCurve[8]->SetInitKeyframes(3, clrInit8);

    mpCColorCurve[9] = new ColorCurve_cls("Coldest Color", mAstrItem);
    double clrInit9[3][5] = {{0.0, 0.00, 0.00, 1.00, 0.0},
			     {0.5, 0.00, 1.00, 1.00, 0.5},
			     {1.0, 1.00, 1.00, 1.00, 1.0}};
    mpCColorCurve[9]->SetInitKeyframes(3, clrInit9);

    mpCColorCurve[10] = new ColorCurve_cls("Height Map", mAstrItem);
    double clrInit10[4][5] = {{0.00, 0.00, 0.00, 1.00, 0.00},
			      {0.02, 0.00, 1.00, 0.00, 0.02},
			      {0.50, 0.66, 0.50, 0.15, 0.50},
			      {1.00, 1.00, 1.00, 1.00, 1.00}};
    mpCColorCurve[10]->SetInitKeyframes(4, clrInit10);
			     
    mpCColorCurve[11] = new ColorCurve_cls("Skyline", mAstrItem);
    double clrInit11[7][5] = {{0.000, 0.00, 0.00, 0.00, 0.000},
			      {0.365, 0.11, 0.06, 0.56, 0.365},
			      {0.750, 0.92, 0.04, 0.04, 0.750},
			      {0.864, 1.00, 0.53, 0.00, 0.864},
			      {0.896, 0.94, 0.93, 0.22, 0.896},
			      {0.934, 0.53, 0.39, 0.03, 0.934},
			      {1.000, 0.00, 0.00, 0.00, 1.000}};
    mpCColorCurve[11]->SetInitKeyframes(7, clrInit11);
}

CLS::
~ColorCurveProvider_cls(){
    for (int i = 0; i < _COLORCURVE_TEMPLATE_MAX; i++)
	delete mpCColorCurve[i];
}

ColorCurve_cls* CLS::
GetPCColorCurve(int index){
    return mpCColorCurve[index];
}

ColorCurveProvider_cls *GpCColorCurveProvider = NULL;
