// (setq c-basic-offset 4)
// "clsColorProvider.cpp"

#ifndef _COLOR_PROVIDER_H_
#define _COLOR_PROVIDER_H_

#include "../../COMMON/clsGetPC.h"
#include "../../CONFITEM/clsConfListContainer.h"
#include "../../CONFITEM/clsConfItem.h"

#include <wx/wx.h>

class ColorProvider_cls : public ConfListContainer_cls, public GetPC_cls {
public:
    ColorProvider_cls();
    void SetToDefault();

    ConfItemINTARRAY_cls mCClrGuideObject, mCClrActive, mCClrSelected;
    ConfItemINTARRAY_cls mCClrTextActive, mCClrTextSelected;
    ConfItemINTARRAY_cls mCClrText, mCClrTextWeak, mCClrError;
    ConfItemINTARRAY_cls mCClrBasePanel, mCClrEditPanel, mCClrBarPanel;
    ConfItemINTARRAY_cls mCClrTextPanel;
    ConfItemINTARRAY_cls mCClrGLBG, mCClrMaskBG;
    ConfItemINTARRAY_cls mCClrGLGrid;
    ConfItemINTARRAY_cls mCClrX, mCClrY, mCClrZ;
    ConfItemUINT_cls mCBGAlphaType;

    void SetColourCommand(wxString strTag, wxString strColor);

    wxColor GetColorMain(wxString strTag);

    static wxColor GetColor(wxString strTag);
    static std::vector < float > GetVGLColor(wxString strTag, bool bSetAlpha = true);
    static void SetGLColor(wxString strTag, bool bSetAlpha = true);
    static void SetGLClearColor(wxString strTag,
				bool bSetAlphaInData = true, float alpha = 1);

    static void SetBGColor(wxWindow *pC, wxString strTag);
    static void SetBGColorDC(wxDC &dc, wxString strTag);
    static void SetTextColorDC(wxDC &dc, bool bSelected);
    static void SetTextColorWeakDC(wxDC &dc);
};

#endif
