// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsFontProvider.h"

#include "clsFontProvider.h"

#include <wx/textfile.h>

FontFile_cls::
FontFile_cls(wxString strFontName, wxString strFontFile, 
	     wxString strFontFileBold, wxString strFontFileItalic,
	     wxString strFontFileBoldItalic){
    mstrFontName = strFontName;
    mstrFontFile = strFontFile;
    mstrFontFileBold = strFontFileBold;
    mstrFontFileItalic = strFontFileItalic;
    mstrFontFileBoldItalic = strFontFileBoldItalic;
}

wxString FontFile_cls::
GetStrFile(wxString strFontName, bool bBold, bool bItalic){
    wxString strFontFile;
    if (strFontName.IsSameAs(mstrFontName) == FALSE) return strFontFile;
    if (bBold == TRUE && bItalic == TRUE){
	strFontFile = mstrFontFileBoldItalic;
	if (strFontFile.IsEmpty() == TRUE) bItalic = FALSE;
	else return strFontFile;
    }
    if (bBold == TRUE){
	strFontFile = mstrFontFileBold;
	if (strFontFile.IsEmpty() == TRUE) bBold = FALSE;
	else return strFontFile;
    }
    if (bItalic == TRUE){
	strFontFile = mstrFontFileItalic;
	if (strFontFile.IsEmpty() == TRUE) bItalic = FALSE;
	else return strFontFile;
    }
    return mstrFontFile;
}

// -----

void FontProvider_cls::
InitializeStatic(){

    wxScreenDC dc;
    msDDIX = dc.GetPPI().GetWidth();

#ifdef WIN32
    for (int i = 0; i < _FONT_MAX; i++){
	msACFont[i] = wxFont((8+i) * 96 / msDDIX, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, FALSE, wxT("CI"));
	msAFontHeight[i] = GetTextHeight(i, wxT("Sample Text"));
    }
#else
    for (int i = 0; i < _FONT_MAX; i++){
	msACFont[i] = wxFont(wxFontInfo(10+i));//wxFont((8+i) * 96 / msDDIX, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, FALSE);
	msAFontHeight[i] = GetTextHeight(i, wxT("Sample Text"));
    }
#endif

    wxString strFile = wxT("Resource/FontList.txt");
    
    wxTextFile CFile(strFile);
    CFile.Open(wxConvFile);
    for (wxString str = CFile.GetFirstLine(); !CFile.Eof();
	 str = CFile.GetNextLine() ){
	int pos;
	pos  = str.Find(wxT(','));
	wxString strFontName = str.Mid(0,pos).Trim(TRUE).Trim(FALSE);
	str.Remove(0, pos+1);
	pos  = str.Find(wxT(','));
	wxString strFontFile = str.Mid(0,pos).Trim(TRUE).Trim(FALSE);
	str.Remove(0, pos+1);
	pos  = str.Find(wxT(','));
	wxString strFontFileBold = str.Mid(0,pos).Trim(TRUE).Trim(FALSE);
	str.Remove(0, pos+1);
	pos  = str.Find(wxT(','));
	wxString strFontFileItalic = str.Mid(0,pos).Trim(TRUE).Trim(FALSE);
	str.Remove(0, pos+1);
	wxString strFontFileBoldItalic = str.Trim(TRUE).Trim(FALSE);
	msVCFontFile.push_back
	    (FontFile_cls(strFontName, strFontFile, strFontFileBold, strFontFileItalic, strFontFileBoldItalic));
    }
}

wxFont& FontProvider_cls::
GetFont(int type){
    return msACFont[type];
}

int FontProvider_cls::
GetHeight(int type){
    return msAFontHeight[type];
}

int FontProvider_cls::
GetScrollBarWidth(){
    if (msDDIX <= 96) return 17;
    return 21;
}

int FontProvider_cls::
GetButtonHeight(){
    if (msDDIX <= 96) return 24;
    return 30;
}

int FontProvider_cls::
GetTextWidth(int type, wxString strText){
    wxCoord singleW, singleH, singleD;
    wxScreenDC DC;
    DC.SetFont(GetFont(type));
    DC.GetTextExtent(strText, &singleW, &singleH, &singleD);
    return singleW;
}

int FontProvider_cls::
GetTextHeight(int type, wxString strText){
    wxCoord singleW, singleH, singleD;
    wxScreenDC DC;
    DC.SetFont(GetFont(type));
    DC.GetTextExtent(strText, &singleW, &singleH, &singleD);
    return singleH;
}

wxString FontProvider_cls::
GetFontFileFromList(wxString strFont, bool bBold, bool bItalic){
    int size = msVCFontFile.size();
    for (int i = 0; i < size; i++){
	wxString strFile = msVCFontFile[i].GetStrFile(strFont, bBold, bItalic);
	if (strFile.IsEmpty() == FALSE) return strFile;
    }
    if (size == 0) return wxEmptyString;
    return msVCFontFile[0].mstrFontFile;
}

wxFont FontProvider_cls::msACFont[_FONT_MAX];
int FontProvider_cls::msAFontHeight[_FONT_MAX];
int FontProvider_cls::msDDIX;

std::vector < FontFile_cls > FontProvider_cls::msVCFontFile;
