// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsFontProvider.cpp"

#ifndef _FONT_PROVIDER_H_
#define _FONT_PROVIDER_H_

#include <wx/wx.h>
#include <vector>

#define _FONT_MAX 7

class FontFile_cls{
public:
    FontFile_cls (wxString strFontName, wxString strFontFile, 
		  wxString strFontFileBold, wxString strFontFileItalic,
		  wxString strFontFileBoldItalic);
    wxString mstrFontName;
    wxString mstrFontFile;
    wxString mstrFontFileBold;
    wxString mstrFontFileItalic;
    wxString mstrFontFileBoldItalic;

    wxString GetStrFile(wxString strFontName, bool bBold = FALSE, bool bItalic = FALSE);
};

class FontProvider_cls{
 public:
    static void InitializeStatic();
    static wxFont msACFont[_FONT_MAX];
    static int msAFontHeight[_FONT_MAX];
    static wxFont& GetFont(int type);
    static int GetTextWidth(int type, wxString strText);
    static int GetTextHeight(int type, wxString strText);
    static int GetHeight(int type);
    static int msDDIX;

    static std::vector < FontFile_cls > msVCFontFile;
    
    static int GetScrollBarWidth();
    static int GetButtonHeight();
    static wxString GetFontFileFromList(wxString strFont, bool bBold = FALSE, bool bItalic = FALSE);
};

#endif
