// (setq c-basic-offset 4)
// "clsIconProvider.cpp"

#include "clsIconProvider.h"
#include "myArtProv.h"

#define CLS IconProvider_cls

CLS::
IconProvider_cls(){
    for (int i = 0; i < _FONT_MAX; i++){
	int lineHeight = FontProvider_cls::GetHeight(i);
	if (lineHeight == 0) lineHeight = 20;
	wxSize sIcon0 = wxSize(lineHeight*0.6, lineHeight*0.6);
	wxSize sIcon1 = wxSize(lineHeight*0.8, lineHeight*0.8);
	mCIconOpen[i].CopyFromBitmap(ARTS("wxART_OPEN", sIcon0));
	mCIconClose[i].CopyFromBitmap(ARTS("wxART_CLOSE", sIcon0));
	mCIconEyeP[i].CopyFromBitmap(ARTS("wxART_EYE_P", sIcon1));
	mCIconEyeN[i].CopyFromBitmap(ARTS("wxART_EYE_N", sIcon1));
	mCIconLink[i].CopyFromBitmap(ARTS("wxART_LINK_P", sIcon1));
	mCIconUnlink[i].CopyFromBitmap(ARTS("wxART_LINK_N", sIcon1));
	mCIconTimeP[i].CopyFromBitmap(ARTS("wxART_TIME_P", sIcon1));
	mCIconTimeN[i].CopyFromBitmap(ARTS("wxART_TIME_N", sIcon1));
	mCIconLeftP[i].CopyFromBitmap(ARTS("wxART_LEFT_P", sIcon1));
	mCIconLeftN[i].CopyFromBitmap(ARTS("wxART_LEFT_N", sIcon1));
	mCIconRightP[i].CopyFromBitmap(ARTS("wxART_RIGHT_P", sIcon1));
	mCIconRightN[i].CopyFromBitmap(ARTS("wxART_RIGHT_N", sIcon1));
	mCIconCheck[i].CopyFromBitmap(ARTS("wxART_CHECK", sIcon1));
	mCIconUncheck[i].CopyFromBitmap(ARTS("wxART_UNCHECK", sIcon1));
	mCIconKilroyP[i].CopyFromBitmap(ARTS("wxART_KILROY_P", sIcon1));
	mCIconKilroyN[i].CopyFromBitmap(ARTS("wxART_KILROY_N", sIcon1));
	mCIconExprP[i].CopyFromBitmap(ARTS("wxART_EXPRESSION_P", sIcon1));
	mCIconExprN[i].CopyFromBitmap(ARTS("wxART_EXPRESSION_N", sIcon1));
	mCIconExprE[i].CopyFromBitmap(ARTS("wxART_EXPRESSION_E", sIcon1));
	mCIconTextBtnP[i].CopyFromBitmap(ARTS("wxART_TEXT_BTN_P", sIcon1));
	mCIconTextBtnN[i].CopyFromBitmap(ARTS("wxART_TEXT_BTN_N", sIcon1));
	mCIconArrow[i].CopyFromBitmap(ARTS("wxART_ARROW", sIcon1));
    }
    mCTLIconLinear[0].CopyFromBitmap(ART("wxART_TLICON_LINEAR_N"));
    mCTLIconLinear[1].CopyFromBitmap(ART("wxART_TLICON_LINEAR_P"));
    mCTLIconLinear[2].CopyFromBitmap(ART("wxART_TLICON_LINEAR_D"));
    mCTLIconStep[0].CopyFromBitmap(ART("wxART_TLICON_STEP_N"));
    mCTLIconStep[1].CopyFromBitmap(ART("wxART_TLICON_STEP_P"));
    mCTLIconStep[2].CopyFromBitmap(ART("wxART_TLICON_STEP_D"));
    mCTLIconHermiteEase[0].CopyFromBitmap(ART("wxART_TLICON_HERMITE_EASE_N"));
    mCTLIconHermiteEase[1].CopyFromBitmap(ART("wxART_TLICON_HERMITE_EASE_P"));
    mCTLIconHermiteEase[2].CopyFromBitmap(ART("wxART_TLICON_HERMITE_EASE_D"));
    mCTLIconHermiteAuto[0].CopyFromBitmap(ART("wxART_TLICON_HERMITE_AUTO_N"));
    mCTLIconHermiteAuto[1].CopyFromBitmap(ART("wxART_TLICON_HERMITE_AUTO_P"));
    mCTLIconHermiteAuto[2].CopyFromBitmap(ART("wxART_TLICON_HERMITE_AUTO_D"));
}

wxIcon* CLS::
GetPCIcon(wxString strTag, int subIndex){
  wxPrintf("GetPCIcon %s %d\n", strTag, subIndex);
    if (strTag.IsSameAs("GROUP_OPEN")) return &mCIconOpen[subIndex];
    if (strTag.IsSameAs("GROUP_CLOSE")) return &mCIconClose[subIndex];
    if (strTag.IsSameAs("EYE_P")) return &mCIconEyeP[subIndex];
    if (strTag.IsSameAs("EYE_N")) return &mCIconEyeN[subIndex];
    if (strTag.IsSameAs("LINK")) return &mCIconLink[subIndex];
    if (strTag.IsSameAs("UNLINK")) return &mCIconUnlink[subIndex];
    if (strTag.IsSameAs("KILROY_P")) return &mCIconKilroyP[subIndex];
    if (strTag.IsSameAs("KILROY_N")) return &mCIconKilroyN[subIndex];
    if (strTag.IsSameAs("EXPRESSION_P")) return &mCIconExprP[subIndex];
    if (strTag.IsSameAs("EXPRESSION_N")) return &mCIconExprN[subIndex];
    if (strTag.IsSameAs("EXPRESSION_E")) return &mCIconExprE[subIndex];
    if (strTag.IsSameAs("TEXT_BTN_N")) return &mCIconTextBtnN[subIndex];
    if (strTag.IsSameAs("TEXT_BTN_P")) return &mCIconTextBtnP[subIndex];
    if (strTag.IsSameAs("ARROW")) return &mCIconArrow[subIndex];
    if (strTag.IsSameAs("TIME_P")) return &mCIconTimeP[subIndex];
    if (strTag.IsSameAs("TIME_N")) return &mCIconTimeN[subIndex];
    if (strTag.IsSameAs("LEFT_P")) return &mCIconLeftP[subIndex];
    if (strTag.IsSameAs("LEFT_N")) return &mCIconLeftN[subIndex];
    if (strTag.IsSameAs("RIGHT_P")) return &mCIconRightP[subIndex];
    if (strTag.IsSameAs("RIGHT_N")) return &mCIconRightN[subIndex];
    if (strTag.IsSameAs("CHECK")) return &mCIconCheck[subIndex];
    if (strTag.IsSameAs("UNCHECK")) return &mCIconUncheck[subIndex];
    
    if (strTag.IsSameAs("TL_LINEAR")) return &mCTLIconLinear[subIndex];
    if (strTag.IsSameAs("TL_STEP")) return &mCTLIconStep[subIndex];
    if (strTag.IsSameAs("TL_HEMITE_EASE")) return &mCTLIconHermiteEase[subIndex];
    if (strTag.IsSameAs("TL_HEMITE_AUTO")) return &mCTLIconHermiteAuto[subIndex];
    return &mCIconOpen[0];
}

IconProvider_cls *GpCIconProvider = NULL;
