// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsSplittableWindow.cpp"

#ifndef _SPLITTABLE_WINDOW_H
#define _SPLITTABLE_WINDOW_H

#include "../../FILEIO/clsParser.h"
#include "../../WIDGETCTRL/clsWidgetCommon.h"

#include <wx/splitter.h>

class View3D_cls;
class wxPanelEX;
class wxWindow;

class SplittableWindow_cls : public wxSplitterWindow, public Parser_cls, public WidgetCommon_cls {
 public:
    SplittableWindow_cls(wxWindow *pCParentLink);
    SplittableWindow_cls(wxSplitterWindow *pCParentLink);

    wxWindow *mpCParentLink;
    bool mbRootWinodow;

    SplittableWindow_cls *mpCChildSWindow[2];

    View3D_cls* GetPCActiveView3D();

    wxWindow* GeneratePanel(wxString strPanelType, bool bInitialize = true);
    void GenerateWindows(wxString strPanelType0, wxString strPanelType1);
    
    bool ReplaceWindowTo(SplittableWindow_cls *pCSWindowOrg, 
			 SplittableWindow_cls *pCSWindowNew);
    void DestroyChildSWindows(SplittableWindow_cls *pCSWindow);
    void DestroyPanel(wxPanelEX *pCPanel);
    void SeparatePanel(bool bVertical);
    void SeparationDirection();
    void SeparationSwap();

    void ChangePanelType(int panelType);

    int  SetMinimumSize();

    void Serialize(wxString &strOut);
    void ReadStrLine(std::wistream &istream, wxString strFirstItem, wxString strLine);
    void ProceedParsePanel(std::wistream &istream);
    void ProceedParseSplit(std::wistream &istream, SplittableWindow_cls **ppCSWindow0, SplittableWindow_cls **ppCSWindow1);

    bool IsInnertiaExist();
    void UpdatePanels(const wxString& strPanelTag, bool bUpdateBar = FALSE);
    void ProcAfterMath(const wxString& strCommand, const wxString& strItem);
    void CheckAbortClicked(const wxPoint& mousePos);

    void Resash();
    //void OnSize(wxSizeEvent &event);
    
    DECLARE_EVENT_TABLE();
};

#endif
