// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsMain.cpp"

#include "myArtProv.h"

#include "../../COMMON/CommonDefinitions.h"

#define SETITEM(a,b) SetListItem(wxT(a), wxT(b));
#define SETITEM2(a,b,c,d,e,f) SetListItem(wxT(a), wxT(b), wxPoint(c, d), wxSize(e,f));

MyArtProvider::
MyArtProvider(wxString strInitCwd){
    mstrInitCwd = strInitCwd;
    mFrameIconSize = -1;

    SETITEM2("wxART_STARTPOINT",    "PlayCtrls.png", 0, 0, 16, 16);
    SETITEM2("wxART_PLAY_BACK",     "PlayCtrls.png", 16, 0, 16, 16);
    SETITEM2("wxART_STEP_BACKWARD", "PlayCtrls.png", 32, 0, 16, 16);
    SETITEM2("wxART_STEP_FORWARD",  "PlayCtrls.png", 48, 0, 16, 16);
    SETITEM2("wxART_PLAY",          "PlayCtrls.png", 64, 0, 16, 16);
    SETITEM2("wxART_ENDPOINT",      "PlayCtrls.png", 80, 0, 16, 16);
    SETITEM2("wxART_REPEAT",        "PlayCtrls.png", 96, 0, 24, 16);
    
    SETITEM2("wxART_OPEN_FILE", "OpenFile.png", 0, 0, 48, 48);
    SETITEM2("wxART_OPEN_HISTORY", "OpenFile.png", 48, 0, 48, 48);
    SETITEM2("wxART_UNDO", "Do.png", 0, 0, 48, 48);
    SETITEM2("wxART_REDO", "Do.png", 48, 0, 48, 48);
    SETITEM2("wxART_SAVE_FILE", "Save.png", 0, 0, 48, 48);
    SETITEM2("wxART_SAVE_FILE_AS", "Save.png", 48, 0, 48, 48);
    SETITEM2("wxART_SAVE_IMAGE", "Save.png", 96, 0, 48, 48);

    SETITEM2("wxART_HELP", "Helps.png", 0, 0, 48, 48);
    SETITEM2("wxART_INFO", "Helps.png", 48, 0, 48, 48);
    SETITEM2("wxART_TIPS", "Helps.png", 96, 0, 48, 48);

    SETITEM2("wxART_PREFERENCE", "Dialogs.png", 0, 0, 48, 48);
    SETITEM2("wxART_SCENE", "Dialogs.png", 48, 0, 48, 48);
    SETITEM2("wxART_MEMORY", "Dialogs.png", 96, 0, 48, 48);
    SETITEM("wxART_CLEAR", "Clear.png");
    SETITEM2("wxART_TEXT_APPLY", "Text.png", 0, 0, 48, 48);
    SETITEM2("wxART_TEXT_COPY", "Text.png", 48, 0, 48, 48);
    SETITEM2("wxART_TEXT_CUT", "Text.png", 96, 0, 48, 48);
    SETITEM2("wxART_TEXT_PASTE", "Text.png", 144, 0, 48, 48);
    
    SETITEM2("wxART_NEW_OBJ", "Objects.png", 0, 0, 48, 48);
    SETITEM2("wxART_BOX", "Objects.png", 48, 0, 48, 48);
    SETITEM2("wxART_SPHERE", "Objects.png", 96, 0, 48, 48);
    SETITEM2("wxART_PLANE", "Objects.png", 144, 0, 48, 48);
    SETITEM2("wxART_DUPLICATE", "Objects.png", 0, 48, 48, 48);
    SETITEM2("wxART_MESH", "Objects.png", 48, 48, 48, 48); 
    SETITEM2("wxART_CONE", "Objects.png", 96, 48, 48, 48);
    SETITEM2("wxART_CYLINDER", "Objects.png", 144, 48, 48, 48);
    
    SETITEM2("wxART_VOLUMEBOX", "Data.png", 96, 0, 48, 48);
    SETITEM2("wxART_PARTICLE", "Data.png", 0, 0, 48, 48);
    SETITEM2("wxART_HEIGHTFIELD", "Data.png", 48, 0, 48, 48);
    SETITEM2("wxART_STREAMLINE", "Data.png", 0, 48, 48, 48);
    SETITEM2("wxART_ISOSURFACE", "Data.png", 48, 48, 48, 48);
    
    SETITEM2("wxART_RENDER", "Properties.png", 0, 0, 48, 48);
    SETITEM2("wxART_OBJECT_SQUARE", "Properties.png", 48, 0, 48, 48);
    SETITEM2("wxART_TEXTURE", "Properties.png", 96, 0, 48, 48);
    SETITEM2("wxART_MODIFIER", "Properties.png", 144, 0, 48, 48);
    SETITEM2("wxART_EXECUTE", "Properties.png", 192, 0, 48, 48);
    SETITEM2("wxART_FILTER", "Properties.png", 0, 48, 48, 48);
    SETITEM2("wxART_TEXT_ICON", "Properties.png", 48, 48, 48, 48);

    SETITEM2("wxART_HANDLE", "Handle.png", 0, 0, 36, 18);
    SETITEM2("wxART_HANDLE_P", "Handle.png", 0, 18, 36, 18);

    SETITEM2("wxART_EYE_N", "eye.png", 0, 0, 18, 18);
    SETITEM2("wxART_EYE_P", "eye.png", 18, 0, 18, 18);
    SETITEM2("wxART_KILROY_N", "Kilroy.png", 0, 0, 18, 18);
    SETITEM2("wxART_KILROY_P", "Kilroy.png", 18, 0, 18, 18);
    SETITEM2("wxART_EXPRESSION_N", "Expressions.png", 0, 0, 18, 18);
    SETITEM2("wxART_EXPRESSION_P", "Expressions.png", 18, 0, 18, 18);
    SETITEM2("wxART_EXPRESSION_E", "Expressions.png", 36, 0, 18, 18);
    SETITEM2("wxART_TEXT_BTN_N", "Expressions.png", 0, 18, 18, 18);
    SETITEM2("wxART_TEXT_BTN_P", "Expressions.png", 18, 18, 18, 18);
    SETITEM2("wxART_ARROW", "Arrow.png", 0, 0, 18, 18);
    SETITEM2("wxART_ARROW_UP", "Arrow.png", 18, 0, 18, 18);
    SETITEM2("wxART_ARROW_UP_P", "Arrow.png", 18, 18, 18, 18);
    SETITEM2("wxART_ARROW_UP_D", "Arrow.png", 18, 36, 18, 18);
    SETITEM2("wxART_ARROW_DOWN", "Arrow.png", 36, 0, 18, 18);
    SETITEM2("wxART_ARROW_DOWN_P", "Arrow.png", 36, 18, 18, 18);
    SETITEM2("wxART_ARROW_DOWN_D", "Arrow.png", 36, 36, 18, 18);
    SETITEM2("wxART_WARNING", "Status.png", 0, 0, 18, 18);
    
    SETITEM2("wxART_EYE_S_N", "eyes.png", 0, 0, 14, 14);
    SETITEM2("wxART_EYE_S_P", "eyes.png", 14, 0, 14, 14);
    SETITEM2("wxART_KILROY_S_N", "Kilroys.png", 0, 0, 12, 12);
    SETITEM2("wxART_KILROY_S_P", "Kilroys.png", 12, 0, 12, 12);
    
    SETITEM2("wxART_LINK_N", "ParameterIcon.png", 0, 0, 18, 18);
    SETITEM2("wxART_LINK_P", "ParameterIcon.png", 18, 0, 18, 18);
    SETITEM2("wxART_LINK_D", "ParameterIcon.png", 36, 0, 18, 18);
    SETITEM2("wxART_LOCK_N", "ParameterIcon.png", 0, 18, 18, 18);
    SETITEM2("wxART_LOCK_P", "ParameterIcon.png", 18, 18, 18, 18);
    SETITEM2("wxART_LOCK_D", "ParameterIcon.png", 36, 18, 18, 18);
    SETITEM2("wxART_SELECTOR_N", "Selector.png", 0, 0, 14, 14);
    SETITEM2("wxART_SELECTOR_P", "Selector.png", 14, 0, 14, 14);
    SETITEM2("wxART_TIME_N", "Times.png", 0, 0, 18, 18);
    SETITEM2("wxART_TIME_P", "Times.png", 18, 0, 18, 18);
    SETITEM2("wxART_ARROW_N", "Times.png", 0, 18, 18, 18);
    SETITEM2("wxART_ARROW_P", "Times.png", 18, 18, 18, 18);
    SETITEM2("wxART_UNPIN_N", "Pin.png", 0, 0, 20, 20);
    SETITEM2("wxART_UNPIN_P", "Pin.png", 20, 0, 20, 20);
    SETITEM2("wxART_PIN_N", "Pin.png", 0, 20, 20, 20);
    SETITEM2("wxART_PIN_P", "Pin.png", 20, 20, 20, 20);

    SETITEM2("wxART_OPEN", "OpenClose.png", 0, 0, 18, 18);
    SETITEM2("wxART_CLOSE", "OpenClose.png", 18, 0, 18, 18);
    SETITEM2("wxART_DROPDOWN", "OpenClose.png", 36, 0, 18, 18);
    SETITEM2("wxART_LEFT_P", "ParamButtons.png", 0, 0, 18, 18);
    SETITEM2("wxART_LEFT_N", "ParamButtons.png", 0, 18, 18, 18);
    SETITEM2("wxART_RIGHT_P", "ParamButtons.png", 18, 0, 18, 18);
    SETITEM2("wxART_RIGHT_N", "ParamButtons.png", 18, 18, 18, 18);
    SETITEM2("wxART_CHECK", "ParamButtons.png", 36, 0, 18, 18);
    SETITEM2("wxART_UNCHECK", "ParamButtons.png", 36, 18, 18, 18);

    SETITEM2("wxART_NAVI_N", "Navigator.png", 0, 0, 18, 18);
    SETITEM2("wxART_NAVI_P", "Navigator.png", 0, 18, 18, 18);
    SETITEM2("wxART_NAVI_H_N", "Navigator.png", 18, 0, 18, 18);
    SETITEM2("wxART_NAVI_H_P", "Navigator.png", 18, 18, 18, 18);
    SETITEM2("wxART_GRID_N", "Navigator.png", 36, 0, 18, 18);
    SETITEM2("wxART_GRID_P", "Navigator.png", 36, 18, 18, 18);
    SETITEM2("wxART_GRID_H_N", "Navigator.png", 54, 0, 18, 18);
    SETITEM2("wxART_GRID_H_P", "Navigator.png", 54, 18, 18, 18);
    SETITEM2("wxART_GUIDE_N", "Navigator.png", 72, 0, 18, 18);
    SETITEM2("wxART_GUIDE_P", "Navigator.png", 72, 18, 18, 18);
    SETITEM2("wxART_GUIDE_H_N", "Navigator.png", 90, 0, 18, 18);
    SETITEM2("wxART_GUIDE_H_P", "Navigator.png", 90, 18, 18, 18);
    SETITEM2("wxART_LIGHT_N", "Navigator.png", 108, 0, 18, 18);
    SETITEM2("wxART_LIGHT_P", "Navigator.png", 108, 18, 18, 18);
    SETITEM2("wxART_LIGHT_H_N", "Navigator.png", 126, 0, 18, 18);
    SETITEM2("wxART_LIGHT_H_P", "Navigator.png", 126, 18, 18, 18);
    SETITEM2("wxART_LOUPE_N", "Navigator.png", 144, 0, 18, 18);
    SETITEM2("wxART_LOUPE_P", "Navigator.png", 144, 18, 18, 18);
    SETITEM2("wxART_LOUPE_H_N", "Navigator.png", 162, 0, 18, 18);
    SETITEM2("wxART_LOUPE_H_P", "Navigator.png", 162, 18, 18, 18);
    SETITEM2("wxART_PIVOT_N", "Navigator.png", 180, 0, 18, 18);
    SETITEM2("wxART_PIVOT_P", "Navigator.png", 180, 18, 18, 18);
    SETITEM2("wxART_PIVOT_H_N", "Navigator.png", 198, 0, 18, 18);
    SETITEM2("wxART_PIVOT_H_P", "Navigator.png", 198, 18, 18, 18);

    SETITEM2("wxART_SPLITTER_H", "Splitter.png", 0, 0, 18, 18);
    SETITEM2("wxART_SPLITTER_V", "Splitter.png", 18, 0, 18, 18);
    SETITEM2("wxART_SPLITTER_D", "Splitter.png", 36, 0, 18, 18);
    SETITEM2("wxART_SPLITTER_H_P", "Splitter.png", 0, 18, 18, 18);
    SETITEM2("wxART_SPLITTER_V_P", "Splitter.png", 18, 18, 18, 18);
    SETITEM2("wxART_SPLITTER_D_P", "Splitter.png", 36, 18, 18, 18);
    
    SETITEM2("wxART_ZOOM_P", "Zoom.png", 0, 0, 18, 18);
    SETITEM2("wxART_ZOOM_M", "Zoom.png", 18, 0, 18, 18);
    SETITEM2("wxART_ZOOM_P_P", "Zoom.png", 0, 18, 18, 18);
    SETITEM2("wxART_ZOOM_M_P", "Zoom.png", 18, 18, 18, 18);
    SETITEM2("wxART_SEARCH", "SearchZoom.png", 0, 0, 54, 54);
    SETITEM2("wxART_ZOOM_PLUS", "SearchZoom.png", 54, 0, 54, 54);
    SETITEM2("wxART_ZOOM_MINUS", "SearchZoom.png", 108, 0, 54, 54);
    SETITEM2("wxART_ZOOM_AUTO", "SearchZoom.png", 162, 0, 54, 54);

    SETITEM2("wxART_HIDE", "HideShow.png", 0, 0, 18, 18);
    SETITEM2("wxART_SHOW", "HideShow.png", 18, 0, 18, 18);
    SETITEM2("wxART_HIDE_P", "HideShow.png", 0, 18, 18, 18);
    SETITEM2("wxART_SHOW_P", "HideShow.png", 18, 18, 18, 18);
    SETITEM2("wxART_HIDE_GL", "HideShow.png", 0, 36, 18, 18);
    SETITEM2("wxART_SHOW_GL", "HideShow.png", 18, 36, 18, 18);
    SETITEM2("wxART_CLOSE_PANEL", "SmallButtons.png", 0, 0, 18, 18);
    SETITEM2("wxART_CLOSE_PANEL_P", "SmallButtons.png", 0, 18, 18, 18);
    SETITEM2("wxART_CLOSE_PANEL_D", "SmallButtons.png", 0, 36, 18, 18);
    SETITEM2("wxART_CLEAR_PANEL", "SmallButtons.png", 18, 0, 18, 18);
    SETITEM2("wxART_CLEAR_PANEL_P", "SmallButtons.png", 18, 18, 18, 18);
    SETITEM2("wxART_CLEAR_PANEL_D", "SmallButtons.png", 18, 36, 18, 18);
    SETITEM2("wxART_FONT", "SmallButtons.png", 36, 0, 18, 18);
    SETITEM2("wxART_FONT_P", "SmallButtons.png", 36, 18, 18, 18);
    SETITEM2("wxART_FONT_D", "SmallButtons.png", 36, 36, 18, 18);
    SETITEM2("wxART_ABORT", "Cancel.png", 0, 0, 18, 18);
    
    SETITEM2("wxART_NEW_LAMP", "Lights.png", 0, 0, 48, 48);
    SETITEM2("wxART_LIGHT_0", "Lights.png", 48, 0, 48, 48);
    SETITEM2("wxART_LIGHT_1", "Lights.png", 96, 0, 48, 48);
    SETITEM2("wxART_LIGHT_2", "Lights.png", 144, 0, 48, 48);

    SETITEM2("wxART_NEW_CAMERA", "NewItems.png", 0, 0, 48, 48);
    SETITEM2("wxART_NEW_WORLD", "NewItems.png", 48, 0, 48, 48);
    SETITEM2("wxART_NEW_TEXT", "NewItems.png", 96, 0, 48, 48);
    SETITEM("wxART_NEW_EMPTY", "EmptyNew.png");

    SETITEM2("wxART_TIMESLIDER_SMALL", "TimeSliderSmall.png", 0, 2, 9, 11);
    SETITEM2("wxART_MIN_SMALL", "TimeSliderSmall.png", 9, 0, 6, 15);
    SETITEM2("wxART_MAX_SMALL", "TimeSliderSmall.png", 15, 0, 6, 15);
    SETITEM2("wxART_REGION", "TimeSliderSmall.png", 21, 8, 21, 7);
    SETITEM2("wxART_TIMESLIDER", "TimeSlider.png", 0, 2, 15, 18);
    SETITEM2("wxART_MIN", "TimeSlider.png", 15, 0, 6, 22);
    SETITEM2("wxART_MAX", "TimeSlider.png", 21, 0, 6, 22);
    SETITEM2("wxART_NAVISLIDER", "TimeSlider.png", 27, 2, 15, 18);

    SETITEM2("wxART_TLICON_LINEAR_N", "TimelineIcon.png", 0, 0, 9, 9);
    SETITEM2("wxART_TLICON_LINEAR_P", "TimelineIcon.png", 0, 9, 9, 9);
    SETITEM2("wxART_TLICON_LINEAR_D", "TimelineIcon.png", 0, 18, 9, 9);
    SETITEM2("wxART_TLICON_STEP_N", "TimelineIcon.png", 9, 0, 9, 9);
    SETITEM2("wxART_TLICON_STEP_P", "TimelineIcon.png", 9, 9, 9, 9);
    SETITEM2("wxART_TLICON_STEP_D", "TimelineIcon.png", 9, 18, 9, 9);
    SETITEM2("wxART_TLICON_HERMITE_AUTO_N", "TimelineIcon.png", 18, 0, 9, 9);
    SETITEM2("wxART_TLICON_HERMITE_AUTO_P", "TimelineIcon.png", 18, 9, 9, 9);
    SETITEM2("wxART_TLICON_HERMITE_AUTO_D", "TimelineIcon.png", 18, 18, 9, 9);
    SETITEM2("wxART_TLICON_HERMITE_EASE_N", "TimelineIcon.png", 27, 0, 9, 9);
    SETITEM2("wxART_TLICON_HERMITE_EASE_P", "TimelineIcon.png", 27, 9, 9, 9);
    SETITEM2("wxART_TLICON_HERMITE_EASE_D", "TimelineIcon.png", 27, 18, 9, 9);
    SETITEM2("wxART_TLICON_AUTO", "TimelineIcon.png", 36, 0, 9, 9);

    SETITEM2("wxART_TIMELINE", "Panels.png", 0, 0, 14, 14);
    SETITEM2("wxART_OUTLINER", "Panels.png", 14, 0, 14, 14);
    SETITEM2("wxART_GRAPH", "Panels.png", 28, 0, 14, 14);
    SETITEM2("wxART_VIEW3D", "Panels.png", 42, 0, 14, 14);
    SETITEM2("wxART_PROPERTY", "Panels.png", 56, 0, 14, 14);
    SETITEM2("wxART_COLOR_CURVE", "Panels.png", 70, 0, 14, 14);
    SETITEM2("wxART_CONSOLE", "Panels.png", 84, 0, 14, 14);
    SETITEM2("wxART_TEXT", "Panels.png", 98, 0, 14, 14);

    SETITEM2("wxART_ALPHA_OFF", "SelectorAlpha.png", 0, 0, 22, 22);
    SETITEM2("wxART_ALPHA_ON", "SelectorAlpha.png", 22, 0, 22, 22);

    /*
    SETITEM2("wxART_STARTPOINT",    "PlayCtrls.png", 0, 0, 16, 16);
    SETITEM2("wxART_PLAY_BACK",     "PlayCtrls.png", 16, 0, 16, 16);
    SETITEM2("wxART_STEP_BACKWARD", "PlayCtrls.png", 32, 0, 16, 16);
    SETITEM2("wxART_STEP_FORWARD",  "PlayCtrls.png", 48, 0, 16, 16);
    SETITEM2("wxART_PLAY",          "PlayCtrls.png", 64, 0, 16, 16);
    SETITEM2("wxART_ENDPOINT",      "PlayCtrls.png", 80, 0, 16, 16);
    SETITEM2("wxART_REPEAT",        "PlayCtrls.png", 96, 0, 24, 16);
    
    SETITEM2("wxART_LEFT",          "leftCombined.png", 0 , 0, 12, 12);
    SETITEM2("wxART_LEFT_DISABLED", "leftCombined.png", 12, 0, 12, 12);
    SETITEM2("wxART_LEFT_HOVER",    "leftCombined.png", 24, 0, 12, 12);
    SETITEM2("wxART_RIGHT",         "rightCombined.png", 0 , 0 , 12, 12);
    SETITEM2("wxART_RIGHT_DISABLED","rightCombined.png", 12, 0 , 12, 12);
    SETITEM2("wxART_RIGHT_HOVER",   "rightCombined.png", 24, 0 , 12, 12);
    SETITEM("wxART_EXPAND_PLUS",   "ZoomOut.png");
    SETITEM("wxART_EXPAND_MINUS",  "ZoomIm.png");
    SETITEM2("wxART_GRAPH_N",       "Graph.png", 0, 0, 20, 20);
    SETITEM2("wxART_GRAPH_P",       "Graph.png", 20, 0, 20, 20);

    SETITEM2("wxART_OPEN_FOLDER",  "openclose.png", 0, 0, 16, 16);
    SETITEM2("wxART_CLOSE_FOLDER", "openclose.png", 16, 0, 16, 16);
    SETITEM2("wxART_LINKED",       "Links.png", 0, 0, 12, 12);
    SETITEM2("wxART_UNLINKED",     "Links.png", 12, 0, 12, 12);
    SETITEM2("wxART_LINK_D",       "Links.png", 24, 0, 12, 12);
    SETITEM2("wxART_EXPRESSION",     "expressions.png", 0, 0, 16, 16);
    SETITEM2("wxART_EXPRESSION_NOT", "expressions.png", 16, 0, 16, 16);
    SETITEM2("wxART_KILROY_HERE",  "Kilroys.png", 0, 0, 12, 12);
    SETITEM2("wxART_KILROY_THERE", "Kilroys.png", 12, 0, 12, 12);
    SETITEM("wxART_ZOOM_IN", "ZoomIn.png");
    SETITEM("wxART_ZOOM_OUT", "ZoomOut.png");
    SETITEM2("wxART_INPUT", "Dialogs.png", 32, 16, 16, 16);

    SETITEM2("wxART_TIME_P",       "times.png", 0, 0, 12, 12);
    SETITEM2("wxART_TIME_N",       "times.png", 12, 0, 12, 12);
    SETITEM2("wxART_TIME_D",       "times.png", 24, 0, 12, 12);
    SETITEM2("wxART_EYE_P",       "eyes.png", 0, 0, 12, 12);
    SETITEM2("wxART_EYE_N",       "eyes.png", 12, 0, 12, 12);
    
    SETITEM2("wxART_CAMERA",       "Dialogs.png", 0, 0, 16, 16);
    SETITEM2("wxART_LIGHT",        "Dialogs.png", 48, 16, 16, 16);
    SETITEM("wxART_SPOTLIGHT",    "SpotLight.png");
    SETITEM("wxART_STEREOGRAM",   "StereoGram.png");
    SETITEM("wxART_COLOR",        "Color.png");
    SETITEM2("wxART_PREFERENCE",   "Dialogs.png", 48, 0, 16, 16);
    SETITEM2("wxART_POVRAY",       "Dialogs.png", 0, 16, 16, 16);
    SETITEM2("wxART_TABLE",        "Dialogs.png", 16, 16, 16, 16);
    SETITEM2("wxART_SCENE",        "Dialogs.png", 16, 0, 16, 16);
    SETITEM("wxART_TEXTURE",      "Texture.png");
    SETITEM2("wxART_PERIODIC",     "Dialogs.png", 32, 0, 16, 16);

    SETITEM2("wxART_REDO",        "UndoRedo.png", 0, 0, 16, 16);
    SETITEM2("wxART_UNDO",        "UndoRedo.png", 16, 0, 16, 16);
    SETITEM2("wxART_COPY_TEXT",   "Copy.png", 0, 0, 16, 16);
    SETITEM2("wxART_COPY_IMAGE",  "Copy.png", 16, 0, 16, 16);
    SETITEM2("wxART_OPEN",        "FileIcons.png", 0, 0, 16, 16);
    SETITEM2("wxART_QUIT",        "FileIcons.png", 16, 0, 16, 16);

    SETITEM2("wxART_SPLIT_H",      "split.png", 0, 0, 14, 14);
    SETITEM2("wxART_SPLIT_V",      "split.png", 14, 0, 14, 14);
    SETITEM2("wxART_SPLIT_4",      "split.png", 28, 0, 14, 14);
    
    SETITEM("wxART_IMG_SEQ",      "ImgSequence.png");
    SETITEM("wxART_PARTICLE",     "Particle.png");

    SETITEM("wxART_DRAG_ITEM",    "DragItem.png");
    SETITEM2("wxART_SEARCH",       "SearchZoom.png", 0, 0, 54, 54);
    SETITEM2("wxART_ZOOM_PLUS",    "SearchZoom.png", 54, 0, 54, 54);
    SETITEM2("wxART_ZOOM_MINUS",   "SearchZoom.png", 108, 0, 54, 54);
    SETITEM2("wxART_ZOOM_AUTO",   "SearchZoom.png", 162, 0, 54, 54);

    SETITEM2("wxART_SNAP_TAKE", "Snaps.png", 0, 0, 12, 12);
    SETITEM2("wxART_SNAP_SHOW", "Snaps.png", 12, 0, 12, 12);
    SETITEM2("wxART_SNAP_SHOW_PUSHED", "Snaps.png", 24, 0, 12, 12);
    */

    SetFrameIconSize();
}

void MyArtProvider::
SetListItem(wxString strID, wxString strFile, wxPoint pos, wxSize size){
    mVstrBtnIDList .push_back(strID);
    mVstrBtnImgList.push_back(strFile);
    mVPoint.push_back(pos);
    mVSize.push_back(size);
}

void MyArtProvider::
SetFrameIconSize(){
    mFrameIconSize = 
	wxArtProvider::GetBitmap(wxT("wxART_WARNING"), wxART_FRAME_ICON).GetWidth();
}

wxBitmap MyArtProvider::
CreateBitmap(const wxArtID& id,
	     const wxArtClient& client,
	     const wxSize& size){
    wxSize localSize = size;
    if (client.IsSameAs(wxT("wxART_FRAME_ICON_C")))
	localSize = wxSize(mFrameIconSize, mFrameIconSize);

    wxString strDir = mstrInitCwd; strDir << "/Resource/ICONS/";
    for (unsigned int i = 0; i < mVstrBtnIDList.size(); i++){
	if (id == mVstrBtnIDList[i]){
	    wxImage CImg(strDir + mVstrBtnImgList[i], wxBITMAP_TYPE_PNG);

	    //wxPrintf("%s %s %d %d\n", strDir, mVstrBtnImgList[i], size.GetWidth(), size.GetHeight());
	    
	    ASSERT(CImg.IsOk() == TRUE);
	    ASSERT(!(mVSize[i].GetWidth() == 0 && mVSize[i].GetHeight() ==0));

	    if (mVSize[i] != wxDefaultSize)
		CImg = CImg.GetSubImage(wxRect(mVPoint[i], mVSize[i]));
	    
	    wxSize CSize(CImg.GetWidth(), CImg.GetHeight());
	    if (localSize != wxDefaultSize && CSize != localSize){
		wxImage CImgSmall = GetSmallImageLinear(CImg, localSize);
		return wxBitmap(CImgSmall);
	    }
	    return wxBitmap(CImg);
	}
    }
    
    return wxNullBitmap;
}

int MyArtProvider::
floor(float value){
    float valueNew = value;
    if (value < 0) valueNew *= -1;
    int floor = (int)valueNew;
    if (value < 0) floor = - floor - 1;
    return floor;
}

float MyArtProvider::
GetAverageRed(wxImage &CImage, float fX0, float fY0, float fX1, float fY1){
    float areaSum = 0;
    float valueSum = 0;
    for (float fY = fY0; fY < fY1; fY++){
	float fYMax = (float)floor(fY)+1;
	if (fYMax > fY1) fYMax = fY1;
	float areaDimY = fYMax - fY;
	int iY = (int)fY;
	if (iY >= 0 && iY < CImage.GetHeight())
	    for (float fX = fX0; fX < fX1; fX++){
		float fXMax = (float)floor(fX)+1;
		if (fXMax > fX1) fXMax = fX1;
		float areaDimX = fXMax - fX;
		int iX = (int)fX;
		areaSum += areaDimX*areaDimY;
		valueSum += areaDimX*areaDimY * CImage.GetRed(iX, iY);
	    }
	else
	    areaSum += areaDimY * (fX1 - fX0);
    }
    return valueSum / areaSum;
}

float MyArtProvider::
GetAverageGreen(wxImage &CImage, float fX0, float fY0, float fX1, float fY1){
    float areaSum = 0;
    float valueSum = 0;
    for (float fY = fY0; fY < fY1; fY++){
	float fYMax = (float)floor(fY)+1;
	if (fYMax > fY1) fYMax = fY1;
	float areaDimY = fYMax - fY;
	int iY = (int)fY;
	if (iY >= 0 && iY < CImage.GetHeight())
	    for (float fX = fX0; fX < fX1; fX++){
		float fXMax = (float)floor(fX)+1;
		if (fXMax > fX1) fXMax = fX1;
		float areaDimX = fXMax - fX;
		int iX = (int)fX;
		areaSum += areaDimX*areaDimY;
		valueSum += areaDimX*areaDimY * CImage.GetGreen(iX, iY);
	    }
	else
	    areaSum += areaDimY * (fX1 - fX0);
    }
    return valueSum / areaSum;
}

float MyArtProvider::
GetAverageBlue(wxImage &CImage, float fX0, float fY0, float fX1, float fY1){
    float areaSum = 0;
    float valueSum = 0;
    for (float fY = fY0; fY < fY1; fY++){
	float fYMax = (float)floor(fY)+1;
	if (fYMax > fY1) fYMax = fY1;
	float areaDimY = fYMax - fY;
	int iY = (int)fY;
	if (iY >= 0 && iY < CImage.GetHeight())
	    for (float fX = fX0; fX < fX1; fX++){
		float fXMax = (float)floor(fX)+1;
		if (fXMax > fX1) fXMax = fX1;
		float areaDimX = fXMax - fX;
		int iX = (int)fX;
		areaSum += areaDimX*areaDimY;
		valueSum += areaDimX*areaDimY * CImage.GetBlue(iX, iY);
	    }
	else
	    areaSum += areaDimY * (fX1 - fX0);
    }
    return valueSum / areaSum;
}

float MyArtProvider::
GetAverageAlpha(wxImage &CImage, float fX0, float fY0, float fX1, float fY1){
    float areaSum = 0;
    float valueSum = 0;
    for (float fY = fY0; fY < fY1; fY++){
	float fYMax = (float)floor(fY)+1;
	if (fYMax > fY1) fYMax = fY1;
	float areaDimY = fYMax - fY;
	int iY = (int)fY;
	if (iY >= 0 && iY < CImage.GetHeight())
	    for (float fX = fX0; fX < fX1; fX++){
		float fXMax = (float)floor(fX)+1;
		if (fXMax > fX1) fXMax = fX1;
		float areaDimX = fXMax - fX;
		int iX = (int)fX;
		areaSum += areaDimX*areaDimY;
		valueSum += areaDimX*areaDimY * CImage.GetAlpha(iX, iY);
	    }
	else
	    areaSum += areaDimY * (fX1 - fX0);
    }
    return valueSum / areaSum;
}

void MyArtProvider::
ConvertMaskToAlpha(wxImage& CImg){
    int width  = CImg.GetWidth();
    int height = CImg.GetHeight();
    
    if (CImg.HasMask() == TRUE){

	if (CImg.HasAlpha() == TRUE){
	    printf("!!");
	}

	unsigned char mr = CImg.GetMaskRed();
	unsigned char mg = CImg.GetMaskGreen();
	unsigned char mb = CImg.GetMaskBlue();

	unsigned char *pAlpha = new unsigned char [width * height];
	for (int y = 0; y < height; y++){
	    int indexy = y * width;
	    for (int x = 0; x < width; x++){
		int index = indexy + x;
		if (CImg.GetRed(x,y) == mr && 
		    CImg.GetGreen(x,y) == mg &&
		    CImg.GetBlue(x,y) == mb)
		    pAlpha[index] = 0;
		else
		    pAlpha[index] = 255;
		
	    }
	}
	CImg.SetAlpha(pAlpha);
	CImg.SetMask(FALSE);
    }
}

wxImage MyArtProvider::
GetSmallImageLinear(wxImage &CImage, wxSize sizeNew){
    ConvertMaskToAlpha(CImage);

    int widthNew  = sizeNew.GetWidth();
    int heightNew = sizeNew.GetHeight();
    float aspectNew = (float)widthNew/heightNew;

    int widthOrg = CImage.GetWidth();
    int heightOrg = CImage.GetHeight();
    float aspectOrg = (float)widthOrg/heightOrg;
    
    float factorY = aspectNew / aspectOrg;
    
    unsigned char *pData = (unsigned char*)malloc(3*widthNew*heightNew);
    unsigned char *pAlpha = NULL;

    if (pData == NULL){
	return wxNullImage;
    }

    for (int iY = 0; iY < heightNew; iY++){
	float fY0 = (((float)(iY+0)/heightNew-0.5)*factorY + 0.5) * heightOrg;
	float fY1 = (((float)(iY+1)/heightNew-0.5)*factorY + 0.5) * heightOrg;
	int indexy = iY*widthNew;
	for (int iX = 0; iX < widthNew; iX++){
	    float fX0 = ((float)(iX+0))/widthNew * widthOrg;
	    float fX1 = ((float)(iX+1))/widthNew * widthOrg;
	    int index = indexy + iX;
	    
	    float fR = GetAverageRed  (CImage, fX0, fY0, fX1, fY1);
	    float fG = GetAverageGreen(CImage, fX0, fY0, fX1, fY1);
	    float fB = GetAverageBlue (CImage, fX0, fY0, fX1, fY1);

	    pData[index*3+0] = (unsigned char)fR;
	    pData[index*3+1] = (unsigned char)fG;
	    pData[index*3+2] = (unsigned char)fB;
	}
    }

    if (CImage.HasAlpha() == TRUE){
	pAlpha = (unsigned char*)malloc(widthNew*heightNew);

	if (pAlpha != NULL)
	    for (int iY = 0; iY < heightNew; iY++){
		float fY0 = 
		    (((float)(iY+0)/heightNew-0.5)*factorY + 0.5)*heightOrg;
		float fY1 = 
		    (((float)(iY+1)/heightNew-0.5)*factorY + 0.5)*heightOrg;
		int indexy = iY*widthNew;
		for (int iX = 0; iX < widthNew; iX++){
		    float fX0 = (float)(iX+0)/widthNew * widthOrg;
		    float fX1 = (float)(iX+1)/widthNew * widthOrg;
		    int index = indexy + iX;
		    float fA = GetAverageAlpha(CImage, fX0, fY0, fX1, fY1);
		    pAlpha[index] = fA;
		}
	    }
    }

    if (pAlpha == NULL)
	return wxImage(widthNew, heightNew, pData);

    return wxImage (widthNew, heightNew, pData, pAlpha);
    //return CImgSmall;
}
