// -*- c -*- 
// "clsBitmapPanel.cpp"

#ifndef _BITMAP_PANEL_H_
#define _BITMAP_PANEL_H_

#include "clsWidgetCommon.h"

#include "../COMMON/CommonDefinitionsWX.h"

#include <wx/dcbuffer.h>

class ColorCurve_cls;

class BitmapPanel_cls : public wxPanel, public WidgetCommon_cls {
 public:
    BitmapPanel_cls(wxWindow *parent, wxWindowID id = wxID_ANY, 
		    wxPoint pos = wxDP, wxSize size = wxDS);

    int mColorCurveAlpha;
    ColorCurve_cls *mpCColorCurveLink;

    bool mbDealPushed;
    bool mbButton;
    bool mbBorder;
    bool mbPushed;
    unsigned int mState;
    int  mBorderX, mBorderY;
    wxSize mCSize;
    wxString mstrCommandStr;
    wxString mstrLabel;

    wxArrayString mVstrBitmap;
    wxArrayString mVstrBitmapPushed;
    wxString mstrBitmapDisable;
    
    int GetDevCoordFromN(double normedValue, int offsetX);
    void SetBorder(int borderX, int borderY);    
    void SetStatus(unsigned int status);
    void SetColorCurveLink(ColorCurve_cls *pCColorCurve);
    
    void SetBitmapStr(int index, const char *pChar, const char *pCharPushed = NULL);
    void AddBitmapStr(const char *pChar, const char *pCharPushed = NULL);
    void SetBitmapStrDisable(wxString strBitmap);

    void DrawColorCurve(wxAutoBufferedPaintDC& dc);
    void DrawDefault(wxAutoBufferedPaintDC& dc);
    void UpdateDisplay(wxAutoBufferedPaintDC& dc);
    void OnPaint(wxPaintEvent& event);
    void OnMouse(wxMouseEvent& event);

    static BitmapPanel_cls* GetNewPCButtonPin(wxWindow *pCParent);
    static BitmapPanel_cls* GetNewPCButtonDropDown(wxWindow *pCParent, int id = wxID_ANY);
    static BitmapPanel_cls* GetNewPCButtonPanelHide(wxWindow *pCParent);
    static BitmapPanel_cls* GetNewPCButtonLink(wxWindow *pCParent);
    static BitmapPanel_cls* GetNewPCButtonLock(wxWindow *pCParent, int id = wxID_ANY);

    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

#endif
