// -*- c++ -*-
// "clsWidgetsCommon.cpp"

#include "clsWidgetCommon.h"

#include <wx/ribbon/toolbar.h>

#define wxCEH wxCommandEventHandler

wxCommandEvent GetMenuCommand(int Id){
    return wxCommandEvent(wxEVT_COMMAND_MENU_SELECTED, Id);
}

void WidgetCommon_cls::
SendEvent(wxWindow *pC, int type, int ID){
    wxCommandEvent com(type, ID);
    pC->GetEventHandler()->AddPendingEvent(com);
}

void WidgetCommon_cls::
SendRbnEvent(wxWindow *pC, int ID){
    wxRibbonToolBarEvent com(wxEVT_COMMAND_RIBBONTOOL_CLICKED, ID);
    com.SetBar(NULL);
    pC->GetEventHandler()->AddPendingEvent(com);
}

void WidgetCommon_cls::
SendRbnEventDropdown(wxWindow *pC, int ID){
    wxRibbonToolBarEvent com(wxEVT_COMMAND_RIBBONTOOL_DROPDOWN_CLICKED, ID);
    pC->GetEventHandler()->AddPendingEvent(com);
}

void WidgetCommon_cls::
SendMenuEvent(wxWindow *pC, int ID){
    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, ID);
    pC->GetEventHandler()->AddPendingEvent(com);
}

void WidgetCommon_cls::
SendBtnEvent(wxWindow *pC, int ID){
    wxCommandEvent com(wxEVT_COMMAND_BUTTON_CLICKED, ID);
    pC->GetEventHandler()->AddPendingEvent(com);
}

void WidgetCommon_cls::
SendBtnEventInt(wxWindow *pC, int ID, int commandInt){
    wxCommandEvent com(wxEVT_COMMAND_BUTTON_CLICKED, ID);
    com.SetInt(commandInt);
    pC->GetEventHandler()->AddPendingEvent(com);
}

void WidgetCommon_cls::
SendBtnEventIntStr(wxWindow *pC, int ID, int commandInt, wxString commandStr){
    wxCommandEvent com(wxEVT_COMMAND_BUTTON_CLICKED, ID);
    com.SetInt(commandInt);
    com.SetString(commandStr);
    pC->GetEventHandler()->AddPendingEvent(com);
}

/*
void WidgetCommon_cls::
SendEventToTop(wxWindow *pC, int type, int ID){
wxCommandEvent com(type, ID);
    wxGetTopLevelParent(pC)->GetEventHandler()->AddPendingEvent(com);
}

void WidgetCommon_cls::
SendMenuEventToTop(wxWindow *pC, int ID, wxString strCmd){
    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, ID);
    if (strCmd.IsEmpty() == FALSE) com.SetString(strCmd);
    wxGetTopLevelParent(pC)->GetEventHandler()->AddPendingEvent(com);
}

void WidgetCommon_cls::
SendEventToTopParent(wxWindow *pC, int type, int ID){
    wxCommandEvent com(type, ID);
    wxGetTopLevelParent(pC)->GetParent()->GetEventHandler()->AddPendingEvent(com);
}



void WidgetCommon_cls::
SendKeyEvent(wxWindow *pC, wxKeyEvent& event){
    event.SetId(pC->GetId());
    pC->GetEventHandler()->AddPendingEvent(event);
}

void WidgetCommon_cls::
SendKeyEventToTop(wxWindow *pC, wxKeyEvent& event){
    event.SetId(wxGetTopLevelParent(pC)->GetId());
    wxGetTopLevelParent(pC)->GetEventHandler()->AddPendingEvent(event);
}



void WidgetCommon_cls::
SendButtonEvent(wxWindow *pC, int ID){
    wxCommandEvent com(wxEVT_COMMAND_BUTTON_CLICKED, ID);
    pC->GetEventHandler()->AddPendingEvent(com);
}

void WidgetCommon_cls::
SendMouseEvent(wxWindow *pC, wxMouseEvent& com){
    pC->GetEventHandler()->AddPendingEvent(com);
}

void WidgetCommon_cls::
SendMouseEvent(wxWindow *pC, int type, int ID){
    wxMouseEvent com(type);
    com.SetId(ID);
    pC->GetEventHandler()->AddPendingEvent(com);
}

void WidgetCommon_cls::
ConnectButton(wxWindow *pCThis, wxWindow *pC, wxObjectEventFunction func){
    pCThis->Connect(pC->GetId(), wxEVT_COMMAND_BUTTON_CLICKED, func);
}

wxBoxSizer *WidgetCommon_cls::
GetPSizerStaticTextVCenter(wxWindow *pCParent, wxString strTag){
    wxBoxSizer *pBoxSizer = new wxBoxSizer(wxVERTICAL);
    wxStaticText *pCStaticText = new wxStaticText(pCParent, wxID_ANY, strTag);
    pBoxSizer->Add( -1, -1, 1, wxEXPAND);
    pBoxSizer->Add( pCStaticText, 0, wxEXPAND);
    pBoxSizer->Add( -1, -1, 1, wxEXPAND);
    return pBoxSizer;
}
*/
