// (setq c-basic-offset 4)
// "clsFrameMain.h"

#include "clsFrameMain.h"

#include "SRC/COMMON/clsClassProvider.h"
extern ClassProvider_cls GCClassProvider;

#include "SRC/COMMON/clsThreadCommon.h"
#include "SRC/GLCANVAS/clsView3D.h"
#include "SRC/GLOBJ/clsVBOHFProvider.h"
#include "SRC/MAINCANVAS/clsRibbonUI.h"
#include "SRC/MISC/clsAboutBox.h"
#include "SRC/PREFERENCE/clsPreference.h"
#include "SRC/PREFERENCE/clsShortcut.h"
#include "SRC/DIALOG/clsScene.h"
#include "SRC/MYGL/clsGLInfo.h"
#include "SRC/MYGL/clsTextureProvider.h"
#include "SRC/SCENEOBJ/clsLightSource.h"
#include "SRC/SCENEOBJ/clsSceneObjCtrl.h"
#include "SRC/SCENEOBJ/clsPrimitive.h"
#include "SRC/TIMELINE/clsTimeCtrl.h"
#include "SRC/UNDO/clsUndoManager.h"
#include "SRC/WIDGETCTRL/EX/wxPanelEX.h"
#include "SRC/WIDGETCTRL/EX/clsPopupMenuEX.h"
#include "SRC/WIDGETCTRL/WX/clsSplittableWindow.h"
#include "SRC/WIDGETCTRL/WX/myArtProv.h"

#include "SRC/COMMON/CommonDefinitions.h"
#include "wxWidgetEnum.h"
#include "wxWidgetEnumMenu.h"
#include "wxWidgetString.h"

#include <fstream>
#include <sstream>
#include <wx/ribbon/bar.h>
#include <wx/filename.h>

#define CLS FrameMain_cls

BEGIN_EVENT_TABLE(FrameMain_cls, wxFrame)
EVT_RIBBONTOOLBAR_CLICKED(rBtnOpenProject, CLS::OnRbnOpenProject)
EVT_RIBBONTOOLBAR_CLICKED(rBtnOpenRecent, CLS::OnRbnOpenRecent)
EVT_RIBBONTOOLBAR_CLICKED(rBtnSaveProject, CLS::OnRbnSaveProject)
EVT_RIBBONTOOLBAR_CLICKED(rBtnSaveProjectAs, CLS::OnRbnSaveProjectAs)
EVT_RIBBONTOOLBAR_CLICKED(rBtnScene, CLS::OnRbnScene)
EVT_RIBBONTOOLBAR_CLICKED(rBtnUndo, CLS::OnRbnUndo)
EVT_RIBBONTOOLBAR_CLICKED(rBtnRedo, CLS::OnRbnRedo)
EVT_RIBBONTOOLBAR_CLICKED(rBtnVolumeBox, CLS::OnRbnVolumeBox)
EVT_RIBBONTOOLBAR_CLICKED(rBtnIsosurface, CLS::OnRbnIsosurface)
EVT_RIBBONTOOLBAR_CLICKED(rBtnParticle, CLS::OnRbnParticle)
EVT_RIBBONTOOLBAR_CLICKED(rBtnStreamline, CLS::OnRbnStreamline)
EVT_RIBBONTOOLBAR_CLICKED(rBtnHeightField, CLS::OnRbnHeightFiled)
EVT_RIBBONTOOLBAR_CLICKED(rBtnObjects, CLS::OnDropObjects)
EVT_RIBBONTOOLBAR_CLICKED(rBtnObjectBox, CLS::OnRbnObjectBox)
EVT_RIBBONTOOLBAR_CLICKED(rBtnObjectSphere, CLS::OnRbnObjectSphere)
EVT_RIBBONTOOLBAR_CLICKED(rBtnObjectPlane, CLS::OnRbnObjectPlane)
EVT_RIBBONTOOLBAR_CLICKED(rBtnObjectCone, CLS::OnRbnObjectCone)
EVT_RIBBONTOOLBAR_CLICKED(rBtnObjectCylinder, CLS::OnRbnObjectCylinder)
EVT_RIBBONTOOLBAR_CLICKED(rBtnObjectMesh, CLS::OnRbnObjectMesh)
EVT_RIBBONTOOLBAR_CLICKED(rBtnObjectText, CLS::OnRbnObjectText)
EVT_RIBBONTOOLBAR_CLICKED(rBtnLighParallel, CLS::OnRbnLightParallel)
EVT_RIBBONTOOLBAR_CLICKED(rBtnLighPoint, CLS::OnRbnLightPoint)
EVT_RIBBONTOOLBAR_CLICKED(rBtnLighSpot, CLS::OnRbnLightSpot)
EVT_RIBBONTOOLBAR_CLICKED(rBtnCamera, CLS::OnRbnCamera)
EVT_RIBBONTOOLBAR_CLICKED(rBtnWorld, CLS::OnRbnWorld)
EVT_RIBBONTOOLBAR_CLICKED(rBtnEmpty, CLS::OnRbnEmpty)
EVT_RIBBONTOOLBAR_CLICKED(rBtnDuplicate, CLS::OnRbnDuplicate)
EVT_RIBBONTOOLBAR_CLICKED(rBtnDelete, CLS::OnRbnObjectsDelete)
EVT_RIBBONTOOLBAR_CLICKED(rBtnInfo, CLS::OnRbnInfo)
EVT_RIBBONTOOLBAR_CLICKED(rBtnHelp, CLS::OnRbnHelp)
EVT_RIBBONTOOLBAR_CLICKED(rBtnToolTip, CLS::OnRbnToolTip)
EVT_RIBBONTOOLBAR_CLICKED(rBtnInfoGL, CLS::OnRbnInfoGL)
EVT_RIBBONTOOLBAR_CLICKED(rBtnInfoStatus, CLS::OnRbnInfoStatus)
EVT_RIBBONTOOLBAR_CLICKED(rBtnPreference, CLS::OnRbnPreference)
EVT_RIBBONTOOLBAR_CLICKED(rBtnCache, CLS::OnDropCache)
EVT_RIBBONTOOLBAR_CLICKED(rBtnClearCacheTexture, CLS::OnRbnClearCacheTexture)
EVT_RIBBONTOOLBAR_CLICKED(rBtnClearCacheVBO, CLS::OnRbnClearCacheVBO)
EVT_RIBBONTOOLBAR_DROPDOWN_CLICKED(rBtnOpenRecent, CLS::OnDropRecent)
EVT_RIBBONTOOLBAR_DROPDOWN_CLICKED(rBtnSaveProject, CLS::OnDropSaveFile)
EVT_RIBBONTOOLBAR_DROPDOWN_CLICKED(rBtnObjects, CLS::OnDropObjects)
EVT_RIBBONTOOLBAR_DROPDOWN_CLICKED(rBtnCache, CLS::OnDropCache)
EVT_RIBBONTOOLBAR_DROPDOWN_CLICKED(rBtnInfo, CLS::OnDropInfo)
EVT_BUTTON(btnCtrlAbort, CLS::OnButtonAbort)
EVT_MENU_RANGE(MENU_COMMON_INI, MENU_COMMON_FIN, CLS::OnMenuCommon)
EVT_MENU_RANGE(menuRecent0, menuRecent9, CLS::OnMenuRecent)
EVT_MENU(menuSplitterSize, CLS::OnMenuSplitterSize)
EVT_MENU(menuFromSubThread, CLS::OnMenuFromSubThread)
EVT_MENU(menuLog, CLS::OnMenuLog)
EVT_CHAR_HOOK (CLS::OnKeyDown)
EVT_SIZE(CLS::OnSizeFrameMain)
EVT_CLOSE(CLS::OnClose)
EVT_IDLE(CLS::OnIdle)
END_EVENT_TABLE()

CLS::
FrameMain_cls(const wxString& title, Main_cls *pCMain, int posx, int posy,
	      int width, int height) :
wxFrame(NULL, wxID_ANY, title, wxPoint(posx, posy), wxSize(width, height))
{
    mpCMainLink = pCMain;
    mstrTitleBase = title;

    wxBoxSizer  *pBoxSizerSrc = new wxBoxSizer(wxVERTICAL);

    mpCRibbonUI = new RibbonUI_cls(this);
    pBoxSizerSrc->Add(mpCRibbonUI->mpCRbnBar, 0, wxEXPAND);

    mpCSplittableWindow = new SplittableWindow_cls(this);
    pBoxSizerSrc->Add(mpCSplittableWindow, 1, wxEXPAND);
    
    SetSizer(pBoxSizerSrc);

    mpCSplittableWindow->Connect(wxID_ANY, wxEVT_KEY_DOWN,
				 wxKeyEventHandler(CLS::OnKeyDown));

    CreateStatusBar();
    int statusBarWidth[6] = {180, 180, 180, 180, -1, 120};
    GetStatusBar()->SetFieldsCount(6, statusBarWidth);
    GetStatusBar()->PushStatusText(wxT("field_0"), 0);
    GetStatusBar()->PushStatusText(wxT("field_1"), 1);
    GetStatusBar()->PushStatusText(wxT("field_2"), 2);
    GetStatusBar()->PushStatusText(wxT("field_3"), 3);
    GetStatusBar()->PushStatusText(wxT("field_4"), 4);
    GetStatusBar()->PushStatusText(wxT("field_5"), 5);

    mpCButtonAbort = new wxBitmapButton(GetStatusBar(), btnCtrlAbort, ARTWX("wxART_ABORT"), wxDP, wxSize(16, 16));
    
    mpCStatusGauge = new wxGauge(GetStatusBar(), wxID_ANY, 100, wxDPS, wxGA_HORIZONTAL);
    mpCOutputGauge = new wxGauge(GetStatusBar(), wxID_ANY, 0, wxDPS, wxGA_HORIZONTAL);
#ifdef WIN32
    mpCAppGauge = new wxAppProgressIndicator(this, 100);
#endif
   

    //SetFocus();
}

CLS::
~FrameMain_cls(){
#ifdef WIN32
    delete mpCAppGauge;
#endif
    delete mpCRibbonUI;
    if (mpCSplittableWindow != NULL)
	mpCSplittableWindow->Destroy();
}

void CLS::
ReplaceTopSplitterbleWindow(SplittableWindow_cls *pCNewWindow){
    pCNewWindow->Reparent(this);
    pCNewWindow->mpCParentLink = this;
    pCNewWindow->mbRootWinodow = TRUE;
    GetSizer()->Replace(mpCSplittableWindow, pCNewWindow);
    mpCSplittableWindow->Destroy();
    mpCSplittableWindow = pCNewWindow;
    Layout();
}

void CLS::
UpdatePanels(const wxString& strPanelTag){
    mpCRibbonUI->UpdateRibbonState();
    mpCSplittableWindow->UpdatePanels(strPanelTag); }

void CLS::
UpdateTitle(){
    if (GetPCMain()->mCLastOpenedFileZJP.mstrBody.IsEmpty() == TRUE)
	return SetTitle(_FRAME_MAIN_APPNAME);
    if (GetPCMain()->mbHasOpenedProject == FALSE) return;

    wxString strTitle = mstrTitleBase;
    strTitle << wxT(" - ") << GetPCMain()->mCLastOpenedFileZJP.mstrBody;
    SetTitle(strTitle);
}

void CLS::
SetGauge(int percentage, bool bForce){
    static int sPrevTime = -1;
    if (bForce == FALSE && 
	GetPCTimeCtrl()->mCStopWatch.Time() < sPrevTime + 100) return;
    sPrevTime = GetPCTimeCtrl()->mCStopWatch.Time();
    
    mpCStatusGauge->SetRange(101);
    mpCStatusGauge->SetValue(101);
    mpCStatusGauge->SetRange(100);
    mpCStatusGauge->SetValue(percentage);

    mpCStatusGauge->Refresh();
    mpCStatusGauge->Update();

    wxString strPercentage; strPercentage << percentage << "%";
    
    GetStatusBar()->SetStatusText(strPercentage, 2);

    wxString strOutput = "Not Recording";
    if (GetPCTimeCtrl()->mbRecordRender == TRUE &&
	GetPCTimeCtrl()->mbRecordConfirmed == TRUE){
	strOutput = "Recording...";
	double percentOutput = GetPCTimeCtrl()->GetOutputPercent();
	strOutput = GetPCTimeCtrl()->GetStrRecordInfo(percentOutput);
	mpCOutputGauge->SetRange(101);
	mpCOutputGauge->SetValue(101);
	mpCOutputGauge->SetRange(100);
	mpCOutputGauge->SetValue((int)percentOutput);
#ifdef WIN32
	mpCAppGauge->SetValue((int)percentOutput);
#endif
    }
    else{
	mpCOutputGauge->SetRange(101);
	mpCOutputGauge->SetValue(101);
	mpCOutputGauge->SetRange(100);
	mpCOutputGauge->SetValue(100);
#ifdef WIN32
	mpCAppGauge->SetValue(0);
#endif
    }
    mpCOutputGauge->Refresh();
    mpCOutputGauge->Update();
	
    
    GetStatusBar()->SetStatusText(strOutput, 4);
    
    //if (wxTheApp->Pending()) wxTheApp->Dispatch();
}

void CLS::
SetStatusText(wxString strStatus){
    GetStatusBar()->SetStatusText(strStatus, 0);
}

void CLS::
SetStatusAborted(){
    GetStatusBar()->SetStatusText("Aborted", 4);
}

void CLS::
ProcAfterMath(wxString strCommand, wxString strItem){
    mpCSplittableWindow->ProcAfterMath(strCommand, strItem);
}

void CLS::
CheckAbortion(){
    wxMouseState mouseState = ::wxGetMouseState();
    wxPoint mousePos = ::wxGetMousePosition();
    bool isLeftDown = mouseState.LeftIsDown();
    if (isLeftDown == TRUE){
	//mpCSplittableWindow->CheckAbortClicked(mousePos);
	if (mpCButtonAbort->IsShownOnScreen() == FALSE) return;
	if (mpCButtonAbort->GetScreenRect().Contains(mousePos))
	    GetPCTimeCtrl()->msbForceAbort = TRUE;
    }
}

View3D_cls* CLS::
GetPCActiveView3D(){
    return mpCSplittableWindow->GetPCActiveView3D();
}

void CLS::
OnRbnOpenProject(wxRTBEvt& event){
    mpCMainLink->OpenProject(); }

void CLS::
OnRbnOpenRecent(wxRTBEvt& event){
    wxString strPath = mpCMainLink->mAstrRecentFile[0];
    if (strPath.IsEmpty() == TRUE) return;
    
    mpCMainLink->OpenProjectMain(strPath);
}

void CLS::
OnRbnSaveProject(wxRTBEvt& event){
    mpCMainLink->SaveProject(_PROJECT_FULL); }

void CLS::
OnRbnSaveProjectAs(wxRTBEvt& event){
    mpCMainLink->SaveProjectAs(_PROJECT_FULL); }

void CLS::
OnRbnScene(wxRTBEvt& event){
    GCClassProvider.GetPCScene()->OpenWindow(); }

void CLS::
OnRbnUndo(wxRTBEvt& event){
    GCClassProvider.GetPCUndo()->Undo(); }

void CLS::
OnRbnRedo(wxRTBEvt& event){
    GCClassProvider.GetPCUndo()->Redo(); }

void CLS::
OnRbnObjectBox(wxRTBEvt& event){
    GetPCSceneObjCtrl()->AppendPrimitiveCommand(_PRIMITIVE_BOX); }

void CLS::
OnRbnObjectSphere(wxRTBEvt& event){
    GetPCSceneObjCtrl()->AppendPrimitiveCommand(_PRIMITIVE_SPHERE); }

void CLS::
OnRbnObjectPlane(wxRTBEvt& event){
    GetPCSceneObjCtrl()->AppendPrimitiveCommand(_PRIMITIVE_PLANE); }

void CLS::
OnRbnObjectCone(wxRTBEvt& event){
    GetPCSceneObjCtrl()->AppendPrimitiveCommand(_PRIMITIVE_CONE); }

void CLS::
OnRbnObjectCylinder(wxRTBEvt& event){
    GetPCSceneObjCtrl()->AppendPrimitiveCommand(_PRIMITIVE_CYLINDER); }

void CLS::
OnRbnObjectMesh(wxRTBEvt& event){
    GetPCSceneObjCtrl()->AppendSceneObjCommand("MeshObj"); }

void CLS::
OnRbnObjectText(wxRTBEvt& event){
    GetPCSceneObjCtrl()->AppendSceneObjCommand("TextObj"); }

void CLS::
OnRbnLightParallel(wxRTBEvt& event){
    GetPCSceneObjCtrl()->AppendLightCommand(_LIGHT_PARALLEL); }

void CLS::
OnRbnLightPoint(wxRTBEvt& event){
    GetPCSceneObjCtrl()->AppendLightCommand(_LIGHT_POINT); }

void CLS::
OnRbnLightSpot(wxRTBEvt& event){
    GetPCSceneObjCtrl()->AppendLightCommand(_LIGHT_SPOT); }

void CLS::
OnRbnCamera(wxRTBEvt& event){
    GetPCSceneObjCtrl()->AppendSceneObjCommand("Camera"); }

void CLS::
OnRbnWorld(wxRTBEvt& event){
    GetPCSceneObjCtrl()->AppendSceneObjCommand("World"); }

void CLS::
OnRbnVolumeBox(wxRTBEvt& event){
    GetPCSceneObjCtrl()->AppendSceneObjCommand("VolumeBox"); }

void CLS::
OnRbnIsosurface(wxRTBEvt& event){
    GetPCSceneObjCtrl()->AppendSceneObjCommand("Isosurface"); }

void CLS::
OnRbnParticle(wxRTBEvt& event){
    GetPCSceneObjCtrl()->AppendSceneObjCommand("Particle"); }

void CLS::
OnRbnStreamline(wxRTBEvt& event){
    GetPCSceneObjCtrl()->AppendSceneObjCommand("Streamline"); }

void CLS::
OnRbnHeightFiled(wxRTBEvt& event){
    GetPCSceneObjCtrl()->AppendSceneObjCommand("HeightField"); }

void CLS::
OnRbnEmpty(wxRTBEvt& event){
    GetPCSceneObjCtrl()->AppendPrimitiveCommand(_PRIMITIVE_EMPTY); }

void CLS::
OnRbnDuplicate(wxRTBEvt& event){
    GetPCSceneObjCtrl()->DuplicateObjectCommand(); }

void CLS::
OnRbnObjectsDelete(wxRTBEvt& event){
    GetPCSceneObjCtrl()->DeleteItemsCommand(); }

void CLS::
OnRbnInfo(wxRTBEvt& event){
    wxMemorySize mem_size_msz = wxGetFreeMemory(); 
    wxString strMem = mem_size_msz.ToString();
    
    if (strMem == wxT("-1")) strMem = wxT("Unknown");
    else {
	mem_size_msz /= 1024 * 1024;
	strMem = mem_size_msz.ToString();
    }

    wxString strMessage = 
	wxString::Format
	(_FRAME_MAIN_APPNAME _T("\n")
	 _T("%s %s\n%s %s\n%s %s MB\n%s %d\nProgrammed by Takaaki Takeda\n"),
	 _("Powered by"), wxVERSION_STRING,
	 _("running under"), wxGetOsDescription().c_str(),
	 _("free memory"), strMem.c_str(),
	 _("core number"), ThreadCommon_cls::msCPUCount
	 );

    strMessage << wxT("InitializeTimeParallell:") << mpCMainLink->mInitializeTimeParallel << ENDL;    
    strMessage << wxT("InitializeTimeTotal:") << mpCMainLink->mInitializeTimeTotal << ENDL;


    
    AboutBox_cls CAboutBox(this, wxID_ANY, _("About Zindaiji4"), strMessage);
    CAboutBox.ShowModal();
}

void CLS::
OnRbnInfoGL(wxRTBEvt& event){
    wxString strMessage;
    GCClassProvider.GetPCGLInfo()->GetAllGLInfo(strMessage);
    
    AboutBox_cls CAboutBox(this, wxID_ANY, _("OpenGL Info"), strMessage);
    CAboutBox.ShowModal();
}

void CLS::
OnRbnInfoStatus(wxRTBEvt& event){
    wxString strMessage;
    strMessage << "Current Directory = " << wxGetCwd() << ENDL;
    
#ifdef WIN32
    strMessage << "Registry: HungAppTimeout= " << mpCMainLink->mHungAppTimeoutMS << ENDL;
    if (mpCMainLink->mHungAppTimeoutMS == -1)
	strMessage << _("!!) Heavy rendering may fails. See Manuals about window timeout.") << ENDL;
    if (mpCMainLink->mTdrDelay == -1)
	strMessage << "Registry: TdrDelay : undefined" << ENDL;
    else
	strMessage << "Registry: TdrDelay= " << mpCMainLink->mTdrDelay << ENDL;
#endif
    AboutBox_cls CAboutBox(this, wxID_ANY, _("Status Info"), strMessage);
    CAboutBox.ShowModal();
}

void CLS::
OnRbnHelp(wxRTBEvt& event){
}

void CLS::
OnRbnToolTip(wxRTBEvt& event){
    //bool bTip = ! mpCRibbonUI->mVpCRibbonPage[_RBN_VIEW]->mVpCRbnToolBar[_RBN_PANEL_INFO]->GetToolState(rBtnToolTip);
    //bool bTip = event.GetInt();
    bool bTip = ! GetPCPreference()->mCbToolTip.GetBodyBOOL();

    wxString strTip; strTip << bTip;
    GetPCPreference()->mCbToolTip.PushCommandPair(strTip);
    mpCRibbonUI->UpdateRibbonHelp(bTip);
}

void CLS::
OnRbnPreference(wxRTBEvt& event){
    GCClassProvider.GetPCPreference()->OpenWindow(); }

void CLS::
OnDropRecent(wxRTBEvt& event){
    //wxMenu menu;
    PopupMenuEX_cls menu(this);

    int count = 0;
    for (int i = 0; i < _MAX_RECENT_FILE; i++){
	wxString strRecent = mpCMainLink->mAstrRecentFile[i];
	if (strRecent.IsEmpty() == FALSE){
	    wxFileName CFile(strRecent);
	    wxString menuString = CFile.GetFullName();
	    menu.Append(menuRecent0+i, menuString, CFile.GetFullPath());
	}
	count++;
    }

    if (count == 0)
	menu.Append(menuRecentDummy, "empty...");

    event.PopupMenu(&menu);
}

void CLS::
OnDropSaveFile(wxRTBEvt& event){
    //wxMenu menu;
    PopupMenuEX_cls menu(this);
    wxMenuItem *pItem1 = new wxMenuItem(&menu, menuSaveProjectAs, _("Save Project as"), _("Save Project as"));
    wxSize sz = wxSize(36, 36);
    pItem1->SetBitmap(ARTS("wxART_SAVE_FILE_AS", sz));
    menu.Append(pItem1);
    event.PopupMenu(&menu);
}

void CLS::
OnDropObjects(wxRTBEvt& event){

    // ショートカットからドロップダウンを出すときは NULL なので置き換え
    wxRibbonToolBar *pCToolBarObject = mpCRibbonUI->mVpCRibbonPage[0]->mVpCRbnToolBar[1];
    bool bFromShortcut = FALSE;
    if (event.GetBar() == NULL){
      bFromShortcut = TRUE;
      event.SetBar(pCToolBarObject);
    }
    
    PopupMenuEX_cls menu(this);
    
    // サブメニューではPopupMenuEX_clsからもHelpString表示できず
    PopupMenuEX_cls *pMenuObj = new PopupMenuEX_cls(this);

    wxMenuItem *pItem1 = new wxMenuItem(&menu, menuObjectBox, _("Box"));
    wxMenuItem *pItem2 = new wxMenuItem(&menu, menuObjectSphere, _("Sphere"));
    wxMenuItem *pItem3 = new wxMenuItem(&menu, menuObjectPlane, _("Plane"));
    wxMenuItem *pItem4 = new wxMenuItem(&menu, menuObjectCone, _("Cone"));
    wxMenuItem *pItem5 = new wxMenuItem(&menu, menuObjectCylindere, _("Cylinder"));
    wxSize sz = wxSize(36, 36);
    pItem1->SetBitmap(ARTS("wxART_BOX", sz));
    pItem2->SetBitmap(ARTS("wxART_SPHERE", sz));
    pItem3->SetBitmap(ARTS("wxART_PLANE", sz));
    pItem4->SetBitmap(ARTS("wxART_CONE", sz));
    pItem5->SetBitmap(ARTS("wxART_CYLINDER", sz));
    pMenuObj->Append(pItem1);
    pMenuObj->Append(pItem2);
    pMenuObj->Append(pItem3);
    pMenuObj->Append(pItem4);
    pMenuObj->Append(pItem5);

    PopupMenuEX_cls *pMenuLt = new PopupMenuEX_cls(this);
    wxMenuItem *pItemLight0 = 
	new wxMenuItem(pMenuLt, menuLightParallel, _("Parallel Light"));
    wxMenuItem *pItemLight1 = 
	new wxMenuItem(pMenuLt, menuLightPoint, _("Point Light"));
    wxMenuItem *pItemLight2 = 
	new wxMenuItem(pMenuLt, menuLightSpot, _("SpotLight"));
    pItemLight0->SetBitmap(ARTS("wxART_LIGHT_0", sz));
    pItemLight1->SetBitmap(ARTS("wxART_LIGHT_1", sz));
    pItemLight2->SetBitmap(ARTS("wxART_LIGHT_2", sz));
    pMenuLt->Append(pItemLight0);
    pMenuLt->Append(pItemLight1);
    pMenuLt->Append(pItemLight2);

    wxString strAdd = _("Add") + ":";
    wxString strHelpCamera =   strAdd + _("Camera");
    wxString strHelpMesh =     strAdd + _("Mesh");
    wxString strHelpText =     strAdd + _("Text");
    wxString strHelpEmpty =    strAdd + _("Empty");
    wxString strHelpVolume =   strAdd + _("Volume Box");
    wxString strHelpIsosurf =  strAdd + _("Isosurface");
    wxString strHelpParticle = strAdd + _("Particle");
    wxString strHelpStream =   strAdd + _("Streamline");
    wxString strHelpHF =       strAdd + _("Height Field");
    wxString strHelpWorld =    strAdd + _("World");
    
    wxMenuItem *pItemCamera = 
	new wxMenuItem(&menu, menuCamera, _("Camera"), strHelpCamera);
    wxMenuItem *pItemMesh = 
	new wxMenuItem(&menu, menuObjectMesh, _("Mesh"), strHelpMesh);
    wxMenuItem *pItemText = 
	new wxMenuItem(&menu, menuObjectText, _("Text"), strHelpText);
    wxMenuItem *pItemEmpty = 
	new wxMenuItem(&menu, menuEmpty, _("Empty"), strHelpEmpty);
    wxMenuItem *pItemWorld = 
	new wxMenuItem(&menu, menuWorld, _("World"), strHelpWorld);

    pItemCamera->SetBitmap(ARTS("wxART_NEW_CAMERA", sz));
    pItemMesh->SetBitmap(ARTS("wxART_MESH", sz));
    pItemText->SetBitmap(ARTS("wxART_NEW_TEXT", sz));
    pItemEmpty->SetBitmap(ARTS("wxART_NEW_EMPTY", sz));
    pItemWorld->SetBitmap(ARTS("wxART_NEW_WORLD", sz));

    wxMenuItem *pItemVolumeBox = 
	new wxMenuItem(&menu, menuVolumeBox, _("VolumeBox"), strHelpVolume);
    pItemVolumeBox->SetBitmap(ARTS("wxART_VOLUMEBOX", sz));
    wxMenuItem *pItemIsosurface = 
	new wxMenuItem(&menu, menuIsosurface, _("Isosurface"), strHelpIsosurf);
    pItemIsosurface->SetBitmap(ARTS("wxART_ISOSURFACE", sz));
    wxMenuItem *pItemParticle = 
	new wxMenuItem(&menu, menuParticle, _("Particle"), strHelpParticle);
    pItemParticle->SetBitmap(ARTS("wxART_PARTICLE", sz));
    wxMenuItem *pItemStreamline = 
	new wxMenuItem(&menu, menuStreamline, _("Streamline"), strHelpStream);
    pItemStreamline->SetBitmap(ARTS("wxART_STREAMLINE", sz));
    wxMenuItem *pItemHeightField = 
	new wxMenuItem(&menu, menuHeightField, _("Height Field"), strHelpHF);
    pItemHeightField->SetBitmap(ARTS("wxART_HEIGHTFIELD", sz));
    
    menu.AppendSubMenu(pMenuObj, _("Object"))->SetBitmap(ARTS("wxART_NEW_OBJ", sz));;
    menu.AppendSubMenu(pMenuLt, _("Light"))->SetBitmap(ARTS("wxART_NEW_LAMP", sz));;
    menu.Append(pItemCamera);
    menu.Append(pItemMesh);
    menu.Append(pItemText);
    menu.Append(pItemEmpty);
    menu.Append(pItemWorld);
    menu.AppendSeparator();
    menu.Append(pItemVolumeBox);
    menu.Append(pItemIsosurface);
    menu.Append(pItemParticle);
    menu.Append(pItemStreamline);
    menu.Append(pItemHeightField);

    if (bFromShortcut == TRUE)
      PopupMenu(&menu);
    else
      event.PopupMenu(&menu);
    
}

void CLS::
OnDropCache(wxRTBEvt& event){
    PopupMenuEX_cls menu(this);

    GetPCShortcut()->SetMenuItem(&menu, menuClearCacheTexture);
    GetPCShortcut()->SetMenuItem(&menu, menuClearCacheVBO);
    
    //wxMenuItem *pItem1 = new wxMenuItem(&menu, menuClearCacheTexture, _("Clear Texture Cache"), _("Clear Texture Cache"));
    //wxMenuItem *pItem2 = new wxMenuItem(&menu, menuClearCacheVBO, _("Clear VBO Cache"), _("Clear Texture Cache"));
    
    //menu.Append(pItem1);
    //menu.Append(pItem2);
    event.PopupMenu(&menu);
}

void CLS::
OnDropInfo(wxRTBEvt& event){
    
    PopupMenuEX_cls menu(this);
    wxMenuItem *pItem1 = new wxMenuItem(&menu, menuInfoStatus, _("Status Info"), _("Status Info"));
    wxMenuItem *pItem2 = new wxMenuItem(&menu, menuInfoGL, _("OpenGL Info"), _("OpenGL Info"));
        
    menu.Append(pItem1);
    menu.Append(pItem2);
    event.PopupMenu(&menu);
}

void CLS::
OnRbnClearCacheTexture(wxRTBEvt& event){
    GetPCTextureProvider()->ClearAll();
}

void CLS::
OnRbnClearCacheVBO(wxRTBEvt& event){
    GetPCVBOHFProvider()->ClearAll();
}

void CLS::
OnButtonAbort(wxComEvt& event){
    // ここは描画の最中には来ないので
    // 単に再生などを止める以上の効果はない
    GetPCTimeCtrl()->msbForceAbort = TRUE;
}

void CLS::
OnMenuCommon(wxComEvt& event){
    int rbnId = event.GetId() - MENU_COMMON_INI + RBTN_COMMON_INI;
    wxRibbonToolBarEvent com(wxEVT_COMMAND_RIBBONTOOL_CLICKED);
    com.SetId(rbnId);
    GetEventHandler()->AddPendingEvent(com);
}

void CLS::
OnMenuRecent(wxComEvt& event){
    int recentID = event.GetId() - menuRecent0;
    wxString strPath = mpCMainLink->mAstrRecentFile[recentID];
    if (strPath.IsEmpty() == TRUE) return;
    
    mpCMainLink->OpenProjectMain(strPath);
}

void CLS::
OnMenuSplitterSize(wxComEvt& event){
    mpCSplittableWindow->SetMinimumSize(); }

void CLS::
OnMenuFromSubThread(wxComEvt& event){
    GetPCMain()->UpdatePanels("TIMELINE");
}

#include <wx/utils.h>

void CLS::
OnMenuLog(wxComEvt& event){
    wxLogError(event.GetString());
    GetPCMain()->UpdatePanels("CONSOLE");
}

void CLS::
OnKeyDown(wxKeyEvent& event){
    if (GetStatusBar()->GetStatusText(0).IsSameAs("text")){
	event.Skip();	  
	return;
    }
    
    GetPCShortcut()->ProcShortcutKey(event, this);
    int code = event.GetKeyCode();
    if (code == WXK_ESCAPE){
	ShowFullScreen(FALSE);
	mpCRibbonUI->mpCRbnBar->Show();
	Layout();
    }

    event.Skip();
}

void FrameMain_cls::
OnSizeFrameMain(wxSizeEvent& event){
    wxRect rect1, rect2, rect3;
    if (GetStatusBar() != NULL){
	GetStatusBar()->GetFieldRect(1, rect1);
	GetStatusBar()->GetFieldRect(2, rect2);
	GetStatusBar()->GetFieldRect(3, rect3);
	mpCStatusGauge->SetSize(rect1.x,rect1.y+2,rect1.width-16-4,rect1.height-4);
	mpCOutputGauge->SetSize(rect3.x,rect3.y+2,rect3.width,rect3.height-4);
	mpCStatusGauge->SetRange(100);
	mpCOutputGauge->SetRange(100);
	mpCButtonAbort->SetSize(rect1.x + rect1.width - 16, rect1.y+2, 16, 16);
    }
    event.Skip();
}

void CLS::
OnClose(wxCloseEvent &event){

    GCClassProvider.GetPCMain()->ProcAfterMath("Quit", wxES);
    
    event.Skip();
}

void CLS::
MakeSinglePanel(){
    mpCSplittableWindow->Destroy();
    mpCSplittableWindow = NULL;

    mpCSplittableWindow = new SplittableWindow_cls(this);
    GetSizer()->Add(mpCSplittableWindow, 1, wxEXPAND);
	    
    mpCSplittableWindow->GeneratePanel("VIEW3D", TRUE);
    GetSizer()->Layout();
    Refresh(TRUE);
}

void CLS::
OnIdle(wxIdleEvent& event){
    static bool sbInitIdle = TRUE;
    
    if (sbInitIdle == TRUE){
	if (GetPCMain()->InitLayout() == FALSE) MakeSinglePanel();
	sbInitIdle = FALSE;
	Show();
	return; 
    }

    wxWindow *pCFocus = wxWindow::FindFocus();
    if (pCFocus != NULL){
	wxString strFocus = pCFocus->GetName();
	GetStatusBar()->SetStatusText(strFocus, 0);
    }

    wxStopWatch CSW;
    CSW.Start();
    
    bool bPlay = FALSE;
    if (GCClassProvider.GetPCTimeCtrl()->ProcPlay() == TRUE){
	bPlay = TRUE;
	// MEMO. 動画保存で全フレーム描画がうまく行かなかったら
	// パネルのアップデートが終わったら
	// 各自でダミーイベントを飛ばせば、
	// 全アップデート終了後にIdleに戻るようになるかも
    }
    if (mpCSplittableWindow->IsInnertiaExist() == TRUE){
	bPlay = TRUE;
    }

    GetPCMain()->UpdatePanelsFlush();

    int memoryMB = 0;
    GetPCSceneObjCtrl()->GetTotalUsedMemoryMB(memoryMB);
    wxString strMemoryMB; 

    int TexMemoryMB = GetPCTextureProvider()->GetUsedMemoryMB();

    strMemoryMB << memoryMB << "MB " << TexMemoryMB << "MB(Tex)";

    GetStatusBar()->SetStatusText(strMemoryMB, 5);
    
    bool bRelese = FALSE;
    if (memoryMB > GetPCPreference()->mCMemoryLimitMB.GetBodyINT()){
	GetPCSceneObjCtrl()->ReleaseMemory();
	bRelese = TRUE;
    }

    if (bPlay == TRUE){
	int wait = 7 - CSW.Time();
	if (wait > 0) wxMilliSleep(wait);
	SendMenuEvent(this, menuDummy);
    }
    else{
	UpdatePanels("IDLE");
	if (bRelese == FALSE)
	    GetPCSceneObjCtrl()->Prefetch();
    }

    /*
    static int count = 0;
    printf("Idle %d\n", count);
    count++;
    */

    GetPCTimeCtrl()->msbForceAbort = FALSE;
}

wxString CLS::
GetStrWindows(){
    wxString strOut; mpCSplittableWindow->Serialize(strOut);
    return strOut;
}

void CLS::
Serialize(wxString& strOut, int index){
    wxSize sz = GetSize();
    wxString strSize;
    strSize << wxT("::") << sz.GetWidth() << wxT("::") << sz.GetHeight();
    strOut << wxT("FrameMain::") << index << strSize << ENDL;
    mpCSplittableWindow->Serialize(strOut);
    strOut << wxT("FrameMain::Close") << ENDL;
}

void CLS::
ReadStrLine(std::wistream &istream, wxString strFirstItem, wxString strLine){
    if (strFirstItem.IsSameAs(wxT("FrameMain")))
	ProceedParse(istream, strLine);
}

void CLS::
ProceedParse(std::wistream &istream, wxString strLine){
    //int posDelimiter = strLine.Find(wxT("::"));
    long index, width, height;
    PopStrItemFromStrLine(strLine, wxT("::")).ToLong(&index);
    PopStrItemFromStrLine(strLine, wxT("::")).ToLong(&width);
    PopStrItemFromStrLine(strLine, wxT("::")).ToLong(&height);
    
    //if (index != mSelfIndex) CloseParse();

    mpCSplittableWindow->Destroy();
    mpCSplittableWindow = NULL;
    SetSize(wxSize(width, height));

    std::wstring wstrLine;
    while ( std::getline (istream, wstrLine)){
	wxString strLine = wstrLine.c_str();
	wxString strFirstItem = PopStrItemFromStrLine(strLine, wxT("::"));

	if (strFirstItem.IsSameAs(wxT("SplittableWindow"))){
	    wxString strFirstItem = PopStrItemFromStrLine(strLine, wxT("::"));
	    mpCSplittableWindow = new SplittableWindow_cls(this);
	    GetSizer()->Add(mpCSplittableWindow, 1, wxEXPAND);
	    mpCSplittableWindow->ReadStrLine(istream, strFirstItem, strLine);
	    GetSizer()->Layout();
	    Refresh(TRUE);
	}
	
	if (strFirstItem.IsSameAs(wxT("FrameMain")) &&
	    strLine.IsSameAs(wxT("Close")))
	    break;
    }

    
}
