// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsMain.cpp"

#ifndef _MAIN_H_
#define _MAIN_H_

#include "SRC/CONFITEM/clsConfItem.h"
#include "SRC/CONFITEM/clsConfListContainer.h"

#include <vector>

class FrameMain_cls;

#define _PROJECT_CONF 0
#define _PROJECT_FULL 1

#include "SRC/FILEIO/clsParser.h"
#include "SRC/PARAMETER/clsParamGroup.h"

#include "SRC/COMMON/clsGetPC.h"
#include "SRC/COMMON/CommonDefinitionsForH.h"

//class ParamGroup_cls;
//class Parameter_cls;

#include <vector>
#include <string>

class Main_cls : public Parser_cls, public ConfListContainer_cls, public GetPC_cls {
 public:
    Main_cls();
    ~Main_cls();
    bool InitLayout();

    bool mbHasOpenedProject;
    int  mInitializeTimeParallel, mInitializeTimeTotal;
    int  mActiveGLViewID;
    long mHungAppTimeoutMS, mTdrDelay;

    ConfItemSTR_cls  mCLastOpenedFileZJP;
    ConfItemSTR_cls  mCLastOpenedFileIMG;
    ConfItemSTR_cls  mCLastOpenedFilePARTICLE;
    ConfItemSTR_cls  mCLastOpenedFileVOLUME;
    ConfItemSTR_cls  mCLastOpenedFileMESH;
    ConfItemSTR_cls  mCLastOpenedFileHF;
    ConfItemSTR_cls  mCLastOpenedFileSTREAM;
    ConfItemSTR_cls  mCVersionProject;

    std::vector < wxString > mAssUpdatePanelQueue;
    wxString         mstrExecuteDir, mstrInitWorkingDir;
    wxString         mAstrRecentFile[_MAX_RECENT_FILE];
    
    wxStopWatch mCStopWatch;

    ParamGroup_cls* GetPCParamGroup(wxString strItem);
    Parameter_cls* GetPCParameter(wxString strItem);
    void DeselectKeyFrame(wxString strException = wxES);
    bool ChangeKeyTypeByModKey(wxString strTag, int keyIndex, 
			       bool bCtrl, bool bShift, bool bAlt);
    bool SelectKeyFrame(wxString strTag, int keyIndex, 
			bool bSelect, bool bAdditional,
			double resolution = _RES_DEFAULT);

    void SetSelectedTLKeyTypeCommand(int keyType, double ease);
    void MoveSelectedTLKeyCommand(double dNX, double dY);

    wxString GetStrCommandParamGroup(wxString strTag);
    bool SetParamGroupConfCommand(wxString strTag, wxString strHeader, bool bNew);
    bool SetParamGroupConfCommand(wxString strTag, wxString strHeader, wxString strNew);
    void SetParameterConfCommand(wxString strTag, wxString strHeader, bool bNew, bool bSelectedOnly = FALSE);
    
    
    void PushBackRecent(wxString strFile);
    void OpenProject(wxString strFile = wxEmptyString);
    bool OpenProjectMain(wxString strFile, bool bFullProject = TRUE);
    void OpenRecentFile(wxString strFile);
    void ReadStrCommand(std::wistream &sstream, wxString strFirstItem, wxString strLine);
    void SaveProjectAs(int flag);
    void SaveProject(int flag);
    bool SaveProjectMain(wxString strFileOut, int flag);
    void SaveRecentFile(wxString strFileOut);
    void SaveConfigureFile(wxString strFileOut);
    
    void RescaleParameters(double scale);
    
    void UpdatePanels(/*std::string*/wxString strPanelList);
    void UpdatePanelsFlush();
    void ProcAfterMath(wxString strCommand, wxString strItem);
    
    std::vector < FrameMain_cls* > mVpCFrame;

};

#endif
